/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/nls","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=ie[J[L]];return e};define(ie[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const R=new Map,N=new Map,A=new Map,I=new Map;function u(f,v){f.has(v.detail)||f.set(v.detail,-v.timestamp)}function a(f,v){const E=f.get(v.detail);E&&(E>=0||f.set(v.detail,E+v.timestamp))}let y=[];typeof J=="function"&&typeof J.getStats=="function"&&(y=J.getStats().slice(0).sort((f,v)=>f.timestamp-v.timestamp));for(const f of y)switch(f.type){case 10:u(R,f);break;case 11:case 12:a(R,f);break;case 21:u(N,f);break;case 22:a(N,f);break;case 33:u(A,f);break;case 34:a(A,f);break;case 31:u(I,f);break;case 32:a(I,f);break}let b=0;A.forEach(f=>b+=f);function $(f){const v=[];return f.forEach((E,g)=>v.push([g,E])),v}return{amdLoad:$(R),amdInvoke:$(N),nodeRequire:$(A),nodeEval:$(I),nodeRequireTotal:b}}static toMarkdownTable(R,N){let A="";const I=[];return R.forEach((u,a)=>{I[a]=u.length}),N.forEach(u=>{u.forEach((a,y)=>{typeof a>"u"&&(a=u[y]="-");const b=a.toString().length;I[y]=Math.max(b,I[y])})}),R.forEach((u,a)=>{A+=`| ${u+" ".repeat(I[a]-u.toString().length)} `}),A+=`|
`,R.forEach((u,a)=>{A+=`| ${"-".repeat(I[a])} `}),A+=`|
`,N.forEach(u=>{u.forEach((a,y)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(I[y]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=L}),define(ie[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function L(A){return(I,u,a)=>{let y=null,b=null;if(typeof a.value=="function"?(y="value",b=a.value):typeof a.get=="function"&&(y="get",b=a.get),!b)throw new Error("not supported");a[y]=A(b,u)}}function D(A,I,u){let a=null,y=null;if(typeof u.value=="function"?(a="value",y=u.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",y=u.get),!y)throw new Error("not supported");const b=`$memoize$${I}`;u[a]=function(...$){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,$)}),this[b]}}e.$xh=D;function R(A,I,u){return L((a,y)=>{const b=`$debounce$${y}`,$=`$debounce$result$${y}`;return function(...f){this[$]||(this[$]=u?u():void 0),clearTimeout(this[b]),I&&(this[$]=I(this[$],...f),f=[this[$]]),this[b]=setTimeout(()=>{a.apply(this,f),this[$]=u?u():void 0},A)}})}e.$yh=R;function N(A,I,u){return L((a,y)=>{const b=`$throttle$timer$${y}`,$=`$throttle$result$${y}`,f=`$throttle$lastRun$${y}`,v=`$throttle$pending$${y}`;return function(...E){if(this[$]||(this[$]=u?u():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),I&&(this[$]=I(this[$],...E)),this[v])return;const g=this[f]+A;g<=Date.now()?(this[f]=Date.now(),a.apply(this,[this[$]]),this[$]=u?u():void 0):(this[v]=!0,this[b]=setTimeout(()=>{this[v]=!1,this[f]=Date.now(),a.apply(this,[this[$]]),this[$]=u?u():void 0},g-Date.now()))}})}e.$zh=N}),define(ie[71],ne([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function D(u,a){if(!u)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=D;function R(u,a="Unreachable"){throw new Error(a)}e.$6c=R;function N(u){if(!u)throw new L.$cb("Assertion Failed")}e.$7c=N;function A(u){if(!u()){debugger;u(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$8c=A;function I(u,a){let y=0;for(;y<u.length-1;){const b=u[y],$=u[y+1];if(!a(b,$))return!1;y++}return!0}e.$9c=I}),define(ie[38],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var N;(function(s){s.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(s,o=!1){let t=0;const i=s.length;let n="",r=0,l=16,k=0;function S(re){let he=0,ce=0;for(;he<re;){const ae=s.charCodeAt(t);if(ae>=48&&ae<=57)ce=ce*16+ae-48;else if(ae>=65&&ae<=70)ce=ce*16+ae-65+10;else if(ae>=97&&ae<=102)ce=ce*16+ae-97+10;else break;t++,he++}return he<re&&(ce=-1),ce}function w(re){t=re,n="",r=0,l=16,k=0}function j(){const re=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&a(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&a(s.charCodeAt(t)))for(t++;t<s.length&&a(s.charCodeAt(t));)t++;else return k=3,s.substring(re,t);let he=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&a(s.charCodeAt(t))){for(t++;t<s.length&&a(s.charCodeAt(t));)t++;he=t}else k=3;return s.substring(re,he)}function B(){let re="",he=t;for(;;){if(t>=i){re+=s.substring(he,t),k=2;break}const ce=s.charCodeAt(t);if(ce===34){re+=s.substring(he,t),t++;break}if(ce===92){if(re+=s.substring(he,t),t++,t>=i){k=2;break}switch(s.charCodeAt(t++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const q=S(4);q>=0?re+=String.fromCharCode(q):k=4;break}default:k=5}he=t;continue}if(ce>=0&&ce<=31)if(u(ce)){re+=s.substring(he,t),k=2;break}else k=6;t++}return re}function te(){if(n="",k=0,r=t,t>=i)return r=i,l=17;let re=s.charCodeAt(t);if(I(re)){do t++,n+=String.fromCharCode(re),re=s.charCodeAt(t);while(I(re));return l=15}if(u(re))return t++,n+=String.fromCharCode(re),re===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),l=14;switch(re){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,n=B(),l=10;case 47:{const he=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!u(s.charCodeAt(t));)t++;return n=s.substring(he,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=i-1;let ae=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,k=1),n=s.substring(he,t),l=13}return n+=String.fromCharCode(re),t++,l=16}case 45:if(n+=String.fromCharCode(re),t++,t===i||!a(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=j(),l=11;default:for(;t<i&&Y(re);)t++,re=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(re),t++,l=16}}function Y(re){if(I(re)||u(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let re;do re=te();while(re>=12&&re<=15);return re}return{setPosition:w,getPosition:()=>t,scan:o?oe:te,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>k}}e.$an=A;function I(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function u(s){return s===10||s===13||s===8232||s===8233}function a(s){return s>=48&&s<=57}var y;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(y||(y={}));function b(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function k(S,w,j,B){r.value=S,r.offset=w,r.length=j,r.type=B,r.colonOffset=void 0,n=r}try{O(s,{onObjectBegin:(S,w)=>{if(o<=S)throw i;n=void 0,l=o>S,t.push("")},onObjectProperty:(S,w,j)=>{if(o<w||(k(S,w,j,"property"),t[t.length-1]=S,o<=w+j))throw i},onObjectEnd:(S,w)=>{if(o<=S)throw i;n=void 0,t.pop()},onArrayBegin:(S,w)=>{if(o<=S)throw i;n=void 0,t.push(0)},onArrayEnd:(S,w)=>{if(o<=S)throw i;n=void 0,t.pop()},onLiteralValue:(S,w,j)=>{if(o<w||(k(S,w,j,m(S)),o<=w+j))throw i},onSeparator:(S,w,j)=>{if(o<=w)throw i;if(S===":"&&n&&n.type==="property")n.colonOffset=w,l=!1,n=void 0;else if(S===","){const B=t[t.length-1];typeof B=="number"?t[t.length-1]=B+1:(l=!0,t[t.length-1]=""),n=void 0}}})}catch(S){if(S!==i)throw S}return{path:t,previousNode:n,isAtPropertyKey:l,matches:S=>{let w=0;for(let j=0;w<S.length&&j<t.length;j++)if(S[w]===t[j]||S[w]==="*")w++;else if(S[w]!=="**")return!1;return w===S.length}}}e.$bn=b;function $(s,o=[],t=N.DEFAULT){let i=null,n=[];const r=[];function l(S){Array.isArray(n)?n.push(S):i!==null&&(n[i]=S)}return O(s,{onObjectBegin:()=>{const S={};l(S),r.push(n),n=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const S=[];l(S),r.push(n),n=S,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:l,onError:(S,w,j)=>{o.push({error:S,offset:w,length:j})}},t),n[0]}e.$cn=$;function f(s,o=[],t=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function r(S){return i.children.push(S),S}O(s,{onObjectBegin:S=>{i=r({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,w,j)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:w,length:j,parent:i})},onObjectEnd:(S,w)=>{i.length=S+w-i.offset,i=i.parent,n(S+w)},onArrayBegin:(S,w)=>{i=r({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,w)=>{i.length=S+w-i.offset,i=i.parent,n(S+w)},onLiteralValue:(S,w,j)=>{r({type:m(S),offset:w,length:j,parent:i,value:S}),n(w+j)},onSeparator:(S,w,j)=>{i.type==="property"&&(S===":"?i.colonOffset=w:S===","&&n(w))},onError:(S,w,j)=>{o.push({error:S,offset:w,length:j})}},t);const k=i.children[0];return k&&delete k.parent,k}e.$dn=f;function v(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$en=v;function E(s){if(!s.parent||!s.parent.children)return[];const o=E(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$fn=E;function g(s){switch(s.type){case"array":return s.children.map(g);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=g(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$gn=g;function c(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$hn=c;function p(s,o,t=!1){if(c(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=p(i[n],o,t);if(r)return r}return s}}e.$in=p;function O(s,o,t=N.DEFAULT){const i=A(s,!1);function n(x){return x?()=>x(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(x){return x?K=>x(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(o.onObjectBegin),k=r(o.onObjectProperty),S=n(o.onObjectEnd),w=n(o.onArrayBegin),j=n(o.onArrayEnd),B=r(o.onLiteralValue),te=r(o.onSeparator),Y=n(o.onComment),oe=r(o.onError),re=t&&t.disallowComments,he=t&&t.allowTrailingComma;function ce(){for(;;){const x=i.scan();switch(i.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:re||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(x){case 12:case 13:re?ae(10):Y();break;case 16:ae(1);break;case 15:case 14:break;default:return x}}}function ae(x,K=[],F=[]){if(oe(x),K.length+F.length>0){let C=i.getToken();for(;C!==17;){if(K.indexOf(C)!==-1){ce();break}else if(F.indexOf(C)!==-1)break;C=ce()}}}function q(x){const K=i.getTokenValue();return x?B(K):k(K),ce(),!0}function Q(){switch(i.getToken()){case 11:{let x=0;try{x=JSON.parse(i.getTokenValue()),typeof x!="number"&&(ae(2),x=0)}catch{ae(2)}B(x);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return ce(),!0}function U(){return i.getToken()!==10?(ae(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(te(":"),ce(),X()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function T(){l(),ce();let x=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(x||ae(4,[],[]),te(","),ce(),i.getToken()===2&&he)break}else x&&ae(6,[],[]);U()||ae(4,[],[2,5]),x=!0}return S(),i.getToken()!==2?ae(7,[2],[]):ce(),!0}function H(){w(),ce();let x=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(x||ae(4,[],[]),te(","),ce(),i.getToken()===4&&he)break}else x&&ae(6,[],[]);X()||ae(4,[],[4,5]),x=!0}return j(),i.getToken()!==4?ae(8,[4],[]):ce(),!0}function X(){switch(i.getToken()){case 3:return H();case 1:return T();case 10:return q(!0);default:return Q()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):X()?(i.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$jn=O;function h(s,o){const t=A(s),i=[];let n,r=0,l;do switch(l=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==l&&i.push(s.substring(r,l)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$kn=h;function m(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=m}),define(ie[72],ne([0,1,38]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=void 0;function D(a,y,b){let $,f,v,E,g;if(y){for(E=y.offset,g=E+y.length,v=E;v>0&&!u(a,v-1);)v--;let l=g;for(;l<a.length&&!u(a,l);)l++;f=a.substring(v,l),$=A(f,b)}else f=a,$=0,v=0,E=0,g=a.length;const c=I(b,a);let p=!1,O=0,h;b.insertSpaces?h=N(" ",b.tabSize||4):h="	";const m=(0,L.$an)(f,!1);let s=!1;function o(){return c+N(h,$+O)}function t(){let l=m.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=m.scan();return s=l===16||m.getTokenError()!==0,l}const i=[];function n(l,k,S){!s&&k<g&&S>E&&a.substring(k,S)!==l&&i.push({offset:k,length:S-k,content:l})}let r=t();if(r!==17){const l=m.getTokenOffset()+v,k=N(h,$);n(k,v,l)}for(;r!==17;){let l=m.getTokenOffset()+m.getTokenLength()+v,k=t(),S="";for(;!p&&(k===12||k===13);){const j=m.getTokenOffset()+v;n(" ",l,j),l=m.getTokenOffset()+m.getTokenLength()+v,S=k===12?o():"",k=t()}if(k===2)r!==1&&(O--,S=o());else if(k===4)r!==3&&(O--,S=o());else{switch(r){case 3:case 1:O++,S=o();break;case 5:case 12:S=o();break;case 13:p?S=o():S=" ";break;case 6:S=" ";break;case 10:if(k===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:k===12||k===13?S=" ":k!==5&&k!==17&&(s=!0);break;case 16:s=!0;break}p&&(k===12||k===13)&&(S=o())}const w=m.getTokenOffset()+v;n(S,l,w),r=k}return i}e.$mn=D;function R(a,y){const b=JSON.stringify(a,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?b.replace(/\r\n|\r|\n/g,y.eol):b}e.$nn=R;function N(a,y){let b="";for(let $=0;$<y;$++)b+=a;return b}function A(a,y){let b=0,$=0;const f=y.tabSize||4;for(;b<a.length;){const v=a.charAt(b);if(v===" ")$++;else if(v==="	")$+=f;else break;b++}return Math.floor($/f)}function I(a,y){for(let b=0;b<y.length;b++){const $=y.charAt(b);if($==="\r")return b+1<y.length&&y.charAt(b+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return a&&a.eol||`
`}e.$on=I;function u(a,y){return`\r
`.indexOf(a.charAt(y))!==-1}e.$pn=u}),define(ie[73],ne([0,1,38,72]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function R(a,y,b){return N(a,y,void 0,b)}e.$qn=R;function N(a,y,b,$,f){const v=y.slice(),E=[],g=(0,L.$dn)(a,E);let c,p;for(;v.length>0&&(p=v.pop(),c=(0,L.$en)(g,v),c===void 0&&b!==void 0);)typeof p=="string"?b={[p]:b}:b=[b];if(c)if(c.type==="object"&&typeof p=="string"&&Array.isArray(c.children)){const O=(0,L.$en)(c,[p]);if(O!==void 0)if(b===void 0){if(!O.parent)throw new Error("Malformed AST");const h=c.children.indexOf(O.parent);let m,s=O.parent.offset+O.parent.length;if(h>0){const o=c.children[h-1];m=o.offset+o.length}else m=c.offset+1,c.children.length>1&&(s=c.children[1].offset);return A(a,{offset:m,length:s-m,content:""},$)}else return A(a,{offset:O.offset,length:O.length,content:JSON.stringify(b)},$);else{if(b===void 0)return[];const h=`${JSON.stringify(p)}: ${JSON.stringify(b)}`,m=f?f(c.children.map(o=>o.children[0].value)):c.children.length;let s;if(m>0){const o=c.children[m-1];s={offset:o.offset+o.length,length:0,content:","+h}}else c.children.length===0?s={offset:c.offset+1,length:0,content:h}:s={offset:c.offset+1,length:0,content:h+","};return A(a,s,$)}}else if(c.type==="array"&&typeof p=="number"&&Array.isArray(c.children))if(b!==void 0){const O=`${JSON.stringify(b)}`;let h;if(c.children.length===0||p===0)h={offset:c.offset+1,length:0,content:c.children.length===0?O:O+","};else{const m=p===-1||p>c.children.length?c.children.length:p,s=c.children[m-1];h={offset:s.offset+s.length,length:0,content:","+O}}return A(a,h,$)}else{const O=p,h=c.children[O];let m;if(c.children.length===1)m={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===O){const s=c.children[O-1],o=s.offset+s.length,t=c.offset+c.length;m={offset:o,length:t-2-o,content:""}}else m={offset:h.offset,length:c.children[O+1].offset-h.offset,content:""};return A(a,m,$)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${c.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return A(a,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(b)},$)}}e.$rn=N;function A(a,y,b){let $=I(a,y),f=y.offset,v=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;f>0&&!(0,D.$pn)($,f-1);)f--;for(;v<$.length&&!(0,D.$pn)($,v);)v++}const E=(0,D.$mn)($,{offset:f,length:v-f},b);for(let c=E.length-1;c>=0;c--){const p=E[c];$=I($,p),f=Math.min(f,p.offset),v=Math.max(v,p.offset+p.length),v+=p.content.length-p.length}const g=a.length-($.length-v)-f;return[{offset:f,length:g,content:$.substring(f,v)}]}e.$sn=A;function I(a,y){return a.substring(0,y.offset)+y.content+a.substring(y.offset+y.length)}e.$tn=I;function u(a,y){const b=y.slice(0).sort((f,v)=>{const E=f.offset-v.offset;return E===0?f.length-v.length:E});let $=a.length;for(let f=b.length-1;f>=0;f--){const v=b[f];if(v.offset+v.length<=$)a=I(a,v);else throw new Error("Overlapping edit");$=v.offset}return a}e.$un=u}),define(ie[74],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function L(I,u,a){return Math.min(Math.max(I,u),a)}e.$7l=L;function D(I,u){return(u+I%u)%u}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=R;class N{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=N;class A{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=A}),function(){function J(R){const N=[];typeof R=="number"&&N.push("code/timeOrigin",R);function A(u){N.push(u,Date.now())}function I(){const u=[];for(let a=0;a<N.length;a+=2)u.push({name:N[a],startTime:N[a+1]});return u}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(R+A.startTime)});return N}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(D,R,N){L.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:N})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,R){if(1&R&&(D=L(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(L.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var A in D)L.d(N,A,function(I){return D[I]}.bind(null,A));return N},L.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(R,"a",R),R},L.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var R;e=J.exports=F,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],u=e.src=[],a=0,y=a++;u[y]="0|[1-9]\\d*";var b=a++;u[b]="[0-9]+";var $=a++;u[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=a++;u[f]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var v=a++;u[v]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var E=a++;u[E]="(?:"+u[y]+"|"+u[$]+")";var g=a++;u[g]="(?:"+u[b]+"|"+u[$]+")";var c=a++;u[c]="(?:-("+u[E]+"(?:\\."+u[E]+")*))";var p=a++;u[p]="(?:-?("+u[g]+"(?:\\."+u[g]+")*))";var O=a++;u[O]="[0-9A-Za-z-]+";var h=a++;u[h]="(?:\\+("+u[O]+"(?:\\."+u[O]+")*))";var m=a++,s="v?"+u[f]+u[c]+"?"+u[h]+"?";u[m]="^"+s+"$";var o="[v=\\s]*"+u[v]+u[p]+"?"+u[h]+"?",t=a++;u[t]="^"+o+"$";var i=a++;u[i]="((?:<|>)?=?)";var n=a++;u[n]=u[b]+"|x|X|\\*";var r=a++;u[r]=u[y]+"|x|X|\\*";var l=a++;u[l]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[c]+")?"+u[h]+"?)?)?";var k=a++;u[k]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[p]+")?"+u[h]+"?)?)?";var S=a++;u[S]="^"+u[i]+"\\s*"+u[l]+"$";var w=a++;u[w]="^"+u[i]+"\\s*"+u[k]+"$";var j=a++;u[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=a++;u[B]="(?:~>?)";var te=a++;u[te]="(\\s*)"+u[B]+"\\s+",I[te]=new RegExp(u[te],"g");var Y=a++;u[Y]="^"+u[B]+u[l]+"$";var oe=a++;u[oe]="^"+u[B]+u[k]+"$";var re=a++;u[re]="(?:\\^)";var he=a++;u[he]="(\\s*)"+u[re]+"\\s+",I[he]=new RegExp(u[he],"g");var ce=a++;u[ce]="^"+u[re]+u[l]+"$";var ae=a++;u[ae]="^"+u[re]+u[k]+"$";var q=a++;u[q]="^"+u[i]+"\\s*("+o+")$|^$";var Q=a++;u[Q]="^"+u[i]+"\\s*("+s+")$|^$";var U=a++;u[U]="(\\s*)"+u[i]+"\\s*("+o+"|"+u[l]+")",I[U]=new RegExp(u[U],"g");var T=a++;u[T]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var H=a++;u[H]="^\\s*("+u[k]+")\\s+-\\s+("+u[k]+")\\s*$";var X=a++;u[X]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)R(x,u[x]),I[x]||(I[x]=new RegExp(u[x]));function K(V,Z){if(V instanceof F)return V;if(typeof V!="string"||V.length>N||!(Z?I[t]:I[m]).test(V))return null;try{return new F(V,Z)}catch{return null}}function F(V,Z){if(V instanceof F){if(V.loose===Z)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof F))return new F(V,Z);R("SemVer",V,Z),this.loose=Z;var _=V.trim().match(Z?I[t]:I[m]);if(!_)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ye=+me;if(ye>=0&&ye<A)return ye}return me}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=K,e.valid=function(V,Z){var _=K(V,Z);return _?_.version:null},e.clean=function(V,Z){var _=K(V.trim().replace(/^[=v]+/,""),Z);return _?_.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof F||(V=new F(V,this.loose)),this.compareMain(V)||this.comparePre(V)},F.prototype.compareMain=function(V){return V instanceof F||(V=new F(V,this.loose)),d(this.major,V.major)||d(this.minor,V.minor)||d(this.patch,V.patch)},F.prototype.comparePre=function(V){if(V instanceof F||(V=new F(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Z=0;do{var _=this.prerelease[Z],me=V.prerelease[Z];if(R("prerelease compare",Z,_,me),_===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(_===void 0)return-1;if(_!==me)return d(_,me)}while(++Z)},F.prototype.inc=function(V,Z){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Z,_,me){typeof _=="string"&&(me=_,_=void 0);try{return new F(V,_).inc(Z,me).version}catch{return null}},e.diff=function(V,Z){if(W(V,Z))return null;var _=K(V),me=K(Z);if(_.prerelease.length||me.prerelease.length){for(var ye in _)if((ye==="major"||ye==="minor"||ye==="patch")&&_[ye]!==me[ye])return"pre"+ye;return"prerelease"}for(var ye in _)if((ye==="major"||ye==="minor"||ye==="patch")&&_[ye]!==me[ye])return ye},e.compareIdentifiers=d;var C=/^[0-9]+$/;function d(V,Z){var _=C.test(V),me=C.test(Z);return _&&me&&(V=+V,Z=+Z),_&&!me?-1:me&&!_?1:V<Z?-1:V>Z?1:0}function P(V,Z,_){return new F(V,_).compare(new F(Z,_))}function z(V,Z,_){return P(V,Z,_)>0}function M(V,Z,_){return P(V,Z,_)<0}function W(V,Z,_){return P(V,Z,_)===0}function G(V,Z,_){return P(V,Z,_)!==0}function ee(V,Z,_){return P(V,Z,_)>=0}function ue(V,Z,_){return P(V,Z,_)<=0}function fe(V,Z,_,me){var ye;switch(Z){case"===":typeof V=="object"&&(V=V.version),typeof _=="object"&&(_=_.version),ye=V===_;break;case"!==":typeof V=="object"&&(V=V.version),typeof _=="object"&&(_=_.version),ye=V!==_;break;case"":case"=":case"==":ye=W(V,_,me);break;case"!=":ye=G(V,_,me);break;case">":ye=z(V,_,me);break;case">=":ye=ee(V,_,me);break;case"<":ye=M(V,_,me);break;case"<=":ye=ue(V,_,me);break;default:throw new TypeError("Invalid operator: "+Z)}return ye}function ge(V,Z){if(V instanceof ge){if(V.loose===Z)return V;V=V.value}if(!(this instanceof ge))return new ge(V,Z);R("comparator",V,Z),this.loose=Z,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Z){return d(Z,V)},e.major=function(V,Z){return new F(V,Z).major},e.minor=function(V,Z){return new F(V,Z).minor},e.patch=function(V,Z){return new F(V,Z).patch},e.compare=P,e.compareLoose=function(V,Z){return P(V,Z,!0)},e.rcompare=function(V,Z,_){return P(Z,V,_)},e.sort=function(V,Z){return V.sort(function(_,me){return e.compare(_,me,Z)})},e.rsort=function(V,Z){return V.sort(function(_,me){return e.rcompare(_,me,Z)})},e.gt=z,e.lt=M,e.eq=W,e.neq=G,e.gte=ee,e.lte=ue,e.cmp=fe,e.Comparator=ge;var we={};function de(V,Z){if(V instanceof de)return V.loose===Z?V:new de(V.raw,Z);if(V instanceof ge)return new de(V.value,Z);if(!(this instanceof de))return new de(V,Z);if(this.loose=Z,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function le(V){return!V||V.toLowerCase()==="x"||V==="*"}function pe(V,Z,_,me,ye,De,Se,ze,Ie,Ne,Te,Oe,Ae){return((Z=le(_)?"":le(me)?">="+_+".0.0":le(ye)?">="+_+"."+me+".0":">="+Z)+" "+(ze=le(Ie)?"":le(Ne)?"<"+(+Ie+1)+".0.0":le(Te)?"<"+Ie+"."+(+Ne+1)+".0":Oe?"<="+Ie+"."+Ne+"."+Te+"-"+Oe:"<="+ze)).trim()}function ve(V,Z){for(var _=0;_<V.length;_++)if(!V[_].test(Z))return!1;if(Z.prerelease.length){for(_=0;_<V.length;_++)if(R(V[_].semver),V[_].semver!==we&&V[_].semver.prerelease.length>0){var me=V[_].semver;if(me.major===Z.major&&me.minor===Z.minor&&me.patch===Z.patch)return!0}return!1}return!0}function ke(V,Z,_){try{Z=new de(Z,_)}catch{return!1}return Z.test(V)}function Re(V,Z,_,me){var ye,De,Se,ze,Ie;switch(V=new F(V,me),Z=new de(Z,me),_){case">":ye=z,De=ue,Se=M,ze=">",Ie=">=";break;case"<":ye=M,De=ee,Se=z,ze="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(V,Z,me))return!1;for(var Ne=0;Ne<Z.set.length;++Ne){var Te=Z.set[Ne],Oe=null,Ae=null;if(Te.forEach(function(Ce){Ce.semver===we&&(Ce=new ge(">=0.0.0")),Oe=Oe||Ce,Ae=Ae||Ce,ye(Ce.semver,Oe.semver,me)?Oe=Ce:Se(Ce.semver,Ae.semver,me)&&(Ae=Ce)}),Oe.operator===ze||Oe.operator===Ie||(!Ae.operator||Ae.operator===ze)&&De(V,Ae.semver)||Ae.operator===Ie&&Se(V,Ae.semver))return!1}return!0}ge.prototype.parse=function(V){var Z=this.loose?I[q]:I[Q],_=V.match(Z);if(!_)throw new TypeError("Invalid comparator: "+V);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new F(_[2],this.loose):this.semver=we},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new F(V,this.loose)),fe(V,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(V,Z){if(!(V instanceof ge))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new de(V.value,Z),ke(this.value,_,Z);if(V.operator==="")return _=new de(this.value,Z),ke(V.semver,_,Z);var me=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),ze=fe(this.semver,"<",V.semver,Z)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=fe(this.semver,">",V.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return me||ye||De&&Se||ze||Ie},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(V){var Z=this.loose;V=V.trim(),R("range",V,Z);var _=Z?I[H]:I[T];V=V.replace(_,pe),R("hyphen replace",V),V=V.replace(I[U],"$1$2$3"),R("comparator trim",V,I[U]),V=(V=(V=V.replace(I[te],"$1~")).replace(I[he],"$1^")).split(/\s+/).join(" ");var me=Z?I[q]:I[Q],ye=V.split(" ").map(function(De){return function(Se,ze){return R("comp",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Te){return function(Oe,Ae){R("caret",Oe,Ae);var Ce=Ae?I[ae]:I[ce];return Oe.replace(Ce,function(Le,be,Ee,Pe,je){var Fe;return R("caret",Oe,Le,be,Ee,Pe,je),le(be)?Fe="":le(Ee)?Fe=">="+be+".0.0 <"+(+be+1)+".0.0":le(Pe)?Fe=be==="0"?">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+".0 <"+(+be+1)+".0.0":je?(R("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Fe=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Pe+je+" <"+be+"."+Ee+"."+(+Pe+1):">="+be+"."+Ee+"."+Pe+je+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Pe+je+" <"+(+be+1)+".0.0"):(R("no pr"),Fe=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Pe+" <"+be+"."+Ee+"."+(+Pe+1):">="+be+"."+Ee+"."+Pe+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Pe+" <"+(+be+1)+".0.0"),R("caret return",Fe),Fe})}(Te,Ne)}).join(" ")}(Se,ze),R("caret",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Te){return function(Oe,Ae){var Ce=Ae?I[oe]:I[Y];return Oe.replace(Ce,function(Le,be,Ee,Pe,je){var Fe;return R("tilde",Oe,Le,be,Ee,Pe,je),le(be)?Fe="":le(Ee)?Fe=">="+be+".0.0 <"+(+be+1)+".0.0":le(Pe)?Fe=">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":je?(R("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Fe=">="+be+"."+Ee+"."+Pe+je+" <"+be+"."+(+Ee+1)+".0"):Fe=">="+be+"."+Ee+"."+Pe+" <"+be+"."+(+Ee+1)+".0",R("tilde return",Fe),Fe})}(Te,Ne)}).join(" ")}(Se,ze),R("tildes",Se),Se=function(Ie,Ne){return R("replaceXRanges",Ie,Ne),Ie.split(/\s+/).map(function(Te){return function(Oe,Ae){Oe=Oe.trim();var Ce=Ae?I[w]:I[S];return Oe.replace(Ce,function(Le,be,Ee,Pe,je,Fe){R("xRange",Oe,Le,be,Ee,Pe,je,Fe);var qe=le(Ee),Me=qe||le(Pe),Ue=Me||le(je);return be==="="&&Ue&&(be=""),qe?Le=be===">"||be==="<"?"<0.0.0":"*":be&&Ue?(Me&&(Pe=0),Ue&&(je=0),be===">"?(be=">=",Me?(Ee=+Ee+1,Pe=0,je=0):Ue&&(Pe=+Pe+1,je=0)):be==="<="&&(be="<",Me?Ee=+Ee+1:Pe=+Pe+1),Le=be+Ee+"."+Pe+"."+je):Me?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Ue&&(Le=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Le),Le})}(Te,Ne)}).join(" ")}(Se,ze),R("xrange",Se),Se=function(Ie,Ne){return R("replaceStars",Ie,Ne),Ie.trim().replace(I[X],"")}(Se,ze),R("stars",Se),Se}(De,Z)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match(me)})),ye=ye.map(function(De){return new ge(De,Z)})},de.prototype.intersects=function(V,Z){if(!(V instanceof de))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(me){return V.set.some(function(ye){return ye.every(function(De){return me.intersects(De,Z)})})})})},e.toComparators=function(V,Z){return new de(V,Z).set.map(function(_){return _.map(function(me){return me.value}).join(" ").trim().split(" ")})},de.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new F(V,this.loose));for(var Z=0;Z<this.set.length;Z++)if(ve(this.set[Z],V))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(V,Z,_){var me=null,ye=null;try{var De=new de(Z,_)}catch{return null}return V.forEach(function(Se){De.test(Se)&&(me&&ye.compare(Se)!==-1||(ye=new F(me=Se,_)))}),me},e.minSatisfying=function(V,Z,_){var me=null,ye=null;try{var De=new de(Z,_)}catch{return null}return V.forEach(function(Se){De.test(Se)&&(me&&ye.compare(Se)!==1||(ye=new F(me=Se,_)))}),me},e.validRange=function(V,Z){try{return new de(V,Z).range||"*"}catch{return null}},e.ltr=function(V,Z,_){return Re(V,Z,"<",_)},e.gtr=function(V,Z,_){return Re(V,Z,">",_)},e.outside=Re,e.prerelease=function(V,Z){var _=K(V,Z);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(V,Z,_){return V=new de(V,_),Z=new de(Z,_),V.intersects(Z)},e.coerce=function(V){if(V instanceof F)return V;if(typeof V!="string")return null;var Z=V.match(I[j]);return Z==null?null:K((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,R=J.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(g){if(L===setTimeout)return setTimeout(g,0);if((L===N||!L)&&setTimeout)return L=setTimeout,setTimeout(g,0);try{return L(g,0)}catch{try{return L.call(null,g,0)}catch{return L.call(this,g,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:N}catch{L=N}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var u,a=[],y=!1,b=-1;function $(){y&&u&&(y=!1,u.length?a=u.concat(a):b=-1,a.length&&f())}function f(){if(!y){var g=I($);y=!0;for(var c=a.length;c;){for(u=a,a=[];++b<c;)u&&u[b].run();b=-1,c=a.length}u=null,y=!1,function(p){if(D===clearTimeout)return clearTimeout(p);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(p);try{D(p)}catch{try{return D.call(null,p)}catch{return D.call(this,p)}}}(g)}}function v(g,c){this.fun=g,this.array=c}function E(){}R.nextTick=function(g){var c=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)c[p-1]=arguments[p];a.push(new v(g,c)),a.length!==1||y||I(f)},v.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=E,R.addListener=E,R.once=E,R.off=E,R.removeListener=E,R.removeAllListeners=E,R.emit=E,R.prependListener=E,R.prependOnceListener=E,R.listeners=function(g){return[]},R.binding=function(g){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(g){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ie[75],ne([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0;class D{constructor(I,u,a){this.level=I,this.key=u,this.value=a,this.forward=[]}}const R=void 0;class N{constructor(I,u=2**16){this.comparator=I,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(I){return!!N.g(this,I,this.comparator)}get(I){return N.g(this,I,this.comparator)?.value}set(I,u){return N.h(this,I,u,this.comparator)&&(this.f+=1),this}delete(I){const u=N.k(this,I,this.comparator);return u&&(this.f-=1),u}forEach(I,u){let a=this.e.forward[0];for(;a;)I.call(u,a.value,a.key,this),a=a.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",u=this.e.forward[0];for(;u;)I+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return I}static g(I,u,a){let y=I.e;for(let b=I.d-1;b>=0;b--)for(;y.forward[b]&&a(y.forward[b].key,u)<0;)y=y.forward[b];if(y=y.forward[0],y&&a(y.key,u)===0)return y}static h(I,u,a,y){const b=[];let $=I.e;for(let f=I.d-1;f>=0;f--){for(;$.forward[f]&&y($.forward[f].key,u)<0;)$=$.forward[f];b[f]=$}if($=$.forward[0],$&&y($.key,u)===0)return $.value=a,!1;{const f=N.j(I);if(f>I.d){for(let v=I.d;v<f;v++)b[v]=I.e;I.d=f}$=new D(f,u,a);for(let v=0;v<f;v++)$.forward[v]=b[v].forward[v],b[v].forward[v]=$;return!0}}static j(I,u=.5){let a=1;for(;Math.random()<u&&a<I.c;)a+=1;return a}static k(I,u,a){const y=[];let b=I.e;for(let $=I.d-1;$>=0;$--){for(;b.forward[$]&&a(b.forward[$].key,u)<0;)b=b.forward[$];y[$]=b}if(b=b.forward[0],!b||a(b.key,u)!==0)return!1;for(let $=0;$<I.d&&y[$].forward[$]===b;$++)y[$].forward[$]=b.forward[$];for(;I.d>0&&I.e.forward[I.d-1]===R;)I.d-=1;return!0}}e.$1r=N}),define(ie[46],ne([0,1,7,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function R(h){const m=h;return m?typeof m.read=="function":!1}e.$7d=R;function N(h){const m=h;return m?[m.on,m.pause,m.resume,m.destroy].every(s=>typeof s=="function"):!1}e.$8d=N;function A(h){const m=h;return m?N(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.$9d=A;function I(h,m){return new u(h,m)}e.$0d=I;class u{constructor(m,s){this.e=m,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(s=>s(m))}h(m){this.c.error.length===0?(0,L.$1)(m):this.c.error.slice(0).forEach(s=>s(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,s){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(m,s){if(this.a.destroyed)return;let o;switch(m){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(h,m){const s=[];let o;for(;(o=h.read())!==null;)s.push(o);return m(s)}e.$$d=a;function y(h,m,s){const o=[];let t;for(;(t=h.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?m(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return h.read()}}}e.$_d=y;function b(h,m){return new Promise((s,o)=>{const t=[];$(h,{onData:i=>{m&&t.push(i)},onError:i=>{m?o(i):s(void 0)},onEnd:()=>{s(m?m(t):void 0)}})})}e.$ae=b;function $(h,m,s){h.on("error",o=>{s?.isCancellationRequested||m.onError(o)}),h.on("end",()=>{s?.isCancellationRequested||m.onEnd()}),h.on("data",o=>{s?.isCancellationRequested||m.onData(o)})}e.$be=$;function f(h,m){return new Promise((s,o)=>{const t=new D.$Sc,i=[],n=k=>{if(i.push(k),i.length>m)return t.dispose(),h.pause(),s({stream:h,buffer:i,ended:!1})},r=k=>(t.dispose(),o(k)),l=()=>(t.dispose(),s({stream:h,buffer:i,ended:!0}));t.add((0,D.$Rc)(()=>h.removeListener("error",r))),h.on("error",r),t.add((0,D.$Rc)(()=>h.removeListener("end",l))),h.on("end",l),t.add((0,D.$Rc)(()=>h.removeListener("data",n))),h.on("data",n)})}e.$ce=f;function v(h,m){const s=I(m);return s.end(h),s}e.$de=v;function E(){const h=I(()=>{throw new Error("not supported")});return h.end(),h}e.$ee=E;function g(h){let m=!1;return{read:()=>m?null:(m=!0,h)}}e.$fe=g;function c(h,m,s){const o=I(s);return $(h,{onData:t=>o.write(m.data(t)),onError:t=>o.error(m.error?m.error(t):t),onEnd:()=>o.end()}),o}e.$ge=c;function p(h,m,s){let o=!1;return{read:()=>{const t=m.read();return o?t:(o=!0,t!==null?s([h,t]):h)}}}e.$he=p;function O(h,m,s){let o=!1;const t=I(s);return $(m,{onData:i=>o?t.write(i):(o=!0,t.write(s([h,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(h)),t.end()}}),t}e.$ie=O}),define(ie[14],ne([0,1,166,46]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const R=typeof Buffer<"u",N=new L.$V(()=>new Uint8Array(256));let A,I;class u{static alloc(j){return R?new u(Buffer.allocUnsafe(j)):new u(new Uint8Array(j))}static wrap(j){return R&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new u(j)}static fromString(j,B){return!(B?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(j)):(A||(A=new TextEncoder),new u(A.encode(j)))}static fromByteArray(j){const B=u.alloc(j.length);for(let te=0,Y=j.length;te<Y;te++)B.buffer[te]=j[te];return B}static concat(j,B){if(typeof B>"u"){B=0;for(let oe=0,re=j.length;oe<re;oe++)B+=j[oe].byteLength}const te=u.alloc(B);let Y=0;for(let oe=0,re=j.length;oe<re;oe++){const he=j[oe];te.set(he,Y),Y+=he.byteLength}return te}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=u.alloc(this.byteLength);return j.set(this),j}toString(){return R?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(j,B){return new u(this.buffer.subarray(j,B))}set(j,B){if(j instanceof u)this.buffer.set(j.buffer,B);else if(j instanceof Uint8Array)this.buffer.set(j,B);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),B);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return $(this.buffer,j)}writeUInt32BE(j,B){f(this.buffer,j,B)}readUInt32LE(j){return v(this.buffer,j)}writeUInt32LE(j,B){E(this.buffer,j,B)}readUInt8(j){return g(this.buffer,j)}writeUInt8(j,B){c(this.buffer,j,B)}indexOf(j,B=0){return a(this.buffer,j instanceof u?j.buffer:j,B)}}e.$je=u;function a(w,j,B=0){const te=j.byteLength,Y=w.byteLength;if(te===0)return 0;if(te===1)return w.indexOf(j[0]);if(te>Y-B)return-1;const oe=N.value;oe.fill(j.length);for(let ae=0;ae<j.length;ae++)oe[j[ae]]=j.length-ae-1;let re=B+j.length-1,he=re,ce=-1;for(;re<Y;)if(w[re]===j[he]){if(he===0){ce=re;break}re--,he--}else re+=Math.max(j.length-he,oe[w[re]]),he=j.length-1;return ce}e.$ke=a;function y(w,j){return w[j+0]<<0>>>0|w[j+1]<<8>>>0}e.$le=y;function b(w,j,B){w[B+0]=j&255,j=j>>>8,w[B+1]=j&255}e.$me=b;function $(w,j){return w[j]*2**24+w[j+1]*2**16+w[j+2]*2**8+w[j+3]}e.$ne=$;function f(w,j,B){w[B+3]=j,j=j>>>8,w[B+2]=j,j=j>>>8,w[B+1]=j,j=j>>>8,w[B]=j}e.$oe=f;function v(w,j){return w[j+0]<<0>>>0|w[j+1]<<8>>>0|w[j+2]<<16>>>0|w[j+3]<<24>>>0}e.$pe=v;function E(w,j,B){w[B+0]=j&255,j=j>>>8,w[B+1]=j&255,j=j>>>8,w[B+2]=j&255,j=j>>>8,w[B+3]=j&255}e.$qe=E;function g(w,j){return w[j]}e.$re=g;function c(w,j,B){w[B]=j}e.$se=c;function p(w){return D.$$d(w,j=>u.concat(j))}e.$te=p;function O(w){return D.$fe(w)}e.$ue=O;function h(w){return D.$ae(w,j=>u.concat(j))}e.$ve=h;async function m(w){return w.ended?u.concat(w.buffer):u.concat([...w.buffer,await h(w.stream)])}e.$we=m;function s(w){return D.$de(w,j=>u.concat(j))}e.$xe=s;function o(w){return D.$ge(w,{data:j=>typeof j=="string"?u.fromString(j):u.wrap(j)},j=>u.concat(j))}e.$ye=o;function t(w){return D.$0d(j=>u.concat(j),w)}e.$ze=t;function i(w,j){return D.$he(w,j,B=>u.concat(B))}e.$Ae=i;function n(w,j){return D.$ie(w,j,B=>u.concat(B))}e.$Be=n;function r(w){let j=0,B=0,te=0;const Y=new Uint8Array(Math.floor(w.length/4*3)),oe=he=>{switch(B){case 3:Y[te++]=j|he,B=0;break;case 2:Y[te++]=j|he>>>2,j=he<<6,B=3;break;case 1:Y[te++]=j|he>>>4,j=he<<4,B=2;break;default:j=he<<2,B=1}};for(let he=0;he<w.length;he++){const ce=w.charCodeAt(he);if(ce>=65&&ce<=90)oe(ce-65);else if(ce>=97&&ce<=122)oe(ce-97+26);else if(ce>=48&&ce<=57)oe(ce-48+52);else if(ce===43||ce===45)oe(62);else if(ce===47||ce===95)oe(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${w[he]}`)}}const re=te;for(;B>0;)oe(0);return u.wrap(Y).slice(0,re)}e.$Ce=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:w},j=!0,B=!1){const te=B?k:l;let Y="";const oe=w.byteLength%3;let re=0;for(;re<w.byteLength-oe;re+=3){const he=w[re+0],ce=w[re+1],ae=w[re+2];Y+=te[he>>>2],Y+=te[(he<<4|ce>>>4)&63],Y+=te[(ce<<2|ae>>>6)&63],Y+=te[ae&63]}if(oe===1){const he=w[re+0];Y+=te[he>>>2],Y+=te[he<<4&63],j&&(Y+="==")}else if(oe===2){const he=w[re+0],ce=w[re+1];Y+=te[he>>>2],Y+=te[(he<<4|ce>>>4)&63],Y+=te[ce<<2&63],j&&(Y+="=")}return Y}e.$De=S}),define(ie[43],ne([0,1,30]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;function D(c){return R(c,0)}e.$Ti=D;function R(c,p){switch(typeof c){case"object":return c===null?N(349,p):Array.isArray(c)?u(c,p):a(c,p);case"string":return I(c,p);case"boolean":return A(c,p);case"number":return N(c,p);case"undefined":return N(937,p);default:return N(617,p)}}e.$Ui=R;function N(c,p){return(p<<5)-p+c|0}e.$Vi=N;function A(c,p){return N(c?433:863,p)}function I(c,p){p=N(149417,p);for(let O=0,h=c.length;O<h;O++)p=N(c.charCodeAt(O),p);return p}e.$Wi=I;function u(c,p){return p=N(104579,p),c.reduce((O,h)=>R(h,O),p)}function a(c,p){return p=N(181387,p),Object.keys(c).sort().reduce((O,h)=>(O=I(h,O),R(c[h],O)),p)}class y{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=R(p,this.g),this.g}}e.$Xi=y;var b;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function $(c,p,O=32){const h=O-p,m=~((1<<h)-1);return(c<<p|(m&c)>>>h)>>>0}function f(c,p=0,O=c.byteLength,h=0){for(let m=0;m<O;m++)c[p+m]=h}function v(c,p,O="0"){for(;c.length<p;)c=O+c;return c}function E(c,p=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(O=>O.toString(16).padStart(2,"0")).join(""):v((c>>>0).toString(16),p/4)}e.$Yi=E;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const O=p.length;if(O===0)return;const h=this.p;let m=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=p.charCodeAt(0),t=0);;){let i=o;if(L.$df(o))if(t+1<O){const n=p.charCodeAt(t+1);L.$ef(n)?(t++,i=L.$ff(o,n)):i=65533}else{s=o;break}else L.$ef(o)&&(i=65533);if(m=this.w(h,m,i),t++,t<O)o=p.charCodeAt(t);else break}this.r=m,this.u=s}w(p,O,h){return h<128?p[O++]=h:h<2048?(p[O++]=192|(h&1984)>>>6,p[O++]=128|(h&63)>>>0):h<65536?(p[O++]=224|(h&61440)>>>12,p[O++]=128|(h&4032)>>>6,p[O++]=128|(h&63)>>>0):(p[O++]=240|(h&1835008)>>>18,p[O++]=128|(h&258048)>>>12,p[O++]=128|(h&4032)>>>6,p[O++]=128|(h&63)>>>0),O>=64&&(this.y(),O-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),O}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=g.g,O=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,O.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,$(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let h=this.h,m=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let l=0;l<80;l++)l<20?(i=m&s|~m&o,n=1518500249):l<40?(i=m^s^o,n=1859775393):l<60?(i=m&s|m&o|s&o,n=2400959708):(i=m^s^o,n=3395469782),r=$(h,5)+i+t+n+p.getUint32(l*4,!1)&4294967295,t=o,o=s,s=$(m,30),m=h,h=r;this.h=this.h+h&4294967295,this.l=this.l+m&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Zi=g}),define(ie[54],ne([0,1,30]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const N="error",A="warning",I="warn",u="info",a="ignore";function y($){return $?L.$_e(N,$)?R.Error:L.$_e(A,$)||L.$_e(I,$)?R.Warning:L.$_e(u,$)?R.Info:R.Ignore:R.Ignore}R.fromValue=y;function b($){switch($){case R.Error:return N;case R.Warning:return A;case R.Info:return u;default:return a}}R.toString=b}(D||(D={})),e.default=D}),define(ie[28],ne([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([O,h])=>{p[O]=h&&typeof h=="object"?D(h):h}),p}e.$vn=D;function R(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const O=p.shift();Object.freeze(O);for(const h in O)if(N.call(O,h)){const m=O[h];typeof m=="object"&&!Object.isFrozen(m)&&!(0,L.$Lf)(m)&&p.push(m)}}return c}e.$wn=R;const N=Object.prototype.hasOwnProperty;function A(c,p){return I(c,p,new Set)}e.$xn=A;function I(c,p,O){if((0,L.$Rf)(c))return c;const h=p(c);if(typeof h<"u")return h;if(Array.isArray(c)){const m=[];for(const s of c)m.push(I(s,p,O));return m}if((0,L.$Kf)(c)){if(O.has(c))throw new Error("Cannot clone recursive data-structure");O.add(c);const m={};for(const s in c)N.call(c,s)&&(m[s]=I(c[s],p,O));return O.delete(c),m}return c}function u(c,p,O=!0){return(0,L.$Kf)(c)?((0,L.$Kf)(p)&&Object.keys(p).forEach(h=>{h in c?O&&((0,L.$Kf)(c[h])&&(0,L.$Kf)(p[h])?u(c[h],p[h],O):c[h]=p[h]):c[h]=p[h]}),c):p}e.$yn=u;function a(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let O,h;if(Array.isArray(c)){if(c.length!==p.length)return!1;for(O=0;O<c.length;O++)if(!a(c[O],p[O]))return!1}else{const m=[];for(h in c)m.push(h);m.sort();const s=[];for(h in p)s.push(h);if(s.sort(),!a(m,s))return!1;for(O=0;O<m.length;O++)if(!a(c[m[O]],p[m[O]]))return!1}return!0}e.$zn=a;function y(c){const p=new Set;return JSON.stringify(c,(O,h)=>{if((0,L.$Kf)(h)||Array.isArray(h)){if(p.has(h))return"[Circular]";p.add(h)}return h})}e.$An=y;function b(c,p){const O=Object.create(null);return!c||!p||Object.keys(p).forEach(m=>{const s=c[m],o=p[m];a(s,o)||(O[m]=o)}),O}e.$Bn=b;function $(c,p){const O=p.toLowerCase(),h=Object.keys(c).find(m=>m.toLowerCase()===O);return h?c[h]:c[p]}e.$Cn=$;function f(c,p){const O=Object.create(null);for(const[h,m]of Object.entries(c))p(h,m)&&(O[h]=m);return O}e.$Dn=f;function v(c){let p=[];for(;Object.prototype!==c;)p=p.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return p}e.$En=v;function E(c){const p=[];for(const O of v(c))typeof c[O]=="function"&&p.push(O);return p}e.$Fn=E;function g(c,p){const O=m=>function(){const s=Array.prototype.slice.call(arguments,0);return p(m,s)},h={};for(const m of c)h[m]=O(m);return h}e.$Gn=g}),define(ie[29],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return L.test(R)}e.$pg=D,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(I){for(let u=0;u<I.length;u++)I[u]=Math.floor(Math.random()*256);return I};const N=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){R(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let u=0,a="";return a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a}}()}),define(ie[76],ne([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(A){const I=A.replace(/\-/g,":").toLowerCase();return!D.has(I)}function N(){const A=(0,L.networkInterfaces)();for(const I in A){const u=A[I];if(u){for(const{mac:a}of u)if(R(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$9m=N}),define(ie[77],ne([8,6]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[78],ne([0,1,77]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const D=60,R=D*60,N=R*24,A=N*7,I=N*30,u=N*365;function a(b,$,f,v){typeof b!="number"&&(b=b.getTime());const E=Math.round((new Date().getTime()-b)/1e3);if(E<-30)return(0,L.localize)(0,null,a(new Date().getTime()+E*1e3,!1));if(!v&&E<30)return(0,L.localize)(1,null);let g;return E<D?(g=E,$?g===1?f?(0,L.localize)(2,null,g):(0,L.localize)(3,null,g):f?(0,L.localize)(4,null,g):(0,L.localize)(5,null,g):g===1?f?(0,L.localize)(6,null,g):(0,L.localize)(7,null,g):f?(0,L.localize)(8,null,g):(0,L.localize)(9,null,g)):E<R?(g=Math.floor(E/D),$?g===1?f?(0,L.localize)(10,null,g):(0,L.localize)(11,null,g):f?(0,L.localize)(12,null,g):(0,L.localize)(13,null,g):g===1?f?(0,L.localize)(14,null,g):(0,L.localize)(15,null,g):f?(0,L.localize)(16,null,g):(0,L.localize)(17,null,g)):E<N?(g=Math.floor(E/R),$?g===1?f?(0,L.localize)(18,null,g):(0,L.localize)(19,null,g):f?(0,L.localize)(20,null,g):(0,L.localize)(21,null,g):g===1?f?(0,L.localize)(22,null,g):(0,L.localize)(23,null,g):f?(0,L.localize)(24,null,g):(0,L.localize)(25,null,g)):E<A?(g=Math.floor(E/N),$?g===1?(0,L.localize)(26,null,g):(0,L.localize)(27,null,g):g===1?(0,L.localize)(28,null,g):(0,L.localize)(29,null,g)):E<I?(g=Math.floor(E/A),$?g===1?f?(0,L.localize)(30,null,g):(0,L.localize)(31,null,g):f?(0,L.localize)(32,null,g):(0,L.localize)(33,null,g):g===1?f?(0,L.localize)(34,null,g):(0,L.localize)(35,null,g):f?(0,L.localize)(36,null,g):(0,L.localize)(37,null,g)):E<u?(g=Math.floor(E/I),$?g===1?f?(0,L.localize)(38,null,g):(0,L.localize)(39,null,g):f?(0,L.localize)(40,null,g):(0,L.localize)(41,null,g):g===1?f?(0,L.localize)(42,null,g):(0,L.localize)(43,null,g):f?(0,L.localize)(44,null,g):(0,L.localize)(45,null,g)):(g=Math.floor(E/u),$?g===1?f?(0,L.localize)(46,null,g):(0,L.localize)(47,null,g):f?(0,L.localize)(48,null,g):(0,L.localize)(49,null,g):g===1?f?(0,L.localize)(50,null,g):(0,L.localize)(51,null,g):f?(0,L.localize)(52,null,g):(0,L.localize)(53,null,g))}e.$vm=a;function y(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=y}),define(ie[79],ne([8,6]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[34],ne([0,1,19,3,79]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function N(b,$){return $&&(b.stack||b.stacktrace)?R.localize(0,null,I(b),A(b.stack)||A(b.stacktrace)):I(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function I(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function u(b=null,$=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const f=L.$Hb(b),v=u(f[0],$);return f.length>1?R.localize(4,null,v,f.length):v}if(D.$If(b))return b;if(b.detail){const f=b.detail;if(f.error)return N(f.error,$);if(f.exception)return N(f.exception,$)}return b.stack?N(b,$):b.message?b.message:R.localize(5,null)}e.$Qi=u;function a(b){const $=b;return $ instanceof Error&&Array.isArray($.actions)}e.$Ri=a;function y(b,$){let f;return typeof b=="string"?f=new Error(b):f=b,f.actions=$,f}e.$Si=y}),define(ie[80],ne([8,6]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ie[81],ne([0,1,80]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;function D(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$Xp=D}),define(ie[55],ne([0,1,12]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0;var D;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function N(I,...u){const a=u.reduce(($,f)=>($[f]=!0,$),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter($=>!a[$]).forEach($=>{for(let f=0;f<y.length;f++)if($.search(y[f])!==-1){delete I[$];break}})}e.$Rl=N;function A(I){I&&(delete I.DEBUG,L.$j&&delete I.DYLD_LIBRARY_PATH,L.$k&&delete I.LD_PRELOAD)}e.$Sl=A}),define(ie[82],ne([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$oq=e.$nq=e.$mq=void 0;function D(a){const y=a;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.$mq=D;function R(a){const y=[];let b;try{const $=JSON.parse(a.arguments),f=$[$.length-1];f&&f.__$stack&&($.pop(),b=f.__$stack),y.push(...$)}catch{y.push("Unable to log remote console arguments",a.arguments)}return{args:y,stack:b}}e.$nq=R;function N(a){if(typeof a!="string")return N(R(a).stack);const y=a;if(y){const b=A(y),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if($&&$.length===4)return{uri:L.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$oq=N;function A(a){if(!a)return a;const y=a.indexOf(`
`);return y===-1?a:a.substring(0,y)}function I(a,y){const{args:b,stack:$}=R(a),f=typeof b[0]=="string"&&b.length===1;let v=A($);v&&(v=`(${v.trim()})`);let E=[];if(typeof b[0]=="string"?v&&f?E=[`%c[${y}] %c${b[0]} %c${v}`,u("blue"),u(""),u("grey")]:E=[`%c[${y}] %c${b[0]}`,u("blue"),u(""),...b.slice(1)]:E=[`%c[${y}]%`,u("blue"),...b],v&&!f&&E.push(v),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,E)}e.log=I;function u(a){return`color: ${a}`}}),define(ie[47],ne([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function R(u){return JSON.stringify(u,A)}e.$Ah=R;function N(u){let a=JSON.parse(u);return a=I(a),a}e.$Bh=N;function A(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function I(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$je||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let y=0;y<u.length;++y)u[y]=I(u[y],a+1);else for(const y in u)Object.hasOwnProperty.call(u,y)&&(u[y]=I(u[y],a+1))}return u}e.$Ch=I}),define(ie[83],ne([0,1,70,15,12,11]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=void 0;class A{constructor($,f,v){this.id=$,this.dependencies=f,this.callback=v}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,f,v)=>{typeof $!="string"&&(v=f,f=$,$=null),(typeof f!="object"||!Array.isArray(f))&&(v=f,f=null),this.c.push(new A($,f,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const f=await(this.a?this.i($):this.b?this.h($):this.j($));if(!f)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h($){return new Promise((f,v)=>{const E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript");const g=()=>{E.removeEventListener("load",c),E.removeEventListener("error",p)},c=O=>{g(),f(this.c.pop())},p=O=>{g(),v(O)};E.addEventListener("load",c),E.addEventListener("error",p),this.f&&($=this.f.createScriptURL($)),E.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(E)})}i($){return new Promise((f,v)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),f(this.c.pop())}catch(E){v(E)}})}async j($){try{const f=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,E=globalThis._VSCODE_NODE_MODULES.module,g=N.URI.parse($).fsPath,c=f.readFileSync(g).toString(),p=E.wrap(c.replace(/^#!.*/,""));return new v.Script(p).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function y(b,$,f){if(L.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[b]&&(b=a[b]);const v=`${b}/${$}`;if(u.has(v))return u.get(v);let E;if(/^\w[\w\d+.-]*:\/\//.test(v))E=v;else{const O=`${f&&!R.$o?D.$lg:D.$kg}/${v}`;E=D.$og.asBrowserUri(O).toString(!0)}const g=I.INSTANCE.load(E);return u.set(v,g),g}else return await new Promise((v,E)=>{J([b],v,E)})}e.$fD=y}),define(ie[84],ne([0,1,33,48,29,76,12]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=new class{c($){return this.a||(this.a=D.$_h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,f=0;const v=(0,L.networkInterfaces)();for(const E in v){const g=v[E];if(g)for(const{mac:c,internal:p}of g)p||(f+=1,this.c(c.toUpperCase())&&($+=1))}this.b=f>0?$/f:0}return this.b}};let I;async function u($){return I||(I=(async()=>await a($)||R.$qg())()),I}e.$$m=u;async function a($){try{const f=await new Promise((E,g)=>{J(["crypto"],E,g)}),v=(0,N.$9m)();return f.createHash("sha256").update(v,"utf8").digest("hex")}catch(f){$(f);return}}const y="Software\\Microsoft\\SQMClient";async function b($){if(A.$i){const f=await new Promise((v,E)=>{J(["@vscode/windows-registry"],v,E)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(v){return $(v),""}}return""}e.$_m=b}),define(ie[85],ne([0,1,33,16,24]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=void 0;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class b{constructor(m,s,o){this.exePath=m,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function $({useAlternateBitness:h=!1}={}){return h?a===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:h=!1,findPreview:m=!1}={}){const s=$({useAlternateBitness:h});if(!s)return null;const o=D.$jc(s,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const l of await R.Promises.readdir(o)){let k=-1;if(m){const w=l.indexOf("-");if(w<0)continue;const j=l.substring(0,w);if(!N.test(j)||l.substring(w+1)!=="preview")continue;k=parseInt(j,10)}else{if(!N.test(l))continue;k=parseInt(l,10)}if(k<=t)continue;const S=D.$jc(o,l,"pwsh.exe");await R.SymlinkSupport.existsFile(S)&&(i=S,t=k)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=m?" Preview":"";return new b(i,`PowerShell${r}${n}`,!0)}async function v({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const m=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=h?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(m))if(s.test(t)){const i=D.$jc(m,t,"pwsh.exe");return new b(i,o)}return null}function E(){const h=D.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new b(h,".NET Core PowerShell Global Tool")}function g(){const h=D.$jc(process.env.windir,a===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(h,"Windows PowerShell",!0)}async function*c(){let h=await f();h&&(yield h),h=await f({useAlternateBitness:!0}),h&&(yield h),h=await v(),h&&(yield h),h=E(),h&&(yield h),h=await f({findPreview:!0}),h&&(yield h),h=await v({findPreview:!0}),h&&(yield h),h=await f({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=g(),h&&(yield h)}async function*p(){for await(const h of c())await h.exists()&&(yield h)}e.$Pl=p;async function O(){for await(const h of p())return h;return null}e.$Ql=O}),define(ie[56],ne([0,1,16,12,35,55,3,24]),function(J,e,L,D,R,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function u(b=R.env){return b.comspec||"cmd.exe"}e.$Tl=u;function a(b){let $=[],f=!1;const v=function(E){if(f){$.push(E);return}(!b.send(E,c=>{if(c&&console.error(c),f=!1,$.length>0){const p=$.slice(0);$=[],p.forEach(O=>v(O))}})||D.$i)&&(f=!0)};return{send:v}}e.$Ul=a;var y;(function(b){async function $(f,v,E){if(L.$ic(f))return f;if(v===void 0&&(v=R.cwd()),L.$mc(f)!=="."||(E===void 0&&A.$If(R.env.PATH)&&(E=R.env.PATH.split(L.$tc)),E===void 0||E.length===0))return L.$jc(v,f);async function c(p){if(await I.Promises.exists(p)){let O;try{O=await I.Promises.stat(p)}catch(h){h.message.startsWith("EACCES")&&(O=await I.Promises.lstat(p))}return O?!O.isDirectory():!1}return!1}for(const p of E){let O;if(L.$ic(p)?O=L.$jc(p,f):O=L.$jc(v,p,f),await c(O))return O;let h=O+".com";if(await c(h)||(h=O+".exe",await c(h)))return h}return L.$jc(v,f)}b.findExecutable=$})(y||(e.win32=y={}))}),define(ie[86],ne([0,1,33,12,85,56]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=void 0;async function A(b,$){return b===1?D.$i?y():N.$Tl($):u(b,$)}e.$Vl=A;let I=null;function u(b,$){if(D.$k&&b===2||D.$j&&b===3)return"/bin/bash";if(!I){let f;if(D.$i)f="/bin/bash";else{if(f=$.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}I=f}return I}let a=null;async function y(){return a||(a=(await(0,R.$Ql)()).exePath),a}});var $e=this&&this.__decorate||function(J,e,L,D){var R=arguments.length,N=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(J,e,L,D);else for(var I=J.length-1;I>=0;I--)(A=J[I])&&(N=(R<3?A(N):R>3?A(e,L,N):A(e,L))||N);return R>3&&N&&Object.defineProperty(e,L,N),N};define(ie[57],ne([0,1,19,9,14,20,53,7,4,2,47,30,3]),function(J,e,L,D,R,N,A,I,u,a,y,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.ProxyChannel=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.RequestInitiator=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;var f;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(f||(f={}));function v(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(E||(E={}));function g(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(c||(c={}));function p(U){let T=0;for(let H=0;;H+=7){const X=U.read(1);if(T|=(X.buffer[0]&127)<<H,!(X.buffer[0]&128))return T}}const O=t(0);function h(U,T){if(T===0){U.write(O);return}let H=0;for(let x=T;x!==0;x=x>>>7)H++;const X=R.$je.alloc(H);for(let x=0;T!==0;x++)X.buffer[x]=T&127,T=T>>>7,T>0&&(X.buffer[x]|=128);U.write(X)}class m{constructor(T){this.b=T,this.a=0}read(T){const H=this.b.slice(this.a,this.a+T);return this.a+=H.byteLength,H}}e.$Dh=m;class s{constructor(){this.a=[]}get buffer(){return R.$je.concat(this.a)}write(T){this.a.push(T)}}e.$Eh=s;var o;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(o||(o={}));function t(U){const T=R.$je.alloc(1);return T.writeUInt8(U,0),T}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(U,T){if(typeof T>"u")U.write(i.Undefined);else if(typeof T=="string"){const H=R.$je.fromString(T);U.write(i.String),h(U,H.byteLength),U.write(H)}else if(n&&Buffer.isBuffer(T)){const H=R.$je.wrap(T);U.write(i.Buffer),h(U,H.byteLength),U.write(H)}else if(T instanceof R.$je)U.write(i.VSBuffer),h(U,T.byteLength),U.write(T);else if(Array.isArray(T)){U.write(i.Array),h(U,T.length);for(const H of T)r(U,H)}else if(typeof T=="number"&&(T|0)===T)U.write(i.Uint),h(U,T);else{const H=R.$je.fromString(JSON.stringify(T));U.write(i.Object),h(U,H.byteLength),U.write(H)}}e.$Fh=r;function l(U){switch(U.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return U.read(p(U)).toString();case o.Buffer:return U.read(p(U)).buffer;case o.VSBuffer:return U.read(p(U));case o.Array:{const H=p(U),X=[];for(let x=0;x<H;x++)X.push(l(U));return X}case o.Object:return JSON.parse(U.read(p(U)).toString());case o.Int:return p(U)}}e.$Gh=l;class k{constructor(T,H,X=null,x=1e3){this.h=T,this.j=H,this.k=X,this.l=x,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(T,H){this.b.set(T,H),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const H=this.o([T.type]);this.k?.logOutgoing(H,0,1,g(T.type));return}case 201:case 202:case 204:case 203:{const H=this.o([T.type,T.id],T.data);this.k?.logOutgoing(H,T.id,1,g(T.type),T.data);return}}}o(T,H=void 0){const X=new s;return r(X,T),r(X,H),this.p(X.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const H=new m(T),X=l(H),x=l(H),K=X[0];switch(K){case 100:return this.k?.logIncoming(T.byteLength,X[1],1,`${v(K)}: ${X[2]}.${X[3]}`,x),this.s({type:K,id:X[1],channelName:X[2],name:X[3],arg:x});case 102:return this.k?.logIncoming(T.byteLength,X[1],1,`${v(K)}: ${X[2]}.${X[3]}`,x),this.t({type:K,id:X[1],channelName:X[2],name:X[3],arg:x});case 101:return this.k?.logIncoming(T.byteLength,X[1],1,`${v(K)}`),this.u({type:K,id:X[1]});case 103:return this.k?.logIncoming(T.byteLength,X[1],1,`${v(K)}`),this.u({type:K,id:X[1]})}}s(T){const H=this.b.get(T.channelName);if(!H){this.v(T);return}const X=new N.$6d;let x;try{x=H.call(this.j,T.name,T.arg,X.token)}catch(C){x=Promise.reject(C)}const K=T.id;x.then(C=>{this.m({id:K,data:C,type:201})},C=>{C instanceof Error?this.m({id:K,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split?C.stack.split(`
`):C.stack:void 0},type:202}):this.m({id:K,data:C,type:203})}).finally(()=>{F.dispose(),this.d.delete(T.id)});const F=(0,a.$Rc)(()=>X.cancel());this.d.set(T.id,F)}t(T){const H=this.b.get(T.channelName);if(!H){this.v(T);return}const X=T.id,K=H.listen(this.j,T.name,T.arg)(F=>this.m({id:X,data:F,type:204}));this.d.set(T.id,K)}u(T){const H=this.d.get(T.id);H&&(H.dispose(),this.d.delete(T.id))}v(T){let H=this.g.get(T.channelName);H||(H=[],this.g.set(T.channelName,H));const X=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:T,timeoutTimer:X})}w(T){const H=this.g.get(T);if(H){for(const X of H)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=k;var S;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class w{constructor(T,H=null){this.l=T,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=H}getChannel(T){const H=this;return{call(X,x,K){return H.a?Promise.reject(new I.$5):H.m(T,X,x,K)},listen(X,x){return H.a?u.Event.None:H.o(T,X,x)}}}m(T,H,X,x=N.CancellationToken.None){const K=this.g++,C={id:K,type:100,channelName:T,name:H,arg:X};if(x.isCancellationRequested)return Promise.reject(new I.$5);let d;return new Promise((z,M)=>{if(x.isCancellationRequested)return M(new I.$5);const W=()=>{const fe=ge=>{switch(ge.type){case 201:this.f.delete(K),z(ge.data);break;case 202:{this.f.delete(K);const we=new Error(ge.data.message);we.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,we.name=ge.data.name,M(we);break}case 203:this.f.delete(K),M(ge.data);break}};this.f.set(K,fe),this.p(C)};let G=null;this.b===c.Idle?W():(G=(0,D.$Tg)(fe=>this.u()),G.then(()=>{G=null,W()}));const ee=()=>{G?(G.cancel(),G=null):this.p({id:K,type:101}),M(new I.$5)},ue=x.onCancellationRequested(ee);d=(0,a.$Qc)((0,a.$Rc)(ee),ue),this.d.add(d)}).finally(()=>{d.dispose(),this.d.delete(d)})}o(T,H,X){const x=this.g++,F={id:x,type:102,channelName:T,name:H,arg:X};let C=null;const d=new u.$Vd({onWillAddFirstListener:()=>{C=(0,D.$Tg)(z=>this.u()),C.then(()=>{C=null,this.d.add(d),this.p(F)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(d),this.p({id:x,type:103}))}}),P=z=>d.fire(z.data);return this.f.set(x,P),d.event}p(T){switch(T.type){case 100:case 102:{const H=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(H,T.id,0,`${v(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const H=this.q([T.type,T.id]);this.j?.logOutgoing(H,T.id,0,v(T.type));return}}}q(T,H=void 0){const X=new s;return r(X,T),r(X,H),this.r(X.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const H=new m(T),X=l(H),x=l(H),K=X[0];switch(K){case 200:return this.j?.logIncoming(T.byteLength,0,0,g(K)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,X[1],0,g(K),x),this.t({type:X[0],id:X[1],data:x})}}t(T){if(T.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=w,$e([A.$xh],w.prototype,"onDidInitializePromise",null);class j{get connections(){const T=[];return this.f.forEach(H=>T.push(H)),T}constructor(T){this.a=new Map,this.f=new Set,this.g=new u.$Vd,this.onDidAddConnection=this.g.event,this.h=new u.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(T(({protocol:H,onDidClientDisconnect:X})=>{const x=u.Event.once(H.onMessage);this.j.add(x(K=>{const F=new m(K),C=l(F),d=new k(H,C),P=new w(H);this.a.forEach((M,W)=>d.registerChannel(W,M));const z={channelServer:d,channelClient:P,ctx:C};this.f.add(z),this.g.fire(z),this.j.add(X(()=>{d.dispose(),P.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(T,H){const X=this;return{call(x,K,F){let C;if((0,$.$Wf)(H)){const P=(0,L.$4b)(X.connections.filter(H));C=P?Promise.resolve(P):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,H))}else C=H.routeCall(X,x,K);const d=C.then(P=>P.channelClient.getChannel(T));return te(d).call(x,K,F)},listen(x,K){if((0,$.$Wf)(H))return X.k(T,H,x,K);const F=H.routeEvent(X,x,K).then(C=>C.channelClient.getChannel(T));return te(F).listen(x,K)}}}k(T,H,X,x){const K=this;let F;const C=new u.$Vd({onWillAddFirstListener:()=>{F=new a.$Sc;const d=new u.$2d,P=new Map,z=W=>{const ee=W.channelClient.getChannel(T).listen(X,x),ue=d.add(ee);P.set(W,ue)},M=W=>{const G=P.get(W);G&&(G.dispose(),P.delete(W))};K.connections.filter(H).forEach(z),u.Event.filter(K.onDidAddConnection,H)(z,void 0,F),K.onDidRemoveConnection(M,void 0,F),d.event(C.fire,C,F),F.add(d)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return C.event}registerChannel(T,H){this.a.set(T,H);for(const X of this.f)X.channelServer.registerChannel(T,H)}dispose(){this.j.dispose();for(const T of this.f)T.channelClient.dispose(),T.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Jh=j;class B{constructor(T,H,X=null){const x=new s;r(x,H),T.send(x.buffer),this.a=new w(T,X),this.d=new k(T,H,X)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,H){this.d.registerChannel(T,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Kh=B;function te(U){return{call(T,H,X){return U.then(x=>x.call(T,H,X))},listen(T,H){const X=new u.$5d;return U.then(x=>X.input=x.listen(T,H)),X.event}}}e.$Lh=te;function Y(U){let T=!1;return{call(H,X,x){return T?U.call(H,X,x):(0,D.$7g)(0).then(()=>T=!0).then(()=>U.call(H,X,x))},listen(H,X){if(T)return U.listen(H,X);const x=new u.$5d;return(0,D.$7g)(0).then(()=>T=!0).then(()=>x.input=U.listen(H,X)),x.event}}}e.$Mh=Y;class oe{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const H of T.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await u.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$Nh=oe;var re;(function(U){function T(K,F,C){const d=K,P=C&&C.disableMarshalling,z=new Map;for(const M in d)X(M)&&z.set(M,u.Event.buffer(d[M],!0,void 0,F));return new class{listen(M,W,G){const ee=z.get(W);if(ee)return ee;if(x(W)){const ue=d[W];if(typeof ue=="function")return ue.call(d,G)}throw new I.$bb(`Event not found: ${W}`)}call(M,W,G){const ee=d[W];if(typeof ee=="function"){if(!P&&Array.isArray(G))for(let fe=0;fe<G.length;fe++)G[fe]=(0,y.$Ch)(G[fe]);let ue=ee.apply(d,G);return ue instanceof Promise||(ue=Promise.resolve(ue)),ue}throw new I.$bb(`Method not found: ${W}`)}}}U.fromService=T;function H(K,F){const C=F&&F.disableMarshalling;return new Proxy({},{get(d,P){if(typeof P=="string")return F?.properties?.has(P)?F.properties.get(P):x(P)?function(z){return K.listen(P,z)}:X(P)?K.listen(P):async function(...z){let M;F&&!(0,$.$Rf)(F.context)?M=[F.context,...z]:M=z;const W=await K.call(P,M);return C?W:(0,y.$Ch)(W)};throw new I.$bb(`Property not found: ${String(P)}`)}})}U.toService=H;function X(K){return K[0]==="o"&&K[1]==="n"&&b.$$e(K.charCodeAt(2))}function x(K){return/^onDynamic/.test(K)&&b.$$e(K.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const T=U.toString();if(T!=="[object Object]")return T}return U}function ae(U){return Array.isArray(U)?U.map(ce):ce(U)}function q(U,T,H,X,x,K,F){F=ae(F);const C=he[x],d=C[X%C.length];let P=[`%c[${U}]%c[${String(T).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(K)?(P=P.concat(F),P.push(")")):P.push(F),console.log.apply(console,P)}class Q{constructor(T,H){this.d=T,this.f=H,this.a=0,this.b=0}logOutgoing(T,H,X,x,K){this.b+=T,q(this.d,this.b,T,H,X,x,K)}logIncoming(T,H,X,x,K){this.a+=T,q(this.f,this.a,T,H,X,x,K)}}e.$Oh=Q}),define(ie[87],ne([0,1,58,9,14,20,82,7,4,2,28,56,55,57]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class v extends f.$Hh{constructor(c){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",p=>R.$je.wrap(Buffer.from(p,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$qq=v;class E{constructor(c,p){this.i=c,this.j=p,this.c=new Set,this.g=new Map,this.h=new u.$Vd,this.onDidProcessExit=this.h.event;const O=p&&p.timeout?p.timeout:6e4;this.b=new D.$3g(O),this.d=null,this.f=null}getChannel(c){const p=this;return{call(O,h,m){return p.k(c,O,h,m)},listen(O,h){return p.l(c,O,h)}}}k(c,p,O,h=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const m=this.n(c),s=(0,D.$Tg)(i=>m.call(p,O,i)),o=h.onCancellationRequested(()=>s.cancel()),t=(0,a.$Rc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(c,p,O){if(!this.b)return u.Event.None;this.b.cancel();let h;const m=new u.$Vd({onWillAddFirstListener:()=>{h=this.n(c).listen(p,O)(m.fire,m),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,y.$vn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,$.$Sl)(p.env),this.d=(0,L.fork)(this.i,c,p);const O=new u.$Vd;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$mq)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}O.fire(R.$je.wrap(Buffer.from(n,"base64")))});const m=this.j.useQueue?(0,b.$Ul)(this.d):this.d,s=n=>this.d&&this.d.connected&&m.send(n.buffer.toString("base64")),o=O.event,t={send:s,onMessage:o};this.f=new f.$Ih(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,a.$Oc)(l)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(c){let p=this.g.get(c);return p||(p=this.m.getChannel(c),this.g.set(c,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$rq=E}),define(ie[88],ne([0,1,9,4,2,47,3]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.StorageState=e.$pp=e.StorageHint=void 0;var I;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function u($){const f=$;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$pp=u;var a;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(a||(e.StorageState=a={}));class y extends R.$Tc{static{this.a=100}constructor(f,v=Object.create(null)){super(),this.r=f,this.s=v,this.b=this.B(new D.$Yd),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new L.$4g(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((v,E)=>this.w(E,v)),f.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(f,v){if(this.c===a.Closed)return;let E=!1;(0,A.$Rf)(v)?E=this.f.delete(f):this.f.get(f)!==v&&(this.f.set(f,v),E=!0),E&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,v){const E=this.f.get(f);return(0,A.$Rf)(E)?v:E}getBoolean(f,v){const E=this.get(f);return(0,A.$Rf)(E)?v:E==="true"}getNumber(f,v){const E=this.get(f);return(0,A.$Rf)(E)?v:parseInt(E,10)}getObject(f,v){const E=this.get(f);return(0,A.$Rf)(E)?v:(0,N.$Bh)(E)}async set(f,v,E=!1){if(this.c===a.Closed)return;if((0,A.$Rf)(v))return this.delete(f,E);const g=(0,A.$Kf)(v)||Array.isArray(v)?(0,N.$Ah)(v):String(v);if(this.f.get(f)!==g)return this.f.set(f,g),this.j.set(f,g),this.h.delete(f),this.b.fire({key:f,external:E}),this.D()}async delete(f,v=!1){if(!(this.c===a.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:v}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$qp=y;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((v,E)=>this.a.set(E,v)),f.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$rp=b}),define(ie[89],ne([8,6]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ie[49],ne([0,1,90,9,16,3,24,89]),function(J,e,L,D,R,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.zip=e.$Mp=e.$Lp=void 0,e.$Lp="end of central directory record signature not found";const u=new RegExp(e.$Lp);class a extends Error{constructor(m,s){let o=s.message;switch(m){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=m,this.cause=s}}e.$Mp=a;function y(h){const m=h.externalFileAttributes>>16||33188;return[448,56,7].map(s=>m&s).reduce((s,o)=>s+o,m&61440)}function b(h){if(h instanceof a)return h;let m;return u.test(h.message)&&(m="CorruptZip"),new a(m,h)}function $(h,m,s,o,t,i){const n=R.$mc(m),r=R.$jc(o,n);if(!r.startsWith(o))return Promise.reject(new Error(I.localize(0,null,m)));const l=R.$jc(o,m);let k;return i.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(A.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((S,w)=>{if(!i.isCancellationRequested)try{k=(0,L.createWriteStream)(l,{mode:s}),k.once("close",()=>S()),k.once("error",w),h.once("error",w),h.pipe(k)}catch(j){w(j)}}))}function f(h,m,s,o){let t=(0,D.$Tg)(()=>Promise.resolve()),i=0;const n=o.onCancellationRequested(()=>{t.cancel(),h.close()});return new Promise((r,l)=>{const k=new D.$1g,S=w=>{w.isCancellationRequested||(i++,h.readEntry())};h.once("error",l),h.once("close",()=>t.then(()=>{o.isCancellationRequested||h.entryCount===i?r():l(new a("Incomplete",new Error(I.localize(1,null,i,h.entryCount))))},l)),h.readEntry(),h.on("entry",w=>{if(o.isCancellationRequested)return;if(!s.sourcePathRegex.test(w.fileName)){S(o);return}const j=w.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(j)){const Y=R.$jc(m,j);t=(0,D.$Tg)(oe=>A.Promises.mkdir(Y,{recursive:!0}).then(()=>S(oe)).then(void 0,l));return}const B=E(h,w),te=y(w);t=(0,D.$Tg)(Y=>k.queue(()=>B.then(oe=>$(oe,j,te,m,s,Y).then(()=>S(Y)))).then(null,l))})}).finally(()=>n.dispose())}async function v(h,m=!1){const{open:s}=await new Promise((o,t)=>{J(["yauzl"],o,t)});return new Promise((o,t)=>{s(h,m?{lazyEntries:!0}:void 0,(i,n)=>{i?t(b(i)):o((0,N.$Tf)(n))})})}function E(h,m){return new Promise((s,o)=>{h.openReadStream(m,(t,i)=>{t?o(b(t)):s((0,N.$Tf)(i))})})}async function g(h,m){const{ZipFile:s}=await new Promise((o,t)=>{J(["yazl"],o,t)});return new Promise((o,t)=>{const i=new s;m.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const n=(0,L.createWriteStream)(h);i.outputStream.pipe(n),i.outputStream.once("error",t),n.once("error",t),n.once("finish",()=>o(h))})}e.zip=g;function c(h,m,s={},o){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let i=v(h,!0);return s.overwrite&&(i=i.then(n=>A.Promises.rm(m).then(()=>n))),i.then(n=>f(n,m,{sourcePathRegex:t},o))}e.$Op=c;function p(h,m){return v(h).then(s=>new Promise((o,t)=>{s.on("entry",i=>{i.fileName===m&&E(s,i).then(n=>o(n),n=>t(n))}),s.once("close",()=>t(new Error(I.localize(2,null,m))))}))}function O(h,m){return p(h,m).then(s=>new Promise((o,t)=>{const i=[];s.once("error",t),s.on("data",n=>i.push(n)),s.on("end",()=>o(Buffer.concat(i)))}))}e.$Pp=O}),define(ie[91],ne([8,6]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[92],ne([8,6]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[93],ne([8,6]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ie[94],ne([8,6]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[95],ne([8,6]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[96],ne([8,6]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[97],ne([8,6]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[98],ne([8,6]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[99],ne([8,6]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[100],ne([8,6]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[101],ne([8,6]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[102],ne([8,6]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[103],ne([8,6]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[104],ne([8,6]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[105],ne([8,6]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[106],ne([8,6]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[107],ne([8,6]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ie[108],ne([8,6]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[109],ne([8,6]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[110],ne([8,6]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ie[111],ne([0,1,7,93]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var R;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(R||(e.TokenType=R={}));function N(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,D.localize)(3,null),I=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const b=this.d,$=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:$};this.g.push({offset:b,lexeme:$,additionalInfo:y}),this.f.push(f)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const b=this.c.substring(this.d,this.e),$=u.b.get(b);$?this.k($):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,b=!1,$=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(I);return}const v=this.c.charCodeAt(y);if(b)b=!1;else if(v===47&&!$){y++;break}else v===91?$=!0:v===92?b=!0:v===93&&($=!1);y++}for(;y<this.c.length&&u.a.has(this.c.charCodeAt(y));)y++;this.e=y;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=u}),define(ie[112],ne([0,1,78,53,15,16,35,17,11]),function(J,e,L,D,R,N,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$xm=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,N.$mc)(R.$og.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,I.$Hg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$Hg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",f)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$Hg)(u.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$Hg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$Hg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$Hg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?u.URI.file((0,N.$jc)(f,"argv.json")):(0,I.$Hg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,N.$kc)(f):(0,N.$hc)((0,N.$jc)(R.$og.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?u.URI.file((0,N.$kc)(f)):u.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,N.$kc)(f);const v=A.env.VSCODE_EXTENSIONS;if(v)return v;const E=A.env.VSCODE_PORTABLE;return E?(0,N.$jc)(E,"extensions"):(0,I.$Hg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(v=>/^[^:/?#]+?:\/\//.test(v)?u.URI.parse(v):u.URI.file((0,N.$hc)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?u.URI.parse(f):u.URI.file((0,N.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$xm.test(f))}get extensionLogLevel(){const f=[];for(const v of this.args.log||[]){const E=e.$xm.exec(v);E&&E[1]&&E[2]&&f.push([E[1],E[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,I.$Hg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?u.URI.file((0,N.$jc)(f,"policy.json")):(0,I.$Hg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,v,E){this.a=f,this.b=v,this.c=E,this.editSessionId=this.args.editSessionId}}e.$ym=a,$e([D.$xh],a.prototype,"appRoot",null),$e([D.$xh],a.prototype,"userHome",null),$e([D.$xh],a.prototype,"userDataPath",null),$e([D.$xh],a.prototype,"appSettingsHome",null),$e([D.$xh],a.prototype,"tmpDir",null),$e([D.$xh],a.prototype,"cacheHome",null),$e([D.$xh],a.prototype,"stateResource",null),$e([D.$xh],a.prototype,"userRoamingDataHome",null),$e([D.$xh],a.prototype,"userDataSyncHome",null),$e([D.$xh],a.prototype,"sync",null),$e([D.$xh],a.prototype,"machineSettingsResource",null),$e([D.$xh],a.prototype,"workspaceStorageHome",null),$e([D.$xh],a.prototype,"localHistoryHome",null),$e([D.$xh],a.prototype,"keyboardLayoutResource",null),$e([D.$xh],a.prototype,"argvResource",null),$e([D.$xh],a.prototype,"isExtensionDevelopment",null),$e([D.$xh],a.prototype,"untitledWorkspacesHome",null),$e([D.$xh],a.prototype,"builtinExtensionsPath",null),$e([D.$xh],a.prototype,"extensionsPath",null),$e([D.$xh],a.prototype,"extensionDevelopmentLocationURI",null),$e([D.$xh],a.prototype,"extensionDevelopmentKind",null),$e([D.$xh],a.prototype,"extensionTestsLocationURI",null),$e([D.$xh],a.prototype,"debugExtensionHost",null),$e([D.$xh],a.prototype,"logLevel",null),$e([D.$xh],a.prototype,"extensionLogLevel",null),$e([D.$xh],a.prototype,"serviceMachineIdResource",null),$e([D.$xh],a.prototype,"disableTelemetry",null),$e([D.$xh],a.prototype,"disableWorkspaceTrust",null),$e([D.$xh],a.prototype,"useInMemorySecretStorage",null),$e([D.$xh],a.prototype,"policyFile",null);function y($,f){return b($["inspect-extensions"],$["inspect-brk-extensions"],5870,f,$.debugId,$.extensionEnvironment)}e.$zm=y;function b($,f,v,E,g,c){const O=Number(f||$)||(E?null:v),h=O?!!f:!1;let m;if(c)try{m=JSON.parse(c)}catch{}return{port:O,break:h,debugId:g,env:m}}e.$Am=b}),function(){"use strict";function J(e,L,D){function R(A,I){const u=N(A,I),a=[u];return e.isAbsolute(u)||a.unshift(D),e.resolve(...a)}function N(A,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,I);const y=A["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(L.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,I)}return{getUserDataPath:R}}if(typeof define=="function")define(ie[113],ne([167,33,35]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[114],ne([0,1,33,112,113]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=void 0;class N extends D.$ym{constructor(a,y){super(a,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(a,y.nameShort)},y)}}e.$Bm=N;function A(u,a){return(0,D.$Am)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}e.$Cm=A;function I(u,a){return(0,D.$Am)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}e.$Dm=I}),define(ie[115],ne([0,1,3,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;function R(A,I,u,a){try{N(A,I,u,a)}catch(y){A.error(y?.message??y)}return I}e.$Yp=R;function N(A,I,u,a){const y=(b,$,f)=>{const v=b[$];if((0,L.$If)(v)){const E=v,g=E.length;if(g>1&&E[0]==="%"&&E[g-1]==="%"){const c=E.substr(1,g-2);let p=u[c];p===void 0&&a&&(p=a[c]);const O=typeof p=="string"?p:p?.message,h=a?.[c],m=typeof h=="string"?h:h?.message;if(!O){m||A.warn(`[${I.name}]: ${(0,D.localize)(0,null,c)}`);return}if(f&&($==="title"||$==="category")&&m&&m!==O){const s={value:O,original:m};b[$]=s}else b[$]=O}}else if((0,L.$Kf)(v))for(const E in v)v.hasOwnProperty(E)&&(E==="commands"?y(v,E,!0):y(v,E,f));else if(Array.isArray(v))for(let E=0;E<v.length;E++)y(v,E,f)};for(const b in I)I.hasOwnProperty(b)&&y(I,b)}}),define(ie[116],ne([0,1,49,100]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;function R(N){return(0,L.$Pp)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$7p=R}),define(ie[50],ne([0,1,17,54,101,44]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function u(c){return c=c.trim(),c==="*"||A.test(c)}e.$ap=u;function a(c){if(!u(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=c.match(A);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.$bp=a;function y(c){if(!c)return null;const p=c.majorBase,O=c.majorMustEqual,h=c.minorBase;let m=c.minorMustEqual;const s=c.patchBase;let o=c.patchMustEqual;c.hasCaret&&(p===0||(m=!1),o=!1);let t=0;if(c.preRelease){const i=I.exec(c.preRelease);if(i){const[,n,r,l]=i;t=Date.UTC(Number(n),Number(r)-1,Number(l))}}return{majorBase:p,majorMustEqual:O,minorBase:h,minorMustEqual:m,patchBase:s,patchMustEqual:o,isMinimum:c.hasGreaterEquals,notBefore:t}}e.$cp=y;function b(c,p,O){let h;typeof c=="string"?h=y(a(c)):h=c;let m;p instanceof Date?m=p.getTime():typeof p=="string"&&(m=new Date(p).getTime());let s;if(typeof O=="string"?s=y(a(O)):s=O,!h||!s)return!1;const o=h.majorBase,t=h.minorBase,i=h.patchBase;let n=s.majorBase,r=s.minorBase,l=s.patchBase;const k=s.notBefore;let S=s.majorMustEqual,w=s.minorMustEqual,j=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||m&&m<k?!1:i>=l:(o===1&&n===0&&(!S||!w||!j)&&(n=1,r=0,l=0,S=!0,w=!1,j=!1),o<n?!1:o>n?!S:t<r?!1:t>r?!w:i<l?!1:i>l?!j:!(m&&m<k))}e.$dp=b;function $(c,p,O,h,m){const s=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return s.push([D.default.Error,R.localize(0,null)]),s;if(typeof h.name!="string")return s.push([D.default.Error,R.localize(1,null,"name")]),s;if(typeof h.version!="string")return s.push([D.default.Error,R.localize(2,null,"version")]),s;if(!h.engines)return s.push([D.default.Error,R.localize(3,null,"engines")]),s;if(typeof h.engines.vscode!="string")return s.push([D.default.Error,R.localize(4,null,"engines.vscode")]),s;if(typeof h.extensionDependencies<"u"&&!g(h.extensionDependencies))return s.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),s;if(typeof h.activationEvents<"u"){if(!g(h.activationEvents))return s.push([D.default.Error,R.localize(6,null,"activationEvents")]),s;if(typeof h.main>"u"&&typeof h.browser>"u")return s.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),s}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&s.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return s.push([D.default.Error,R.localize(9,null,"main")]),s;{const i=(0,L.$Hg)(O,h.main);(0,L.$Bg)(i,O)||s.push([D.default.Warning,R.localize(10,null,i.path,O.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return s.push([D.default.Error,R.localize(11,null,"browser")]),s;{const i=(0,L.$Hg)(O,h.browser);(0,L.$Bg)(i,O)||s.push([D.default.Warning,R.localize(12,null,i.path,O.path)])}}if(!N.valid(h.version))return s.push([D.default.Error,R.localize(13,null)]),s;const o=[];if(!f(c,p,h,m,o))for(const i of o)s.push([D.default.Error,i]);return s}e.$ep=$;function f(c,p,O,h,m){return h||typeof O.main>"u"&&typeof O.browser>"u"?!0:E(c,p,O.engines.vscode,m)}e.$fp=f;function v(c,p,O){return c==="*"||E(p,O,c)}e.$gp=v;function E(c,p,O,h=[]){const m=y(a(O));if(!m)return h.push(R.localize(14,null,O)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return h.push(R.localize(15,null,O)),!1}else if(!m.majorMustEqual)return h.push(R.localize(16,null,O)),!1;return b(c,p,m)?!0:(h.push(R.localize(17,null,c,O)),!1)}function g(c){if(!Array.isArray(c))return!1;for(let p=0,O=c.length;p<O;p++)if(typeof c[p]!="string")return!1;return!0}}),define(ie[117],ne([0,1,14,29]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;async function R(N,A,I){let u=I&&I.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const y=(await A.readFile(N.serviceMachineIdResource)).value.toString();u=(0,D.$pg)(y)?y:null}catch{u=null}if(!u){u=(0,D.$qg)();try{await A.writeFile(N.serviceMachineIdResource,L.$je.fromString(u))}catch{}}return I?.store("storage.serviceMachineId",u,-1,1),u}e.$Ap=R}),define(ie[51],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class L{constructor(R,N=[],A=!1){this.ctor=R,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$3h=L}),define(ie[118],ne([0,1,51]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const D=[];var R;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function N(I,u,a){u instanceof L.$3h||(u=new L.$3h(u,[],!!a)),D.push([I,u])}e.$Yr=N;function A(){return D}e.$Zr=A}),define(ie[119],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class L{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=L;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const I=this.lookupOrInsertNode(N),u=this.lookupOrInsertNode(A);I.outgoing.set(u.key,u),u.incoming.set(I.key,I)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const I of this.a.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let I=this.a.get(A);return I||(I=new L(A,N),this.a.set(A,I)),I}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,I]of this.a)N.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const I=new Set([N]),u=this.c(A,I);if(u)return u}}c(N,A){for(const[I,u]of N.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const a=this.c(u,A);if(a)return a;A.delete(I)}}}e.$Dq=D}),define(ie[25],ne([0,1,3,11,10]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,R.$6h)("configurationService");function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}e.$Ai=N;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}e.$Bi=A;var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function u(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=u;function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$Di=a;function y(c,p){const O=Object.create(null);for(const h in c)b(O,h,c[h],p);return O}e.$Ei=y;function b(c,p,O,h){const m=p.split("."),s=m.pop();let o=c;for(let t=0;t<m.length;t++){const i=m[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:h(`Ignoring ${p} as ${m.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=O}catch{h(`Ignoring ${p} as ${m.join(".")} is ${JSON.stringify(o)}`)}else h(`Ignoring ${p} as ${m.join(".")} is ${JSON.stringify(o)}`)}e.$Fi=b;function $(c,p){const O=p.split(".");f(c,O)}e.$Gi=$;function f(c,p){const O=p.shift();if(p.length===0){delete c[O];return}if(Object.keys(c).indexOf(O)!==-1){const h=c[O];typeof h=="object"&&!Array.isArray(h)&&(f(h,p),Object.keys(h).length===0&&delete c[O])}}function v(c,p,O){function h(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const m=p.split("."),s=h(c,m);return typeof s>"u"?O:s}e.$Hi=v;function E(c,p,O){Object.keys(p).forEach(h=>{h!=="__proto__"&&(h in c?L.$Kf(c[h])&&L.$Kf(p[h])?E(c[h],p[h],O):O&&(c[h]=p[h]):c[h]=p[h])})}e.$Ii=E;function g(c){return c.replace(/[\[\]]/g,"")}e.$Ji=g}),define(ie[120],ne([0,1,12,30,111,10,92,7]),function(J,e,L,D,R,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$j),u.set("isLinux",L.$k),u.set("isWindows",L.$i),u.set("isWeb",L.$o),u.set("isMacNative",L.$j&&!L.$o),u.set("isEdge",L.$H),u.set("isFirefox",L.$F),u.set("isChrome",L.$E),u.set("isSafari",L.$G);function a(C,d){if(u.get(C)!==void 0)throw(0,I.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(C,d)}e.$2i=a;const y=Object.prototype.hasOwnProperty;var b;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const $={regexParsingWithErrorRecovery:!0},f=(0,A.localize)(0,null),v=(0,A.localize)(1,null),E=(0,A.localize)(2,null),g=(0,A.localize)(3,null),c=(0,A.localize)(4,null),p=(0,A.localize)(5,null),O=(0,A.localize)(6,null),h=(0,A.localize)(7,null);class m{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(d=$){this.k=d,this.d=new R.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(d){if(d===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(d).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const z=this.D(),M=z.type===17?p:void 0;throw this.h.push({message:c,offset:z.offset,lexeme:R.$1i.getLexeme(z),additionalInfo:M}),m.c}return P}catch(P){if(P!==m.c)throw P;return}}l(){return this.m()}m(){const d=[this.o()];for(;this.y(16);){const P=this.o();d.push(P)}return d.length===1?d[0]:s.or(...d)}o(){const d=[this.s()];for(;this.y(15);){const P=this.s();d.push(P)}return d.length===1?d[0]:s.and(...d)}s(){if(this.y(2)){const d=this.D();switch(d.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,g),P?.negate()}case 17:return this.z(),B.create(d.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",d)}}return this.t()}t(){const d=this.D();switch(d.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const P=this.l();return this.A(1,g),P}case 17:{const P=d.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const W=M.lexeme,G=W.lastIndexOf("/"),ee=G===W.length-1?void 0:this.w(W.substring(G+1));let ue;try{ue=new RegExp(W.substring(1,G),ee)}catch{throw this.B("REGEX",M)}return ce.create(P,ue)}switch(M.type){case 10:case 19:{const W=[M.lexeme];this.z();let G=this.D(),ee=0;for(let de=0;de<M.lexeme.length;de++)M.lexeme.charCodeAt(de)===40?ee++:M.lexeme.charCodeAt(de)===41&&ee--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let de=0;de<G.lexeme.length;de++)G.lexeme.charCodeAt(de)===40?ee++:M.lexeme.charCodeAt(de)===41&&ee--}if(ee<0)break;W.push(R.$1i.getLexeme(G)),this.z(),G=this.D()}const ue=W.join(""),fe=ue.lastIndexOf("/"),ge=fe===ue.length-1?void 0:this.w(ue.substring(fe+1));let we;try{we=new RegExp(ue.substring(1,fe),ge)}catch{throw this.B("REGEX",M)}return s.regex(P,we)}case 18:{const W=M.lexeme;this.z();let G=null;if(!(0,D.$Je)(W)){const ee=W.indexOf("/"),ue=W.lastIndexOf("/");if(ee!==ue&&ee>=0){const fe=W.slice(ee+1,ue),ge=W[ue+1]==="i"?"i":"";try{G=new RegExp(fe,ge)}catch{throw this.B("REGEX",M)}}}if(G===null)throw this.B("REGEX",M);return ce.create(P,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,E);const M=this.u();return s.notIn(P,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return s.equals(P,M);switch(M){case"true":return s.has(P);case"false":return s.not(P);default:return s.equals(P,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return s.notEquals(P,M);switch(M){case"true":return s.not(P);case"false":return s.has(P);default:return s.notEquals(P,M)}}case 5:return this.z(),re.create(P,this.u());case 6:return this.z(),he.create(P,this.u());case 7:return this.z(),Y.create(P,this.u());case 8:return this.z(),oe.create(P,this.u());case 13:return this.z(),s.in(P,this.u());default:return s.has(P)}}case 20:throw this.h.push({message:O,offset:d.offset,lexeme:"",additionalInfo:h}),m.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const d=this.D();switch(d.type){case 17:case 18:return this.z(),d.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(d){return d.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(d){return this.C(d)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(d,P){if(this.C(d))return this.z();throw this.B(P,this.D())}B(d,P,z){const M=(0,A.localize)(8,null,d,R.$1i.getLexeme(P)),W=P.offset,G=R.$1i.getLexeme(P);return this.h.push({message:M,offset:W,lexeme:G,additionalInfo:z}),m.c}C(d){return this.D().type===d}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=m;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(d){return l.create(d)}static equals(d,P){return k.create(d,P)}static notEquals(d,P){return j.create(d,P)}static regex(d,P){return ce.create(d,P)}static in(d,P){return S.create(d,P)}static notIn(d,P){return w.create(d,P)}static not(d){return B.create(d)}static and(...d){return Q.create(d,null,!0)}static or(...d){return U.create(d,null,!0)}static greater(d,P){return Y.create(d,P)}static greaterEquals(d,P){return oe.create(d,P)}static smaller(d,P){return re.create(d,P)}static smallerEquals(d,P){return he.create(d,P)}static{this.c=new m({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this.c.parse(d)}}e.$4i=s;function o(C){const d=new m({regexParsingWithErrorRecovery:!1});return C.map(P=>(d.parse(P),d.lexingErrors.length>0?d.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$5i=o;function t(C,d){const P=C?C.substituteConstants():void 0,z=d?d.substituteConstants():void 0;return!P&&!z?!0:!P||!z?!1:P.equals(z)}e.$6i=t;function i(C,d){return C.cmp(d)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return r.INSTANCE}}e.$7i=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return n.INSTANCE}}e.$8i=r;class l{static create(d,P=null){const z=u.get(d);return typeof z=="boolean"?z?r.INSTANCE:n.INSTANCE:new l(d,P)}constructor(d,P){this.key=d,this.c=P,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:H(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=u.get(this.key);return typeof d=="boolean"?d?r.INSTANCE:n.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.c||(this.c=B.create(this.key,this)),this.c}}e.$9i=l;class k{static create(d,P,z=null){if(typeof P=="boolean")return P?l.create(d,z):B.create(d,z);const M=u.get(d);return typeof M=="boolean"?P===(M?"true":"false")?r.INSTANCE:n.INSTANCE:new k(d,P,z)}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=u.get(this.c);if(typeof d=="boolean"){const P=d?"true":"false";return this.d===P?r.INSTANCE:n.INSTANCE}return this}evaluate(d){return d.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(d){return d.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$0i=k;class S{static create(d,P){return new S(d,P)}constructor(d,P){this.d=d,this.f=P,this.type=10,this.c=null}cmp(d){return d.type!==this.type?this.type-d.type:X(this.d,this.f,d.d,d.f)}equals(d){return d.type===this.type?this.d===d.d&&this.f===d.f:!1}substituteConstants(){return this}evaluate(d){const P=d.getValue(this.f),z=d.getValue(this.d);return Array.isArray(P)?P.includes(z):typeof z=="string"&&typeof P=="object"&&P!==null?y.call(P,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(d){return d.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$$i=S;class w{static create(d,P){return new w(d,P)}constructor(d,P){this.d=d,this.f=P,this.type=11,this.c=S.create(d,P)}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(d){return d.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=w;class j{static create(d,P,z=null){if(typeof P=="boolean")return P?B.create(d,z):l.create(d,z);const M=u.get(d);return typeof M=="boolean"?P===(M?"true":"false")?n.INSTANCE:r.INSTANCE:new j(d,P,z)}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=u.get(this.c);if(typeof d=="boolean"){const P=d?"true":"false";return this.d===P?n.INSTANCE:r.INSTANCE}return this}evaluate(d){return d.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(d){return d.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$aj=j;class B{static create(d,P=null){const z=u.get(d);return typeof z=="boolean"?z?n.INSTANCE:r.INSTANCE:new B(d,P)}constructor(d,P){this.c=d,this.d=P,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:H(this.c,d.c)}equals(d){return d.type===this.type?this.c===d.c:!1}substituteConstants(){const d=u.get(this.c);return typeof d=="boolean"?d?n.INSTANCE:r.INSTANCE:this}evaluate(d){return!d.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(d){return d.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$bj=B;function te(C,d){if(typeof C=="string"){const P=parseFloat(C);isNaN(P)||(C=P)}return typeof C=="string"||typeof C=="number"?d(C):n.INSTANCE}class Y{static create(d,P,z=null){return te(P,M=>new Y(d,M,z))}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$cj=Y;class oe{static create(d,P,z=null){return te(P,M=>new oe(d,M,z))}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$dj=oe;class re{static create(d,P,z=null){return te(P,M=>new re(d,M,z))}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$ej=re;class he{static create(d,P,z=null){return te(P,M=>new he(d,M,z))}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$fj=he;class ce{static create(d,P){return new ce(d,P)}constructor(d,P){this.d=d,this.f=P,this.type=7,this.c=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.d<d.d)return-1;if(this.d>d.d)return 1;const P=this.f?this.f.source:"",z=d.f?d.f.source:"";return P<z?-1:P>z?1:0}equals(d){if(d.type===this.type){const P=this.f?this.f.source:"",z=d.f?d.f.source:"";return this.d===d.d&&P===z}return!1}substituteConstants(){return this}evaluate(d){const P=d.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const d=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${d}`}keys(){return[this.d]}map(d){return d.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$gj=ce;class ae{static create(d){return new ae(d)}constructor(d){this.c=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(d){return new ae(this.c.map(d))}negate(){return this.c}}e.$hj=ae;function q(C){let d=null;for(let P=0,z=C.length;P<z;P++){const M=C[P].substituteConstants();if(C[P]!==M&&d===null){d=[];for(let W=0;W<P;W++)d[W]=C[W]}d!==null&&(d[P]=M)}return d===null?C:d}class Q{static create(d,P,z){return Q.d(d,P,z)}constructor(d,P){this.expr=d,this.c=P,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let P=0,z=this.expr.length;P<z;P++){const M=i(this.expr[P],d.expr[P]);if(M!==0)return M}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].equals(d.expr[P]))return!1;return!0}return!1}substituteConstants(){const d=q(this.expr);return d===this.expr?this:Q.create(d,this.c,!1)}evaluate(d){for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].evaluate(d))return!1;return!0}static d(d,P,z){const M=[];let W=!1;for(const G of d)if(G){if(G.type===1){W=!0;continue}if(G.type===0)return n.INSTANCE;if(G.type===6){M.push(...G.expr);continue}M.push(G)}if(M.length===0&&W)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(i);for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];for(;M.length>1;){const G=M[M.length-1];if(G.type!==9)break;M.pop();const ee=M.pop(),ue=M.length===0,fe=U.create(G.expr.map(ge=>Q.create([ge,ee],null,z)),null,ue);fe&&(M.push(fe),M.sort(i))}if(M.length===1)return M[0];if(z){for(let G=0;G<M.length;G++)for(let ee=G+1;ee<M.length;ee++)if(M[G].negate().equals(M[ee]))return n.INSTANCE;if(M.length===1)return M[0]}return new Q(M,P)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const P of this.expr)d.push(...P.keys());return d}map(d){return new Q(this.expr.map(P=>P.map(d)),null)}negate(){if(!this.c){const d=[];for(const P of this.expr)d.push(P.negate());this.c=U.create(d,this,!0)}return this.c}}e.$ij=Q;class U{static create(d,P,z){return U.d(d,P,z)}constructor(d,P){this.expr=d,this.c=P,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let P=0,z=this.expr.length;P<z;P++){const M=i(this.expr[P],d.expr[P]);if(M!==0)return M}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].equals(d.expr[P]))return!1;return!0}return!1}substituteConstants(){const d=q(this.expr);return d===this.expr?this:U.create(d,this.c,!1)}evaluate(d){for(let P=0,z=this.expr.length;P<z;P++)if(this.expr[P].evaluate(d))return!0;return!1}static d(d,P,z){let M=[],W=!1;if(d){for(let G=0,ee=d.length;G<ee;G++){const ue=d[G];if(ue){if(ue.type===0){W=!0;continue}if(ue.type===1)return r.INSTANCE;if(ue.type===9){M=M.concat(ue.expr);continue}M.push(ue)}}if(M.length===0&&W)return n.INSTANCE;M.sort(i)}if(M.length!==0){if(M.length===1)return M[0];for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];if(z){for(let G=0;G<M.length;G++)for(let ee=G+1;ee<M.length;ee++)if(M[G].negate().equals(M[ee]))return r.INSTANCE;if(M.length===1)return M[0]}return new U(M,P)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const P of this.expr)d.push(...P.keys());return d}map(d){return new U(this.expr.map(P=>P.map(d)),null)}negate(){if(!this.c){const d=[];for(const P of this.expr)d.push(P.negate());for(;d.length>1;){const P=d.shift(),z=d.shift(),M=[];for(const W of F(P))for(const G of F(z))M.push(Q.create([W,G],null,!1));d.unshift(U.create(M,null,!1))}this.c=U.create(d,this,!0)}return this.c}}e.$jj=U;class T extends l{static{this.d=[]}static all(){return T.d.values()}constructor(d,P,z){super(d,null),this.f=P,typeof z=="object"?T.d.push({...z,key:d}):z!==!0&&T.d.push({key:d,description:z,type:P!=null?typeof P:void 0})}bindTo(d){return d.createKey(this.key,this.f)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return k.create(this.key,d)}notEqualsTo(d){return j.create(this.key,d)}}e.$kj=T,e.$lj=(0,N.$6h)("contextKeyService");function H(C,d){return C<d?-1:C>d?1:0}function X(C,d,P,z){return C<P?-1:C>P?1:d<z?-1:d>z?1:0}function x(C,d){if(C.type===0||d.type===1)return!0;if(C.type===9)return d.type===9?K(C.expr,d.expr):!1;if(d.type===9){for(const P of d.expr)if(x(C,P))return!0;return!1}if(C.type===6){if(d.type===6)return K(d.expr,C.expr);for(const P of C.expr)if(x(P,d))return!0;return!1}return C.equals(d)}e.$mj=x;function K(C,d){let P=0,z=0;for(;P<C.length&&z<d.length;){const M=C[P].cmp(d[z]);if(M<0)return!1;M===0&&P++,z++}return P===C.length}function F(C){return C.type===9?C.expr:[C]}}),define(ie[59],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do=(0,L.$6h)("downloadService")}),define(ie[18],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,L.$6h)("environmentService"),e.$bi=(0,L.$7h)(e.$ai)}),define(ie[21],ne([0,1,95,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function R(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=R;function N(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=N;function A(c,p){switch(c){case 3:return p==="x64"?"win32-x64":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=A;function I(c,p){return p==="web"&&!c.includes("web")}e.$vo=I;function u(c,p,O){return I(p,O)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===O}e.$wo=u;function a(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$xo=a;var y;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var b;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var $;(function(c){c.Install="install",c.Uninstall="uninstall"})($||(e.StatisticType=$={}));var f;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$yo=(0,D.$6h)("extensionGalleryService");var v;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var E;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(E||(e.ExtensionSignaturetErrorCode=E={}));class g extends Error{constructor(p,O){super(p),this.code=O,this.name=O}}e.$zo=g,e.$Ao=(0,D.$6h)("extensionManagementService"),e.$Bo="extensionsIdentifiers/disabled",e.$Co="extensionsIdentifiers/enabled",e.$Do=(0,D.$6h)("IGlobalExtensionEnablementService"),e.$Eo=(0,D.$6h)("IExtensionTipsService"),e.$Fo=(0,L.localize)(0,null),e.$Go={value:e.$Fo,original:"Extensions"},e.$Ho=(0,L.localize2)(1,"Preferences")}),define(ie[60],ne([0,1,14,7,103,13]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;async function A(y,b,$,f,v,E){let g;try{await I(y,b,$,f,v,E)}catch(c){g=c}finally{g&&v.errorTransformer&&(g=v.errorTransformer(g)),typeof g<"u"&&$.error(g),$.end()}}e.$bq=A;async function I(y,b,$,f,v,E){u(E);const g=await y.open(b,{create:!1});try{u(E);let c=0,p=0,O=v&&typeof v.length=="number"?v.length:void 0,h=L.$je.alloc(Math.min(v.bufferSize,typeof O=="number"?O:v.bufferSize)),m=v&&typeof v.position=="number"?v.position:0,s=0;do p=await y.read(g,m,h.buffer,s,h.byteLength-s),m+=p,s+=p,c+=p,typeof O=="number"&&(O-=p),s===h.byteLength&&(await $.write(f(h)),h=L.$je.alloc(Math.min(v.bufferSize,typeof O=="number"?O:v.bufferSize)),s=0);while(p>0&&(typeof O!="number"||O>0)&&u(E)&&a(c,v));if(s>0){let o=s;typeof O=="number"&&(o=Math.min(s,O)),$.write(f(h.slice(0,o)))}}catch(c){throw(0,N.$Ek)(c)}finally{await y.close(g)}}function u(y){if(y.isCancellationRequested)throw(0,D.$6)();return!0}function a(y,b){if(typeof b?.limits?.size=="number"&&y>b.limits.size)throw(0,N.$Dk)((0,R.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[121],ne([0,1,4,168,2,12,169]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class I extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new L.$Vd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Vd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(a){const y=this.j(a),b=y.filter(f=>{const v=this.c.get(f.path);return v?!(0,D.$Qj)(v.request.excludes,f.excludes)||!(0,D.$Qj)(v.request.includes,f.includes):!0}),$=Array.from(this.c.values()).filter(({request:f})=>!y.find(v=>v.path===f.path&&(0,D.$Qj)(v.excludes,f.excludes)&&(0,D.$Qj)(v.includes,f.includes))).map(({request:f})=>f.path);b.length&&this.m(`Request to start watching: ${b.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const f of $)this.h(f);for(const f of b)this.g(f)}g(a){const y=new A.$xq(a,$=>this.a.fire($),$=>this.b.fire($),this.f),b={request:a,instance:y};this.c.set(a.path,b)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const y=this.c.get(a);y&&(this.c.delete(a),y.instance.dispose())}j(a){const y=new Map;for(const b of a){const $=N.$k?b.path:b.path.toLowerCase();let f=y.get(b.correlationId);f||(f=new Map,y.set(b.correlationId,f)),f.set($,b)}return Array.from(y.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,y]of this.c)y.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,y){return y?`[File Watcher (node.js)] ${a} (path: ${y.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$zq=I}),define(ie[122],ne([0,1,61,121]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class R extends L.$fq{constructor(A,I,u){super(A,I,u),this.s()}r(A){return A.add(new D.$zq)}}e.$Aq=R}),define(ie[123],ne([0,1,15,57,87,61]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;class A extends N.$gq{constructor(u,a,y){super(u,a,y),this.s()}r(u){const a=u.add(new R.$rq(L.$og.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:y,signal:b})=>this.t(`terminated by itself with code ${y}, signal: ${b}`))),D.ProxyChannel.toService((0,D.$Mh)(a.getChannel("watcher")))}}e.$sq=A}),define(ie[62],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class L{constructor(...R){this.a=new Map;for(const[N,A]of R)this.set(N,A)}set(R,N){const A=this.a.get(R);return this.a.set(R,N),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$4h=L}),define(ie[124],ne([0,1,9,7,2,51,119,10,62,170]),function(J,e,L,D,R,N,A,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const y=!1;class b extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class ${constructor(g=new u.$4h,c=!1,p,O=y){this.f=g,this.g=c,this.h=p,this.i=O,this.o=new Set,this.f.set(I.$5h,this),this._globalGraph=O?p?._globalGraph??new A.$Dq(h=>h):void 0}createChild(g){return new $(g,this.g,this,this.i)}invokeFunction(g,...c){const p=v.traceInvocation(this.i,g);let O=!1;try{return g({get:m=>{if(O)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(m,p);if(!s)throw new Error(`[invokeFunction] unknown service '${m}'`);return s}},...c)}finally{O=!0,p.stop()}}createInstance(g,...c){let p,O;return g instanceof N.$3h?(p=v.traceCreation(this.i,g.ctor),O=this.j(g.ctor,g.staticArguments.concat(c),p)):(p=v.traceCreation(this.i,g),O=this.j(g,c,p)),p.stop(),O}j(g,c=[],p){const O=I._util.getServiceDependencies(g).sort((s,o)=>s.index-o.index),h=[];for(const s of O){const o=this.m(s.id,p);o||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${s.id}.`,!1),h.push(o)}const m=O.length>0?O[0].index:c.length;if(c.length!==m){console.trace(`[createInstance] First service dependency of ${g.name} at position ${m+1} conflicts with ${c.length} static arguments`);const s=m-c.length;s>0?c=c.concat(new Array(s)):c=c.slice(0,m)}return Reflect.construct(g,c.concat(h))}k(g,c){if(this.f.get(g)instanceof N.$3h)this.f.set(g,c);else if(this.h)this.h.k(g,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const c=this.f.get(g);return!c&&this.h?this.h.l(g):c}m(g,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const p=this.l(g);return p instanceof N.$3h?this.q(g,p,c.branch(g,!0)):(c.branch(g,!1),p)}q(g,c,p){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,c,p)}finally{this.o.delete(g)}}r(g,c,p){const O=new A.$Dq(s=>s.id.toString());let h=0;const m=[{id:g,desc:c,_trace:p}];for(;m.length;){const s=m.pop();if(O.lookupOrInsertNode(s),h++>1e3)throw new b(O);for(const o of I._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${g} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof N.$3h){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};O.insertEdge(s,i),m.push(i)}}}for(;;){const s=O.roots();if(s.length===0){if(!O.isEmpty())throw new b(O);break}for(const{data:o}of s){if(this.l(o.id)instanceof N.$3h){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}O.removeNode(o)}}return this.l(g)}s(g,c,p=[],O,h){if(this.f.get(g)instanceof N.$3h)return this.t(g,c,p,O,h);if(this.h)return this.h.s(g,c,p,O,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(g,c,p=[],O,h){if(O){const m=new $(void 0,this.g,this,this.i);m.c=String(g);const s=new Map,o=new L.$mh(()=>{const t=m.j(c,p,h);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const l of n)l.disposable=r.apply(t,l.listener)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=s.get(i);return l||(l=new a.$4c,s.set(i,l)),(S,w,j)=>{if(o.isInitialized)return o.value[i](S,w,j);{const B={listener:[S,w,j],disposable:void 0},te=l.push(B);return(0,R.$Rc)(()=>{te(),B.disposable?.dispose()})}}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,p,h)}u(g,c){if(c&&console.warn(g),this.g)throw new Error(g)}}e.$Eq=$;var f;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(f||(f={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,c){return g?new v(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(g,c){return g?new v(1,c.name):v.c}static{this.f=0}constructor(g,c){this.type=g,this.name=c,this.g=Date.now(),this.h=[]}branch(g,c){const p=new v(3,g.toString());return this.h.push([g,c,p]),p}stop(){const g=Date.now()-this.g;v.f+=g;let c=!1;function p(h,m){const s=[],o=new Array(h+1).join("	");for(const[t,i,n]of m.h)if(i&&n){c=!0,s.push(`${o}CREATES -> ${t}`);const r=p(h+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const O=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(g>2||c)&&v.all.add(O.join(`
`))}}e.$Fq=v});var se=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(ie[63],ne([0,1,20,2,12,105,21,10]),function(J,e,L,D,R,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=e.$gr=void 0;function u(y){return y.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.$gr=u,e.$hr=(0,I.$6h)("languagePackService");let a=class extends D.$Tc{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new L.$6d;setTimeout(()=>b.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const v=$.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(g=>g.startsWith("lp-"))).map(E=>{const g=E.properties.localizedLanguages?.[0],c=u(E);return{...this.f(c,g,E),extensionId:E.identifier.id,galleryExtension:E}});return v.push(this.f("en","English")),v}f(b,$,f){const v=$??b;let E;if(v!==b&&(E=`(${b})`),b.toLowerCase()===R.$w.toLowerCase()&&(E??="",E+=(0,N.localize)(0,null)),f?.installCount){E??="";const g=f.installCount;let c;g>1e6?c=`${Math.floor(g/1e5)/10}M`:g>1e3?c=`${Math.floor(g/1e3)}K`:c=String(g),E+=` $(cloud-download) ${c}`}return{id:b,label:v,description:E}}};e.$ir=a,e.$ir=a=$e([se(0,A.$yo)],a)}),define(ie[5],ne([0,1,34,4,43,2,31,12,17,3,11,120,10]),function(J,e,L,D,R,N,A,I,u,a,y,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,$.$6h)("logService"),e.$oj=(0,$.$6h)("loggerService");function f(){return new Date().toISOString()}function v(S){return(0,a.$Mf)(S)}e.$pj=v;var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$qj=E.Info;function g(S,w,j){switch(w){case E.Trace:S.trace(j);break;case E.Debug:S.debug(j);break;case E.Info:S.info(j);break;case E.Warning:S.warn(j);break;case E.Error:S.error(j);break;case E.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=g;function c(S,w=!1){let j="";for(let B=0;B<S.length;B++){let te=S[B];if(te instanceof Error&&(te=(0,L.$Qi)(te,w)),typeof te=="object")try{te=JSON.stringify(te)}catch{}j+=(B>0?" ":"")+te}return j}class p extends N.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new D.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==E.Off&&this.b<=w}}e.$sj=p;class O extends p{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...j){this.f(E.Trace)&&this.g(E.Trace,c([w,...j],!0))}debug(w,...j){this.f(E.Debug)&&this.g(E.Debug,c([w,...j]))}info(w,...j){this.f(E.Info)&&this.g(E.Info,c([w,...j]))}warn(w,...j){this.f(E.Warning)&&this.g(E.Warning,c([w,...j]))}error(w,...j){if(this.f(E.Error))if(w instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=w.stack,this.g(E.Error,c(B))}else this.g(E.Error,c([w,...j]))}flush(){}}e.$tj=O;class h extends p{constructor(w=e.$qj){super(),this.setLevel(w),this.g=!I.$i}trace(w,...j){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...j):console.log(`[main ${f()}]`,w,...j))}debug(w,...j){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...j):console.log(`[main ${f()}]`,w,...j))}info(w,...j){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...j):console.log(`[main ${f()}]`,w,...j))}warn(w,...j){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...j):console.warn(`[main ${f()}]`,w,...j))}error(w,...j){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...j):console.error(`[main ${f()}]`,w,...j))}flush(){}}e.$uj=h;class m extends p{constructor(w=e.$qj,j=!0){super(),this.g=j,this.setLevel(w)}trace(w,...j){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...j):console.log(w,...j))}debug(w,...j){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...j):console.log(w,...j))}info(w,...j){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...j):console.log(w,...j))}warn(w,...j){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...j):console.log(w,...j))}error(w,...j){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...j):console.error(w,...j))}flush(){}}e.$vj=m;class s extends p{constructor(w,j=e.$qj){super(),this.g=w,this.setLevel(j)}trace(w,...j){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(w),...j])}debug(w,...j){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(w),...j])}info(w,...j){this.f(E.Info)&&this.g.log(E.Info,[this.h(w),...j])}warn(w,...j){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(w),...j])}error(w,...j){this.f(E.Error)&&this.g.log(E.Error,[this.h(w),...j])}h(w){return typeof w=="string"?w:(0,L.$Qi)(w,this.f(E.Trace))}flush(){}}e.$wj=s;class o extends p{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const j of this.g)j.setLevel(w);super.setLevel(w)}trace(w,...j){for(const B of this.g)B.trace(w,...j)}debug(w,...j){for(const B of this.g)B.debug(w,...j)}info(w,...j){for(const B of this.g)B.info(w,...j)}warn(w,...j){for(const B of this.g)B.warn(w,...j)}error(w,...j){for(const B of this.g)B.error(w,...j)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$xj=o;class t extends N.$Tc{constructor(w,j,B){if(super(),this.h=w,this.j=j,this.b=new A.$Ac,this.c=this.B(new D.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Vd),this.onDidChangeVisibility=this.g.event,B)for(const te of B)this.b.set(te.resource,{logger:void 0,info:te})}m(w){return(0,a.$If)(w)?[...this.b.values()].find(j=>j.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,j){const B=this.n(w),te=(0,a.$If)(w)?w:j?.id??(0,R.$Ti)(B.toString()).toString(16);let Y=this.b.get(B)?.logger;const oe=j?.logLevel==="always"?E.Trace:j?.logLevel;Y||(Y=this.s(B,oe??this.getLogLevel(B)??this.h,{...j,id:te}));const re={logger:Y,info:{resource:B,id:te,logLevel:oe,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(re.info),this.b.set(B,re),Y}n(w){return(0,a.$If)(w)?(0,u.$Hg)(this.j,`${w}.log`):w}setLogLevel(w,j){if(y.URI.isUri(w)){const B=w,te=j,Y=this.b.get(B);Y&&te!==Y.info.logLevel&&(Y.info.logLevel=te===this.h?void 0:te,Y.logger?.setLevel(te),this.b.set(Y.info.resource,Y),this.f.fire([B,te]))}else{this.h=w;for(const[B,te]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&te.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,j){const B=this.m(w);B&&j!==!B.info.hidden&&(B.info.hidden=!j,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,j]))}getLogLevel(w){let j;return w&&(j=this.b.get(w)?.info.logLevel),j??this.h}registerLogger(w){const j=this.b.get(w.resource);j?j.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const j=this.b.get(w);j&&(j.logger&&j.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=t;class i{constructor(){this.onDidChangeLogLevel=new D.$Vd().event}setLevel(w){}getLevel(){return E.Info}trace(w,...j){}debug(w,...j){}info(w,...j){}warn(w,...j){}error(w,...j){}critical(w,...j){}dispose(){}flush(){}}e.$zj=i;class n extends i{}e.$Aj=n;function r(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const w=k(S.logLevel.toLowerCase());if(w!==void 0)return w}return e.$qj}e.$Bj=r;function l(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.$Cj=l;function k(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$Dj=k,e.$Ej=new b.$kj("logLevel",l(E.Info))}),define(ie[64],ne([0,1,7,10,5]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=void 0,e.$Fp=(0,D.$6h)("IExtensionSignatureVerificationService");let N=class{constructor(I){this.b=I}c(){return this.a||(this.a=new Promise((I,u)=>J(["node-vsce-sign"],async a=>I(a),u))),this.a}async verify(I,u,a){let y;try{y=await this.c()}catch(b){return this.b.error("Could not load vsce-sign module",(0,L.$0)(b)),!1}return y.verify(I,u,a)}};e.$Gp=N,e.$Gp=N=$e([se(0,R.$nj)],N)}),define(ie[125],ne([0,1,19,9,7,4,2,16,61,5]),function(J,e,L,D,R,N,A,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class y extends A.$Tc{constructor($,f){super(),this.a=$,this.b=f,this.c=this.B(new N.$Vd),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$Vd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$4g(0)),this.w=[],this.y=this.B(new D.$4g(0))}watch($,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n($,f):this.z($,f)}n($,f){const v={path:this.H($),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},E=(0,L.$Ub)(this.j,v);return this.r(),(0,A.$Rc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,R.$1)($))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,u.$hq)(f)),f=>this.G(f),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const f of this.j)(0,u.$dq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const f of this.j)(0,u.$dq)(f)&&$.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,f){const v={path:this.H($),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},E=(0,L.$Ub)(this.w,v);return this.C(),(0,A.$Rc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,R.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,u.$hq)($)),$=>this.G($),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,I.$hc)($.fsPath)}}e.$lq=y}),define(ie[126],ne([0,1,19,9,14,20,4,43,65,2,48,15,127,17,46,102,13,60,5,7]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g,c,p,O){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;let m=class extends a.$Tc{static{h=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$Vd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$Vd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$Vd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$Vd),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$Vd),this.Y=this.B(new A.$Vd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$Vd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$ch)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${o}`);const i=new a.$Sc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new g.$Jk(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,a.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await D.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,f.$Lg)(o))throw new g.$Lk((0,E.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new O.$bb;throw i.message=(0,E.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,g.$wk)(t)||(0,g.$tk)(t)||(0,g.$xk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,g.$wk)(t)||(0,g.$tk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,g.$Gk)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.$Lk((0,E.localize)(2,null,this.sb(o)),1):(0,g.$Ek)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,l=t?.resolveSingleChildDescendants,k=t?.resolveMetadata,S=await i.stat(o);let w;return this.t(i,o,S,void 0,!!k,(j,B)=>(w||(w=y.$_h.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(j.resource)||w.findSuperstr(j.resource.with({query:null,fragment:null}))?!0:j.isDirectory&&l?B===1:!1))}async t(o,t,i,n,r,l){const{providerExtUri:k}=this.R(o),S={resource:t,name:k.basename(t),isFile:(i.type&g.FileType.File)!==0,isDirectory:(i.type&g.FileType.Directory)!==0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&g.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&g.FilePermission.Locked),etag:(0,g.$Wk)({mtime:i.mtime,size:i.size}),children:void 0};if(S.isDirectory&&l(S,n)){try{const w=await o.readdir(t),j=await D.Promises.settled(w.map(async([B,te])=>{try{const Y=k.joinPath(t,B),oe=r?await o.stat(Y):{type:te};return await this.t(o,Y,oe,w.length,r,l)}catch(Y){return this.b.trace(Y),null}}));S.children=(0,L.$Hb)(j)}catch(w){this.b.trace(w),S.children=[]}return S}return S}async resolveAll(o){return D.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new g.$Lk((0,E.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=R.$je.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new g.$Ik(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let l=i;if((0,g.$zk)(n)&&!l?.atomic){const k=n.enforceAtomicWriteFile?.(o);k&&(l={...i,atomic:k})}try{await this.w(n,o,l)||await this.U(n,r.dirname(o));let S;if((0,g.$tk)(n)&&!(t instanceof R.$je))if((0,v.$8d)(t)){const w=await(0,v.$ce)(t,3);w.ended?S=R.$je.concat(w.buffer):S=w}else S=(0,v.$_d)(t,w=>R.$je.concat(w),3);else S=t;!(0,g.$wk)(n)||(0,g.$tk)(n)&&S instanceof R.$je||(0,g.$tk)(n)&&(0,g.$zk)(n)&&l?.atomic?await this.hb(n,o,l,S):await this.db(n,o,l,S instanceof R.$je?(0,R.$ue)(S):S),this.r.fire(new g.$Ik(o,4))}catch(k){throw new g.$Lk((0,E.localize)(4,null,this.sb(o),(0,g.$Ek)(k).toString()),(0,g.$Hk)(k),l)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,E.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,E.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,E.localize)(7,null,this.sb(t)));if(n)throw new Error((0,E.localize)(8,null,this.sb(t)))}let l;try{l=await o.stat(t)}catch{return}if(l.type&g.FileType.Directory)throw new g.$Lk((0,E.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.$Vk&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,g.$Wk)({mtime:i.mtime,size:l.size}))throw new g.$Lk((0,E.localize)(10,null),3,i);return l}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,l)=>{this.cb.queueFor(t,async()=>{try{const k=await this.C(o,t,i,n);r(k)}catch(k){l(k)}},this.R(o).providerExtUri)})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,R.$ve)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new N.$6d(n);let l=i;(0,g.$yk)(o)&&o.enforceAtomicReadFile?.(t)&&(l={...i,atomic:!0});const k=this.J(t,l).then(w=>w,w=>{throw r.dispose(!0),w});let S;try{return typeof l?.etag=="string"&&l.etag!==g.$Vk&&await k,l?.atomic&&(0,g.$yk)(o)||!((0,g.$wk)(o)||(0,g.$xk)(o))||(0,g.$tk)(o)&&l?.preferUnbuffered?S=this.I(o,t,l):(0,g.$xk)(o)?S=this.G(o,t,r.token,l):S=this.H(o,t,r.token,l),S.on("end",()=>r.dispose()),S.on("error",()=>r.dispose()),{...await k,value:S}}catch(w){throw S&&await(0,v.$ae)(S),this.F(w,t,l)}}F(o,t,i){const n=(0,E.localize)(11,null,this.sb(t),(0,g.$Ek)(o).toString());return o instanceof g.$Nk?new g.$Nk(n,o.stat,i):o instanceof g.$Mk?new g.$Mk(n,o.fileOperationResult,o.size,o.options):new g.$Lk(n,(0,g.$Hk)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,v.$ge)(r,{data:l=>l instanceof R.$je?l:R.$je.wrap(l),error:l=>this.F(l,t,n)},l=>R.$je.concat(l))}H(o,t,i,n=Object.create(null)){const r=(0,R.$ze)();return(0,c.$bq)(o,t,r,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,t,n)},i),r}I(o,t,i){const n=(0,v.$0d)(r=>R.$je.concat(r));return(async()=>{try{let r;i?.atomic&&(0,g.$yk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(R.$je.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new g.$Lk((0,E.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==g.$Vk&&t.etag===i.etag)throw new g.$Nk((0,E.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new g.$Mk((0,E.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),l=this.qb(await this.n(t),t);await this.Q(r,o,l,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"move",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$Ik(o,l==="move"?2:3,k)),k}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"copy",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$Ik(o,l==="copy"?3:2,k)),k}async N(o,t,i,n,r,l){if(t.toString()===n.toString())return r;const{exists:k,isSameResourceWithDifferentPathCase:S}=await this.Q(o,t,i,n,r,l);if(k&&!S&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,g.$uk)(o))await o.copy(t,n,{overwrite:l});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:l}),r):(await this.N(o,t,i,n,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,g.$wk)(o)&&(0,g.$wk)(i))return this.jb(o,t,i,n);if((0,g.$wk)(o)&&(0,g.$tk)(i))return this.pb(o,t,i,n);if((0,g.$tk)(o)&&(0,g.$wk)(i))return this.nb(o,t,i,n);if((0,g.$tk)(o)&&(0,g.$tk)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async r=>{const l=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,l):this.O(o,r.resource,i,l)}))}async Q(o,t,i,n,r,l){let k=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:j}=this.R(o);if(j||(k=w.isEqual(t,n)),k&&r==="copy")throw new Error((0,E.localize)(15,null,this.sb(t),this.sb(n)));if(!k&&w.isEqualOrParent(n,t))throw new Error((0,E.localize)(16,null,this.sb(t),this.sb(n)))}const S=await this.exists(n);if(S&&!k){if(!l)throw new g.$Lk((0,E.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,E.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:S,isSameResourceWithDifferentPathCase:k}}R(o){const t=this.S(o);return{providerExtUri:t?f.$xg:f.$zg,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new g.$Ik(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&g.FileType.Directory))throw new Error((0,E.localize)(19,null,this.sb(t)));break}catch(r){if((0,g.$Gk)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(l){if((0,g.$Gk)(l)!==g.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,E.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,E.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,E.localize)(22,null,this.sb(o)));let l;try{l=await i.stat(o)}catch{}if(l)this.rb(o,l);else throw new g.$Lk((0,E.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const S=await this.resolve(o);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,E.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,g.$Ak)(i)&&!n?.atomic){const S=i.enforceAtomicDelete?.(o);S&&(n={...t,atomic:S})}const r=!!n?.useTrash,l=!!n?.recursive,k=n?.atomic??!1;await i.delete(o,{recursive:l,useTrash:r,atomic:k}),this.r.fire(new g.$Ik(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(!(i===n&&this.R(i).providerExtUri.isEqual(o,t)))return i===n&&(0,g.$vk)(i)?i.cloneFile(o,t):(await this.U(n,this.R(n).providerExtUri.dirname(t)),i===n&&(0,g.$uk)(i)?this.cb.queueFor(o,()=>i.copy(o,t,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,n,t),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:h.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new a.$Sc;let n=!1,r=()=>{n=!0};i.add((0,a.$Rc)(()=>r())),(async()=>{try{const k=await this.bb(o,t);n?(0,a.$Oc)(k):r=()=>(0,a.$Oc)(k)}catch(k){this.b.error(k)}})();const l=t.correlationId;if(typeof l=="number"){const k=i.add(new A.$Vd);return i.add(this.X.event(w=>{w.correlates(l)&&k.fire(w)})),{onDidChange:k.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,I.$Ti)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,a.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,a.$Oc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,a.$Oc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,v.$8d)(n)||(0,v.$9d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(l){throw(0,g.$Ek)(l)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,t,i){let n=0,r;if((0,v.$9d)(i)){if(i.buffer.length>0){const l=R.$je.concat(i.buffer);await this.gb(o,t,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,k)=>{(0,v.$be)(r,{onData:async S=>{r.pause();try{await this.gb(o,t,S,S.byteLength,n,0)}catch(w){return k(w)}n+=S.byteLength,setTimeout(()=>r.resume())},onError:S=>k(S),onEnd:()=>l()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,l){let k=0;for(;k<n;){const S=await o.write(t,r+k,i.buffer,l+k,n-k);k+=S}}async hb(o,t,i,n){return this.cb.queueFor(t,()=>this.ib(o,t,i,n),this.R(o).providerExtUri)}async ib(o,t,i,n){let r;n instanceof R.$je?r=n:(0,v.$8d)(n)?r=await(0,R.$ve)(n):(0,v.$9d)(n)?r=await(0,R.$we)(n):r=(0,R.$te)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,()=>this.kb(o,t,i,n),this.R(i).providerExtUri)}async kb(o,t,i,n){let r,l;try{r=await o.open(t,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const k=R.$je.alloc(this.a);let S=0,w=0,j=0;do j=await o.read(r,S,k.buffer,w,k.byteLength-w),await this.gb(i,l,k,j,S,w),S+=j,w+=j,w===k.byteLength&&(w=0);while(j>0)}catch(k){throw(0,g.$Ek)(k)}finally{await D.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,()=>this.mb(o,t,i,n),this.R(i).providerExtUri)}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,()=>this.ob(o,t,i,n),this.R(i).providerExtUri)}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await o.readFile(t);await this.gb(i,r,R.$je.wrap(l),l.byteLength,0,0)}catch(l){throw(0,g.$Ek)(l)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,R.$ve)(this.H(o,t,N.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new g.$Lk((0,E.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&g.FilePermission.Readonly)throw new g.$Lk((0,E.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.$cq=m,e.$cq=m=h=$e([se(0,p.$nj)],m)}),define(ie[128],ne([0,1,90,171,9,31,14,4,172,2,16,12,17,46,24,104,13,60,125,34,123,122]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g,c,p,O,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,O.$Qi)(o)}`)}})();class s extends p.$lq{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=I.Event.None,this.N=new N.$Ac(n=>$.$yg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,b.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await v.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,$.$Hg)(t,r.name))).type:l=this.M(r),n.push([r.name,l])}catch(l){this.a.trace(l)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=g.FileType.Unknown:t.isFile()?n=g.FileType.File:t.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,i&&(n|=g.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new R.$5g;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await v.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,f.$0d)(l=>A.$je.concat(l.map(k=>A.$je.wrap(k))).buffer);return(0,c.$bq)(this,t,r,l=>l.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,$.$Hg)((0,$.$Gg)(t),`${(0,$.$Eg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await v.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const l=new a.$Sc;try{l.add(await this.O(t)),l.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{l.dispose()}}async S(t,i,n,r){let l;try{const k=this.H(t);if(!n.create||!n.overwrite){if(await v.Promises.exists(k)){if(!n.overwrite)throw(0,g.$Dk)((0,E.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.$Dk)((0,E.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(l,0,i,0,i.byteLength)}catch(k){throw await this.gb(t,k)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let l;(0,g.$rk)(i)&&!n&&(l=await this.O(t));let k;try{if((0,g.$rk)(i)&&i.unlock)try{const{stat:w}=await v.SymlinkSupport.stat(r);w.mode&128||await v.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let S;if((0,g.$rk)(i)){if(b.$i)try{await v.Promises.truncate(r,0),S="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}S||(S="w")}else S="r";k=await v.Promises.open(r,S)}catch(S){throw l?.dispose(),(0,g.$rk)(i)?await this.gb(t,S):this.fb(S)}if(this.U.set(k,0),(0,g.$rk)(i)&&this.X.set(k,t),l){const S=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${r})`),this.W.set(k,l),S&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${r})`),S.dispose())}return k}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await v.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,l){const k=this.Z(t,i);let S=null;try{S=(await v.Promises.read(t,n,r,l,k)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,k,S)}return S}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,l){return(0,R.$nh)(()=>this.ab(t,i,n,r,l),100,3)}async ab(t,i,n,r,l){const k=this.Z(t,i);let S=null;try{S=(await v.Promises.write(t,n,r,l,k)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,k,S)}return S}async mkdir(t){try{await v.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,y.$jc)((0,y.$mc)(n),`${(0,y.$nc)(n)}${i.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,r)}else try{await v.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:k,symbolicLink:S}=await v.SymlinkSupport.stat(n);l=k.isDirectory()&&!S}catch{}if(l)await v.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"move",n.overwrite),await v.Promises.rename(r,l)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,E.localize)(2,null,(0,y.$nc)(r),(0,y.$nc)((0,y.$mc)(l)),k.toString()))),this.fb(k)}}async copy(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"copy",n.overwrite),await v.Promises.copy(r,l,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,E.localize)(3,null,(0,y.$nc)(r),(0,y.$nc)((0,y.$mc)(l)),k.toString()))),this.fb(k)}}async bb(t,i,n,r){const l=this.H(t),k=this.H(i);let S=!1;if(!!(this.capabilities&1024)||(S=(0,u.$7f)(l,k,!0)),S){if(n==="copy")throw(0,g.$Dk)((0,E.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const j=await this.L(t);if(!j)throw(0,g.$Dk)((0,E.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const B=await this.L(i);if(B){if(!r)throw(0,g.$Dk)((0,E.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);j.type&g.FileType.File&&B.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),l=this.H(i),k=!!(this.capabilities&1024);if((0,u.$7f)(r,l,!k))return;const S=new a.$Sc;try{S.add(await this.O(t)),S.add(await this.O(i)),n&&await v.Promises.mkdir((0,y.$mc)(l),{recursive:!0}),await v.Promises.copyFile(r,l)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{S.dispose()}}t(t,i,n){return new h.$sq(r=>t(r),r=>i(r),n)}F(t,i,n){return new m.$Aq(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof g.$Ck)return t;let i=t,n;switch(t.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.$Dk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await v.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,g.$Dk)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$Bq=s}),define(ie[129],ne([0,1,2,5]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=void 0;class R extends L.$Tc{constructor(A,I=[]){super(),this.a=new D.$xj([A,...I]),this.B(A.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...I){this.a.trace(A,...I)}debug(A,...I){this.a.debug(A,...I)}info(A,...I){this.a.info(A,...I)}warn(A,...I){this.a.warn(A,...I)}error(A,...I){this.a.error(A,...I)}flush(){this.a.flush()}}e.$uO=R}),define(ie[130],ne([0,1,13,5]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=void 0;var R;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(R||(R={}));async function N(a,y,b,$,f){try{const v=await new Promise((g,c)=>{J(["@vscode/spdlog"],g,c)});v.setFlushOn(R.Trace);const E=await v.createAsyncRotatingLogger(a,y,b,$);return f?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(v){console.error(v)}return null}function A(a,y,b){switch(y){case D.LogLevel.Trace:a.trace(b);break;case D.LogLevel.Debug:a.debug(b);break;case D.LogLevel.Info:a.info(b);break;case D.LogLevel.Warning:a.warn(b);break;case D.LogLevel.Error:a.error(b);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function I(a,y){switch(y){case D.LogLevel.Trace:a.setLevel(R.Trace);break;case D.LogLevel.Debug:a.setLevel(R.Debug);break;case D.LogLevel.Info:a.setLevel(R.Info);break;case D.LogLevel.Warning:a.setLevel(R.Warning);break;case D.LogLevel.Error:a.setLevel(R.Error);break;case D.LogLevel.Off:a.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class u extends D.$tj{constructor(y,b,$,f,v){super(),this.m=[],this.setLevel(v),this.n=this.s(y,b,$,f),this.B(this.onDidChangeLogLevel(E=>{this.r&&I(this.r,E)}))}async s(y,b,$,f){const v=$?6:1,E=30/v*L.$Yk.MB,g=await N(y,b,E,v,f);if(g){this.r=g,I(this.r,this.getLevel());for(const{level:c,message:p}of this.m)A(this.r,c,p);this.m=[]}}g(y,b){this.r?A(this.r,y,b):this.getLevel()<=y&&this.m.push({level:y,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$jO=u}),define(ie[131],ne([0,1,29,5,130]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kO=void 0;class N extends D.$yj{s(I,u,a){return new R.$jO((0,L.$qg)(),I.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$kO=N}),define(ie[39],ne([0,1,4,65,2,10]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=void 0,e.$Jn=(0,N.$6h)("policy");class A extends R.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Vd),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const y=Object.keys(this.f).length;return this.f={...a,...this.f},y!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(b,[$,f])=>({...b,[$]:f}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[y,b])=>({...a,[y]:{definition:b,value:this.g.get(y)}}),{})}}e.$Kn=A;class I{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Ln=I}),define(ie[132],ne([0,1,9,4,65,3,13,5,39]),function(J,e,L,D,R,N,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=void 0;function a(b,$){const f=[];for(const v of new Set(R.Iterable.concat(b.keys(),$.keys())))b.get(v)!==$.get(v)&&f.push(v);return f}let y=class extends u.$Kn{constructor($,f,v){super(),this.m=$,this.n=f,this.s=v,this.c=this.B(new L.$4g(500));const E=D.Event.filter(f.onDidFilesChange,g=>g.affects($));this.B(f.watch($)),this.B(E(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const $=new Map;try{const f=await this.n.readFile(this.m),v=JSON.parse(f.value.toString());if(!(0,N.$Kf)(v))throw new Error("Policy file isn't a JSON object");for(const E of Object.keys(v))this.f[E]&&$.set(E,v[E])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return $}async w(){const $=await this.u(),f=a(this.g,$);this.g=$,f.length>0&&this.h.fire(f)}};e.$d_b=y,e.$d_b=y=$e([se(1,A.$qk),se(2,I.$nj)],y)}),define(ie[133],ne([0,1,39,9,2,5]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c_b=void 0;let A=class extends L.$Kn{constructor(u,a){super(),this.m=u,this.n=a,this.a=new D.$Zg,this.b=this.B(new R.$Uc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((y,b)=>{J(["@vscode/policy-watcher"],y,b)});await this.a.queue(()=>new Promise((y,b)=>{try{this.b.value=a(this.n,u,$=>{this.t($),y()})}catch($){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",$),b($)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const y=u[a];y===void 0?this.g.delete(a):this.g.set(a,y)}this.h.fire(Object.keys(u))}};e.$c_b=A,e.$c_b=A=$e([se(0,N.$nj)],A)}),define(ie[32],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,L.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"}),define(ie[36],ne([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class R{constructor(){this.a=new Map}add(A,I){L.ok(D.$If(A)),L.ok(D.$Kf(I)),L.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,I)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Hn=new R}),define(ie[134],ne([0,1,4,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function R(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class N{constructor(){this.b=new L.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[R(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;D.$Hn.add(e.$In.JSONContribution,A)}),define(ie[40],ne([0,1,19,4,3,91,25,134,36]),function(J,e,L,D,R,N,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var a;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$Mn={Configuration:"base.contributions.configuration"};var y;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const b=u.$Hn.as(I.$In.JSONContribution);class ${constructor(){this.h=new Set,this.i=new D.$Vd,this.onDidSchemaChange=this.i.event,this.j=new D.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),b.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),b.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),b.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$Wn.test(r)){const l=this.a.get(r),k=l?.valuesSources??new Map;if(n)for(const B of Object.keys(i[r]))k.set(B,n);const S={...l?.value||{},...i[r]};this.a.set(r,{source:n,value:S,valuesSources:k});const w=(0,A.$Ji)(r),j={type:"object",default:S,description:N.localize(1,null,w),$ref:e.$Tn,defaultDefaultValue:S,source:R.$If(n)?void 0:n,defaultValueSource:n};t.push(...E(r)),this.d[r]=j,this.b.properties[r]=j}else{this.a.set(r,{value:i[r],source:n});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),l=R.$If(i)?i:i?.id,k=R.$If(r?.source)?r?.source:r?.source?.id;if(l===k)if(o.add(n),this.a.delete(n),e.$Wn.test(n))delete this.d[n],delete this.b.properties[n];else{const S=this.d[n];S&&(this.w(n,S),this.r(n,S))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=R.$Rf(s.scope)?n:s.scope;const l=s.properties;if(l)for(const S in l){const w=l[S];if(o&&O(S,w)){delete l[S];continue}if(w.source=t,w.defaultDefaultValue=l[S].default,this.w(S,w),e.$Wn.test(S)?w.scope=void 0:(w.scope=R.$Rf(w.scope)?n:w.scope,w.restricted=R.$Rf(w.restricted)?!!i?.includes(S):w.restricted),l[S].hasOwnProperty("included")&&!l[S].included){this.f[S]=l[S],delete l[S];continue}else this.d[S]=l[S],l[S].policy?.name&&this.e.set(l[S].policy.name,S);!l[S].deprecationMessage&&l[S].markdownDeprecationMessage&&(l[S].deprecationMessage=l[S].markdownDeprecationMessage),r.add(S)}const k=s.allOf;if(k)for(const S of k)this.p(S,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$Nn.properties[s]=o,o.scope){case 1:e.$On.properties[s]=o;break;case 2:e.$Pn.properties[s]=o;break;case 6:e.$Qn.properties[s]=o;break;case 3:e.$Rn.properties[s]=o;break;case 4:e.$Sn.properties[s]=o;break;case 5:e.$Sn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$Nn.properties[s],o.scope){case 1:delete e.$On.properties[s];break;case 2:delete e.$Pn.properties[s];break;case 6:delete e.$Qn.properties[s];break;case 3:delete e.$Rn.properties[s];break;case 4:case 5:delete e.$Sn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$Tn};this.w(o,t),e.$Nn.properties[o]=t,e.$On.properties[o]=t,e.$Pn.properties[o]=t,e.$Qn.properties[o]=t,e.$Rn.properties[o]=t,e.$Sn.properties[o]=t}}v(){const s={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=s,e.$On.patternProperties[e.$Vn]=s,e.$Pn.patternProperties[e.$Vn]=s,e.$Qn.patternProperties[e.$Vn]=s,e.$Rn.patternProperties[e.$Vn]=s,e.$Sn.patternProperties[e.$Vn]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;R.$Pf(i)&&(i=o.defaultDefaultValue,n=void 0),R.$Pf(i)&&(i=c(o.type)),o.default=i,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",v=new RegExp(f,"g");e.$Vn=`^(${f})+$`,e.$Wn=new RegExp(e.$Vn);function E(m){const s=[];if(e.$Wn.test(m)){let o=v.exec(m);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=v.exec(m)}}return(0,L.$Mb)(s)}e.$Xn=E;function g(m){return m.reduce((s,o)=>`${s}[${o}]`,"")}e.$Yn=g;function c(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=c;const p=new $;u.$Hn.add(e.$Mn.Configuration,p);function O(m,s){return m.trim()?e.$Wn.test(m)?N.localize(7,null,m):p.getConfigurationProperties()[m]!==void 0?N.localize(8,null,m):s.policy?.name&&p.getPolicyConfigurations().get(s.policy?.name)!==void 0?N.localize(9,null,m,s.policy?.name,p.getPolicyConfigurations().get(s.policy?.name)):null:N.localize(6,null)}e.$1n=O;function h(){const m=[],s=p.getConfigurationProperties();for(const o of Object.keys(s))m.push([o,s[o].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.$2n=h}),define(ie[66],ne([0,1,19,4,38,2,31,28,3,11,25,40,36]),function(J,e,L,D,R,N,A,I,u,a,y,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function f(o){return Object.isFrozen(o)?o:I.$wn(o)}class v{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof v)return i;const n=new E("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,y.$Hi)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:l}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,y.$Hi)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=I.$vn(this.contents),n=I.$vn(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const k of t)if(l.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(i,k.contents);for(const S of k.overrides){const[w]=n.filter(j=>L.$ub(j.identifiers,S.identifiers));w?(this.h(w.contents,S.contents),w.keys.push(...S.keys),w.keys=L.$Mb(w.keys)):n.push(I.$vn(S))}for(const S of k.keys)r.indexOf(S)===-1&&r.push(S)}return new v(i,r,n,l.every(k=>k instanceof v)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r];const k=i[r];k&&(typeof l=="object"&&typeof k=="object"?(l=I.$vn(l),this.h(l,k)):l=k),n[r]=l}return new v(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&u.$Kf(t[n])&&u.$Kf(i[n])){this.h(t[n],i[n]);continue}t[n]=I.$vn(i[n])}}i(t){let i=null,n=null;const r=l=>{l&&(n?this.h(n,l):n=I.$vn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?i=l.contents:l.identifiers.includes(t)&&r(l.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,y.$Gi)(this.contents,t),b.$Wn.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$ub(n.identifiers,(0,b.$Xn)(t))),1))}j(t,i,n){(0,y.$Fi)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),b.$Wn.test(t)&&this.overrides.push({identifiers:(0,b.$Xn)(t),keys:Object.keys(this.contents[t]),contents:(0,y.$Ei)(this.contents[t],r=>console.error(r))})}}e.$3n=v;class E{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!u.$Rf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:l,restricted:k,hasExcludedProperties:S}=this.h(t,i);this.b=new v(n,r,l,S?[t]:void 0),this.c=k||[]}g(t){let i={},n=null,r=[];const l=[],k=[];function S(j){Array.isArray(r)?r.push(j):n!==null&&(r[n]=j)}const w={onObjectBegin:()=>{const j={};S(j),l.push(r),r=j,n=null},onObjectProperty:j=>{n=j},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const j=[];S(j),l.push(r),r=j,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:S,onError:(j,B,te)=>{k.push({error:j,offset:B,length:te})}};if(t)try{R.$jn(t,w),i=r[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return i}h(t,i){const n=$.$Hn.as(b.$Mn.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const l=(0,y.$Ei)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(t),S=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:l,keys:k,overrides:S,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const k={},S=[];for(const w in t)if(b.$Wn.test(w)&&n){const j=this.i(t[w],i,!1,r);k[w]=j.raw,l=l||j.hasExcludedProperties,S.push(...j.restricted)}else{const j=i[w],B=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&S.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(B===void 0||r.scopes===void 0||r.scopes.includes(B))&&!(r.skipRestricted&&j?.restricted))?k[w]=t[w]:l=!0}return{raw:k,restricted:S,hasExcludedProperties:l}}j(t,i){const n=[];for(const r of Object.keys(t))if(b.$Wn.test(r)){const l={};for(const k in t[r])l[k]=t[r][k];n.push({identifiers:(0,b.$Xn)(r),keys:Object.keys(l),contents:(0,y.$Ei)(l,i)})}return n}}e.$4n=E;class g extends N.$Tc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new D.$Vd),this.onDidChange=this.b.event,this.a=new E(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=g;class c{constructor(t,i,n,r,l,k,S,w,j,B,te,Y,oe){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=l,this.f=k,this.g=S,this.h=w,this.i=j,this.j=B,this.k=te,this.l=Y,this.m=oe}get value(){return f(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return f(r.value)},get override(){return f(r.override)},get merged(){return f(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(t,i,n,r,l=new v,k=new v,S=new A.$Ac,w=new v,j=new A.$Ac){this.c=t,this.d=i,this.f=n,this.g=r,this.h=l,this.i=k,this.j=S,this.l=w,this.m=j,this.a=null,this.b=new A.$Ac,this.n=null}getValue(t,i,n){return this.p(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new v,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.p(t,i,n),l=this.t(i.resource,n),k=i.resource?this.m.get(i.resource)||this.l:this.l,S=new Set;for(const w of r.overrides)for(const j of w.identifiers)r.getOverrideValue(t,j)!==void 0&&S.add(j);return new c(t,i,r.getValue(t),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,k)}keys(t){const i=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:l,removed:k}=m(this.c,t);i=[...r,...l,...k]}for(const r of i)for(const l of(0,b.$Xn)(r)){const k=this.c.getKeysForOverrideIdentifier(l),S=t.getKeysForOverrideIdentifier(l),w=[...S.filter(j=>k.indexOf(j)===-1),...k.filter(j=>S.indexOf(j)===-1),...k.filter(j=>!I.$zn(this.c.override(l).getValue(j),t.override(l).getValue(j)))];n.push([l,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=m(this.d,t),l=[...i,...n,...r];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=m(this.applicationConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateApplicationConfiguration(t),{keys:k,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=m(this.localUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateLocalUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=m(this.remoteUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateRemoteUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=m(this.workspaceConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateWorkspaceConfiguration(t),{keys:k,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:r,updated:l,removed:k,overrides:S}=m(n,i),w=[...r,...l,...k];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:S}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:k}=m(i,void 0);return{keys:[...n,...r,...l],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,i,n){let r=this.q(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}q({resource:t},i){let n=this.r();if(i&&t){const r=i.getFolder(t);r&&(n=this.s(r.uri)||n);const l=this.m.get(t);l&&(n=n.merge(l))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let i=this.b.get(t);if(!i){const n=this.r(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}t(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:l}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}v(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.w(t.defaults),n=this.w(t.policy),r=this.w(t.application),l=this.w(t.user),k=this.w(t.workspace),S=t.folders.reduce((w,j)=>(w.set(a.URI.revive(j[0]),this.w(j[1])),w),new A.$Ac);return new p(i,n,r,l,new v,k,S,new v,new A.$Ac)}static w(t){return new v(t.contents,t.keys,t.overrides)}}e.$6n=p;function O(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,k])=>{const S=(0,A.$xc)(i,l,new Set);k.forEach(w=>S.add(w))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$7n=O;class h{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const k of l)this.affectedKeys.add(k);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const l=r+n.length;if(l>=this.d.length)return!1;const k=this.d.charCodeAt(l);if(k!==this.b&&k!==this.c)return!1;if(i){const S=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!I.$zn(S,w)}return!0}}e.$8n=h;function m(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),l=[],k=o?.getAllOverrideIdentifiers()||[],S=t?.getAllOverrideIdentifiers()||[];if(t){const w=S.filter(j=>!k.includes(j));for(const j of w)l.push([j,t.getKeysForOverrideIdentifier(j)])}if(o){const w=k.filter(j=>!S.includes(j));for(const j of w)l.push([j,o.getKeysForOverrideIdentifier(j)])}if(t&&o){for(const w of k)if(S.includes(w)){const j=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});l.push([w,[...j.added,...j.removed,...j.updated]])}}return{added:i,removed:n,updated:r,overrides:l}}function s(o,t){const i=o?t?o.keys.filter(l=>t.keys.indexOf(l)===-1):[...o.keys]:[],n=t?o?t.keys.filter(l=>o.keys.indexOf(l)===-1):[...t.keys]:[],r=[];if(o&&t){for(const l of t.keys)if(o.keys.indexOf(l)!==-1){const k=(0,y.$Hi)(t.contents,l),S=(0,y.$Hi)(o.contents,l);I.$zn(k,S)||r.push(l)}}return{added:i,removed:n,updated:r}}}),define(ie[135],ne([0,1,19,4,2,28,3,66,40,5,39,36]),function(J,e,L,D,R,N,A,I,u,a,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=void 0;class $ extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Vd),this.onDidChangeConfiguration=this.a.event,this.b=new I.$3n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.$Hn.as(u.$Mn.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:c})=>this.c(Array.from(g),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,c){this.h(g,b.$Hn.as(u.$Mn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new I.$3n;const g=b.$Hn.as(u.$Mn.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,c){const p=this.f();for(const O of g){const h=p[O],m=c[O];h!==void 0?this.b.addValue(O,h):m?this.b.addValue(O,m.default):this.b.removeValue(O)}}}e.$9n=$;class f{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new I.$3n}async initialize(){return this.configurationModel}}e.$0n=f;let v=class extends R.$Tc{get configurationModel(){return this.b}constructor(g,c,p){super(),this.c=g,this.f=c,this.g=p,this.a=this.B(new D.$Vd),this.onDidChangeConfiguration=this.a.event,this.b=new I.$3n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const c={},p=[],O=b.$Hn.as(u.$Mn.Configuration).getConfigurationProperties();for(const h of g){const m=O[h];if(!m){p.push(h);continue}if(m.policy){if(m.type!=="string"&&m.type!=="number"){this.g.warn(`Policy ${m.policy.name} has unsupported type ${m.type}`);continue}p.push(h),c[m.policy.name]={type:m.type}}}return(0,A.$Vf)(c)||await this.f.updatePolicyDefinitions(c),p}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const c=b.$Hn.as(u.$Mn.Configuration).getPolicyConfigurations(),p=(0,L.$Hb)(g.map(O=>c.get(O)));this.m(p,!0)}m(g,c){this.g.trace("PolicyConfiguration#update",g);const p=b.$Hn.as(u.$Mn.Configuration).getConfigurationProperties(),O=[],h=this.b.isEmpty();for(const m of g){const s=p[m]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(h?o!==void 0:!(0,N.$zn)(this.b.getValue(m),o))&&O.push([m,o])}else this.b.getValue(m)!==void 0&&O.push([m,void 0])}if(O.length){this.g.trace("PolicyConfiguration#changed",O);const m=this.b;this.b=new I.$3n;for(const s of m.keys)this.b.setValue(s,m.getValue(s));for(const[s,o]of O)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);c&&this.a.fire(this.b)}}};e.$$n=v,e.$$n=v=$e([se(1,y.$Jn),se(2,a.$nj)],v)}),define(ie[136],ne([0,1,19,9,14,4,38,73,2,28,12,17,25,66,40,135,39]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=void 0;class c extends u.$Tc{constructor(h,m,s,o){super(),this.m=h,this.h=this.B(new N.$Vd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.$9n),this.c=s instanceof g.$Ln?new E.$0n:this.B(new E.$$n(this.b,s,o)),this.f=this.B(new f.$5n(this.m,{},b.$yg,m)),this.a=new f.$6n(this.b.configurationModel,this.c.configurationModel,new f.$3n,new f.$3n),this.j=new p(h,m,this),this.g=this.B(new D.$fh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:i})=>this.r(t,i))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,m,s]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$6n(h,m,new f.$3n,s)}getConfigurationData(){return this.a.toData()}getValue(h,m){const s=typeof h=="string"?h:void 0,o=(0,$.$Ai)(h)?h:(0,$.$Ai)(m)?m:{};return this.a.getValue(s,o,void 0)}async updateValue(h,m,s,o,t){const i=(0,$.$Bi)(s)?s:(0,$.$Ai)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,n=i?o:s;if(n!==void 0&&n!==3&&n!==2)throw new Error(`Unable to write ${h} to target ${n}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,L.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const r=this.inspect(h,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,a.$zn)(m,r.defaultValue)&&(m=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const k=i.overrideIdentifiers.sort(),S=this.a.localUserConfiguration.overrides.find(w=>(0,L.$ub)([...w.identifiers].sort(),k));S&&(i.overrideIdentifiers=S.identifiers)}const l=i?.overrideIdentifiers?.length?[(0,v.$Yn)(i.overrideIdentifiers),h]:[h];await this.j.write(l,m),await this.reloadConfiguration()}inspect(h,m={}){return this.a.inspect(h,m,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const m=this.a.toData(),s=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(s,m,2)}r(h,m){const s=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(h,m);this.t(o,s,7)}s(h){const m=this.a.toData(),s=this.a.compareAndUpdatePolicyConfiguration(h);this.t(s,m,7)}t(h,m,s){const o=new f.$8n(h,{data:m},this.a);o.source=s,o.sourceConfig=this.u(s),this.h.fire(o)}u(h){switch(h){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$_n=c;class p{constructor(h,m,s){this.b=h,this.c=m,this.d=s,this.a=new D.$ah}write(h,m){return this.a.queue(()=>this.e(h,m))}async e(h,m){let s;try{s=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)s="{}";else throw i}const o=[];if((0,A.$cn)(s,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(s,h,m);s=(0,I.$un)(s,t),await this.c.writeFile(this.b,R.$je.fromString(s))}f(h,m,s){const{tabSize:o,insertSpaces:t,eol:i}=this.h;if(!m.length){const n=JSON.stringify(s,null,t?" ".repeat(o):"	");return[{content:n,length:n.length,offset:0}]}return(0,I.$rn)(h,m,s,{tabSize:o,insertSpaces:t,eol:i})}get h(){if(!this.g){let h=y.OS===3||y.OS===2?`
`:`\r
`;const m=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});m&&typeof m=="string"&&m!=="auto"&&(h=m),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ie[67],ne([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function D(a){return a.scheme===L.Schemas.vscodeRemote?a.authority:void 0}e.$al=D;function R(a){if(!a)return;const y=a.indexOf("+");return y<0?a:a.substr(0,y)}e.$bl=R;function N(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$cl=N;function A(a){const{host:y,port:b}=u(a);if(typeof b>"u")throw new Error(`Invalid remote authority: ${a}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:b}}e.$dl=A;function I(a,y){let{host:b,port:$}=u(a);return typeof $>"u"&&($=y),{host:b,port:$}}e.$el=I;function u(a){const y=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const b=a.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const $=a.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:a,port:void 0}}}),define(ie[37],ne([0,1,30,10,67]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function N(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.$jm=N,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(A||(e.ExtensionType=A={}));var I;(function(E){E.WIN32_X64="win32-x64",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class u{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,c){if(typeof g>"u"||g===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof g=="string"||typeof c=="string"){const p=typeof g=="string"?g:g.value,O=typeof c=="string"?c:c.value;return L.$_e(p,O)}return g._lower===c._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$lm=u;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const c of g)this.add(c)}add(g){this.c.add(u.toKey(g))}delete(g){return this.c.delete(u.toKey(g))}has(g){return this.c.has(u.toKey(g))}}e.$mm=a;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(u.toKey(g))}get(g){return this.c.get(u.toKey(g))}has(g){return this.c.has(u.toKey(g))}set(g,c){this.c.set(u.toKey(g),c)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=y;function b(E){return $(E)}e.$om=b;function $(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.$pm=$;function f(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.$qm=f;function v(E,g){if(g){const c=`onResolveRemoteAuthority:${(0,R.$bl)(g)}`;return!!E.activationEvents?.includes(c)}return!1}e.$rm=v,e.$sm=(0,D.$6h)("IBuiltinExtensionsScannerService")}),define(ie[137],ne([0,1,2,37,13]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class N extends L.$Tc{constructor(I,u,a,y,b){super(),this.a=I,this.b=u,this.c=a,this.f=b,this.B(y.onDidInstallExtensions($=>this.g($))),this.B(y.onDidUninstallExtension($=>this.h($)))}g(I){for(const u of I)u.local&&this.invalidate(u.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,I)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,D.$fm))}catch(u){(0,R.$Hk)(u)!==1&&this.f.error(u)}}}e.$8p=N}),define(ie[45],ne([0,1,14,7,2,106,40,10,5,36]),function(J,e,L,D,R,N,A,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=void 0,e.$hp=(0,I.$6h)("requestService");class y{constructor(m){this.b=m}toJSON(){if(!this.a){const m=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?m[s]="*****":m[s]=this.b[s];this.a=m}return this.a}}class b extends R.$Tc{constructor(m){super(),this.b=0,this.a=m.createLogger("network",{name:(0,N.localize)(0,null),when:u.$Ej.isEqualTo((0,u.$Cj)(u.LogLevel.Trace)).serialize()})}async c(m,s,o){const t=`${m} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new y(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,D.$0)(i)),i}}}e.$ip=b;function $(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.$jp=$;function f(h){return h.res.statusCode===204}e.$kp=f;async function v(h){return f(h)?null:(await(0,L.$ve)(h.stream)).toString()}e.$lp=v;async function E(h){if(!$(h))throw new Error("Server returned "+h.res.statusCode);return v(h)}e.$mp=E;async function g(h){if(!$(h))throw new Error("Server returned "+h.res.statusCode);if(f(h))return null;const s=(await(0,L.$ve)(h.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$np=g;function c(h){O(h)}e.$op=c;let p;function O(h){const m=a.$Hn.as(A.$Mn.Configuration),s=p;p={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},m.updateConfigurations({add:[p],remove:s?[s]:[]})}O(1)}),define(ie[138],ne([0,1,20,15,13,45]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=void 0;let A=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,y=L.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,a);return}const b={type:"GET",url:u.toString(!0)},$=await this.a.request(b,y);if($.res.statusCode===200)await this.b.writeFile(a,$.stream);else{const f=await(0,N.$mp)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${f}`)}}};e.$JO=A,e.$JO=A=$e([se(0,N.$hp),se(1,R.$qk)],A)}),define(ie[139],ne([0,1,140,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;function R(A,I){return A.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:A.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function N(A,I,u={}){const a=(0,L.parse)(A),y=u.proxyUrl||R(a,I);if(!y)return null;const b=(0,L.parse)(y);if(!/^https?:$/.test(b.protocol||""))return null;const $={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,D.$Of)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((f,v)=>{J(["http-proxy-agent"],f,v)})).HttpProxyAgent(y,$):new(await new Promise((f,v)=>{J(["https-proxy-agent"],f,v)})).HttpsProxyAgent(y,$)}e.$mr=N}),define(ie[141],ne([0,1,58,16,107,20,34,7,12,29,86,173,9,74]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=void 0;let v;async function E(c,p,O,h){return O["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$6l)(h)&&!O["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$6l)(h)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=$.Promises.withAsyncBody(async(m,s)=>{const o=new N.$6d;let t=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.$7l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,R.localize)(0,null)))},t);try{m(await g(p,o.token))}catch(r){!(0,I.$4)(r)&&!o.token.isCancellationRequested?s(new Error((0,R.localize)(1,null,(0,A.$Qi)(r)))):m({})}finally{clearTimeout(n),o.dispose()}})),v)}e.$_l=E;async function g(c,p){const O=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",O);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",h);const m=(0,a.$qg)().replace(/-/g,"").substr(0,12),s=new RegExp(m+"({.*})"+m),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",o);const t=await(0,y.$Vl)(u.OS,o);return c.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if(p.isCancellationRequested)return n(new I.$5);const r=(0,D.$nc)(t);let l,k;const S="";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${S} -p '''${m}'' + JSON.stringify(process.env) + ''${m}'''`,k=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${S} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,k=["-i","-l","-c"]):r==="xonsh"?(l=`import os, json; print("${m}", json.dumps(dict(os.environ)), "${m}")`,k=["-i","-l","-c"]):(l=`'${process.execPath}' ${S} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,r==="tcsh"||r==="csh"?k=["-ic"]:k=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),l);const w=(0,L.spawn)(t,[...k,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});p.onCancellationRequested(()=>(w.kill(),n(new I.$5))),w.on("error",te=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$Qi)(te)),n(te)});const j=[];w.stdout.on("data",te=>j.push(te));const B=[];w.stderr.on("data",te=>B.push(te)),w.on("close",(te,Y)=>{const oe=Buffer.concat(j).toString("utf8");c.trace("getUnixShellEnvironment#raw",oe);const re=Buffer.concat(B).toString("utf8");if(re.trim()&&c.trace("getUnixShellEnvironment#stderr",re),te||Y)return n(new Error((0,R.localize)(2,null,te,Y)));const he=s.exec(oe),ce=he?he[1]:"{}";try{const ae=JSON.parse(ce);O?ae.ELECTRON_RUN_AS_NODE=O:delete ae.ELECTRON_RUN_AS_NODE,h?ae.ELECTRON_NO_ATTACH_CONSOLE=h:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),i(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,A.$Qi)(ae)),n(ae)}})})}}),define(ie[142],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mO=e.$lO=void 0,e.$lO=(0,L.$6h)("stateReadService"),e.$mO=(0,L.$6h)("stateService")}),define(ie[68],ne([0,1,9,14,2,3,18,13,5]),function(J,e,L,D,R,N,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=e.$oO=e.$nO=e.SaveStrategy=void 0;var a;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class y extends R.$Tc{constructor(v,E,g,c){super(),this.h=v,this.j=E,this.m=g,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new L.$4g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.m.error(v)}}getItem(v,E){const g=this.a[v];return(0,N.$Rf)(g)?E:g}setItem(v,E){this.setItems([{key:v,data:E}])}setItems(v){let E=!1;for(const{key:g,data:c}of v)this.a[g]!==c&&((0,N.$Rf)(c)?(0,N.$Pf)(this.a[g])||(this.a[g]=void 0,E=!0):(this.a[g]=c,E=!0));E&&this.s()}removeItem(v){(0,N.$Pf)(this.a[v])||(this.a[v]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.n.writeFile(this.h,D.$je.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(E){this.m.error(E)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$nO=y;let b=class extends R.$Tc{constructor(v,E,g,c){super(),this.a=this.B(new y(E.stateResource,v,g,c))}async init(){await this.a.init()}getItem(v,E){return this.a.getItem(v,E)}};e.$oO=b,e.$oO=b=$e([se(1,A.$ai),se(2,u.$nj),se(3,I.$qk)],b);class $ extends b{setItem(v,E){this.a.setItem(v,E)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$pO=$}),define(ie[69],ne([0,1,12,35,29]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=void 0;function N(u){if(L.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function A(u,a,y,b,$,f,v,E,g){const c=Object.create(null);c["common.machineId"]=f,c["common.sqmId"]=v,c.sessionID=(0,R.$qg)()+Date.now(),c.commitHash=b,c.version=$,c["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,L.$h)(L.$u),c["common.nodePlatform"]=D.$dc,c["common.nodeArch"]=y,c["common.product"]=g||"desktop",E&&(c["common.msftInternal"]=E);let p=0;const O=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-O,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),L.$l&&(c["common.snap"]="true");const h=N(a);return h&&(c["common.platformDetail"]=h),c}e.$Io=A;function I(u){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const y=a.toLowerCase();return u.some(b=>y===b)}e.$Jo=I}),define(ie[26],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,L.$6h)("telemetryService"),e.$vl=(0,L.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ie[41],ne([0,1,28,3,4,25,67,69,26]),function(J,e,L,D,R,N,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$Ko=a;class y{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Lo=y,e.$Mo=new y;class b{async publicLog(n,r,l){}async publicLogError(n,r,l){}}e.$No=b,e.$Oo="telemetry",e.$Po="extensionTelemetryLog",e.$Qo={log:()=>null,flush:()=>Promise.resolve(null)};function $(i,n){return R.Event.debounce(n.onDidChangeConfiguration,(l,k)=>{const S=l?new Set([...l.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:S}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,N.$Ci)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$Ro=$;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$So=f;function v(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$To=v;function E(i){const n=i.getValue(u.$Cl),r=i.getValue(u.$Dl);if(i.getValue(u.$El)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=E;function g(i){const n={},r={},l={};O(i,l);for(let k in l){k=k.length>150?k.substr(k.length-149):k;const S=l[k];typeof S=="number"?r[k]=S:typeof S=="boolean"?r[k]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${S.length}`),n[k]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(n[k]=S)}return{properties:n,measurements:r}}e.$Vo=g;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const n=(0,A.$bl)(i);return c.has(n)?n:"other"}e.$Wo=p;function O(i,n,r=0,l){if(i)for(const k of Object.getOwnPropertyNames(i)){const S=i[k],w=l?l+k:k;Array.isArray(S)?n[w]=(0,L.$An)(S):S instanceof Date?n[w]=S.toISOString():(0,D.$Kf)(S)?r<2?O(S,n,r+1,w+"."):n[w]=(0,L.$An)(S):n[w]=S}}function h(i,n){const r=i.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,I.$Jo)(r)||l}e.$Xo=h;function m(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Yo=m;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const l=[];for(const j of n)for(;;){const B=j.exec(i);if(!B)break;l.push([B.index,j.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const j=S.exec(i);if(!j)break;const B=l.some(([te,Y])=>j.index<Y&&te<S.lastIndex);!k.test(j[0])&&!B&&(r+=i.substring(w,j.index)+"<REDACTED: user-file-path>",w=S.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$xn)(i,r=>{if(r instanceof a||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=s(l,n);for(const k of n)l=l.replace(k,"");return l=o(l),l}})}e.$Zo=t}),define(ie[27],ne([0,1,30,21,37,12,11,7,35,41]),function(J,e,L,D,R,N,A,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function y(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$7e)(t.id,i.id)===0}e.$1o=y;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new $(i.identifier,n,r)}static parse(i){const n=b.exec(i);return n&&n[1]&&n[2]?new $({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof $?y(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$2o=$;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(t){const i=f.exec(t);return i&&i[1]?[g(i[1]),i[2]]:[g(t),void 0]}e.$3o=v;function E(t,i){return`${t}.${i}`}e.$4o=E;function g(t){return t.toLowerCase()}e.$5o=g;function c(t,i){return g(E(t??R.$hm,i))}e.$6o=c;function p(t,i){const n=[],r=l=>{for(const k of n)if(k.some(S=>y(i(S),i(l))))return k;return null};for(const l of t){const k=r(l);k?k.push(l):n.push([l])}return n}e.$7o=p;function O(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$8o=O;function h(t){return{id:new a.$Ko(t.identifier.id),name:new a.$Ko(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$9o=h,e.$0o=new R.$lm("pprice.better-merge");function m(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&n.every(k=>!y(k.identifier,{id:l}))){const k=t.filter(S=>y(S.identifier,{id:l}));k.length===1&&(n.push(k[0]),r.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$$o=m;async function s(t,i){if(!N.$k)return!1;let n;try{n=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,I.$0)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,D.$uo)(n?"alpine":N.$u,u.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$_o=o}),define(ie[143],ne([0,1,20,7,15,17,44,11,96,21,27,37]),function(J,e,L,D,R,N,A,I,u,a,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;const $=E=>(0,u.localize)(0,null,E),f=(0,u.localize)(1,null,"ms-dotnettools.csharp");let v=class{constructor(g,c,p){this.a=g,this.b=c,this.d=p}get f(){}async listExtensions(g,c,p){let O=await this.b.getInstalled(1,p);const h=b.$km.map(s=>s.toLowerCase());if(c&&c!==""){if(h.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}O=O.filter(s=>s.manifest.categories?s.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),h.forEach(s=>{this.a.info(s)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),O=O.sort((s,o)=>s.identifier.id.localeCompare(o.identifier.id));let m;for(const s of O)m!==s.identifier.id&&(m=s.identifier.id,this.a.info(g?`${m}@${s.manifest.version}`:m))}async installExtensions(g,c,p,O){const h=[];try{const m=[];g.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const s=[];let o=[];const t=(n,r,l)=>{o.push({id:n,version:r!=="prerelease"?r:void 0,installOptions:{...p,isBuiltin:l,installPreReleaseVersion:r==="prerelease"||p.installPreReleaseVersion}})};for(const n of g)if(n instanceof I.URI)s.push({vsix:n,installOptions:p});else{const[r,l]=(0,y.$3o)(n);t(r,l,!1)}for(const n of c)if(n instanceof I.URI)s.push({vsix:n,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[r,l]=(0,y.$3o)(n);t(r,l,!0)}const i=await this.b.getInstalled(1,p.profileLocation);if(s.length&&await Promise.all(s.map(async({vsix:n,installOptions:r})=>{try{const l=await this.g(n,r,O,i);l&&m.push(l)}catch(l){this.a.error(l),h.push(n.toString())}})),o.length&&(o=o.filter(({id:n,version:r})=>{const l=i.find(k=>(0,y.$1o)(k.identifier,{id:n}));if(l){if(!O&&(!r||r==="prerelease"&&l.preRelease))return this.a.info((0,u.localize)(5,null,n,l.manifest.version,n)),!1;if(r&&l.manifest.version===r)return this.a.info((0,u.localize)(6,null,`${n}@${r}`)),!1}return!0}),o.length)){const n=await this.h(o);await Promise.all(o.map(async r=>{const l=n.get(r.id.toLowerCase());if(l)try{const k=await this.j(r,l,i);k&&m.push(k)}catch(k){this.a.error(k.message||k.stack||k),h.push(r.id)}else this.a.error(`${$(r.version?`${r.id}@${r.version}`:r.id)}
${f}`),h.push(r.id)}))}}catch(m){throw this.a.error((0,u.localize)(7,null,(0,D.$0)(m))),m}if(h.length)throw new Error((0,u.localize)(8,null,h.join(", ")))}async updateExtensions(g){const c=await this.b.getInstalled(1,g),p=[];for(const s of c)s.identifier.uuid&&p.push({...s.identifier,preRelease:s.preRelease});this.a.trace((0,u.localize)(9,null,p.length));const O=await this.d.getExtensions(p,{compatible:!0},L.CancellationToken.None),h=[];for(const s of O)for(const o of c)(0,y.$1o)(o.identifier,s.identifier)&&(0,A.gt)(s.version,o.manifest.version)&&h.push({extension:s,options:{operation:3,installPreReleaseVersion:o.isPreReleaseVersion}});if(!h.length){this.a.info((0,u.localize)(10,null));return}this.a.info((0,u.localize)(11,null,h.map(s=>s.extension.identifier.id).join(", ")));const m=await this.b.installGalleryExtensions(h);for(const s of m)s.error?this.a.error((0,u.localize)(12,null,s.identifier.id,(0,D.$0)(s.error))):this.a.info((0,u.localize)(13,null,s.identifier.id,s.local?.manifest.version))}async g(g,c,p,O){const h=await this.b.getManifest(g);if(!h)throw new Error("Invalid vsix");if(await this.l(h,p,c.profileLocation,O))try{return await this.b.install(g,c),this.a.info((0,u.localize)(14,null,(0,N.$Eg)(g))),h}catch(s){if((0,D.$4)(s))return this.a.info((0,u.localize)(15,null,(0,N.$Eg)(g))),null;throw s}return null}async h(g){const c=new Map,p=g.some(m=>m.installOptions.installPreReleaseVersion),O=await this.b.getTargetPlatform(),h=[];for(const m of g)a.$no.test(m.id)&&h.push({...m,preRelease:p});if(h.length){const m=await this.d.getExtensions(h,{targetPlatform:O},L.CancellationToken.None);for(const s of m)c.set(s.identifier.id.toLowerCase(),s)}return c}async j({id:g,version:c,installOptions:p},O,h){const m=await this.d.getManifest(O,L.CancellationToken.None);if(m&&!this.k(m))return null;const s=h.find(o=>(0,y.$1o)(o.identifier,O.identifier));if(s){if(O.version===s.manifest.version)return this.a.info((0,u.localize)(16,null,c?`${g}@${c}`:g)),null;this.a.info((0,u.localize)(17,null,g,O.version))}try{p.isBuiltin?this.a.info(c?(0,u.localize)(18,null,g,c):(0,u.localize)(19,null,g)):this.a.info(c?(0,u.localize)(20,null,g,c):(0,u.localize)(21,null,g));const o=await this.b.installFromGallery(O,{...p,installGivenVersion:!!c});return this.a.info((0,u.localize)(22,null,g,o.manifest.version)),m}catch(o){if((0,D.$4)(o))return this.a.info((0,u.localize)(23,null,g)),null;throw o}}k(g){return!0}async l(g,c,p,O){if(!c){const h={id:(0,y.$6o)(g.publisher,g.name)},m=O.find(s=>(0,y.$1o)(h,s.identifier)&&(0,A.gt)(s.manifest.version,g.version));if(m)return this.a.info((0,u.localize)(24,null,m.identifier.id,m.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,c,p){const O=async m=>{if(m instanceof I.URI){const s=await this.b.getManifest(m);return(0,y.$4o)(s.publisher,s.name)}return m},h=[];for(const m of g){const s=await O(m),t=(await this.b.getInstalled(void 0,p)).filter(i=>(0,y.$1o)(i.identifier,{id:s}));if(!t.length)throw new Error(`${this.m(s)}
${f}`);if(t.some(i=>i.type===0)){this.a.info((0,u.localize)(25,null,s));return}if(!c&&t.some(i=>i.isBuiltin)){this.a.info((0,u.localize)(26,null,s));return}this.a.info((0,u.localize)(27,null,s));for(const i of t)await this.b.uninstall(i,{profileLocation:p}),h.push(i);this.f?this.a.info((0,u.localize)(28,null,s,this.f)):this.a.info((0,u.localize)(29,null,s))}}async locateExtension(g){const c=await this.b.getInstalled();g.forEach(p=>{c.forEach(O=>{if(O.identifier.id===p&&O.location.scheme===R.Schemas.file){this.a.info(O.location.fsPath);return}})})}m(g){return this.f?(0,u.localize)(30,null,g,this.f):(0,u.localize)(31,null,g)}};e.$Hp=v,e.$Hp=v=$e([se(1,a.$Ao),se(2,a.$yo)],v)}),define(ie[144],ne([0,1,9,7,2,15,17,44,3,29,24,49,25,18,21,27,64,13,5]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g,c,p){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;let h=class extends R.$Tc{static{O=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,A.$Hg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new v.$zo(r.message,v.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(l){const k=l;if(n=k.code,k.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${k.output}`),n===v.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===v.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(i)}catch(S){this.r.error(S)}throw new v.$zo(b.$Lp,v.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return this.r.info(`Extension is not signed: ${s.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,u.$Of)(o)?o:!0}async u(s){await this.g;const o=(0,A.$Hg)(this.extensionsDownloadDir,`${this.z(s)}${O.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==N.Schemas.file){await t(o);return}const i=(0,A.$Hg)(this.extensionsDownloadDir,`.${(0,a.$qg)()}`);await this.h.exists(i)||await t(i);try{await y.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const l of s.children)if(l.name.endsWith(O.c))i.push(l.resource);else{const k=E.$2o.parse(l.name);k&&t.push([k,l])}const n=(0,E.$7o)(t,([l])=>l),r=[];for(const l of n)l.sort((k,S)=>I.rcompare(k[0].version,S[0].version)),o.push(...l.slice(1).map(k=>k[1].resource)),r.push(l[0][1]);r.sort((l,k)=>l.mtime-k.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),o.push(...i),await L.Promises.settled(o.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?E.$2o.create(s).toString().toLowerCase():(0,a.$qg)()}};e.$5p=h,e.$5p=h=O=$e([se(0,f.$bi),se(1,c.$qk),se(2,v.$yo),se(3,$.$zi),se(4,g.$Fp),se(5,p.$nj)],h)}),define(ie[145],ne([0,1,4,2,31,27,37]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class I extends D.$Tc{constructor(a,y,b,$,f,v,E){super(),this.f=a,this.g=y,this.h=b,this.j=$,this.m=f,this.n=v,this.r=E,this.a=this.B(new L.$Vd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$3c),this.s().then(null,g=>E.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(y=>(this.c.set(y.id,(0,D.$Qc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w(a){for(const y of a.extensions)this.I(this.L(y.identifier,y.version),a.profileLocation)}async y(a){for(const y of a.extensions){const b=this.L(y.identifier,y.version);a.error?this.J(b,a.profileLocation):this.I(b,a.profileLocation)}}async z(a){for(const y of a.extensions)this.J(this.L(y.identifier,y.version),a.profileLocation)}async C(a){const y=[],b=[];for(const $ of a.extensions){const f=this.L($.identifier,$.version);a.error?this.I(f,a.profileLocation):(this.J(f,a.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),b.push(this.f.scanInstalledExtensionAtLocation($.location).then(v=>{v?y.push(v):this.r.info("Extension not found at the location",$.location.toString())},v=>this.r.error(v)))))}try{await Promise.all(b),y.length&&await this.H(y)}catch($){this.r.error($)}}D(a){for(const y of this.h.profiles)a.contains(y.extensionsResource,0,1)&&this.F(y.extensionsResource)}async F(a){const y=[],b=[],$=await this.j.scanProfileExtensions(a),f=new Set,v=new Set;for(const[E,g]of this.b)g.has(a)&&v.add(E);for(const E of $){const g=this.L(E.identifier,E.version);f.add(g),v.has(g)||(y.push(E.identifier),this.I(g,a))}for(const E of v)if(!f.has(E)){const g=this.M(E);g&&(b.push(g.identifier),this.J(E,a))}(y.length||b.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:a}:void 0,removed:b.length?{extensions:b,profileLocation:a}:void 0})}async G(a){const y=await this.j.scanProfileExtensions(a);for(const b of y)this.I(this.L(b.identifier,b.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.L(b.identifier,b.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,y){let b=this.b.get(a);b||this.b.set(a,b=new R.$Bc($=>this.m.extUri.getComparisonKey($))),b.add(y)}J(a,y){const b=this.b.get(a);b&&b.delete(y),b?.size||this.b.delete(a)}L(a,y){return`${A.$lm.toKey(a.id)}@${y}`}M(a){const[y,b]=(0,N.$3o)(a);return b?{identifier:{id:y},version:b}:void 0}}e.$9p=I}),define(ie[146],ne([0,1,117,41]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;async function R(N,A,I,u,a,y,b){const $={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,D.$So)(A,I)&&(0,D.$Uo)(u)===3){const f=await(0,L.$Ap)(I,a,y);$["X-Market-User-Id"]=f,$["VSCode-SessionId"]=b.machineId||f}return $}e.$Bp=R}),define(ie[147],ne([0,1,174,19,9,2,15,16,24,18,21,27,5,63,11]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;let E=class extends f.$ir{constructor(O,h,m,s){super(m),this.h=O,this.j=s,this.g=this.B(new g(h,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(O,h){const s=(await this.g.getLanguagePacks())[h];if(!s){this.j.warn(`No language pack found for ${h}`);return}const o=s.translations[O];return o?v.URI.file(o):void 0}async getInstalledLanguages(){const O=await this.g.getLanguagePacks(),h=Object.keys(O).map(m=>{const s=O[m];return{...this.f(m,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((m,s)=>m.label.localeCompare(s.label)),h}async m(O){O&&O.manifest&&O.manifest.contributes&&O.manifest.contributes.localizations&&O.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",O.identifier.id),await this.update())}async n(O){const h=await this.g.getLanguagePacks();Object.keys(h).some(m=>h[m]&&h[m].extensions.some(s=>(0,b.$1o)(s.extensionIdentifier,O.identifier)))&&(this.j.info("Removing language packs from the extension",O.identifier.id),await this.update())}async update(){const[O,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),m=await this.g.update(h);return!(0,D.$ub)(Object.keys(O),Object.keys(m))}};e.$jr=E,e.$jr=E=$e([se(0,y.$Ao),se(1,a.$bi),se(2,y.$yo),se(3,$.$nj)],E);let g=class extends N.$Tc{constructor(O,h){super(),this.j=h,this.c={},this.f=(0,I.$jc)(O.userDataPath,"languagepacks.json"),this.g=new R.$ah}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(O){return this.s(h=>{Object.keys(h).forEach(m=>delete h[m]),this.m(h,...O)}).then(()=>this.c)}m(O,...h){for(const m of h)m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&this.n(O,m);Object.keys(O).forEach(m=>this.r(O[m]))}n(O,h){const m=h.identifier,s=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const o of s)if(h.location.scheme===A.Schemas.file&&c(o)){let t=O[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},O[o.languageId]=t);const i=t.extensions.filter(n=>(0,b.$1o)(n.extensionIdentifier,m))[0];i?i.version=h.manifest.version:t.extensions.push({extensionIdentifier:m,version:h.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,I.$jc)(h.location.fsPath,n.path)}}r(O){if(O){const h=(0,L.createHash)("md5");for(const m of O.extensions)h.update(m.extensionIdentifier.uuid||m.extensionIdentifier.id).update(m.version);O.hash=h.digest("hex")}}s(O=()=>null){return this.g.queue(()=>{let h=null;return u.Promises.readFile(this.f,"utf8").then(void 0,m=>m.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(m)).then(m=>{try{return JSON.parse(m)}catch{return{}}}).then(m=>(h=O(m),m)).then(m=>{for(const o of Object.keys(m))m[o]||delete m[o];this.c=m,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),u.Promises.writeFile(this.f,s)}).then(()=>h,m=>this.j.error(m))})}};g=$e([se(0,a.$bi),se(1,$.$nj)],g);function c(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const O of p.translations)if(typeof O.id!="string"||typeof O.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ie[148],ne([0,1,83,7,28,41]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hO=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function u(y,b,$){const f=await(0,L.$fD)("@microsoft/1ds-core-js","dist/ms.core.js"),v=await(0,L.$fD)("@microsoft/1ds-post-js","dist/ms.post.js"),E=new f.AppInsightsCore,g=new v.PostChannel,c={instrumentationKey:y,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if($){c.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:$};c.extensionConfig[g.identifier]=p}return E.initialize(c,[]),E.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',b&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),E}class a{constructor(b,$,f,v,E){this.e=b,this.f=$,this.g=f,this.h=E,this.c=A,this.d=I,this.g||(this.g={}),typeof v=="function"?this.a=v():this.a=v,this.b=null}i(b){if(this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then($=>{b($)},$=>{(0,D.$1)($),console.error($)})}}log(b,$){if(!this.a)return;$=(0,R.$yn)($,this.g),$=(0,N.$Vo)($);const f=this.f+"/"+b;try{this.i(v=>{v.pluginVersionString=$?.properties.version??"Unknown",v.track({name:f,baseData:{name:f,properties:$?.properties,measurements:$?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i($=>{$.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.$hO=a}),define(ie[149],ne([0,1,2,28,12,30,108,25,40,150,32,36,26,41]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,p,O){this.k=p,this.l=O,this.d={},this.i=new L.$Sc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,N.$Oe)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$Oe)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration($.$Cl)||h.affectsConfiguration($.$El)||h.affectsConfiguration($.$Dl))&&this.m()}))}setExperimentProperty(c,p){this.d[c]=p}m(){let c=(0,f.$Uo)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const O=p.usage?3:p.error?2:0;c=Math.min(c,O)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,p,O){this.g<p||(O=(0,D.$yn)(O,this.d),O=(0,f.$Zo)(O,this.j),O=(0,D.$yn)(O,this.c),this.b.forEach(h=>h.log(c,O)))}publicLog(c,p){this.n(c,3,p)}publicLog2(c,p){this.publicLog(c,p)}publicLogError(c,p){this.h&&this.n(c,2,p)}publicLogError2(c,p){this.publicLogError(c,p)}};e.$pr=v,e.$pr=v=$e([se(1,I.$zi),se(2,y.$Fj)],v);function E(){const g=(0,A.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=R.$o?"":(0,A.localize)(3,null),O=(0,A.localize)(4,null),h=(0,A.localize)(5,null),m=(0,A.localize)(6,null),s=(0,A.localize)(7,null),o=`
|       | ${O} | ${h} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${g} ${c} ${p}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}b.$Hn.as(u.$Mn.Configuration).registerConfiguration({id:$.$Bl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[$.$Cl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$Hn.as(u.$Mn.Configuration).registerConfiguration({id:$.$Bl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[$.$El]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${$.$Cl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[151],ne([0,1,14,20,175,148]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=void 0;async function A(y,b){const $=await b.request(y,D.CancellationToken.None),f=(await(0,L.$ve)($.stream)).toString(),v=$.res.statusCode??200;return{headers:$.res.headers,statusCode:v,responseData:f}}async function I(y){const b={method:y.type,headers:y.headers};return new Promise((f,v)=>{const E=R.request(y.url??"",b,g=>{g.on("data",function(c){f({headers:g.headers,statusCode:g.statusCode??200,responseData:c.toString()})}),g.on("error",function(c){v(c)})});E.write(y.data,g=>{g&&v(g)}),E.end()})}async function u(y,b,$){const f=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),v={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:f};try{const E=y?await A(v,y):await I(v);$(E.statusCode,E.headers,E.responseData)}catch{$(0,{})}}class a extends N.$hO{constructor(b,$,f,v,E){const g={sendPOST:(c,p)=>{u(b,c,p)}};super($,f,v,E,g)}}e.$iO=a}),define(ie[152],ne([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=void 0;async function R(N,A){const I=Object.create(null),u=(y,b)=>{const $=JSON.parse(y);I[b]=$};if(A){const y=[],b=await D.Promises.readdir(A);for(const f of b)try{(await D.Promises.stat((0,L.$jc)(A,f))).isDirectory()&&y.push(f)}catch{}const $=[];for(const f of y)(await D.Promises.readdir((0,L.$jc)(A,f))).filter(E=>E==="telemetry.json").length===1&&$.push(f);for(const f of $){const v=(await D.Promises.readFile((0,L.$jc)(A,f,"telemetry.json"))).toString();u(v,f)}}let a=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(I,null,4)}e.$A_b=R}),define(ie[153],ne([0,1,12,84,26]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=e.$S$b=void 0;async function N(I,u){let a=I.getItem(R.$zl);return(typeof a!="string"||L.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$$m)(u.error.bind(u))),a}e.$S$b=N;async function A(I,u){let a=I.getItem(R.$Al);return typeof a!="string"&&(a=await(0,D.$_m)(u.error.bind(u))),a}e.$T$b=A}),define(ie[22],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=void 0,e.$1k=(0,L.$6h)("IUriIdentityService")}),define(ie[154],ne([0,1,22,118,13,17,75,4,2]),function(J,e,L,D,R,N,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;class a{static{this._clock=0}constructor($){this.uri=$,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let y=class{constructor($){this.g=$,this.c=new u.$Sc,this.f=2**16;const f=new Map,v=E=>{let g=f.get(E.scheme);return g===void 0&&(g=$.hasProvider(E)&&!this.g.hasCapability(E,1024),f.set(E.scheme,g)),g};this.c.add(I.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(E=>{f.delete(E.scheme)})),this.extUri=new N.$wg(v),this.d=new A.$1r((E,g)=>this.extUri.compare(E,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,N.$Ig)($));const f=this.d.get($);return f?f.touch().uri.with({fragment:$.fragment}):(this.d.set($,new a($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((v,E)=>v[1].time<E[1].time?1:v[1].time>E[1].time?-1:0);a._clock=0,this.d.clear();const f=this.f*.5;for(let v=0;v<f;v++)this.d.set($[v][0],$[v][1].touch())}};e.$2r=y,e.$2r=y=$e([se(0,R.$qk)],y),(0,D.$Yr)(L.$1k,y,1)}),define(ie[155],ne([0,1,4,2,13,48,31]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=void 0;class I extends D.$Tc{constructor(a,y,b,$,f,v){super(),this.f=a,this.g=y,this.h=b,this.j=$,this.m=f,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Vd),this.onDidChangeFile=this.a.event,this.b=N.$_h.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(E=>this.m.extUri.getComparisonKey(this.t(E))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(E=>this.s(E)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,y){return this.g.open(this.t(a),y)}close(a){return this.g.close(a)}read(a,y,b,$,f){return this.g.read(a,y,b,$,f)}write(a,y,b,$,f){return this.g.write(a,y,b,$,f)}watch(a,y){this.b.set(a,a);const b=this.g.watch(this.t(a),y);return(0,D.$Rc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,y,b){return this.g.rename(this.t(a),this.t(y),b)}readFile(a,y){return this.g.readFile(this.t(a),y)}readFileStream(a,y,b){return this.g.readFileStream(this.t(a),y,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,y,b){return this.g.writeFile(this.t(a),y,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,y){return this.g.delete(this.t(a),y)}copy(a,y,b){if((0,R.$uk)(this.g))return this.g.copy(this.t(a),this.t(y),b);throw new Error("copy not supported")}cloneFile(a,y){if((0,R.$vk)(this.g))return this.g.cloneFile(this.t(a),this.t(y));throw new Error("clone not supported")}s(a){const y=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const $=this.u(b.resource);this.b.findSubstr($)&&y.push({resource:$,type:b.type,cId:b.cId})}y.length&&(this.n.debug("User data changed"),this.a.fire(y))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$e_b=I}),define(ie[156],ne([0,1,110,16,48,17,11,10,15]),function(J,e,L,D,R,N,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,I.$6h)("contextService");function a(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$di=a;function y(i){return typeof i?.id=="string"&&!a(i)&&!$(i)}e.$ei=y,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function b(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$nc)(i)}:n?e.$fi:e.$gi;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$hi=b;function $(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$ii=$;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:A.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$ji=f;var v;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$ki=E;function g(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$li=g;class c{constructor(n,r,l,k,S){this.h=n,this.j=l,this.k=k,this.l=S,this.c=R.$_h.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$_h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=c;class p{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,N.$Hg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=p;function O(i){return new p({uri:i,index:0,name:(0,N.$Dg)(i)},{uri:i.toString()})}e.$oi=O,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,L.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function h(i,n){return N.$yg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$ti=h;function m(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===u.Schemas.tmp}e.$ui=m,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$vi}e.$wi=s;function o(i,n){return!h(i,n)&&!m(i)}e.$xi=o;function t(i){return(typeof i=="string"?(0,D.$oc)(i):(0,N.$Fg)(i))===e.$qi}e.$yi=t}),define(ie[23],ne([0,1,43,4,2,17,11,109,18,13,10,5,156,31,22,9,29,30,3]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.ProfileResourceType=void 0;var O;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(O||(e.ProfileResourceType=O={}));function h(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$2k=h,e.$3k=(0,y.$6h)("IUserDataProfilesService");function m(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:n}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$4k=m;function s(i,n,r,l,k,S){return{id:i,name:n,location:r,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:S&&k?.useDefaultFlags?.globalState?S.globalStorageHome:(0,N.$Hg)(r,"globalStorage"),settingsResource:S&&k?.useDefaultFlags?.settings?S.settingsResource:(0,N.$Hg)(r,"settings.json"),keybindingsResource:S&&k?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,N.$Hg)(r,"keybindings.json"),tasksResource:S&&k?.useDefaultFlags?.tasks?S.tasksResource:(0,N.$Hg)(r,"tasks.json"),snippetsHome:S&&k?.useDefaultFlags?.snippets?S.snippetsHome:(0,N.$Hg)(r,"snippets"),extensionsResource:S&&k?.useDefaultFlags?.extensions?S.extensionsResource:(0,N.$Hg)(r,"extensions.json"),cacheHome:(0,N.$Hg)(l,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$5k=s;let o=class extends R.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,l,k){super(),this.t=n,this.u=r,this.w=l,this.y=k,this.f=!0,this.h=this.B(new D.$Vd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Vd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Vd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Vd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$Hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$Hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,p.$If)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}r.push(s((0,N.$Eg)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},n))}}catch(S){this.y.error(S)}const l=new f.$Ac,k=new Map;if(r.length)try{const S=this.Q();if(S.workspaces)for(const[w,j]of Object.entries(S.workspaces)){const B=A.URI.parse(w),te=r.find(Y=>Y.id===j);te&&l.set(B,te)}if(S.emptyWindows)for(const[w,j]of Object.entries(S.emptyWindows)){const B=r.find(te=>te.id===j);B&&k.set(w,B)}}catch(S){this.y.error(S)}this.z={profiles:r,workspaces:l,emptyWindows:k}}return this.z}D(){const n=s("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,c.$Oe)(r)}\\s(\\d+)`);let k=0;for(const w of this.profiles){const j=l.exec(w.name),B=j?parseInt(j[1]):0;k=B>k?B:k}const S=`${r} ${k+1}`;return this.createProfile((0,L.$Ti)((0,g.$qg)()).toString(16),S,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,L.$Ti)((0,g.$qg)()).toString(16),n,r,l)}async createProfile(n,r,l,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F(n,r,l);return k&&await this.setProfileForWorkspace(k,S),S}async F(n,r,l){if(!(0,p.$If)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(r);return k||(k=(async()=>{try{const S=this.profiles.find(B=>B.name===r||B.id===n);if(S)return S;const w=s(n,r,(0,N.$Hg)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(w.location);const j=[];return this.j.fire({profile:w,join(B){j.push(B)}}),await E.Promises.settled(j),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,k)),k}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(k=>k.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=s(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(k=>k.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:r,join(k){l.push(k)}});try{await Promise.allSettled(l)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(k){(0,a.$Hk)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(k=>k.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return A.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,$.$di)(n)?n.uri:(0,$.$ii)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,l){const k=[...this.profiles,...n],S=[];this.s.profiles=[];for(let w of k)w.isDefault||r.some(j=>w.id===j.id)||(w=l.find(j=>w.id===j.id)??w,w.isTransient?this.s.profiles.push(w):S.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(S),this.z=void 0,this.J(n,r,l)}J(n,r,l){this.h.fire({added:n,removed:r,updated:l,all:this.profiles})}L(n,r,l){l=r?.isTransient?!0:l,l||this.L(n,void 0,!0);const k=this.G(n),S=l?this.s:this.C;A.URI.isUri(k)?(S.workspaces.delete(k),r&&S.workspaces.set(k,r)):(S.emptyWindows.delete(k),r&&S.emptyWindows.set(k,r)),l||this.M()}M(){const n={};for(const[l,k]of this.C.workspaces.entries())n[l.toString()]=k.id;const r={};for(const[l,k]of this.C.emptyWindows.entries())r[l.toString()]=k.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},l=this.D();if(n.workspaces)for(const[S,w]of Object.entries(n.workspaces)){const j=A.URI.parse(w);r[S]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}const k={};if(n.emptyWindows)for(const[S,w]of Object.entries(n.emptyWindows)){const j=A.URI.parse(w);k[S]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}return{workspaces:r,emptyWindows:k}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$6k=o,e.$6k=o=$e([se(0,u.$ai),se(1,a.$qk),se(2,v.$1k),se(3,b.$nj)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$7k=t}),define(ie[157],ne([0,1,19,9,20,7,4,2,12,3,11,94,21,27,37,5,32,26,22,23]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g,c,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=e.$Rp=e.$Qp=void 0;let h=class extends I.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,l,k,S,w){super(),this.z=n,this.C=r,this.D=l,this.F=k,this.G=S,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$Vd),this.s=this.B(new A.$Vd),this.t=this.B(new A.$Vd),this.u=this.B(new A.$Vd),this.w=this.B(new A.$Vd),this.y=[],this.B((0,I.$Rc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,$.$wo)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const k=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:S})=>(0,f.$1o)(S,n.identifier));if(k?.local)return k?.local;throw k?.error?k.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new $.$zo(b.localize(0,null),$.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(n.map(async({extension:k,options:S})=>{try{const w=await this.O(k,!!S?.installGivenVersion,!!S?.installPreReleaseVersion);l.push({...w,options:S})}catch(w){r.push({identifier:k.identifier,operation:2,source:k,error:w})}})),l.length&&r.push(...await this.I(l));for(const k of r)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!y.URI.isUri(k.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$9o)(k.source),error:k.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,v.$om)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const k of this.H.profiles){const S=(await this.getInstalled(1,k.extensionsResource)).find(w=>(0,f.$1o)(w.identifier,n.identifier));S?this.w.fire(S):this.u.fire({identifier:n.identifier,profileLocation:k.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async l=>{try{const k=await this.J(l,(S,w)=>n.some(j=>(0,f.$5o)(w.identifier.id)===(0,f.$6o)(j.manifest.publisher,j.manifest.name))?!1:this.L(S,w));r.push(...k)}catch(k){r.push({identifier:{id:(0,f.$6o)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:k})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:l},k){const S=l.isApplicationScoped||l.isBuiltin||(0,v.$om)(n),w={...l,installOnlyNewlyAddedFromExtensionPack:y.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:S,profileLocation:S?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},j=he=>`${f.$2o.create(he).toString()}${w.profileLocation?`-${w.profileLocation.toString()}`:""}`;if(!y.URI.isUri(r)){const he=this.j.get(j(r));if(he)return this.F.info("Extensions is already requested to install",r.identifier.id),await he.task.waitUntilTaskIsFinished(),[]}const B=[],te=[],Y=[],oe=this.Z(n,r,w);y.URI.isUri(r)||this.j.set(j(r),{task:oe,waitingTasks:[]}),this.n.fire({identifier:oe.identifier,source:r,profileLocation:w.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),B.push({task:oe,manifest:n});let re=!1;try{if(w.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",oe.identifier.id);else try{const ce=await this.N(oe.identifier,n,!!w.installOnlyNewlyAddedFromExtensionPack,!!w.installPreReleaseVersion,w.profileLocation),ae=await this.getInstalled(void 0,w.profileLocation),q={...w,donotIncludePackAndDependencies:!0,context:{...w.context,[$.$ro]:!0}};for(const{gallery:Q,manifest:U}of(0,L.$Mb)(ce,({gallery:T})=>T.identifier.id)){re=re||!!U.extensionDependencies?.some(X=>(0,f.$1o)({id:X},oe.identifier));const T=j(Q),H=this.j.get(T);if(H){if(k(oe,H.task)){const X=H.task.identifier;this.F.info("Waiting for already requested installing extension",X.id,oe.identifier.id),H.waitingTasks.push(oe),te.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,x=>x.some(K=>(0,f.$1o)(K.identifier,X)))).then(x=>{if(this.F.info("Finished waiting for already requested installing extension",X.id,oe.identifier.id),!x.find(F=>(0,f.$1o)(F.identifier,X))?.local)throw new Error(`Extension ${X.id} is not installed`)}))}}else if(!ae.some(({identifier:X})=>(0,f.$1o)(X,Q.identifier))){const X=this.Z(U,Q,q);this.j.set(T,{task:X,waitingTasks:[oe]}),this.n.fire({identifier:X.identifier,source:Q,profileLocation:w.profileLocation}),this.F.info("Installing extension:",X.identifier.id,oe.identifier.id),B.push({task:X,manifest:U})}}}catch(ce){if(y.URI.isUri(oe.source))(0,L.$Lb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",oe.identifier.id,ce.message),(0,L.$Lb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",oe.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",oe.identifier.id),ce}const he=B.reduce((ce,{task:ae,manifest:q})=>(ce.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:q}),ce),new Map);for(;he.size;){let ce;const ae=[...he.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(Q=>he.has(Q.toLowerCase())));ae.length?ce=he.size===1?ae:ae.filter(({task:q})=>!(q===oe&&!re)):(this.F.info("Found extensions with circular dependencies",ae.map(({task:q})=>q.identifier.id)),ce=[...he.values()]),await this.M(ce.map(async({task:q})=>{const Q=new Date().getTime();try{const U=await q.run();if(await this.M(this.y.map(T=>T.postInstall(U,q.source,w,R.CancellationToken.None))),!y.URI.isUri(q.source)){const T=q.operation===3,H=T?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(o(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$9o)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:H}),u.$o&&q.operation!==3)try{await this.z.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,"install")}catch{}}Y.push({local:U,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:U.isApplicationScoped})}catch(U){throw y.URI.isUri(q.source)||o(this.C,q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$9o)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-Q,error:U}),this.F.error("Error while installing the extension",q.identifier.id,(0,N.$0)(U)),U}finally{he.delete(q.identifier.id.toLowerCase())}}))}return te.length&&await this.M(te),Y.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),Y}catch(he){if(B.forEach(({task:ce})=>ce.cancel()),Y.length)try{const ce=await Promise.allSettled(Y.map(({local:ae})=>this.$(ae,{versionOnly:!0,profileLocation:w.profileLocation}).run()));for(let ae=0;ae<ce.length;ae++){const q=ce[ae],{identifier:Q}=Y[ae];q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Q.id):this.F.warn("Rollback: Error while uninstalling extension",Q.id,(0,N.$0)(q.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,N.$0)(ce),Y.map(({identifier:ae})=>ae.id))}return B.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:w.context,profileLocation:w.profileLocation,error:he}))}finally{for(const{task:he}of B)he.source&&!y.URI.isUri(he.source)&&this.j.delete(j(he.source))}}L(n,r){for(const[,{task:l,waitingTasks:k}]of this.j.entries())if(l===n&&(k.includes(r)||k.some(S=>this.L(S,r)))||l===r&&k[0]&&!this.L(n,k[0]))return!1;return!0}async M(n){const r=[],l=[],k=await Promise.allSettled(n);for(const S of k)S.status==="fulfilled"?r.push(S.value):l.push(S.reason);if(l.length)throw m(l);return r}async N(n,r,l,k,S){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,S),j=[],B=[],te=async(Y,oe)=>{j.push(Y);const re=oe.extensionDependencies||[],he=[...re];if(oe.extensionPack){const ce=l?w.find(ae=>(0,f.$1o)(ae.identifier,Y)):void 0;for(const ae of oe.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,f.$1o)({id:q},{id:ae}))||he.every(q=>!(0,f.$1o)({id:q},{id:ae}))&&he.push(ae)}if(he.length){const ce=he.filter(ae=>j.every(q=>!(0,f.$1o)(q,{id:ae})));if(ce.length){const ae=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:k})),R.CancellationToken.None);for(const q of ae){if(j.find(T=>(0,f.$1o)(T,q.identifier)))continue;const Q=re.some(T=>(0,f.$1o)({id:T},q.identifier));let U;try{U=await this.O(q,!1,k)}catch(T){if(Q)throw T;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,N.$0)(T));continue}B.push({gallery:U.extension,manifest:U.manifest}),await te(U.extension.identifier,U.manifest)}}}};return await te(n,r),B}async O(n,r,l){let k;const S=await this.getExtensionsControlManifest();if(S.malicious.some(B=>(0,f.$1o)(n.identifier,B)))throw new $.$zo(b.localize(1,null,n.identifier.id),$.ExtensionManagementErrorCode.Malicious);const w=S.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!k)throw new $.$zo(b.localize(2,null,n.identifier.id,w.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const B=await this.getTargetPlatform();throw new $.$zo(b.localize(3,null,n.identifier.id,this.G.nameLong,(0,$.$so)(B)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(n,r,l),!k)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],R.CancellationToken.None))[0]?new $.$zo(b.localize(4,null,n.displayName??n.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$zo(b.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),$.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const j=await this.z.getManifest(k,R.CancellationToken.None);if(j===null)throw new $.$zo(`Missing manifest for extension ${k.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(j.version!==k.version)throw new $.$zo(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:j}}async P(n,r,l){const k=await this.getTargetPlatform();let S=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(S=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(n,l,k)&&(S=n),S||(r?S=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(n,l,k)),S}async Q(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},k=Y=>`${Y.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,S=this.m.get(k(n.identifier));if(S)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),S.waitUntilTaskIsFinished();const w=Y=>{const oe=this.$(Y,l);return this.m.set(k(oe.extension.identifier),oe),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this.t.fire({identifier:Y.identifier,profileLocation:l.profileLocation,applicationScoped:Y.isApplicationScoped}),oe},j=(Y,oe)=>{oe?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,l.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,oe.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$8o)(Y),error:oe}),this.u.fire({identifier:Y.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:Y.isApplicationScoped})},B=[],te=[];try{B.push(w(n));const Y=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const oe=this.U(n,Y);for(const re of oe)this.m.has(k(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):B.push(w(re))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(B.map(oe=>oe.extension),Y,n),await this.M(B.map(async oe=>{try{if(await oe.run(),await this.M(this.y.map(re=>re.postUninstall(oe.extension,l,R.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}j(oe.extension)}catch(re){const he=re instanceof $.$zo?re:new $.$zo((0,N.$0)(re),$.ExtensionManagementErrorCode.Internal);throw j(oe.extension,he),he}finally{te.push(oe)}}))}catch(Y){const oe=Y instanceof $.$zo?Y:new $.$zo((0,N.$0)(Y),$.ExtensionManagementErrorCode.Internal);for(const re of B){try{re.cancel()}catch{}te.includes(re)||j(re.extension,oe)}throw oe}finally{for(const Y of B)this.m.delete(k(Y.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}R(n,r,l){for(const k of n){const S=this.W(k,r);if(S.length){const w=S.filter(j=>!n.some(B=>(0,f.$1o)(B.identifier,j.identifier)));if(w.length)throw new Error(this.S(k,w,l))}}}S(n,r,l){return l===n?r.length===1?b.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const k=n.manifest.extensionPack?n.manifest.extensionPack:[];if(k.length){const S=r.filter(j=>!j.isBuiltin&&k.some(B=>(0,f.$1o)({id:B},j.identifier))),w=[];for(const j of S)w.push(...this.U(j,r,l));return[...S,...w]}return[]}W(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(k=>(0,f.$1o)({id:k},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Qp=h,e.$Qp=h=$e([se(0,$.$yo),se(1,c.$ul),se(2,p.$1k),se(3,E.$nj),se(4,g.$Fj),se(5,O.$3k)],h);function m(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$Rp=m;function s(i){if(i instanceof $.$zo)return i;const n=new $.$zo(i.message,$.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$Sp=s;function o(i,n,{extensionData:r,verificationStatus:l,duration:k,error:S,durationSinceUpdate:w}){let j,B;(0,a.$Qf)(l)&&(l===!0?l="Verified":(l===!1||(j=$.ExtensionManagementErrorCode.Signature,B=l),l="Unverified")),S&&(S instanceof $.$zo?(j=S.code,S.code===$.ExtensionManagementErrorCode.Signature&&(B=S.message)):j=$.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:l,success:!S,duration:k,errorcode:j,errorcodeDetail:B,durationSinceUpdate:w})}class t{constructor(){this.d=new D.$5g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Tg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Tg)(n=>new Promise((r,l)=>{const k=n.onCancellationRequested(()=>{k.dispose(),l(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$Tp=t}),define(ie[42],ne([0,1,9,14,2,4,31,11,21,27,13,10,5,23,22,3,7,26]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class O extends Error{constructor(t,i){super(t),this.code=i}}e.$Up=O,e.$Vp=(0,b.$6h)("IExtensionsProfileScannerService");let h=class extends R.$Tc{constructor(t,i,n,r,l,k){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=l,this.t=k,this.b=this.B(new N.$Vd),this.onAddExtensions=this.b.event,this.c=this.B(new N.$Vd),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$Vd),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$Vd),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,l=>{const k=[];for(const S of l)t.some(([w])=>(0,a.$1o)(w.identifier,S.identifier)&&w.manifest.version!==S.version)?n.push(S):k.push(S);for(const[S,w]of t){const j=k.findIndex(te=>(0,a.$1o)(te.identifier,S.identifier)&&te.version===S.manifest.version),B={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:w};j===-1?(r.push(B),k.push(B)):k.splice(j,1,B)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const l=[];for(const k of r){const S=t.find(([w])=>(0,a.$1o)(w.identifier,k.identifier)&&w.manifest.version===k.version);S&&(k.metadata={...k.metadata,...S[1]},n.push(k)),l.push(k)}return l}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const l=[];for(const k of r)(0,a.$1o)(k.identifier,t.identifier)?n.push(k):l.push(k);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],l;try{const k=await this.m.readFile(t);l=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,y.$Hk)(k)!==1)throw k;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new O((0,g.$0)(k),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let k=!1;for(const S of l){m(S)||this.w(t);let w;if((0,E.$If)(S.relativeLocation)&&S.relativeLocation)w=this.z(S.relativeLocation);else if((0,E.$If)(S.location))w=this.z(S.location),k=!0,S.relativeLocation=S.location,S.location=w.toJSON();else{w=I.URI.revive(S.location);const j=this.y(w);j&&(k=!0,S.relativeLocation=j)}r.push({identifier:S.identifier,location:w,version:S.version,metadata:S.metadata})}k&&await this.m.writeFile(t,D.$je.fromString(JSON.stringify(l)))}if(i){r=i(r);const k=r.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.y(S.location),metadata:S.metadata}));await this.m.writeFile(t,D.$je.fromString(JSON.stringify(k)))}return r})}w(t){const i=new O(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(l){if((0,y.$Hk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(k=>m(k))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$je.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,y.$Hk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,y.$Hk)(l)!==1&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,y.$Hk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$ah,this.h.set(t,i)),i}};e.$Wp=h,e.$Wp=h=$e([se(1,y.$qk),se(2,f.$3k),se(3,v.$1k),se(4,c.$ul),se(5,$.$nj)],h);function m(o){return(0,E.$Kf)(o)&&(0,u.$xo)(o.identifier)&&(s(o.location)||(0,E.$If)(o.location)&&o.location)&&((0,E.$Pf)(o.relativeLocation)||(0,E.$If)(o.relativeLocation))&&o.version&&(0,E.$If)(o.version)}function s(o){return o?(0,E.$If)(o.path)&&(0,E.$If)(o.scheme):!1}}),define(ie[52],ne([0,1,19,9,28,14,7,38,81,2,15,16,12,17,44,54,3,11,98,18,27,37,50,13,10,5,32,4,47,42,23,22,115]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g,c,p,O,h,m,s,o,t,i,n,r,l,k,S,w,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.Translations=void 0;var B;(function(ae){function q(Q,U){if(Q===U)return!0;const T=Object.keys(Q),H=new Set;for(const X of Object.keys(U))H.add(X);if(T.length!==H.size)return!1;for(const X of T){if(Q[X]!==U[X])return!1;H.delete(X)}return H.size===0}ae.equals=q})(B||(e.Translations=B={})),e.$Zp=(0,t.$6h)("IExtensionsScannerService");let te=class extends a.$Tc{constructor(q,Q,U,T,H,X,x,K,F,C,d,P){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=Q,this.r=U,this.s=T,this.t=H,this.u=X,this.w=x,this.y=K,this.z=F,this.C=C,this.D=d,this.F=P,this.g=this.B(new r.$Vd),this.onDidChangeCache=this.g.event,this.h=(0,f.$Hg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$_o)(this.w,this.y)),this.G}async scanAllExtensions(q,Q,U){const[T,H]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(Q)]),X=U?await this.scanExtensionsUnderDevelopment(q,[...T,...H]):[];return this.L(T,H,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const Q=[];Q.push(this.M(!!q.useCache,q.language)),Q.push(this.N(q.language,!!q.checkControlFile));const[U,T]=await Promise.all(Q);return this.J([...U,...T],0,q,!1)}async scanUserExtensions(q){const Q=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const U=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.P(Q,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,U),H=q.useCache&&!T.devMode&&T.excludeObsolete?this.m:this.n;let X;try{X=await H.scanExtensions(T)}catch(x){if(x instanceof k.$Up&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await H.scanExtensions(T);else throw x}return X=await this.J(X,1,q,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(q,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const U=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(T=>T.scheme===y.Schemas.file).map(async T=>{const H=await this.P(T,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(H)).map(x=>(x.type=Q.find(K=>(0,h.$1o)(K.identifier,x.identifier))?.type??x.type,this.n.validate(x,H)))}))).flat();return this.J(U,"development",q,!0)}return[]}async scanExistingExtension(q,Q,U){const T=await this.P(q,!1,Q,!0,U.language,!0,void 0),H=await this.n.scanExtension(T);return!H||!U.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(q,Q,U){const T=await this.P(q,!1,Q,!0,U.language,!0,void 0),H=await this.n.scanOneOrMultipleExtensions(T);return this.J(H,Q,U,!0)}async scanMetadata(q){const Q=(0,f.$Hg)(q,"package.json"),U=(await this.w.readFile(Q)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(q,Q){const U=(0,f.$Hg)(q,"package.json"),T=(await this.w.readFile(U)).value.toString(),H=JSON.parse(T);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,H.__metadata={...H.__metadata,...Q},await this.w.writeFile((0,f.$Hg)(q,"package.json"),N.$je.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$Up&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$je.fromString(JSON.stringify([])))}catch(Q){(0,o.$Hk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,Q,U,T){return U.includeAllVersions||(q=this.L(Q===0?q:void 0,Q===1?q:void 0,Q==="development"?q:void 0,await this.getTargetPlatform(),T)),U.includeInvalid||(q=q.filter(H=>H.isValid)),q.sort((H,X)=>{const x=b.$nc(H.location.fsPath),K=b.$nc(X.location.fsPath);return x<K?-1:x>K?1:0})}L(q,Q,U,T,H){const X=(K,F,C)=>{if(K.isValid&&!F.isValid)return!1;if(K.isValid===F.isValid){if(H&&v.gt(K.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(v.eq(K.manifest.version,F.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===T)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return C?this.y.warn(`Overwriting user extension ${K.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${F.location.path}.`),!0},x=new m.$nm;return q?.forEach(K=>{const F=x.get(K.identifier.id);(!F||X(F,K,!1))&&x.set(K.identifier.id,K)}),Q?.forEach(K=>{const F=x.get(K.identifier.id);if(!F&&q&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!F||X(F,K,!1))&&x.set(K.identifier.id,K)}),U?.forEach(K=>{const F=x.get(K.identifier.id);(!F||X(F,K,!0))&&x.set(K.identifier.id,K),x.set(K.identifier.id,K)}),[...x.values()]}async M(q,Q){this.y.trace("Started scanning system extensions");const U=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),H=await(q&&!U.devMode?this.j:this.n).scanExtensions(U);return this.y.trace("Scanned system extensions:",H.length),H}async N(q,Q){const U=this.z.isBuilt?[]:this.C.builtInExtensions;if(!U?.length)return[];this.y.trace("Started scanning dev system extensions");const T=Q?await this.O():{},H=[],X=c.URI.file(b.$hc(b.$jc(y.$og.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of U){const F=T[K.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":H.push((0,f.$Hg)(X,K.name));break;default:H.push(c.URI.file(F));break}}const x=await Promise.all(H.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",x.length),(0,L.$Hb)(x)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,Q,U,T,H,X,x){const K=await this.f(H??$.$w),F=await this.Q(q),C=Q&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,d=C?await this.Q(C):void 0;return new Y(q,F,C,d,Q,x,U,T,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,H,K)}async Q(q){try{const Q=await this.w.stat(q);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$1p=te,e.$1p=te=$e([se(4,S.$3k),se(5,k.$Vp),se(6,o.$qk),se(7,i.$nj),se(8,O.$ai),se(9,n.$Fj),se(10,w.$1k),se(11,t.$5h)],te);class Y{constructor(q,Q,U,T,H,X,x,K,F,C,d,P,z,M,W){this.location=q,this.mtime=Q,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=T,this.profile=H,this.profileScanOptions=X,this.type=x,this.excludeObsolete=K,this.validate=F,this.productVersion=C,this.productDate=d,this.productCommit=P,this.devMode=z,this.language=M,this.translations=W}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,Q){return(0,f.$Ag)(q.location,Q.location)&&q.mtime===Q.mtime&&(0,f.$Ag)(q.applicationExtensionslocation,Q.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&q.profile===Q.profile&&R.$zn(q.profileScanOptions,Q.profileScanOptions)&&q.type===Q.type&&q.excludeObsolete===Q.excludeObsolete&&q.validate===Q.validate&&q.productVersion===Q.productVersion&&q.productDate===Q.productDate&&q.productCommit===Q.productCommit&&q.devMode===Q.devMode&&q.language===Q.language&&B.equals(q.translations,Q.translations)}}e.$2p=Y;let oe=class extends a.$Tc{constructor(q,Q,U,T,H){super(),this.f=q,this.g=Q,this.h=U,this.j=T,this.m=H}async scanExtensions(q){const Q=q.profile?await this.r(q):await this.n(q);let U={};if(q.excludeObsolete&&q.type===1)try{const T=(await this.j.readFile(this.f)).value.toString();U=JSON.parse(T)}catch{}return(0,g.$Vf)(U)?Q:Q.filter(T=>!U[h.$2o.create(T).toString()])}async n(q){const Q=await this.j.resolve(q.location);if(!Q.children?.length)return[];const U=await Promise.all(Q.children.map(async T=>{if(!T.isDirectory||q.type===1&&(0,f.$Eg)(T.resource).indexOf(".")===0)return null;const H=new Y(T.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(H)}));return(0,L.$Hb)(U).sort((T,H)=>T.location.path<H.location.path?-1:1)}async r(q){let Q=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){Q=Q.filter(T=>!T.metadata?.isApplicationScoped);const U=await this.s(q.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,q);Q.push(...U)}return Q}async s(q,Q,U){const T=await this.g.scanProfileExtensions(q,U.profileScanOptions);if(!T.length)return[];const H=await Promise.all(T.map(async X=>{if(Q(X)){const x=new Y(X.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(x,X.metadata)}return null}));return(0,L.$Hb)(H)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,f.$Hg)(q.location,"package.json"))){const Q=await this.scanExtension(q);return Q?[Q]:[]}else return await this.scanExtensions(q)}catch(Q){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,A.$0)(Q)),[]}}async scanExtension(q,Q){try{let U=await this.scanExtensionManifest(q.location);if(U){U.publisher||(U.publisher=m.$hm),Q=Q??U.__metadata,delete U.__metadata;const T=(0,h.$6o)(U.publisher,U.name),H=Q?.id?{id:T,uuid:Q.id}:{id:T},X=Q?.isSystem?0:q.type,x=X===0||!!Q?.isBuiltin;U=await this.t(q.location,U,Y.createNlsConfiguration(q));const K={type:X,identifier:H,manifest:U,location:q.location,isBuiltin:x,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return q.validate?this.validate(K,q):K}}catch(U){q.type!==0&&this.m.error(U)}return null}validate(q,Q){let U=!0;const T=(0,s.$ep)(Q.productVersion,Q.productDate,Q.location,q.manifest,q.isBuiltin);for(const[H,X]of T)H===E.default.Error&&(U=!1,this.m.error(this.z(Q.location,X)));return q.isValid=U,q.validations=T,q}async scanExtensionManifest(q){const Q=(0,f.$Hg)(q,"package.json");let U;try{U=(await this.j.readFile(Q)).value.toString()}catch(H){return(0,o.$Hk)(H)!==1&&this.m.error(this.z(q,(0,p.localize)(0,null,Q.path,H.message))),null}let T;try{T=JSON.parse(U)}catch{const X=[];(0,I.$cn)(U,X);for(const x of X)this.m.error(this.z(q,(0,p.localize)(1,null,Q.path,x.offset,x.length,(0,u.$Xp)(x.error))));return null}return(0,I.$ln)(T)!=="object"?(this.m.error(this.z(q,(0,p.localize)(2,null,Q.path))),null):T}async t(q,Q,U){const T=await this.u(q,Q,U);if(T)try{const H=[],X=await this.w(T.default,H);if(H.length>0)return H.forEach(K=>{this.m.error(this.z(q,(0,p.localize)(3,null,T.default?.path,(0,u.$Xp)(K.error))))}),Q;if((0,I.$ln)(T)!=="object")return this.m.error(this.z(q,(0,p.localize)(4,null,T.default?.path))),Q;const x=T.values||Object.create(null);return(0,j.$Yp)(this.m,Q,x,X)}catch{}return Q}async u(q,Q,U){const T=(0,f.$Hg)(q,"package.nls.json"),H=(F,C)=>{C.forEach(d=>{this.m.error(this.z(q,(0,p.localize)(5,null,F?.path,(0,u.$Xp)(d.error))))})},X=F=>{this.m.error(this.z(q,(0,p.localize)(6,null,F?.path)))},x=`${Q.publisher}.${Q.name}`,K=U.translations[x];if(K)try{const F=c.URI.file(K),C=(await this.j.readFile(F)).value.toString(),d=[],P=(0,I.$cn)(C,d);return d.length>0?(H(F,d),{values:void 0,default:T}):(0,I.$ln)(P)!=="object"?(X(F),{values:void 0,default:T}):{values:P.contents?P.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.j.exists(T))return;let C;try{C=await this.y(q,U)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const d=(await this.j.readFile(C.localized)).value.toString(),P=[],z=(0,I.$cn)(d,P);return P.length>0?(H(C.localized,P),{values:void 0,default:C.original}):(0,I.$ln)(z)!=="object"?(X(C.localized),{values:void 0,default:C.original}):{values:z,default:C.original}}catch{return{values:void 0,default:C.original}}}}async w(q,Q){if(q)try{const U=(await this.j.readFile(q)).value.toString();return(0,I.$cn)(U,Q)}catch{}}y(q,Q){return new Promise((U,T)=>{const H=X=>{const x=(0,f.$Hg)(q,`package.nls.${X}.json`);this.j.exists(x).then(K=>{K&&U({localized:x,original:(0,f.$Hg)(q,"package.nls.json")});const F=X.lastIndexOf("-");F===-1?U({localized:(0,f.$Hg)(q,"package.nls.json"),original:null}):(X=X.substring(0,F),H(X))})};if(Q.devMode||Q.pseudo||!Q.language)return U({localized:(0,f.$Hg)(q,"package.nls.json"),original:null});H(Q.language)})}z(q,Q){return`[${q.path}]: ${Q}`}};oe=$e([se(1,k.$Vp),se(2,w.$1k),se(3,o.$qk),se(4,i.$nj)],oe);let re=class extends oe{constructor(q,Q,U,T,H,X,x){super(Q,T,H,X,x),this.G=q,this.H=U,this.D=this.B(new D.$4g(3e3)),this.F=this.B(new r.$Vd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const Q=this.M(q),U=await this.I(Q);if(this.C=q,U&&U.input&&Y.equals(U.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),U.result.map(H=>(H.location=c.URI.revive(H.location),H));const T=await super.scanExtensions(q);return await this.J(Q,{input:q,result:T}),T}async I(q){try{const Q=await this.j.readFile(q),U=JSON.parse(Q.value.toString());return{result:U.result,input:(0,l.$Ch)(U.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",q.path,(0,A.$0)(Q))}return null}async J(q,Q){try{await this.j.writeFile(q,N.$je.fromString(JSON.stringify(Q)))}catch(U){this.m.debug("Error while writing the extension cache file:",q.path,(0,A.$0)(U))}}async L(){if(!this.C)return;const q=this.M(this.C),Q=await this.I(q);if(!Q)return;const U=Q.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$zn(T,U))try{this.m.info("Invalidating Cache",U,T),await this.j.del(q),this.F.fire()}catch(H){this.m.error(H)}}M(q){const Q=this.N(q);return this.h.extUri.joinPath(Q.cacheHome,q.type===0?m.$gm:m.$fm)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(q.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};re=$e([se(2,S.$3k),se(3,k.$Vp),se(4,w.$1k),se(5,o.$qk),se(6,i.$nj)],re);function he(ae,q){const Q=(0,h.$4o)(ae.manifest.publisher,ae.manifest.name);return{id:Q,identifier:new m.$lm(Q),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:q,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$3p=he;class ce extends te{constructor(q,Q,U,T,H,X,x,K,F,C,d,P){super(q,Q,(0,f.$Hg)(U,".vscode-oss-dev","extensions","control.json"),T,H,X,x,K,F,C,d,P),this.R=(async()=>{if($.$z)try{const z=await this.w.readFile(c.URI.file($.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$4p=ce}),define(ie[158],ne([0,1,58,9,34,4,2,15,16,24,5,23]),function(J,e,L,D,R,N,A,I,u,a,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=void 0;let $=class extends A.$Tc{constructor(v,E){super(),this.b=v,this.f=E,this.a=new D.$_g(5)}async postUninstall(v){const E=this.g(v,"uninstall");E&&(this.f.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(E.script,"uninstall",E.args,!0,v),this.f.info("Finished running post uninstall script",v.identifier.id,v.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",v.identifier.id,v.manifest.version),this.f.error(g)}}));try{await a.Promises.rm(this.m(v))}catch(g){this.f.error("Error while removing extension storage path",v.identifier.id),this.f.error(g)}}g(v,E){const g=`vscode:${E}`;if(v.location.scheme===I.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[g]=="string"){const c=v.manifest.scripts[g].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(v.identifier.id,v.manifest.version,`${g} should be a node script`),null):{script:(0,u.$jc)(v.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(v,E,g,c,p){return new Promise((O,h)=>{const m=this.j(v,E,g,p);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?h(t):O(void 0)};m.on("error",t=>{o((0,R.$Qi)(t)||"Unknown")}),m.on("exit",(t,i)=>{o(t?`post-${E} process exited with code ${t}`:void 0)}),c&&(s=setTimeout(()=>{s=null,m.kill(),h("timed out")},5e3))})}j(v,E,g,c){const p={silent:!0,execArgv:void 0},O=(0,L.fork)(v,[`--type=extension-post-${E}`,...g],p);O.stdout.setEncoding("utf8"),O.stderr.setEncoding("utf8");const h=N.Event.fromNodeEventEmitter(O.stdout,"data"),m=N.Event.fromNodeEventEmitter(O.stderr,"data");h(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${E}`,t)),m(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${E}`,t));const s=N.Event.any(N.Event.map(h,t=>({data:`%c${t}`,format:[""]})),N.Event.map(m,t=>({data:`%c${t}`,format:["color: red"]})));return N.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),O}m(v){return(0,u.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};e.$6p=$,e.$6p=$=$e([se(0,b.$3k),se(1,y.$nj)],$)}),define(ie[159],ne([0,1,9,14,20,34,7,4,43,2,31,15,16,17,44,3,11,29,24,49,99,59,18,157,21,27,42,52,144,158,116,137,145,50,13,10,5,32,26,22,23]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g,c,p,O,h,m,s,o,t,i,n,r,l,k,S,w,j,B,te,Y,oe,re,he,ce,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.$0p=void 0,e.$0p=(0,Y.$7h)(t.$Ao);const q=".vsctmp";let Q=class extends o.$Qp{constructor(F,C,d,P,z,M,W,G,ee,ue,fe,ge){super(F,C,fe,d,ue,ge),this.fb=z,this.gb=M,this.hb=W,this.ib=ee,this.eb=new Map,this.rb=new y.$Bc;const we=this.B(G.createInstance(k.$6p));this.bb=this.B(G.createInstance(U,le=>we.postUninstall(le))),this.cb=this.B(new w.$8p(ge,ee,fe,this,this.F)),this.db=this.B(G.createInstance(l.$5p));const de=this.B(new j.$9p(this,this.fb,ge,M,fe,ee,d));this.B(de.onDidChangeExtensionsByAnotherSource(le=>this.qb(le))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$_o)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const C=await this.pb(F),d=await(0,O.zip)((0,f.$Hg)(this.db.extensionsDownloadDir,(0,c.$qg)()).fsPath,C);return g.URI.file(d)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:C,cleanup:d}=await this.lb(F),P=$.$kc(C.fsPath);try{return await(0,S.$7p)(P)}finally{await d()}}getInstalled(F,C=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(F??null,C)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.bb.scanUserExtensionAtLocation(F)}async install(F,C={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:d,cleanup:P}=await this.lb(F);try{const z=await(0,S.$7p)($.$kc(d.fsPath)),M=(0,i.$6o)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,B.$gp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,M,this.G.version));const G=(await this.I([{manifest:z,extension:d,options:C}])).find(({identifier:ee})=>(0,i.$1o)(ee,{id:M}));if(G?.local)return G.local;throw G?.error?G.error:(0,o.$Sp)(new Error(`Unknown error while installing extension ${M}`))}finally{await P()}}async installFromLocation(F,C){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const d=await this.bb.scanUserExtensionAtLocation(F);if(!d)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ub([[d,void 0]],C),this.F.info("Successfully installed extension",d.identifier.id,C.toString()),d}async installExtensionsFromProfile(F,C,d){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,C.toString(),d.toString());const P=(await this.bb.scanExtensions(1,C)).filter(z=>F.some(M=>(0,i.$1o)(M,z.identifier)));if(P.length){const z=await Promise.all(P.map(M=>this.bb.scanMetadata(M,C)));await this.ub(P.map((M,W)=>[M,z[W]]),d),this.F.info("Successfully installed extensions",P.map(M=>M.identifier.id),d.toString())}return P}async updateMetadata(F,C,d=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),C.isPreReleaseVersion&&(C.preRelease=!0),C.isMachineScoped===!1&&(C.isMachineScoped=void 0),C.isBuiltin===!1&&(C.isBuiltin=void 0),C.pinned===!1&&(C.pinned=void 0),F=await this.bb.updateMetadata(F,C,d),this.cb.invalidate(d),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const C=await this.getTargetPlatform(),[d]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:C,compatible:!0},R.CancellationToken.None);if(!d)throw new Error(h.localize(2,null));await this.bb.setUninstalled(F);try{await this.bb.removeUninstalledExtension(F)}catch(P){throw new Error(h.localize(3,null,(0,N.$Qi)(P)))}return this.installFromGallery(d)}ab(F,C,d,P){return this.bb.copyExtension(F,C,d,P)}copyExtensions(F,C){return this.bb.copyExtensions(F,C)}markAsUninstalled(...F){return this.bb.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(F){this.F.error(F)}}async download(F,C,d){const{location:P}=await this.db.download(F,C,!d);return P}async lb(F){if(F.scheme===b.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const C=(0,f.$Hg)(this.db.extensionsDownloadDir,(0,c.$qg)());return await this.hb.download(F,C),this.F.info("Downloaded extension to",C.toString()),{location:C,cleanup:async()=>{try{await this.ib.del(C)}catch(P){this.F.error(P)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(F,C,d){if(g.URI.isUri(C))return new X(F,C,d,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const P=i.$2o.create(C).toString();let z=this.eb.get(P);return z||(this.eb.set(P,z=new H(F,C,d,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(P))),z}$(F,C){return new x(F,C.profileLocation,this.gb)}async pb(F){const C=async P=>{let z=await p.Promises.readdir(P);z=z.map(G=>$.$jc(P,G));const M=await Promise.all(z.map(G=>p.Promises.stat(G)));let W=Promise.resolve([]);return M.forEach((G,ee)=>{const ue=z[ee];G.isFile()&&(W=W.then(fe=>[...fe,ue])),G.isDirectory()&&(W=W.then(fe=>C(ue).then(ge=>[...fe,...ge])))}),W};return(await C(F.location.fsPath)).map(P=>({path:`extension/${$.$lc(F.location.fsPath,P)}`,localPath:P}))}async qb({added:F,removed:C}){if(C){const d=F&&this.D.extUri.isEqual(C.profileLocation,F.profileLocation)?C.extensions.filter(P=>F.extensions.every(z=>!(0,i.$1o)(z,P))):C.extensions;for(const P of d)this.F.info("Extensions removed from another source",P.id,C.profileLocation.toString()),this.u.fire({identifier:P,profileLocation:C.profileLocation})}if(F){const P=(await this.bb.scanExtensions(1,F.profileLocation)).filter(z=>F.extensions.some(M=>(0,i.$1o)(M,z.identifier)));this.s.fire(P.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,F.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:F.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(C=>this.rb.add(C)));const F=await this.ib.resolve(this.fb.userExtensionsLocation);for(const C of F.children??[])C.isDirectory&&this.rb.add(C.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(C=>this.tb(C)))}async tb(F){if(!F.affects(this.fb.userExtensionsLocation,1))return;const C=[];for(const d of F.rawAdded){if(this.rb.has(d)||!this.D.extUri.isEqual(this.D.extUri.dirname(d),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(d,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(d).startsWith(".")||!(await this.ib.stat(d)).isDirectory)continue;const P=await this.bb.scanUserExtensionAtLocation(d);P&&P.installedTimestamp===void 0&&(this.rb.add(d),C.push(P))}C.length&&(await this.ub(C.map(d=>[d,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",C.map(d=>d.identifier.id)))}async ub(F,C){const d=F.map(P=>P[0]);await this.vb(d),await this.gb.addExtensionsToProfile(F,C),this.s.fire(d.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:C})))}async vb(F){const C=await this.bb.getUninstalledExtensions();for(const d of F){const P=i.$2o.create(d);C[P.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",P.id),await this.bb.setInstalled(P),this.F.info("Removed the extension from uninstalled list:",P.id))}}};e.$$p=Q,e.$$p=Q=$e([se(0,t.$yo),se(1,he.$ul),se(2,oe.$nj),se(3,s.$bi),se(4,r.$Zp),se(5,n.$Vp),se(6,m.$do),se(7,Y.$5h),se(8,te.$qk),se(9,re.$Fj),se(10,ce.$1k),se(11,ae.$3k)],Q);let U=class extends a.$Tc{constructor(F,C,d,P,z,M){super(),this.j=F,this.m=C,this.n=d,this.s=P,this.t=z,this.u=M,this.h=this.B(new I.$Vd),this.onExtract=this.h.event,this.c=(0,f.$Hg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$ah}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,C){const d={includeInvalid:!0,profileLocation:C};let P=[];return F===null||F===0?P.push(...await this.n.scanAllExtensions({includeInvalid:!0},d,!1)):F===1&&P.push(...await this.n.scanUserExtensions(d)),P=F!==null?P.filter(z=>z.type===F):P,Promise.all(P.map(z=>this.F(z)))}async scanAllUserExtensions(F){const C=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(C.map(d=>this.F(d)))}async scanUserExtensionAtLocation(F){try{const C=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(C)return await this.F(C)}catch(C){this.u.error(C)}return null}async extractUserExtension(F,C,d,P,z){const M=F.toString(),W=g.URI.file($.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$qg)()}`)),G=g.URI.file($.$jc(this.n.userExtensionsLocation.fsPath,M));let ee=await this.m.exists(G);if(ee&&P){try{await this.y(F.id,G,"removeExisting")}catch{throw new t.$zo(h.localize(4,null,G.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}ee=!1}if(!ee)try{try{this.u.trace(`Started extracting the extension from ${C} to ${G.fsPath}`),await(0,O.$Op)(C,W.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${G}:`,F.id)}catch(ue){let fe=t.ExtensionManagementErrorCode.Extract;throw ue instanceof O.$Mp&&(ue.type==="CorruptZip"?fe=t.ExtensionManagementErrorCode.CorruptZip:ue.type==="Incomplete"&&(fe=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$zo(ue.message,fe)}await this.n.updateMetadata(W,d);try{this.u.trace(`Started renaming the extension from ${W.fsPath} to ${G.fsPath}`),await this.C(W.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ue){if(ue.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ue)}. Deleted from extracted location`,W),ue}this.h.fire(G)}catch(ue){try{await this.m.del(W,{recursive:!0})}catch{}throw ue}return this.D(G,1)}async scanMetadata(F,C){return C?(await this.w(F,C))?.metadata:this.n.scanMetadata(F.location)}async w(F,C){return(await this.s.scanProfileExtensions(C)).find(P=>(0,i.$1o)(P.identifier,F.identifier))}async updateMetadata(F,C,d){return d?await this.s.updateMetadata([[F,C]],d):await this.n.updateMetadata(F.location,C),this.D(F.location,F.type,d)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const C=F.map(d=>i.$2o.create(d));await this.z(d=>C.forEach(P=>{d[P.toString()]=!0,this.u.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(F){await this.z(C=>delete C[F.toString()])}async removeExtension(F,C){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,C)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(C=>delete C[i.$2o.create(F).toString()])}async copyExtension(F,C,d,P){const z=await this.w(F,C),M=await this.w(F,d);return P={...z?.metadata,...P},M?await this.s.updateMetadata([[F,{...M.metadata,...P}]],d):await this.s.addExtensionsToProfile([[F,P]],d),this.D(F.location,F.type,d)}async copyExtensions(F,C){const d=await this.scanExtensions(1,F),P=await Promise.all(d.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,F)]));await this.s.addExtensionsToProfile(P,C)}async y(F,C,d){this.u.trace(`Deleting ${d} extension from disk`,F,C.fsPath);const P=this.t.extUri.joinPath(this.t.extUri.dirname(C),`${this.t.extUri.basename(C)}.${(0,u.$Ti)((0,c.$qg)()).toString(16)}${q}`);await this.C(C.fsPath,P.fsPath),await this.m.del(P,{recursive:!0}),this.u.info(`Deleted ${d} extension from disk`,F,C.fsPath)}async z(F){return this.g.queue(async()=>{let C;try{C=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,te.$Hk)(P)!==1)throw P}let d={};if(C)try{d=JSON.parse(C)}catch{}return F&&(F(d),Object.keys(d).length?await this.m.writeFile(this.c,D.$je.fromString(JSON.stringify(d))):await this.m.del(this.c)),d})}async C(F,C){try{await p.Promises.rename(F,C,2*60*1e3)}catch(d){throw new t.$zo(d.message||h.localize(5,null,F,C),d.code||t.ExtensionManagementErrorCode.Rename)}}async D(F,C,d){if(d){const z=(await this.n.scanUserExtensions({profileLocation:d})).find(M=>this.t.extUri.isEqual(M.location,F));if(z)return this.F(z)}else{const P=await this.n.scanExistingExtension(F,C,{includeInvalid:!0});if(P)return this.F(P)}throw new Error(h.localize(6,null,F.path))}async F(F){const C=await this.m.resolve(F.location);let d,P;return C.children&&(d=C.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,P=C.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:d,changelogUrl:P,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const C=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),d=new Set;for(const z of C)F[i.$2o.create(z).toString()]||d.add(z.identifier.id.toLowerCase());try{const z=(0,i.$7o)(C,M=>M.identifier);await L.Promises.settled(z.map(async M=>{const W=M.sort((G,ee)=>v.rcompare(G.manifest.version,ee.manifest.version))[0];d.has(W.identifier.id.toLowerCase())||await this.j(await this.F(W))}))}catch(z){this.u.error(z)}const P=C.filter(z=>z.metadata&&F[i.$2o.create(z).toString()]);await Promise.allSettled(P.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(C){(0,te.$Hk)(C)!==1&&this.u.error(C);return}if(F?.children)try{await Promise.allSettled(F.children.map(async C=>{if(!(!C.isDirectory||!C.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",C.resource.toString());try{await this.m.del(C.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",C.resource.toString())}catch(d){(0,te.$Hk)(d)!==1&&this.u.error(d)}}}))}catch{}}};e.$_p=U,e.$_p=U=$e([se(1,te.$qk),se(2,r.$Zp),se(3,n.$Vp),se(4,ce.$1k),se(5,oe.$nj)],U);class T extends o.$Tp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,E.$Pf)(this.options.operation)?this.l:this.options.operation}constructor(F,C,d,P,z,M,W,G,ee){super(),this.identifier=F,this.source=C,this.options=d,this.m=P,this.n=z,this.o=M,this.p=W,this.q=G,this.s=ee,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[C,d]=await this.x(F);return this.j=C.isBuiltin||C.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[C,d]],this.j),C}async u({zipPath:F,key:C,metadata:d},P,z){let M=await this.v(C);return M||(this.s.trace("Extracting extension...",C.id),M=await this.m.extractUserExtension(C,F,d,P,z),this.s.info("Extracting extension completed.",C.id)),M}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(P=>i.$2o.create(P).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class H extends T{constructor(F,C,d,P,z,M,W,G,ee,ue){super(C.identifier,C,d,z,M,W,G,ee,ue),this.y=C,this.z=P}async x(F){const d=(await this.m.scanExtensions(null,this.options.profileLocation)).find(W=>(0,i.$1o)(W.identifier,this.y.identifier));d&&(this.l=3);const P={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||d?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||d?.isMachineScoped,isBuiltin:this.options.isBuiltin||d?.isBuiltin,isSystem:d?.type===0?!0:void 0,updated:!!d,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??d?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,E.$Of)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:d?.preRelease)};if(d?.manifest.version===this.y.version)return[await this.m.updateMetadata(d,P),P];const{location:z,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.$2o.create(this.y),metadata:P},!1,F),P]}catch(W){try{await this.z.delete(z)}catch(G){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,A.$0)(G))}throw W}}async B(F){try{await(0,S.$7p)(F)}catch(C){throw new t.$zo((0,o.$Rp)(C).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$aq=H;class X extends T{constructor(F,C,d,P,z,M,W,G,ee,ue){super({id:(0,i.$6o)(F.publisher,F.name)},C,d,z,M,W,G,ee,ue),this.y=F,this.z=C,this.A=P}async h(F){const C=await super.h(F);return this.D(C,F),C}async x(F){const C=new i.$2o(this.identifier,this.y.version),P=(await this.m.scanExtensions(1,this.options.profileLocation)).find(W=>(0,i.$1o)(this.identifier,W.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned};if(P)if(this.l=3,C.equals(new i.$2o(P.identifier,P.manifest.version)))try{await this.m.removeExtension(P,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&v.gt(P.manifest.version,this.y.version)&&await this.m.setUninstalled(P);else{const W=await this.v(C);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:$.$kc(this.z.fsPath),key:C,metadata:z},!0,F),z]}async D(F,C){try{let[d]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],C);if(d||([d]=await this.A.getExtensions([{id:F.identifier.id}],C)),d){const P={id:d.identifier.uuid,publisherDisplayName:d.publisherDisplayName,publisherId:d.publisherId,isPreReleaseVersion:d.properties.isPreReleaseVersion,preRelease:d.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,P,this.options.profileLocation)}}catch{}}}class x extends o.$Tp{constructor(F,C,d){super(),this.extension=F,this.j=C,this.k=d}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ie[160],ne([0,1,5,23,22,26,42,13,18,11]),function(J,e,L,D,R,N,A,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=void 0;let y=class extends A.$Wp{constructor($,f,v,E,g,c){super(a.URI.file($.extensionsPath),f,v,E,g,c)}};e.$tO=y,e.$tO=y=$e([se(0,u.$bi),se(1,I.$qk),se(2,D.$3k),se(3,R.$1k),se(4,N.$ul),se(5,L.$nj)],y)}),define(ie[161],ne([0,1,11,18,42,52,13,10,5,32,22,23]),function(J,e,L,D,R,N,A,I,u,a,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P$b=void 0;let $=class extends N.$4p{constructor(v,E,g,c,p,O,h,m){super(L.URI.file(p.builtinExtensionsPath),L.URI.file(p.extensionsPath),p.userHome,v.defaultProfile,v,E,g,c,p,O,h,m)}};e.$P$b=$,e.$P$b=$=$e([se(0,b.$3k),se(1,R.$Vp),se(2,A.$qk),se(3,u.$nj),se(4,D.$bi),se(5,a.$Fj),se(6,y.$1k),se(7,I.$5h)],$)}),define(ie[162],ne([0,1,9,4,2,127,3,88,10,23]),function(J,e,L,D,R,N,A,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$up=e.$tp=e.$sp=void 0,e.$sp="__$__isNewStorageMarker",e.$tp="__$__targetStorageMarker",e.$up=(0,u.$6h)("storageService");var y;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var b;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var $;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function f(p){const O=p.get(e.$tp);if(O)try{return JSON.parse(O)}catch{}return Object.create(null)}e.$vp=f;class v extends R.$Tc{static{this.a=60*1e3}constructor(O={flushInterval:v.a}){super(),this.m=O,this.b=this.B(new D.$Yd),this.c=this.B(new D.$Yd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Vd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(O,h,m){return D.Event.filter(this.b.event,s=>s.scope===O&&(h===void 0||s.key===h),m)}n(){this.j.value=(0,L.$jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(O,h){const{key:m,external:s}=h;if(m===e.$tp){switch(O){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:O})}else this.b.fire({scope:O,key:m,target:this.J(O)[m],external:s})}w(O){this.f.fire({reason:O})}get(O,h,m){return this.P(h)?.get(O,m)}getBoolean(O,h,m){return this.P(h)?.getBoolean(O,m)}getNumber(O,h,m){return this.P(h)?.getNumber(O,m)}getObject(O,h,m){return this.P(h)?.getObject(O,m)}storeAll(O,h){this.y(()=>{for(const m of O)this.store(m.key,m.value,m.scope,m.target,h)})}store(O,h,m,s,o=!1){if((0,A.$Rf)(h)){this.remove(O,m,o);return}this.y(()=>{this.z(O,m,s),this.P(m)?.set(O,h,o)})}remove(O,h,m=!1){this.y(()=>{this.z(O,h,void 0),this.P(h)?.delete(O,m)})}y(O){this.b.pause(),this.c.pause();try{O()}finally{this.b.resume(),this.c.resume()}}keys(O,h){const m=[],s=this.J(O);for(const o of Object.keys(s))s[o]===h&&m.push(o);return m}z(O,h,m,s=!1){const o=this.J(h);typeof m=="number"?o[O]!==m&&(o[O]=m,this.P(h)?.set(e.$tp,JSON.stringify(o),s)):typeof o[O]=="number"&&(delete o[O],this.P(h)?.set(e.$tp,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(O){switch(O){case-1:return this.I;case 0:return this.G;default:return this.D}}L(O){const h=this.P(O);return h?f(h):Object.create(null)}isNew(O){return this.getBoolean(e.$sp,O)===!0}async flush(O=y.NONE){this.f.fire({reason:O});const h=this.P(-1),m=this.P(0),s=this.P(1);switch(O){case y.NONE:await L.Promises.settled([h?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await L.Promises.settled([h?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const O=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,m=this.P(1)?.items??new Map;return c(O,h,m,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(O){return await this.flush(),this.P(O)?.optimize()}async switch(O,h){return this.w(y.NONE),(0,a.$2k)(O)?this.R(O,h):this.S(O,h)}M(O,h){return!(O.id===h.id||E(h)&&E(O))}N(O,h,m){this.y(()=>{const s=new Set;for(const[o,t]of O)s.add(o),h.get(o)!==t&&this.u(m,{key:o,external:!0});for(const[o]of h.items)s.has(o)||this.u(m,{key:o,external:!0})})}}e.$wp=v;function E(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.$xp=E;class g extends v{constructor(){super(),this.U=this.B(new I.$qp(new I.$rp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$qp(new I.$rp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$qp(new I.$rp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(O=>this.u(1,O))),this.B(this.W.onDidChangeStorage(O=>this.u(0,O))),this.B(this.U.onDidChangeStorage(O=>this.u(-1,O)))}P(O){switch(O){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(O){switch(O){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(O){return!1}}e.$yp=g;async function c(p,O,h,m,s,o){const t=B=>{try{return JSON.parse(B)}catch{return B}},i=new Map,n=new Map;p.forEach((B,te)=>{i.set(te,B),n.set(te,t(B))});const r=new Map,l=new Map;O.forEach((B,te)=>{r.set(te,B),l.set(te,t(B))});const k=new Map,S=new Map;h.forEach((B,te)=>{k.set(te,B),S.set(te,t(B))}),console.group(m!==s?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const w=[];if(i.forEach((B,te)=>{w.push({key:te,value:B})}),console.table(w),console.groupEnd(),console.log(n),m!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const B=[];r.forEach((te,Y)=>{B.push({key:Y,value:te})}),console.table(B),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const j=[];k.forEach((B,te)=>{j.push({key:te,value:B})}),console.table(j),console.groupEnd(),console.log(S)}e.$zp=c}),define(ie[163],ne([0,1,19,20,7,12,35,3,11,25,18,21,27,50,13,5,32,45,146,162,26,176]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g,c,p,O,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=void 0;const s=N.$o?"web":(0,b.$uo)(N.$u,A.$ec),o="X-Market-Search-Activity-Id";var t;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...P){return String(P.reduce((z,M)=>z|M,0))}var n;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(z=S){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,M=this.d.pageSize){return new w({...this.d,pageNumber:z,pageSize:M})}withFilter(z,...M){const W=[...this.d.criteria,...M.length?M.map(G=>({filterType:z,value:G})):[{filterType:z}]];return new w({...this.d,criteria:W})}withSortBy(z){return new w({...this.d,sortBy:z})}withSortOrder(z){return new w({...this.d,sortOrder:z})}withFlags(...z){return new w({...this.d,flags:z.reduce((M,W)=>M|W,0)})}withAssetTypes(...z){return new w({...this.d,assetTypes:z})}withSource(z){return new w({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:M,pageSize:W,sortBy:G,sortOrder:ee,flags:ue,assetTypes:fe}=this.d;return{filters:[{criteria:z,pageNumber:M,pageSize:W,sortBy:G,sortOrder:ee}],assetTypes:fe,flags:ue}}get searchText(){const z=this.d.criteria.filter(M=>M.filterType===n.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(P,z){const M=(P||[]).filter(W=>W.statisticName===z)[0];return M?M.value:0}function B(P){const z="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(W=>W.assetType.indexOf(z)===0).reduce((W,G)=>{const ee=oe(P,G.assetType);return ee&&W.push([G.assetType.substring(z.length),ee]),W},[])}function te(P){if(P.properties){const z=P.properties.filter(G=>G.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=z.filter(G=>M.test(G.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return oe(P,r.Repository)}function Y(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function oe(P,z){return P.files.filter(W=>W.assetType===z)[0]?{uri:`${P.assetUri}/${z}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${z}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function re(P,z){const M=P.properties?P.properties.filter(G=>G.key===z):[],W=M.length>0&&M[0].value;return W?W.split(",").map(G=>(0,$.$5o)(G)):[]}function he(P){const z=P.properties?P.properties.filter(M=>M.key===l.Engine):[];return z.length>0&&z[0].value||""}function ce(P){const z=P.properties?P.properties.filter(M=>M.key===l.PreRelease):[];return z.length>0&&z[0].value==="true"}function ae(P){const z=P.properties?P.properties.filter(W=>W.key===l.LocalizedLanguages):[],M=z.length>0&&z[0].value||"";return M?M.split(","):[]}function q(P){return P.properties?.find(z=>z.key===l.SponsorLink)?.value}function Q(P){return P.properties?.find(z=>z.key===l.SupportLink)?.value}function U(P){return P.indexOf("preview")!==-1}function T(P){return P.targetPlatform?(0,b.$to)(P.targetPlatform):"undefined"}function H(P){const z=(0,L.$Mb)(P.versions.map(T)),M=!!P.tags?.includes(b.$oo),W=z.indexOf("web");return M?W===-1&&z.push("web"):W!==-1&&z.splice(W,1),z}function X(P,z){for(let M=0;M<P.length;M++){const W=P[M];if(W.version===P[M-1]?.version){let G=M;if(T(W)===z)for(;G>0&&P[G-1].version===W.version;)G--;G!==M&&(P.splice(M,1),P.splice(G,0,W))}}return P}e.$Cp=X;function x(P,z,M){P.telemetryData={index:z,querySource:M,queryActivityId:P.queryContext?.[o]}}function K(P,z,M,W){const G=P.versions[0],ee={manifest:oe(z,r.Manifest),readme:oe(z,r.Details),changelog:oe(z,r.Changelog),license:oe(z,r.License),repository:te(z),download:Y(z),icon:oe(z,r.Icon),signature:oe(z,r.Signature),coreTranslations:B(z)};return{identifier:{id:(0,$.$6o)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:z.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(G),description:P.shortDescription||"",installCount:j(P.statistics,"install"),rating:j(P.statistics,"averagerating"),ratingCount:j(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:M,assets:ee,properties:{dependencies:re(z,l.Dependency),extensionPack:re(z,l.ExtensionPack),engine:he(z),localizedLanguages:ae(z),targetPlatform:T(z),isPreReleaseVersion:ce(z)},hasPreReleaseVersion:ce(G),hasReleaseVersion:!0,preview:U(P.flags),isSigned:!!ee.signature,queryContext:W,supportLink:Q(G)}}let F=class{constructor(z,M,W,G,ee,ue,fe,ge){this.k=M,this.l=W,this.n=G,this.o=ee,this.q=ue,this.u=fe,this.w=ge;const we=fe.extensionsGallery,de=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=de?we.servicePPEUrl:we?.serviceUrl,this.g=de?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,p.$Bp)(fe.version,fe,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,M,W){const G=D.CancellationToken.isCancellationToken(M)?{}:M,ee=D.CancellationToken.isCancellationToken(M)?M:W,ue=[],fe=[],ge=[],we=[];let de=!0;for(const ve of z){ve.uuid?fe.push(ve.uuid):ue.push(ve.id);const ke=!!(ve.version||ve.preRelease);ge.push({id:ve.id,uuid:ve.uuid,includePreRelease:ke}),ve.version&&we.push({id:ve.id,uuid:ve.uuid,version:ve.version}),de=de&&!!ve.hasPreRelease&&!ke}if(!fe.length&&!ue.length)return[];let le=new w().withPage(1,z.length);fe.length&&(le=le.withFilter(n.ExtensionId,...fe)),ue.length&&(le=le.withFilter(n.ExtensionName,...ue)),(G.queryAllVersions||de)&&(le=le.withFlags(le.flags,t.IncludeVersions)),G.source&&(le=le.withSource(G.source));const{extensions:pe}=await this.z(le,{targetPlatform:G.targetPlatform??s,includePreRelease:ge,versions:we,compatible:!!G.compatible},ee);return G.source&&pe.forEach((ve,ke)=>x(ve,ke,G.source)),pe}async getCompatibleExtension(z,M,W){if((0,b.$vo)(z.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(z,M,W))return z;const G=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,z.identifier.uuid),{extensions:ee}=await this.z(G,{targetPlatform:W,compatible:!0,includePreRelease:M},D.CancellationToken.None);return ee[0]||null}async isExtensionCompatible(z,M,W){if(!(0,b.$wo)(z.properties.targetPlatform,z.allTargetPlatforms,W)||!M&&z.properties.isPreReleaseVersion)return!1;let G=z.properties.engine;if(!G){const ee=await this.getManifest(z,D.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");G=ee.engines.vscode}return(0,f.$gp)(G,this.u.version,this.u.date)}async y(z,M,W,G,ee){if(!(0,b.$wo)(T(z),G,ee)||M!=="any"&&ce(z)!==(M==="prerelease"))return!1;if(W)try{const ue=await this.E(z);if(!(0,f.$gp)(ue,this.u.version,this.u.date))return!1}catch(ue){return this.l.error(`Error while getting the engine for the version ${z.version}.`,(0,R.$0)(ue)),!1}return!0}async query(z,M){let W=z.text||"";const G=z.pageSize??50;let ee=new w().withPage(1,G);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,le,pe)=>(ee=ee.withFilter(n.Category,pe||le),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,le,pe)=>(ee=ee.withFilter(n.Tag,pe||le),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(n.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),ee=ee.withFilter(n.SearchText,W)),ee=ee.withSortBy(0)):z.ids?ee=ee.withFilter(n.ExtensionId,...z.ids):z.names?ee=ee.withFilter(n.ExtensionName,...z.names):ee=ee.withSortBy(4),typeof z.sortBy=="number"&&(ee=ee.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(ee=ee.withSortOrder(z.sortOrder)),z.source&&(ee=ee.withSource(z.source));const ue=async(de,le)=>{const{extensions:pe,total:ve}=await this.z(de,{targetPlatform:s,compatible:!1,includePreRelease:!!z.includePreRelease},le);return pe.forEach((ke,Re)=>x(ke,(de.pageNumber-1)*de.pageSize+Re,z.source)),{extensions:pe,total:ve}},{extensions:fe,total:ge}=await ue(ee,M),we=async(de,le)=>{if(le.isCancellationRequested)throw new R.$5;const{extensions:pe}=await ue(ee.withPage(de+1),le);return pe};return{firstPage:fe,total:ge,pageSize:ee.pageSize,getPage:we}}async z(z,M,W){const G=z.flags;z.flags&t.IncludeLatestVersionOnly&&z.flags&t.IncludeVersions&&(z=z.withFlags(z.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(z.flags&t.IncludeLatestVersionOnly)&&!(z.flags&t.IncludeVersions)&&(z=z.withFlags(z.flags,t.IncludeLatestVersionOnly)),M.versions?.length&&(z=z.withFlags(z.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),z=z.withFlags(z.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ee,total:ue,context:fe}=await this.B(z,W);if(!(z.flags&t.IncludeLatestVersionOnly)){const le=[];for(const pe of ee){const ve=await this.A(pe,M,fe);ve&&le.push(ve)}return{extensions:le,total:ue}}const we=[],de=new Map;for(let le=0;le<ee.length;le++){const pe=ee[le],ve={id:(0,$.$6o)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},ke=(0,I.$Of)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(V=>(0,$.$1o)(V,ve))?.includePreRelease;if(M.compatible&&(0,b.$vo)(H(pe),M.targetPlatform))continue;const Re=await this.A(pe,M,fe);!Re||Re.properties.isPreReleaseVersion&&(!ke||!Re.hasReleaseVersion)||!Re.properties.isPreReleaseVersion&&Re.properties.targetPlatform!==M.targetPlatform&&Re.hasPreReleaseVersion?de.set(pe.extensionId,le):we.push([le,Re])}if(de.size){const le=new m.$Rd,pe=new w().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,de.size).withFilter(n.ExtensionId,...de.keys()),{extensions:ve}=await this.z(pe,M,W);this.o.publicLog2("galleryService:additionalQuery",{duration:le.elapsed(),count:de.size});for(const ke of ve){const Re=de.get(ke.identifier.uuid);we.push([Re,ke])}}return{extensions:we.sort((le,pe)=>le[0]-pe[0]).map(([,le])=>le),total:ue}}async A(z,M,W){const G={id:(0,$.$6o)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},ee=M.versions?.find(we=>(0,$.$1o)(we,G))?.version,ue=(0,I.$Of)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(we=>(0,$.$1o)(we,G))?.includePreRelease,fe=H(z),ge=X(z.versions,M.targetPlatform);if(M.compatible&&(0,b.$vo)(fe,M.targetPlatform))return null;for(let we=0;we<ge.length;we++){const de=ge[we];if(!(ee&&de.version!==ee)){if(await this.y(de,ue?"any":"release",M.compatible,fe,M.targetPlatform))return K(z,de,fe,W);if(ee&&de.version===ee)return null}}return ee||M.compatible?null:K(z,z.versions[0],fe)}async B(z,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const W=await this.j,G=JSON.stringify(z.raw),ee={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},ue=new m.$Rd;let fe,ge,we=0;try{if(fe=await this.k.request({type:"POST",url:this.g&&z.criteria.some(le=>le.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:ee},M),fe.res.statusCode&&fe.res.statusCode>=400&&fe.res.statusCode<500)return{galleryExtensions:[],total:we};const de=await(0,c.$np)(fe);if(de){const le=de.results[0],pe=le.extensions,ve=le.resultMetadata&&le.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return we=ve&&ve.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:we,context:{[o]:fe.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(de){throw ge=de,de}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(G.length),duration:ue.elapsed(),success:!!fe&&(0,c.$jp)(fe),responseBodySize:fe?.res.headers["Content-Length"],statusCode:fe?String(fe.res.statusCode):void 0,errorCode:ge?(0,R.$4)(ge)?"canceled":(0,R.$0)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(we)})}}async reportStatistic(z,M,W,G){if(!this.isEnabled())return;const ee=N.$o?this.x(`/itemName/${z}.${M}/version/${W}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${M}/${W}/stats?statType=${G}`),ue=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:ue};try{await this.k.request({type:"POST",url:ee,headers:ge},D.CancellationToken.None)}catch{}}async download(z,M,W){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const G=(0,$.$9o)(z),ee=new Date().getTime(),ue=le=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:le}),fe=W===2?"install":W===3?"update":"",ge=fe?{uri:`${z.assets.download.uri}${u.URI.parse(z.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${z.assets.download.fallbackUri}${u.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:z.assets.download,we=z.queryContext?.[o]?{[o]:z.queryContext[o]}:void 0,de=await this.D(ge,we?{headers:we}:void 0);await this.q.writeFile(M,de.stream),ue(new Date().getTime()-ee)}async downloadSignatureArchive(z,M){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const W=await this.D(z.assets.signature);await this.q.writeFile(M,W.stream)}async getReadme(z,M){if(z.assets.readme){const W=await this.D(z.assets.readme,{},M);return await(0,c.$mp)(W)||""}return""}async getManifest(z,M){if(z.assets.manifest){const W=await this.D(z.assets.manifest,{},M),G=await(0,c.$mp)(W);return G?JSON.parse(G):null}return null}async C(z,M){const W=oe(z,r.Manifest);if(!W)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},ee=await this.D(W,{headers:G});return await(0,c.$np)(ee)}async getCoreTranslation(z,M){const W=z.assets.coreTranslations.filter(G=>G[0]===M.toUpperCase())[0];if(W){const G=await this.D(W[1]),ee=await(0,c.$mp)(G);return ee?JSON.parse(ee):null}return null}async getChangelog(z,M){if(z.assets.changelog){const W=await this.D(z.assets.changelog,{},M);return await(0,c.$mp)(W)||""}return""}async getAllCompatibleVersions(z,M,W){let G=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?G=G.withFilter(n.ExtensionId,z.identifier.uuid):G=G.withFilter(n.ExtensionName,z.identifier.id);const{galleryExtensions:ee}=await this.B(G,D.CancellationToken.None);if(!ee.length)return[];const ue=H(ee[0]);if((0,b.$vo)(ue,W))return[];const fe=[];await Promise.all(ee[0].versions.map(async de=>{try{await this.y(de,M?"any":"release",!0,ue,W)&&fe.push(de)}catch{}}));const ge=[],we=new Set;for(const de of X(fe,W))we.has(de.version)||(we.add(de.version),ge.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:ce(de)}));return ge}async D(z,M={},W=D.CancellationToken.None){const G=await this.j,ee={type:"GET"},ue={...G,...M.headers||{}};M={...M,...ee,headers:ue};const fe=z.uri,ge=z.fallbackUri,we={...M,url:fe};try{const de=await this.k.request(we,W);if(de.res.statusCode===200)return de;const le=await(0,c.$mp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${le}`)}catch(de){if((0,R.$4)(de))throw de;const le=(0,R.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{url:fe,message:le});const pe={...M,url:ge};return this.k.request(pe,W)}}async E(z){let M=he(z);if(!M){const W=await this.C(z,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");M=W.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,c.$np)(z),W=[],G={},ee=[];if(M){for(const ue of M.malicious)W.push({id:ue});if(M.migrateToPreRelease)for(const[ue,fe]of Object.entries(M.migrateToPreRelease))(!fe.engine||(0,f.$gp)(fe.engine,this.u.version,this.u.date))&&(G[ue.toLowerCase()]={disallowInstall:!0,extension:{id:fe.id,displayName:fe.displayName,autoMigrate:{storage:!!fe.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ue,fe]of Object.entries(M.deprecated))fe&&(G[ue.toLowerCase()]=(0,I.$Of)(fe)?{}:fe);if(M.search)for(const ue of M.search)ee.push(ue)}return{malicious:W,deprecated:G,search:ee}}};F=$e([se(1,c.$hp),se(2,E.$nj),se(3,y.$ai),se(4,h.$ul),se(5,v.$qk),se(6,g.$Fj),se(7,a.$zi)],F);let C=class extends F{constructor(z,M,W,G,ee,ue,fe,ge){super(z,M,W,G,ee,ue,fe,ge)}};e.$Dp=C,e.$Dp=C=$e([se(0,O.$up),se(1,c.$hp),se(2,E.$nj),se(3,y.$ai),se(4,h.$ul),se(5,v.$qk),se(6,g.$Fj),se(7,a.$zi)],C);let d=class extends F{constructor(z,M,W,G,ee,ue,fe){super(void 0,z,M,W,G,ee,ue,fe)}};e.$Ep=d,e.$Ep=d=$e([se(0,c.$hp),se(1,E.$nj),se(2,y.$ai),se(3,h.$ul),se(4,v.$qk),se(5,g.$Fj),se(6,a.$zi)],d)}),define(ie[164],ne([0,1,11,18,13,5,142,22,23,3,68]),function(J,e,L,D,R,N,A,I,u,a,y){"use strict";var b,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$sO=e.$rO=e.$qO=void 0;let f=class extends u.$6k{static{b=this}static{this.a="profileAssociationsMigration"}constructor(c,p,O,h,m){super(O,h,p,m),this.U=c,this.W=O}O(){return this.U.getItem(b.b,[]).map(p=>({...p,location:(0,a.$If)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):L.URI.revive(p.location)}))}Q(){const c=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$qO=f,e.$qO=f=b=$e([se(0,A.$lO),se(1,I.$1k),se(2,D.$bi),se(3,R.$qk),se(4,N.$nj)],f);let v=$=class extends f{constructor(c,p,O,h,m){super(c,p,O,h,m),this.$=c}P(c){c.length?this.$.setItem($.b,c.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem($.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem($.c,c):this.$.removeItem($.c)}Q(){const c="workspaceAndProfileInfo",p=this.$.getItem(c,void 0);if(p){this.$.removeItem(c);const h=p.reduce((m,{workspace:s,profile:o})=>(m[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),m),{});this.$.setItem($.c,{workspaces:h})}const O=super.Q();return this.$.getItem($.a,!1)||(this.R(O),this.$.setItem($.a,!0)),O}};e.$rO=v,e.$rO=v=$=$e([se(0,A.$mO),se(1,I.$1k),se(2,D.$bi),se(3,R.$qk),se(4,N.$nj)],v);let E=class extends v{constructor(c,p,O,h){super(new y.$pO(0,p,h,O),c,p,O,h)}async init(){return await this.$.init(),super.init()}};e.$sO=E,e.$sO=E=$e([se(0,I.$1k),se(1,D.$bi),se(2,R.$qk),se(3,N.$nj)],E)}),define(ie[165],ne([0,1,140,9,14,7,3,25,18,141,5,45,139,177]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;let v=class extends b.$ip{constructor(p,O,h,m){super(m),this.m=p,this.n=O,this.r=h,this.s(),this.B(p.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,O){const{f:h,g:m}=this;let s;try{s=await(0,a.$_l)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(i)))}const o={...process.env,...s},t=p.agent?p.agent:await(0,$.$mr)(p.url||"",o,{proxyUrl:h,strictSSL:m});return p.agent=t,p.strictSSL=m,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>g(p,O))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((O,h)=>{J(["@vscode/proxy-agent"],O,h)})).loadSystemCertificates({log:this.r})}};e.$nr=v,e.$nr=v=$e([se(0,I.$zi),se(1,u.$bi),se(2,y.$nj),se(3,y.$oj)],v);async function E(c){return((0,L.parse)(c.url).protocol==="https:"?await new Promise((h,m)=>{J(["https"],h,m)}):await new Promise((h,m)=>{J(["http"],h,m)})).request}async function g(c,p){return D.Promises.withAsyncBody(async(O,h)=>{const m=(0,L.parse)(c.url),s=c.getRawRequest?c.getRawRequest(c):await E(c),o={hostname:m.hostname,port:m.port?parseInt(m.port):m.protocol==="https:"?443:80,protocol:m.protocol,path:m.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$Of)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(o.auth=c.user+":"+c.password);const t=s(o,i=>{const n=(0,A.$Mf)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)g({...c,url:i.headers.location,followRedirects:n-1},p).then(O,h);else{let r=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),O({res:i,stream:(0,R.$ye)(r)})}});t.on("error",h),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),p.onCancellationRequested(()=>{t.abort(),h(new N.$5)})})}e.$or=g}),define(ie[178],ne([0,1,33,9,34,7,2,15,16,12,35,11,24,25,136,59,138,18,114,163,21,64,143,42,52,159,161,13,126,128,51,124,62,63,147,5,132,39,133,150,32,45,165,68,69,26,149,41,151,152,22,154,23,164,153,160,129,131,6,155]),function(J,e,L,D,R,N,A,I,u,a,y,b,$,f,v,E,g,c,p,O,h,m,s,o,t,i,n,r,l,k,S,w,j,B,te,Y,oe,re,he,ce,ae,q,Q,U,T,H,X,x,K,F,C,d,P,z,M,W,G,ee,ue,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ge extends A.$Tc{constructor(le){super(),this.b=le,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[le,pe]=await this.f();return le.invokeFunction(async ve=>{const ke=ve.get(Y.$nj),Re=ve.get(r.$qk),V=ve.get(c.$bi),Z=ve.get(P.$3k);ke.info("CLI main",this.b),this.g(ke),await this.h(V,Re,Z,le),await Promise.all(pe.map(_=>{(0,D.$Xg)(_.flush(),1e3)}))})}async f(){const le=new j.$4h,pe={_serviceBrand:void 0,...ce.default};le.set(ae.$Fj,pe);const ve=new p.$Bm(this.b,pe);le.set(c.$bi,ve),await Promise.all([ve.appSettingsHome.with({scheme:I.Schemas.file}).fsPath,ve.extensionsPath].map(Le=>Le?$.Promises.mkdir(Le,{recursive:!0}):void 0));const ke=new ee.$kO((0,Y.$Bj)(ve),ve.logsHome);le.set(Y.$oj,ke);const Re=this.B(ke.createLogger("cli",{name:(0,ue.localize)(0,null)})),V=[];ke.getLogLevel()===Y.LogLevel.Trace&&V.push(new Y.$vj(ke.getLogLevel()));const Z=this.B(new G.$uO(Re,V));le.set(Y.$nj,Z);const _=this.B(new l.$cq(Z));le.set(r.$qk,_);const me=this.B(new k.$Bq(Z));_.registerProvider(I.Schemas.file,me);const ye=new d.$2r(_);le.set(C.$1k,ye);const De=new U.$oO(1,ve,Z,_),Se=new z.$qO(De,ye,ve,_,Z);le.set(P.$3k,Se),_.registerProvider(I.Schemas.vscodeUserData,new fe.$e_b(I.Schemas.file,me,I.Schemas.vscodeUserData,Se,ye,Z));const ze=a.$i&&pe.win32RegValueName?this.B(new he.$c_b(Z,pe.win32RegValueName)):ve.policyFile?this.B(new oe.$d_b(ve.policyFile,_,Z)):new re.$Ln;le.set(re.$Jn,ze);const Ie=this.B(new v.$_n(Se.defaultProfile.settingsResource,_,ze,Z));le.set(f.$zi,Ie),await Promise.all([De.init(),Ie.initialize()]);let Ne;try{Ne=await(0,M.$S$b)(De,Z)}catch(Le){Le.code!=="ENOENT"&&Z.error(Le)}const Te=await(0,M.$T$b)(De,Z);Se.init(),le.set(C.$1k,new d.$2r(_));const Oe=new Q.$nr(Ie,ve,Z,ke);le.set(q.$hp,Oe),le.set(E.$do,new S.$3h(g.$JO,void 0,!0)),le.set(o.$Vp,new S.$3h(W.$tO,void 0,!0)),le.set(t.$Zp,new S.$3h(n.$P$b,void 0,!0)),le.set(m.$Fp,new S.$3h(m.$Gp,void 0,!0)),le.set(i.$0p,new S.$3h(i.$$p,void 0,!0)),le.set(h.$yo,new S.$3h(O.$Ep,void 0,!0)),le.set(B.$hr,new S.$3h(te.$jr,void 0,!1));const Ae=[],Ce=(0,x.$Xo)(pe,Ie);if((0,x.$So)(pe,ve)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ae.push(new K.$iO(Oe,Ce,"monacoworkbench",null,pe.aiConfig.ariaKey));const Le={appenders:Ae,sendErrorTelemetry:!1,commonProperties:(0,T.$Io)((0,L.release)(),(0,L.hostname)(),process.arch,pe.commit,pe.version,Ne,Te,Ce),piiPaths:(0,x.$Yo)(ve)};le.set(H.$ul,new S.$3h(X.$pr,[Le],!1))}else le.set(H.$ul,x.$Mo);return[new w.$Eq(le),Ae]}g(le){(0,N.setUnexpectedErrorHandler)(pe=>{const ve=(0,R.$Qi)(pe,!0);ve&&le.error(`[uncaught exception in CLI]: ${ve}`)}),process.on("uncaughtException",pe=>{(0,N.$Z)(pe)||(0,N.$1)(pe)}),process.on("unhandledRejection",pe=>(0,N.$1)(pe))}async h(le,pe,ve,ke){let Re;if(le.args.profile&&(Re=ve.profiles.find(Z=>Z.name===le.args.profile),!Re))throw new Error(`Profile '${le.args.profile}' not found.`);const V=(Re??ve.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(s.$Hp,new Y.$vj(Y.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Z={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return ke.createInstance(s.$Hp,new Y.$vj(Y.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Z,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(s.$Hp,new Y.$vj(Y.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["update-extensions"])return ke.createInstance(s.$Hp,new Y.$vj(Y.LogLevel.Info,!1)).updateExtensions(V);if(this.b["locate-extension"])return ke.createInstance(s.$Hp,new Y.$vj(Y.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$A_b)(le.appRoot,le.extensionsPath))}}j(le){return le.map(pe=>/\.vsix$/i.test(pe)?b.URI.file((0,u.$ic)(pe)?pe:(0,u.$jc)((0,y.cwd)(),pe)):pe)}}async function we(de){const le=new ge(de);try{await le.run()}finally{le.dispose()}}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/81725794264e4c0fddbc1b3b728013744ae90840/core/vs/code/node/cliProcessMain.js.map
