/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],E=0,T=ge.length;E<T;E++)e[E]=Pe[ge[E]];return e};define(Pe[66],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function E(R){return($,g,b)=>{let A=null,D=null;if(typeof b.value=="function"?(A="value",D=b.value):typeof b.get=="function"&&(A="get",D=b.get),!D)throw new Error("not supported");b[A]=R(D,g)}}function T(R,$,g){let b=null,A=null;if(typeof g.value=="function"?(b="value",A=g.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(b="get",A=g.get),!A)throw new Error("not supported");const D=`$memoize$${$}`;g[b]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,u)}),this[D]}}e.$xh=T;function C(R,$,g){return E((b,A)=>{const D=`$debounce$${A}`,u=`$debounce$result$${A}`;return function(...p){this[u]||(this[u]=g?g():void 0),clearTimeout(this[D]),$&&(this[u]=$(this[u],...p),p=[this[u]]),this[D]=setTimeout(()=>{b.apply(this,p),this[u]=g?g():void 0},R)}})}e.$yh=C;function M(R,$,g){return E((b,A)=>{const D=`$throttle$timer$${A}`,u=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...s){if(this[u]||(this[u]=g?g():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),$&&(this[u]=$(this[u],...s)),this[w])return;const o=this[p]+R;o<=Date.now()?(this[p]=Date.now(),b.apply(this,[this[u]]),this[u]=g?g():void 0):(this[w]=!0,this[D]=setTimeout(()=>{this[w]=!1,this[p]=Date.now(),b.apply(this,[this[u]]),this[u]=g?g():void 0},o-Date.now()))}})}e.$zh=M}),define(Pe[89],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.$cN=void 0;class E{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$cN=E,e.$dN=new E("id#")}),define(Pe[119],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(i,l=!1){let r=0;const d=i.length;let m="",f=0,S=16,L=0;function v(z){let P=0,I=0;for(;P<z;){const H=i.charCodeAt(r);if(H>=48&&H<=57)I=I*16+H-48;else if(H>=65&&H<=70)I=I*16+H-65+10;else if(H>=97&&H<=102)I=I*16+H-97+10;else break;r++,P++}return P<z&&(I=-1),I}function y(z){r=z,m="",f=0,S=16,L=0}function k(){const z=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&b(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&b(i.charCodeAt(r)))for(r++;r<i.length&&b(i.charCodeAt(r));)r++;else return L=3,i.substring(z,r);let P=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&b(i.charCodeAt(r))){for(r++;r<i.length&&b(i.charCodeAt(r));)r++;P=r}else L=3;return i.substring(z,P)}function N(){let z="",P=r;for(;;){if(r>=d){z+=i.substring(P,r),L=2;break}const I=i.charCodeAt(r);if(I===34){z+=i.substring(P,r),r++;break}if(I===92){if(z+=i.substring(P,r),r++,r>=d){L=2;break}switch(i.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const ae=v(4);ae>=0?z+=String.fromCharCode(ae):L=4;break}default:L=5}P=r;continue}if(I>=0&&I<=31)if(g(I)){z+=i.substring(P,r),L=2;break}else L=6;r++}return z}function O(){if(m="",L=0,f=r,r>=d)return f=d,S=17;let z=i.charCodeAt(r);if($(z)){do r++,m+=String.fromCharCode(z),z=i.charCodeAt(r);while($(z));return S=15}if(g(z))return r++,m+=String.fromCharCode(z),z===13&&i.charCodeAt(r)===10&&(r++,m+=`
`),S=14;switch(z){case 123:return r++,S=1;case 125:return r++,S=2;case 91:return r++,S=3;case 93:return r++,S=4;case 58:return r++,S=6;case 44:return r++,S=5;case 34:return r++,m=N(),S=10;case 47:{const P=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<d&&!g(i.charCodeAt(r));)r++;return m=i.substring(P,r),S=12}if(i.charCodeAt(r+1)===42){r+=2;const I=d-1;let H=!1;for(;r<I;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,L=1),m=i.substring(P,r),S=13}return m+=String.fromCharCode(z),r++,S=16}case 45:if(m+=String.fromCharCode(z),r++,r===d||!b(i.charCodeAt(r)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=k(),S=11;default:for(;r<d&&G(z);)r++,z=i.charCodeAt(r);if(f!==r){switch(m=i.substring(f,r),m){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return m+=String.fromCharCode(z),r++,S=16}}function G(z){if($(z)||g(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let z;do z=O();while(z>=12&&z<=15);return z}return{setPosition:y,getPosition:()=>r,scan:l?W:O,getToken:()=>S,getTokenValue:()=>m,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>L}}e.$an=R;function $(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function b(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function D(i,l){const r=[],d=new Object;let m;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function L(v,y,k,N){f.value=v,f.offset=y,f.length=k,f.type=N,f.colonOffset=void 0,m=f}try{a(i,{onObjectBegin:(v,y)=>{if(l<=v)throw d;m=void 0,S=l>v,r.push("")},onObjectProperty:(v,y,k)=>{if(l<y||(L(v,y,k,"property"),r[r.length-1]=v,l<=y+k))throw d},onObjectEnd:(v,y)=>{if(l<=v)throw d;m=void 0,r.pop()},onArrayBegin:(v,y)=>{if(l<=v)throw d;m=void 0,r.push(0)},onArrayEnd:(v,y)=>{if(l<=v)throw d;m=void 0,r.pop()},onLiteralValue:(v,y,k)=>{if(l<y||(L(v,y,k,h(v)),l<=y+k))throw d},onSeparator:(v,y,k)=>{if(l<=y)throw d;if(v===":"&&m&&m.type==="property")m.colonOffset=y,S=!1,m=void 0;else if(v===","){const N=r[r.length-1];typeof N=="number"?r[r.length-1]=N+1:(S=!0,r[r.length-1]=""),m=void 0}}})}catch(v){if(v!==d)throw v}return{path:r,previousNode:m,isAtPropertyKey:S,matches:v=>{let y=0;for(let k=0;y<v.length&&k<r.length;k++)if(v[y]===r[k]||v[y]==="*")y++;else if(v[y]!=="**")return!1;return y===v.length}}}e.$bn=D;function u(i,l=[],r=M.DEFAULT){let d=null,m=[];const f=[];function S(v){Array.isArray(m)?m.push(v):d!==null&&(m[d]=v)}return a(i,{onObjectBegin:()=>{const v={};S(v),f.push(m),m=v,d=null},onObjectProperty:v=>{d=v},onObjectEnd:()=>{m=f.pop()},onArrayBegin:()=>{const v=[];S(v),f.push(m),m=v,d=null},onArrayEnd:()=>{m=f.pop()},onLiteralValue:S,onError:(v,y,k)=>{l.push({error:v,offset:y,length:k})}},r),m[0]}e.$cn=u;function p(i,l=[],r=M.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(v){d.type==="property"&&(d.length=v-d.offset,d=d.parent)}function f(v){return d.children.push(v),v}a(i,{onObjectBegin:v=>{d=f({type:"object",offset:v,length:-1,parent:d,children:[]})},onObjectProperty:(v,y,k)=>{d=f({type:"property",offset:y,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:v,offset:y,length:k,parent:d})},onObjectEnd:(v,y)=>{d.length=v+y-d.offset,d=d.parent,m(v+y)},onArrayBegin:(v,y)=>{d=f({type:"array",offset:v,length:-1,parent:d,children:[]})},onArrayEnd:(v,y)=>{d.length=v+y-d.offset,d=d.parent,m(v+y)},onLiteralValue:(v,y,k)=>{f({type:h(v),offset:y,length:k,parent:d,value:v}),m(y+k)},onSeparator:(v,y,k)=>{d.type==="property"&&(v===":"?d.colonOffset=y:v===","&&m(y))},onError:(v,y,k)=>{l.push({error:v,offset:y,length:k})}},r);const L=d.children[0];return L&&delete L.parent,L}e.$dn=p;function w(i,l){if(!i)return;let r=i;for(const d of l)if(typeof d=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let m=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===d){r=f.children[1],m=!0;break}if(!m)return}else{const m=d;if(r.type!=="array"||m<0||!Array.isArray(r.children)||m>=r.children.length)return;r=r.children[m]}return r}e.$en=w;function s(i){if(!i.parent||!i.parent.children)return[];const l=s(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;l.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&l.push(r)}return l}e.$fn=s;function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const l=Object.create(null);for(const r of i.children){const d=r.children[1];d&&(l[r.children[0].value]=o(d))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$gn=o;function t(i,l,r=!1){return l>=i.offset&&l<i.offset+i.length||r&&l===i.offset+i.length}e.$hn=t;function n(i,l,r=!1){if(t(i,l,r)){const d=i.children;if(Array.isArray(d))for(let m=0;m<d.length&&d[m].offset<=l;m++){const f=n(d[m],l,r);if(f)return f}return i}}e.$in=n;function a(i,l,r=M.DEFAULT){const d=R(i,!1);function m(se){return se?()=>se(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(se){return se?be=>se(be,d.getTokenOffset(),d.getTokenLength()):()=>!0}const S=m(l.onObjectBegin),L=f(l.onObjectProperty),v=m(l.onObjectEnd),y=m(l.onArrayBegin),k=m(l.onArrayEnd),N=f(l.onLiteralValue),O=f(l.onSeparator),G=m(l.onComment),W=f(l.onError),z=r&&r.disallowComments,P=r&&r.allowTrailingComma;function I(){for(;;){const se=d.scan();switch(d.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:z||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(se){case 12:case 13:z?H(10):G();break;case 16:H(1);break;case 15:case 14:break;default:return se}}}function H(se,be=[],ne=[]){if(W(se),be.length+ne.length>0){let Y=d.getToken();for(;Y!==17;){if(be.indexOf(Y)!==-1){I();break}else if(ne.indexOf(Y)!==-1)break;Y=I()}}}function ae(se){const be=d.getTokenValue();return se?N(be):L(be),I(),!0}function de(){switch(d.getToken()){case 11:{let se=0;try{se=JSON.parse(d.getTokenValue()),typeof se!="number"&&(H(2),se=0)}catch{H(2)}N(se);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return I(),!0}function we(){return d.getToken()!==10?(H(3,[],[2,5]),!1):(ae(!1),d.getToken()===6?(O(":"),I(),ve()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function ke(){S(),I();let se=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(se||H(4,[],[]),O(","),I(),d.getToken()===2&&P)break}else se&&H(6,[],[]);we()||H(4,[],[2,5]),se=!0}return v(),d.getToken()!==2?H(7,[2],[]):I(),!0}function le(){y(),I();let se=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(se||H(4,[],[]),O(","),I(),d.getToken()===4&&P)break}else se&&H(6,[],[]);ve()||H(4,[],[4,5]),se=!0}return k(),d.getToken()!==4?H(8,[4],[]):I(),!0}function ve(){switch(d.getToken()){case 3:return le();case 1:return ke();case 10:return ae(!0);default:return de()}}return I(),d.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):ve()?(d.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.$jn=a;function c(i,l){const r=R(i),d=[];let m,f=0,S;do switch(S=r.getPosition(),m=r.scan(),m){case 12:case 13:case 17:f!==S&&d.push(i.substring(f,S)),l!==void 0&&d.push(r.getTokenValue().replace(/[^\r\n]/g,l)),f=r.getPosition();break}while(m!==17);return d.join("")}e.$kn=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=h}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ce,ce){for(var te=0;te<ce.length;te++){var Q=ce[te];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ce,Q.key,Q)}}function E(Ce,ce,te){return ce&&e(Ce.prototype,ce),te&&e(Ce,te),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function T(Ce,ce){if(Ce){if(typeof Ce=="string")return C(Ce,ce);var te=Object.prototype.toString.call(Ce).slice(8,-1);if(te==="Object"&&Ce.constructor&&(te=Ce.constructor.name),te==="Map"||te==="Set")return Array.from(Ce);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return C(Ce,ce)}}function C(Ce,ce){(ce==null||ce>Ce.length)&&(ce=Ce.length);for(var te=0,Q=new Array(ce);te<ce;te++)Q[te]=Ce[te];return Q}function M(Ce,ce){var te=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(te)return(te=te.call(Ce)).next.bind(te);if(Array.isArray(Ce)||(te=T(Ce))||ce&&Ce&&typeof Ce.length=="number"){te&&(Ce=te);var Q=0;return function(){return Q>=Ce.length?{done:!0}:{done:!1,value:Ce[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=R();function $(Ce){ge.defaults=Ce}var g=/[&<>"']/,b=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ce){return u[ce]};function w(Ce,ce){if(ce){if(g.test(Ce))return Ce.replace(b,p)}else if(A.test(Ce))return Ce.replace(D,p);return Ce}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ce){return Ce.replace(s,function(ce,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Ce,ce){Ce=typeof Ce=="string"?Ce:Ce.source,ce=ce||"";var te={replace:function(ee,me){return me=me.source||me,me=me.replace(t,"$1"),Ce=Ce.replace(ee,me),te},getRegex:function(){return new RegExp(Ce,ce)}};return te}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,ce,te){if(Ce){var Q;try{Q=decodeURIComponent(o(te)).replace(a,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}ce&&!c.test(te)&&(te=m(ce,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var i={},l=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(Ce,ce){i[" "+Ce]||(l.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=v(Ce,"/",!0)),Ce=i[" "+Ce];var te=Ce.indexOf(":")===-1;return ce.substring(0,2)==="//"?te?ce:Ce.replace(r,"$1")+ce:ce.charAt(0)==="/"?te?ce:Ce.replace(d,"$1")+ce:Ce+ce}var f={exec:function(){}};function S(Ce){for(var ce=1,te,Q;ce<arguments.length;ce++){te=arguments[ce];for(Q in te)Object.prototype.hasOwnProperty.call(te,Q)&&(Ce[Q]=te[Q])}return Ce}function L(Ce,ce){var te=Ce.replace(/\|/g,function(me,pe,Ae){for(var he=!1,ye=pe;--ye>=0&&Ae[ye]==="\\";)he=!he;return he?"|":" |"}),Q=te.split(/ \|/),ee=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>ce)Q.splice(ce);else for(;Q.length<ce;)Q.push("");for(;ee<Q.length;ee++)Q[ee]=Q[ee].trim().replace(/\\\|/g,"|");return Q}function v(Ce,ce,te){var Q=Ce.length;if(Q===0)return"";for(var ee=0;ee<Q;){var me=Ce.charAt(Q-ee-1);if(me===ce&&!te)ee++;else if(me!==ce&&te)ee++;else break}return Ce.slice(0,Q-ee)}function y(Ce,ce){if(Ce.indexOf(ce[1])===-1)return-1;for(var te=Ce.length,Q=0,ee=0;ee<te;ee++)if(Ce[ee]==="\\")ee++;else if(Ce[ee]===ce[0])Q++;else if(Ce[ee]===ce[1]&&(Q--,Q<0))return ee;return-1}function k(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(Ce,ce){if(ce<1)return"";for(var te="";ce>1;)ce&1&&(te+=Ce),ce>>=1,Ce+=Ce;return te+Ce}function O(Ce,ce,te,Q){var ee=ce.href,me=ce.title?w(ce.title):null,pe=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ae={type:"link",raw:te,href:ee,title:me,text:pe,tokens:Q.inlineTokens(pe)};return Q.state.inLink=!1,Ae}return{type:"image",raw:te,href:ee,title:me,text:w(pe)}}function G(Ce,ce){var te=Ce.match(/^(\s+)(?:```)/);if(te===null)return ce;var Q=te[1];return ce.split(`
`).map(function(ee){var me=ee.match(/^\s+/);if(me===null)return ee;var pe=me[0];return pe.length>=Q.length?ee.slice(Q.length):ee}).join(`
`)}var W=function(){function Ce(te){this.options=te||ge.defaults}var ce=Ce.prototype;return ce.space=function(Q){var ee=this.rules.block.newline.exec(Q);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ce.code=function(Q){var ee=this.rules.block.code.exec(Q);if(ee){var me=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?me:v(me,`
`)}}},ce.fences=function(Q){var ee=this.rules.block.fences.exec(Q);if(ee){var me=ee[0],pe=G(me,ee[3]||"");return{type:"code",raw:me,lang:ee[2]?ee[2].trim():ee[2],text:pe}}},ce.heading=function(Q){var ee=this.rules.block.heading.exec(Q);if(ee){var me=ee[2].trim();if(/#$/.test(me)){var pe=v(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:me,tokens:this.lexer.inline(me)}}},ce.hr=function(Q){var ee=this.rules.block.hr.exec(Q);if(ee)return{type:"hr",raw:ee[0]}},ce.blockquote=function(Q){var ee=this.rules.block.blockquote.exec(Q);if(ee){var me=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},ce.list=function(Q){var ee=this.rules.block.list.exec(Q);if(ee){var me,pe,Ae,he,ye,F,q,K,U,X,x,Ee,Te=ee[1].trim(),Ve=Te.length>1,He={type:"list",raw:"",ordered:Ve,start:Ve?+Te.slice(0,-1):"",loose:!1,items:[]};Te=Ve?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=Ve?Te:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(Ee=!1,!(!(ee=Ye.exec(Q))||this.rules.block.hr.test(Q)));){if(me=ee[0],Q=Q.substring(me.length),K=ee[2].split(`
`,1)[0],U=Q.split(`
`,1)[0],this.options.pedantic?(he=2,x=K.trimLeft()):(he=ee[2].search(/[^ ]/),he=he>4?1:he,x=K.slice(he),he+=ee[1].length),F=!1,!K&&/^ *$/.test(U)&&(me+=U+`
`,Q=Q.substring(U.length+1),Ee=!0),!Ee)for(var st=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,he-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,he-1)+"}#");Q&&(X=Q.split(`
`,1)[0],K=X,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(K)||at.test(K)||st.test(K)||nt.test(Q)));){if(K.search(/[^ ]/)>=he||!K.trim())x+=`
`+K.slice(he);else if(!F)x+=`
`+K;else break;!F&&!K.trim()&&(F=!0),me+=X+`
`,Q=Q.substring(X.length+1)}He.loose||(q?He.loose=!0:/\n *\n *$/.test(me)&&(q=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(x),pe&&(Ae=pe[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:me,task:!!pe,checked:Ae,loose:!1,text:x}),He.raw+=me}He.items[He.items.length-1].raw=me.trimRight(),He.items[He.items.length-1].text=x.trimRight(),He.raw=He.raw.trimRight();var ct=He.items.length;for(ye=0;ye<ct;ye++){this.lexer.state.top=!1,He.items[ye].tokens=this.lexer.blockTokens(He.items[ye].text,[]);var je=He.items[ye].tokens.filter(function(Z){return Z.type==="space"}),vt=je.every(function(Z){for(var _=Z.raw.split(""),$e=0,Be=M(_),Qe;!(Qe=Be()).done;){var it=Qe.value;if(it===`
`&&($e+=1),$e>1)return!0}return!1});!He.loose&&je.length&&vt&&(He.loose=!0,He.items[ye].loose=!0)}return He}},ce.html=function(Q){var ee=this.rules.block.html.exec(Q);if(ee){var me={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(ee[0]):w(ee[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},ce.def=function(Q){var ee=this.rules.block.def.exec(Q);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var me=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ee[0],href:ee[2],title:ee[3]}}},ce.table=function(Q){var ee=this.rules.block.table.exec(Q);if(ee){var me={type:"table",header:L(ee[1]).map(function(q){return{text:q}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ee[0];var pe=me.align.length,Ae,he,ye,F;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(pe=me.rows.length,Ae=0;Ae<pe;Ae++)me.rows[Ae]=L(me.rows[Ae],me.header.length).map(function(q){return{text:q}});for(pe=me.header.length,he=0;he<pe;he++)me.header[he].tokens=this.lexer.inline(me.header[he].text);for(pe=me.rows.length,he=0;he<pe;he++)for(F=me.rows[he],ye=0;ye<F.length;ye++)F[ye].tokens=this.lexer.inline(F[ye].text);return me}}},ce.lheading=function(Q){var ee=this.rules.block.lheading.exec(Q);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ce.paragraph=function(Q){var ee=this.rules.block.paragraph.exec(Q);if(ee){var me=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:me,tokens:this.lexer.inline(me)}}},ce.text=function(Q){var ee=this.rules.block.text.exec(Q);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ce.escape=function(Q){var ee=this.rules.inline.escape.exec(Q);if(ee)return{type:"escape",raw:ee[0],text:w(ee[1])}},ce.tag=function(Q){var ee=this.rules.inline.tag.exec(Q);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):w(ee[0]):ee[0]}},ce.link=function(Q){var ee=this.rules.inline.link.exec(Q);if(ee){var me=ee[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=v(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Ae=y(ee[2],"()");if(Ae>-1){var he=ee[0].indexOf("!")===0?5:4,ye=he+ee[1].length+Ae;ee[2]=ee[2].substring(0,Ae),ee[0]=ee[0].substring(0,ye).trim(),ee[3]=""}}var F=ee[2],q="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(F);K&&(F=K[1],q=K[3])}else q=ee[3]?ee[3].slice(1,-1):"";return F=F.trim(),/^</.test(F)&&(this.options.pedantic&&!/>$/.test(me)?F=F.slice(1):F=F.slice(1,-1)),O(ee,{href:F&&F.replace(this.rules.inline._escapes,"$1"),title:q&&q.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ce.reflink=function(Q,ee){var me;if((me=this.rules.inline.reflink.exec(Q))||(me=this.rules.inline.nolink.exec(Q))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=ee[pe.toLowerCase()],!pe||!pe.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return O(me,pe,me[0],this.lexer)}},ce.emStrong=function(Q,ee,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(Q);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var he=pe[0].length-1,ye,F,q=he,K=0,U=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,ee=ee.slice(-1*Q.length+he);(pe=U.exec(ee))!=null;)if(ye=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!ye){if(F=ye.length,pe[3]||pe[4]){q+=F;continue}else if((pe[5]||pe[6])&&he%3&&!((he+F)%3)){K+=F;continue}if(q-=F,!(q>0)){if(F=Math.min(F,F+q+K),Math.min(he,F)%2){var X=Q.slice(1,he+pe.index+F);return{type:"em",raw:Q.slice(0,he+pe.index+F+1),text:X,tokens:this.lexer.inlineTokens(X)}}var x=Q.slice(2,he+pe.index+F-1);return{type:"strong",raw:Q.slice(0,he+pe.index+F+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},ce.codespan=function(Q){var ee=this.rules.inline.code.exec(Q);if(ee){var me=ee[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return pe&&Ae&&(me=me.substring(1,me.length-1)),me=w(me,!0),{type:"codespan",raw:ee[0],text:me}}},ce.br=function(Q){var ee=this.rules.inline.br.exec(Q);if(ee)return{type:"br",raw:ee[0]}},ce.del=function(Q){var ee=this.rules.inline.del.exec(Q);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ce.autolink=function(Q,ee){var me=this.rules.inline.autolink.exec(Q);if(me){var pe,Ae;return me[2]==="@"?(pe=w(this.options.mangle?ee(me[1]):me[1]),Ae="mailto:"+pe):(pe=w(me[1]),Ae=pe),{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.url=function(Q,ee){var me;if(me=this.rules.inline.url.exec(Q)){var pe,Ae;if(me[2]==="@")pe=w(this.options.mangle?ee(me[0]):me[0]),Ae="mailto:"+pe;else{var he;do he=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(he!==me[0]);pe=w(me[0]),me[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.inlineText=function(Q,ee){var me=this.rules.inline.text.exec(Q);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):w(me[0]):me[0]:pe=w(this.options.smartypants?ee(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},Ce}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=S({},z),z.gfm=S({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=S({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=n(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=n(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=n(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=n(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=n(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=n(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=n(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=n(P.reflink).replace("label",P._label).replace("ref",z._label).getRegex(),P.nolink=n(P.nolink).replace("ref",z._label).getRegex(),P.reflinkSearch=n(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=S({},P),P.pedantic=S({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=S({},P.normal,{escape:n(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=n(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=S({},P.gfm,{br:n(P.br).replace("{2,}","*").getRegex(),text:n(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function I(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Ce){var ce="",te,Q,ee=Ce.length;for(te=0;te<ee;te++)Q=Ce.charCodeAt(te),Math.random()>.5&&(Q="x"+Q.toString(16)),ce+="&#"+Q+";";return ce}var ae=function(){function Ce(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||ge.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:z.normal,inline:P.normal};this.options.pedantic?(Q.block=z.pedantic,Q.inline=P.pedantic):this.options.gfm&&(Q.block=z.gfm,this.options.breaks?Q.inline=P.breaks:Q.inline=P.gfm),this.tokenizer.rules=Q}Ce.lex=function(Q,ee){var me=new Ce(ee);return me.lex(Q)},Ce.lexInline=function(Q,ee){var me=new Ce(ee);return me.inlineTokens(Q)};var ce=Ce.prototype;return ce.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ce.blockTokens=function(Q,ee){var me=this;ee===void 0&&(ee=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(q,K,U){return K+"    ".repeat(U.length)});for(var pe,Ae,he,ye;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(q){return(pe=q.call({lexer:me},Q,ee))?(Q=Q.substring(pe.raw.length),ee.push(pe),!0):!1}))){if(pe=this.tokenizer.space(Q)){Q=Q.substring(pe.raw.length),pe.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(pe);continue}if(pe=this.tokenizer.code(Q)){Q=Q.substring(pe.raw.length),Ae=ee[ee.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(pe);continue}if(pe=this.tokenizer.fences(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.heading(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.hr(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.blockquote(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.list(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.html(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.def(Q)){Q=Q.substring(pe.raw.length),Ae=ee[ee.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.lheading(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(he=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var q=1/0,K=Q.slice(1),U=void 0;me.options.extensions.startBlock.forEach(function(X){U=X.call({lexer:this},K),typeof U=="number"&&U>=0&&(q=Math.min(q,U))}),q<1/0&&q>=0&&(he=Q.substring(0,q+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(he))){Ae=ee[ee.length-1],ye&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(pe),ye=he.length!==Q.length,Q=Q.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(Q)){Q=Q.substring(pe.raw.length),Ae=ee[ee.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(pe);continue}if(Q){var F="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(F);break}else throw new Error(F)}}return this.state.top=!0,ee},ce.inline=function(Q,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:Q,tokens:ee}),ee},ce.inlineTokens=function(Q,ee){var me=this;ee===void 0&&(ee=[]);var pe,Ae,he,ye=Q,F,q,K;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(F=this.tokenizer.rules.inline.reflinkSearch.exec(ye))!=null;)U.includes(F[0].slice(F[0].lastIndexOf("[")+1,-1))&&(ye=ye.slice(0,F.index)+"["+N("a",F[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(F=this.tokenizer.rules.inline.blockSkip.exec(ye))!=null;)ye=ye.slice(0,F.index)+"["+N("a",F[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(F=this.tokenizer.rules.inline.escapedEmSt.exec(ye))!=null;)ye=ye.slice(0,F.index)+"++"+ye.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(q||(K=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(pe=x.call({lexer:me},Q,ee))?(Q=Q.substring(pe.raw.length),ee.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.tag(Q)){Q=Q.substring(pe.raw.length),Ae=ee[ee.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):ee.push(pe);continue}if(pe=this.tokenizer.link(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(pe.raw.length),Ae=ee[ee.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):ee.push(pe);continue}if(pe=this.tokenizer.emStrong(Q,ye,K)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.codespan(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.br(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.del(Q)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(pe=this.tokenizer.autolink(Q,H)){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(Q,H))){Q=Q.substring(pe.raw.length),ee.push(pe);continue}if(he=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,Ee=Q.slice(1),Te=void 0;me.options.extensions.startInline.forEach(function(Ve){Te=Ve.call({lexer:this},Ee),typeof Te=="number"&&Te>=0&&(x=Math.min(x,Te))}),x<1/0&&x>=0&&(he=Q.substring(0,x+1))}(),pe=this.tokenizer.inlineText(he,I)){Q=Q.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(K=pe.raw.slice(-1)),q=!0,Ae=ee[ee.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):ee.push(pe);continue}if(Q){var X="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return ee},E(Ce,null,[{key:"rules",get:function(){return{block:z,inline:P}}}]),Ce}(),de=function(){function Ce(te){this.options=te||ge.defaults}var ce=Ce.prototype;return ce.code=function(Q,ee,me){var pe=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(Q,pe);Ae!=null&&Ae!==Q&&(me=!0,Q=Ae)}return Q=Q.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+w(pe,!0)+'">'+(me?Q:w(Q,!0))+`</code></pre>
`:"<pre><code>"+(me?Q:w(Q,!0))+`</code></pre>
`},ce.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},ce.html=function(Q){return Q},ce.heading=function(Q,ee,me,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug(me);return"<h"+ee+' id="'+Ae+'">'+Q+"</h"+ee+`>
`}return"<h"+ee+">"+Q+"</h"+ee+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Q,ee,me){var pe=ee?"ol":"ul",Ae=ee&&me!==1?' start="'+me+'"':"";return"<"+pe+Ae+`>
`+Q+"</"+pe+`>
`},ce.listitem=function(Q){return"<li>"+Q+`</li>
`},ce.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Q){return"<p>"+Q+`</p>
`},ce.table=function(Q,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+ee+`</table>
`},ce.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},ce.tablecell=function(Q,ee){var me=ee.header?"th":"td",pe=ee.align?"<"+me+' align="'+ee.align+'">':"<"+me+">";return pe+Q+("</"+me+`>
`)},ce.strong=function(Q){return"<strong>"+Q+"</strong>"},ce.em=function(Q){return"<em>"+Q+"</em>"},ce.codespan=function(Q){return"<code>"+Q+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Q){return"<del>"+Q+"</del>"},ce.link=function(Q,ee,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var pe='<a href="'+w(Q)+'"';return ee&&(pe+=' title="'+ee+'"'),pe+=">"+me+"</a>",pe},ce.image=function(Q,ee,me){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var pe='<img src="'+Q+'" alt="'+me+'"';return ee&&(pe+=' title="'+ee+'"'),pe+=this.options.xhtml?"/>":">",pe},ce.text=function(Q){return Q},Ce}(),we=function(){function Ce(){}var ce=Ce.prototype;return ce.strong=function(Q){return Q},ce.em=function(Q){return Q},ce.codespan=function(Q){return Q},ce.del=function(Q){return Q},ce.html=function(Q){return Q},ce.text=function(Q){return Q},ce.link=function(Q,ee,me){return""+me},ce.image=function(Q,ee,me){return""+me},ce.br=function(){return""},Ce}(),ke=function(){function Ce(){this.seen={}}var ce=Ce.prototype;return ce.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Q,ee){var me=Q,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[Q];do pe++,me=Q+"-"+pe;while(this.seen.hasOwnProperty(me))}return ee||(this.seen[Q]=pe,this.seen[me]=0),me},ce.slug=function(Q,ee){ee===void 0&&(ee={});var me=this.serialize(Q);return this.getNextSafeSlug(me,ee.dryrun)},Ce}(),le=function(){function Ce(te){this.options=te||ge.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ke}Ce.parse=function(Q,ee){var me=new Ce(ee);return me.parse(Q)},Ce.parseInline=function(Q,ee){var me=new Ce(ee);return me.parseInline(Q)};var ce=Ce.prototype;return ce.parse=function(Q,ee){ee===void 0&&(ee=!0);var me="",pe,Ae,he,ye,F,q,K,U,X,x,Ee,Te,Ve,He,Ye,st,nt,tt,at,ct=Q.length;for(pe=0;pe<ct;pe++){if(x=Q[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(at=this.options.extensions.renderers[x.type].call({parser:this},x),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){me+=at||"";continue}switch(x.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(x.tokens),x.depth,o(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(U="",K="",ye=x.header.length,Ae=0;Ae<ye;Ae++)K+=this.renderer.tablecell(this.parseInline(x.header[Ae].tokens),{header:!0,align:x.align[Ae]});for(U+=this.renderer.tablerow(K),X="",ye=x.rows.length,Ae=0;Ae<ye;Ae++){for(q=x.rows[Ae],K="",F=q.length,he=0;he<F;he++)K+=this.renderer.tablecell(this.parseInline(q[he].tokens),{header:!1,align:x.align[he]});X+=this.renderer.tablerow(K)}me+=this.renderer.table(U,X);continue}case"blockquote":{X=this.parse(x.tokens),me+=this.renderer.blockquote(X);continue}case"list":{for(Ee=x.ordered,Te=x.start,Ve=x.loose,ye=x.items.length,X="",Ae=0;Ae<ye;Ae++)Ye=x.items[Ae],st=Ye.checked,nt=Ye.task,He="",Ye.task&&(tt=this.renderer.checkbox(st),Ve?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=tt+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=tt+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:tt}):He+=tt),He+=this.parse(Ye.tokens,Ve),X+=this.renderer.listitem(He,nt,st);me+=this.renderer.list(X,Ee,Te);continue}case"html":{me+=this.renderer.html(x.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(X=x.tokens?this.parseInline(x.tokens):x.text;pe+1<ct&&Q[pe+1].type==="text";)x=Q[++pe],X+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);me+=ee?this.renderer.paragraph(X):X;continue}default:{var je='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return me},ce.parseInline=function(Q,ee){ee=ee||this.renderer;var me="",pe,Ae,he,ye=Q.length;for(pe=0;pe<ye;pe++){if(Ae=Q[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(he=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=he||"";continue}switch(Ae.type){case"escape":{me+=ee.text(Ae.text);break}case"html":{me+=ee.html(Ae.text);break}case"link":{me+=ee.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,ee));break}case"image":{me+=ee.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=ee.strong(this.parseInline(Ae.tokens,ee));break}case"em":{me+=ee.em(this.parseInline(Ae.tokens,ee));break}case"codespan":{me+=ee.codespan(Ae.text);break}case"br":{me+=ee.br();break}case"del":{me+=ee.del(this.parseInline(Ae.tokens,ee));break}case"text":{me+=ee.text(Ae.text);break}default:{var F='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(F);return}else throw new Error(F)}}}return me},Ce}();function ve(Ce,ce,te){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ce=="function"&&(te=ce,ce=null),ce=S({},ve.defaults,ce||{}),k(ce),te){var Q=ce.highlight,ee;try{ee=ae.lex(Ce,ce)}catch(ye){return te(ye)}var me=function(F){var q;if(!F)try{ce.walkTokens&&ve.walkTokens(ee,ce.walkTokens),q=le.parse(ee,ce)}catch(K){F=K}return ce.highlight=Q,F?te(F):te(null,q)};if(!Q||Q.length<3||(delete ce.highlight,!ee.length))return me();var pe=0;ve.walkTokens(ee,function(ye){ye.type==="code"&&(pe++,setTimeout(function(){Q(ye.text,ye.lang,function(F,q){if(F)return me(F);q!=null&&q!==ye.text&&(ye.text=q,ye.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Ae(ye){if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(ye.message+"",!0)+"</pre>";throw ye}try{var he=ae.lex(Ce,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ve.walkTokens(he,ce.walkTokens)).then(function(){return le.parse(he,ce)}).catch(Ae);ve.walkTokens(he,ce.walkTokens)}return le.parse(he,ce)}catch(ye){Ae(ye)}}ve.options=ve.setOptions=function(Ce){return S(ve.defaults,Ce),$(ve.defaults),ve},ve.getDefaults=R,ve.defaults=ge.defaults,ve.use=function(){for(var Ce=arguments.length,ce=new Array(Ce),te=0;te<Ce;te++)ce[te]=arguments[te];var Q=S.apply(void 0,[{}].concat(ce)),ee=ve.defaults.extensions||{renderers:{},childTokens:{}},me;ce.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var ye=ee.renderers?ee.renderers[he.name]:null;ye?ee.renderers[he.name]=function(){for(var F=arguments.length,q=new Array(F),K=0;K<F;K++)q[K]=arguments[K];var U=he.renderer.apply(this,q);return U===!1&&(U=ye.apply(this,q)),U}:ee.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[he.level]?ee[he.level].unshift(he.tokenizer):ee[he.level]=[he.tokenizer],he.start&&(he.level==="block"?ee.startBlock?ee.startBlock.push(he.start):ee.startBlock=[he.start]:he.level==="inline"&&(ee.startInline?ee.startInline.push(he.start):ee.startInline=[he.start]))}he.childTokens&&(ee.childTokens[he.name]=he.childTokens)})),pe.renderer&&function(){var he=ve.defaults.renderer||new de,ye=function(K){var U=he[K];he[K]=function(){for(var X=arguments.length,x=new Array(X),Ee=0;Ee<X;Ee++)x[Ee]=arguments[Ee];var Te=pe.renderer[K].apply(he,x);return Te===!1&&(Te=U.apply(he,x)),Te}};for(var F in pe.renderer)ye(F);Q.renderer=he}(),pe.tokenizer&&function(){var he=ve.defaults.tokenizer||new W,ye=function(K){var U=he[K];he[K]=function(){for(var X=arguments.length,x=new Array(X),Ee=0;Ee<X;Ee++)x[Ee]=arguments[Ee];var Te=pe.tokenizer[K].apply(he,x);return Te===!1&&(Te=U.apply(he,x)),Te}};for(var F in pe.tokenizer)ye(F);Q.tokenizer=he}(),pe.walkTokens){var Ae=ve.defaults.walkTokens;Q.walkTokens=function(he){var ye=[];return ye.push(pe.walkTokens.call(this,he)),Ae&&(ye=ye.concat(Ae.call(this,he))),ye}}me&&(Q.extensions=ee),ve.setOptions(Q)})},ve.walkTokens=function(Ce,ce){for(var te=[],Q=function(){var Ae=me.value;switch(te=te.concat(ce.call(ve,Ae)),Ae.type){case"table":{for(var he=M(Ae.header),ye;!(ye=he()).done;){var F=ye.value;te=te.concat(ve.walkTokens(F.tokens,ce))}for(var q=M(Ae.rows),K;!(K=q()).done;)for(var U=K.value,X=M(U),x;!(x=X()).done;){var Ee=x.value;te=te.concat(ve.walkTokens(Ee.tokens,ce))}break}case"list":{te=te.concat(ve.walkTokens(Ae.items,ce));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Ae.type]?ve.defaults.extensions.childTokens[Ae.type].forEach(function(Te){te=te.concat(ve.walkTokens(Ae[Te],ce))}):Ae.tokens&&(te=te.concat(ve.walkTokens(Ae.tokens,ce)))}},ee=M(Ce),me;!(me=ee()).done;)Q();return te},ve.parseInline=function(Ce,ce){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ce=S({},ve.defaults,ce||{}),k(ce);try{var te=ae.lexInline(Ce,ce);return ce.walkTokens&&ve.walkTokens(te,ce.walkTokens),le.parseInline(te,ce)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(Q.message+"",!0)+"</pre>";throw Q}},ve.Parser=le,ve.parser=le.parse,ve.Renderer=de,ve.TextRenderer=we,ve.Lexer=ae,ve.lexer=ae.lex,ve.Tokenizer=W,ve.Slugger=ke,ve.parse=ve;var se=ve.options,be=ve.setOptions,ne=ve.use,Y=ve.walkTokens,V=ve.parseInline,ie=ve,Ie=le.parse,Le=ae.lex;ge.Lexer=ae,ge.Parser=le,ge.Renderer=de,ge.Slugger=ke,ge.TextRenderer=we,ge.Tokenizer=W,ge.getDefaults=R,ge.lexer=Le,ge.marked=ve,ge.options=se,ge.parse=ie,ge.parseInline=V,ge.parser=Ie,ge.setOptions=be,ge.use=ne,ge.walkTokens=Y,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Pe[121],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=void 0;function E(s){const o=M(s);if(o&&o.length>0)return new Uint32Array(o)}e.$Rj=E;let T=0;const C=new Uint32Array(10);function M(s){if(T=0,R(s,D,4352),T>0||(R(s,u,4449),T>0)||(R(s,p,4520),T>0)||(R(s,w,12593),T))return C.subarray(0,T);if(s>=44032&&s<=55203){const o=s-44032,t=o%588,n=Math.floor(o/588),a=Math.floor(t/28),c=t%28-1;if(n<D.length?R(n,D,0):4352+n-12593<w.length&&R(4352+n,w,12593),a<u.length?R(a,u,0):4449+a-12593<w.length&&R(4449+a-12593,w,12593),c>=0&&(c<p.length?R(c,p,0):4520+c-12593<w.length&&R(4520+c-12593,w,12593)),T>0)return C.subarray(0,T)}}function R(s,o,t){s>=t&&s<t+o.length&&$(o[s-t])}function $(s){s!==0&&(C[T++]=s&255,s>>8&&(C[T++]=s>>8&255),s>>16&&(C[T++]=s>>16&255))}var g;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var b;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(b||(b={}));var A;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(A||(A={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),w=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[122],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function E($,g,b){return Math.min(Math.max($,g),b)}e.$7l=E;function T($,g){return(g+$%g)%g}e.rot=T;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=C;class M{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=M;class R{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const b=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=R}),function(){function ge(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function R(g){M.push(g,Date.now())}function $(){const g=[];for(let b=0;b<M.length;b+=2)g.push({name:M[b],startTime:M[b+1]});return g}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(C+R.startTime)});return M}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function E(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:ge)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function E(T){if(e[T])return e[T].exports;var C=e[T]={i:T,l:!1,exports:{}};return ge[T].call(C.exports,C,C.exports,E),C.l=!0,C.exports}return E.m=ge,E.c=e,E.d=function(T,C,M){E.o(T,C)||Object.defineProperty(T,C,{enumerable:!0,get:M})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,C){if(1&C&&(T=E(T)),8&C||4&C&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&C&&typeof T!="string")for(var R in T)E.d(M,R,function($){return T[$]}.bind(null,R));return M},E.n=function(T){var C=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(C,"a",C),C},E.o=function(T,C){return Object.prototype.hasOwnProperty.call(T,C)},E.p="",E(E.s=0)}([function(ge,e,E){(function(T){var C;e=ge.exports=ne,C=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],g=e.src=[],b=0,A=b++;g[A]="0|[1-9]\\d*";var D=b++;g[D]="[0-9]+";var u=b++;g[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=b++;g[p]="("+g[A]+")\\.("+g[A]+")\\.("+g[A]+")";var w=b++;g[w]="("+g[D]+")\\.("+g[D]+")\\.("+g[D]+")";var s=b++;g[s]="(?:"+g[A]+"|"+g[u]+")";var o=b++;g[o]="(?:"+g[D]+"|"+g[u]+")";var t=b++;g[t]="(?:-("+g[s]+"(?:\\."+g[s]+")*))";var n=b++;g[n]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var a=b++;g[a]="[0-9A-Za-z-]+";var c=b++;g[c]="(?:\\+("+g[a]+"(?:\\."+g[a]+")*))";var h=b++,i="v?"+g[p]+g[t]+"?"+g[c]+"?";g[h]="^"+i+"$";var l="[v=\\s]*"+g[w]+g[n]+"?"+g[c]+"?",r=b++;g[r]="^"+l+"$";var d=b++;g[d]="((?:<|>)?=?)";var m=b++;g[m]=g[D]+"|x|X|\\*";var f=b++;g[f]=g[A]+"|x|X|\\*";var S=b++;g[S]="[v=\\s]*("+g[f]+")(?:\\.("+g[f]+")(?:\\.("+g[f]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var L=b++;g[L]="[v=\\s]*("+g[m]+")(?:\\.("+g[m]+")(?:\\.("+g[m]+")(?:"+g[n]+")?"+g[c]+"?)?)?";var v=b++;g[v]="^"+g[d]+"\\s*"+g[S]+"$";var y=b++;g[y]="^"+g[d]+"\\s*"+g[L]+"$";var k=b++;g[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=b++;g[N]="(?:~>?)";var O=b++;g[O]="(\\s*)"+g[N]+"\\s+",$[O]=new RegExp(g[O],"g");var G=b++;g[G]="^"+g[N]+g[S]+"$";var W=b++;g[W]="^"+g[N]+g[L]+"$";var z=b++;g[z]="(?:\\^)";var P=b++;g[P]="(\\s*)"+g[z]+"\\s+",$[P]=new RegExp(g[P],"g");var I=b++;g[I]="^"+g[z]+g[S]+"$";var H=b++;g[H]="^"+g[z]+g[L]+"$";var ae=b++;g[ae]="^"+g[d]+"\\s*("+l+")$|^$";var de=b++;g[de]="^"+g[d]+"\\s*("+i+")$|^$";var we=b++;g[we]="(\\s*)"+g[d]+"\\s*("+l+"|"+g[S]+")",$[we]=new RegExp(g[we],"g");var ke=b++;g[ke]="^\\s*("+g[S]+")\\s+-\\s+("+g[S]+")\\s*$";var le=b++;g[le]="^\\s*("+g[L]+")\\s+-\\s+("+g[L]+")\\s*$";var ve=b++;g[ve]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)C(se,g[se]),$[se]||($[se]=new RegExp(g[se]));function be(U,X){if(U instanceof ne)return U;if(typeof U!="string"||U.length>M||!(X?$[r]:$[h]).test(U))return null;try{return new ne(U,X)}catch{return null}}function ne(U,X){if(U instanceof ne){if(U.loose===X)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ne))return new ne(U,X);C("SemVer",U,X),this.loose=X;var x=U.trim().match(X?$[r]:$[h]);if(!x)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Te=+Ee;if(Te>=0&&Te<R)return Te}return Ee}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=be,e.valid=function(U,X){var x=be(U,X);return x?x.version:null},e.clean=function(U,X){var x=be(U.trim().replace(/^[=v]+/,""),X);return x?x.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(U){return C("SemVer.compare",this.version,this.loose,U),U instanceof ne||(U=new ne(U,this.loose)),this.compareMain(U)||this.comparePre(U)},ne.prototype.compareMain=function(U){return U instanceof ne||(U=new ne(U,this.loose)),V(this.major,U.major)||V(this.minor,U.minor)||V(this.patch,U.patch)},ne.prototype.comparePre=function(U){if(U instanceof ne||(U=new ne(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var X=0;do{var x=this.prerelease[X],Ee=U.prerelease[X];if(C("prerelease compare",X,x,Ee),x===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(x===void 0)return-1;if(x!==Ee)return V(x,Ee)}while(++X)},ne.prototype.inc=function(U,X){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,X,x,Ee){typeof x=="string"&&(Ee=x,x=void 0);try{return new ne(U,x).inc(X,Ee).version}catch{return null}},e.diff=function(U,X){if(Ce(U,X))return null;var x=be(U),Ee=be(X);if(x.prerelease.length||Ee.prerelease.length){for(var Te in x)if((Te==="major"||Te==="minor"||Te==="patch")&&x[Te]!==Ee[Te])return"pre"+Te;return"prerelease"}for(var Te in x)if((Te==="major"||Te==="minor"||Te==="patch")&&x[Te]!==Ee[Te])return Te},e.compareIdentifiers=V;var Y=/^[0-9]+$/;function V(U,X){var x=Y.test(U),Ee=Y.test(X);return x&&Ee&&(U=+U,X=+X),x&&!Ee?-1:Ee&&!x?1:U<X?-1:U>X?1:0}function ie(U,X,x){return new ne(U,x).compare(new ne(X,x))}function Ie(U,X,x){return ie(U,X,x)>0}function Le(U,X,x){return ie(U,X,x)<0}function Ce(U,X,x){return ie(U,X,x)===0}function ce(U,X,x){return ie(U,X,x)!==0}function te(U,X,x){return ie(U,X,x)>=0}function Q(U,X,x){return ie(U,X,x)<=0}function ee(U,X,x,Ee){var Te;switch(X){case"===":typeof U=="object"&&(U=U.version),typeof x=="object"&&(x=x.version),Te=U===x;break;case"!==":typeof U=="object"&&(U=U.version),typeof x=="object"&&(x=x.version),Te=U!==x;break;case"":case"=":case"==":Te=Ce(U,x,Ee);break;case"!=":Te=ce(U,x,Ee);break;case">":Te=Ie(U,x,Ee);break;case">=":Te=te(U,x,Ee);break;case"<":Te=Le(U,x,Ee);break;case"<=":Te=Q(U,x,Ee);break;default:throw new TypeError("Invalid operator: "+X)}return Te}function me(U,X){if(U instanceof me){if(U.loose===X)return U;U=U.value}if(!(this instanceof me))return new me(U,X);C("comparator",U,X),this.loose=X,this.parse(U),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(U,X){return V(X,U)},e.major=function(U,X){return new ne(U,X).major},e.minor=function(U,X){return new ne(U,X).minor},e.patch=function(U,X){return new ne(U,X).patch},e.compare=ie,e.compareLoose=function(U,X){return ie(U,X,!0)},e.rcompare=function(U,X,x){return ie(X,U,x)},e.sort=function(U,X){return U.sort(function(x,Ee){return e.compare(x,Ee,X)})},e.rsort=function(U,X){return U.sort(function(x,Ee){return e.rcompare(x,Ee,X)})},e.gt=Ie,e.lt=Le,e.eq=Ce,e.neq=ce,e.gte=te,e.lte=Q,e.cmp=ee,e.Comparator=me;var pe={};function Ae(U,X){if(U instanceof Ae)return U.loose===X?U:new Ae(U.raw,X);if(U instanceof me)return new Ae(U.value,X);if(!(this instanceof Ae))return new Ae(U,X);if(this.loose=X,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function he(U){return!U||U.toLowerCase()==="x"||U==="*"}function ye(U,X,x,Ee,Te,Ve,He,Ye,st,nt,tt,at,ct){return((X=he(x)?"":he(Ee)?">="+x+".0.0":he(Te)?">="+x+"."+Ee+".0":">="+X)+" "+(Ye=he(st)?"":he(nt)?"<"+(+st+1)+".0.0":he(tt)?"<"+st+"."+(+nt+1)+".0":at?"<="+st+"."+nt+"."+tt+"-"+at:"<="+Ye)).trim()}function F(U,X){for(var x=0;x<U.length;x++)if(!U[x].test(X))return!1;if(X.prerelease.length){for(x=0;x<U.length;x++)if(C(U[x].semver),U[x].semver!==pe&&U[x].semver.prerelease.length>0){var Ee=U[x].semver;if(Ee.major===X.major&&Ee.minor===X.minor&&Ee.patch===X.patch)return!0}return!1}return!0}function q(U,X,x){try{X=new Ae(X,x)}catch{return!1}return X.test(U)}function K(U,X,x,Ee){var Te,Ve,He,Ye,st;switch(U=new ne(U,Ee),X=new Ae(X,Ee),x){case">":Te=Ie,Ve=Q,He=Le,Ye=">",st=">=";break;case"<":Te=Le,Ve=te,He=Ie,Ye="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(q(U,X,Ee))return!1;for(var nt=0;nt<X.set.length;++nt){var tt=X.set[nt],at=null,ct=null;if(tt.forEach(function(je){je.semver===pe&&(je=new me(">=0.0.0")),at=at||je,ct=ct||je,Te(je.semver,at.semver,Ee)?at=je:He(je.semver,ct.semver,Ee)&&(ct=je)}),at.operator===Ye||at.operator===st||(!ct.operator||ct.operator===Ye)&&Ve(U,ct.semver)||ct.operator===st&&He(U,ct.semver))return!1}return!0}me.prototype.parse=function(U){var X=this.loose?$[ae]:$[de],x=U.match(X);if(!x)throw new TypeError("Invalid comparator: "+U);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new ne(x[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(U){return C("Comparator.test",U,this.loose),this.semver===pe||(typeof U=="string"&&(U=new ne(U,this.loose)),ee(U,this.operator,this.semver,this.loose))},me.prototype.intersects=function(U,X){if(!(U instanceof me))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Ae(U.value,X),q(this.value,x,X);if(U.operator==="")return x=new Ae(this.value,X),q(U.semver,x,X);var Ee=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Ve=this.semver.version===U.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ye=ee(this.semver,"<",U.semver,X)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),st=ee(this.semver,">",U.semver,X)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return Ee||Te||Ve&&He||Ye||st},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(U){var X=this.loose;U=U.trim(),C("range",U,X);var x=X?$[le]:$[ke];U=U.replace(x,ye),C("hyphen replace",U),U=U.replace($[we],"$1$2$3"),C("comparator trim",U,$[we]),U=(U=(U=U.replace($[O],"$1~")).replace($[P],"$1^")).split(/\s+/).join(" ");var Ee=X?$[ae]:$[de],Te=U.split(" ").map(function(Ve){return function(He,Ye){return C("comp",He),He=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){C("caret",at,ct);var je=ct?$[H]:$[I];return at.replace(je,function(vt,Z,_,$e,Be){var Qe;return C("caret",at,vt,Z,_,$e,Be),he(Z)?Qe="":he(_)?Qe=">="+Z+".0.0 <"+(+Z+1)+".0.0":he($e)?Qe=Z==="0"?">="+Z+"."+_+".0 <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+".0 <"+(+Z+1)+".0.0":Be?(C("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=Z==="0"?_==="0"?">="+Z+"."+_+"."+$e+Be+" <"+Z+"."+_+"."+(+$e+1):">="+Z+"."+_+"."+$e+Be+" <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+"."+$e+Be+" <"+(+Z+1)+".0.0"):(C("no pr"),Qe=Z==="0"?_==="0"?">="+Z+"."+_+"."+$e+" <"+Z+"."+_+"."+(+$e+1):">="+Z+"."+_+"."+$e+" <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+"."+$e+" <"+(+Z+1)+".0.0"),C("caret return",Qe),Qe})}(tt,nt)}).join(" ")}(He,Ye),C("caret",He),He=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){var je=ct?$[W]:$[G];return at.replace(je,function(vt,Z,_,$e,Be){var Qe;return C("tilde",at,vt,Z,_,$e,Be),he(Z)?Qe="":he(_)?Qe=">="+Z+".0.0 <"+(+Z+1)+".0.0":he($e)?Qe=">="+Z+"."+_+".0 <"+Z+"."+(+_+1)+".0":Be?(C("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+Z+"."+_+"."+$e+Be+" <"+Z+"."+(+_+1)+".0"):Qe=">="+Z+"."+_+"."+$e+" <"+Z+"."+(+_+1)+".0",C("tilde return",Qe),Qe})}(tt,nt)}).join(" ")}(He,Ye),C("tildes",He),He=function(st,nt){return C("replaceXRanges",st,nt),st.split(/\s+/).map(function(tt){return function(at,ct){at=at.trim();var je=ct?$[y]:$[v];return at.replace(je,function(vt,Z,_,$e,Be,Qe){C("xRange",at,vt,Z,_,$e,Be,Qe);var it=he(_),rt=it||he($e),Ne=rt||he(Be);return Z==="="&&Ne&&(Z=""),it?vt=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Ne?(rt&&($e=0),Ne&&(Be=0),Z===">"?(Z=">=",rt?(_=+_+1,$e=0,Be=0):Ne&&($e=+$e+1,Be=0)):Z==="<="&&(Z="<",rt?_=+_+1:$e=+$e+1),vt=Z+_+"."+$e+"."+Be):rt?vt=">="+_+".0.0 <"+(+_+1)+".0.0":Ne&&(vt=">="+_+"."+$e+".0 <"+_+"."+(+$e+1)+".0"),C("xRange return",vt),vt})}(tt,nt)}).join(" ")}(He,Ye),C("xrange",He),He=function(st,nt){return C("replaceStars",st,nt),st.trim().replace($[ve],"")}(He,Ye),C("stars",He),He}(Ve,X)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(Ve){return!!Ve.match(Ee)})),Te=Te.map(function(Ve){return new me(Ve,X)})},Ae.prototype.intersects=function(U,X){if(!(U instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(Ee){return U.set.some(function(Te){return Te.every(function(Ve){return Ee.intersects(Ve,X)})})})})},e.toComparators=function(U,X){return new Ae(U,X).set.map(function(x){return x.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new ne(U,this.loose));for(var X=0;X<this.set.length;X++)if(F(this.set[X],U))return!0;return!1},e.satisfies=q,e.maxSatisfying=function(U,X,x){var Ee=null,Te=null;try{var Ve=new Ae(X,x)}catch{return null}return U.forEach(function(He){Ve.test(He)&&(Ee&&Te.compare(He)!==-1||(Te=new ne(Ee=He,x)))}),Ee},e.minSatisfying=function(U,X,x){var Ee=null,Te=null;try{var Ve=new Ae(X,x)}catch{return null}return U.forEach(function(He){Ve.test(He)&&(Ee&&Te.compare(He)!==1||(Te=new ne(Ee=He,x)))}),Ee},e.validRange=function(U,X){try{return new Ae(U,X).range||"*"}catch{return null}},e.ltr=function(U,X,x){return K(U,X,"<",x)},e.gtr=function(U,X,x){return K(U,X,">",x)},e.outside=K,e.prerelease=function(U,X){var x=be(U,X);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(U,X,x){return U=new Ae(U,x),X=new Ae(X,x),U.intersects(X)},e.coerce=function(U){if(U instanceof ne)return U;if(typeof U!="string")return null;var X=U.match($[k]);return X==null?null:be((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,E(1))},function(ge,e){var E,T,C=ge.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(o){if(E===setTimeout)return setTimeout(o,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var g,b=[],A=!1,D=-1;function u(){A&&g&&(A=!1,g.length?b=g.concat(b):D=-1,b.length&&p())}function p(){if(!A){var o=$(u);A=!0;for(var t=b.length;t;){for(g=b,b=[];++D<t;)g&&g[D].run();D=-1,t=b.length}g=null,A=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(o)}}function w(o,t){this.fun=o,this.array=t}function s(){}C.nextTick=function(o){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];b.push(new w(o,t)),b.length!==1||A||$(p)},w.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=s,C.addListener=s,C.once=s,C.off=s,C.removeListener=s,C.removeAllListeners=s,C.emit=s,C.prependListener=s,C.prependOnceListener=s,C.listeners=function(o){return[]},C.binding=function(o){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(o){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[123],Re([1,0,15,6]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function C(c){const h=c;return h?typeof h.read=="function":!1}e.$7d=C;function M(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$8d=M;function R(c){const h=c;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$9d=R;function $(c,h){return new g(c,h)}e.$0d=$;class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,E.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let l;switch(h){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(i);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(c,h){const i=[];let l;for(;(l=c.read())!==null;)i.push(l);return h(i)}e.$$d=b;function A(c,h,i){const l=[];let r;for(;(r=c.read())!==null&&l.length<i;)l.push(r);return r===null&&l.length>0?h(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const d=r;return r=void 0,d}return c.read()}}}e.$_d=A;function D(c,h){return new Promise((i,l)=>{const r=[];u(c,{onData:d=>{h&&r.push(d)},onError:d=>{h?l(d):i(void 0)},onEnd:()=>{i(h?h(r):void 0)}})})}e.$ae=D;function u(c,h,i){c.on("error",l=>{i?.isCancellationRequested||h.onError(l)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",l=>{i?.isCancellationRequested||h.onData(l)})}e.$be=u;function p(c,h){return new Promise((i,l)=>{const r=new T.$Sc,d=[],m=L=>{if(d.push(L),d.length>h)return r.dispose(),c.pause(),i({stream:c,buffer:d,ended:!1})},f=L=>(r.dispose(),l(L)),S=()=>(r.dispose(),i({stream:c,buffer:d,ended:!0}));r.add((0,T.$Rc)(()=>c.removeListener("error",f))),c.on("error",f),r.add((0,T.$Rc)(()=>c.removeListener("end",S))),c.on("end",S),r.add((0,T.$Rc)(()=>c.removeListener("data",m))),c.on("data",m)})}e.$ce=p;function w(c,h){const i=$(h);return i.end(c),i}e.$de=w;function s(){const c=$(()=>{throw new Error("not supported")});return c.end(),c}e.$ee=s;function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$fe=o;function t(c,h,i){const l=$(i);return u(c,{onData:r=>l.write(h.data(r)),onError:r=>l.error(h.error?h.error(r):r),onEnd:()=>l.end()}),l}e.$ge=t;function n(c,h,i){let l=!1;return{read:()=>{const r=h.read();return l?r:(l=!0,r!==null?i([c,r]):c)}}}e.$he=n;function a(c,h,i){let l=!1;const r=$(i);return u(h,{onData:d=>l?r.write(d):(l=!0,r.write(i([c,d]))),onError:d=>r.error(d),onEnd:()=>{l||(l=!0,r.write(c)),r.end()}}),r}e.$ie=a}),define(Pe[24],Re([1,0,39,123]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const C=typeof Buffer<"u",M=new E.$V(()=>new Uint8Array(256));let R,$;class g{static alloc(k){return C?new g(Buffer.allocUnsafe(k)):new g(new Uint8Array(k))}static wrap(k){return C&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new g(k)}static fromString(k,N){return!(N?.dontUseNodeBuffer||!1)&&C?new g(Buffer.from(k)):(R||(R=new TextEncoder),new g(R.encode(k)))}static fromByteArray(k){const N=g.alloc(k.length);for(let O=0,G=k.length;O<G;O++)N.buffer[O]=k[O];return N}static concat(k,N){if(typeof N>"u"){N=0;for(let W=0,z=k.length;W<z;W++)N+=k[W].byteLength}const O=g.alloc(N);let G=0;for(let W=0,z=k.length;W<z;W++){const P=k[W];O.set(P,G),G+=P.byteLength}return O}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=g.alloc(this.byteLength);return k.set(this),k}toString(){return C?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(k,N){return new g(this.buffer.subarray(k,N))}set(k,N){if(k instanceof g)this.buffer.set(k.buffer,N);else if(k instanceof Uint8Array)this.buffer.set(k,N);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),N);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return u(this.buffer,k)}writeUInt32BE(k,N){p(this.buffer,k,N)}readUInt32LE(k){return w(this.buffer,k)}writeUInt32LE(k,N){s(this.buffer,k,N)}readUInt8(k){return o(this.buffer,k)}writeUInt8(k,N){t(this.buffer,k,N)}indexOf(k,N=0){return b(this.buffer,k instanceof g?k.buffer:k,N)}}e.$je=g;function b(y,k,N=0){const O=k.byteLength,G=y.byteLength;if(O===0)return 0;if(O===1)return y.indexOf(k[0]);if(O>G-N)return-1;const W=M.value;W.fill(k.length);for(let H=0;H<k.length;H++)W[k[H]]=k.length-H-1;let z=N+k.length-1,P=z,I=-1;for(;z<G;)if(y[z]===k[P]){if(P===0){I=z;break}z--,P--}else z+=Math.max(k.length-P,W[y[z]]),P=k.length-1;return I}e.$ke=b;function A(y,k){return y[k+0]<<0>>>0|y[k+1]<<8>>>0}e.$le=A;function D(y,k,N){y[N+0]=k&255,k=k>>>8,y[N+1]=k&255}e.$me=D;function u(y,k){return y[k]*2**24+y[k+1]*2**16+y[k+2]*2**8+y[k+3]}e.$ne=u;function p(y,k,N){y[N+3]=k,k=k>>>8,y[N+2]=k,k=k>>>8,y[N+1]=k,k=k>>>8,y[N]=k}e.$oe=p;function w(y,k){return y[k+0]<<0>>>0|y[k+1]<<8>>>0|y[k+2]<<16>>>0|y[k+3]<<24>>>0}e.$pe=w;function s(y,k,N){y[N+0]=k&255,k=k>>>8,y[N+1]=k&255,k=k>>>8,y[N+2]=k&255,k=k>>>8,y[N+3]=k&255}e.$qe=s;function o(y,k){return y[k]}e.$re=o;function t(y,k,N){y[N]=k}e.$se=t;function n(y){return T.$$d(y,k=>g.concat(k))}e.$te=n;function a(y){return T.$fe(y)}e.$ue=a;function c(y){return T.$ae(y,k=>g.concat(k))}e.$ve=c;async function h(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await c(y.stream)])}e.$we=h;function i(y){return T.$de(y,k=>g.concat(k))}e.$xe=i;function l(y){return T.$ge(y,{data:k=>typeof k=="string"?g.fromString(k):g.wrap(k)},k=>g.concat(k))}e.$ye=l;function r(y){return T.$0d(k=>g.concat(k),y)}e.$ze=r;function d(y,k){return T.$he(y,k,N=>g.concat(N))}e.$Ae=d;function m(y,k){return T.$ie(y,k,N=>g.concat(N))}e.$Be=m;function f(y){let k=0,N=0,O=0;const G=new Uint8Array(Math.floor(y.length/4*3)),W=P=>{switch(N){case 3:G[O++]=k|P,N=0;break;case 2:G[O++]=k|P>>>2,k=P<<6,N=3;break;case 1:G[O++]=k|P>>>4,k=P<<4,N=2;break;default:k=P<<2,N=1}};for(let P=0;P<y.length;P++){const I=y.charCodeAt(P);if(I>=65&&I<=90)W(I-65);else if(I>=97&&I<=122)W(I-97+26);else if(I>=48&&I<=57)W(I-48+52);else if(I===43||I===45)W(62);else if(I===47||I===95)W(63);else{if(I===61)break;throw new SyntaxError(`Unexpected base64 character ${y[P]}`)}}const z=O;for(;N>0;)W(0);return g.wrap(G).slice(0,z)}e.$Ce=f;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:y},k=!0,N=!1){const O=N?L:S;let G="";const W=y.byteLength%3;let z=0;for(;z<y.byteLength-W;z+=3){const P=y[z+0],I=y[z+1],H=y[z+2];G+=O[P>>>2],G+=O[(P<<4|I>>>4)&63],G+=O[(I<<2|H>>>6)&63],G+=O[H&63]}if(W===1){const P=y[z+0];G+=O[P>>>2],G+=O[P<<4&63],k&&(G+="==")}else if(W===2){const P=y[z+0],I=y[z+1];G+=O[P>>>2],G+=O[(P<<4|I>>>4)&63],G+=O[I<<2&63],k&&(G+="=")}return G}e.$De=v}),define(Pe[124],Re([1,0,28,121,11]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=e.$6j=e.FuzzyScore=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.or=void 0;function M(...he){return function(ye,F){for(let q=0,K=he.length;q<K;q++){const U=he[q](ye,F);if(U)return U}return null}}e.or=M,e.$Tj=R.bind(void 0,!1),e.$Uj=R.bind(void 0,!0);function R(he,ye,F){if(!F||F.length<ye.length)return null;let q;return he?q=C.$af(F,ye):q=F.indexOf(ye)===0,q?ye.length>0?[{start:0,end:ye.length}]:[]:null}function $(he,ye){const F=ye.toLowerCase().indexOf(he.toLowerCase());return F===-1?null:[{start:F,end:F+he.length}]}e.$Vj=$;function g(he,ye){return b(he.toLowerCase(),ye.toLowerCase(),0,0)}e.$Wj=g;function b(he,ye,F,q){if(F===he.length)return[];if(q===ye.length)return null;if(he[F]===ye[q]){let K=null;return(K=b(he,ye,F+1,q+1))?c({start:q,end:q+1},K):null}return b(he,ye,F,q+1)}function A(he){return 97<=he&&he<=122}function D(he){return 65<=he&&he<=90}e.$Xj=D;function u(he){return 48<=he&&he<=57}function p(he){return he===32||he===9||he===10||he===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(he=>w.add(he.charCodeAt(0)));function s(he){return p(he)||w.has(he)}function o(he,ye){return he===ye||s(he)&&s(ye)}const t=new Map;function n(he){if(t.has(he))return t.get(he);let ye;const F=(0,T.$Rj)(he);return F&&(ye=F),t.set(he,ye),ye}function a(he){return A(he)||D(he)||u(he)}function c(he,ye){return ye.length===0?ye=[he]:he.end===ye[0].start?ye[0].start=he.start:ye.unshift(he),ye}function h(he,ye){for(let F=ye;F<he.length;F++){const q=he.charCodeAt(F);if(D(q)||u(q)||F>0&&!a(he.charCodeAt(F-1)))return F}return he.length}function i(he,ye,F,q){if(F===he.length)return[];if(q===ye.length)return null;if(he[F]!==ye[q].toLowerCase())return null;{let K=null,U=q+1;for(K=i(he,ye,F+1,q+1);!K&&(U=h(ye,U))<ye.length;)K=i(he,ye,F+1,U),U++;return K===null?null:c({start:q,end:q+1},K)}}function l(he){let ye=0,F=0,q=0,K=0,U=0;for(let Ve=0;Ve<he.length;Ve++)U=he.charCodeAt(Ve),D(U)&&ye++,A(U)&&F++,a(U)&&q++,u(U)&&K++;const X=ye/he.length,x=F/he.length,Ee=q/he.length,Te=K/he.length;return{upperPercent:X,lowerPercent:x,alphaPercent:Ee,numericPercent:Te}}function r(he){const{upperPercent:ye,lowerPercent:F}=he;return F===0&&ye>.6}function d(he){const{upperPercent:ye,lowerPercent:F,alphaPercent:q,numericPercent:K}=he;return F>.2&&ye<.8&&q>.6&&K<.2}function m(he){let ye=0,F=0,q=0,K=0;for(let U=0;U<he.length;U++)q=he.charCodeAt(U),D(q)&&ye++,A(q)&&F++,p(q)&&K++;return(ye===0||F===0)&&K===0?he.length<=30:ye<=5}function f(he,ye){if(!ye||(ye=ye.trim(),ye.length===0)||!m(he)||ye.length>60)return null;const F=l(ye);if(!d(F)){if(!r(F))return null;ye=ye.toLowerCase()}let q=null,K=0;for(he=he.toLowerCase();K<ye.length&&(q=i(he,ye,0,K))===null;)K=h(ye,K+1);return q}e.$Yj=f;function S(he,ye,F=!1){if(!ye||ye.length===0)return null;let q=null,K=0;for(he=he.toLowerCase(),ye=ye.toLowerCase();K<ye.length&&(q=L(he,ye,0,K,F),q===null);)K=v(ye,K+1);return q}e.$Zj=S;function L(he,ye,F,q,K){let U=0;if(F===he.length)return[];if(q===ye.length)return null;if(!o(he.charCodeAt(F),ye.charCodeAt(q))){const Ee=n(he.charCodeAt(F));if(!Ee)return null;for(let Te=0;Te<Ee.length;Te++)if(!o(Ee[Te],ye.charCodeAt(q+Te)))return null;U+=Ee.length-1}let X=null,x=q+U+1;if(X=L(he,ye,F+1,x,K),!K)for(;!X&&(x=v(ye,x))<ye.length;)X=L(he,ye,F+1,x,K),x++;if(!X)return null;if(he.charCodeAt(F)!==ye.charCodeAt(q)){const Ee=n(he.charCodeAt(F));if(!Ee)return X;for(let Te=0;Te<Ee.length;Te++)if(Ee[Te]!==ye.charCodeAt(q+Te))return X}return c({start:q,end:q+U+1},X)}function v(he,ye){for(let F=ye;F<he.length;F++)if(s(he.charCodeAt(F))||F>0&&s(he.charCodeAt(F-1)))return F;return he.length}const y=M(e.$Uj,f,$),k=M(e.$Uj,f,g),N=new E.$Dc(1e4);function O(he,ye,F=!1){if(typeof he!="string"||typeof ye!="string")return null;let q=N.get(he);q||(q=new RegExp(C.$Ve(he),"i"),N.set(he,q));const K=q.exec(ye);return K?[{start:K.index,end:K.index+K[0].length}]:F?k(he,ye):y(he,ye)}e.$1j=O;function G(he,ye){const F=ce(he,he.toLowerCase(),0,ye,ye.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?z(F):null}e.$2j=G;function W(he,ye,F,q,K,U){const X=Math.min(13,he.length);for(;F<X;F++){const x=ce(he,ye,F,q,K,U,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(x)return x}return[0,U]}e.$3j=W;function z(he){if(typeof he>"u")return[];const ye=[],F=he[1];for(let q=he.length-1;q>1;q--){const K=he[q]+F,U=ye[ye.length-1];U&&U.end===K?U.end=K+1:ye.push({start:K,end:K+1})}return ye}e.$4j=z;const P=128;function I(){const he=[],ye=[];for(let F=0;F<=P;F++)ye[F]=0;for(let F=0;F<=P;F++)he.push(ye.slice(0));return he}function H(he){const ye=[];for(let F=0;F<=he;F++)ye[F]=0;return ye}const ae=H(2*P),de=H(2*P),we=I(),ke=I(),le=I(),ve=!1;function se(he,ye,F,q,K){function U(x,Ee,Te=" "){for(;x.length<Ee;)x=Te+x;return x}let X=` |   |${q.split("").map(x=>U(x,3)).join("|")}
`;for(let x=0;x<=F;x++)x===0?X+=" |":X+=`${ye[x-1]}|`,X+=he[x].slice(0,K+1).map(Ee=>U(Ee.toString(),3)).join("|")+`
`;return X}function be(he,ye,F,q){he=he.substr(ye),F=F.substr(q),console.log(se(ke,he,he.length,F,F.length)),console.log(se(le,he,he.length,F,F.length)),console.log(se(we,he,he.length,F,F.length))}function ne(he,ye){if(ye<0||ye>=he.length)return!1;const F=he.codePointAt(ye);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.$sf(F)}}function Y(he,ye){if(ye<0||ye>=he.length)return!1;switch(he.charCodeAt(ye)){case 32:case 9:return!0;default:return!1}}function V(he,ye,F){return ye[he]!==F[he]}function ie(he,ye,F,q,K,U,X=!1){for(;ye<F&&K<U;)he[ye]===q[K]&&(X&&(ae[ye]=K),ye+=1),K+=1;return ye===F}e.$5j=ie;var Ie;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Le;(function(he){he.Default=[-100,0];function ye(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}he.isDefault=ye})(Le||(e.FuzzyScore=Le={}));class Ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ye,F){this.firstMatchCanBeWeak=ye,this.boostFullMatch=F}}e.$6j=Ce;function ce(he,ye,F,q,K,U,X=Ce.default){const x=he.length>P?P:he.length,Ee=q.length>P?P:q.length;if(F>=x||U>=Ee||x-F>Ee-U||!ie(ye,F,x,K,U,Ee,!0))return;te(x,Ee,F,U,ye,K);let Te=1,Ve=1,He=F,Ye=U;const st=[!1];for(Te=1,He=F;He<x;Te++,He++){const je=ae[He],vt=de[He],Z=He+1<x?de[He+1]:Ee;for(Ve=je-U+1,Ye=je;Ye<Z;Ve++,Ye++){let _=Number.MIN_SAFE_INTEGER,$e=!1;Ye<=vt&&(_=Q(he,ye,He,F,q,K,Ye,Ee,U,we[Te-1][Ve-1]===0,st));let Be=0;_!==Number.MAX_SAFE_INTEGER&&($e=!0,Be=_+ke[Te-1][Ve-1]);const Qe=Ye>je,it=Qe?ke[Te][Ve-1]+(we[Te][Ve-1]>0?-5:0):0,rt=Ye>je+1&&we[Te][Ve-1]>0,Ne=rt?ke[Te][Ve-2]+(we[Te][Ve-2]>0?-5:0):0;if(rt&&(!Qe||Ne>=it)&&(!$e||Ne>=Be))ke[Te][Ve]=Ne,le[Te][Ve]=3,we[Te][Ve]=0;else if(Qe&&(!$e||it>=Be))ke[Te][Ve]=it,le[Te][Ve]=2,we[Te][Ve]=0;else if($e)ke[Te][Ve]=Be,le[Te][Ve]=1,we[Te][Ve]=we[Te-1][Ve-1]+1;else throw new Error("not possible")}}if(ve&&be(he,F,q,U),!st[0]&&!X.firstMatchCanBeWeak)return;Te--,Ve--;const nt=[ke[Te][Ve],U];let tt=0,at=0;for(;Te>=1;){let je=Ve;do{const vt=le[Te][je];if(vt===3)je=je-2;else if(vt===2)je=je-1;else break}while(je>=1);tt>1&&ye[F+Te-1]===K[U+Ve-1]&&!V(je+U-1,q,K)&&tt+1>we[Te][je]&&(je=Ve),je===Ve?tt++:tt=1,at||(at=je),Te--,Ve=je-1,nt.push(Ve)}Ee===x&&X.boostFullMatch&&(nt[0]+=2);const ct=at-x;return nt[0]-=ct,nt}e.$7j=ce;function te(he,ye,F,q,K,U){let X=he-1,x=ye-1;for(;X>=F&&x>=q;)K[X]===U[x]&&(de[X]=x,X--),x--}function Q(he,ye,F,q,K,U,X,x,Ee,Te,Ve){if(ye[F]!==U[X])return Number.MIN_SAFE_INTEGER;let He=1,Ye=!1;return X===F-q?He=he[F]===K[X]?7:5:V(X,K,U)&&(X===0||!V(X-1,K,U))?(He=he[F]===K[X]?7:5,Ye=!0):ne(U,X)&&(X===0||!ne(U,X-1))?He=5:(ne(U,X-1)||Y(U,X-1))&&(He=5,Ye=!0),He>1&&F===q&&(Ve[0]=!0),Ye||(Ye=V(X,K,U)||ne(U,X-1)||Y(U,X-1)),F===q?X>Ee&&(He-=Ye?3:5):Te?He+=Ye?2:0:He+=Ye?0:1,X+1===x&&(He-=Ye?3:5),He}function ee(he,ye,F,q,K,U,X){return pe(he,ye,F,q,K,U,!0,X)}e.$8j=ee;function me(he,ye,F,q,K,U,X){return pe(he,ye,F,q,K,U,!1,X)}e.$9j=me;function pe(he,ye,F,q,K,U,X,x){let Ee=ce(he,ye,F,q,K,U,x);if(Ee&&!X)return Ee;if(he.length>=3){const Te=Math.min(7,he.length-1);for(let Ve=F+1;Ve<Te;Ve++){const He=Ae(he,Ve);if(He){const Ye=ce(He,He.toLowerCase(),F,q,K,U,x);Ye&&(Ye[0]-=3,(!Ee||Ye[0]>Ee[0])&&(Ee=Ye))}}}return Ee}function Ae(he,ye){if(ye+1>=he.length)return;const F=he[ye],q=he[ye+1];if(F!==q)return he.slice(0,ye)+q+F+he.slice(ye+2)}}),define(Pe[31],Re([1,0,11]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const M="error",R="warning",$="warn",g="info",b="ignore";function A(u){return u?E.$_e(M,u)?C.Error:E.$_e(R,u)||E.$_e($,u)?C.Warning:E.$_e(g,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=A;function D(u){switch(u){case C.Error:return M;case C.Warning:return R;case C.Info:return g;default:return b}}C.toString=D}(T||(T={})),e.default=T}),define(Pe[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,11]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const w=p.charCodeAt(0),s=this.b.charCodeAt(this.c);return w-s}value(){return this.b[this.c]}}e.$8h=C;class M{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.$6e)(p,this.b,0,p.length,this.c,this.d):(0,T.$8e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=M;class R{constructor(p=!0,w=!0){this.f=p,this.g=w}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let w=p.length-1;w>=0;w--,this.c--){const s=this.b.charCodeAt(w);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.$6e)(p,this.b,0,p.length,this.d,this.e):(0,T.$8e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=R;var $;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})($||($={}));class g{constructor(p,w){this.f=p,this.g=w,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.$7e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.$7e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.$5e)(p,this.c.query);if(this.d[this.e]===5)return(0,T.$5e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=g;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(A||(A={}));class D{static forUris(p=()=>!1,w=()=>!1){return new D(new g(p,w))}static forPaths(p=!1){return new D(new R(void 0,!p))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new M)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,w){if(w){const s=w.slice(0);(0,E.$Xb)(s);for(const o of s)this.set(o,p)}else{const s=p.slice(0);(0,E.$Xb)(s);for(const o of s)this.set(o[0],o[1])}}set(p,w){const s=this.b.reset(p);let o;this.c||(this.c=new b,this.c.segment=s.value());const t=[];for(o=this.c;;){const a=s.cmp(o.segment);if(a>0)o.left||(o.left=new b,o.left.segment=s.value()),t.push([-1,o]),o=o.left;else if(a<0)o.right||(o.right=new b,o.right.segment=s.value()),t.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new b,o.mid.segment=s.value()),t.push([0,o]),o=o.mid;else break}const n=o.value;o.value=w,o.key=p;for(let a=t.length-1;a>=0;a--){const c=t[a][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=t[a][0],l=t[a+1][0];if(i===1&&l===1)t[a][1]=c.rotateLeft();else if(i===-1&&l===-1)t[a][1]=c.rotateRight();else if(i===1&&l===-1)c.right=t[a+1][1]=t[a+1][1].rotateRight(),t[a][1]=c.rotateLeft();else if(i===-1&&l===1)c.left=t[a+1][1]=t[a+1][1].rotateLeft(),t[a][1]=c.rotateRight();else throw new Error;if(a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const w=this.b.reset(p);let s=this.c;for(;s;){const o=w.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(w.hasNext())w.next(),s=s.mid;else break}return s}has(p){const w=this.d(p);return!(w?.value===void 0&&w?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,w){const s=this.b.reset(p),o=[];let t=this.c;for(;t;){const n=s.cmp(t.segment);if(n>0)o.push([-1,t]),t=t.left;else if(n<0)o.push([1,t]),t=t.right;else if(s.hasNext())s.next(),o.push([0,t]),t=t.mid;else break}if(t){if(w?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:a,value:c,segment:h}=n;this.e(n.key,!1),t.key=a,t.value=c,t.segment=h}}else{const n=t.left??t.right;if(o.length>0){const[a,c]=o[o.length-1];switch(a){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const a=o[n][1];a.updateHeight();const c=a.balanceFactor();if(c>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),o[n][1]=a.rotateLeft()):c<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),o[n][1]=a.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const w=this.b.reset(p);let s=this.c,o;for(;s;){const t=w.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(w.hasNext())w.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(p){return this.g(p,!1)}g(p,w){const s=this.b.reset(p);let o=this.c;for(;o;){const t=s.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):w?o.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[w,s]of this)p(s,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const w=[];return this.j(p,w),w[Symbol.iterator]()}j(p,w){p&&(p.left&&this.j(p.left,w),p.value&&w.push([p.key,p.value]),p.mid&&this.j(p.mid,w),p.right&&this.j(p.right,w))}_isBalanced(){const p=w=>{if(!w)return!0;const s=w.balanceFactor();return s<-1||s>1?!1:p(w.left)&&p(w.right)};return p(this.c)}}e.$_h=D}),define(Pe[45],Re([1,0,90]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ak=e.ThemeColor=void 0;var T;(function(R){function $(g){return g&&typeof g=="object"&&typeof g.id=="string"}R.isThemeColor=$})(T||(e.ThemeColor=T={}));function C(R){return{id:R}}e.$ak=C;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function g(n){const a=$.exec(n.id);if(!a)return g(E.$_j.error);const[,c,h]=a,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}R.asClassNameArray=g;function b(n){return g(n).join(" ")}R.asClassName=b;function A(n){return"."+g(n).join(".")}R.asCSSSelector=A;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}R.isThemeIcon=D;const u=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function p(n){const a=u.exec(n);if(!a)return;const[,c]=a;return{id:c}}R.fromString=p;function w(n){return{id:n}}R.fromId=w;function s(n,a){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),a&&(c=`${c}~${a}`),{id:c}}R.modify=s;function o(n){const a=n.id.lastIndexOf("~");if(a!==-1)return n.id.substring(a+1)}R.getModifier=o;function t(n,a){return n.id===a.id&&n.color?.id===a.color?.id}R.isEqual=t})(M||(e.ThemeIcon=M={}))}),define(Pe[126],Re([1,0,124,11,45]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=void 0;const M="$(",R=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function g(t){return t.replace($,(n,a)=>a?n:`\\${n}`)}e.$bk=g;const b=new RegExp(`\\\\${R.source}`,"g");function A(t){return t.replace(b,n=>`\\${n}`)}e.$ck=A;const D=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function u(t){return t.indexOf(M)===-1?t:t.replace(D,(n,a,c,h)=>c?n:a||h||"")}e.$dk=u;function p(t){return t?t.replace(/\$\((.*?)\)/g,(n,a)=>` ${a} `).trim():""}e.$ek=p;const w=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(t){w.lastIndex=0;let n="";const a=[];let c=0;for(;;){const h=w.lastIndex,i=w.exec(t),l=t.substring(h,i?.index);if(l.length>0){n+=l;for(let r=0;r<l.length;r++)a.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:a}}e.$fk=s;function o(t,n,a=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,E.$1j)(t,c,a);const i=(0,T.$Te)(c," "),l=c.length-i.length,r=(0,E.$1j)(t,i,a);if(r)for(const d of r){const m=h[d.start+l]+l;d.start+=m,d.end+=m}return r}e.$gk=o}),define(Pe[33],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(C){return E.test(C)}e.$pg=T,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function($){for(let g=0;g<$.length;g++)$[g]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let g=0,b="";return b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b+="-",b+=R[M[g++]],b+=R[M[g++]],b+="-",b+=R[M[g++]],b+=R[M[g++]],b+="-",b+=R[M[g++]],b+=R[M[g++]],b+="-",b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b+=R[M[g++]],b}}()}),define(Pe[127],Re([1,0,18,67,33]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.$pt=e.$ot=e.$nt=void 0;function M(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$nt=M;function R(D,u,p){const w={id:(0,C.$qg)(),name:D,uri:u,data:p};return{asString:async()=>"",asFile:()=>w,value:void 0}}e.$ot=R;class ${constructor(){this.a=new Map}get size(){let u=0;for(const p of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const p=[...this.a.keys()];return T.Iterable.some(this,([w,s])=>s.asFile())&&p.push("files"),A(g(u),p)}get(u){return this.a.get(this.b(u))?.[0]}append(u,p){const w=this.a.get(u);w?w.push(p):this.a.set(this.b(u),[p])}replace(u,p){this.a.set(this.b(u),[p])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,p]of this.a)for(const w of p)yield[u,w]}b(u){return g(u)}}e.$pt=$;function g(D){return D.toLowerCase()}function b(D,u){return A(g(D),u.map(g))}e.$qt=b;function A(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const p=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[w,s,o]=p;return o==="*"?u.some(t=>t.startsWith(s+"/")):!1}e.$rt=Object.freeze({create:D=>(0,E.$Mb)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$rt.split(D).filter(u=>!u.startsWith("#"))})}),define(Pe[128],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.StringEOL=void 0;var E;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(C){let M=0,R=0,$=0,g=0;for(let b=0,A=C.length;b<A;b++){const D=C.charCodeAt(b);D===13?(M===0&&(R=b),M++,b+1<A&&C.charCodeAt(b+1)===10?(g|=2,b++):g|=3,$=b+1):D===10&&(g|=1,M===0&&(R=b),M++,$=b+1)}return M===0&&(R=C.length),[M,R,C.length-$,g]}e.$ut=T}),define(Pe[129],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0,e.$ss={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.$Rt=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let g=0,b=$.notIn.length;g<b;g++)switch($.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,g){if($.getTokenCount()===0)return!0;const b=$.findTokenIndexAtOffset(g-2),A=$.getStandardTokenType(b);return this.isOK(A)}g($,g){for(let b=$;b<=g;b++){const A=String.fromCharCode(b);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Rt=T;class C{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of $)M(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),M(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),M(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),M(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&M(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$St=C;function M(R,$,g){R.has($)?R.get($).push(g):R.set($,[g])}}),define(Pe[131],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.NodeColor=e.$SB=void 0;class E{constructor(o,t){this.piece=o,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$TB)return C(this.right);let o=this;for(;o.parent!==e.$TB&&o.parent.left!==o;)o=o.parent;return o.parent===e.$TB?e.$TB:o.parent}prev(){if(this.left!==e.$TB)return M(this.left);let o=this;for(;o.parent!==e.$TB&&o.parent.right!==o;)o=o.parent;return o.parent===e.$TB?e.$TB:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$SB=E;var T;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$TB=new E(null,0),e.$TB.parent=e.$TB,e.$TB.left=e.$TB,e.$TB.right=e.$TB,e.$TB.color=0;function C(s){for(;s.left!==e.$TB;)s=s.left;return s}e.$UB=C;function M(s){for(;s.right!==e.$TB;)s=s.right;return s}e.$VB=M;function R(s){return s===e.$TB?0:s.size_left+s.piece.length+R(s.right)}function $(s){return s===e.$TB?0:s.lf_left+s.piece.lineFeedCnt+$(s.right)}function g(){e.$TB.parent=e.$TB}function b(s,o){const t=o.right;t.size_left+=o.size_left+(o.piece?o.piece.length:0),t.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=t.left,t.left!==e.$TB&&(t.left.parent=o),t.parent=o.parent,o.parent===e.$TB?s.root=t:o.parent.left===o?o.parent.left=t:o.parent.right=t,t.left=o,o.parent=t}e.$WB=b;function A(s,o){const t=o.left;o.left=t.right,t.right!==e.$TB&&(t.right.parent=o),t.parent=o.parent,o.size_left-=t.size_left+(t.piece?t.piece.length:0),o.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),o.parent===e.$TB?s.root=t:o===o.parent.right?o.parent.right=t:o.parent.left=t,t.right=o,o.parent=t}e.$XB=A;function D(s,o){let t,n;if(o.left===e.$TB?(n=o,t=n.right):o.right===e.$TB?(n=o,t=n.left):(n=C(o.right),t=n.right),n===s.root){s.root=t,t.color=0,o.detach(),g(),s.root.parent=e.$TB;return}const a=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===o?(t.parent=n.parent,w(s,t)):(n.parent===o?t.parent=n:t.parent=n.parent,w(s,t),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===s.root?s.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$TB&&(n.left.parent=n),n.right!==e.$TB&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,w(s,n)),o.detach(),t.parent.left===t){const h=R(t),i=$(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const l=h-t.parent.size_left,r=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,p(s,t.parent,l,r)}}if(w(s,t.parent),a){g();return}let c;for(;t!==s.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,b(s,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,A(s,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,b(s,t.parent),t=s.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,A(s,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,b(s,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,A(s,t.parent),t=s.root));t.color=0,g()}e.$YB=D;function u(s,o){for(w(s,o);o!==s.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const t=o.parent.parent.right;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,b(s,o)),o.parent.color=0,o.parent.parent.color=1,A(s,o.parent.parent))}else{const t=o.parent.parent.left;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,A(s,o)),o.parent.color=0,o.parent.parent.color=1,b(s,o.parent.parent))}s.root.color=0}e.$ZB=u;function p(s,o,t,n){for(;o!==s.root&&o!==e.$TB;)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}e.$1B=p;function w(s,o){let t=0,n=0;if(o!==s.root){for(;o!==s.root&&o===o.parent.right;)o=o.parent;if(o!==s.root)for(o=o.parent,t=R(o.left)-o.size_left,n=$(o.left)-o.lf_left,o.size_left+=t,o.lf_left+=n;o!==s.root&&(t!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}}e.$2B=w}),define(Pe[91],Re([1,0,92,29,93,131,94]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=void 0;const $=65535;function g(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class b{constructor(n,a,c,h,i){this.lineStarts=n,this.cr=a,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function A(t,n=!0){const a=[0];let c=1;for(let h=0,i=t.length;h<i;h++){const l=t.charCodeAt(h);l===13?h+1<i&&t.charCodeAt(h+1)===10?(a[c++]=h+2,h++):a[c++]=h+1:l===10&&(a[c++]=h+1)}return n?g(a):a}e.$9B=A;function D(t,n){t.length=0,t[0]=0;let a=1,c=0,h=0,i=0,l=!0;for(let d=0,m=n.length;d<m;d++){const f=n.charCodeAt(d);f===13?d+1<m&&n.charCodeAt(d+1)===10?(i++,t[a++]=d+2,d++):(c++,t[a++]=d+1):f===10?(h++,t[a++]=d+1):l&&f!==9&&(f<32||f>126)&&(l=!1)}const r=new b(g(t),c,h,i,l);return t.length=0,r}e.$0B=D;class u{constructor(n,a,c,h,i){this.bufferIndex=n,this.start=a,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$$B=u;class p{constructor(n,a){this.buffer=n,this.lineStarts=a}}e.$_B=p;class w{constructor(n,a){this.a=[],this.c=n,this.d=a,this.b=0,n.root!==M.$TB&&n.iterate(n.root,c=>(c!==M.$TB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let a=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,a=!0;continue}}if(a){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(n,a,c){this.create(n,a,c)}create(n,a,c){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=M.$TB,this.b=1,this.c=0,this.d=a,this.e=a.length,this.f=c;let h=null;for(let i=0,l=n.length;i<l;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=A(n[i].buffer));const r=new u(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,r)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const a=$,c=a-Math.floor(a/3),h=c*2;let i="",l=0;const r=[];if(this.iterate(this.root,d=>{const m=this.R(d),f=m.length;if(l<=c||l+f<h)return i+=m,l+=f,!0;const S=i.replace(/\r\n|\r|\n/g,n);return r.push(new p(S,A(S))),i=m,l=f,!0}),l>0){const d=i.replace(/\r\n|\r|\n/g,n);r.push(new p(d,A(d)))}this.create(r,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new w(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let a=0;return this.iterate(this.root,h=>{if(h===M.$TB)return!0;const i=this.R(h),l=i.length,r=n.G(a),d=n.G(a+l),m=n.getValueInRange2(r,d);return a+=l,i===m})}getOffsetAt(n,a){let c=0,h=this.root;for(;h!==M.$TB;)if(h.left!==M.$TB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+a-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let a=this.root,c=0;const h=n;for(;a!==M.$TB;)if(a.size_left!==0&&a.size_left>=n)a=a.left;else if(a.size_left+a.piece.length>=n){const i=this.A(a,n-a.size_left);if(c+=a.lf_left+i.index,i.index===0){const l=this.getOffsetAt(c+1,1),r=h-l;return new E.$Ts(c+1,r+1)}return new E.$Ts(c+1,i.remainder+1)}else if(n-=a.size_left+a.piece.length,c+=a.lf_left+a.piece.lineFeedCnt,a.right===M.$TB){const i=this.getOffsetAt(c+1,1),l=h-n-i;return new E.$Ts(c+1,l+1)}else a=a.right;return new E.$Ts(1,1)}getValueInRange(n,a){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return a?a!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,a):i}getValueInRange2(n,a){if(n.node===a.node){const r=n.node,d=this.a[r.piece.bufferIndex].buffer,m=this.u(r.piece.bufferIndex,r.piece.start);return d.substring(m+n.remainder,m+a.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let l=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==M.$TB;){const r=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===a.node){l+=r.substring(d,d+a.remainder);break}else l+=r.substr(d,c.piece.length);c=c.next()}return l}getLinesContent(){const n=[];let a=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===M.$TB)return!0;const l=i.piece;let r=l.length;if(r===0)return!0;const d=this.a[l.bufferIndex].buffer,m=this.a[l.bufferIndex].lineStarts,f=l.start.line,S=l.end.line;let L=m[f]+l.start.column;if(h&&(d.charCodeAt(L)===10&&(L++,r--),n[a++]=c,c="",h=!1,r===0))return!0;if(f===S)return!this.f&&d.charCodeAt(L+r-1)===13?(h=!0,c+=d.substr(L,r-1)):c+=d.substr(L,r),!0;c+=this.f?d.substring(L,Math.max(L,m[f+1]-this.e)):d.substring(L,m[f+1]).replace(/(\r\n|\r|\n)$/,""),n[a++]=c;for(let v=f+1;v<S;v++)c=this.f?d.substring(m[v],m[v+1]-this.e):d.substring(m[v],m[v+1]).replace(/(\r\n|\r|\n)$/,""),n[a++]=c;return!this.f&&d.charCodeAt(m[S]+l.end.column-1)===13?(h=!0,l.end.column===0?a--:c=d.substr(m[S],l.end.column-1)):c=d.substr(m[S],l.end.column),!0}),h&&(n[a++]=c,c=""),n[a++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const a=n.node.next();if(!a)return 0;const c=this.a[a.piece.bufferIndex],h=this.u(a.piece.bufferIndex,a.piece.start);return c.buffer.charCodeAt(h)}else{const a=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return a.buffer.charCodeAt(h)}}getLineCharCode(n,a){const c=this.H(n,a+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const a=this.getOffsetAt(n,1);return this.getLength()-a}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const a=this.G(n);return this.l(a)}findMatchesInNode(n,a,c,h,i,l,r,d,m,f,S){const L=this.a[n.piece.bufferIndex],v=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,i),k=this.u(n.piece.bufferIndex,l);let N;const O={line:0,column:0};let G,W;a._wordSeparators?(G=L.buffer.substring(y,k),W=z=>z+y,a.reset(0)):(G=L.buffer,W=z=>z,a.reset(y));do if(N=a.next(G),N){if(W(N.index)>=k)return f;this.s(n,W(N.index)-v,O);const z=this.t(n.piece.bufferIndex,i,O),P=O.line===i.line?O.column-i.column+h:O.column+1,I=P+N[0].length;if(S[f++]=(0,R.$5B)(new T.$Us(c+z,P,c+z,I),N,d),W(N.index)+N[0].length>=k||f>=m)return f}while(N);return f}findMatchesLineByLine(n,a,c,h){const i=[];let l=0;const r=new R.$8B(a.wordSeparators,a.regex);let d=this.H(n.startLineNumber,n.startColumn);if(d===null)return[];const m=this.H(n.endLineNumber,n.endColumn);if(m===null)return[];let f=this.s(d.node,d.remainder);const S=this.s(m.node,m.remainder);if(d.node===m.node)return this.findMatchesInNode(d.node,r,n.startLineNumber,n.startColumn,f,S,a,c,h,l,i),i;let L=n.startLineNumber,v=d.node;for(;v!==m.node;){const k=this.t(v.piece.bufferIndex,f,v.piece.end);if(k>=1){const O=this.a[v.piece.bufferIndex].lineStarts,G=this.u(v.piece.bufferIndex,v.piece.start),W=O[f.line+k],z=L===n.startLineNumber?n.startColumn:1;if(l=this.findMatchesInNode(v,r,L,z,f,this.s(v,W-G),a,c,h,l,i),l>=h)return i;L+=k}const N=L===n.startLineNumber?n.startColumn-1:0;if(L===n.endLineNumber){const O=this.getLineContent(L).substring(N,n.endColumn-1);return l=this.n(a,r,O,n.endLineNumber,N,l,i,c,h),i}if(l=this.n(a,r,this.getLineContent(L).substr(N),L,N,l,i,c,h),l>=h)return i;L++,d=this.H(L,1),v=d.node,f=this.s(d.node,d.remainder)}if(L===n.endLineNumber){const k=L===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(L).substring(k,n.endColumn-1);return l=this.n(a,r,N,n.endLineNumber,k,l,i,c,h),i}const y=L===n.startLineNumber?n.startColumn:1;return l=this.findMatchesInNode(m.node,r,L,y,f,S,a,c,h,l,i),i}n(n,a,c,h,i,l,r,d,m){const f=n.wordSeparators;if(!d&&n.simpleSearch){const L=n.simpleSearch,v=L.length,y=c.length;let k=-v;for(;(k=c.indexOf(L,k+v))!==-1;)if((!f||(0,R.$7B)(f,c,y,k,v))&&(r[l++]=new C.$av(new T.$Us(h,k+1+i,h,k+1+v+i),null),l>=m))return l;return l}let S;a.reset(0);do if(S=a.next(c),S&&(r[l++]=(0,R.$5B)(new T.$Us(h,S.index+1+i,h,S.index+1+S[0].length+i),S,d),l>=m))return l;while(S);return l}insert(n,a,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==M.$TB){const{node:h,remainder:i,nodeStartOffset:l}=this.G(n),r=h.piece,d=r.bufferIndex,m=this.s(h,i);if(h.piece.bufferIndex===0&&r.end.line===this.g.line&&r.end.column===this.g.column&&l+r.length===n&&a.length<$){this.F(h,a),this.y();return}if(l===n)this.o(a,h),this.h.validate(n);else if(l+h.piece.length>n){const f=[];let S=new u(r.bufferIndex,m,r.end,this.t(r.bufferIndex,m,r.end),this.u(d,r.end)-this.u(d,m));if(this.K()&&this.M(a)&&this.I(h,i)===10){const k={line:S.start.line+1,column:0};S=new u(S.bufferIndex,k,S.end,this.t(S.bufferIndex,k,S.end),S.length-1),a+=`
`}if(this.K()&&this.L(a))if(this.I(h,i-1)===13){const k=this.s(h,i-1);this.C(h,k),a="\r"+a,h.piece.length===0&&f.push(h)}else this.C(h,m);else this.C(h,m);const L=this.w(a);S.length>0&&this.S(h,S);let v=h;for(let y=0;y<L.length;y++)v=this.S(v,L[y]);this.v(f)}else this.q(a,h)}else{const h=this.w(a);let i=this.T(null,h[0]);for(let l=1;l<h.length;l++)i=this.S(i,h[l])}this.y()}delete(n,a){if(this.j.lineNumber=0,this.j.value="",a<=0||this.root===M.$TB)return;const c=this.G(n),h=this.G(n+a),i=c.node,l=h.node;if(i===l){const L=this.s(i,c.remainder),v=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(a===i.piece.length){const y=i.next();(0,M.$YB)(this,i),this.N(y),this.y();return}this.D(i,v),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+a){this.C(i,L),this.O(i),this.y();return}this.E(i,L,v),this.y();return}const r=[],d=this.s(i,c.remainder);this.C(i,d),this.h.validate(n),i.piece.length===0&&r.push(i);const m=this.s(l,h.remainder);this.D(l,m),l.piece.length===0&&r.push(l);const f=i.next();for(let L=f;L!==M.$TB&&L!==l;L=L.next())r.push(L);const S=i.piece.length===0?i.prev():i;this.v(r),this.O(S),this.y()}o(n,a){const c=[];if(this.K()&&this.M(n)&&this.L(a)){const l=a.piece,r={line:l.start.line+1,column:0},d=new u(l.bufferIndex,r,l.end,this.t(l.bufferIndex,r,l.end),l.length-1);a.piece=d,n+=`
`,(0,M.$1B)(this,a,-1,-1),a.piece.length===0&&c.push(a)}const h=this.w(n);let i=this.T(a,h[h.length-1]);for(let l=h.length-2;l>=0;l--)i=this.T(i,h[l]);this.N(i),this.v(c)}q(n,a){this.Q(n,a)&&(n+=`
`);const c=this.w(n),h=this.S(a,c[0]);let i=h;for(let l=1;l<c.length;l++)i=this.S(i,c[l]);this.N(h)}s(n,a,c){const h=n.piece,i=n.piece.bufferIndex,l=this.a[i].lineStarts,d=l[h.start.line]+h.start.column+a;let m=h.start.line,f=h.end.line,S=0,L=0,v=0;for(;m<=f&&(S=m+(f-m)/2|0,v=l[S],S!==f);)if(L=l[S+1],d<v)f=S-1;else if(d>=L)m=S+1;else break;return c?(c.line=S,c.column=d-v,null):{line:S,column:d-v}}t(n,a,c){if(c.column===0)return c.line-a.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-a.line;const i=h[c.line+1],l=h[c.line]+c.column;if(i>l+1)return c.line-a.line;const r=l-1;return this.a[n].buffer.charCodeAt(r)===13?c.line-a.line+1:c.line-a.line}u(n,a){return this.a[n].lineStarts[a.line]+a.column}v(n){for(let a=0;a<n.length;a++)(0,M.$YB)(this,n[a])}w(n){if(n.length>$){const f=[];for(;n.length>$;){const L=n.charCodeAt($-1);let v;L===13||L>=55296&&L<=56319?(v=n.substring(0,$-1),n=n.substring($-1)):(v=n.substring(0,$),n=n.substring($));const y=A(v);f.push(new u(this.a.length,{line:0,column:0},{line:y.length-1,column:v.length-y[y.length-1]},y.length-1,v.length)),this.a.push(new p(v,y))}const S=A(n);return f.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:n.length-S[S.length-1]},S.length-1,n.length)),this.a.push(new p(n,S)),f}let a=this.a[0].buffer.length;const c=A(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===a&&a!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=a+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,a+=1}else{if(a!==0)for(let f=0;f<c.length;f++)c[f]+=a;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,l=this.a[0].lineStarts.length-1,r=i-this.a[0].lineStarts[l],d={line:l,column:r},m=new u(0,h,d,this.t(0,h,d),i-a);return this.g=d,[m]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,a=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const l=this.B(c,n-i.nodeStartLineNumber-1),r=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=r.substring(d+l,d+c.piece.length);else{const m=this.B(c,n-i.nodeStartLineNumber);return r.substring(d+l,d+m-a)}}else{let l=0;const r=n;for(;c!==M.$TB;)if(c.left!==M.$TB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const d=this.B(c,n-c.lf_left-2),m=this.B(c,n-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);return l+=c.size_left,this.h.set({node:c,nodeStartOffset:l,nodeStartLineNumber:r-(n-1-c.lf_left)}),f.substring(S+d,S+m-a)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const d=this.B(c,n-c.lf_left-2),m=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=m.substring(f+d,f+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,l+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==M.$TB;){const l=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const r=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return h+=l.substring(d,d+r-a),h}else{const r=this.u(c.piece.bufferIndex,c.piece.start);h+=l.substr(r,c.piece.length)}c=c.next()}return h}y(){let n=this.root,a=1,c=0;for(;n!==M.$TB;)a+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=a,this.c=c,this.h.validate(this.c)}A(n,a){const c=n.piece,h=this.s(n,a),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===a){const l=this.t(n.piece.bufferIndex,c.start,h);if(l!==i)return{index:l,remainder:0}}return{index:i,remainder:h.column}}B(n,a){if(a<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+a+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,a){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),l=a,r=this.u(c.bufferIndex,l),d=this.t(c.bufferIndex,c.start,l),m=d-h,f=r-i,S=c.length+f;n.piece=new u(c.bufferIndex,c.start,l,d,S),(0,M.$1B)(this,n,f,m)}D(n,a){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),l=a,r=this.t(c.bufferIndex,l,c.end),d=this.u(c.bufferIndex,l),m=r-h,f=i-d,S=c.length+f;n.piece=new u(c.bufferIndex,l,c.end,r,S),(0,M.$1B)(this,n,f,m)}E(n,a,c){const h=n.piece,i=h.start,l=h.end,r=h.length,d=h.lineFeedCnt,m=a,f=this.t(h.bufferIndex,h.start,m),S=this.u(h.bufferIndex,a)-this.u(h.bufferIndex,i);n.piece=new u(h.bufferIndex,h.start,m,f,S),(0,M.$1B)(this,n,S-r,f-d);const L=new u(h.bufferIndex,c,l,this.t(h.bufferIndex,c,l),this.u(h.bufferIndex,l)-this.u(h.bufferIndex,c)),v=this.S(n,L);this.N(v)}F(n,a){this.Q(a,n)&&(a+=`
`);const c=this.K()&&this.L(a)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=a;const i=A(a,!1);for(let v=0;v<i.length;v++)i[v]+=h;if(c){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const l=this.a[0].lineStarts.length-1,r=this.a[0].buffer.length-this.a[0].lineStarts[l],d={line:l,column:r},m=n.piece.length+a.length,f=n.piece.lineFeedCnt,S=this.t(0,n.piece.start,d),L=S-f;n.piece=new u(n.piece.bufferIndex,n.piece.start,d,S,m),this.g=d,(0,M.$1B)(this,n,a.length,L)}G(n){let a=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;a!==M.$TB;)if(a.size_left>n)a=a.left;else if(a.size_left+a.piece.length>=n){h+=a.size_left;const i={node:a,remainder:n-a.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=a.size_left+a.piece.length,h+=a.size_left+a.piece.length,a=a.right;return null}H(n,a){let c=this.root,h=0;for(;c!==M.$TB;)if(c.left!==M.$TB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),l=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+a-1,l),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+a-1<=c.piece.length)return{node:c,remainder:i+a-1,nodeStartOffset:h};a-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==M.$TB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),l=this.J(c);return{node:c,remainder:Math.min(a-1,i),nodeStartOffset:l}}else if(c.piece.length>=a-1){const i=this.J(c);return{node:c,remainder:a-1,nodeStartOffset:i}}else a-=c.piece.length;c=c.next()}return null}I(n,a){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+a;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let a=n.size_left;for(;n!==this.root;)n.parent.right===n&&(a+=n.parent.size_left+n.parent.piece.length),n=n.parent;return a}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$TB||n.piece.lineFeedCnt===0)return!1;const a=n.piece,c=this.a[a.bufferIndex].lineStarts,h=a.start.line,i=c[h]+a.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[a.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$TB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const a=n.prev();this.M(a)&&this.P(a,n)}}O(n){if(this.K()&&this.M(n)){const a=n.next();this.L(a)&&this.P(n,a)}}P(n,a){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const l=n.piece.length-1,r=n.piece.lineFeedCnt-1;n.piece=new u(n.piece.bufferIndex,n.piece.start,i,r,l),(0,M.$1B)(this,n,-1,-1),n.piece.length===0&&c.push(n);const d={line:a.piece.start.line+1,column:0},m=a.piece.length-1,f=this.t(a.piece.bufferIndex,d,a.piece.end);a.piece=new u(a.piece.bufferIndex,d,a.piece.end,f,m),(0,M.$1B)(this,a,-1,-1),a.piece.length===0&&c.push(a);const S=this.w(`\r
`);this.S(n,S[0]);for(let L=0;L<c.length;L++)(0,M.$YB)(this,c[L])}Q(n,a){if(this.K()&&this.M(n)){const c=a.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,M.$YB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},l=h.length-1,r=this.t(h.bufferIndex,i,h.end);c.piece=new u(h.bufferIndex,i,h.end,r,l),(0,M.$1B)(this,c,-1,-1)}return!0}}return!1}iterate(n,a){if(n===M.$TB)return a(M.$TB);const c=this.iterate(n.left,a);return c&&a(n)&&this.iterate(n.right,a)}R(n){if(n===M.$TB)return"";const a=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return a.buffer.substring(h,i)}getPieceContent(n){const a=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return a.buffer.substring(c,h)}S(n,a){const c=new M.$SB(a,1);if(c.left=M.$TB,c.right=M.$TB,c.parent=M.$TB,c.size_left=0,c.lf_left=0,this.root===M.$TB)this.root=c,c.color=0;else if(n.right===M.$TB)n.right=c,c.parent=n;else{const i=(0,M.$UB)(n.right);i.left=c,c.parent=i}return(0,M.$ZB)(this,c),c}T(n,a){const c=new M.$SB(a,1);if(c.left=M.$TB,c.right=M.$TB,c.parent=M.$TB,c.size_left=0,c.lf_left=0,this.root===M.$TB)this.root=c,c.color=0;else if(n.left===M.$TB)n.left=c,c.parent=n;else{const h=(0,M.$VB)(n.left);h.right=c,c.parent=h}return(0,M.$ZB)(this,c),c}U(n){let a="";return this.iterate(n,c=>(a+=this.R(c),!0)),a}}e.$aC=o}),define(Pe[132],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8=e.$j8=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$j8=E;class T{constructor(M){this.identifier=M}}e.$k8=T}),define(Pe[133],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Pe[134],Re([1,0,5,6,133]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class M extends T.$Tc{constructor(u,p="",w="",s=!0,o){super(),this.h=this.B(new E.$Vd),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=p,this.u=w,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,p){this.C&&await this.C(u)}}e.$Ki=M;class R extends T.$Tc{constructor(){super(...arguments),this.f=this.B(new E.$Vd),this.onWillRun=this.f.event,this.m=this.B(new E.$Vd),this.onDidRun=this.m.event}async run(u,p){if(!u.enabled)return;this.f.fire({action:u});let w;try{await this.u(u,p)}catch(s){w=s}this.m.fire({action:u,error:w})}async u(u,p){await u.run(p)}}e.$Li=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let p=[];for(const w of u)w.length&&(p.length?p=[...p,new $,...w]:p=w);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Mi=$;class g{get actions(){return this.a}constructor(u,p,w,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=p,this.class=s,this.a=w}async run(){}}e.$Ni=g;class b extends M{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,C.localize(0,null),void 0,!1)}}e.$Oi=b;function A(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...u)=>D.run(...u),tooltip:D.label}}e.$Pi=A}),define(Pe[135],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Pe[136],Re([1,0,135]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const T=60,C=T*60,M=C*24,R=M*7,$=M*30,g=M*365;function b(D,u,p,w){typeof D!="number"&&(D=D.getTime());const s=Math.round((new Date().getTime()-D)/1e3);if(s<-30)return(0,E.localize)(0,null,b(new Date().getTime()+s*1e3,!1));if(!w&&s<30)return(0,E.localize)(1,null);let o;return s<T?(o=s,u?o===1?p?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):p?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?p?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):p?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):s<C?(o=Math.floor(s/T),u?o===1?p?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):p?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?p?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):p?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):s<M?(o=Math.floor(s/C),u?o===1?p?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):p?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?p?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):p?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):s<R?(o=Math.floor(s/M),u?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):s<$?(o=Math.floor(s/R),u?o===1?p?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):p?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?p?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):p?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):s<g?(o=Math.floor(s/$),u?o===1?p?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):p?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?p?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):p?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(s/g),u?o===1?p?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):p?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?p?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):p?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.$vm=b;function A(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=A}),define(Pe[137],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Pe[40],Re([1,0,18,16,137]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function M(D,u){return u&&(D.stack||D.stacktrace)?C.localize(0,null,$(D),R(D.stack)||R(D.stacktrace)):$(D)}function R(D){return Array.isArray(D)?D.join(`
`):D}function $(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function g(D=null,u=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const p=E.$Hb(D),w=g(p[0],u);return p.length>1?C.localize(4,null,w,p.length):w}if(T.$If(D))return D;if(D.detail){const p=D.detail;if(p.error)return M(p.error,u);if(p.exception)return M(p.exception,u)}return D.stack?M(D,u):D.message?D.message:C.localize(5,null)}e.$Qi=g;function b(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}e.$Ri=b;function A(D,u){let p;return typeof D=="string"?p=new Error(D):p=D,p.actions=u,p}e.$Si=A}),define(Pe[138],Re([1,0,39,19]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;const C=new E.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),M=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(L,v,y=!1){const k=L||"",N=v||"",O=C.value.collator.compare(k,N);return C.value.collatorIsNumeric&&O===0&&k!==N?k<N?-1:1:O}e.$Iq=$;function g(L,v){const y=M.value.collator;return L=L||"",v=v||"",c(y,L,v)}e.$Jq=g;function b(L,v){const y=M.value.collator;return L=L||"",v=v||"",r(L,v)||c(y,L,v)}e.$Kq=b;function A(L,v){const y=M.value.collator;return L=L||"",v=v||"",l(L,v)||c(y,L,v)}e.$Lq=A;function D(L,v){return L=L||"",v=v||"",L===v?0:L<v?-1:1}e.$Mq=D;function u(L,v){const[y,k]=n(L),[N,O]=n(v);let G=C.value.collator.compare(k,O);if(G===0){if(C.value.collatorIsNumeric&&k!==O)return k<O?-1:1;if(G=C.value.collator.compare(y,N),C.value.collatorIsNumeric&&G===0&&y!==N)return y<N?-1:1}return G}e.$Nq=u;function p(L,v){L=L||"",v=v||"";const y=a(L),k=a(v),N=M.value.collator,O=R.value.collator;return c(O,y,k)||c(N,L,v)}e.$Oq=p;function w(L,v){L=L||"",v=v||"";const y=a(L),k=a(v),N=M.value.collator,O=R.value.collator;return c(O,y,k)||r(L,v)||c(N,L,v)}e.$Pq=w;function s(L,v){L=L||"",v=v||"";const y=a(L),k=a(v),N=M.value.collator,O=R.value.collator;return c(O,y,k)||l(L,v)||c(N,L,v)}e.$Qq=s;function o(L,v){L=L||"",v=v||"";const y=a(L).toLowerCase(),k=a(v).toLowerCase();return y!==k?y<k?-1:1:L!==v?L<v?-1:1:0}e.$Rq=o;const t=/^(.*?)(\.([^.]*))?$/;function n(L,v=!1){const y=L?t.exec(L):[];let k=[y&&y[1]||"",y&&y[3]||""];return v&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function a(L){const v=L?t.exec(L):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function c(L,v,y){const k=L.compare(v,y);return k!==0?k:v.length!==y.length?v.length<y.length?-1:1:0}function h(L){const v=L.charAt(0);return v.toLocaleUpperCase()!==v}function i(L){const v=L.charAt(0);return v.toLocaleLowerCase()!==v}function l(L,v){return h(L)&&i(v)?-1:i(L)&&h(v)?1:0}function r(L,v){return i(L)&&h(v)?-1:h(L)&&i(v)?1:0}function d(L,v,y=!1){return y||(L=L&&L.toLowerCase(),v=v&&v.toLowerCase()),L===v?0:L<v?-1:1}function m(L,v,y=!1){const k=L.split(T.sep),N=v.split(T.sep),O=k.length-1,G=N.length-1;let W,z;for(let P=0;;P++){if(W=O===P,z=G===P,W&&z)return $(k[P],N[P],y);if(W)return-1;if(z)return 1;const I=d(k[P],N[P],y);if(I!==0)return I}}e.$Sq=m;function f(L,v,y){const k=L.toLowerCase(),N=v.toLowerCase(),O=S(L,v,y);if(O)return O;const G=k.endsWith(y),W=N.endsWith(y);if(G!==W)return G?-1:1;const z=$(k,N);return z!==0?z:k.localeCompare(N)}e.$Tq=f;function S(L,v,y){const k=L.toLowerCase(),N=v.toLowerCase(),O=k.startsWith(y),G=N.startsWith(y);if(O!==G)return O?-1:1;if(O&&G){if(k.length<N.length)return-1;if(k.length>N.length)return 1}return 0}e.$Uq=S}),define(Pe[46],Re([1,0,19,21,11,16]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function R(f){return f===47||f===92}e.$1f=R;function $(f){return f.replace(/[\\/]/g,E.$gc.sep)}e.$2f=$;function g(f){return f.indexOf("/")===-1&&(f=$(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$3f=g;function b(f,S=E.$gc.sep){if(!f)return"";const L=f.length,v=f.charCodeAt(0);if(R(v)){if(R(f.charCodeAt(1))&&!R(f.charCodeAt(2))){let k=3;const N=k;for(;k<L&&!R(f.charCodeAt(k));k++);if(N!==k&&!R(f.charCodeAt(k+1))){for(k+=1;k<L;k++)if(R(f.charCodeAt(k)))return f.slice(0,k+1).replace(/[\\/]/g,S)}}return S}else if(t(v)&&f.charCodeAt(1)===58)return R(f.charCodeAt(2))?f.slice(0,2)+S:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<L;y++)if(R(f.charCodeAt(y)))return f.slice(0,y+1)}return""}e.$4f=b;function A(f){if(!T.$i||!f||f.length<5)return!1;let S=f.charCodeAt(0);if(S!==92||(S=f.charCodeAt(1),S!==92))return!1;let L=2;const v=L;for(;L<f.length&&(S=f.charCodeAt(L),S!==92);L++);return!(v===L||(S=f.charCodeAt(L+1),isNaN(S)||S===92))}e.$5f=A;const D=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(f,S=T.$i){const L=S?D:u;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||S&&p.test(f)||f==="."||f===".."||S&&f[f.length-1]==="."||S&&f.length!==f.trim().length||f.length>255)}e.$6f=w;function s(f,S,L){const v=f===S;return!L||v?v:!f||!S?!1:(0,C.$_e)(f,S)}e.$7f=s;function o(f,S,L,v=E.sep){if(f===S)return!0;if(!f||!S||S.length>f.length)return!1;if(L){if(!(0,C.$af)(f,S))return!1;if(S.length===f.length)return!0;let k=S.length;return S.charAt(S.length-1)===v&&k--,f.charAt(k)===v}return S.charAt(S.length-1)!==v&&(S+=v),f.indexOf(S)===0}e.$8f=o;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.$9f=t;function n(f,S){return T.$i&&f.endsWith(":")&&(f+=E.sep),(0,E.$ic)(f)||(f=(0,E.$jc)(S,f)),f=(0,E.$hc)(f),T.$i?(f=(0,C.$Ue)(f,E.sep),f.endsWith(":")&&(f+=E.sep)):(f=(0,C.$Ue)(f,E.sep),f||(f=E.sep)),f}e.$0f=n;function a(f){const S=(0,E.$hc)(f);return T.$i?f.length>3?!1:c(S)&&(f.length===2||S.charCodeAt(2)===92):S===E.$gc.sep}e.$$f=a;function c(f,S=T.$i){return S?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$_f=c;function h(f,S=T.$i){return c(f,S)?f[0]:void 0}e.$ag=h;function i(f,S,L){return S.length>f.length?-1:f===S?0:(L&&(f=f.toLowerCase(),S=S.toLowerCase()),f.indexOf(S))}e.$bg=i;function l(f){const S=f.split(":");let L,v,y;for(const k of S){const N=Number(k);(0,M.$Mf)(N)?v===void 0?v=N:y===void 0&&(y=N):L=L?[L,k].join(":"):k}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:v!==void 0?v:void 0,column:y!==void 0?y:v!==void 0?1:void 0}}e.$cg=l;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(f,S,L=8){let v="";for(let k=0;k<L;k++){let N;k===0&&T.$i&&!S&&(L===3||L===4)?N=d:N=r,v+=N.charAt(Math.floor(Math.random()*N.length))}let y;return S?y=`${S}-${v}`:y=v,f?(0,E.$jc)(f,y):y}e.$dg=m}),define(Pe[68],Re([1,0,19]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const D=(0,E.$oc)(A),u=T[D.toLowerCase()];return u!==void 0?u:R(A)}e.$gs=M;function R(A){const D=(0,E.$oc)(A);return C[D.toLowerCase()]}e.$hs=R;function $(A){for(const D in C)if(C[D]===A)return D}e.$is=$;const g=/^(.+)\/(.+?)(;.+)?$/;function b(A,D){const u=g.exec(A);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:A}e.$js=b}),define(Pe[51],Re([1,0,24,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function C(g){return JSON.stringify(g,R)}e.$Ah=C;function M(g){let b=JSON.parse(g);return b=$(b),b}e.$Bh=M;function R(g,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function $(g,b=0){if(!g||b>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof E.$je||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let A=0;A<g.length;++A)g[A]=$(g[A],b+1);else for(const A in g)Object.hasOwnProperty.call(g,A)&&(g[A]=$(g[A],b+1))}return g}e.$Ch=$}),define(Pe[12],Re([1,0,15,21,11,2]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var R;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function $(u,p){return M.URI.isUri(u)?(0,C.$_e)(u.scheme,p):(0,C.$af)(u,p+":")}e.$eg=$;function g(u,...p){return p.some(w=>$(u,w))}e.$fg=g,e.$gg="vscode-tkn",e.$hg="tkn";class b{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${R.vscodeRemoteResource}`}set(p,w,s){this.a[p]=w,this.b[p]=s}setConnectionToken(p,w){this.c[p]=w}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(a){return E.$1(a),p}const w=p.authority;let s=this.a[w];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const o=this.b[w],t=this.c[w];let n=`path=${encodeURIComponent(p.path)}`;return typeof t=="string"&&(n+=`&${e.$hg}=${encodeURIComponent(t)}`),M.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${s}:${o}`,path:this.f,query:n})}}e.$ig=new b,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class A{static{this.a=e.$ng}asBrowserUri(p){const w=this.b(p,ge);return this.uriToBrowserUri(w)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.$ig.rewrite(p):p.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${A.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||A.a,query:null,fragment:null}):p}asFileUri(p){const w=this.b(p,ge);return this.uriToFileUri(w)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==A.a?p.authority:null,query:null,fragment:null}):p}b(p,w){return M.URI.isUri(p)?p:M.URI.parse(w.toUrl(p))}}e.$og=new A;var D;(function(u){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(p.get("3"));const w="vscode-coi";function s(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:M.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const a=n?.get(w);if(a)return p.get(a)}u.getHeadersFromQuery=s;function o(t,n,a){if(!globalThis.crossOriginIsolated)return;const c=n&&a?"3":a?"2":"1";t instanceof URLSearchParams?t.set(w,c):t[w]=c}u.addSearchParam=o})(D||(e.COI=D={}))}),define(Pe[25],Re([1,0,46,12,19,21,11,2]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function g(p){return(0,$.$wc)(p,!0)}e.$vg=g;class b{constructor(w){this.a=w}compare(w,s,o=!1){return w===s?0:(0,R.$5e)(this.getComparisonKey(w,o),this.getComparisonKey(s,o))}isEqual(w,s,o=!1){return w===s?!0:!w||!s?!1:this.getComparisonKey(w,o)===this.getComparisonKey(s,o)}getComparisonKey(w,s=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,s,o=!1){if(w.scheme===s.scheme){if(w.scheme===T.Schemas.file)return E.$8f(g(w),g(s),this.a(w))&&w.query===s.query&&(o||w.fragment===s.fragment);if((0,e.$Mg)(w.authority,s.authority))return E.$8f(w.path,s.path,this.a(w),"/")&&w.query===s.query&&(o||w.fragment===s.fragment)}return!1}joinPath(w,...s){return $.URI.joinPath(w,...s)}basenameOrAuthority(w){return(0,e.$Eg)(w)||w.authority}basename(w){return C.$gc.basename(w.path)}extname(w){return C.$gc.extname(w.path)}dirname(w){if(w.path.length===0)return w;let s;return w.scheme===T.Schemas.file?s=$.URI.file(C.$mc(g(w))).path:(s=C.$gc.dirname(w.path),w.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),s="/")),w.with({path:s})}normalizePath(w){if(!w.path.length)return w;let s;return w.scheme===T.Schemas.file?s=$.URI.file(C.$hc(g(w))).path:s=C.$gc.normalize(w.path),w.with({path:s})}relativePath(w,s){if(w.scheme!==s.scheme||!(0,e.$Mg)(w.authority,s.authority))return;if(w.scheme===T.Schemas.file){const n=C.$lc(g(w),g(s));return M.$i?E.$2f(n):n}let o=w.path||"/";const t=s.path||"/";if(this.a(w)){let n=0;for(const a=Math.min(o.length,t.length);n<a&&!(o.charCodeAt(n)!==t.charCodeAt(n)&&o.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);o=t.substr(0,n)+o.substr(n)}return C.$gc.relative(o,t)}resolvePath(w,s){if(w.scheme===T.Schemas.file){const o=$.URI.file(C.$kc(g(w),s));return w.with({authority:o.authority,path:o.path})}return s=E.$3f(s),w.with({path:C.$gc.resolve(w.path,s)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,s){return w===s||w!==void 0&&s!==void 0&&(0,R.$_e)(w,s)}hasTrailingPathSeparator(w,s=C.sep){if(w.scheme===T.Schemas.file){const o=g(w);return o.length>E.$4f(o).length&&o[o.length-1]===s}else{const o=w.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,s=C.sep){return(0,e.$Ng)(w,s)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,s=C.sep){let o=!1;if(w.scheme===T.Schemas.file){const t=g(w);o=t!==void 0&&t.length===E.$4f(t).length&&t[t.length-1]===s}else{s="/";const t=w.path;o=t.length===1&&t.charCodeAt(t.length-1)===47}return!o&&!(0,e.$Ng)(w,s)?w.with({path:w.path+"/"}):w}}e.$wg=b,e.$xg=new b(()=>!1),e.$yg=new b(p=>p.scheme===T.Schemas.file?!M.$k:!0),e.$zg=new b(p=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function A(p,w){const s=[];for(let o=0;o<p.length;o++){const t=w(p[o]);p.some((n,a)=>a===o?!1:(0,e.$Bg)(t,w(n)))||s.push(p[o])}return s}e.$Qg=A;var D;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function w(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,h]=a.split(":");c&&h&&o.set(c,h)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&o.set(p.META_DATA_MIME,n),o}p.parseMetaData=w})(D||(e.DataUri=D={}));function u(p,w,s){if(w){let o=p.path;return o&&o[0]!==C.$gc.sep&&(o=C.$gc.sep+o),p.with({scheme:s,authority:w,path:o})}return p.with({scheme:s})}e.$Rg=u}),define(Pe[13],Re([1,0,20,15,5,6,25,21,125,39]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function A(ce){return!!ce&&typeof ce.then=="function"}e.$Sg=A;function D(ce){const te=new E.$6d,Q=ce(te.token),ee=new Promise((me,pe)=>{const Ae=te.token.onCancellationRequested(()=>{Ae.dispose(),pe(new T.$5)});Promise.resolve(Q).then(he=>{Ae.dispose(),te.dispose(),me(he)},he=>{Ae.dispose(),te.dispose(),pe(he)})});return new class{cancel(){te.cancel(),te.dispose()}then(me,pe){return ee.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return ee.finally(me)}}}e.$Tg=D;function u(ce,te,Q){return new Promise((ee,me)=>{const pe=te.onCancellationRequested(()=>{pe.dispose(),ee(Q)});ce.then(ee,me).finally(()=>pe.dispose())})}e.$Ug=u;function p(ce,te){return new Promise((Q,ee)=>{const me=te.onCancellationRequested(()=>{me.dispose(),ee(new T.$5)});ce.then(Q,ee).finally(()=>me.dispose())})}e.$Vg=p;async function w(ce){let te=-1;const Q=ce.map((ee,me)=>ee.then(pe=>(te=me,pe)));try{return await Promise.race(Q)}finally{ce.forEach((ee,me)=>{me!==te&&ee.cancel()})}}e.$Wg=w;function s(ce,te,Q){let ee;const me=setTimeout(()=>{ee?.(void 0),Q?.()},te);return Promise.race([ce.finally(()=>clearTimeout(me)),new Promise(pe=>ee=pe)])}e.$Xg=s;function o(ce){return new Promise((te,Q)=>{const ee=ce();A(ee)?ee.then(te,Q):te(ee)})}e.$Yg=o;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const Q=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(Q,Q).then(ee)})}return new Promise((Q,ee)=>{this.b.then(Q,ee)})}return this.a=te(),new Promise((Q,ee)=>{this.a.then(me=>{this.a=null,Q(me)},me=>{this.a=null,ee(me)})})}dispose(){this.f=!0}}e.$Zg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$1g=n;class a{constructor(){this.a=new Map}queue(te,Q){const me=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(te)===me&&this.a.delete(te)});return this.a.set(te,me),me}}e.$2g=a;const c=(ce,te)=>{let Q=!0;const ee=setTimeout(()=>{Q=!1,te()},ce);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(ee),Q=!1}}},h=ce=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,ce())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class i{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,Q=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((me,pe)=>{this.d=me,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=Q===g.$Sd?h(ee):c(Q,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=i;class l{constructor(te){this.a=new i(te),this.b=new t}trigger(te,Q){return this.a.trigger(()=>this.b.queue(te),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=l;class r{constructor(){this.a=!1,this.b=new Promise((te,Q)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=r;class d extends r{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$6g=d;function m(ce,te){return te?new Promise((Q,ee)=>{const me=setTimeout(()=>{pe.dispose(),Q()},ce),pe=te.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),ee(new T.$5)})}):D(Q=>m(ce,Q))}e.$7g=m;function f(ce,te=0,Q){const ee=setTimeout(()=>{ce(),Q&&me.dispose()},te),me=(0,M.$Rc)(()=>{clearTimeout(ee),Q?.deleteAndLeak(me)});return Q?.add(me),me}e.$8g=f;function S(ce){const te=[];let Q=0;const ee=ce.length;function me(){return Q<ee?ce[Q++]():null}function pe(Ae){Ae!=null&&te.push(Ae);const he=me();return he?he.then(pe):Promise.resolve(te)}return Promise.resolve(null).then(pe)}e.$9g=S;function L(ce,te=ee=>!!ee,Q=null){let ee=0;const me=ce.length,pe=()=>{if(ee>=me)return Promise.resolve(Q);const Ae=ce[ee++];return Promise.resolve(Ae()).then(ye=>te(ye)?Promise.resolve(ye):pe())};return pe()}e.$0g=L;function v(ce,te=ee=>!!ee,Q=null){if(ce.length===0)return Promise.resolve(Q);let ee=ce.length;const me=()=>{ee=-1;for(const pe of ce)pe.cancel?.()};return new Promise((pe,Ae)=>{for(const he of ce)he.then(ye=>{--ee>=0&&te(ye)?(me(),pe(ye)):ee===0&&pe(Q)}).catch(ye=>{--ee>=0&&(me(),Ae(ye))})})}e.$$g=v;class y{constructor(te){this.a=0,this.b=!1,this.f=te,this.g=[],this.d=0,this.h=new C.$Vd}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(te){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Q,ee)=>{this.g.push({factory:te,c:Q,e:ee}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const te=this.g.shift();this.d++;const Q=te.factory();Q.then(te.c,te.e),Q.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=y;class k extends y{constructor(){super(1)}}e.$ah=k;class N{constructor(){this.a=new ke,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$bh=N;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new se;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueSize(te,Q=R.$xg){const ee=Q.getComparisonKey(te);return this.a.get(ee)?.size??0}queueFor(te,Q,ee=R.$xg){const me=ee.getComparisonKey(te);let pe=this.a.get(me);if(!pe){pe=new k;const Ae=this.f++,he=C.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ae),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$3c),this.d.set(Ae,he),this.a.set(me,pe)}return pe.queue(Q)}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=O;class G{constructor(te,Q){this.a=-1,typeof te=="function"&&typeof Q=="number"&&this.setIfNotSet(te,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},Q)}setIfNotSet(te,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},Q))}}e.$dh=G;class W{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,Q,ee=globalThis){this.cancel();const me=ee.setInterval(()=>{te()},Q);this.d=(0,M.$Rc)(()=>{ee.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$eh=W;class z{constructor(te,Q){this.b=-1,this.a=te,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=z;class P{constructor(te,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=te,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=P;class I extends z{constructor(te,Q){super(te,Q),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$hh=I;class H extends M.$Tc{constructor(te,Q){super(),this.g=te,this.h=Q,this.a=[],this.b=this.B(new M.$Uc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of te)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(ce,te)=>{(0,$.$B)(()=>{if(Q)return;const ee=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$kh=(ce,te,Q)=>{const ee=ce.requestIdleCallback(te,typeof Q=="number"?{timeout:Q}:void 0);let me=!1;return{dispose(){me||(me=!0,ce.cancelIdleCallback(ee))}}},e.$jh=ce=>(0,e.$kh)(globalThis,ce)}();class ae{constructor(te,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$kh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=ae;class de extends ae{constructor(te){super(globalThis,te)}}e.$mh=de;async function we(ce,te,Q){let ee;for(let me=0;me<Q;me++)try{return await ce()}catch(pe){ee=pe,await m(te)}throw ee}e.$nh=we;class ke{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,Q,ee){return this.a={taskId:te,cancel:()=>ee?.(),promise:Q},Q.then(()=>this.d(te),()=>this.d(te)),Q}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let Q,ee;const me=new Promise((pe,Ae)=>{Q=pe,ee=Ae});this.b={run:te,promise:me,promiseResolve:Q,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=ke;class le{constructor(te,Q=()=>Date.now()){this.d=te,this.f=Q,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$ph=le;var ve;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(ve||(ve={}));class se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,Q)=>{this.a=te,this.b=Q})}complete(te){return new Promise(Q=>{this.a(te),this.d={outcome:0,value:te},Q()})}error(te){return new Promise(Q=>{this.b(te),this.d={outcome:1,value:te},Q()})}cancel(){return this.error(new T.$5)}}e.$qh=se;var be;(function(ce){async function te(ee){let me;const pe=await Promise.all(ee.map(Ae=>Ae.then(he=>he,he=>{me||(me=he)})));if(typeof me<"u")throw me;return pe}ce.settled=te;function Q(ee){return new Promise(async(me,pe)=>{try{await ee(me,pe)}catch(Ae){pe(Ae)}})}ce.withAsyncBody=Q})(be||(e.Promises=be={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=ne;class Y{constructor(te){this.b=te,this.a=new b.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=Y;var V;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(V||(V={}));class ie{static fromArray(te){return new ie(Q=>{Q.emitMany(te)})}static fromPromise(te){return new ie(async Q=>{Q.emitMany(await te)})}static fromPromises(te){return new ie(async Q=>{await Promise.all(te.map(async ee=>Q.emitOne(await ee)))})}static merge(te){return new ie(async Q=>{await Promise.all(te.map(async ee=>{for await(const me of ee)Q.emitOne(me)}))})}static{this.EMPTY=ie.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new C.$Vd,queueMicrotask(async()=>{const Q={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(te(Q)),this.j()}catch(ee){this.k(ee)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(te,Q){return new ie(async ee=>{for await(const me of te)ee.emitOne(Q(me))})}map(te){return ie.map(this,te)}static filter(te,Q){return new ie(async ee=>{for await(const me of te)Q(me)&&ee.emitOne(me)})}filter(te){return ie.filter(this,te)}static coalesce(te){return ie.filter(te,Q=>!!Q)}coalesce(){return ie.coalesce(this)}static async toPromise(te){const Q=[];for await(const ee of te)Q.push(ee);return Q}toPromise(){return ie.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$th=ie;class Ie extends ie{constructor(te,Q){super(Q),this.l=te}cancel(){this.l.cancel()}}e.$uh=Ie;function Le(ce){const te=new E.$6d,Q=ce(te.token);return new Ie(te,async ee=>{const me=te.token.onCancellationRequested(()=>{me.dispose(),te.dispose(),ee.reject(new T.$5)});try{for await(const pe of Q){if(te.token.isCancellationRequested)return;ee.emitOne(pe)}me.dispose(),te.dispose()}catch(pe){me.dispose(),te.dispose(),ee.reject(pe)}})}e.$vh=Le;class Ce{constructor(){this.a=new se,this.b=new ie(ee=>{if(te){ee.reject(te);return}return Q&&ee.emitMany(Q),this.d=me=>ee.reject(me),this.f=me=>ee.emitOne(me),this.a.p});let te,Q;this.f=ee=>{Q||(Q=[]),Q.push(ee)},this.d=ee=>{te||(te=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$wh=Ce}),define(Pe[34],Re([1,0,18,13,46,28,19,21,11]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=void 0;function b(){return Object.create(null)}e.$Hj=b,e.$Ij="**",e.$Jj="/";const A="[/\\\\]",D="[^/\\\\]",u=/\//g;function p(de,we){switch(de){case 0:return"";case 1:return`${D}*?`;default:return`(?:${A}|${D}+${A}${we?`|${A}${D}+`:""})*?`}}function w(de,we){if(!de)return[];const ke=[];let le=!1,ve=!1,se="";for(const be of de){switch(be){case we:if(!le&&!ve){ke.push(se),se="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}se+=be}return se&&ke.push(se),ke}e.$Kj=w;function s(de){if(!de)return"";let we="";const ke=w(de,e.$Jj);if(ke.every(le=>le===e.$Ij))we=".*";else{let le=!1;ke.forEach((ve,se)=>{if(ve===e.$Ij){if(le)return;we+=p(2,se===ke.length-1)}else{let be=!1,ne="",Y=!1,V="";for(const ie of ve){if(ie!=="}"&&be){ne+=ie;continue}if(Y&&(ie!=="]"||!V)){let Ie;ie==="-"?Ie=ie:(ie==="^"||ie==="!")&&!V?Ie="^":ie===e.$Jj?Ie="":Ie=(0,g.$Oe)(ie),V+=Ie;continue}switch(ie){case"{":be=!0;continue;case"[":Y=!0;continue;case"}":{const Le=`(?:${w(ne,",").map(Ce=>s(Ce)).join("|")})`;we+=Le,be=!1,ne="";break}case"]":{we+="["+V+"]",Y=!1,V="";break}case"?":we+=D;continue;case"*":we+=p(1);continue;default:we+=(0,g.$Oe)(ie)}}se<ke.length-1&&(ke[se+1]!==e.$Ij||se+2<ke.length)&&(we+=A)}le=ve===e.$Ij})}return we}const o=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Dc(1e4),l=function(){return!1},r=function(){return null};function d(de,we){if(!de)return r;let ke;typeof de!="string"?ke=de.pattern:ke=de,ke=ke.trim();const le=`${ke}_${!!we.trimForExclusions}`;let ve=i.get(le);if(ve)return m(ve,de);let se;return o.test(ke)?ve=S(ke.substr(4),ke):(se=t.exec(f(ke,we)))?ve=L(se[1],ke):(we.trimForExclusions?a:n).test(ke)?ve=v(ke,we):(se=c.exec(f(ke,we)))?ve=y(se[1].substr(1),ke,!0):(se=h.exec(f(ke,we)))?ve=y(se[1],ke,!1):ve=k(ke),i.set(le,ve),m(ve,de)}function m(de,we){if(typeof we=="string")return de;const ke=function(le,ve){return(0,C.$8f)(le,we.base,!$.$k)?de((0,g.$Te)(le.substr(we.base.length),R.sep),ve):null};return ke.allBasenames=de.allBasenames,ke.allPaths=de.allPaths,ke.basenames=de.basenames,ke.patterns=de.patterns,ke}function f(de,we){return we.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function S(de,we){return function(ke,le){return typeof ke=="string"&&ke.endsWith(de)?we:null}}function L(de,we){const ke=`/${de}`,le=`\\${de}`,ve=function(be,ne){return typeof be!="string"?null:ne?ne===de?we:null:be===de||be.endsWith(ke)||be.endsWith(le)?we:null},se=[de];return ve.basenames=se,ve.patterns=[we],ve.allBasenames=se,ve}function v(de,we){const ke=H(de.slice(1,-1).split(",").map(ne=>d(ne,we)).filter(ne=>ne!==r),de),le=ke.length;if(!le)return r;if(le===1)return ke[0];const ve=function(ne,Y){for(let V=0,ie=ke.length;V<ie;V++)if(ke[V](ne,Y))return de;return null},se=ke.find(ne=>!!ne.allBasenames);se&&(ve.allBasenames=se.allBasenames);const be=ke.reduce((ne,Y)=>Y.allPaths?ne.concat(Y.allPaths):ne,[]);return be.length&&(ve.allPaths=be),ve}function y(de,we,ke){const le=R.sep===R.$gc.sep,ve=le?de:de.replace(u,R.sep),se=R.sep+ve,be=R.$gc.sep+de;let ne;return ke?ne=function(Y,V){return typeof Y=="string"&&(Y===ve||Y.endsWith(se)||!le&&(Y===de||Y.endsWith(be)))?we:null}:ne=function(Y,V){return typeof Y=="string"&&(Y===ve||!le&&Y===de)?we:null},ne.allPaths=[(ke?"*/":"./")+de],ne}function k(de){try{const we=new RegExp(`^${s(de)}$`);return function(ke){return we.lastIndex=0,typeof ke=="string"&&we.test(ke)?de:null}}catch{return r}}function N(de,we,ke){return!de||typeof we!="string"?!1:O(de)(we,void 0,ke)}e.$Lj=N;function O(de,we={}){if(!de)return l;if(typeof de=="string"||G(de)){const ke=d(de,we);if(ke===r)return l;const le=function(ve,se){return!!ke(ve,se)};return ke.allBasenames&&(le.allBasenames=ke.allBasenames),ke.allPaths&&(le.allPaths=ke.allPaths),le}return P(de,we)}e.$Mj=O;function G(de){const we=de;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}e.$Nj=G;function W(de){return de.allBasenames||[]}e.$Oj=W;function z(de){return de.allPaths||[]}e.$Pj=z;function P(de,we){const ke=H(Object.getOwnPropertyNames(de).map(ne=>I(ne,de[ne],we)).filter(ne=>ne!==r)),le=ke.length;if(!le)return r;if(!ke.some(ne=>!!ne.requiresSiblings)){if(le===1)return ke[0];const ne=function(ie,Ie){let Le;for(let Ce=0,ce=ke.length;Ce<ce;Ce++){const te=ke[Ce](ie,Ie);if(typeof te=="string")return te;(0,T.$Sg)(te)&&(Le||(Le=[]),Le.push(te))}return Le?(async()=>{for(const Ce of Le){const ce=await Ce;if(typeof ce=="string")return ce}return null})():null},Y=ke.find(ie=>!!ie.allBasenames);Y&&(ne.allBasenames=Y.allBasenames);const V=ke.reduce((ie,Ie)=>Ie.allPaths?ie.concat(Ie.allPaths):ie,[]);return V.length&&(ne.allPaths=V),ne}const ve=function(ne,Y,V){let ie,Ie;for(let Le=0,Ce=ke.length;Le<Ce;Le++){const ce=ke[Le];ce.requiresSiblings&&V&&(Y||(Y=(0,R.$nc)(ne)),ie||(ie=Y.substr(0,Y.length-(0,R.$oc)(ne).length)));const te=ce(ne,Y,ie,V);if(typeof te=="string")return te;(0,T.$Sg)(te)&&(Ie||(Ie=[]),Ie.push(te))}return Ie?(async()=>{for(const Le of Ie){const Ce=await Le;if(typeof Ce=="string")return Ce}return null})():null},se=ke.find(ne=>!!ne.allBasenames);se&&(ve.allBasenames=se.allBasenames);const be=ke.reduce((ne,Y)=>Y.allPaths?ne.concat(Y.allPaths):ne,[]);return be.length&&(ve.allPaths=be),ve}function I(de,we,ke){if(we===!1)return r;const le=d(de,ke);if(le===r)return r;if(typeof we=="boolean")return le;if(we){const ve=we.when;if(typeof ve=="string"){const se=(be,ne,Y,V)=>{if(!V||!le(be,ne))return null;const ie=ve.replace("$(basename)",()=>Y),Ie=V(ie);return(0,T.$Sg)(Ie)?Ie.then(Le=>Le?de:null):Ie?de:null};return se.requiresSiblings=!0,se}}return le}function H(de,we){const ke=de.filter(ne=>!!ne.basenames);if(ke.length<2)return de;const le=ke.reduce((ne,Y)=>{const V=Y.basenames;return V?ne.concat(V):ne},[]);let ve;if(we){ve=[];for(let ne=0,Y=le.length;ne<Y;ne++)ve.push(we)}else ve=ke.reduce((ne,Y)=>{const V=Y.patterns;return V?ne.concat(V):ne},[]);const se=function(ne,Y){if(typeof ne!="string")return null;if(!Y){let ie;for(ie=ne.length;ie>0;ie--){const Ie=ne.charCodeAt(ie-1);if(Ie===47||Ie===92)break}Y=ne.substr(ie)}const V=le.indexOf(Y);return V!==-1?ve[V]:null};se.basenames=le,se.patterns=ve,se.allBasenames=le;const be=de.filter(ne=>!ne.basenames);return be.push(se),be}function ae(de,we){return(0,E.$ub)(de,we,(ke,le)=>typeof ke=="string"&&typeof le=="string"?ke===le:typeof ke!="string"&&typeof le!="string"?ke.base===le.base&&ke.pattern===le.pattern:!1)}e.$Qj=ae}),define(Pe[52],Re([1,0,15,126,25,11,2]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class g{constructor(n="",a=!1){if(this.value=n,typeof this.value!="string")throw(0,E.$7)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(n,a=0){return this.value+=u(this.supportThemeIcons?(0,T.$bk)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,a){return this.value+=`
${p(a,n)}
`,this}appendLink(n,a,c){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,a){const c=new RegExp((0,M.$Oe)(a),"g");return n.replace(c,(h,i)=>n.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$hk=g;function b(t){return A(t)?!t.value:Array.isArray(t)?t.every(b):!0}e.$ik=b;function A(t){return t instanceof g?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$jk=A;function D(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,C.$Ag)(R.URI.from(t.baseUri),R.URI.from(n.baseUri)))}e.$kk=D;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$lk=u;function p(t,n){const a=t.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=a>=3?a+1:3;return[`${"`".repeat(c)}${n}`,t,`${"`".repeat(c)}`].join(`
`)}e.$mk=p;function w(t){return t.replace(/"/g,"&quot;")}e.$nk=w;function s(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ok=s;function o(t){const n=[],a=t.split("|").map(h=>h.trim());t=a[0];const c=a[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),l=h?h[1]:"",r=i?i[1]:"",d=isFinite(parseInt(r)),m=isFinite(parseInt(l));d&&n.push(`width="${r}"`),m&&n.push(`height="${l}"`)}return{href:t,dimensions:n}}e.$pk=o}),define(Pe[95],Re([1,0,18,46,19,21,25,11]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;function g(d,m){const{os:f,tildify:S,relative:L}=m;if(L){const k=b(d,L,f);if(typeof k=="string")return k}let v=d.fsPath;if(f===1&&!M.$i?v=v.replace(/\//g,"\\"):f!==1&&M.$i&&(v=v.replace(/\\/g,"/")),f!==1&&S?.userHome){const k=S.userHome.fsPath;let N;d.scheme!==S.userHome.scheme&&d.path[0]===C.$gc.sep&&d.path[1]!==C.$gc.sep?N=S.userHome.with({path:d.path}).fsPath:N=v,v=u(N,k,f)}return(f===1?C.$fc:C.$gc).normalize(A(v,f===1))}e.$Vv=g;function b(d,m,f){const S=f===1?C.$fc:C.$gc,L=f===3?R.$xg:R.$zg,v=m.getWorkspace(),y=(0,E.$Ob)(v.folders);if(!y)return;d.scheme!==y.uri.scheme&&d.path[0]===C.$gc.sep&&d.path[1]!==C.$gc.sep&&(d=y.uri.with({path:d.path}));const k=m.getWorkspaceFolder(d);if(!k)return;let N;if(L.isEqual(k.uri,d)?N="":N=L.relativePath(k.uri,d)??"",N&&(N=S.normalize(N)),v.folders.length>1&&!m.noPrefix){const O=k.name?k.name:L.basenameOrAuthority(k.uri);N=N?`${O} \u2022 ${N}`:O}return N}function A(d,m=M.$i){return(0,T.$_f)(d,m)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Wv=A;let D=Object.create(null);function u(d,m,f=M.OS){if(f===1||!d||!m)return d;let S=D.original===m?D.normalized:void 0;S||(S=m,M.$i&&(S=(0,T.$2f)(S)),S=`${(0,$.$Ue)(S,C.$gc.sep)}${C.$gc.sep}`,D={original:m,normalized:S});let L=d;return M.$i&&(L=(0,T.$2f)(L)),(f===3?L.startsWith(S):(0,$.$af)(L,S))?`~/${L.substr(S.length)}`:d}e.$Xv=u;function p(d,m){return d.replace(/^~($|\/|\\)/,`${m}$1`)}e.$Yv=p;const w="\u2026",s="\\\\",o="~";function t(d,m=C.sep){const f=new Array(d.length);let S=!1;for(let L=0;L<d.length;L++){const v=d[L];if(v===""){f[L]=`.${m}`;continue}if(!v){f[L]=v;continue}S=!0;let y="",k=v;k.indexOf(s)===0?(y=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length)):k.indexOf(m)===0?(y=k.substr(0,k.indexOf(m)+m.length),k=k.substr(k.indexOf(m)+m.length)):k.indexOf(o)===0&&(y=k.substr(0,k.indexOf(o)+o.length),k=k.substr(k.indexOf(o)+o.length));const N=k.split(m);for(let O=1;S&&O<=N.length;O++)for(let G=N.length-O;S&&G>=0;G--){S=!1;let W=N.slice(G,G+O).join(m);for(let z=0;!S&&z<d.length;z++)if(z!==L&&d[z]&&d[z].indexOf(W)>-1){const P=G+O===N.length,I=G>0&&d[z].indexOf(m)>-1?m+W:W,H=d[z].endsWith(I);S=!P||H}if(!S){let z="";(N[0].endsWith(":")||y!=="")&&(G===1&&(G=0,O++,W=N[0]+m+W),G>0&&(z=N[0]+m),z=y+z),G>0&&(z=z+w+m),z=z+W,G+O<N.length&&(z=z+m+w),f[L]=z}}S&&(f[L]=v)}return f}e.$Zv=t;var n;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function a(d,m=Object.create(null)){const f=[];let S=!1,L="";for(const v of d)if(v==="$"||S&&v==="{")L&&f.push({value:L,type:n.TEXT}),L="",S=!0;else if(v==="}"&&S){const y=m[L];if(typeof y=="string")y.length&&f.push({value:y,type:n.VARIABLE});else if(y){const k=f[f.length-1];(!k||k.type!==n.SEPARATOR)&&f.push({value:y.label,type:n.SEPARATOR})}L="",S=!1}else L+=v;return L&&!S&&f.push({value:L,type:n.TEXT}),f.filter((v,y)=>{if(v.type===n.SEPARATOR){const k=f[y-1],N=f[y+1];return[k,N].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(v=>v.value).join("")}e.$1v=a;function c(d,m){return M.$j||m?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):d.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$2v=c;function h(d,m){return M.$j||m?d.replace(/\(&&\w\)|&&/g,""):M.$i?d.replace(/&&|&/g,f=>f==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$3v=h;function i(d){return d.replace(/&/g,"&&")}e.$4v=i;function l(d){if(d.endsWith("]")){const m=d.lastIndexOf(" [",d.length-2);if(m!==-1){const f=r(d.substring(0,m)),S=d.substring(m);return{name:f.name+S,parentPath:f.parentPath}}}return r(d)}e.$5v=l;function r(d){const m=d.indexOf("/")!==-1?C.$gc:C.$fc,f=m.basename(d),S=m.dirname(d);return f.length?{name:f,parentPath:S}:{name:S,parentPath:""}}}),define(Pe[139],Re([1,0,24,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function C(D){return D.toJSON()}class M{constructor(u){this.a=u}transformIncoming(u){const p=this.a.transformIncoming(u);return p===u?u:C(T.URI.from(p))}transformOutgoing(u){const p=this.a.transformOutgoing(u);return p===u?u:C(T.URI.from(p))}transformOutgoingURI(u){const p=this.a.transformOutgoing(u);return p===u?u:T.URI.from(p)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$4m=M,e.$5m=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,u,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof T.URI)return u.transformOutgoing(D);for(const w in D)if(Object.hasOwnProperty.call(D,w)){const s=R(D[w],u,p+1);s!==null&&(D[w]=s)}}return null}function $(D,u){const p=R(D,u,0);return p===null?D:p}e.$6m=$;function g(D,u,p,w){if(!D||w>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?T.URI.revive(u.transformIncoming(D)):u.transformIncoming(D);if(D instanceof E.$je)return null;for(const s in D)if(Object.hasOwnProperty.call(D,s)){const o=g(D[s],u,p,w+1);o!==null&&(D[s]=o)}}return null}function b(D,u){const p=g(D,u,!1,0);return p===null?D:p}e.$7m=b;function A(D,u){const p=g(D,u,!0,0);return p===null?D:p}e.$8m=A}),define(Pe[140],Re([1,0,11,21,24]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=void 0;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function g(){return $||($=new TextDecoder("UTF-16BE")),$}let b;function A(){return b||(b=T.$D()?R():g()),b}e.$at=A;function D(w,s,o){const t=new Uint16Array(w.buffer,s,o);return o>0&&(t[0]===65279||t[0]===65534)?u(w,s,o):R().decode(t)}e.$bt=D;function u(w,s,o){const t=[];let n=0;for(let a=0;a<o;a++){const c=C.$le(w,s);s+=2,t[n++]=String.fromCharCode(c)}return t.join("")}class p{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return A().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const o=this.a-this.d;o<=1&&(o===0||E.$df(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const o=s.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=s;return}for(let t=0;t<o;t++)this.b[this.d++]=s.charCodeAt(t)}}e.$ct=p}),define(Pe[141],Re([1,0,24,140]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=void 0;function C(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(b,A,D,u){this.oldPosition=b,this.oldText=A,this.newPosition=D,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(b){return 4+2*b.length}static c(b,A,D){const u=A.length;E.$oe(b,u,D),D+=4;for(let p=0;p<u;p++)E.$me(b,A.charCodeAt(p),D),D+=2;return D}static d(b,A){const D=E.$ne(b,A);return A+=4,(0,T.$bt)(b,A,D)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(b,A){return E.$oe(b,this.oldPosition,A),A+=4,E.$oe(b,this.newPosition,A),A+=4,A=M.c(b,this.oldText,A),A=M.c(b,this.newText,A),A}static read(b,A,D){const u=E.$ne(b,A);A+=4;const p=E.$ne(b,A);A+=4;const w=M.d(b,A);A+=M.a(w);const s=M.d(b,A);return A+=M.a(s),D.push(new M(u,w,p,s)),A}}e.$dt=M;function R(g,b){return g===null||g.length===0?b:new $(g,b).compress()}e.$et=R;class ${constructor(b,A){this.a=b,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let b=0,A=0,D=this.n(b),u=this.l(A);for(;b<this.f||A<this.h;){if(D===null){this.k(u),u=this.l(++A);continue}if(u===null){this.m(D),D=this.n(++b);continue}if(u.oldEnd<=D.newPosition){this.k(u),u=this.l(++A);continue}if(D.newEnd<=u.oldPosition){this.m(D),D=this.n(++b);continue}if(u.oldPosition<D.newPosition){const[t,n]=$.r(u,D.newPosition-u.oldPosition);this.k(t),u=n;continue}if(D.newPosition<u.oldPosition){const[t,n]=$.q(D,u.oldPosition-D.newPosition);this.m(t),D=n;continue}let s,o;if(u.oldEnd===D.newEnd)s=D,o=u,D=this.n(++b),u=this.l(++A);else if(u.oldEnd<D.newEnd){const[t,n]=$.q(D,u.oldLength);s=t,o=u,D=n,u=this.l(++A)}else{const[t,n]=$.r(u,D.newLength);s=D,o=t,D=this.n(++b),u=n}this.d[this.e++]=new M(s.oldPosition,s.oldText,o.newPosition,o.newText),this.g+=s.newLength-s.oldLength,this.j+=o.newLength-o.oldLength}const p=$.s(this.d);return $.t(p)}k(b){this.d[this.e++]=$.o(this.g,b),this.j+=b.newLength-b.oldLength}l(b){return b<this.h?this.c[b]:null}m(b){this.d[this.e++]=$.p(this.j,b),this.g+=b.newLength-b.oldLength}n(b){return b<this.f?this.a[b]:null}static o(b,A){return new M(A.oldPosition-b,A.oldText,A.newPosition,A.newText)}static p(b,A){return new M(A.oldPosition,A.oldText,A.newPosition+b,A.newText)}static q(b,A){const D=b.newText.substr(0,A),u=b.newText.substr(A);return[new M(b.oldPosition,b.oldText,b.newPosition,D),new M(b.oldEnd,"",b.newPosition+A,u)]}static r(b,A){const D=b.oldText.substr(0,A),u=b.oldText.substr(A);return[new M(b.oldPosition,D,b.newPosition,b.newText),new M(b.oldPosition+A,u,b.newEnd,"")]}static s(b){if(b.length===0)return b;const A=[];let D=0,u=b[0];for(let p=1;p<b.length;p++){const w=b[p];u.oldEnd===w.oldPosition?u=new M(u.oldPosition,u.oldText+w.oldText,u.newPosition,u.newText+w.newText):(A[D++]=u,u=w)}return A[D++]=u,A}static t(b){if(b.length===0)return b;const A=[];let D=0;for(let u=0;u<b.length;u++){const p=b[u];p.oldText!==p.newText&&(A[D++]=p)}return A}}}),define(Pe[142],Re([1,0,34,19]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;function C(M,R,$,g,b,A){if(Array.isArray(M)){let D=0;for(const u of M){const p=C(u,R,$,g,b,A);if(p===10)return p;p>D&&(D=p)}return D}else{if(typeof M=="string")return g?M==="*"?5:M===$?10:0:0;if(M){const{language:D,pattern:u,scheme:p,hasAccessToAllModels:w,notebookType:s}=M;if(!g&&!w)return 0;s&&b&&(R=b);let o=0;if(p)if(p===R.scheme)o=10;else if(p==="*")o=5;else return 0;if(D)if(D===$)o=10;else if(D==="*")o=Math.max(o,5);else return 0;if(s)if(s===A)o=10;else if(s==="*"&&A!==void 0)o=Math.max(o,5);else return 0;if(u){let t;if(typeof u=="string"?t=u:t={...u,base:(0,T.$hc)(u.base)},t===R.fsPath||(0,E.$Lj)(t,R.fsPath))o=10;else return 0}return o}else return 0}}e.$Bt=C}),define(Pe[143],Re([1,0,5,11,29,93,91,128,141,6]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class A extends b.$Tc{constructor(u,p,w,s,o,t,n){super(),this.m=this.B(new E.$Vd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!t,this.g=s,this.h=o,this.c=new R.$aC(u,w,n)}equals(u){return!(u instanceof A)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,p){return this.c.getOffsetAt(u,p)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,p){const w=u+p,s=this.getPositionAt(u),o=this.getPositionAt(w);return new C.$Us(s.lineNumber,s.column,o.lineNumber,o.column)}getValueInRange(u,p=0){if(u.isEmpty())return"";const w=this.n(p);return this.c.getValueInRange(u,w)}getValueLengthInRange(u,p=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const w=this.getOffsetAt(u.startLineNumber,u.startColumn),s=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const t=this.n(p),n=this.getEOL();if(t.length!==n.length){const a=t.length-n.length,c=u.endLineNumber-u.startLineNumber;o=a*c}return s-w+o}getCharacterCountInRange(u,p=0){if(this.j){let w=0;const s=u.startLineNumber,o=u.endLineNumber;for(let t=s;t<=o;t++){const n=this.getLineContent(t),a=t===s?u.startColumn-1:0,c=t===o?u.endColumn-1:n.length;for(let h=a;h<c;h++)T.$df(n.charCodeAt(h))?(w=w+1,h=h+1):w=w+1}return w+=this.n(p).length*(o-s),w}return this.getValueLengthInRange(u,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,p){return this.c.getLineCharCode(u,p)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const p=T.$1e(this.getLineContent(u));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(u){const p=T.$3e(this.getLineContent(u));return p===-1?0:p+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,p,w){let s=this.g,o=this.h,t=this.j,n=!0,a=[];for(let m=0;m<u.length;m++){const f=u[m];n&&f._isTracked&&(n=!1);const S=f.range;if(f.text){let N=!0;t||(N=!T.$of(f.text),t=N),!s&&N&&(s=T.$nf(f.text)),!o&&N&&(o=T.$qf(f.text))}let L="",v=0,y=0,k=0;if(f.text){let N;[v,y,k,N]=(0,$.$ut)(f.text);const O=this.getEOL();N===0||N===(O===`\r
`?2:1)?L=f.text:L=f.text.replace(/\r\n|\r|\n/g,O)}a[m]={sortIndex:m,identifier:f.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:L,eolCount:v,firstLineLength:y,lastLineLength:k,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}a.sort(A.u);let c=!1;for(let m=0,f=a.length-1;m<f;m++){const S=a[m].range.getEndPosition(),L=a[m+1].range.getStartPosition();if(L.isBeforeOrEqual(S)){if(L.isBefore(S))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(a=this.s(a));const h=w||p?A._getInverseEditRanges(a):[],i=[];if(p)for(let m=0;m<a.length;m++){const f=a[m],S=h[m];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let L=S.startLineNumber;L<=S.endLineNumber;L++){let v="";L===S.startLineNumber&&(v=this.getLineContent(f.range.startLineNumber),T.$1e(v)!==-1)||i.push({lineNumber:L,oldContent:v})}}let l=null;if(w){let m=0;l=[];for(let f=0;f<a.length;f++){const S=a[f],L=h[f],v=this.getValueInRange(S.range),y=S.rangeOffset+m;m+=S.text.length-v.length,l[f]={sortIndex:S.sortIndex,identifier:S.identifier,range:L,text:v,textChange:new g.$dt(S.rangeOffset,v,y,S.text)}}c||l.sort((f,S)=>f.sortIndex-S.sortIndex)}this.g=s,this.h=o,this.j=t;const r=this.t(a);let d=null;if(p&&i.length>0){i.sort((m,f)=>f.lineNumber-m.lineNumber),d=[];for(let m=0,f=i.length;m<f;m++){const S=i[m].lineNumber;if(m>0&&i[m-1].lineNumber===S)continue;const L=i[m].oldContent,v=this.getLineContent(S);v.length===0||v===L||T.$1e(v)!==-1||d.push(S)}}return this.m.fire(),new M.$ev(l,r,d)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let p=!1;const w=u[0].range,s=u[u.length-1].range,o=new C.$Us(w.startLineNumber,w.startColumn,s.endLineNumber,s.endColumn);let t=w.startLineNumber,n=w.startColumn;const a=[];for(let r=0,d=u.length;r<d;r++){const m=u[r],f=m.range;p=p||m.forceMoveMarkers,a.push(this.getValueInRange(new C.$Us(t,n,f.startLineNumber,f.startColumn))),m.text.length>0&&a.push(m.text),t=f.endLineNumber,n=f.endColumn}const c=a.join(""),[h,i,l]=(0,$.$ut)(c);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:l,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(u){u.sort(A.w);const p=[];for(let w=0;w<u.length;w++){const s=u[w],o=s.range.startLineNumber,t=s.range.startColumn,n=s.range.endLineNumber,a=s.range.endColumn;if(o===n&&t===a&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new C.$Us(o,t,n,a);p.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return p}findMatchesLineByLine(u,p,w,s){return this.c.findMatchesLineByLine(u,p,w,s)}getPieceTree(){return this.c}static _getInverseEditRange(u,p){const w=u.startLineNumber,s=u.startColumn,[o,t,n]=(0,$.$ut)(p);let a;if(p.length>0){const c=o+1;c===1?a=new C.$Us(w,s,w,s+t):a=new C.$Us(w,s,w+c-1,n+1)}else a=new C.$Us(w,s,w,s);return a}static _getInverseEditRanges(u){const p=[];let w=0,s=0,o=null;for(let t=0,n=u.length;t<n;t++){const a=u[t];let c,h;o?o.range.endLineNumber===a.range.startLineNumber?(c=w,h=s+(a.range.startColumn-o.range.endColumn)):(c=w+(a.range.startLineNumber-o.range.endLineNumber),h=a.range.startColumn):(c=a.range.startLineNumber,h=a.range.startColumn);let i;if(a.text.length>0){const l=a.eolCount+1;l===1?i=new C.$Us(c,h,c,h+a.firstLineLength):i=new C.$Us(c,h,c+l-1,a.lastLineLength+1)}else i=new C.$Us(c,h,c,h);w=i.endLineNumber,s=i.endColumn,p.push(i),o=a}return p}static u(u,p){const w=C.$Us.compareRangesUsingEnds(u.range,p.range);return w===0?u.sortIndex-p.sortIndex:w}static w(u,p){const w=C.$Us.compareRangesUsingEnds(u.range,p.range);return w===0?p.sortIndex-u.sortIndex:-w}}e.$bC=A}),define(Pe[144],Re([1,0,11,91,143]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class M{constructor(g,b,A,D,u,p,w,s,o){this.a=g,this.b=b,this.c=A,this.d=D,this.e=u,this.f=p,this.g=w,this.h=s,this.j=o}k(g){const b=this.c+this.d+this.e,A=this.c+this.e;return b===0?g===1?`
`:`\r
`:A>b/2?`\r
`:`
`}create(g){const b=this.k(g),A=this.a;if(this.j&&(b===`\r
`&&(this.c>0||this.d>0)||b===`
`&&(this.c>0||this.e>0)))for(let u=0,p=A.length;u<p;u++){const w=A[u].buffer.replace(/\r\n|\r|\n/g,b),s=(0,T.$9B)(w);A[u]=new T.$_B(w,s)}const D=new C.$bC(A,this.b,b,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&E.$wf(g)&&(this.b=E.$vf,g=g.substr(1));const b=g.charCodeAt(g.length-1);b===13||b>=55296&&b<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=b):(this.m(g,!1),this.c=!1,this.d=b)}m(g,b){!b&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const b=(0,T.$0B)(this.e,g);this.a.push(new T.$_B(g,b.lineStarts)),this.f+=b.cr,this.g+=b.lf,this.h+=b.crlf,b.isBasicASCII||(this.l=!1,this.j||(this.j=E.$nf(g)),this.k||(this.k=E.$qf(g)))}finish(g=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const b=(0,T.$9B)(g.buffer);g.lineStarts=b,this.d===13&&this.f++}}}e.$cC=R}),define(Pe[96],Re([1,0,24,21]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t$=e.$s$=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function M(D){for(let u=0,p=D.length;u<p;u+=4){const w=D[u+0],s=D[u+1],o=D[u+2],t=D[u+3];D[u+0]=t,D[u+1]=o,D[u+2]=s,D[u+3]=w}}function R(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return T.$D()||M(u),E.$je.wrap(u)}function $(D){const u=D.buffer;if(T.$D()||M(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const p=new Uint8Array(u.byteLength);return p.set(u),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function g(D){const u=new Uint32Array(b(D));let p=0;if(u[p++]=D.id,D.type==="full")u[p++]=1,u[p++]=D.data.length,u.set(D.data,p),p+=D.data.length;else{u[p++]=2,u[p++]=D.deltas.length;for(const w of D.deltas)u[p++]=w.start,u[p++]=w.deleteCount,w.data?(u[p++]=w.data.length,u.set(w.data,p),p+=w.data.length):u[p++]=0}return R(u)}e.$s$=g;function b(D){let u=0;if(u+=1+1,D.type==="full")u+=1+D.data.length;else{u+=1,u+=(1+1+1)*D.deltas.length;for(const p of D.deltas)p.data&&(u+=p.data.length)}return u}function A(D){const u=$(D);let p=0;const w=u[p++];if(u[p++]===1){const n=u[p++],a=u.subarray(p,p+n);return p+=n,{id:w,type:"full",data:a}}const o=u[p++],t=[];for(let n=0;n<o;n++){const a=u[p++],c=u[p++],h=u[p++];let i;h>0&&(i=u.subarray(p,p+h),p+=h),t[n]={start:a,deleteCount:c,data:i}}return{id:w,type:"delta",deltas:t}}e.$t$=A}),define(Pe[145],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Re([1,0,18,26,21,129,147,145]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=b;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class D{constructor(_,$e,Be,Qe){this.id=_,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,$e){return p(_,$e)}compute(_,$e,Be){return Be}}class u{constructor(_,$e){this.newValue=_,this.didChange=$e}}e.ApplyUpdateResult=u;function p(Z,_){if(typeof Z!="object"||typeof _!="object"||!Z||!_)return new u(_,Z!==_);if(Array.isArray(Z)||Array.isArray(_)){const Be=Array.isArray(Z)&&Array.isArray(_)&&E.$ub(Z,_);return new u(_,!Be)}let $e=!1;for(const Be in _)if(_.hasOwnProperty(Be)){const Qe=p(Z[Be],_[Be]);Qe.didChange&&(Z[Be]=Qe.newValue,$e=!0)}return new u(Z,$e)}class w{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,$e){return p(_,$e)}validate(_){return this.defaultValue}}class s{constructor(_,$e,Be,Qe){this.id=_,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,$e){return p(_,$e)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,$e,Be){return Be}}function o(Z,_){return typeof Z>"u"?_:Z==="false"?!1:!!Z}e.boolean=o;class t extends s{constructor(_,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(_,$e,Be,Qe)}validate(_){return o(_,this.defaultValue)}}function n(Z,_,$e,Be){if(typeof Z>"u")return _;let Qe=parseInt(Z,10);return isNaN(Qe)?_:(Qe=Math.max($e,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=n;class a extends s{static clampedInt(_,$e,Be,Qe){return n(_,$e,Be,Qe)}constructor(_,$e,Be,Qe,it,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Qe,rt.maximum=it),super(_,$e,Be,rt),this.minimum=Qe,this.maximum=it}validate(_){return a.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function c(Z,_,$e,Be){if(typeof Z>"u")return _;const Qe=h.float(Z,_);return h.clamp(Qe,$e,Be)}e.clampedFloat=c;class h extends s{static clamp(_,$e,Be){return _<$e?$e:_>Be?Be:_}static float(_,$e){if(typeof _=="number")return _;if(typeof _>"u")return $e;const Be=parseFloat(_);return isNaN(Be)?$e:Be}constructor(_,$e,Be,Qe,it){typeof it<"u"&&(it.type="number",it.default=Be),super(_,$e,Be,it),this.validationFn=Qe}validate(_){return this.validationFn(h.float(_,this.defaultValue))}}class i extends s{static string(_,$e){return typeof _!="string"?$e:_}constructor(_,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(_,$e,Be,Qe)}validate(_){return i.string(_,this.defaultValue)}}function l(Z,_,$e,Be){return typeof Z!="string"?_:Be&&Z in Be?Be[Z]:$e.indexOf(Z)===-1?_:Z}e.stringSet=l;class r extends s{constructor(_,$e,Be,Qe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=Be),super(_,$e,Be,it),this.c=Qe}validate(_){return l(_,this.defaultValue,this.c)}}class d extends D{constructor(_,$e,Be,Qe,it,rt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=it,Ne.default=Qe),super(_,$e,Be,Ne),this.c=it,this.d=rt}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function m(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,$e,Be){return Be===0?_.accessibilitySupport:Be}}class S extends D{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:$.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{insertSpace:o($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function v(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function k(Z){switch(Z){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function N(Z){switch(Z){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class O extends w{constructor(){super(140)}compute(_,$e,Be){const Qe=["monaco-editor"];return $e.get(39)&&Qe.push($e.get(39)),_.extraEditorClassName&&Qe.push(_.extraEditorClassName),$e.get(73)==="default"?Qe.push("mouse-default"):$e.get(73)==="copy"&&Qe.push("mouse-copy"),$e.get(110)&&Qe.push("showUnused"),$e.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class G extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(_,$e,Be){return Be&&_.emptySelectionClipboard}}class W extends D{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:$.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:$.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{cursorMoveOnType:o($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":l($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":l($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o($e.loop,this.defaultValue.loop)}}}class z extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?z.OFF:_==="true"?z.ON:_:_?z.ON:z.OFF}}e.EditorFontLigatures=z;class P extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",P.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?P.OFF:_==="true"?P.TRANSLATE:_:_?P.TRANSLATE:P.OFF}compute(_,$e,Be){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=P;class I extends w{constructor(){super(50)}compute(_,$e,Be){return _.fontInfo}}class H extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(_){const $e=h.float(_,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp($e,6,100)}compute(_,$e,Be){return _.fontInfo.fontSize}}class ae extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ae.d,maximum:ae.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ae.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(a.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,ae.d,ae.e))}}class de extends D{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{multiple:l($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??l($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??l($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??l($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??l($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??l($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class we extends D{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:$.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),delay:a.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:o($e.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o($e.above,this.defaultValue.above)}}}var ke;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class le extends w{constructor(){super(143)}compute(_,$e,Be){return le.computeLayout($e,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const $e=_.height/_.lineHeight,Be=Math.floor(_.paddingTop/_.lineHeight);let Qe=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Qe=Math.max(Qe,$e-1));const it=(Be+_.viewLineCount+Qe)/(_.pixelRatio*_.height),rt=Math.floor(_.viewLineCount/it);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:it,minimapLineCount:rt}}static c(_,$e){const Be=_.outerWidth,Qe=_.outerHeight,it=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const rt=$e.stableMinimapLayoutInput,Ne=rt&&_.outerHeight===rt.outerHeight&&_.lineHeight===rt.lineHeight&&_.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&_.pixelRatio===rt.pixelRatio&&_.scrollBeyondLastLine===rt.scrollBeyondLastLine&&_.paddingTop===rt.paddingTop&&_.paddingBottom===rt.paddingBottom&&_.minimap.enabled===rt.minimap.enabled&&_.minimap.side===rt.minimap.side&&_.minimap.size===rt.minimap.size&&_.minimap.showSlider===rt.minimap.showSlider&&_.minimap.renderCharacters===rt.minimap.renderCharacters&&_.minimap.maxColumn===rt.minimap.maxColumn&&_.minimap.scale===rt.minimap.scale&&_.verticalScrollbarWidth===rt.verticalScrollbarWidth&&_.isViewportWrapping===rt.isViewportWrapping,Pt=_.lineHeight,Tt=_.typicalHalfwidthCharacterWidth,Ht=_.scrollBeyondLastLine,Bt=_.minimap.renderCharacters;let yt=it>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Kt=_.minimap.maxColumn,Nt=_.minimap.size,Xt=_.minimap.side,zt=_.verticalScrollbarWidth,Rt=_.viewLineCount,Ze=_.remainingWidth,Gt=_.isViewportWrapping,Jt=Bt?2:3;let lt=Math.floor(it*Qe);const $t=lt/it;let jt=!1,Vt=!1,kt=Jt*yt,dt=yt/it,Ct=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Se,desiredRatio:Fe,minimapLineCount:fe}=le.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Ht,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Qe,lineHeight:Pt,pixelRatio:it});if(Rt/fe>1)jt=!0,Vt=!0,yt=1,kt=1,dt=yt/it;else{let Me=!1,Ue=yt+1;if(Nt==="fit"){const Xe=Math.ceil((Ft+Rt+Se)*kt);Gt&&Ne&&Ze<=$e.stableFitRemainingWidth?(Me=!0,Ue=$e.stableFitMaxMinimapScale):Me=Xe>lt}if(Nt==="fill"||Me){jt=!0;const Xe=yt;kt=Math.min(Pt*it,Math.max(1,Math.floor(1/Fe))),Gt&&Ne&&Ze<=$e.stableFitRemainingWidth&&(Ue=$e.stableFitMaxMinimapScale),yt=Math.min(Ue,Math.max(1,Math.floor(kt/Jt))),yt>Xe&&(Ct=Math.min(2,yt/Xe)),dt=yt/it/Ct,lt=Math.ceil(Math.max(ft,Ft+Rt+Se)*kt),Gt?($e.stableMinimapLayoutInput=_,$e.stableFitRemainingWidth=Ze,$e.stableFitMaxMinimapScale=yt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const xt=Math.floor(Kt*dt),Dt=Math.min(xt,Math.max(0,Math.floor((Ze-zt-2)*dt/(Tt+dt)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(it*Dt);const Mt=qe/it;qe=Math.floor(qe*Ct);const Wt=Bt?1:2,Qt=Xt==="left"?0:Be-Dt-zt;return{renderMinimap:Wt,minimapLeft:Qt,minimapWidth:Dt,minimapHeightIsEditorHeight:jt,minimapIsSampling:Vt,minimapScale:yt,minimapLineHeight:kt,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:$t}}static computeLayout(_,$e){const Be=$e.outerWidth|0,Qe=$e.outerHeight|0,it=$e.lineHeight|0,rt=$e.lineNumbersDigitCount|0,Ne=$e.typicalHalfwidthCharacterWidth,Pt=$e.maxDigitWidth,Tt=$e.pixelRatio,Ht=$e.viewLineCount,Bt=_.get(135),yt=Bt==="inherit"?_.get(134):Bt,Kt=yt==="inherit"?_.get(130):yt,Nt=_.get(133),Xt=$e.isDominatedByLongLines,zt=_.get(57),Rt=_.get(67).renderType!==0,Ze=_.get(68),Gt=_.get(104),Jt=_.get(83),lt=_.get(72),$t=_.get(102),jt=$t.verticalScrollbarSize,Vt=$t.verticalHasArrows,kt=$t.arrowSize,dt=$t.horizontalScrollbarSize,Ct=_.get(43),xt=_.get(109)!=="never";let Dt=_.get(65);Ct&&xt&&(Dt+=16);let qe=0;if(Rt){const _e=Math.max(rt,Ze);qe=Math.round(_e*Pt)}let Mt=0;zt&&(Mt=it*$e.glyphMarginDecorationLaneCount);let Wt=0,Qt=Wt+Mt,ft=Qt+qe,Ft=ft+Dt;const Se=Be-Mt-qe-Dt;let Fe=!1,fe=!1,J=-1;yt==="inherit"&&Xt?(Fe=!0,fe=!0):Kt==="on"||Kt==="bounded"?fe=!0:Kt==="wordWrapColumn"&&(J=Nt);const Me=le.c({outerWidth:Be,outerHeight:Qe,lineHeight:it,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Tt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:lt,verticalScrollbarWidth:jt,viewLineCount:Ht,remainingWidth:Se,isViewportWrapping:fe},$e.memory||new A);Me.renderMinimap!==0&&Me.minimapLeft===0&&(Wt+=Me.minimapWidth,Qt+=Me.minimapWidth,ft+=Me.minimapWidth,Ft+=Me.minimapWidth);const Ue=Se-Me.minimapWidth,Xe=Math.max(1,Math.floor((Ue-jt-2)/Ne)),We=Vt?kt:0;return fe&&(J=Math.max(1,Xe),Kt==="bounded"&&(J=Math.min(J,Nt))),{width:Be,height:Qe,glyphMarginLeft:Wt,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:Dt,contentLeft:Ft,contentWidth:Ue,minimap:Me,viewportColumn:Xe,isWordWrapMinified:Fe,isViewportWrapping:fe,wrappingColumn:J,verticalScrollbarWidth:jt,horizontalScrollbarHeight:dt,overviewRuler:{top:We,width:jt,height:Qe-2*We,right:0}}}}e.EditorLayoutInfoComputer=le;class ve extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(_){return l(_,"simple",["simple","advanced"])}compute(_,$e,Be){return $e.get(2)===2?"advanced":Be}}var se;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class be extends D{constructor(){const _={enabled:se.On};super(64,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",enum:[se.Off,se.OnCode,se.On],default:_.enabled,enumDescriptions:[$.localize(50,null),$.localize(51,null),$.localize(52,null)],description:$.localize(53,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:l(_.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class ne extends D{constructor(){const _={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:$.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:$.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:$.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:$.localize(57,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:l($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Y extends D{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:$.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(59,null),$.localize(60,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(61,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:$.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:$.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:$.localize(65,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:l($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),padding:o($e.padding,this.defaultValue.padding)}}}class V extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):a.clampedInt(_,this.defaultValue,0,1e3)}compute(_,$e,Be){return Be<0?a.clampedInt(-Be*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ie extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>h.clamp(_,0,150),{markdownDescription:$.localize(66,null)})}compute(_,$e,Be){return _.fontInfo.lineHeight}}class Ie extends D{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:$.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:$.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(69,null),$.localize(70,null),$.localize(71,null)],default:_.size,description:$.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:$.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:$.localize(74,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:$.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:$.localize(77,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),autohide:o($e.autohide,this.defaultValue.autohide),size:l($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:l($e.side,this.defaultValue.side,["right","left"]),showSlider:l($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o($e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt($e.scale,1,1,3),maxColumn:a.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Le(Z){return Z==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(79,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{top:a.clampedInt($e.top,0,0,1e3),bottom:a.clampedInt($e.bottom,0,0,1e3)}}}class ce extends D{constructor(){const _={enabled:!0,cycle:!0};super(85,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:$.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:$.localize(81,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),cycle:o($e.cycle,this.defaultValue.cycle)}}}class te extends w{constructor(){super(141)}compute(_,$e,Be){return _.pixelRatio}}class Q extends D{constructor(){const _={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(82,null),$.localize(83,null),$.localize(84,null)]}];super(88,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:_.strings,description:$.localize(85,null)},comments:{anyOf:$e,default:_.comments,description:$.localize(86,null)},other:{anyOf:$e,default:_.other,description:$.localize(87,null)}},default:_,markdownDescription:$.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Tt=_?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!_||typeof _!="object")return this.defaultValue;const{other:$e,comments:Be,strings:Qe}=_,it=["on","inline","off"];let rt,Ne,Pt;return typeof $e=="boolean"?rt=$e?"on":"off":rt=l($e,this.defaultValue.other,it),typeof Be=="boolean"?Ne=Be?"on":"off":Ne=l(Be,this.defaultValue.comments,it),typeof Qe=="boolean"?Pt=Qe?"on":"off":Pt=l(Qe,this.defaultValue.strings,it),{other:rt,comments:Ne,strings:Pt}}}var ee;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class me extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(89,null),$.localize(90,null),$.localize(91,null),$.localize(92,null)],default:"on",description:$.localize(93,null)})}validate(_){let $e=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?($e=4,Be=_):_==="interval"?$e=3:_==="relative"?$e=2:_==="on"?$e=1:$e=0),{renderType:$e,renderFn:Be}}}function pe(Z){const _=Z.get(97);return _==="editable"?Z.get(90):_!=="on"}e.filterValidationDecorations=pe;class Ae extends D{constructor(){const _=[],$e={type:"number",description:$.localize(94,null)};super(101,"rulers",_,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:$.localize(95,null),format:"color-hex"}}}]},default:_,description:$.localize(96,null)})}validate(_){if(Array.isArray(_)){const $e=[];for(const Be of _)if(typeof Be=="number")$e.push({column:a.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;$e.push({column:a.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return $e.sort((Be,Qe)=>Be.column-Qe.column),$e}return this.defaultValue}}class he extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function ye(Z,_){if(typeof Z!="string")return _;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends D{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(97,null),$.localize(98,null),$.localize(99,null)],default:"auto",description:$.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(101,null),$.localize(102,null),$.localize(103,null)],default:"auto",description:$.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:$.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:$.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:$.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:$.localize(108,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_,Be=a.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=a.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ye($e.vertical,this.defaultValue.vertical),horizontal:ye($e.horizontal,this.defaultValue.horizontal),useShadows:o($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:o($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:a.clampedInt($e.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:a.clampedInt($e.verticalSliderSize,Qe,0,1e3),scrollByPage:o($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends D{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:$.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:$.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:$.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:$.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:$.localize(115,null)}})}applyUpdate(_,$e){let Be=!1;$e.allowedCharacters&&_&&(T.$zn(_.allowedCharacters,$e.allowedCharacters)||(_={..._,allowedCharacters:$e.allowedCharacters},Be=!0)),$e.allowedLocales&&_&&(T.$zn(_.allowedLocales,$e.allowedLocales)||(_={..._,allowedLocales:$e.allowedLocales},Be=!0));const Qe=super.applyUpdate(_,$e);return Be?new u(Qe.newValue,!0):Qe}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{nonBasicASCII:x($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,$e){if(typeof _!="object"||!_)return $e;const Be={};for(const[Qe,it]of Object.entries(_))it===!0&&(Be[Qe]=!0);return Be}}class K extends D{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:$.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(117,null),$.localize(118,null),$.localize(119,null)],description:$.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:$.localize(121,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),mode:l($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:l($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class U extends D{constructor(){const _={enabled:M.$ss.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$ss.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:$.localize(123,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends D{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:_.bracketPairs,description:$.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(128,null),$.localize(129,null),$.localize(130,null)],default:_.bracketPairsHorizontal,description:$.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:$.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:$.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(134,null),$.localize(135,null),$.localize(136,null)],default:_.highlightActiveIndentation,description:$.localize(137,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{bracketPairs:x($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:x($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Z,_,$e){const Be=$e.indexOf(Z);return Be===-1?_:$e[Be]}class Ee extends D{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(138,null),$.localize(139,null)],default:_.insertMode,description:$.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:$.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:$.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:$.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(144,null),$.localize(145,null),$.localize(146,null),$.localize(147,null)],default:_.selectionMode,markdownDescription:$.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:$.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:$.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:$.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:$.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:$.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(185,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{insertMode:l($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:l($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o($e.showIcons,this.defaultValue.showIcons),showStatusBar:o($e.showStatusBar,this.defaultValue.showStatusBar),preview:o($e.preview,this.defaultValue.preview),previewMode:l($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o($e.showMethods,this.defaultValue.showMethods),showFunctions:o($e.showFunctions,this.defaultValue.showFunctions),showConstructors:o($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:o($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o($e.showFields,this.defaultValue.showFields),showVariables:o($e.showVariables,this.defaultValue.showVariables),showClasses:o($e.showClasses,this.defaultValue.showClasses),showStructs:o($e.showStructs,this.defaultValue.showStructs),showInterfaces:o($e.showInterfaces,this.defaultValue.showInterfaces),showModules:o($e.showModules,this.defaultValue.showModules),showProperties:o($e.showProperties,this.defaultValue.showProperties),showEvents:o($e.showEvents,this.defaultValue.showEvents),showOperators:o($e.showOperators,this.defaultValue.showOperators),showUnits:o($e.showUnits,this.defaultValue.showUnits),showValues:o($e.showValues,this.defaultValue.showValues),showConstants:o($e.showConstants,this.defaultValue.showConstants),showEnums:o($e.showEnums,this.defaultValue.showEnums),showEnumMembers:o($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o($e.showKeywords,this.defaultValue.showKeywords),showWords:o($e.showWords,this.defaultValue.showWords),showColors:o($e.showColors,this.defaultValue.showColors),showFiles:o($e.showFiles,this.defaultValue.showFiles),showReferences:o($e.showReferences,this.defaultValue.showReferences),showFolders:o($e.showFolders,this.defaultValue.showFolders),showTypeParameters:o($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o($e.showSnippets,this.defaultValue.showSnippets),showUsers:o($e.showUsers,this.defaultValue.showUsers),showIssues:o($e.showIssues,this.defaultValue.showIssues)}}}class Te extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(187,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(_.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class He extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(188,null),$.localize(189,null),$.localize(190,null),$.localize(191,null)],description:$.localize(192,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,$e,Be){return $e.get(2)===2?0:Be}}class Ye extends w{constructor(){super(144)}compute(_,$e,Be){const Qe=$e.get(143);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class st extends D{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),showDropSelector:l($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends D{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(199,null),$.localize(200,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const $e=_;return{enabled:o($e.enabled,this.defaultValue.enabled),showPasteSelector:l($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?at:C.$k?ct:tt,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var vt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.occurrencesHighlight=80]="occurrencesHighlight",Z[Z.overviewRulerBorder=81]="overviewRulerBorder",Z[Z.overviewRulerLanes=82]="overviewRulerLanes",Z[Z.padding=83]="padding",Z[Z.pasteAs=84]="pasteAs",Z[Z.parameterHints=85]="parameterHints",Z[Z.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=88]="quickSuggestions",Z[Z.quickSuggestionsDelay=89]="quickSuggestionsDelay",Z[Z.readOnly=90]="readOnly",Z[Z.readOnlyMessage=91]="readOnlyMessage",Z[Z.renameOnType=92]="renameOnType",Z[Z.renderControlCharacters=93]="renderControlCharacters",Z[Z.renderFinalNewline=94]="renderFinalNewline",Z[Z.renderLineHighlight=95]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=97]="renderValidationDecorations",Z[Z.renderWhitespace=98]="renderWhitespace",Z[Z.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Z[Z.roundedSelection=100]="roundedSelection",Z[Z.rulers=101]="rulers",Z[Z.scrollbar=102]="scrollbar",Z[Z.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=104]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=105]="scrollPredominantAxis",Z[Z.selectionClipboard=106]="selectionClipboard",Z[Z.selectionHighlight=107]="selectionHighlight",Z[Z.selectOnLineNumbers=108]="selectOnLineNumbers",Z[Z.showFoldingControls=109]="showFoldingControls",Z[Z.showUnused=110]="showUnused",Z[Z.snippetSuggestions=111]="snippetSuggestions",Z[Z.smartSelect=112]="smartSelect",Z[Z.smoothScrolling=113]="smoothScrolling",Z[Z.stickyScroll=114]="stickyScroll",Z[Z.stickyTabStops=115]="stickyTabStops",Z[Z.stopRenderingLineAfter=116]="stopRenderingLineAfter",Z[Z.suggest=117]="suggest",Z[Z.suggestFontSize=118]="suggestFontSize",Z[Z.suggestLineHeight=119]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Z[Z.suggestSelection=121]="suggestSelection",Z[Z.tabCompletion=122]="tabCompletion",Z[Z.tabIndex=123]="tabIndex",Z[Z.unicodeHighlighting=124]="unicodeHighlighting",Z[Z.unusualLineTerminators=125]="unusualLineTerminators",Z[Z.useShadowDOM=126]="useShadowDOM",Z[Z.useTabStops=127]="useTabStops",Z[Z.wordBreak=128]="wordBreak",Z[Z.wordSeparators=129]="wordSeparators",Z[Z.wordWrap=130]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=133]="wordWrapColumn",Z[Z.wordWrapOverride1=134]="wordWrapOverride1",Z[Z.wordWrapOverride2=135]="wordWrapOverride2",Z[Z.wrappingIndent=136]="wrappingIndent",Z[Z.wrappingStrategy=137]="wrappingStrategy",Z[Z.showDeprecated=138]="showDeprecated",Z[Z.inlayHints=139]="inlayHints",Z[Z.editorClassName=140]="editorClassName",Z[Z.pixelRatio=141]="pixelRatio",Z[Z.tabFocusMode=142]="tabFocusMode",Z[Z.layoutInfo=143]="layoutInfo",Z[Z.wrappingInfo=144]="wrappingInfo",Z[Z.defaultColorDecorators=145]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(201,null)})),acceptSuggestionOnEnter:je(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(202,null),""],markdownDescription:$.localize(203,null)})),accessibilitySupport:je(new f),accessibilityPageSize:je(new a(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(204,null),tags:["accessibility"]})),ariaLabel:je(new i(4,"ariaLabel",$.localize(205,null))),ariaRequired:je(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:je(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(207,null),$.localize(208,null),""],description:$.localize(209,null)})),autoClosingComments:je(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(210,null),$.localize(211,null),""],description:$.localize(212,null)})),autoClosingDelete:je(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(213,null),""],description:$.localize(214,null)})),autoClosingOvertype:je(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(215,null),""],description:$.localize(216,null)})),autoClosingQuotes:je(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(217,null),$.localize(218,null),""],description:$.localize(219,null)})),autoIndent:je(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[$.localize(220,null),$.localize(221,null),$.localize(222,null),$.localize(223,null),$.localize(224,null)],description:$.localize(225,null)})),automaticLayout:je(new t(13,"automaticLayout",!1)),autoSurround:je(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(226,null),$.localize(227,null),$.localize(228,null),""],description:$.localize(229,null)})),bracketPairColorization:je(new U),bracketPairGuides:je(new X),stickyTabStops:je(new t(115,"stickyTabStops",!1,{description:$.localize(230,null)})),codeLens:je(new t(17,"codeLens",!0,{description:$.localize(231,null)})),codeLensFontFamily:je(new i(18,"codeLensFontFamily","",{description:$.localize(232,null)})),codeLensFontSize:je(new a(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(233,null)})),colorDecorators:je(new t(20,"colorDecorators",!0,{description:$.localize(234,null)})),colorDecoratorActivatedOn:je(new r(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(235,null),$.localize(236,null),$.localize(237,null)],description:$.localize(238,null)})),colorDecoratorsLimit:je(new a(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(239,null)})),columnSelection:je(new t(22,"columnSelection",!1,{description:$.localize(240,null)})),comments:je(new S),contextmenu:je(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new t(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(241,null)})),cursorBlinking:je(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:$.localize(242,null)})),cursorSmoothCaretAnimation:je(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(243,null),$.localize(244,null),$.localize(245,null)],description:$.localize(246,null)})),cursorStyle:je(new d(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:$.localize(247,null)})),cursorSurroundingLines:je(new a(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(248,null)})),cursorSurroundingLinesStyle:je(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(249,null),$.localize(250,null)],markdownDescription:$.localize(251,null)})),cursorWidth:je(new a(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(252,null)})),disableLayerHinting:je(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new t(34,"domReadOnly",!1)),dragAndDrop:je(new t(35,"dragAndDrop",!0,{description:$.localize(253,null)})),emptySelectionClipboard:je(new G),dropIntoEditor:je(new st),stickyScroll:je(new ne),experimentalWhitespaceRendering:je(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(254,null),$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),extraEditorClassName:je(new i(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:$.localize(258,null)})),find:je(new W),fixedOverflowWidgets:je(new t(42,"fixedOverflowWidgets",!1)),folding:je(new t(43,"folding",!0,{description:$.localize(259,null)})),foldingStrategy:je(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(260,null),$.localize(261,null)],description:$.localize(262,null)})),foldingHighlight:je(new t(45,"foldingHighlight",!0,{description:$.localize(263,null)})),foldingImportsByDefault:je(new t(46,"foldingImportsByDefault",!1,{description:$.localize(264,null)})),foldingMaximumRegions:je(new a(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(265,null)})),unfoldOnClickAfterEndOfLine:je(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(266,null)})),fontFamily:je(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(267,null)})),fontInfo:je(new I),fontLigatures2:je(new z),fontSize:je(new H),fontWeight:je(new ae),fontVariations:je(new P),formatOnPaste:je(new t(55,"formatOnPaste",!1,{description:$.localize(268,null)})),formatOnType:je(new t(56,"formatOnType",!1,{description:$.localize(269,null)})),glyphMargin:je(new t(57,"glyphMargin",!0,{description:$.localize(270,null)})),gotoLocation:je(new de),hideCursorInOverviewRuler:je(new t(59,"hideCursorInOverviewRuler",!1,{description:$.localize(271,null)})),hover:je(new we),inDiffEditor:je(new t(61,"inDiffEditor",!1)),letterSpacing:je(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:$.localize(272,null)})),lightbulb:je(new be),lineDecorationsWidth:je(new V),lineHeight:je(new ie),lineNumbers:je(new me),lineNumbersMinChars:je(new a(68,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new t(69,"linkedEditing",!1,{description:$.localize(273,null)})),links:je(new t(70,"links",!0,{description:$.localize(274,null)})),matchBrackets:je(new r(71,"matchBrackets","always",["always","near","never"],{description:$.localize(275,null)})),minimap:je(new Ie),mouseStyle:je(new r(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:$.localize(276,null)})),mouseWheelZoom:je(new t(75,"mouseWheelZoom",!1,{markdownDescription:C.$j?$.localize(277,null):$.localize(278,null)})),multiCursorMergeOverlapping:je(new t(76,"multiCursorMergeOverlapping",!0,{description:$.localize(279,null)})),multiCursorModifier:je(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Le,{markdownEnumDescriptions:[$.localize(280,null),$.localize(281,null)],markdownDescription:$.localize(282,null)})),multiCursorPaste:je(new r(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(283,null),$.localize(284,null)],markdownDescription:$.localize(285,null)})),multiCursorLimit:je(new a(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(286,null)})),occurrencesHighlight:je(new r(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(287,null),$.localize(288,null),$.localize(289,null)],markdownDescription:$.localize(290,null)})),overviewRulerBorder:je(new t(81,"overviewRulerBorder",!0,{description:$.localize(291,null)})),overviewRulerLanes:je(new a(82,"overviewRulerLanes",3,0,3)),padding:je(new Ce),pasteAs:je(new nt),parameterHints:je(new ce),peekWidgetDefaultFocus:je(new r(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(292,null),$.localize(293,null)],description:$.localize(294,null)})),definitionLinkOpensInPeek:je(new t(87,"definitionLinkOpensInPeek",!1,{description:$.localize(295,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new a(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(296,null)})),readOnly:je(new t(90,"readOnly",!1)),readOnlyMessage:je(new he),renameOnType:je(new t(92,"renameOnType",!1,{description:$.localize(297,null),markdownDeprecationMessage:$.localize(298,null)})),renderControlCharacters:je(new t(93,"renderControlCharacters",!0,{description:$.localize(299,null),restricted:!0})),renderFinalNewline:je(new r(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(300,null)})),renderLineHighlight:je(new r(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(301,null)],description:$.localize(302,null)})),renderLineHighlightOnlyWhenFocus:je(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(303,null)})),renderValidationDecorations:je(new r(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new r(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(304,null),$.localize(305,null),$.localize(306,null),""],description:$.localize(307,null)})),revealHorizontalRightPadding:je(new a(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new t(100,"roundedSelection",!0,{description:$.localize(308,null)})),rulers:je(new Ae),scrollbar:je(new F),scrollBeyondLastColumn:je(new a(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(309,null)})),scrollBeyondLastLine:je(new t(104,"scrollBeyondLastLine",!0,{description:$.localize(310,null)})),scrollPredominantAxis:je(new t(105,"scrollPredominantAxis",!0,{description:$.localize(311,null)})),selectionClipboard:je(new t(106,"selectionClipboard",!0,{description:$.localize(312,null),included:C.$k})),selectionHighlight:je(new t(107,"selectionHighlight",!0,{description:$.localize(313,null)})),selectOnLineNumbers:je(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:je(new r(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),showUnused:je(new t(110,"showUnused",!0,{description:$.localize(318,null)})),showDeprecated:je(new t(138,"showDeprecated",!0,{description:$.localize(319,null)})),inlayHints:je(new Y),snippetSuggestions:je(new r(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(320,null),$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),smartSelect:je(new Te),smoothScrolling:je(new t(113,"smoothScrolling",!1,{description:$.localize(325,null)})),stopRenderingLineAfter:je(new a(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new Ee),inlineSuggest:je(new K),inlineCompletionsAccessibilityVerbose:je(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(326,null)})),suggestFontSize:je(new a(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new a(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new t(120,"suggestOnTriggerCharacters",!0,{description:$.localize(329,null)})),suggestSelection:je(new r(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(330,null),$.localize(331,null),$.localize(332,null)],description:$.localize(333,null)})),tabCompletion:je(new r(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),tabIndex:je(new a(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new q),unusualLineTerminators:je(new r(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null)],description:$.localize(341,null)})),useShadowDOM:je(new t(126,"useShadowDOM",!0)),useTabStops:je(new t(127,"useTabStops",!0,{description:$.localize(342,null)})),wordBreak:je(new r(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null)],description:$.localize(345,null)})),wordSeparators:je(new i(129,"wordSeparators",R.$ts,{description:$.localize(346,null)})),wordWrap:je(new r(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(347,null),$.localize(348,null),$.localize(349,null),$.localize(350,null)],description:$.localize(351,null)})),wordWrapBreakAfterCharacters:je(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new a(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(352,null)})),wordWrapOverride1:je(new r(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new r(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new O),defaultColorDecorators:je(new t(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(353,null)})),pixelRatio:je(new te),tabFocusMode:je(new t(142,"tabFocusMode",!1,{markdownDescription:$.localize(354,null)})),layoutInfo:je(new le),wrappingInfo:je(new Ye),wrappingIndent:je(new He),wrappingStrategy:je(new ve)}}),define(Pe[148],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Pe[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Pe[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Pe[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Pe[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[180],Re([1,0,15,150]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var C;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(C||(e.TokenType=C={}));function M(...b){switch(b.length){case 1:return(0,T.localize)(0,null,b[0]);case 2:return(0,T.localize)(1,null,b[0],b[1]);case 3:return(0,T.localize)(2,null,b[0],b[1],b[2]);default:return}}const R=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const D=this.d,u=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:u};this.g.push({offset:D,lexeme:u,additionalInfo:A}),this.f.push(p)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const D=this.c.substring(this.d,this.e),u=g.b.get(D);u?this.k(u):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,D=!1,u=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const w=this.c.charCodeAt(A);if(D)D=!1;else if(w===47&&!u){A++;break}else w===91?u=!0:w===92?D=!0:w===93&&(u=!1);A++}for(;A<this.c.length&&g.a.has(this.c.charCodeAt(A));)A++;this.e=A;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=g}),define(Pe[181],Re([1,0,25,31,152,293]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function g(t){return t=t.trim(),t==="*"||R.test(t)}e.$ap=g;function b(t){if(!g(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$bp=b;function A(t){if(!t)return null;const n=t.majorBase,a=t.majorMustEqual,c=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let l=t.patchMustEqual;t.hasCaret&&(n===0||(h=!1),l=!1);let r=0;if(t.preRelease){const d=$.exec(t.preRelease);if(d){const[,m,f,S]=d;r=Date.UTC(Number(m),Number(f)-1,Number(S))}}return{majorBase:n,majorMustEqual:a,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:l,isMinimum:t.hasGreaterEquals,notBefore:r}}e.$cp=A;function D(t,n,a){let c;typeof t=="string"?c=A(b(t)):c=t;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof a=="string"?i=A(b(a)):i=a,!c||!i)return!1;const l=c.majorBase,r=c.minorBase,d=c.patchBase;let m=i.majorBase,f=i.minorBase,S=i.patchBase;const L=i.notBefore;let v=i.majorMustEqual,y=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?l>m?!0:l<m?!1:r>f?!0:r<f||h&&h<L?!1:d>=S:(l===1&&m===0&&(!v||!y||!k)&&(m=1,f=0,S=0,v=!0,y=!1,k=!1),l<m?!1:l>m?!v:r<f?!1:r>f?!y:d<S?!1:d>S?!k:!(h&&h<L))}e.$dp=D;function u(t,n,a,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,C.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,C.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,C.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,C.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([T.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([T.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,C.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,C.localize(9,null,"main")]),i;{const d=(0,E.$Hg)(a,c.main);(0,E.$Bg)(d,a)||i.push([T.default.Warning,C.localize(10,null,d.path,a.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,C.localize(11,null,"browser")]),i;{const d=(0,E.$Hg)(a,c.browser);(0,E.$Bg)(d,a)||i.push([T.default.Warning,C.localize(12,null,d.path,a.path)])}}if(!M.valid(c.version))return i.push([T.default.Error,C.localize(13,null)]),i;const l=[];if(!p(t,n,c,h,l))for(const d of l)i.push([T.default.Error,d]);return i}e.$ep=u;function p(t,n,a,c,h){return c||typeof a.main>"u"&&typeof a.browser>"u"?!0:s(t,n,a.engines.vscode,h)}e.$fp=p;function w(t,n,a){return t==="*"||s(n,a,t)}e.$gp=w;function s(t,n,a,c=[]){const h=A(b(a));if(!h)return c.push(C.localize(14,null,a)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(C.localize(15,null,a)),!1}else if(!h.majorMustEqual)return c.push(C.localize(16,null,a)),!1;return D(t,n,h)?!0:(c.push(C.localize(17,null,t,a)),!1)}function o(t){if(!Array.isArray(t))return!1;for(let n=0,a=t.length;n<a;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Pe[69],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class E{constructor(C,M=[],R=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$3h=E}),define(Pe[70],Re([1,0,69]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const T=[];var C;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function M($,g,b){g instanceof E.$3h||(g=new E.$3h(g,[],!!b)),T.push([$,g])}e.$Yr=M;function R(){return T}e.$Zr=R}),define(Pe[182],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class E{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=E;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const $=this.lookupOrInsertNode(M),g=this.lookupOrInsertNode(R);$.outgoing.set(g.key,g),g.incoming.set($.key,$)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let $=this.a.get(R);return $||($=new E(R,M),this.a.set(R,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,$]of this.a)M.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const $=new Set([M]),g=this.c(R,$);if(g)return g}}c(M,R){for(const[$,g]of M.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const b=this.c(g,R);if(b)return b;R.delete($)}}}e.$Dq=T}),define(Pe[4],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(g){return g[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$5h=C("instantiationService");function T(R,$,g){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:g}):($[E.DI_DEPENDENCIES]=[{id:R,index:g}],$[E.DI_TARGET]=$)}function C(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(g,b,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,g,A)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$6h=C;function M(R){return R}e.$7h=M}),define(Pe[41],Re([1,0,16,2,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,C.$6h)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$Ai=M;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$Bi=R;var $;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function g(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=g;function b(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$Di=b;function A(t,n){const a=Object.create(null);for(const c in t)D(a,c,t[c],n);return a}e.$Ei=A;function D(t,n,a,c){const h=n.split("."),i=h.pop();let l=t;for(let r=0;r<h.length;r++){const d=h[r];let m=l[d];switch(typeof m){case"undefined":m=l[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,r+1).join(".")} is ${JSON.stringify(m)}`);return}l=m}if(typeof l=="object"&&l!==null)try{l[i]=a}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(l)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(l)}`)}e.$Fi=D;function u(t,n){const a=n.split(".");p(t,a)}e.$Gi=u;function p(t,n){const a=n.shift();if(n.length===0){delete t[a];return}if(Object.keys(t).indexOf(a)!==-1){const c=t[a];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete t[a])}}function w(t,n,a){function c(l,r){let d=l;for(const m of r){if(typeof d!="object"||d===null)return;d=d[m]}return d}const h=n.split("."),i=c(t,h);return typeof i>"u"?a:i}e.$Hi=w;function s(t,n,a){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in t?E.$Kf(t[c])&&E.$Kf(n[c])?s(t[c],n[c],a):a&&(t[c]=n[c]):t[c]=n[c])})}e.$Ii=s;function o(t){return t.replace(/[\[\]]/g,"")}e.$Ji=o}),define(Pe[35],Re([1,0,21,11,180,4,149,15]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",E.$j),g.set("isLinux",E.$k),g.set("isWindows",E.$i),g.set("isWeb",E.$o),g.set("isMacNative",E.$j&&!E.$o),g.set("isEdge",E.$H),g.set("isFirefox",E.$F),g.set("isChrome",E.$E),g.set("isSafari",E.$G);function b(Y,V){if(g.get(Y)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(Y,V)}e.$2i=b;const A=Object.prototype.hasOwnProperty;var D;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const u={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),w=(0,R.localize)(1,null),s=(0,R.localize)(2,null),o=(0,R.localize)(3,null),t=(0,R.localize)(4,null),n=(0,R.localize)(5,null),a=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=u){this.k=V,this.d=new C.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const Ie=this.D(),Le=Ie.type===17?n:void 0;throw this.h.push({message:t,offset:Ie.offset,lexeme:C.$1i.getLexeme(Ie),additionalInfo:Le}),h.c}return ie}catch(ie){if(ie!==h.c)throw ie;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ie=this.o();V.push(ie)}return V.length===1?V[0]:i.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ie=this.s();V.push(ie)}return V.length===1?V[0]:i.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),m.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,o),ie?.negate()}case 17:return this.z(),N.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ie=this.l();return this.A(1,o),ie}case 17:{const ie=V.lexeme;if(this.z(),this.y(9)){const Le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Le.type!==10)throw this.B("REGEX",Le);const Ce=Le.lexeme,ce=Ce.lastIndexOf("/"),te=ce===Ce.length-1?void 0:this.w(Ce.substring(ce+1));let Q;try{Q=new RegExp(Ce.substring(1,ce),te)}catch{throw this.B("REGEX",Le)}return I.create(ie,Q)}switch(Le.type){case 10:case 19:{const Ce=[Le.lexeme];this.z();let ce=this.D(),te=0;for(let Ae=0;Ae<Le.lexeme.length;Ae++)Le.lexeme.charCodeAt(Ae)===40?te++:Le.lexeme.charCodeAt(Ae)===41&&te--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Ae=0;Ae<ce.lexeme.length;Ae++)ce.lexeme.charCodeAt(Ae)===40?te++:Le.lexeme.charCodeAt(Ae)===41&&te--}if(te<0)break;Ce.push(C.$1i.getLexeme(ce)),this.z(),ce=this.D()}const Q=Ce.join(""),ee=Q.lastIndexOf("/"),me=ee===Q.length-1?void 0:this.w(Q.substring(ee+1));let pe;try{pe=new RegExp(Q.substring(1,ee),me)}catch{throw this.B("REGEX",Le)}return i.regex(ie,pe)}case 18:{const Ce=Le.lexeme;this.z();let ce=null;if(!(0,T.$Je)(Ce)){const te=Ce.indexOf("/"),Q=Ce.lastIndexOf("/");if(te!==Q&&te>=0){const ee=Ce.slice(te+1,Q),me=Ce[Q+1]==="i"?"i":"";try{ce=new RegExp(ee,me)}catch{throw this.B("REGEX",Le)}}}if(ce===null)throw this.B("REGEX",Le);return I.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Le=this.u();return i.notIn(ie,Le)}switch(this.D().type){case 3:{this.z();const Le=this.u();if(this.x().type===18)return i.equals(ie,Le);switch(Le){case"true":return i.has(ie);case"false":return i.not(ie);default:return i.equals(ie,Le)}}case 4:{this.z();const Le=this.u();if(this.x().type===18)return i.notEquals(ie,Le);switch(Le){case"true":return i.not(ie);case"false":return i.has(ie);default:return i.notEquals(ie,Le)}}case 5:return this.z(),z.create(ie,this.u());case 6:return this.z(),P.create(ie,this.u());case 7:return this.z(),G.create(ie,this.u());case 8:return this.z(),W.create(ie,this.u());case 13:return this.z(),i.in(ie,this.u());default:return i.has(ie)}}case 20:throw this.h.push({message:a,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ie){if(this.C(V))return this.z();throw this.B(ie,this.D())}B(V,ie,Ie){const Le=(0,R.localize)(8,null,V,C.$1i.getLexeme(ie)),Ce=ie.offset,ce=C.$1i.getLexeme(ie);return this.h.push({message:Le,offset:Ce,lexeme:ce,additionalInfo:Ie}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=h;class i{static false(){return m.INSTANCE}static true(){return f.INSTANCE}static has(V){return S.create(V)}static equals(V,ie){return L.create(V,ie)}static notEquals(V,ie){return k.create(V,ie)}static regex(V,ie){return I.create(V,ie)}static in(V,ie){return v.create(V,ie)}static notIn(V,ie){return y.create(V,ie)}static not(V){return N.create(V)}static and(...V){return de.create(V,null,!0)}static or(...V){return we.create(V,null,!0)}static greater(V,ie){return G.create(V,ie)}static greaterEquals(V,ie){return W.create(V,ie)}static smaller(V,ie){return z.create(V,ie)}static smallerEquals(V,ie){return P.create(V,ie)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$4i=i;function l(Y){const V=new h({regexParsingWithErrorRecovery:!1});return Y.map(ie=>(V.parse(ie),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,R.localize)(9,null,Ie.additionalInfo):(0,R.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$5i=l;function r(Y,V){const ie=Y?Y.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ie&&!Ie?!0:!ie||!Ie?!1:ie.equals(Ie)}e.$6i=r;function d(Y,V){return Y.cmp(V)}class m{static{this.INSTANCE=new m}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return f.INSTANCE}}e.$7i=m;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return m.INSTANCE}}e.$8i=f;class S{static create(V,ie=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?f.INSTANCE:m.INSTANCE:new S(V,ie)}constructor(V,ie){this.key=V,this.c=ie,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:le(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=g.get(this.key);return typeof V=="boolean"?V?f.INSTANCE:m.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$9i=S;class L{static create(V,ie,Ie=null){if(typeof ie=="boolean")return ie?S.create(V,Ie):N.create(V,Ie);const Le=g.get(V);return typeof Le=="boolean"?ie===(Le?"true":"false")?f.INSTANCE:m.INSTANCE:new L(V,ie,Ie)}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?f.INSTANCE:m.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$0i=L;class v{static create(V,ie){return new v(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ie)?ie.includes(Ie):typeof Ie=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$$i=v;class y{static create(V,ie){return new y(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=11,this.c=v.create(V,ie)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=y;class k{static create(V,ie,Ie=null){if(typeof ie=="boolean")return ie?N.create(V,Ie):S.create(V,Ie);const Le=g.get(V);return typeof Le=="boolean"?ie===(Le?"true":"false")?m.INSTANCE:f.INSTANCE:new k(V,ie,Ie)}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?m.INSTANCE:f.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$aj=k;class N{static create(V,ie=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?m.INSTANCE:f.INSTANCE:new N(V,ie)}constructor(V,ie){this.c=V,this.d=ie,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=g.get(this.c);return typeof V=="boolean"?V?m.INSTANCE:f.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$bj=N;function O(Y,V){if(typeof Y=="string"){const ie=parseFloat(Y);isNaN(ie)||(Y=ie)}return typeof Y=="string"||typeof Y=="number"?V(Y):m.INSTANCE}class G{static create(V,ie,Ie=null){return O(ie,Le=>new G(V,Le,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$cj=G;class W{static create(V,ie,Ie=null){return O(ie,Le=>new W(V,Le,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$dj=W;class z{static create(V,ie,Ie=null){return O(ie,Le=>new z(V,Le,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$ej=z;class P{static create(V,ie,Ie=null){return O(ie,Le=>new P(V,Le,Ie))}constructor(V,ie,Ie){this.c=V,this.d=ie,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$fj=P;class I{static create(V,ie){return new I(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ie=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ie<Ie?-1:ie>Ie?1:0}equals(V){if(V.type===this.type){const ie=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ie===Ie}return!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$gj=I;class H{static create(V){return new H(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new H(this.c.map(V))}negate(){return this.c}}e.$hj=H;function ae(Y){let V=null;for(let ie=0,Ie=Y.length;ie<Ie;ie++){const Le=Y[ie].substituteConstants();if(Y[ie]!==Le&&V===null){V=[];for(let Ce=0;Ce<ie;Ce++)V[Ce]=Y[Ce]}V!==null&&(V[ie]=Le)}return V===null?Y:V}class de{static create(V,ie,Ie){return de.d(V,ie,Ie)}constructor(V,ie){this.expr=V,this.c=ie,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++){const Le=d(this.expr[ie],V.expr[ie]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:de.create(V,this.c,!1)}evaluate(V){for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(!this.expr[ie].evaluate(V))return!1;return!0}static d(V,ie,Ie){const Le=[];let Ce=!1;for(const ce of V)if(ce){if(ce.type===1){Ce=!0;continue}if(ce.type===0)return m.INSTANCE;if(ce.type===6){Le.push(...ce.expr);continue}Le.push(ce)}if(Le.length===0&&Ce)return f.INSTANCE;if(Le.length!==0){if(Le.length===1)return Le[0];Le.sort(d);for(let ce=1;ce<Le.length;ce++)Le[ce-1].equals(Le[ce])&&(Le.splice(ce,1),ce--);if(Le.length===1)return Le[0];for(;Le.length>1;){const ce=Le[Le.length-1];if(ce.type!==9)break;Le.pop();const te=Le.pop(),Q=Le.length===0,ee=we.create(ce.expr.map(me=>de.create([me,te],null,Ie)),null,Q);ee&&(Le.push(ee),Le.sort(d))}if(Le.length===1)return Le[0];if(Ie){for(let ce=0;ce<Le.length;ce++)for(let te=ce+1;te<Le.length;te++)if(Le[ce].negate().equals(Le[te]))return m.INSTANCE;if(Le.length===1)return Le[0]}return new de(Le,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new de(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());this.c=we.create(V,this,!0)}return this.c}}e.$ij=de;class we{static create(V,ie,Ie){return we.d(V,ie,Ie)}constructor(V,ie){this.expr=V,this.c=ie,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++){const Le=d(this.expr[ie],V.expr[ie]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:we.create(V,this.c,!1)}evaluate(V){for(let ie=0,Ie=this.expr.length;ie<Ie;ie++)if(this.expr[ie].evaluate(V))return!0;return!1}static d(V,ie,Ie){let Le=[],Ce=!1;if(V){for(let ce=0,te=V.length;ce<te;ce++){const Q=V[ce];if(Q){if(Q.type===0){Ce=!0;continue}if(Q.type===1)return f.INSTANCE;if(Q.type===9){Le=Le.concat(Q.expr);continue}Le.push(Q)}}if(Le.length===0&&Ce)return m.INSTANCE;Le.sort(d)}if(Le.length!==0){if(Le.length===1)return Le[0];for(let ce=1;ce<Le.length;ce++)Le[ce-1].equals(Le[ce])&&(Le.splice(ce,1),ce--);if(Le.length===1)return Le[0];if(Ie){for(let ce=0;ce<Le.length;ce++)for(let te=ce+1;te<Le.length;te++)if(Le[ce].negate().equals(Le[te]))return f.INSTANCE;if(Le.length===1)return Le[0]}return new we(Le,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new we(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());for(;V.length>1;){const ie=V.shift(),Ie=V.shift(),Le=[];for(const Ce of ne(ie))for(const ce of ne(Ie))Le.push(de.create([Ce,ce],null,!1));V.unshift(we.create(Le,null,!1))}this.c=we.create(V,this,!0)}return this.c}}e.$jj=we;class ke extends S{static{this.d=[]}static all(){return ke.d.values()}constructor(V,ie,Ie){super(V,null),this.f=ie,typeof Ie=="object"?ke.d.push({...Ie,key:V}):Ie!==!0&&ke.d.push({key:V,description:Ie,type:ie!=null?typeof ie:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return L.create(this.key,V)}notEqualsTo(V){return k.create(this.key,V)}}e.$kj=ke,e.$lj=(0,M.$6h)("contextKeyService");function le(Y,V){return Y<V?-1:Y>V?1:0}function ve(Y,V,ie,Ie){return Y<ie?-1:Y>ie?1:V<Ie?-1:V>Ie?1:0}function se(Y,V){if(Y.type===0||V.type===1)return!0;if(Y.type===9)return V.type===9?be(Y.expr,V.expr):!1;if(V.type===9){for(const ie of V.expr)if(se(Y,ie))return!0;return!1}if(Y.type===6){if(V.type===6)return be(V.expr,Y.expr);for(const ie of Y.expr)if(se(ie,V))return!0;return!1}return Y.equals(V)}e.$mj=se;function be(Y,V){let ie=0,Ie=0;for(;ie<Y.length&&Ie<V.length;){const Le=Y[ie].cmp(V[Ie]);if(Le<0)return!1;Le===0&&ie++,Ie++}return ie===Y.length}function ne(Y){return Y.type===9?Y.expr:[Y]}}),define(Pe[183],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,E.$6h)("environmentService"),e.$bi=(0,E.$7h)(e.$ai)}),define(Pe[97],Re([1,0,151,4]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function C(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=C;function M(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=M;function R(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=R;function $(t,n){return n==="web"&&!t.includes("web")}e.$vo=$;function g(t,n,a){return $(n,a)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===a}e.$wo=g;function b(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$xo=b;var A;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var D;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var u;(function(t){t.Install="install",t.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var p;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$yo=(0,T.$6h)("extensionGalleryService");var w;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var s;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class o extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.$zo=o,e.$Ao=(0,T.$6h)("extensionManagementService"),e.$Bo="extensionsIdentifiers/disabled",e.$Co="extensionsIdentifiers/enabled",e.$Do=(0,T.$6h)("IGlobalExtensionEnablementService"),e.$Eo=(0,T.$6h)("IExtensionTipsService"),e.$Fo=(0,E.localize)(0,null),e.$Go={value:e.$Fo,original:"Extensions"},e.$Ho=(0,E.localize2)(1,"Preferences")}),define(Pe[42],Re([1,0,50,19,11,16,2,153,4,21,12,39]),function(ge,e,E,T,C,M,R,$,g,b,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,g.$6h)("fileService");function u(se){return se.create===!0}e.$rk=u;var p;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var w;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(w||(e.FilePermission=w={}));function s(se){const be=se;return!!be&&typeof be.onDidChange=="function"}e.$sk=s;var o;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function t(se){return!!(se.capabilities&2)}e.$tk=t;function n(se){return!!(se.capabilities&8)}e.$uk=n;function a(se){return!!(se.capabilities&131072)}e.$vk=a;function c(se){return!!(se.capabilities&4)}e.$wk=c;function h(se){return!!(se.capabilities&16)}e.$xk=h;function i(se){return t(se)?!!(se.capabilities&16384):!1}e.$yk=i;function l(se){return t(se)?!!(se.capabilities&32768):!1}e.$zk=l;function r(se){return!!(se.capabilities&65536)}e.$Ak=r;function d(se){return!!(se.capabilities&2048)}e.$Bk=d;var m;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(m||(e.FileSystemProviderErrorCode=m={}));class f extends Error{static create(be,ne){const Y=new f(be.toString(),ne);return v(Y,ne),Y}constructor(be,ne){super(be),this.code=ne}}e.$Ck=f;function S(se,be){return f.create(se,be)}e.$Dk=S;function L(se){return se||S((0,$.localize)(0,null),m.Unknown)}e.$Ek=L;function v(se,be){return se.name=be?`${be} (FileSystemError)`:"FileSystemError",se}e.$Fk=v;function y(se){if(!se)return m.Unknown;if(se instanceof f)return se.code;const be=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!be)return m.Unknown;switch(be[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.$Gk=y;function k(se){if(se instanceof P)return se.fileOperationResult;switch(y(se)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 9;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileTooLarge:return 7;default:return 10}}e.$Hk=k;var N;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class O{constructor(be,ne,Y){this.resource=be,this.operation=ne,this.target=Y}isOperation(be){return this.operation===be}}e.$Ik=O;var G;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class W{static{this.a=null}constructor(be,ne){this.c=ne,this.b=void 0,this.d=new D.$V(()=>{const Y=E.$_h.forUris(()=>this.c);return Y.fill(this.rawAdded.map(V=>[V,!0])),Y}),this.f=new D.$V(()=>{const Y=E.$_h.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(V=>[V,!0])),Y}),this.g=new D.$V(()=>{const Y=E.$_h.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(V=>[V,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of be){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.b!==W.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(be,...ne){return this.h(be,{includeChildren:!1},...ne)}affects(be,...ne){return this.h(be,{includeChildren:!0},...ne)}h(be,ne,...Y){if(!be)return!1;const V=Y.length>0;return!!((!V||Y.includes(1))&&(this.d.value.get(be)||ne.includeChildren&&this.d.value.findSuperstr(be))||(!V||Y.includes(0))&&(this.f.value.get(be)||ne.includeChildren&&this.f.value.findSuperstr(be))||(!V||Y.includes(2))&&(this.g.value.findSubstr(be)||ne.includeChildren&&this.g.value.findSuperstr(be)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(be){return this.b===be}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=W;function z(se,be,ne){return!se||!be||se===be||be.length>se.length?!1:(be.charAt(be.length-1)!==T.sep&&(be+=T.sep),ne?(0,C.$af)(se,be):se.indexOf(be)===0)}e.$Kk=z;class P extends Error{constructor(be,ne,Y){super(be),this.fileOperationResult=ne,this.options=Y}}e.$Lk=P;class I extends P{constructor(be,ne,Y,V){super(be,ne,V),this.fileOperationResult=ne,this.size=Y}}e.$Mk=I;class H extends P{constructor(be,ne,Y){super(be,2,Y),this.stat=ne}}e.$Nk=H;var ae;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var de;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(e.FileKind=de={})),e.$Vk="";function we(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$Wk=we;async function ke(se,be){if(!be.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(ne=>{const Y=be.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===se.scheme&&V.added&&(Y.dispose(),ne())})})}e.$Xk=ke;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(be){return(0,M.$Mf)(be)||(be=0),be<le.KB?(0,$.localize)(1,null,be.toFixed(0)):be<le.MB?(0,$.localize)(2,null,(be/le.KB).toFixed(2)):be<le.GB?(0,$.localize)(3,null,(be/le.MB).toFixed(2)):be<le.TB?(0,$.localize)(4,null,(be/le.GB).toFixed(2)):(0,$.localize)(5,null,(be/le.TB).toFixed(2))}}e.$Yk=le;function ve(se){const be=typeof se=="string"||se?.scheme===A.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===A.Schemas.file?1024*le.MB:be?10*le.MB:b.$o?50*le.MB:1024*le.MB}e.$Zk=ve}),define(Pe[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class E{constructor(...C){this.a=new Map;for(const[M,R]of C)this.set(M,R)}set(C,M){const R=this.a.get(C);return this.a.set(C,M),R}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$4h=E}),define(Pe[184],Re([1,0,13,15,6,69,182,4,71,185]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const A=!1;class D extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new g.$4h,t=!1,n,a=A){this.f=o,this.g=t,this.h=n,this.i=a,this.o=new Set,this.f.set($.$5h,this),this._globalGraph=a?n?._globalGraph??new R.$Dq(c=>c):void 0}createChild(o){return new u(o,this.g,this,this.i)}invokeFunction(o,...t){const n=w.traceInvocation(this.i,o);let a=!1;try{return o({get:h=>{if(a)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{a=!0,n.stop()}}createInstance(o,...t){let n,a;return o instanceof M.$3h?(n=w.traceCreation(this.i,o.ctor),a=this.j(o.ctor,o.staticArguments.concat(t),n)):(n=w.traceCreation(this.i,o),a=this.j(o,t,n)),n.stop(),a}j(o,t=[],n){const a=$._util.getServiceDependencies(o).sort((i,l)=>i.index-l.index),c=[];for(const i of a){const l=this.m(i.id,n);l||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(l)}const h=a.length>0?a[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(o,t.concat(c))}k(o,t){if(this.f.get(o)instanceof M.$3h)this.f.set(o,t);else if(this.h)this.h.k(o,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const t=this.f.get(o);return!t&&this.h?this.h.l(o):t}m(o,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof M.$3h?this.q(o,n,t.branch(o,!0)):(t.branch(o,!1),n)}q(o,t,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,t,n)}finally{this.o.delete(o)}}r(o,t,n){const a=new R.$Dq(i=>i.id.toString());let c=0;const h=[{id:o,desc:t,_trace:n}];for(;h.length;){const i=h.pop();if(a.lookupOrInsertNode(i),c++>1e3)throw new D(a);for(const l of $._util.getServiceDependencies(i.desc.ctor)){const r=this.l(l.id);if(r||this.u(`[createInstance] ${o} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(l.id)),r instanceof M.$3h){const d={id:l.id,desc:r,_trace:i._trace.branch(l.id,!0)};a.insertEdge(i,d),h.push(d)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new D(a);break}for(const{data:l}of i){if(this.l(l.id)instanceof M.$3h){const d=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,d)}a.removeNode(l)}}return this.l(o)}s(o,t,n=[],a,c){if(this.f.get(o)instanceof M.$3h)return this.t(o,t,n,a,c);if(this.h)return this.h.s(o,t,n,a,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(o,t,n=[],a,c){if(a){const h=new u(void 0,this.g,this,this.i);h.c=String(o);const i=new Map,l=new E.$mh(()=>{const r=h.j(t,n,c);for(const[d,m]of i){const f=r[d];if(typeof f=="function")for(const S of m)S.disposable=f.apply(r,S.listener)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,d){if(!l.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let S=i.get(d);return S||(S=new b.$4c,i.set(d,S)),(v,y,k)=>{if(l.isInitialized)return l.value[d](v,y,k);{const N={listener:[v,y,k],disposable:void 0},O=S.push(N);return(0,C.$Rc)(()=>{O(),N.disposable?.dispose()})}}}if(d in r)return r[d];const m=l.value;let f=m[d];return typeof f!="function"||(f=f.bind(m),r[d]=f),f},set(r,d,m){return l.value[d]=m,!0},getPrototypeOf(r){return t.prototype}})}else return this.j(t,n,c)}u(o,t){if(t&&console.warn(o),this.g)throw new Error(o)}}e.$Eq=u;var p;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(p||(p={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,t){return o?new w(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(o,t){return o?new w(1,t.name):w.c}static{this.f=0}constructor(o,t){this.type=o,this.name=t,this.g=Date.now(),this.h=[]}branch(o,t){const n=new w(3,o.toString());return this.h.push([o,t,n]),n}stop(){const o=Date.now()-this.g;w.f+=o;let t=!1;function n(c,h){const i=[],l=new Array(c+1).join("	");for(const[r,d,m]of h.h)if(d&&m){t=!0,i.push(`${l}CREATES -> ${r}`);const f=n(c+1,m);f&&i.push(f)}else i.push(`${l}uses -> ${r}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(o>2||t)&&w.all.add(a.join(`
`))}}e.$Fq=w}),define(Pe[14],Re([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,u.$6h)("logService"),e.$oj=(0,u.$6h)("loggerService");function p(){return new Date().toISOString()}function w(v){return(0,b.$Mf)(v)}e.$pj=w;var s;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$qj=s.Info;function o(v,y,k){switch(y){case s.Trace:v.trace(k);break;case s.Debug:v.debug(k);break;case s.Info:v.info(k);break;case s.Warning:v.warn(k);break;case s.Error:v.error(k);break;case s.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=o;function t(v,y=!1){let k="";for(let N=0;N<v.length;N++){let O=v[N];if(O instanceof Error&&(O=(0,E.$Qi)(O,y)),typeof O=="object")try{O=JSON.stringify(O)}catch{}k+=(N>0?" ":"")+O}return k}class n extends M.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new T.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==s.Off&&this.b<=y}}e.$sj=n;class a extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...k){this.f(s.Trace)&&this.g(s.Trace,t([y,...k],!0))}debug(y,...k){this.f(s.Debug)&&this.g(s.Debug,t([y,...k]))}info(y,...k){this.f(s.Info)&&this.g(s.Info,t([y,...k]))}warn(y,...k){this.f(s.Warning)&&this.g(s.Warning,t([y,...k]))}error(y,...k){if(this.f(s.Error))if(y instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=y.stack,this.g(s.Error,t(N))}else this.g(s.Error,t([y,...k]))}flush(){}}e.$tj=a;class c extends n{constructor(y=e.$qj){super(),this.setLevel(y),this.g=!$.$i}trace(y,...k){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...k):console.log(`[main ${p()}]`,y,...k))}debug(y,...k){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...k):console.log(`[main ${p()}]`,y,...k))}info(y,...k){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...k):console.log(`[main ${p()}]`,y,...k))}warn(y,...k){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,y,...k):console.warn(`[main ${p()}]`,y,...k))}error(y,...k){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,y,...k):console.error(`[main ${p()}]`,y,...k))}flush(){}}e.$uj=c;class h extends n{constructor(y=e.$qj,k=!0){super(),this.g=k,this.setLevel(y)}trace(y,...k){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...k):console.log(y,...k))}debug(y,...k){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...k):console.log(y,...k))}info(y,...k){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...k):console.log(y,...k))}warn(y,...k){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...k):console.log(y,...k))}error(y,...k){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...k):console.error(y,...k))}flush(){}}e.$vj=h;class i extends n{constructor(y,k=e.$qj){super(),this.g=y,this.setLevel(k)}trace(y,...k){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(y),...k])}debug(y,...k){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(y),...k])}info(y,...k){this.f(s.Info)&&this.g.log(s.Info,[this.h(y),...k])}warn(y,...k){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(y),...k])}error(y,...k){this.f(s.Error)&&this.g.log(s.Error,[this.h(y),...k])}h(y){return typeof y=="string"?y:(0,E.$Qi)(y,this.f(s.Trace))}flush(){}}e.$wj=i;class l extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const k of this.g)k.setLevel(y);super.setLevel(y)}trace(y,...k){for(const N of this.g)N.trace(y,...k)}debug(y,...k){for(const N of this.g)N.debug(y,...k)}info(y,...k){for(const N of this.g)N.info(y,...k)}warn(y,...k){for(const N of this.g)N.warn(y,...k)}error(y,...k){for(const N of this.g)N.error(y,...k)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$xj=l;class r extends M.$Tc{constructor(y,k,N){if(super(),this.h=y,this.j=k,this.b=new R.$Ac,this.c=this.B(new T.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Vd),this.onDidChangeVisibility=this.g.event,N)for(const O of N)this.b.set(O.resource,{logger:void 0,info:O})}m(y){return(0,b.$If)(y)?[...this.b.values()].find(k=>k.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,k){const N=this.n(y),O=(0,b.$If)(y)?y:k?.id??(0,C.$Ti)(N.toString()).toString(16);let G=this.b.get(N)?.logger;const W=k?.logLevel==="always"?s.Trace:k?.logLevel;G||(G=this.s(N,W??this.getLogLevel(N)??this.h,{...k,id:O}));const z={logger:G,info:{resource:N,id:O,logLevel:W,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(z.info),this.b.set(N,z),G}n(y){return(0,b.$If)(y)?(0,g.$Hg)(this.j,`${y}.log`):y}setLogLevel(y,k){if(A.URI.isUri(y)){const N=y,O=k,G=this.b.get(N);G&&O!==G.info.logLevel&&(G.info.logLevel=O===this.h?void 0:O,G.logger?.setLevel(O),this.b.set(G.info.resource,G),this.f.fire([N,O]))}else{this.h=y;for(const[N,O]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,k){const N=this.m(y);N&&k!==!N.info.hidden&&(N.info.hidden=!k,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,k]))}getLogLevel(y){let k;return y&&(k=this.b.get(y)?.info.logLevel),k??this.h}registerLogger(y){const k=this.b.get(y.resource);k?k.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const k=this.b.get(y);k&&(k.logger&&k.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=r;class d{constructor(){this.onDidChangeLogLevel=new T.$Vd().event}setLevel(y){}getLevel(){return s.Info}trace(y,...k){}debug(y,...k){}info(y,...k){}warn(y,...k){}error(y,...k){}critical(y,...k){}dispose(){}flush(){}}e.$zj=d;class m extends d{}e.$Aj=m;function f(v){if(v.verbose)return s.Trace;if(typeof v.logLevel=="string"){const y=L(v.logLevel.toLowerCase());if(y!==void 0)return y}return e.$qj}e.$Bj=f;function S(v){switch(v){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.$Cj=S;function L(v){switch(v){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$Dj=L,e.$Ej=new D.$kj("logLevel",S(s.Info))}),define(Pe[186],Re([1,0,6,14]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=void 0;class C extends E.$Tc{constructor(R,$=[]){super(),this.a=new T.$xj([R,...$]),this.B(R.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$uO=C}),define(Pe[99],Re([1,0,31,154,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(g){function b(w,s){return s-w}g.compare=b;const A=Object.create(null);A[g.Error]=(0,T.localize)(0,null),A[g.Warning]=(0,T.localize)(1,null),A[g.Info]=(0,T.localize)(2,null);function D(w){return A[w]||""}g.toString=D;function u(w){switch(w){case E.default.Error:return g.Error;case E.default.Warning:return g.Warning;case E.default.Info:return g.Info;case E.default.Ignore:return g.Hint}}g.fromSeverity=u;function p(w){switch(w){case g.Error:return E.default.Error;case g.Warning:return E.default.Warning;case g.Info:return E.default.Info;case g.Hint:return E.default.Ignore}}g.toSeverity=p}(R||(e.MarkerSeverity=R={}));var $;(function(g){const b="";function A(u){return D(u,!0)}g.makeKey=A;function D(u,p){const w=[b];return u.source?w.push(u.source.replace("\xA6","\\\xA6")):w.push(b),u.code?typeof u.code=="string"?w.push(u.code.replace("\xA6","\\\xA6")):w.push(u.code.value.replace("\xA6","\\\xA6")):w.push(b),u.severity!==void 0&&u.severity!==null?w.push(R.toString(u.severity)):w.push(b),u.message&&p?w.push(u.message.replace("\xA6","\\\xA6")):w.push(b),u.startLineNumber!==void 0&&u.startLineNumber!==null?w.push(u.startLineNumber.toString()):w.push(b),u.startColumn!==void 0&&u.startColumn!==null?w.push(u.startColumn.toString()):w.push(b),u.endLineNumber!==void 0&&u.endLineNumber!==null?w.push(u.endLineNumber.toString()):w.push(b),u.endColumn!==void 0&&u.endColumn!==null?w.push(u.endColumn.toString()):w.push(b),w.push(b),w.join("\xA6")}g.makeKeyOptionalMessage=D})($||(e.IMarkerData=$={})),e.$At=(0,C.$6h)("markerService")}),define(Pe[187],Re([1,0,5,31,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.NotificationsFilter=e.$qv=e.NeverShowAgainScope=e.NotificationPriority=e.$pv=e.Severity=void 0,e.Severity=T.default,e.$pv=(0,C.$6h)("notificationService");var M;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function $(D){if(D){const u=D;return typeof u.id=="string"&&typeof u.label=="string"}return!1}e.$qv=$;var g;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class b{constructor(){this.progress=new A,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$rv=b;class A{infinite(){}done(){}total(u){}worked(u){}}e.$sv=A}),define(Pe[188],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,E.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,E,T){var C=arguments.length,M=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ge,e,E,T);else for(var $=ge.length-1;$>=0;$--)(R=ge[$])&&(M=(C<3?R(M):C>3?R(e,E,M):R(e,E))||M);return C>3&&M&&Object.defineProperty(e,E,M),M},Ke=this&&this.__param||function(ge,e){return function(E,T){e(E,T,ge)}};define(Pe[72],Re([1,0,13,20,6,4]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.ProgressLocation=e.$tv=void 0,e.$tv=(0,M.$6h)("progressService");var R;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$uv=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$vv=$;class g{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const p=this.d;this.d=()=>{p?.(),u()}}):Promise.resolve()}}e.$wv=g;let b=class extends C.$Tc{constructor(u,p){super(),this.a=new E.$qh,p.withProgress(u,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,C.$Rc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$xv=b,e.$xv=b=Je([Ke(1,e.$tv)],b);class A extends C.$Tc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new C.$Sc)}start(u){this.stop();const p=++this.a,w=new T.$6d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,C.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Rc)(()=>w.cancel())),this.b.add((0,C.$Rc)(()=>this.c?this.c.done():void 0)),{id:p,token:w.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$yv=A,e.$zv=(0,M.$6h)("editorProgressService")}),define(Pe[30],Re([1,0,53,16]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class C{constructor(){this.a=new Map}add(R,$){E.ok(T.$If(R)),E.ok(T.$Kf($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Hn=new C}),define(Pe[73],Re([1,0,5,30]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function C($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,b){this.a[C(g)]=b,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;T.$Hn.add(e.$In.JSONContribution,R)}),define(Pe[54],Re([1,0,18,5,16,148,41,73,30]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var b;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$Mn={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const D=g.$Hn.as($.$In.JSONContribution);class u{constructor(){this.h=new Set,this.i=new T.$Vd,this.onDidSchemaChange=this.i.event,this.j=new T.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(i,l=!0){this.registerConfigurations([i],l)}registerConfigurations(i,l=!0){const r=new Set;this.n(i,l,r),D.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const l=new Set;this.o(i,l),D.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:i,remove:l}){const r=new Set;this.o(l,r),this.n(i,!1,r),D.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const l=new Set;this.k(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(i,l){const r=[];for(const{overrides:d,source:m}of i)for(const f in d)if(l.add(f),e.$Wn.test(f)){const S=this.a.get(f),L=S?.valuesSources??new Map;if(m)for(const N of Object.keys(d[f]))L.set(N,m);const v={...S?.value||{},...d[f]};this.a.set(f,{source:m,value:v,valuesSources:L});const y=(0,R.$Ji)(f),k={type:"object",default:v,description:M.localize(1,null,y),$ref:e.$Tn,defaultDefaultValue:v,source:C.$If(m)?void 0:m,defaultValueSource:m};r.push(...s(f)),this.d[f]=k,this.b.properties[f]=k}else{this.a.set(f,{value:d[f],source:m});const S=this.d[f];S&&(this.w(f,S),this.r(f,S))}this.m(r)}deregisterDefaultConfigurations(i){const l=new Set;this.l(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(i,l){for(const{overrides:r,source:d}of i)for(const m in r){const f=this.a.get(m),S=C.$If(d)?d:d?.id,L=C.$If(f?.source)?f?.source:f?.source?.id;if(S===L)if(l.add(m),this.a.delete(m),e.$Wn.test(m))delete this.d[m],delete this.b.properties[m];else{const v=this.d[m];v&&(this.w(m,v),this.r(m,v))}}this.u()}deltaConfiguration(i){let l=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),l=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),l=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const l of i)this.h.add(l);this.u()}n(i,l,r){i.forEach(d=>{this.p(d,l,d.extensionInfo,d.restrictedProperties,void 0,r),this.c.push(d),this.q(d)})}o(i,l){const r=d=>{if(d.properties)for(const m in d.properties){l.add(m);const f=this.d[m];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[m],this.s(m,d.properties[m])}d.allOf?.forEach(m=>r(m))};for(const d of i){r(d);const m=this.c.indexOf(d);m!==-1&&this.c.splice(m,1)}}p(i,l=!0,r,d,m=3,f){m=C.$Rf(i.scope)?m:i.scope;const S=i.properties;if(S)for(const v in S){const y=S[v];if(l&&a(v,y)){delete S[v];continue}if(y.source=r,y.defaultDefaultValue=S[v].default,this.w(v,y),e.$Wn.test(v)?y.scope=void 0:(y.scope=C.$Rf(y.scope)?m:y.scope,y.restricted=C.$Rf(y.restricted)?!!d?.includes(v):y.restricted),S[v].hasOwnProperty("included")&&!S[v].included){this.f[v]=S[v],delete S[v];continue}else this.d[v]=S[v],S[v].policy?.name&&this.e.set(S[v].policy.name,v);!S[v].deprecationMessage&&S[v].markdownDeprecationMessage&&(S[v].deprecationMessage=S[v].markdownDeprecationMessage),f.add(v)}const L=i.allOf;if(L)for(const v of L)this.p(v,l,r,d,m,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const l=r=>{const d=r.properties;if(d)for(const f in d)this.r(f,d[f]);r.allOf?.forEach(l)};l(i)}r(i,l){switch(e.$Nn.properties[i]=l,l.scope){case 1:e.$On.properties[i]=l;break;case 2:e.$Pn.properties[i]=l;break;case 6:e.$Qn.properties[i]=l;break;case 3:e.$Rn.properties[i]=l;break;case 4:e.$Sn.properties[i]=l;break;case 5:e.$Sn.properties[i]=l,this.g.properties[i]=l;break}}s(i,l){switch(delete e.$Nn.properties[i],l.scope){case 1:delete e.$On.properties[i];break;case 2:delete e.$Pn.properties[i];break;case 6:delete e.$Qn.properties[i];break;case 3:delete e.$Rn.properties[i];break;case 4:case 5:delete e.$Sn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const l=`[${i}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$Tn};this.w(l,r),e.$Nn.properties[l]=r,e.$On.properties[l]=r,e.$Pn.properties[l]=r,e.$Qn.properties[l]=r,e.$Rn.properties[l]=r,e.$Sn.properties[l]=r}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=i,e.$On.patternProperties[e.$Vn]=i,e.$Pn.patternProperties[e.$Vn]=i,e.$Qn.patternProperties[e.$Vn]=i,e.$Rn.patternProperties[e.$Vn]=i,e.$Sn.patternProperties[e.$Vn]=i,this.i.fire()}w(i,l){const r=this.a.get(i);let d=r?.value,m=r?.source;C.$Pf(d)&&(d=l.defaultDefaultValue,m=void 0),C.$Pf(d)&&(d=t(l.type)),l.default=d,l.defaultValueSource=m}}const p="\\[([^\\]]+)\\]",w=new RegExp(p,"g");e.$Vn=`^(${p})+$`,e.$Wn=new RegExp(e.$Vn);function s(h){const i=[];if(e.$Wn.test(h)){let l=w.exec(h);for(;l?.length;){const r=l[1].trim();r&&i.push(r),l=w.exec(h)}}return(0,E.$Mb)(i)}e.$Xn=s;function o(h){return h.reduce((i,l)=>`${i}[${l}]`,"")}e.$Yn=o;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=t;const n=new u;g.$Hn.add(e.$Mn.Configuration,n);function a(h,i){return h.trim()?e.$Wn.test(h)?M.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$1n=a;function c(){const h=[],i=n.getConfigurationProperties();for(const l of Object.keys(i))h.push([l,i[l].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$2n=c}),define(Pe[189],Re([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function p(l){return Object.isFrozen(l)?l:$.$wn(l)}class w{constructor(r={},d=[],m=[],f){this.b=r,this.c=d,this.d=m,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(d=>{if(d instanceof w)return d;const m=new s("");return m.parseRaw(d),m.configurationModel});this.f=r.reduce((d,m)=>m===d?m:d.merge(m),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,A.$Hi)(this.contents,r):this.contents}inspect(r,d){const m=this.rawConfiguration.getValue(r),f=d?this.rawConfiguration.getOverrideValue(r,d):void 0,S=d?this.rawConfiguration.override(d).getValue(r):m;return{value:m,override:f,merged:S}}getOverrideValue(r,d){const m=this.i(d);return m?r?(0,A.$Hi)(m,r):m:void 0}getKeysForOverrideIdentifier(r){const d=[];for(const m of this.overrides)m.identifiers.includes(r)&&d.push(...m.keys);return E.$Mb(d)}getAllOverrideIdentifiers(){const r=[];for(const d of this.overrides)r.push(...d.identifiers);return E.$Mb(r)}override(r){let d=this.a.get(r);return d||(d=this.g(r),this.a.set(r,d)),d}merge(...r){const d=$.$vn(this.contents),m=$.$vn(this.overrides),f=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const L of r)if(S.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(d,L.contents);for(const v of L.overrides){const[y]=m.filter(k=>E.$ub(k.identifiers,v.identifiers));y?(this.h(y.contents,v.contents),y.keys.push(...v.keys),y.keys=E.$Mb(y.keys)):m.push($.$vn(v))}for(const v of L.keys)f.indexOf(v)===-1&&f.push(v)}return new w(d,f,m,S.every(L=>L instanceof w)?void 0:S)}g(r){const d=this.i(r);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const m={};for(const f of E.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let S=this.contents[f];const L=d[f];L&&(typeof S=="object"&&typeof L=="object"?(S=$.$vn(S),this.h(S,L)):S=L),m[f]=S}return new w(m,this.keys,this.overrides)}h(r,d){for(const m of Object.keys(d)){if(m in r&&g.$Kf(r[m])&&g.$Kf(d[m])){this.h(r[m],d[m]);continue}r[m]=$.$vn(d[m])}}i(r){let d=null,m=null;const f=S=>{S&&(m?this.h(m,S):m=$.$vn(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===r?d=S.contents:S.identifiers.includes(r)&&f(S.contents);return f(d),m}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,d){this.j(r,d,!0)}setValue(r,d){this.j(r,d,!1)}removeValue(r){const d=this.keys.indexOf(r);d!==-1&&(this.keys.splice(d,1),(0,A.$Gi)(this.contents,r),D.$Wn.test(r)&&this.overrides.splice(this.overrides.findIndex(m=>E.$ub(m.identifiers,(0,D.$Xn)(r))),1))}j(r,d,m){(0,A.$Fi)(this.contents,r,d,f=>console.error(f)),m=m||this.keys.indexOf(r)===-1,m&&this.keys.push(r),D.$Wn.test(r)&&this.overrides.push({identifiers:(0,D.$Xn)(r),keys:Object.keys(this.contents[r]),contents:(0,A.$Ei)(this.contents[r],f=>console.error(f))})}}e.$3n=w;class s{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,d){if(!g.$Rf(r)){const m=this.g(r);this.parseRaw(m,d)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,d){this.a=r;const{contents:m,keys:f,overrides:S,restricted:L,hasExcludedProperties:v}=this.h(r,d);this.b=new w(m,f,S,v?[r]:void 0),this.c=L||[]}g(r){let d={},m=null,f=[];const S=[],L=[];function v(k){Array.isArray(f)?f.push(k):m!==null&&(f[m]=k)}const y={onObjectBegin:()=>{const k={};v(k),S.push(f),f=k,m=null},onObjectProperty:k=>{m=k},onObjectEnd:()=>{f=S.pop()},onArrayBegin:()=>{const k=[];v(k),S.push(f),f=k,m=null},onArrayEnd:()=>{f=S.pop()},onLiteralValue:v,onError:(k,N,O)=>{L.push({error:k,offset:N,length:O})}};if(r)try{C.$jn(r,y),d=f[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return d}h(r,d){const m=u.$Hn.as(D.$Mn.Configuration).getConfigurationProperties(),f=this.i(r,m,!0,d);r=f.raw;const S=(0,A.$Ei)(r,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),L=Object.keys(r),v=this.j(r,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:S,keys:L,overrides:v,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(r,d,m,f){let S=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:S};const L={},v=[];for(const y in r)if(D.$Wn.test(y)&&m){const k=this.i(r[y],d,!1,f);L[y]=k.raw,S=S||k.hasExcludedProperties,v.push(...k.restricted)}else{const k=d[y],N=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&v.push(y),!f.exclude?.includes(y)&&(f.include?.includes(y)||(N===void 0||f.scopes===void 0||f.scopes.includes(N))&&!(f.skipRestricted&&k?.restricted))?L[y]=r[y]:S=!0}return{raw:L,restricted:v,hasExcludedProperties:S}}j(r,d){const m=[];for(const f of Object.keys(r))if(D.$Wn.test(f)){const S={};for(const L in r[f])S[L]=r[f][L];m.push({identifiers:(0,D.$Xn)(f),keys:Object.keys(S),contents:(0,A.$Ei)(S,d)})}return m}}e.$4n=s;class o extends M.$Tc{constructor(r,d,m,f){super(),this.c=r,this.f=d,this.g=f,this.b=this.B(new T.$Vd),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(m.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&m.isEqual(S.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=o;class t{constructor(r,d,m,f,S,L,v,y,k,N,O,G,W){this.a=r,this.b=d,this.c=m,this.overrideIdentifiers=f,this.d=S,this.f=L,this.g=v,this.h=y,this.i=k,this.j=N,this.k=O,this.l=G,this.m=W}get value(){return p(this.c)}n(r,d,m){const f=r.inspect(d,m);return{get value(){return p(f.value)},get override(){return p(f.override)},get merged(){return p(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(r,d,m,f,S=new w,L=new w,v=new R.$Ac,y=new w,k=new R.$Ac){this.c=r,this.d=d,this.f=m,this.g=f,this.h=S,this.i=L,this.j=v,this.l=y,this.m=k,this.a=null,this.b=new R.$Ac,this.n=null}getValue(r,d,m){return this.p(r,d,m).getValue(r)}updateValue(r,d,m={}){let f;m.resource?(f=this.m.get(m.resource),f||(f=new w,this.m.set(m.resource,f))):f=this.l,d===void 0?f.removeValue(r):f.setValue(r,d),m.resource||(this.a=null)}inspect(r,d,m){const f=this.p(r,d,m),S=this.t(d.resource,m),L=d.resource?this.m.get(d.resource)||this.l:this.l,v=new Set;for(const y of f.overrides)for(const k of y.identifiers)f.getOverrideValue(r,k)!==void 0&&v.add(k);return new t(r,d,f.getValue(r),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,m?this.i:void 0,S||void 0,L)}keys(r){const d=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,d){this.j.set(r,d),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,d){const m=[];if(!d){const{added:f,updated:S,removed:L}=h(this.c,r);d=[...f,...S,...L]}for(const f of d)for(const S of(0,D.$Xn)(f)){const L=this.c.getKeysForOverrideIdentifier(S),v=r.getKeysForOverrideIdentifier(S),y=[...v.filter(k=>L.indexOf(k)===-1),...L.filter(k=>v.indexOf(k)===-1),...L.filter(k=>!$.$zn(this.c.override(S).getValue(k),r.override(S).getValue(k)))];m.push([S,y])}return this.updateDefaultConfiguration(r),{keys:d,overrides:m}}compareAndUpdatePolicyConfiguration(r){const{added:d,updated:m,removed:f}=h(this.d,r),S=[...d,...m,...f];return S.length&&this.updatePolicyConfiguration(r),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:d,updated:m,removed:f,overrides:S}=h(this.applicationConfiguration,r),L=[...d,...m,...f];return L.length&&this.updateApplicationConfiguration(r),{keys:L,overrides:S}}compareAndUpdateLocalUserConfiguration(r){const{added:d,updated:m,removed:f,overrides:S}=h(this.localUserConfiguration,r),L=[...d,...m,...f];return L.length&&this.updateLocalUserConfiguration(r),{keys:L,overrides:S}}compareAndUpdateRemoteUserConfiguration(r){const{added:d,updated:m,removed:f,overrides:S}=h(this.remoteUserConfiguration,r),L=[...d,...m,...f];return L.length&&this.updateRemoteUserConfiguration(r),{keys:L,overrides:S}}compareAndUpdateWorkspaceConfiguration(r){const{added:d,updated:m,removed:f,overrides:S}=h(this.workspaceConfiguration,r),L=[...d,...m,...f];return L.length&&this.updateWorkspaceConfiguration(r),{keys:L,overrides:S}}compareAndUpdateFolderConfiguration(r,d){const m=this.folderConfigurations.get(r),{added:f,updated:S,removed:L,overrides:v}=h(m,d),y=[...f,...S,...L];return(y.length||!m)&&this.updateFolderConfiguration(r,d),{keys:y,overrides:v}}compareAndDeleteFolderConfiguration(r){const d=this.folderConfigurations.get(r);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:m,updated:f,removed:S,overrides:L}=h(d,void 0);return{keys:[...m,...f,...S],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,d,m){let f=this.q(d,m);return d.overrideIdentifier&&(f=f.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(f=f.merge(this.d)),f}q({resource:r},d){let m=this.r();if(d&&r){const f=d.getFolder(r);f&&(m=this.s(f.uri)||m);const S=this.m.get(r);S&&(m=m.merge(S))}return m}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let d=this.b.get(r);if(!d){const m=this.r(),f=this.j.get(r);f?(d=m.merge(f),this.b.set(r,d)):d=m}return d}t(r,d){if(d&&r){const m=d.getFolder(r);if(m)return this.j.get(m.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,d)=>{const{contents:m,overrides:f,keys:S}=this.j.get(d);return r.push([d,{contents:m,overrides:f,keys:S}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(d=>r.add(d)),this.userConfiguration.keys.forEach(d=>r.add(d)),this.i.keys.forEach(d=>r.add(d)),this.j.forEach(d=>d.keys.forEach(m=>r.add(m))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>r.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>r.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>r.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(m=>r.add(m))),[...r.values()]}v(r){const d=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(m=>d.add(m)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(m=>d.add(m)),this.i.getKeysForOverrideIdentifier(r).forEach(m=>d.add(m)),this.j.forEach(m=>m.getKeysForOverrideIdentifier(r).forEach(f=>d.add(f))),[...d.values()]}static parse(r){const d=this.w(r.defaults),m=this.w(r.policy),f=this.w(r.application),S=this.w(r.user),L=this.w(r.workspace),v=r.folders.reduce((y,k)=>(y.set(b.URI.revive(k[0]),this.w(k[1])),y),new R.$Ac);return new n(d,m,f,S,new w,L,v,new w,new R.$Ac)}static w(r){return new w(r.contents,r.keys,r.overrides)}}e.$6n=n;function a(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,d=new Map;for(const f of l)f.keys.forEach(S=>r.add(S)),f.overrides.forEach(([S,L])=>{const v=(0,R.$xc)(d,S,new Set);L.forEach(y=>v.add(y))});const m=[];return d.forEach((f,S)=>m.push([S,[...f.values()]])),{keys:[...r.values()],overrides:m}}e.$7n=a;class c{constructor(r,d,m,f){this.change=r,this.f=d,this.g=m,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of r.keys)this.affectedKeys.add(S);for(const[,S]of r.overrides)for(const L of S)this.affectedKeys.add(L);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(r,d){const m=this.a+r,f=this.d.indexOf(m);if(f<0)return!1;const S=f+m.length;if(S>=this.d.length)return!1;const L=this.d.charCodeAt(S);if(L!==this.b&&L!==this.c)return!1;if(d){const v=this.previousConfiguration?this.previousConfiguration.getValue(r,d,this.f?.workspace):void 0,y=this.g.getValue(r,d,this.h);return!$.$zn(v,y)}return!0}}e.$8n=c;function h(l,r){const{added:d,removed:m,updated:f}=i(r?.rawConfiguration,l?.rawConfiguration),S=[],L=l?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const y=v.filter(k=>!L.includes(k));for(const k of y)S.push([k,r.getKeysForOverrideIdentifier(k)])}if(l){const y=L.filter(k=>!v.includes(k));for(const k of y)S.push([k,l.getKeysForOverrideIdentifier(k)])}if(r&&l){for(const y of L)if(v.includes(y)){const k=i({contents:l.getOverrideValue(void 0,y)||{},keys:l.getKeysForOverrideIdentifier(y)},{contents:r.getOverrideValue(void 0,y)||{},keys:r.getKeysForOverrideIdentifier(y)});S.push([y,[...k.added,...k.removed,...k.updated]])}}return{added:d,removed:m,updated:f,overrides:S}}function i(l,r){const d=l?r?l.keys.filter(S=>r.keys.indexOf(S)===-1):[...l.keys]:[],m=r?l?r.keys.filter(S=>l.keys.indexOf(S)===-1):[...r.keys]:[],f=[];if(l&&r){for(const S of r.keys)if(l.keys.indexOf(S)!==-1){const L=(0,A.$Hi)(r.contents,S),v=(0,A.$Hi)(l.contents,S);$.$zn(L,v)||f.push(S)}}return{added:d,removed:m,updated:f}}}),define(Pe[100],Re([1,0,15,4]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.RemoteAuthorityResolverErrorCode=e.$0k=e.$9k=e.RemoteConnectionType=e.$8k=void 0,e.$8k=(0,T.$6h)("remoteAuthorityResolverService");var C;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class M{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$9k=M;class R{constructor(D,u){this.host=D,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$0k=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class g extends E.$bb{static isNotAvailable(D){return D instanceof g&&D._code===$.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof g&&D._code===$.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof g&&D._code===$.NoResolverFound}static isInvalidAuthority(D){return D instanceof g&&D._code===$.InvalidAuthority}static isHandled(D){return D instanceof g&&D.isHandled}constructor(D,u=$.Unknown,p){super(D),this._message=D,this._code=u,this._detail=p,this.isHandled=u===$.NotAvailable&&p===!0,Object.setPrototypeOf(this,g.prototype)}}e.$$k=g;function b(A){const D=A.indexOf("+");return D===-1?A:A.substring(0,D)}e.$_k=b}),define(Pe[55],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function T(b){return b.scheme===E.Schemas.vscodeRemote?b.authority:void 0}e.$al=T;function C(b){if(!b)return;const A=b.indexOf("+");return A<0?b:b.substr(0,A)}e.$bl=C;function M(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$cl=M;function R(b){const{host:A,port:D}=g(b);if(typeof D>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:D}}e.$dl=R;function $(b,A){let{host:D,port:u}=g(b);return typeof u>"u"&&(u=A),{host:D,port:u}}e.$el=$;function g(b){const A=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const D=b.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const u=b.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:b,port:void 0}}}),define(Pe[22],Re([1,0,11,4,55]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function M(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$jm=M,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,t){if(typeof o>"u"||o===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof o=="string"||typeof t=="string"){const n=typeof o=="string"?o:o.value,a=typeof t=="string"?t:t.value;return E.$_e(n,a)}return o._lower===t._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$lm=g;class b{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const t of o)this.add(t)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$mm=b;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,t){this.c.set(g.toKey(o),t)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=A;function D(s){return u(s)}e.$om=D;function u(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.$pm=u;function p(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.$qm=p;function w(s,o){if(o){const t=`onResolveRemoteAuthority:${(0,C.$bl)(o)}`;return!!s.activationEvents?.includes(t)}return!1}e.$rm=w,e.$sm=(0,T.$6h)("IBuiltinExtensionsScannerService")}),define(Pe[101],Re([1,0,15,22]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const g of R){const b=this.readActivationEvents(g);b.length>0&&($[T.$lm.toKey(g.identifier)]=b)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let g=0;g<$.length;g++)$[g]==="onUri"&&($[g]=`onUri:${T.$lm.toKey(R.identifier)}`);if(!R.contributes)return $;for(const g in R.contributes){const b=this.a.get(g);if(!b)continue;const A=R.contributes[g],D=Array.isArray(A)?A:[A];try{b(D,$)}catch(u){(0,E.$1)(u)}}return $}}e.$gF=C,e.$hF=new C}),define(Pe[190],Re([1,0,21,74,33]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=void 0;function M(g){if(E.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function R(g,b,A,D,u,p,w,s,o){const t=Object.create(null);t["common.machineId"]=p,t["common.sqmId"]=w,t.sessionID=(0,C.$qg)()+Date.now(),t.commitHash=D,t.version=u,t["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$dc,t["common.nodeArch"]=A,t["common.product"]=o||"desktop",s&&(t["common.msftInternal"]=s);let n=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=M(b);return c&&(t["common.platformDetail"]=c),t}e.$Io=R;function $(g){const b=T.env.USERDNSDOMAIN;if(!b)return!1;const A=b.toLowerCase();return g.some(D=>A===D)}e.$Jo=$}),define(Pe[191],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,E.$6h)("telemetryService"),e.$vl=(0,E.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Pe[56],Re([1,0,26,16,5,41,55,190,191]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0;class b{constructor(m){this.value=m,this.isTrustedTelemetryValue=!0}}e.$Ko=b;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Lo=A,e.$Mo=new A;class D{async publicLog(m,f,S){}async publicLogError(m,f,S){}}e.$No=D,e.$Oo="telemetry",e.$Po="extensionTelemetryLog",e.$Qo={log:()=>null,flush:()=>Promise.resolve(null)};function u(d,m){return C.Event.debounce(m.onDidChangeConfiguration,(S,L)=>{const v=S?new Set([...S.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:v}},1e3,!0)(S=>{S.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.$Ci)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$Ro=u;function p(d,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!d.enableTelemetry)}e.$So=p;function w(d,m){return m.extensionTestsLocationURI?!0:!(m.isBuilt||m.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$To=w;function s(d){const m=d.getValue(g.$Cl),f=d.getValue(g.$Dl);if(d.getValue(g.$El)===!1||f===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=s;function o(d){const m={},f={},S={};a(d,S);for(let L in S){L=L.length>150?L.substr(L.length-149):L;const v=S[L];typeof v=="number"?f[L]=v:typeof v=="boolean"?f[L]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${v.length}`),m[L]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(m[L]=v)}return{properties:m,measurements:f}}e.$Vo=o;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(d){if(!d)return"none";const m=(0,R.$bl)(d);return t.has(m)?m:"other"}e.$Wo=n;function a(d,m,f=0,S){if(d)for(const L of Object.getOwnPropertyNames(d)){const v=d[L],y=S?S+L:L;Array.isArray(v)?m[y]=(0,E.$An)(v):v instanceof Date?m[y]=v.toISOString():(0,T.$Kf)(v)?f<2?a(v,m,f+1,y+"."):m[y]=(0,E.$An)(v):m[y]=v}}function c(d,m){const f=d.msftInternalDomains||[],S=m.getValue("telemetry.internalTesting");return(0,$.$Jo)(f)||S}e.$Xo=c;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Yo=h;function i(d,m){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let f=d;const S=[];for(const k of m)for(;;){const N=k.exec(d);if(!N)break;S.push([N.index,k.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(f="";;){const k=v.exec(d);if(!k)break;const N=S.some(([O,G])=>k.index<G&&O<v.lastIndex);!L.test(k[0])&&!N&&(f+=d.substring(y,k.index)+"<REDACTED: user-file-path>",y=v.lastIndex)}return y<d.length&&(f+=d.substr(y)),f}function l(d){if(!d)return d;const m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of m)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return d}function r(d,m){return(0,E.$xn)(d,f=>{if(f instanceof b||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let S=f.replaceAll("%20"," ");S=i(S,m);for(const L of m)S=S.replace(L,"");return S=l(S),S}})}e.$Zo=r}),define(Pe[192],Re([1,0,11,97,22,21,2,15,74,56]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function A(r,d){return r.uuid&&d.uuid?r.uuid===d.uuid:r.id===d.id?!0:(0,E.$7e)(r.id,d.id)===0}e.$1o=A;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(d){const m=d.manifest?d.manifest.version:d.version,f=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new u(d.identifier,m,f)}static parse(d){const m=D.exec(d);return m&&m[1]&&m[2]?new u({id:m[1]},m[2],m[4]||void 0):null}constructor(d,m,f="undefined"){this.version=m,this.targetPlatform=f,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof u?A(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$2o=u;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(r){const d=p.exec(r);return d&&d[1]?[o(d[1]),d[2]]:[o(r),void 0]}e.$3o=w;function s(r,d){return`${r}.${d}`}e.$4o=s;function o(r){return r.toLowerCase()}e.$5o=o;function t(r,d){return o(s(r??C.$hm,d))}e.$6o=t;function n(r,d){const m=[],f=S=>{for(const L of m)if(L.some(v=>A(d(v),d(S))))return L;return null};for(const S of r){const L=f(S);L?L.push(S):m.push([S])}return m}e.$7o=n;function a(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$8o=a;function c(r){return{id:new b.$Ko(r.identifier.id),name:new b.$Ko(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$9o=c,e.$0o=new C.$lm("pprice.better-merge");function h(r,d){const m=[],f=d.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const S=f.shift();if(S&&m.every(L=>!A(L.identifier,{id:S}))){const L=r.filter(v=>A(v.identifier,{id:S}));L.length===1&&(m.push(L[0]),f.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.$$o=h;async function i(r,d){if(!M.$k)return!1;let m;try{m=(await r.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{m=(await r.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){d.debug("Error while getting the os-release file.",(0,$.$0)(S))}}return!!m&&(m.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,d){const m=await i(r,d),f=(0,T.$uo)(m?"alpine":M.$u,g.$ec);return d.debug("ComputeTargetPlatform:",f),f}e.$_o=l}),define(Pe[193],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0;function E(g){return[...g.entries()]}e.$Mr=E;function T(g){return g?[...g.entries()]:[]}e.$Nr=T;function C(g){return new Map(g)}e.$Or=C;function M(g){return new Map(g??[])}e.$Pr=M;function R(g){return Array.from(g.entries()).map(b=>[b[0],E(b[1].map),T(b[1].descriptionMap)])}e.$Qr=R;function $(g){return new Map(g.map(b=>[b[0],{map:C(b[1]),descriptionMap:M(b[2])}]))}e.$Rr=$}),define(Pe[194],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Krb=void 0;class E{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,M,R=5){const $=M(g=>{const b=typeof g=="string"?g:g.data;let A=this.a.get(C);if(A){A.data.push(b);return}const D=setTimeout(()=>this.flushBuffer(C),R);A={data:[b],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),$.dispose()}},this.a.set(C,A)});return $}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const M=this.a.get(C);M&&(this.a.delete(C),this.b(C,M.data.join("")))}}e.$Krb=E}),define(Pe[195],Re([1,0,13,90,45,5,16,2,155,73,30]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.IconFontDefinition=e.IconContribution=e.$ww=void 0,e.$ww={IconContribution:"base.contributions.icons"};var D;(function(c){function h(i,l){let r=i.defaults;for(;C.ThemeIcon.isThemeIcon(r);){const d=w.getIcon(r.id);if(!d)return;r=d.defaults}return r}c.getDefinition=h})(D||(e.IconContribution=D={}));var u;(function(c){function h(l){return{weight:l.weight,style:l.style,src:l.src.map(r=>({format:r.format,location:r.location.toString()}))}}c.toJSONObject=h;function i(l){const r=d=>(0,R.$If)(d)?d:void 0;if(l&&Array.isArray(l.src)&&l.src.every(d=>(0,R.$If)(d.format)&&(0,R.$If)(d.location)))return{weight:r(l.weight),style:r(l.style),src:l.src.map(d=>({format:d.format,location:$.URI.parse(d.location)}))}}c.fromJSONObject=i})(u||(e.IconFontDefinition=u={}));class p{constructor(){this.a=new M.$Vd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,l,r){const d=this.b[h];if(d){if(l&&!d.description){d.description=l,this.d.properties[h].markdownDescription=`${l} $(${h})`;const S=this.e.enum.indexOf(h);S!==-1&&(this.e.enumDescriptions[S]=l),this.a.fire()}return d}const m={id:h,description:l,defaults:i,deprecationMessage:r};this.b[h]=m;const f={$ref:"#/definitions/icons"};return r&&(f.deprecationMessage=r),l&&(f.markdownDescription=`${l}: $(${h})`),this.d.properties[h]=f,this.e.enum.push(h),this.e.enumDescriptions.push(l||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const l=this.f[h];return l||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(d,m)=>d.id.localeCompare(m.id),i=d=>{for(;C.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(d=>this.b[d]);for(const d of r.filter(m=>!!m.description).sort(h))l.push(`|<i class="${i(d)}"></i>|${d.id}|${C.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const d of r.filter(m=>!C.ThemeIcon.isThemeIcon(m.defaults)).sort(h))l.push(`|<i class="${i(d)}"></i>|${d.id}|`);return l.join(`
`)}}const w=new p;A.$Hn.add(e.$ww.IconContribution,w);function s(c,h,i,l){return w.registerIcon(c,h,i,l)}e.$xw=s;function o(){return w}e.$yw=o;function t(){const c=(0,T.$0j)();for(const h in c){const i="\\"+c[h].toString(16);w.registerIcon(h,{fontCharacter:i})}}t(),e.$zw="vscode://schemas/icons";const n=A.$Hn.as(b.$In.JSONContribution);n.registerSchema(e.$zw,w.getIconSchema());const a=new E.$fh(()=>n.notifySchemaChanged(e.$zw),200);w.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$Aw=s("widget-close",T.$_j.close,(0,g.localize)(2,null)),e.$Bw=s("goto-previous-location",T.$_j.arrowUp,(0,g.localize)(3,null)),e.$Cw=s("goto-next-location",T.$_j.arrowDown,(0,g.localize)(4,null)),e.$Dw=C.ThemeIcon.modify(T.$_j.sync,"spin"),e.$Ew=C.ThemeIcon.modify(T.$_j.loading,"spin")}),define(Pe[196],Re([1,0,5,41,4,14]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProvidedOnAutoForward=e.$Cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bv=e.$Av=void 0,e.$Av=(0,C.$6h)("tunnelService"),e.$Bv=(0,C.$6h)("sharedTunnelsService");var R;(function(o){o.Http="http",o.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})($||(e.TunnelPrivacyId=$={}));function g(o){return!!o.forwardPort}e.$Cv=g;var b;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}e.$Dv=A,e.$Ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(o){return e.$Ev.indexOf(o)>=0}e.$Fv=D,e.$Gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(o){return e.$Gv.indexOf(o)>=0}e.$Hv=u;function p(o,t,n,a){if(n===1)return!1;if(n===2&&u(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(c?.length===4&&parseInt(c[1])>=18)return!1}return o<1024}e.$Iv=p;class w{constructor(t,n,a){this.remoteAddress=t,this.localAddress=n,this.b=a,this.a=new E.$Vd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jv=w;let s=class{constructor(t,n){this.k=t,this.l=n,this.a=new E.$Vd,this.onTunnelOpened=this.a.event,this.b=new E.$Vd,this.onTunnelClosed=this.b.event,this.c=new E.$Vd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],n=Array.from(this.e.values());for(const a of n){const c=Array.from(a.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(a=>typeof a!="string"?a?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,a,c,h){this.q(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:a,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(u(t)||D(t))&&(t=e.$Ev[0]);const a=this.s(t,n);if(a)return++a.refcount,a.value}openTunnel(t,n,a,c,h,i=!1,l,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${a} on local port ${h}.`);const d=this.f??t;if(!d)return;if(n||(n="localhost"),c||(c=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.t(d,n,a,c,h,i,l,r);return m?m.then(f=>{if(f){if(typeof f=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,a),f}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(f);return(f.tunnelRemoteHost!==n||f.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&f.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const a=n.get(t.tunnelRemotePort);a&&(a.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,a))}}}}async p(t,n,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const c=a.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),c}}async closeTunnel(t,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const a=this.e.get(t);if(a&&a.has(n)){const c=a.get(n);c.refcount=0,await this.p(t,n,c)}}q(t,n,a){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:a})}async r(t,n){const a=this.e.get(t);if(a){const c=a.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&a.delete(n),a.size===0&&this.e.delete(t)}}s(t,n){const a=[t];D(t)?(a.push(...e.$Ev),a.push(...e.$Gv)):u(t)&&a.push(...e.$Gv);const c=a.map(h=>this.e.get(h));for(const h of c){const i=h?.get(n);if(i)return i}}canTunnel(t){return!!A(t)}u(t,n,a,c,h,i,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${a} on local port ${c}.`);const r=a;this.j.add(r);const d=c===void 0?a:c,m={elevationRequired:h?this.isPortPrivileged(d):!1},f={remoteAddress:{host:n,port:a},localAddressPort:c,privacy:i,public:i?i!==$.Private:void 0,protocol:l},S=t.forwardPort(f,m);return S?(this.q(n,a,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),S}};e.$Kv=s,e.$Kv=s=Je([Ke(0,M.$nj),Ke(1,T.$zi)],s)}),define(Pe[197],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Lv=void 0,e.$Lv=(0,E.$6h)("editSessionIdentityService");var T;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[198],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=void 0;function T(g){return g.scheme!==E.Schemas.file&&g.scheme!==E.Schemas.vscodeRemote}e.$CK=T;function C(g){if(g.folders.length)return g.folders.every(b=>T(b.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}e.$DK=C;function M(g){return C(g)?.scheme}e.$EK=M;function R(g){return C(g)?.authority}e.$FK=R;function $(g){return C(g)!==void 0}e.$GK=$}),define(Pe[47],Re([1,0,156,19,50,25,2,4,12]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,$.$6h)("contextService");function b(d){const m=d;return typeof m?.id=="string"&&R.URI.isUri(m.uri)}e.$di=b;function A(d){return typeof d?.id=="string"&&!b(d)&&!u(d)}e.$ei=A,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function D(d,m){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,T.$nc)(d)}:m?e.$fi:e.$gi;const f=d;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$hi=D;function u(d){const m=d;return typeof m?.id=="string"&&R.URI.isUri(m.configPath)}e.$ii=u;function p(d){const m=d;if(m?.uri)return{id:m.id,uri:R.URI.revive(m.uri)};const f=d;if(f?.configPath)return{id:f.id,configPath:R.URI.revive(f.configPath)};if(d?.id)return{id:d.id}}e.$ji=p;var w;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function s(d){const m=d;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.$ki=s;function o(d){const m=d;return!!(m&&typeof m=="object"&&R.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.$li=o;class t{constructor(m,f,S,L,v){this.h=m,this.j=S,this.k=L,this.l=v,this.c=C.$_h.forUris(this.l,()=>!0),this.folders=f}update(m){this.h=m.id,this.k=m.configuration,this.j=m.transient,this.l=m.l,this.folders=m.folders}get folders(){return this.g}set folders(m){this.g=m,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(m){this.k=m}getFolder(m){return m&&this.c.findSubstr(m)||null}n(){this.c=C.$_h.forUris(this.l,()=>!0);for(const m of this.folders)this.c.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=t;class n{constructor(m,f){this.raw=f,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.$Hg)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=n;function a(d){return new n({uri:d,index:0,name:(0,M.$Dg)(d)},{uri:d.toString()})}e.$oi=a,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,E.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function c(d,m){return M.$yg.isEqualOrParent(d,m.untitledWorkspacesHome)}e.$ti=c;function h(d){let m;return R.URI.isUri(d)?m=d:m=d.configuration,m?.scheme===g.Schemas.tmp}e.$ui=h,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(d){return d.id===e.$vi}e.$wi=i;function l(d,m){return!c(d,m)&&!h(d)}e.$xi=l;function r(d){return(typeof d=="string"?(0,T.$oc)(d):(0,M.$Fg)(d))===e.$qi}e.$yi=r}),define(Pe[75],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class E{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const M=this.c++;return this.b.set(M,C),this.e(),M}get(C,M){return this.b.has(C)?this.b.get(C)[M]:void 0}delete(C){this.b.delete(C),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$3fc=E}),define(Pe[43],Re([1,0,12,25,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$wg($=>{const g=this.b.get($.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos($,g){g===null?this.b.delete($.scheme):this.b.set($.scheme,g)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$6fc=M,e.$7fc=(0,C.$6h)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0,e.$nN=(0,E.$6h)("IExtHostInitDataService")}),define(Pe[199],Re([1,0,161,14,186,27]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;let R=class extends C.$uO{constructor(g,b,A){const D=A.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",u=A.remote.isRemote?(0,E.localize)(0,null):g?(0,E.localize)(1,null):(0,E.localize)(2,null);super(b.createLogger(D,{name:u}))}};e.$aic=R,e.$aic=R=Je([Ke(1,T.$oj),Ke(2,M.$nN)],R)}),define(Pe[200],Re([1,0,13]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=void 0;class T{constructor(R,$,g){this.h=new Map,this.a=R,this.b=$,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(b=>(this.f=b,this)),this.g=this.c.onDidChangeStorage(b=>{b.shared===this.b&&b.key===this.a&&(this.f=b.value)}),this.i=new E.$fh(()=>{const b=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of b.values())A.complete()}catch(A){for(const D of b.values())D.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let g=this.f[R];return typeof g>"u"&&(g=$),g}update(R,$){this.f[R]=$;const g=this.h.get(R);if(g!==void 0)return g.p;const b=new E.$qh;return this.h.set(R,b),this.i.isScheduled()||this.i.schedule(),b.p}dispose(){this.g.dispose()}}e.$Ogc=T;class C extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$Pgc=C}),define(Pe[201],Re([1,0,5,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;class C{constructor(R){this.c=R,this.a=new E.$Vd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Vd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,g,b){const D=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged($.value,g,b);this.b.fire(D)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire($.apiNotebook)}}e.$Chc=C}),define(Pe[17],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=void 0,e.$0M=(0,E.$6h)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$$M=T}),define(Pe[202],Re([1,0,22,5]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class C{#e;constructor(R,$){this.b=new T.$Vd,this.onDidChange=this.b.event,this.a=E.$lm.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$Wgc=C}),define(Pe[57],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=e.$mgc=void 0,e.$mgc=(0,E.$6h)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$ngc=T}),define(Pe[203],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlb=e.$clb=void 0;class T{constructor(){this.buffers=[]}add(g){let b=this.buffers.indexOf(g);return b<0&&(b=this.buffers.length,this.buffers.push(g)),b}}function C($,g){if(g.serializeBuffersForPostMessage){const b=new T,D=JSON.stringify($,(p,w)=>{if(w instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(w)};if(ArrayBuffer.isView(w)){const s=M(w);if(s)return{$$vscode_array_buffer_reference$$:!0,index:b.add(w.buffer),view:{type:s,byteLength:w.byteLength,byteOffset:w.byteOffset}}}return w}),u=b.buffers.map(p=>{const w=new Uint8Array(p);return E.$je.wrap(w)});return{message:D,buffers:u}}else return{message:JSON.stringify($),buffers:[]}}e.$clb=C;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,g){const b=g.map(u=>{const p=new ArrayBuffer(u.byteLength);return new Uint8Array(p).set(u.buffer),p}),A=g.length?(u,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const w=p,{index:s}=w,o=b[s];if(w.view)switch(w.view.type){case 1:return new Int8Array(o,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return p}:void 0;return{message:JSON.parse($,A),arrayBuffers:b}}e.$dlb=R}),define(Pe[102],Re([1,0,170,16,2,6,4,30,42,12,40,134,31]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.EditorsOrder=e.$2E=e.CloseDirection=e.$1E=e.$ZE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.EditorInputCapabilities=e.$QE=e.SaveReason=e.Verbosity=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$DE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$EE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$FE="workbench.editor.sidebysideEditor",e.$GE="workbench.editors.textDiffEditor",e.$HE="workbench.editors.binaryResourceDiffEditor";var p;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var w;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function s(ne){const Y=ne;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.$IE=s;function o(ne,Y,V){for(const ie of V.visibleEditorPanes)if(ie.group.id===Y&&ne.matches(ie.input))return ie.getViewState()}e.$JE=o;function t(ne){if(S(ne))return!1;const Y=ne;return C.URI.isUri(Y?.resource)}e.$KE=t;function n(ne){if(S(ne))return!1;const Y=ne;return Y?.original!==void 0&&Y.modified!==void 0}e.$LE=n;function a(ne){if(S(ne))return!1;const Y=ne;return!Y||Y.resources&&!Array.isArray(Y.resources)?!1:!!Y.resources||!!Y.multiDiffSource}e.$ME=a;function c(ne){if(S(ne)||n(ne))return!1;const Y=ne;return Y?.primary!==void 0&&Y.secondary!==void 0}e.$NE=c;function h(ne){if(S(ne))return!1;const Y=ne;return Y?Y.resource===void 0||Y.resource.scheme===b.Schemas.untitled||Y.forceUntitled===!0:!1}e.$OE=h;function i(ne){if(S(ne))return!1;const Y=ne;return C.URI.isUri(Y?.base?.resource)&&C.URI.isUri(Y?.input1?.resource)&&C.URI.isUri(Y?.input2?.resource)&&C.URI.isUri(Y?.result?.resource)}e.$PE=i;var l;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(l||(e.Verbosity=l={}));var r;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class d{constructor(){this.a=new Map}registerSource(Y,V){let ie=this.a.get(Y);return ie||(ie={source:Y,label:V},this.a.set(Y,ie)),ie.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$QE=new d;var m;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad",ne[ne.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(m||(e.EditorInputCapabilities=m={}));class f extends M.$Tc{}e.$RE=f;function S(ne){return ne instanceof f}e.$SE=S;function L(ne){const Y=ne;return C.URI.isUri(Y?.preferredResource)}function v(ne){const Y=ne;return S(Y?.primary)&&S(Y?.secondary)}e.$TE=v;function y(ne){const Y=ne;return S(Y?.modified)&&S(Y?.original)}e.$UE=y;function k(ne,Y,V,ie,Ie){return be(ie,[(0,D.$Pi)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Le={...V,limits:{size:Number.MAX_VALUE}};ne.openEditor(Y,Le)}}),(0,D.$Pi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$VE=k;function N(ne){return S(ne?.editor)}e.$WE=N;function O(ne){const Y=ne;return N(ne)&&Y?.group!==void 0}e.$XE=O;function G(ne){const Y=ne;return typeof Y?.groupId=="number"&&S(Y.editor)}e.$YE=G;var W;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var z;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_STICKY=11]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=12]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var P;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(P||(e.SideBySideEditor=P={}));class I{getOriginalUri(Y,V){if(!Y)return;if(i(Y))return e.$1E.getOriginalUri(Y.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Le}=this.a(Y);if(Ie&&Le){if(V?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Le,{filterByScheme:V.filterByScheme});Y=V.supportSideBySide===P.PRIMARY?Ie:Le}}if(n(Y)||a(Y)||c(Y)||i(Y))return;const ie=L(Y)?Y.preferredResource:Y.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}a(Y){return v(Y)||c(Y)?{primary:Y.primary,secondary:Y.secondary}:y(Y)||n(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,V){if(!Y)return;if(i(Y))return e.$1E.getCanonicalUri(Y.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Le}=this.a(Y);if(Ie&&Le){if(V?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme});Y=V.supportSideBySide===P.PRIMARY?Ie:Le}}if(n(Y)||a(Y)||c(Y)||i(Y))return;const ie=Y.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}b(Y,V){if(Array.isArray(V)){if(V.some(ie=>Y.scheme===ie))return Y}else if(V===Y.scheme)return Y}}var H;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(H||(e.EditorCloseMethod=H={}));function ae(ne,Y,V,ie){if(!ne.isSticky(Y))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return V===H.MOUSE||V===H.KEYBOARD;case"mouse":return V===H.MOUSE;case"keyboard":return V===H.KEYBOARD}return!1}e.$ZE=ae,e.$1E=new I;var de;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(de||(e.CloseDirection=de={}));class we{constructor(){this.c=new Map,this.d=new Map}start(Y){const V=this.a=Y.get(R.$5h);for(const[ie,Ie]of this.c)this.e(ie,Ie,V);this.c.clear()}e(Y,V,ie){const Ie=ie.createInstance(V);this.d.set(Y,Ie)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,T.$Tf)(this.b)}registerEditorSerializer(Y,V){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,V,this.a):this.c.set(Y,V),(0,M.$Rc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}$.$Hn.add(e.$DE.EditorFactory,new we);async function ke(ne,Y,V){return!ne||!ne.length?[]:await Promise.all(ne.map(async ie=>{const Ie=C.URI.revive(ie.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ie);return}if(!await Y.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ie);return}let Ce=ie.exists,ce=ie.type;if(typeof Ce!="boolean"||typeof ce!="number")try{ce=(await Y.stat(Ie)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Ce=!0}catch(Q){V.error(Q),Ce=!1}if(!Ce&&ie.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ie);return}if(ce===g.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ie);return}const te={...ie.options,pinned:!0};return Ce?{resource:Ie,options:te}:{resource:Ie,options:te,forceUntitled:!0}}))}e.$2E=ke;var le;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function ve(ne){const Y=ne;if(!Y)return!1;const V=Y;if(V.modified)return ve(V.modified);const ie=Y;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$3E=ve;function se(ne){return(0,A.$Ri)(ne)}e.$4E=se;function be(ne,Y,V){const ie=(0,A.$Si)(ne,Y);return ie.forceMessage=V?.forceMessage,ie.forceSeverity=V?.forceSeverity,ie.allowDialog=V?.allowDialog,ie}e.$5E=be}),define(Pe[204],Re([1,0,5,171,4,6,28,30,18,26,90,195]),function(ge,e,E,T,C,M,R,$,g,b,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$$E=e.ViewContentGroups=e.$0E=e.$9E=e.ViewContainerLocation=e.Extensions=e.$8E=e.$7E=e.$6E=void 0,e.$6E="views",e.$7E=(0,T.localize)(0,null),e.$8E=(0,D.$xw)("default-view-icon",A.$_j.window,(0,T.localize)(1,null));var u;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var p;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel",l[l.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$9E=[0,1,2];function w(l){switch(l){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$0E=w;class s extends M.$Tc{constructor(){super(...arguments),this.c=this.B(new E.$Vd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Vd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(r,d,m){const f=this.get(r.id);if(f)return f;const S=r;return S.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$xc)(this.g,d,[]).push(S),m?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:d}),S}deregisterViewContainer(r){for(const d of this.g.keys()){const m=this.g.get(d),f=m?.indexOf(r);if(f!==-1){m?.splice(f,1),m.length===0&&this.g.delete(d),this.f.fire({viewContainer:r,viewContainerLocation:d});return}}}get(r){return this.all.filter(d=>d.id===r)[0]}getViewContainers(r){return[...this.g.get(r)||[]]}getViewContainerLocation(r){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(m=>m?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.h.find(d=>this.getViewContainerLocation(d)===r)}}$.$Hn.add(u.ViewContainersRegistry,new s);var o;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(o||(e.ViewContentGroups=o={}));function t(l,r){const d=l.group??o.More,m=r.group??o.More;return d!==m?d.localeCompare(m):(l.order??5)-(r.order??5)}class n extends M.$Tc{constructor(){super(...arguments),this.c=this.B(new E.$Vd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Vd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Vd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Vd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(r,d){this.registerViews2([{views:r,viewContainer:d}])}registerViews2(r){r.forEach(({views:d,viewContainer:m})=>this.r(d,m)),this.c.fire(r)}deregisterViews(r,d){const m=this.s(r,d);m.length&&this.f.fire({views:m,viewContainer:d})}moveViews(r,d){for(const m of this.m.keys())if(m!==d){const f=this.s(r,m);f.length&&(this.r(f,d),this.g.fire({views:f,from:m,to:d}))}}getViews(r){return this.m.get(r)||[]}getView(r){for(const d of this.j){const m=(this.m.get(d)||[]).filter(f=>f.id===r)[0];if(m)return m}return null}getViewContainer(r){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===r)[0])return d;return null}registerViewWelcomeContent(r,d){return this.n.add(r,d),this.h.fire(r),(0,M.$Rc)(()=>{this.n.delete(r,d),this.h.fire(r)})}registerViewWelcomeContent2(r,d){const m=new Map;for(const[f,S]of d)this.n.add(r,S),m.set(f,(0,M.$Rc)(()=>{this.n.delete(r,S),this.h.fire(r)}));return this.h.fire(r),m}getViewWelcomeContent(r){const d=[];return this.n.forEach(r,m=>d.push(m)),d.sort(t)}r(r,d){let m=this.m.get(d);m||(m=[],this.m.set(d,m),this.j.push(d));for(const f of r){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(2,null,f.id));m.push(f)}}s(r,d){const m=this.m.get(d);if(!m)return[];const f=[],S=[];for(const L of m)r.includes(L)?f.push(L):S.push(L);return f.length&&(S.length?this.m.set(d,S):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}$.$Hn.add(u.ViewsRegistry,new n),e.$$E=(0,C.$6h)("viewDescriptorService");var a;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var c;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(r,d){this.c=!1,this.d=!1,(0,b.$yn)(this,r),this.d=!!d,this.resolve=async m=>{if(d&&!this.c){const f=await d(m);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$_E=h;class i extends Error{constructor(r){super((0,T.localize)(3,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.$aF=i}),define(Pe[205],Re([1,0,2,29,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$4F=e.$3F=void 0;function M(b){return!!b&&typeof b=="object"&&"uri"in b&&b.uri instanceof E.URI&&"version"in b&&typeof b.version=="number"&&"ranges"in b&&Array.isArray(b.ranges)&&b.ranges.every(T.$Us.isIRange)}e.$3F=M;function R(b){return!!b&&typeof b=="object"&&"documents"in b&&Array.isArray(b.documents)&&b.documents.every(M)}e.$4F=R;var $;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var g;(function(b){b[b.Action=1]="Action",b[b.Toolbar=2]="Toolbar"})(g||(e.ChatAgentCopyKind=g={})),e.$5F=(0,C.$6h)("IChatService")}),define(Pe[206],Re([1,0,5,13,172]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Vd,this.n=new E.$Vd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,g,b,A){const D={command:$};if(g&&Object.keys(g).length>0&&(D.arguments=g),this.s("request",D),typeof A=="number"){const u=setTimeout(()=>{clearTimeout(u);const p=this.f.get(D.seq);if(p){this.f.delete(D.seq);const w={type:"response",seq:0,request_seq:D.seq,success:!1,command:$,message:(0,C.localize)(0,null,A,$)};p(w)}},A)}return b&&this.f.set(D.seq,b),D.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,g){return $.type!=="event"||g.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$7g)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const g=$,b=this.f.get(g.request_seq);b&&(this.f.delete(g.request_seq),b(g));break}}}}s($,g){g.type=$,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((g,b)=>$.set(b,g)),await(0,T.$7g)(500),$.forEach((g,b)=>{g({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.f.delete(b)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Ilb=M}),define(Pe[207],Re([1,0,173,35,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$NH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$MH=e.MemoryRangeType=e.$LH=e.State=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG="workbench.view.debug",e.$JG="workbench.debug.variablesView",e.$KG="workbench.debug.watchExpressionsView",e.$LG="workbench.debug.callStackView",e.$MG="workbench.debug.loadedScriptsView",e.$NG="workbench.debug.breakPointsView",e.$OG="workbench.debug.disassemblyView",e.$PG="workbench.panel.repl",e.$QG="workbench.panel.repl.view",e.$RG=new T.$kj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$SG=new T.$kj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$TG=new T.$kj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$UG="debugUx",e.$VG=new T.$kj(e.$UG,"default",{type:"string",description:E.localize(3,null)}),e.$WG=new T.$kj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$XG=new T.$kj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$YG=new T.$kj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$ZG=new T.$kj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$1G=new T.$kj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$2G=new T.$kj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$3G=new T.$kj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$4G=new T.$kj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$5G=new T.$kj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$6G=new T.$kj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$7G=new T.$kj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$8G=new T.$kj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$9G=new T.$kj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$0G=new T.$kj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$$G=new T.$kj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$_G=new T.$kj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$aH=new T.$kj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$bH=new T.$kj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$cH=new T.$kj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$dH=new T.$kj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$eH=new T.$kj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$fH=new T.$kj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$gH=new T.$kj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$hH=new T.$kj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$iH=new T.$kj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$jH=new T.$kj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$kH=new T.$kj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$lH=new T.$kj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$mH=new T.$kj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$nH=new T.$kj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$oH=new T.$kj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$pH=new T.$kj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$qH=new T.$kj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$rH=new T.$kj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$sH=new T.$kj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$tH=new T.$kj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$uH=new T.$kj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$vH=new T.$kj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$wH=new T.$kj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$xH=new T.$kj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$yH=new T.$kj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$zH=new T.$kj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$AH=new T.$kj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$BH=new T.$kj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$CH=new T.$kj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$DH=new T.$kj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$EH=new T.$kj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$FH=new T.$kj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=u=>E.localize(52,null,u);e.$GH=M,e.$HH="editor.contrib.debug",e.$IH="editor.contrib.breakpoint",e.$JH="debug",e.$KH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(R||(e.State=R={}));function $(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$LH=$;var g;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$MH="vscode-debug-memory";var b;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var A;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$NH=(0,C.$6h)("debugService");var D;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE",u[u.TRIGGER_POINT=3]="TRIGGER_POINT"})(D||(e.BreakpointWidgetContext=D={}))}),define(Pe[208],Re([1,0,11,2,19,26,12,29,20,18]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0;const A=/{([^}]+)}/g;function D(L,v,y){return L.replace(A,function(k,N){return v&&N.length>0&&N[0]!=="_"?k:y&&y.hasOwnProperty(N)?y[N]:k})}e.$0F=D;function u(L){const v={};for(const y of Object.keys(L))y.startsWith("!")||(v[y]=L[y]);return v}e.$$F=u;function p(L){return L.configuration.request==="attach"&&!w(L)&&(!L.parentSession||p(L.parentSession))}e.$_F=p;function w(L){let v=L.configuration.type;if(v)return v==="vslsShare"&&(v=L.configuration.adapterProxy.configuration.type),(0,E.$_e)(v,"extensionhost")||(0,E.$_e)(v,"pwa-extensionhost")?L:L.parentSession?w(L.parentSession):void 0}e.$aG=w;function s(L){return L.type&&(L.label||L.program||L.runtime)}e.$bG=s;function o(L,v,y){let k,N=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=O.exec(L);){const W=G.index+1,z=W+G[0].length;if(W<=v&&z>=y){k=G[0],N=W;break}}if(k){const W=/\w+/g;let z=null;for(;(z=W.exec(k))&&!(z.index+1+N+z[0].length>=y););z&&(k=k.substring(0,W.lastIndex))}return k?{start:N,end:N+k.length-1}:{start:0,end:0}}e.$cG=o;async function t(L,v,y,k){if(L.evaluatableExpressionProvider.has(v)){const N=L.evaluatableExpressionProvider.ordered(v),O=(0,b.$Hb)(await Promise.all(N.map(async G=>{try{return await G.provideEvaluatableExpression(v,y,k??g.CancellationToken.None)}catch{return}})));if(O.length>0){let G=O[0].expression;const W=O[0].range;return G||(G=v.getLineContent(y.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:G}}}else{const N=v.getLineContent(y.lineNumber),{start:O,end:G}=o(N,y.column,y.column),W=N.substring(O-1,G);return{matchingExpression:W,range:new $.$Us(y.lineNumber,O,y.lineNumber,O+W.length)}}return null}e.$dG=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(L){return!!(L&&L.match(n))}e.$eG=a;function c(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(a(L.path))return T.URI.parse(L.path);if((0,C.$ic)(L.path))return T.URI.file(L.path)}return L.path}function h(L){if(typeof L.path=="object"){const v=T.URI.revive(L.path);if(v)return v.scheme===R.Schemas.file?v.fsPath:v.toString()}return L.path}function i(L,v){const y=v?c:h,k=(0,M.$vn)(L);return r(k,(N,O)=>{N&&O&&(O.path=y(O))}),k}e.$fG=i;function l(L,v){const y=v?c:h,k=(0,M.$vn)(L);return r(k,(N,O)=>{!N&&O&&(O.path=y(O))}),k}e.$gG=l;function r(L,v){switch(L.type){case"event":{const y=L;switch(y.event){case"output":v(!1,y.body.source);break;case"loadedSource":v(!1,y.body.source);break;case"breakpoint":v(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=L;switch(y.command){case"setBreakpoints":v(!0,y.arguments.source);break;case"breakpointLocations":v(!0,y.arguments.source);break;case"source":v(!0,y.arguments.source);break;case"gotoTargets":v(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(k=>v(!1,k));break;default:break}break}case"response":{const y=L;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(k=>v(!1,k.source));break;case"loadedSources":y.body.sources.forEach(k=>v(!1,k));break;case"scopes":y.body.scopes.forEach(k=>v(!1,k.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(k=>v(!1,k.source));break;case"setBreakpoints":y.body.breakpoints.forEach(k=>v(!1,k.source));break;case"disassemble":y.body?.instructions.forEach(N=>v(!1,N.location));break;default:break}break}}}function d(L){return L.filter(v=>!v.presentation?.hidden).sort((v,y)=>v.presentation?y.presentation?v.presentation.group?y.presentation.group?v.presentation.group!==y.presentation.group?v.presentation.group.localeCompare(y.presentation.group):m(v.presentation.order,y.presentation.order):-1:y.presentation.group?1:m(v.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$hG=d;function m(L,v){return typeof L!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:L-v}async function f(L,v){const y=L.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(y!=="none"&&(await v.saveAll(),y==="allEditorsInActiveGroup")){const k=v.activeEditorPane;k&&k.input.resource?.scheme===R.Schemas.untitled&&await v.save({editor:k.input,groupId:k.group.id})}await L.reloadConfiguration()}e.$iG=f;const S=(L,v)=>!L||!v?L===v:L.name===v.name&&L.path===v.path&&L.sourceReference===v.sourceReference;e.$jG=S}),define(Pe[76],Re([1,0,24,34,67,68,12,19,21,35]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.$$I=e.$0I=e.$9I=e.CellStatusbarAlignment=e.$8I=e.$7I=e.$6I=e.NotebookEditorPriority=e.$5I=e.$4I=e.$3I=e.$2I=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$1I=e.$ZI=e.$YI=e.$XI=e.CellKind=e.$WI=e.$VI=e.$UI=void 0,e.$UI="workbench.editor.notebook",e.$VI="workbench.editor.notebookTextDiffEditor",e.$WI="workbench.editor.interactive";var A;(function(I){I[I.Markup=1]="Markup",I[I.Code=2]="Code"})(A||(e.CellKind=A={})),e.$XI=["application/json","application/javascript","text/html","image/svg+xml",M.$fs.latex,M.$fs.markdown,"image/png","image/jpeg",M.$fs.text],e.$YI=[M.$fs.latex,M.$fs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$fs.text],e.$ZI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$1I="_notAvailable";var D;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var u;(function(I){I[I.Unconfirmed=1]="Unconfirmed",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var p;(function(I){I[I.Unconfirmed=1]="Unconfirmed",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var w;(function(I){I[I.WithHardKernelDependency=0]="WithHardKernelDependency",I[I.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",I[I.Pure=2]="Pure",I[I.Never=3]="Never"})(w||(e.NotebookRendererMatch=w={}));var s;(function(I){I.Always="always",I.Never="never",I.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var o;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.ChangeCellLanguage=5]="ChangeCellLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",I[I.ChangeCellMime=13]="ChangeCellMime",I[I.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var t;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.Move=6]="Move",I[I.OutputItems=7]="OutputItems",I[I.PartialMetadata=8]="PartialMetadata",I[I.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var a;(function(I){I.scheme=R.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],ae=new RegExp(`^[${H.join("")}]+`),de=7;function we(ne,Y){const V=Y.toString(de),Ie=`${V.length<H.length?H[V.length-1]:"z"}${V}s${(0,E.$De)(E.$je.fromString(ne.scheme),!0,!0)}`;return ne.with({scheme:I.scheme,fragment:Ie})}I.generate=we;function ke(ne){if(ne.scheme!==I.scheme)return;const Y=ne.fragment.indexOf("s");if(Y<0)return;const V=parseInt(ne.fragment.substring(0,Y).replace(ae,""),de),ie=(0,E.$Ce)(ne.fragment.substring(Y+1)).toString();if(!isNaN(V))return{handle:V,notebook:ne.with({scheme:ie,fragment:null})}}I.parse=ke;function le(ne,Y){return ne.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Y??""},${ne.scheme!==R.Schemas.file?ne.scheme:""}`})}I.generateCellOutputUri=le;function ve(ne){if(ne.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Y=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!Y)return;const V=Y[1]&&Y[1]!==""?Y[1]:void 0,ie=Y[2];return{outputId:V,notebook:ne.with({scheme:ie||R.Schemas.file,fragment:null})}}I.parseCellOutputUri=ve;function se(ne,Y,V){return I.generate(ne,Y).with({scheme:V})}I.generateCellPropertyUri=se;function be(ne,Y){if(ne.scheme===Y)return I.parse(ne.with({scheme:I.scheme}))}I.parseCellPropertyUri=be})(a||(e.CellUri=a={}));const c=I=>g.$i?I.replace(/\//g,"\\"):I;class h{constructor(H=[],ae=e.$XI){this.e=ae,this.d=[...new Set(H)].map(de=>({pattern:de,matches:T.$Mj(c(de))}))}sort(H){const ae=new Map(C.Iterable.map(H,we=>[we,c(we)]));let de=[];for(const{matches:we}of this.d)for(const[ke,le]of ae)if(we(le)){de.push(ke),ae.delete(ke);break}return ae.size&&(de=de.concat([...ae.keys()].sort((we,ke)=>this.e.indexOf(we)-this.e.indexOf(ke)))),de}prioritize(H,ae){const de=this.f(H);if(de===-1){this.d.unshift({pattern:H,matches:T.$Mj(c(H))});return}const we=new Set(ae.map(le=>this.f(le,de)));we.delete(-1);const ke=Array.from(we).sort();this.d.splice(de+1,0,...ke.map(le=>this.d[le]));for(let le=ke.length-1;le>=0;le--)this.d.splice(ke[le],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,ae=this.d.length){const de=c(H);for(let we=0;we<ae;we++)if(this.d[we].matches(de))return we;return-1}}e.$2I=h;function i(I,H,ae,de=(we,ke)=>we===ke){const we=[];function ke(se,be,ne){if(be===0&&ne.length===0)return;const Y=we[we.length-1];Y&&Y.start+Y.deleteCount===se?(Y.deleteCount+=be,Y.toInsert.push(...ne)):we.push({start:se,deleteCount:be,toInsert:ne})}let le=0,ve=0;for(;;){if(le===I.length){ke(le,0,H.slice(ve));break}if(ve===H.length){ke(le,I.length-le,[]);break}const se=I[le],be=H[ve];if(de(se,be)){le+=1,ve+=1;continue}ae(be)?(ke(le,1,[]),le+=1):(ke(le,0,[be]),ve+=1)}return we}e.$3I=i,e.$4I=new b.$kj("notebookEditorCursorAtBoundary","none"),e.$5I=new b.$kj("notebookEditorCursorAtLineBoundary","none");var l;(function(I){I.default="default",I.option="option"})(l||(e.NotebookEditorPriority=l={}));function r(I){const H=I;return!!((typeof H.include=="string"||T.$Nj(H.include))&&(typeof H.exclude=="string"||T.$Nj(H.exclude)))}e.$6I=r;function d(I,H,ae){if(Array.isArray(I.viewType)&&I.viewType.indexOf(H)>=0||I.viewType===H)return!0;if(I.filenamePattern){const de=r(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,we=r(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(T.$Lj(de,(0,$.$nc)(ae.fsPath).toLowerCase()))return!(we&&T.$Lj(we,(0,$.$nc)(ae.fsPath).toLowerCase()))}return!1}e.$7I=d,e.$8I={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var m;(function(I){I[I.Left=1]="Left",I[I.Right=2]="Right"})(m||(e.CellStatusbarAlignment=m={}));class f{static{this.d="notebook/"}static create(H){return`${f.d}${H}`}static parse(H){if(H.startsWith(f.d))return H.substring(f.d.length)}}e.$9I=f;function S(I){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(I)}e.$0I=S;const L=new TextDecoder;function v(I){const H=[];let ae=!1;for(const le of I)(H.length===0||ae)&&(H.push(le),ae=!0);let de=N(H);const we=E.$je.concat(H.map(le=>E.$je.wrap(le))),ke=P(we);return de=de||ke.byteLength!==we.byteLength,{data:ke,didCompression:de}}e.$$I=v,e.$_I=`${String.fromCharCode(27)}[A`;const y=e.$_I.split("").map(I=>I.charCodeAt(0)),k=10;function N(I){let H=!1;return I.forEach((ae,de)=>{if(de===0||ae.length<e.$_I.length)return;const we=I[de-1],ke=ae.subarray(0,e.$_I.length);if(ke[0]===y[0]&&ke[1]===y[1]&&ke[2]===y[2]){const le=we.lastIndexOf(k);if(le===-1)return;H=!0,I[de-1]=we.subarray(0,le),I[de]=ae.subarray(e.$_I.length)}}),H}function O(I){let H=I;do I=H,H=I.replace(/[^\n]\x08/gm,"");while(H.length<I.length);return I}function G(I){for(I=I.replace(/\r+\n/gm,`
`);I.search(/\r[^$]/g)>-1;){const H=I.match(/^(.*)\r+/m)[1];let ae=I.match(/\r+(.*)$/m)[1];ae=ae+H.slice(ae.length,H.length),I=I.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return I}const W="\b".charCodeAt(0),z="\r".charCodeAt(0);function P(I){return!I.buffer.includes(W)&&!I.buffer.includes(z)?I:E.$je.fromString(G(O(L.decode(I.buffer))))}}),define(Pe[7],Re([1,0,18,15,52,28,68,11,16,2,33,22,42,100,76]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w){"use strict";var s,o,t,n,a,c,h,i,l,r,d,m,f,S,L,v,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$YM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$XM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.TestRunProfileKind=e.TestResultState=e.$DM=e.$CM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$BM=e.NotebookVariablesRequestKind=e.$AM=e.$zM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$yM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.ColorThemeKind=e.$sM=e.$rM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$qM=e.DebugConsoleMode=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$kM=e.$jM=e.FileChangeType=e.$iM=e.$hM=e.$gM=e.$fM=e.InlineCompletionTriggerKind=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.ConfigurationTarget=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UL=e.ViewBadge=e.ProgressLocation=e.$TL=e.$SL=e.TaskScope=e.ShellQuoting=e.$RL=e.$QL=e.$PL=e.TaskPanelKind=e.TaskRevealKind=e.$OL=e.TerminalLocation=e.$NL=e.$ML=e.$LL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KL=e.$JL=e.$IL=e.$HL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$GL=e.StatusBarAlignment=e.ViewColumn=e.$FL=e.$EL=e.$DL=e.$CL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BL=e.$AL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.LanguageStatusSeverity=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.CodeActionTriggerKind=e.$oL=e.$nL=e.SymbolTag=e.SymbolKind=e.$mL=e.$lL=e.DocumentHighlightKind=e.$kL=e.$jL=e.$iL=e.$hL=e.DiagnosticSeverity=e.DiagnosticTag=e.$gL=e.$fL=e.FileEditType=e.$eL=e.$dL=e.$cL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function k(B){return Object.assign(B,{apply:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const De=oe.length===1?[]:oe[1];return Reflect.construct(B,De,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const[De,...Ge]=oe;return Reflect.construct(B,Ge,De.constructor)}}})}var N;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let G=s=class{static from(...j){let oe=j;return new s(function(){if(oe){for(const De of oe)De&&typeof De.dispose=="function"&&De.dispose();oe=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$8K=G,e.$8K=G=s=Je([k],G);let W=o=class{static Min(...j){if(j.length===0)throw new TypeError;let oe=j[0];for(let De=1;De<j.length;De++){const Ge=j[De];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...j){if(j.length===0)throw new TypeError;let oe=j[0];for(let De=1;De<j.length;De++){const Ge=j[De];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(j){if(!j)return!1;if(j instanceof o)return!0;const{line:oe,character:De}=j;return typeof oe=="number"&&typeof De=="number"}static of(j){if(j instanceof o)return j;if(this.isPosition(j))return new o(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,oe){if(j<0)throw(0,T.$7)("line must be non-negative");if(oe<0)throw(0,T.$7)("character must be non-negative");this.c=j,this.e=oe}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,oe=0){if(j===null||oe===null)throw(0,T.$7)();let De;return typeof j>"u"?De=0:typeof j=="number"?De=j:(De=typeof j.lineDelta=="number"?j.lineDelta:0,oe=typeof j.characterDelta=="number"?j.characterDelta:0),De===0&&oe===0?this:new o(this.line+De,this.character+oe)}with(j,oe=this.character){if(j===null||oe===null)throw(0,T.$7)();let De;return typeof j>"u"?De=this.line:typeof j=="number"?De=j:(De=typeof j.line=="number"?j.line:this.line,oe=typeof j.character=="number"?j.character:this.character),De===this.line&&oe===this.character?this:new o(De,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$9K=W,e.$9K=W=o=Je([k],W);let z=t=class{static isRange(j){return j instanceof t?!0:j?W.isPosition(j.start)&&W.isPosition(j.end):!1}static of(j){if(j instanceof t)return j;if(this.isRange(j))return new t(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,oe,De,Ge){let xe,ut;if(typeof j=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ge=="number"?(xe=new W(j,oe),ut=new W(De,Ge)):W.isPosition(j)&&W.isPosition(oe)&&(xe=W.of(j),ut=W.of(oe)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(j){return t.isRange(j)?this.contains(j.start)&&this.contains(j.end):W.isPosition(j)?!(W.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const oe=W.Max(j.start,this.c),De=W.Min(j.end,this.e);if(!oe.isAfter(De))return new t(oe,De)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const oe=W.Min(j.start,this.c),De=W.Max(j.end,this.end);return new t(oe,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,oe=this.end){if(j===null||oe===null)throw(0,T.$7)();let De;return j?W.isPosition(j)?De=j:(De=j.start||this.start,oe=j.end||this.end):De=this.start,De.isEqual(this.c)&&oe.isEqual(this.end)?this:new t(De,oe)}toJSON(){return[this.start,this.end]}};e.$0K=z,e.$0K=z=t=Je([k],z);let P=n=class extends z{static isSelection(j){return j instanceof n?!0:j?z.isRange(j)&&W.isPosition(j.anchor)&&W.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,oe,De,Ge){let xe,ut;if(typeof j=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ge=="number"?(xe=new W(j,oe),ut=new W(De,Ge)):W.isPosition(j)&&W.isPosition(oe)&&(xe=W.of(j),ut=W.of(oe)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$$K=P,e.$$K=P=n=Je([k],P);const I=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,T.$7)("connectionToken")};class H{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,oe,De){if(typeof j!="string"||j.length===0)throw(0,T.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,T.$7)("port");typeof De<"u"&&I(De),this.host=j,this.port=Math.round(oe),this.connectionToken=De}}e.$_K=H;class ae{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,oe){this.makeConnection=j,this.connectionToken=oe,typeof oe<"u"&&I(oe)}}e.$aL=ae;class de extends Error{static NotAvailable(j,oe){return new de(j,p.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(j){return new de(j,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,oe=p.RemoteAuthorityResolverErrorCode.Unknown,De){super(j),this._message=j,this._code=oe,this._detail=De,Object.setPrototypeOf(this,de.prototype)}}e.$bL=de;var we;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var ke;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let le=a=class{static isTextEdit(j){return j instanceof a?!0:j?z.isRange(j)&&typeof j.newText=="string":!1}static replace(j,oe){return new a(j,oe)}static insert(j,oe){return a.replace(new z(j,j),oe)}static delete(j){return a.replace(j,"")}static setEndOfLine(j){const oe=new a(new z(new W(0,0),new W(0,0)),"");return oe.newEol=j,oe}get range(){return this.c}set range(j){if(j&&!z.isRange(j))throw(0,T.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,T.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,T.$7)("newEol");this.f=j}constructor(j,oe){this.c=j,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$cL=le,e.$cL=le=a=Je([k],le);let ve=c=class{static isNotebookCellEdit(j){return j instanceof c?!0:j?ei.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,oe){return new c(j,oe)}static insertCells(j,oe){return new c(new ei(j,j),oe)}static deleteCells(j){return new c(j,[])}static updateCellMetadata(j,oe){const De=new c(new ei(j,j),[]);return De.newCellMetadata=oe,De}static updateNotebookMetadata(j){const oe=new c(new ei(0,0),[]);return oe.newNotebookMetadata=j,oe}constructor(j,oe){this.range=j,this.newCells=oe}};e.$dL=ve,e.$dL=ve=c=Je([k],ve);class se{static isSnippetTextEdit(j){return j instanceof se?!0:j?z.isRange(j.range)&&Y.isSnippetString(j.snippet):!1}static replace(j,oe){return new se(j,oe)}static insert(j,oe){return se.replace(new z(j,j),oe)}constructor(j,oe){this.range=j,this.snippet=oe}}e.$eL=se;var be;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,oe,De,Ge){this.c.push({_type:1,from:j,to:oe,options:De,metadata:Ge})}createFile(j,oe,De){this.c.push({_type:1,from:void 0,to:j,options:oe,metadata:De})}deleteFile(j,oe,De){this.c.push({_type:1,from:j,to:void 0,options:oe,metadata:De})}e(j,oe,De){this.c.push({_type:3,metadata:De,uri:j,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(j,oe,De,Ge){const xe=oe.start,ut=oe.end;(xe!==ut||De.length>0)&&this.c.push({_type:5,uri:j,index:xe,count:ut-xe,cells:De,metadata:Ge})}g(j,oe,De,Ge){this.c.push({_type:3,metadata:Ge,uri:j,edit:{editType:3,index:oe,metadata:De}})}replace(j,oe,De,Ge){this.c.push({_type:2,uri:j,edit:new le(oe,De),metadata:Ge})}insert(j,oe,De,Ge){this.replace(j,new z(oe,oe),De,Ge)}delete(j,oe,De){this.replace(j,oe,"",De)}has(j){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===j.toString())}set(j,oe){if(oe)for(const De of oe){if(!De)continue;let Ge,xe;Array.isArray(De)?(Ge=De[0],xe=De[1]):Ge=De,ve.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(j,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(j,Ge.newNotebookMetadata,xe):this.f(j,Ge.range,Ge.newCells,xe):se.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:j,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:j,edit:Ge,metadata:xe})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===j.toString()&&(this.c[De]=void 0);break}}(0,E.$Ib)(this.c)}}get(j){const oe=[];for(const De of this.c)De._type===2&&De.uri.toString()===j.toString()&&oe.push(De.edit);return oe}entries(){const j=new M.$Ac;for(const oe of this.c)if(oe._type===2){let De=j.get(oe.uri);De||(De=[oe.uri,[]],j.set(oe.uri,De)),De[1].push(oe.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$fL=ne,e.$fL=ne=Je([k],ne);let Y=h=class{static isSnippetString(j){return j instanceof h?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=h.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,oe=this.e++){if(typeof j=="function"){const De=new h;De.e=this.e,j(De),this.e=De.e,j=De.value}else j=h.c(j);return this.value+="${",this.value+=oe,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,oe=this.e++){const De=j.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(j,oe){if(typeof oe=="function"){const De=new h;De.e=this.e,oe(De),this.e=De.e,oe=De.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$gL=Y,e.$gL=Y=h=Je([k],Y);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ie;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let Ie=i=class{static isLocation(j){return j instanceof i?!0:j?z.isRange(j.range)&&b.URI.isUri(j.uri):!1}constructor(j,oe){if(this.uri=j,oe)if(z.isRange(oe))this.range=z.of(oe);else if(W.isPosition(oe))this.range=new z(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$hL=Ie,e.$hL=Ie=i=Je([k],Ie);let Le=class{static is(j){return j?typeof j.message=="string"&&j.location&&z.isRange(j.location.range)&&b.URI.isUri(j.location.uri):!1}constructor(j,oe){this.location=j,this.message=oe}static isEqual(j,oe){return j===oe?!0:!j||!oe?!1:j.message===oe.message&&j.location.range.isEqual(oe.location.range)&&j.location.uri.toString()===oe.location.uri.toString()}};e.$iL=Le,e.$iL=Le=Je([k],Le);let Ce=class{constructor(j,oe,De=ie.Error){if(!z.isRange(j))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=j,this.message=oe,this.severity=De}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,oe){return j===oe?!0:!j||!oe?!1:j.message===oe.message&&j.severity===oe.severity&&j.code===oe.code&&j.severity===oe.severity&&j.source===oe.source&&j.range.isEqual(oe.range)&&(0,E.$ub)(j.tags,oe.tags)&&(0,E.$ub)(j.relatedInformation,oe.relatedInformation,Le.isEqual)}};e.$jL=Ce,e.$jL=Ce=Je([k],Ce);let ce=class{constructor(j,oe){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=oe}};e.$kL=ce,e.$kL=ce=Je([k],ce);var te;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let Q=class{constructor(j,oe=te.Text){this.range=j,this.kind=oe}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$lL=Q,e.$lL=Q=Je([k],Q);let ee=class{constructor(j,oe){this.uri=j,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$mL=ee,e.$mL=ee=Je([k],ee);var me;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var pe;(function(B){B[B.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Ae=l=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,oe,De,Ge,xe){this.name=j,this.kind=oe,this.containerName=xe,typeof De=="string"&&(this.containerName=De),Ge instanceof Ie?this.location=Ge:De instanceof z&&(this.location=new Ie(Ge,De)),l.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$nL=Ae,e.$nL=Ae=l=Je([k],Ae);let he=r=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(r.validate)}constructor(j,oe,De,Ge,xe){this.name=j,this.detail=oe,this.kind=De,this.range=Ge,this.selectionRange=xe,this.children=[],r.validate(this)}};e.$oL=he,e.$oL=he=r=Je([k],he);var ye;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(ye||(e.CodeActionTriggerKind=ye={}));let F=class{constructor(j,oe){this.title=j,this.kind=oe}};e.$pL=F,e.$pL=F=Je([k],F);let q=class{static{d=this}static{this.c="."}constructor(j){this.value=j}append(j){return new d(this.value?this.value+d.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+d.c)}};e.$qL=q,e.$qL=q=d=Je([k],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let K=class{constructor(j,oe){if(this.range=j,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rL=K,e.$rL=K=Je([k],K);class U{constructor(j,oe,De,Ge,xe,ut){this.kind=j,this.name=oe,this.detail=De,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$sL=U;class X{constructor(j,oe){this.fromRanges=oe,this.from=j}}e.$tL=X;class x{constructor(j,oe){this.fromRanges=oe,this.to=j}}e.$uL=x;var Ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ee||(e.LanguageStatusSeverity=Ee={}));let Te=class{constructor(j,oe){this.range=j,this.command=oe}get isResolved(){return!!this.command}};e.$vL=Te,e.$vL=Te=Je([k],Te);let Ve=m=class{#e;static isMarkdownString(j){return j instanceof m?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,oe=!1){this.#e=new C.$hk(j,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,oe){return this.#e.appendCodeblock(oe??"",j),this}};e.$wL=Ve,e.$wL=Ve=m=Je([k],Ve);let He=class{constructor(j,oe){this.label=j,this.documentation=oe}};e.$xL=He,e.$xL=He=Je([k],He);let Ye=class{constructor(j,oe){this.label=j,this.documentation=oe,this.parameters=[]}};e.$yL=Ye,e.$yL=Ye=Je([k],Ye);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zL=st,e.$zL=st=Je([k],st);var nt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let at=class{constructor(j){this.value=j}};e.$AL=at,e.$AL=at=Je([k],at);let ct=class{constructor(j,oe,De){this.position=j,this.label=oe,this.kind=De}};e.$BL=ct,e.$BL=ct=Je([k],ct);var je;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var vt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var Z;(function(B){B[B.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let _=class{constructor(j,oe){this.label=j,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CL=_,e.$CL=_=Je([k],_);let $e=class{constructor(j=[],oe=!1){this.items=j,this.isIncomplete=oe}};e.$DL=$e,e.$DL=$e=Je([k],$e);let Be=class{constructor(j,oe,De){this.insertText=j,this.range=oe,this.command=De}};e.$EL=Be,e.$EL=Be=Je([k],Be);let Qe=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$FL=Qe,e.$FL=Qe=Je([k],Qe);var it;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var rt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function Ne(B,j){return`${D.$lm.toKey(B)}.${j}`}e.$GL=Ne;var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Tt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Ht;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var Bt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var yt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var Kt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(B){function j(oe){switch(oe){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=j}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Nt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Nt||(e.SyntaxTokenType=Nt={})),function(B){function j(oe){switch(oe){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=j}(Nt||(e.SyntaxTokenType=Nt={}));let Xt=class{constructor(j,oe){if(oe&&!b.URI.isUri(oe))throw(0,T.$7)("target");if(!z.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.target=oe}};e.$HL=Xt,e.$HL=Xt=Je([k],Xt);let zt=class{constructor(j,oe,De,Ge){this.red=j,this.green=oe,this.blue=De,this.alpha=Ge}};e.$IL=zt,e.$IL=zt=Je([k],zt);let Rt=class{constructor(j,oe){if(oe&&!(oe instanceof zt))throw(0,T.$7)("color");if(!z.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.color=oe}};e.$JL=Rt,e.$JL=Rt=Je([k],Rt);let Ze=class{constructor(j){if(!j||typeof j!="string")throw(0,T.$7)("label");this.label=j}};e.$KL=Ze,e.$KL=Ze=Je([k],Ze);var Gt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var lt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class $t{constructor(j,oe,De){if(this.startIndex=j,this.length=oe,this.tooltip=De,typeof j!="number"||j<0)throw(0,T.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,T.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,T.$7)("tooltip")}}e.$LL=$t;class jt{constructor(j){this.uri=j}}e.$ML=jt;class Vt{constructor(j){this.terminalCommand=j}}e.$NL=Vt;var kt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class dt{constructor(j){if(this.options=j,typeof j!="object")throw(0,T.$7)("options")}}e.$OL=dt;var Ct;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var xt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let Dt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(j){switch(j){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(j,oe){if(this.label=oe,typeof j!="string"||typeof oe!="string")throw(0,T.$7)("name");this.c=j}get id(){return this.c}};e.$PL=Dt,e.$PL=Dt=f=Je([k],Dt);function qe(B){let j="";for(let oe=0;oe<B.length;oe++)j+=B[oe].replace(/,/g,",,")+",";return j}let Mt=class{constructor(j,oe,De){if(typeof j!="string")throw(0,T.$7)("process");this.e=[],this.c=j,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=De):this.f=oe)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,T.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)j.push(oe);return qe(j)}};e.$QL=Mt,e.$QL=Mt=Je([k],Mt);let Wt=class{constructor(j,oe,De){if(this.f=[],Array.isArray(oe)){if(!j)throw(0,T.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j,this.f=oe,this.g=De}else{if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j,this.g=oe}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)j.push(typeof oe=="string"?oe:oe.value);return qe(j)}};e.$RL=Wt,e.$RL=Wt=Je([k],Wt);var Qt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Ft{constructor(j){this.c=j}computeId(){return"customExecution"+(0,A.$qg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$SL=Ft;let Se=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,oe,De,Ge,xe,ut){this.k=!1,this.l=this.definition=j;let gt;typeof oe=="string"?(this.n=this.name=oe,this.u=this.source=De,this.execution=Ge,gt=xe,this.k=!0):oe===ft.Global||oe===ft.Workspace?(this.target=oe,this.n=this.name=De,this.u=this.source=Ge,this.execution=xe,gt=ut):(this.target=oe,this.n=this.name=De,this.u=this.source=Ge,this.execution=xe,gt=ut),typeof gt=="string"?(this.q=[gt],this.r=!0):Array.isArray(gt)?(this.q=gt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Mt?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Wt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Ft?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,A.$qg)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=j}get scope(){return this.m}set target(j){this.A(),this.m=j}get name(){return this.n}set name(j){if(typeof j!="string")throw(0,T.$7)("name");this.A(),this.n=j}get execution(){return this.o}set execution(j){j===null&&(j=void 0),this.A(),this.o=j;const oe=this.l.type;(S.g===oe||S.e===oe||S.f===oe||S.c===oe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(j){if(Array.isArray(j))this.A(),this.q=j,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.A(),this.t=j}get source(){return this.u}set source(j){if(typeof j!="string"||j.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=j}get group(){return this.w}set group(j){j===null&&(j=void 0),this.A(),this.w=j}get detail(){return this.z}set detail(j){j===null&&(j=void 0),this.z=j}get presentationOptions(){return this.x}set presentationOptions(j){j==null&&(j=Object.create(null)),this.A(),this.x=j}get runOptions(){return this.y}set runOptions(j){j==null&&(j=Object.create(null)),this.A(),this.y=j}};e.$TL=Se,e.$TL=Se=S=Je([k],Se);var Fe;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var fe;(function(B){function j(oe){const De=oe;return(0,g.$Mf)(De.value)?De.tooltip&&!(0,g.$If)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=j})(fe||(e.ViewBadge=fe={}));let J=L=class{static isTreeItem(j,oe){const De=j;if(De.checkboxState!==void 0){const Ge=(0,g.$Mf)(De.checkboxState)?De.checkboxState:(0,g.$Kf)(De.checkboxState)&&(0,g.$Mf)(De.checkboxState.state)?De.checkboxState.state:void 0,xe=!(0,g.$Mf)(De.checkboxState)&&(0,g.$Kf)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Ue.Checked&&Ge!==Ue.Unchecked||xe!==void 0&&!(0,g.$If)(xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(j instanceof L)return!0;if(De.label!==void 0&&!(0,g.$If)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$If)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$If)(De.iconPath)&&!b.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$If)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,g.$If)(Ge.light)&&!b.URI.isUri(Ge.light)&&!(0,g.$If)(Ge.dark)&&!b.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$If)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!b.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$If)(De.tooltip)&&!(De.tooltip instanceof Ve)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Me.None&&De.collapsibleState>Me.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$If)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(j,oe=Me.None){this.collapsibleState=oe,b.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$UL=J,e.$UL=J=L=Je([k],J);var Me;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Me||(e.TreeItemCollapsibleState=Me={}));var Ue;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Ue||(e.TreeItemCheckboxState=Ue={}));let Xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$VL=Xe,e.$VL=Xe=Je([k],Xe);class We extends Xe{}e.$WL=We;class _e extends We{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$XL=_e;class mt{constructor(j,oe,De,Ge){this.name=j,this.uri=oe,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$YL=mt;let Ut=class{#e=new Map;constructor(j){for(const[oe,De]of j??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(De):this.#e.set(this.#t(oe),[De])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,oe){this.#e.set(this.#t(j),[oe])}forEach(j,oe){for(const[De,Ge]of this.#e)for(const xe of Ge)j.call(oe,xe,De,this)}*[Symbol.iterator](){for(const[j,oe]of this.#e)for(const De of oe)yield[j,De]}#t(j){return j.toLowerCase()}};e.$ZL=Ut,e.$ZL=Ut=Je([k],Ut);let Et=class{constructor(j){this.insertText=j}};e.$1L=Et,e.$1L=Et=Je([k],Et);let St=class{constructor(j,oe){this.label=oe,this.insertText=j}};e.$2L=St,e.$2L=St=Je([k],St);let bt=class{constructor(j,oe){this.id=j,this.color=oe}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$3L=bt,e.$3L=bt=Je([k],bt),bt.File=new bt("file"),bt.Folder=new bt("folder");let gi=class{constructor(j){this.id=j}};e.$4L=gi,e.$4L=gi=Je([k],gi);var At;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Si=class{get base(){return this.c}set base(j){this.c=j,this.e=b.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,oe){if(typeof j!="string"&&(!j||!b.URI.isUri(j)&&!b.URI.isUri(j.uri)))throw(0,T.$7)("base");if(typeof oe!="string")throw(0,T.$7)("pattern");typeof j=="string"?this.baseUri=b.URI.file(j):b.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$5L=Si,e.$5L=Si=Je([k],Si);const Gi=new WeakMap;function It(B,j){Gi.set(B,j)}e.$6L=It;let ri=class{constructor(j,oe,De,Ge){this.enabled=typeof j=="boolean"?j:!0,typeof oe=="string"&&(this.condition=oe),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Gi.get(this)??(0,A.$qg)()),this.c}};e.$7L=ri,e.$7L=ri=Je([k],ri);let mi=class extends ri{constructor(j,oe,De,Ge,xe){if(super(oe,De,Ge,xe),j===null)throw(0,T.$7)("location");this.location=j}};e.$8L=mi,e.$8L=mi=Je([k],mi);let ci=class extends ri{constructor(j,oe,De,Ge,xe){super(oe,De,Ge,xe),this.functionName=j}};e.$9L=ci,e.$9L=ci=Je([k],ci);let Ii=class extends ri{constructor(j,oe,De,Ge,xe,ut,gt){if(super(Ge,xe,ut,gt),!oe)throw(0,T.$7)("dataId");this.label=j,this.dataId=oe,this.canPersist=De}};e.$0L=Ii,e.$0L=Ii=Je([k],Ii);let Ci=class{constructor(j,oe,De){this.command=j,this.args=oe||[],this.options=De}};e.$$L=Ci,e.$$L=Ci=Je([k],Ci);let Ot=class{constructor(j,oe){this.port=j,this.host=oe}};e.$_L=Ot,e.$_L=Ot=Je([k],Ot);let $i=class{constructor(j){this.path=j}};e.$aM=$i,e.$aM=$i=Je([k],$i);let Pi=class{constructor(j){this.implementation=j}};e.$bM=Pi,e.$bM=Pi=Je([k],Pi);let ui=class{constructor(j,oe,De){this.session=j,this.threadId=oe,this.frameId=De}};e.$cM=ui,e.$cM=ui=Je([k],ui);let li=class{constructor(j,oe){this.session=j,this.threadId=oe}};e.$dM=li,e.$dM=li=Je([k],li);let ht=class{constructor(j,oe){this.range=j,this.expression=oe}};e.$eM=ht,e.$eM=ht=Je([k],ht);var Ji;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let _t=class{constructor(j,oe){this.range=j,this.text=oe}};e.$fM=_t,e.$fM=_t=Je([k],_t);let si=class{constructor(j,oe,De=!0){this.range=j,this.variableName=oe,this.caseSensitiveLookup=De}};e.$gM=si,e.$gM=si=Je([k],si);let pi=class{constructor(j,oe){this.range=j,this.expression=oe}};e.$hM=pi,e.$hM=pi=Je([k],pi);let Ri=class{constructor(j,oe){this.frameId=j,this.stoppedLocation=oe}};e.$iM=Ri,e.$iM=Ri=Je([k],Ri);var Qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ai=v=class extends Error{static FileExists(j){return new v(j,u.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(j){return new v(j,u.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(j){return new v(j,u.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(j){return new v(j,u.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(j){return new v(j,u.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(j){return new v(j,u.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(j,oe=u.FileSystemProviderErrorCode.Unknown,De){super(b.URI.isUri(j)?j.toString(!0):j),this.code=De?.name??"Unknown",(0,u.$Fk)(this,oe),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$jM=Ai,e.$jM=Ai=v=Je([k],Ai);let vi=class{constructor(j,oe,De){this.start=j,this.end=oe,this.kind=De}};e.$kM=vi,e.$kM=vi=Je([k],vi);var Xi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Li;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Yi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Yi||(e.CommentState=Yi={}));var wi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Mi{constructor(j,oe=[]){this.tokenTypes=j,this.tokenModifiers=oe}}e.$lM=Mi;function un(B){return typeof B>"u"||(0,g.$Jf)(B)}class Fi{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let oe=0,De=j.tokenTypes.length;oe<De;oe++)this.k.set(j.tokenTypes[oe],oe);for(let oe=0,De=j.tokenModifiers.length;oe<De;oe++)this.l.set(j.tokenModifiers[oe],oe)}}push(j,oe,De,Ge,xe){if(typeof j=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(j,oe,De,Ge,xe);if(z.isRange(j)&&typeof oe=="string"&&un(De))return this.n(j,oe,De);throw(0,T.$7)()}n(j,oe,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=j.start.line,xe=j.start.character,ut=j.end.character-j.start.character,gt=this.k.get(oe);let qt=0;if(De)for(const Zt of De){if(!this.l.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Zt);qt|=1<<ii>>>0}this.o(Ge,xe,ut,gt,qt)}o(j,oe,De,Ge,xe){if(this.f&&(j<this.c||j===this.c&&oe<this.e)){this.f=!1;const qt=this.g.length/5|0;let Zt=0,ii=0;for(let ni=0;ni<qt;ni++){let ai=this.g[5*ni],Ki=this.g[5*ni+1];ai===0?(ai=Zt,Ki+=ii):ai+=Zt,this.g[5*ni]=ai,this.g[5*ni+1]=Ki,Zt=ai,ii=Ki}}let ut=j,gt=oe;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=xe,this.c=j,this.e=oe}static q(j){const oe=[],De=j.length/5|0;for(let gt=0;gt<De;gt++)oe[gt]=gt;oe.sort((gt,qt)=>{const Zt=j[5*gt],ii=j[5*qt];if(Zt===ii){const ni=j[5*gt+1],ai=j[5*qt+1];return ni-ai}return Zt-ii});const Ge=new Uint32Array(j.length);let xe=0,ut=0;for(let gt=0;gt<De;gt++){const qt=5*oe[gt],Zt=j[qt+0],ii=j[qt+1],ni=j[qt+2],ai=j[qt+3],Ki=j[qt+4],In=Zt-xe,zn=In===0?ii-ut:ii,Hi=5*gt;Ge[Hi+0]=In,Ge[Hi+1]=zn,Ge[Hi+2]=ni,Ge[Hi+3]=ai,Ge[Hi+4]=Ki,xe=Zt,ut=ii}return Ge}build(j){return this.f?new oi(new Uint32Array(this.g),j):new oi(Fi.q(this.g),j)}}e.$mM=Fi;class oi{constructor(j,oe){this.resultId=oe,this.data=j}}e.$nM=oi;class ln{constructor(j,oe,De){this.start=j,this.deleteCount=oe,this.data=De}}e.$oM=ln;class hn{constructor(j,oe){this.resultId=oe,this.edits=j}}e.$pM=hn;var Zi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let di=class{static{this.Back={iconPath:new bt("arrow-left")}}constructor(){}};e.$qM=di,e.$qM=di=Je([k],di);var xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var _i;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var bi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(bi||(e.ExtensionKind=bi={}));class en{static validate(j){if(typeof j.badge=="string"){let oe=(0,$.$jf)(j.badge,0);if(oe<j.badge.length&&(oe+=(0,$.$jf)(j.badge,oe)),j.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!bt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,oe,De){this.badge=j,this.tooltip=oe,this.color=De}}e.$rM=en;let Ti=class{constructor(j){this.kind=j}};e.$sM=Ti,e.$sM=Ti=Je([k],Ti);var Ni;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class ei{static isNotebookRange(j){return j instanceof ei?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,oe){if(j<0)throw(0,T.$7)("start must be positive");if(oe<0)throw(0,T.$7)("end must be positive");j<=oe?(this.c=j,this.e=oe):(this.c=oe,this.e=j)}with(j){let oe=this.c,De=this.e;return j.start!==void 0&&(oe=j.start),j.end!==void 0&&(De=j.end),oe===this.c&&De===this.e?this:new ei(oe,De)}}e.$tM=ei;class yi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(oe=>yi.isNotebookCellData(oe))}static isNotebookCellData(j){return!0}constructor(j,oe,De,Ge,xe,ut,gt){this.kind=j,this.value=oe,this.languageId=De,this.mime=Ge,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,yi.validate(this)}}e.$uM=yi;class dn{constructor(j){this.cells=j}}e.$vM=dn;class Yt{static isNotebookCellOutputItem(j){return j instanceof Yt?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const oe={name:j.name,message:j.message,stack:j.stack};return Yt.json(oe,"application/vnd.code.notebook.error")}static stdout(j){return Yt.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return Yt.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,oe="application/octet-stream"){return new Yt(j,oe)}static#e=new TextEncoder;static text(j,oe=R.$fs.text){const De=Yt.#e.encode(String(j));return new Yt(De,oe)}static json(j,oe="text/x-json"){const De=JSON.stringify(j,void 0,"	");return Yt.text(De,oe)}constructor(j,oe){this.data=j,this.mime=oe;const De=(0,R.$js)(oe,!0);if(!De)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$wM=Yt;class Ei{static isNotebookCellOutput(j){return j instanceof Ei?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,oe=!1){const De=new Set,Ge=new Set;for(let xe=0;xe<j.length;xe++){const ut=j[xe],gt=(0,R.$js)(ut.mime);if(!De.has(gt)||(0,w.$0I)(gt)){De.add(gt);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?j:j.filter((xe,ut)=>!Ge.has(ut))}constructor(j,oe,De){this.items=Ei.ensureUniqueMimeTypes(j,!0),typeof oe=="string"?(this.id=oe,this.metadata=De):(this.id=(0,A.$qg)(),this.metadata=oe??De)}}e.$xM=Ei;var ki;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Oi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var ze;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ze||(e.NotebookCellStatusBarAlignment=ze={}));var ti;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class tn{constructor(j,oe){this.text=j,this.alignment=oe}}e.$yM=tn;var et;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(et||(e.NotebookControllerAffinity=et={}));var pt;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(pt||(e.NotebookControllerAffinity2=pt={}));class fn{constructor(j,oe=[]){this.uri=j,this.provides=(0,E.$3b)(oe)}}e.$zM=fn;class gn{constructor(j){this.label=j}}e.$AM=gn;var zi;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(zi||(e.NotebookVariablesRequestKind=zi={}));let ji=class{constructor(j,oe){this.label=j,this.timestamp=oe}};e.$BM=ji,e.$BM=ji=Je([k],ji);var fi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var nn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class mn{constructor(j,oe){this.ranges=j,this.wordPattern=oe}}e.$CM=mn;class sn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$DM=sn;var on;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ui=class{constructor(j=void 0,oe=void 0,De=void 0,Ge=!1){this.include=j,this.exclude=oe,this.profile=De,this.continuous=Ge}};e.$EM=Ui,e.$EM=Ui=Je([k],Ui);let Bi=y=class{static diff(j,oe,De){const Ge=new y(j);return Ge.expectedOutput=oe,Ge.actualOutput=De,Ge}constructor(j){this.message=j}};e.$FM=Bi,e.$FM=Bi=y=Je([k],Bi);let Vi=class{constructor(j){this.id=j}};e.$GM=Vi,e.$GM=Vi=Je([k],Vi);class Di{constructor(j,oe){this.covered=j,this.total=oe}}e.$HM=Di;const Wi=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class qi{static fromDetails(j,oe){const De=new Di(0,0),Ge=new Di(0,0),xe=new Di(0,0);for(const gt of oe)if("branches"in gt){De.total+=1,De.covered+=gt.executionCount>0?1:0;for(const qt of gt.branches)Ge.total+=1,Ge.covered+=qt.executionCount>0?1:0}else xe.total+=1,xe.covered+=gt.executionCount>0?1:0;const ut=new qi(j,De,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=oe,ut}constructor(j,oe,De,Ge){this.uri=j,this.statementCoverage=oe,this.branchCoverage=De,this.functionCoverage=Ge,Wi(oe),Wi(De),Wi(Ge)}}e.$IM=qi;class $n{constructor(j,oe,De=[]){this.executionCount=j,this.location=oe,this.branches=De}}e.$JM=$n;class pn{constructor(j,oe,De){this.executionCount=j,this.location=oe,this.label=De}}e.$KM=pn;class re{constructor(j,oe,De){this.name=j,this.executionCount=oe,this.location=De}}e.$LM=re;var ue;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(ue||(e.ExternalUriOpenerPriority=ue={}));var Oe;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Oe||(e.WorkspaceTrustState=Oe={}));var ot;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(ot||(e.PortAutoForwardAction=ot={}));class wt{constructor(j,oe,De,Ge,xe,ut){this.kind=j,this.name=oe,this.detail=De,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$MM=wt;class Lt{constructor(j){this.uri=j}}e.$NM=Lt;class cn{constructor(j,oe){this.original=j,this.modified=oe}}e.$OM=cn;class Cn{constructor(j,oe,De,Ge){this.base=j,this.input1=oe,this.input2=De,this.result=Ge}}e.$PM=Cn;class Pn{constructor(j,oe){this.uri=j,this.viewType=oe}}e.$QM=Pn;class Rn{constructor(j){this.viewType=j}}e.$RM=Rn;class An{constructor(j,oe){this.uri=j,this.notebookType=oe}}e.$SM=An;class Ln{constructor(j,oe,De){this.original=j,this.modified=oe,this.notebookType=De}}e.$TM=Ln;class Mn{constructor(){}}e.$UM=Mn;class Fn{constructor(j,oe){this.uri=j,this.inputBoxUri=oe}}e.$VM=Fn;class Tn{constructor(j){this.providerId=j}}e.$WM=Tn;var vn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var wn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(wn||(e.ChatAgentCopyKind=wn={}));var bn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Nn{constructor(j,oe){this.label=j,this.values=oe}}e.$XM=Nn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class On{constructor(j,oe){this.role=j,this.content=oe}}e.$YM=On;var kn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Dn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Pe[103],Re([1,0,53,12,11,294,147,7,18]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=e.$_M=void 0;const b=new Map;function A(w,s){s?b.set(w,s):b.delete(w)}e.$_M=A;function D(w){return b.get(w)}class u extends M.$lv{constructor(s,o,t,n,a,c,h,i){super(o,t,n,a),this.c=s,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,g.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===T.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,t){return s.y(o,t)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,E.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,E.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const t=this.g,n=o.start.line,a=o.end.line,c=[];c.push(this.f[n].substring(o.start.character));for(let h=n+1;h<a;h++)c.push(this.f[h]);return c.push(this.f[a].substring(0,o.end.character)),c.join(t)}t(s){let o;if(s instanceof $.$9K?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new p(o,this.f[o],o===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),t=this.f[o.index].length;return new $.$9K(o.index,Math.min(o.remainder,t))}w(s){if(!(s instanceof $.$0K))throw new Error("Invalid argument");const o=this.x(s.start),t=this.x(s.end);return o===s.start&&t===s.end?s:new $.$0K(o.line,o.character,t.line,t.character)}x(s){if(!(s instanceof $.$9K))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:o,character:t}=s,n=!1;if(o<0)o=0,t=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,t=this.f[o].length,n=!0;else{const a=this.f[o].length;t<0?(t=0,n=!0):t>a&&(t=a,n=!0)}return n?new $.$9K(o,t):s}y(s,o){const t=this.x(s);if(!o)o=D(this.m);else if((0,C.$Ye)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.$xs)(t.character+1,(0,R.$vs)(o),this.f[t.line],0);if(n)return new $.$0K(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$aN=u;class p{constructor(s,o,t){this.a=s,this.b=o,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$0K(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$0K(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$bN=p}),define(Pe[209],Re([1,0,7,17,5]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;let M=class{constructor($){this.a=new E.$sM(E.ColorThemeKind.Dark),this.b=new C.$Vd}get activeColorTheme(){return this.a}$onColorThemeChange($){let g;switch($){case"light":g=E.ColorThemeKind.Light;break;case"hcDark":g=E.ColorThemeKind.HighContrast;break;case"hcLight":g=E.ColorThemeKind.HighContrastLight;break;default:g=E.ColorThemeKind.Dark}this.a=new E.$sM(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$1hc=M,e.$1hc=M=Je([Ke(0,T.$0M)],M)}),define(Pe[210],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bJ=e.CellExecutionUpdateType=void 0;var T;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$bJ=(0,E.$6h)("INotebookExecutionService")}),define(Pe[211],Re([1,0,6,29,144,94]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQb=void 0;class R extends E.$Tc{constructor(g,b,A){super(),this._source=g,this.b=b,this.c=A,this.a=void 0}f(g){const b=g.getLineCount();return new T.$Us(1,1,b,this.g(g,b))}g(g,b){if(b<1||b>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(b)+1}get inputTextBuffer(){if(!this.b){const g=new C.$cC;g.acceptChunk(this._source);const b=g.finish(!0),{textBuffer:A,disposable:D}=b.create(1);this.b=A,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const b=new C.$cC;b.acceptChunk(g);const A=b.finish(!0),{textBuffer:D,disposable:u}=A.create(1);return this.B(u),D})),this.a}findInInputs(g){const A=new M.$3B(g,!1,!1,null).parseSearchRequest();if(!A)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,A,!0,5e3)}findInOutputs(g){const A=new M.$3B(g,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(D=>{const u=D.findMatchesLineByLine(this.f(D),A,!0,5e3);if(u.length!==0)return{textBuffer:D,matches:u}}).filter(D=>!!D):[]}}e.$KQb=R}),define(Pe[48],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class C{static fromExtHostTestItem(R,$,g=R.parent){if(R._isRoot)return new C([$]);const b=[R.id];for(let A=g;A&&A.id!==$;A=A.parent)b.push(A.id);return b.push($),new C(b.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new C(R.split("\0"))}static join(R,$){return new C([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:C.isChild(R,$)?2:C.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new C(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new C(this.path,R)}compare(R){if(typeof R=="string")return C.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$XJ=C}),define(Pe[58],Re([1,0,2,92,29,48]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$5J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$4J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$3J=e.$2J=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$1J=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$ZJ=e.$YJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var $;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})($||(e.ExtTestRunProfileKind=$={}));var g;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$YJ=[2,4,8,16,32,64];const b=P=>"runId"in P;e.$ZJ=b;var A;(function(P){P.serialize=I=>({range:I.range.toJSON(),uri:I.uri.toJSON()}),P.deserialize=(I,H)=>({range:C.$Us.lift(H.range),uri:I.asCanonicalUri(E.URI.revive(H.uri))})})(A||(e.IRichLocation=A={}));var D;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(D||(e.TestMessageType=D={}));var u;(function(P){P.serialize=I=>({message:I.message,type:0,expected:I.expected,actual:I.actual,contextValue:I.contextValue,location:I.location&&A.serialize(I.location)}),P.deserialize=(I,H)=>({message:H.message,type:0,expected:H.expected,actual:H.actual,contextValue:H.contextValue,location:H.location&&A.deserialize(I,H.location)})})(u||(e.ITestErrorMessage=u={}));const p=(P,I)=>`${I?"s":"e"}${P}`;e.$1J=p;var w;(function(P){P.serialize=I=>({message:I.message,type:1,offset:I.offset,length:I.length,location:I.location&&A.serialize(I.location)}),P.deserialize=(I,H)=>({message:H.message,type:1,offset:H.offset,length:H.length,location:H.location&&A.deserialize(I,H.location)})})(w||(e.ITestOutputMessage=w={}));var s;(function(P){P.serialize=I=>I.type===0?u.serialize(I):w.serialize(I),P.deserialize=(I,H)=>H.type===0?u.deserialize(I,H):w.deserialize(I,H)})(s||(e.ITestMessage=s={}));var o;(function(P){P.serializeWithoutMessages=I=>({state:I.state,duration:I.duration,messages:[]}),P.serialize=I=>({state:I.state,duration:I.duration,messages:I.messages.map(s.serialize)}),P.deserialize=(I,H)=>({state:H.state,duration:H.duration,messages:H.messages.map(ae=>s.deserialize(I,ae))})})(o||(e.ITestTaskState=o={}));const t="\0",n=(P,I)=>P+t+I;e.$2J=n;const a=P=>{const I=P.indexOf(t);return{ctrlId:P.slice(0,I),tagId:P.slice(I+1)}};e.$3J=a;var c;(function(P){P.serialize=I=>({extId:I.extId,label:I.label,tags:I.tags,busy:I.busy,children:void 0,uri:I.uri?.toJSON(),range:I.range?.toJSON()||null,description:I.description,error:I.error,sortText:I.sortText}),P.deserialize=(I,H)=>({extId:H.extId,label:H.label,tags:H.tags,busy:H.busy,children:void 0,uri:H.uri?I.asCanonicalUri(E.URI.revive(H.uri)):void 0,range:H.range?C.$Us.lift(H.range):null,description:H.description,error:H.error,sortText:H.sortText})})(c||(e.ITestItem=c={}));var h;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(P){P.serialize=I=>({expand:I.expand,item:c.serialize(I.item)}),P.deserialize=(I,H)=>({controllerId:M.$XJ.root(H.item.extId),expand:H.expand,item:c.deserialize(I,H.item)})})(i||(e.InternalTestItem=i={}));var l;(function(P){P.serialize=I=>{let H;return I.item&&(H={},I.item.label!==void 0&&(H.label=I.item.label),I.item.tags!==void 0&&(H.tags=I.item.tags),I.item.busy!==void 0&&(H.busy=I.item.busy),I.item.uri!==void 0&&(H.uri=I.item.uri?.toJSON()),I.item.range!==void 0&&(H.range=I.item.range?.toJSON()),I.item.description!==void 0&&(H.description=I.item.description),I.item.error!==void 0&&(H.error=I.item.error),I.item.sortText!==void 0&&(H.sortText=I.item.sortText)),{extId:I.extId,expand:I.expand,item:H}},P.deserialize=I=>{let H;return I.item&&(H={},I.item.label!==void 0&&(H.label=I.item.label),I.item.tags!==void 0&&(H.tags=I.item.tags),I.item.busy!==void 0&&(H.busy=I.item.busy),I.item.range!==void 0&&(H.range=I.item.range?C.$Us.lift(I.item.range):null),I.item.description!==void 0&&(H.description=I.item.description),I.item.error!==void 0&&(H.error=I.item.error),I.item.sortText!==void 0&&(H.sortText=I.item.sortText)),{extId:I.extId,expand:I.expand,item:H}}})(l||(e.ITestItemUpdate=l={}));const r=(P,I)=>{I.expand!==void 0&&(P.expand=I.expand),I.item!==void 0&&(P.item=P.item?Object.assign(P.item,I.item):I.item)};e.$4J=r;var d;(function(P){P.serializeWithoutMessages=I=>({...i.serialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(o.serializeWithoutMessages)}),P.serialize=I=>({...i.serialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(o.serialize)}),P.deserialize=(I,H)=>({...i.deserialize(I,H),ownComputedState:H.ownComputedState,computedState:H.computedState,tasks:H.tasks.map(ae=>o.deserialize(I,ae)),retired:!0})})(d||(e.TestResultItem=d={}));var m;(function(P){P.empty=()=>({covered:0,total:0}),P.sum=(I,H)=>{I.covered+=H.covered,I.total+=H.total}})(m||(e.ICoveredCount=m={}));var f;(function(P){P.serialize=I=>({statement:I.statement,branch:I.branch,function:I.function,details:I.details?.map(y.serialize),uri:I.uri.toJSON()}),P.deserialize=(I,H)=>({statement:H.statement,branch:H.branch,function:H.function,details:H.details?.map(y.deserialize),uri:I.asCanonicalUri(E.URI.revive(H.uri))})})(f||(e.IFileCoverage=f={}));function S(P){return{...P,location:P.location?.toJSON()}}function L(P){return P.location=P.location?T.$Ts.isIPosition(P.location)?T.$Ts.lift(P.location):C.$Us.lift(P.location):void 0,P}e.$5J=3;var v;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement",P[P.Branch=2]="Branch"})(v||(e.DetailType=v={}));var y;(function(P){P.serialize=I=>I.type===0?N.serialize(I):O.serialize(I),P.deserialize=I=>I.type===0?N.deserialize(I):O.deserialize(I)})(y||(e.CoverageDetails=y={}));var k;(function(P){P.serialize=S,P.deserialize=L})(k||(e.IBranchCoverage=k={}));var N;(function(P){P.serialize=S,P.deserialize=L})(N||(e.IFunctionCoverage=N={}));var O;(function(P){P.serialize=I=>({...S(I),branches:I.branches?.map(k.serialize)}),P.deserialize=I=>({...L(I),branches:I.branches?.map(k.deserialize)})})(O||(e.IStatementCoverage=O={}));var G;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var W;(function(P){P.deserialize=(I,H)=>H.op===0?{op:H.op,item:i.deserialize(I,H.item)}:H.op===1?{op:H.op,item:l.deserialize(H.item)}:H.op===2?{op:H.op,uri:I.asCanonicalUri(E.URI.revive(H.uri)),docv:H.docv}:H,P.serialize=I=>I.op===0?{op:I.op,item:i.serialize(I.item)}:I.op===1?{op:I.op,item:l.serialize(I.item)}:I})(W||(e.TestsDiffOp=W={}));class z{constructor(I){this.k=I,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(I){const H=this.v();for(const ae of I)switch(ae.op){case 0:this.l(i.deserialize(this.k,ae.item),H);break;case 1:this.o(l.deserialize(ae.item),H);break;case 3:this.p(ae.itemId,H);break;case 5:this.q(ae.itemId);break;case 4:this.updatePendingRoots(ae.amount);break;case 6:this.c.set(ae.tag.id,ae.tag);break;case 7:this.c.delete(ae.id);break}H.complete?.()}l(I,H){const ae=M.$XJ.parentId(I.item.extId)?.toString();let de;if(!ae)de=this.w(I),this.g.add(de),this.f.set(I.item.extId,de);else if(this.f.has(ae)){const we=this.f.get(ae);we.children.add(I.item.extId),de=this.w(I,we),this.f.set(I.item.extId,de)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(I)}`);return}return H.add?.(de),I.expand===2&&this.h++,de}o(I,H){const ae=this.f.get(I.extId);if(ae)return I.expand!==void 0&&(ae.expand===2&&this.h--,I.expand===2&&this.h++),(0,e.$4J)(ae,I),H.update?.(ae),ae}p(I,H){const ae=this.f.get(I);if(!ae)return;const de=M.$XJ.parentId(ae.item.extId)?.toString();de?this.f.get(de).children.delete(ae.item.extId):this.g.delete(ae);const we=[[I]];for(;we.length;)for(const ke of we.pop()){const le=this.f.get(ke);le&&(we.push(le.children),this.f.delete(ke),H.remove?.(le,le!==ae),le.expand===2&&this.h--)}}q(I){}updatePendingRoots(I){this.j+=I}v(){return{}}}e.$6J=z}),define(Pe[77],Re([1,0,13,5,6,53,58,48]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.TestItemEventOp=void 0;var g;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const b=(n,a)=>n===a,D=Object.entries({range:(n,a)=>n===a?!0:!n||!a?!1:n.equalsRange(a),busy:b,label:b,description:b,error:b,sortText:b,tags:(n,a)=>!(n.length!==a.length||n.some(c=>!a.includes(c)))}),u=(n,a)=>{let c;for(const[h,i]of D)i(n[h],a[h])||(c?c[h]=a[h]:c={[h]:a[h]});return c};class p extends C.$Tc{get root(){return this.s.root}constructor(a){super(),this.s=a,this.f=this.B(new E.$fh(()=>this.flushDiff(),200)),this.g=this.B(new T.$Vd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(a){this.h=a;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const a=this.m;return this.m=[],a}pushDiff(a){switch(a.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===a.uri){c.docv=a.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===a.item.extId){(0,R.$4J)(c.item,a.item);return}if(c.op===0&&c.item.item.extId===a.item.extId){(0,R.$4J)(c.item,a.item);return}}break}}this.m.push(a),this.f.isScheduled()||this.f.schedule()}expand(a,c){const h=this.tree.get(a);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const a of this.tree.values())this.s.getApiFor(a.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(a,c){switch(c.op){case 3:this.O($.$XJ.joinToString(a.fullId,c.id));break;case 0:this.z(c.item,a);break;case 5:for(const h of c.ops)this.w(a,h);break;case 1:this.C(c.new,c.old,a.fullId.toString());break;case 2:this.J(a);break;case 4:this.pushDiff({op:1,item:{extId:a.fullId.toString(),item:c.update}});break;case 6:this.y(a.actual.uri);break;default:(0,M.$6c)(c)}}y(a){a&&this.pushDiff({op:2,uri:a,docv:this.s.getDocumentVersion(a)})}z(a,c){const h=$.$XJ.fromExtHostTestItem(a,this.root.id,c?.actual),i=this.s.getApiFor(a);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(a.id);let l=this.tree.get(h.toString());if(!l){l={fullId:h,actual:a,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},a.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(a,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(a)}}),this.I(a,l,c);return}if(l.actual===a){this.H(a,l,c);return}if(l.actual.uri?.toString()!==a.uri?.toString())return this.O(h.toString()),this.z(a,c);const r=this.s.getChildren(l.actual),d=l.actual,m=u(this.s.toITestItem(d),this.s.toITestItem(a));this.s.getApiFor(d).listener=void 0,l.actual=a,l.expand=0,m&&(m.hasOwnProperty("tags")&&(this.C(a.tags,d.tags,h.toString()),delete m.tags),this.w(l,{op:4,update:m})),this.I(a,l,c);for(const[f,S]of r)this.s.getChildren(a).get(S.id)||this.O($.$XJ.joinToString(h,S.id));this.y(l.actual.uri)}C(a,c,h){const i=new Set(c.map(l=>l.id));for(const l of a)i.delete(l.id)||this.D(l);this.pushDiff({op:1,item:{extId:h,item:{tags:a.map(l=>(0,R.$2J)(this.s.controllerId,l.id))}}}),i.forEach(this.F,this)}D(a){const c=this.j.get(a.id);c?c.refCount++:(this.j.set(a.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$2J)(this.s.controllerId,a.id)}}))}F(a){const c=this.j.get(a);c&&!--c.refCount&&(this.j.delete(a),this.pushDiff({op:7,id:(0,R.$2J)(this.s.controllerId,a)}))}G(a,c){this.s.getApiFor(a).parent=c&&c.actual!==this.root?c.actual:void 0}H(a,c,h){this.G(a,h);const i=this.s.getApiFor(a);i.parent=h?.actual,i.listener=l=>this.w(c,l),this.J(c)}I(a,c,h){this.H(a,c,h);for(const[i,l]of this.s.getChildren(a))this.z(l,c)}J(a){let c;this.h?a.resolveBarrier?c=a.resolveBarrier.isOpen()?3:2:c=a.actual.canResolveChildren?1:0:c=0,c!==a.expand&&(a.expand=c,this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:c}}),c===1&&a.expandLevels!==void 0&&this.M(a))}L(a,c){if(c<0)return;const h=[];for(const[i,l]of this.s.getChildren(a.actual)){const r=this.expand($.$XJ.joinToString(a.fullId,l.id),c);(0,E.$Sg)(r)&&h.push(r)}if(h.length)return Promise.all(h).then(()=>{})}M(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this.h){const l=new E.$5g;return l.open(),l}a.expand=2,this.N(a);const c=a.resolveBarrier=new E.$5g,h=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let i;try{i=this.h(a.actual===this.root?void 0:a.actual)}catch(l){h(l)}return(0,E.$Sg)(i)?i.catch(h).then(()=>{c.open(),this.J(a)}):(c.open(),this.J(a)),a.resolveBarrier}N(a){this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:a.expand}})}O(a){const c=this.tree.get(a);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:a});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const l of i.actual.tags)this.F(l.id);this.tree.delete(i.fullId.toString());for(const[l,r]of this.s.getChildren(i.actual))h.push(this.tree.get($.$XJ.joinToString(i.fullId,r.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.g.fire(a)}}e.$ZM=p;class w extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.$1M=w;class s extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$2M=s;class o extends Error{constructor(a,c,h){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$3M=o;const t=(n,a,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,l){for(const r of h.values())i.call(l,r,this)},[Symbol.iterator](){return h.entries()},replace(i){const l=new Map,r=new Set(h.keys()),d={op:5,ops:[]};for(const m of i){if(!(m instanceof c))throw new s(m.id);const f=a(m).controllerId;if(f!==n.controllerId)throw new o(m.id,f,n.controllerId);if(l.has(m.id))throw new w(m.id);l.set(m.id,m),r.delete(m.id),d.ops.push({op:0,item:m})}for(const m of r.keys())d.ops.push({op:3,id:m});n.listener?.(d),h=l},add(i){if(!(i instanceof c))throw new s(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$4M=t}),define(Pe[104],Re([1,0,77]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=void 0;const T=new WeakMap,C=(R,$)=>{const g={controllerId:$};return T.set(R,g),g};e.$5M=C;const M=R=>{const $=T.get(R);if(!$)throw new E.$2M(R?.id||"<unknown>");return $};e.$6M=M}),define(Pe[78],Re([1,0,12,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xvb=e.$wvb=e.$vvb=e.$uvb=e.$tvb=void 0,e.$tvb="vscode-cdn.net",e.$uvb=`vscode-resource.${e.$tvb}`,e.$vvb=`'self' https://*.${e.$tvb}`;function C($,g){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(g&&g.authority&&g.isRemote&&$.scheme===E.Schemas.file&&($=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:g.authority,path:$.path})),T.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$uvb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$wvb=C;function M($){return $.replace(/./g,g=>{const b=g.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?g:"-"+b.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(g,b)=>String.fromCharCode(parseInt(b,16)))}e.$xvb=R}),define(Pe[212],Re([1,0,5,6,78]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class M{constructor($,g,b){this.d=$,this.e=g,this.f=b,this.a=0,this.b=new T.$Sc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const A=g.getVisibleTextEditors();for(const D of this.c.values())A.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,g,b,A,D){let u;for(const a of this.e.getVisibleTextEditors(!0))if(a.value===$){u=a;break}if(!u)throw new Error("not a visible editor");const p=this,w=this.a++,s=new E.$Vd,o=new E.$Vd,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(a){return(0,C.$wvb)(a,p.f)}get cspSource(){return C.$vvb}set options(a){this.b=a,p.d.$setOptions(w,a)}get options(){return this.b}set html(a){this.a=a,p.d.$setHtml(w,a)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(a){return p.d.$postMessage(w,a)}},n=new class{constructor(){this.editor=$,this.line=g,this.height=b,this.webview=t,this.onDidDispose=o.event}dispose(){p.c.has(w)&&(p.c.delete(w),p.d.$disposeEditorInset(w),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(w,u.id,u.value.document.uri,g+1,b,A||{},D.identifier,D.extensionLocation),this.c.set(w,{editor:$,inset:n,onDidReceiveMessage:s}),n}$onDidDispose($){const g=this.c.get($);g&&g.inset.dispose()}$onDidReceiveMessage($,g){this.c.get($)?.onDidReceiveMessage.fire(g)}}e.$kgc=M}),define(Pe[213],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=e.VariableKind=e.$VN=void 0,e.$VN=(0,E.$6h)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator",M.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class C extends Error{constructor(R,$){super($),this.variable=R}}e.$WN=C}),define(Pe[214],Re([1,0,19,74,16,26,21,95,176,213,11]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,w,s,o){this.h=new Map,this.a=p,this.b=w,this.g=s,o&&(this.c=o.then(t=>this.i(t)))}i(p){if(R.$i){const w=Object.create(null);return Object.keys(p).forEach(s=>{w[s.toLowerCase()]=p[s]}),w}return p}resolveWithEnvironment(p,w,s){return this.l({env:this.i(p),userHome:void 0},w?w.uri:void 0,s)}async resolveAsync(p,w){const s={env:await this.c,userHome:await this.g};return this.l(s,p?p.uri:void 0,w)}async j(p,w,s,o){const t=M.$vn(w);R.$i&&t.windows?Object.keys(t.windows).forEach(a=>t[a]=t.windows[a]):R.$j&&t.osx?Object.keys(t.osx).forEach(a=>t[a]=t.osx[a]):R.$k&&t.linux&&Object.keys(t.linux).forEach(a=>t[a]=t.linux[a]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,t,s,o)}async resolveAnyAsync(p,w,s){return this.j(p,w,s)}async resolveAnyMap(p,w,s){const o=new Map;return{newConfig:await this.j(p,w,s,o),resolvedVariables:o}}resolveWithInteractionReplace(p,w,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,w,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,w){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,w)}async l(p,w,s,o,t){if(C.$If(s))return this.m(p,w,s,o,t);if(Array.isArray(s))return Promise.all(s.map(n=>this.l(p,w,n,o,t)));if(C.$Kf(s)){const n=Object.create(null),a=await Promise.all(Object.keys(s).map(async c=>[await this.m(p,w,c,o,t),await this.l(p,w,s[c],o,t)]));for(const[c,h]of a)n[c]=h;return n}return s}m(p,w,s,o,t){return(0,A.$4e)(s,D.VARIABLE_REGEXP,async(n,a)=>{if(a.includes(D.VARIABLE_LHS))return n;let c=await this.o(p,n,a,w,o);return t?.set(a,c),c!==n&&C.$If(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.m(p,w,c,o,t)),c})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,w,s,o,t){let n;const a=s.split(":");a.length>1&&(s=a[0],n=a[1]);const c=l=>{const r=this.a.getFilePath();if(r)return(0,$.$Wv)(r);throw new b.$WN(l,(0,g.localize)(0,null,w))},h=l=>{const r=c(l);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,$.$Wv)(d)}throw new b.$WN(l,(0,g.localize)(1,null,w,E.$nc(r)))},i=l=>{if(n){const r=this.a.getFolderUri(n);if(r)return r;throw new b.$WN(l,(0,g.localize)(2,null,w,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new b.$WN(l,(0,g.localize)(3,null,w)):new b.$WN(l,(0,g.localize)(4,null,w))};switch(s){case"env":if(n){if(p.env){const l=p.env[R.$i?n.toLowerCase():n];if(C.$If(l))return l}return""}throw new b.$WN(b.VariableKind.Env,(0,g.localize)(5,null,w));case"config":if(n){const l=this.a.getConfigurationValue(o,n);if(C.$Rf(l))throw new b.$WN(b.VariableKind.Config,(0,g.localize)(6,null,w,n));if(C.$Kf(l))throw new b.$WN(b.VariableKind.Config,(0,g.localize)(7,null,w,n));return l}throw new b.$WN(b.VariableKind.Config,(0,g.localize)(8,null,w));case"command":return this.p(b.VariableKind.Command,w,n,t,"command");case"input":return this.p(b.VariableKind.Input,w,n,t,"input");case"extensionInstallFolder":if(n){const l=await this.a.getExtension(n);if(!l)throw new b.$WN(b.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,w,n));return this.n(l.extensionLocation)}throw new b.$WN(b.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,w));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,$.$Wv)(this.n(i(b.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,$.$Wv)(this.n(i(b.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Wv)(E.$nc(this.n(i(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new b.$WN(b.VariableKind.UserHome,(0,g.localize)(11,null,w))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new b.$WN(b.VariableKind.LineNumber,(0,g.localize)(12,null,w))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new b.$WN(b.VariableKind.SelectedText,(0,g.localize)(13,null,w))}case"file":return c(b.VariableKind.File);case"fileWorkspaceFolder":return h(b.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(h(b.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?E.$lc(this.n(i(b.VariableKind.RelativeFile)),c(b.VariableKind.RelativeFile)):c(b.VariableKind.RelativeFile);case"relativeFileDirname":{const l=E.$mc(c(b.VariableKind.RelativeFileDirname));if(o||n){const r=E.$lc(this.n(i(b.VariableKind.RelativeFileDirname)),l);return r.length===0?".":r}return l}case"fileDirname":return E.$mc(c(b.VariableKind.FileDirname));case"fileExtname":return E.$oc(c(b.VariableKind.FileExtname));case"fileBasename":return E.$nc(c(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=E.$nc(c(b.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-E.$oc(l).length)}case"fileDirnameBasename":return E.$nc(E.$mc(c(b.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||w}case"execInstallFolder":{const l=this.a.getAppRoot();return l||w}case"pathSeparator":case"/":return E.sep;default:try{const l=n?`${s}:${n}`:s;return this.p(b.VariableKind.Unknown,w,l,t,void 0)}catch{return w}}}}p(p,w,s,o,t){if(s&&o){const n=t===void 0?o[s]:o[t+":"+s];if(typeof n=="string")return n;throw new b.$WN(p,(0,g.localize)(14,null,w))}return w}}e.$$N=D}),define(Pe[105],Re([1,0,4,102]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.OpenEditorContext=e.GroupsOrder=e.$0C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9C=void 0,e.$9C=(0,E.$6h)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var M;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var g;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function b(w){const s=w;return(0,T.$SE)(s?.editor)&&(0,T.$SE)(s?.replacement)}e.$0C=b;var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var D;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u(w){const s=w;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.$$C=u;function p(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_C=p}),define(Pe[215],Re([1,0,4,105]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=void 0,e.$aD=(0,E.$6h)("editorService"),e.$bD=-1,e.$cD=-2,e.$dD=-3;function C(M){const R=M;return typeof M=="number"||(0,T.$$C)(R)}e.$eD=C}),define(Pe[216],Re([1,0,4,183]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=void 0,e.$qK=(0,E.$7h)(T.$ai)}),define(Pe[106],Re([1,0,22,5,19,6]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j8b=e.$i8b=e.$h8b=e.$g8b=e.$f8b=void 0;class R{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$f8b=R;class ${static isHostExtension(t,n,a){if(n.getExtensionDescription(t))return!1;const c=a.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,n){this.j=t,this.c=new T.$Vd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(w),this.f=new E.$nm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const a of n)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=s(this.e,n),this.e=this.e.concat(t);const a=$.l(this.e);return this.e=s(this.e,a.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,a)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,r){this.addNode(l),this.addNode(r),this.c.has(l)?this.c.get(l).push(r):this.c.set(l,[r])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,r){const d=n.getArcs(l);for(let m=0;m<d.length;m++)if(!r.has(d[m]))return!1;return!0}getNodes(){return this.e}},a=new E.$nm;for(const l of t)if(a.set(l.identifier,l),l.extensionDependencies)for(const r of l.extensionDependencies)n.addArc(E.$lm.toKey(l.identifier),E.$lm.toKey(r));const c=new Set;n.getNodes().filter(l=>n.getArcs(l).length===0).forEach(l=>c.add(l));const h=n.getNodes().filter(l=>!c.has(l));let i;do{i=!1;for(let l=0;l<h.length;l++){const r=h[l];n.hasOnlyGoodArcs(r,c)&&(h.splice(l,1),l--,c.add(r),i=!0)}}while(i);return h.map(l=>a.get(l))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$g8b=$;class g{constructor(t,n){this.versionId=t,this.extensions=n}}e.$h8b=g;class b{constructor(t){this.d=new u,this.c=new $(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new A(this,n)}deltaExtensions(t,n,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,a)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$i8b=b;class A extends M.$Tc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$j8b=A;class D{constructor(t){this.name=t,this.promise=new Promise((n,a)=>{this.c=n})}resolve(t){this.c(t)}}class u{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new D(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const a=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(a),n=!1,this.d=!1,this.e())};t.resolve((0,M.$Rc)(c))}}var p;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(p||(p={}));function w(o,t){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==a)return n-a;const c=C.$gc.basename(o.extensionLocation.path),h=C.$gc.basename(t.extensionLocation.path);return c<h?-1:c>h?1:0}function s(o,t){const n=new E.$mm(t);return o.filter(a=>!n.has(a.identifier))}}),define(Pe[79],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$um=e.$tm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(T||(e.UIKind=T={}));var C;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var M;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(b){const A=E.$je.alloc(1);switch(b){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$tm=R;function $(b,A){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$um=$;var g;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Pe[59],Re([1,0,4,5,14,27,79,55,56,26,2,6,164]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=e.$pN=e.$oN=void 0;let p=class extends D.$Tc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new T.$Vd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Vd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:g.$Po,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(a=>{(0,C.$pj)(a)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,a){const c=this.getTelemetryDetails(),h=new w(n,a,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,n,a){this.f=t,this.g=n,this.c=a??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$bl)((0,g.$Wo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((a,c)=>{const h=a.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(a=>{for(const c of a)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$oN=p,e.$oN=p=Je([Ke(0,M.$nN),Ke(1,C.$oj)],p);class w{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,a,c,h,i,l){this.g=a,this.h=c,this.i=h,this.j=i,this.a=new T.$Vd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,g.$Zo)(n,[]),this.c&&(n=(0,b.$yn)(n,this.c)),this.b||(n=(0,b.$yn)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const a={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,g.$Zo)(a,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$pN=w;function s(o){const t=Date.now()-new Date(o).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$qN=s,e.$rN=(0,E.$6h)("IExtHostTelemetry")}),define(Pe[23],Re([1,0,5,2,192,101,22,4]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.ActivationKind=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.ExtensionHostStartup=e.$zF=e.$yF=e.$xF=e.$wF=void 0,e.$wF=Object.freeze({identifier:new R.$lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$xF="extensions.webWorker",e.$yF=(0,$.$6h)("extensionService");class g{constructor(h){this.dependency=h}}e.$zF=g;var b;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,l){this.c=h,this.d=i.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$hF.createActivationEventsMap(this.d)}}set(h,i,l){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const r=[],d=[],m=[],f=[],S=D(this.d),L=D(i),v=(G,W)=>G.extensionLocation.toString()===W.extensionLocation.toString()||G.isBuiltin===W.isBuiltin||G.isUserBuiltin===W.isUserBuiltin||G.isUnderDevelopment===W.isUnderDevelopment;for(const G of this.d){const W=L.get(G.identifier);if(!W){r.push(G.identifier),S.delete(G.identifier);continue}if(!v(G,W)){r.push(G.identifier),S.delete(G.identifier);continue}}for(const G of i){const W=S.get(G.identifier);if(!W){d.push(G);continue}if(!v(W,G)){r.push(W.identifier),S.delete(W.identifier);continue}}const y=new R.$mm(this.e),k=new R.$mm(l);for(const G of this.e)k.has(G)||m.push(G);for(const G of l)y.has(G)||f.push(G);const N=M.$hF.createActivationEventsMap(d),O={versionId:h,toRemove:r,toAdd:d,addActivationEvents:N,myToRemove:m,myToAdd:f};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:l,myToRemove:r,myToAdd:d}=h,m=new R.$mm(i),f=new R.$mm(r);for(let S=0;S<this.d.length;S++)m.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)f.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of l)this.d.push(S);for(const S of d)this.e.push(S);return this.f=null,h}containsExtension(h){for(const i of this.e)if(R.$lm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const l=M.$hF.readActivationEvents(i);for(const r of l)h.add(r)}return h}}e.$AF=A;function D(c){const h=new R.$nm;for(const i of c)h.set(i.identifier,i);return h}function u(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$BF=u;function p(c,h){if(!u(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$CF=p;class w{constructor(h,i,l,r){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=l,this.activationReason=r}}e.$DF=w;class s{constructor(h,i){this.description=h,this.value=i}}e.$EF=s;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.$6o)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$FF=t;function n(c,h){return{identifier:new R.$lm((0,C.$4o)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$GF=n;class a{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$HF=a}),define(Pe[217],Re([1,0,15,106,22,23,14,13]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=e.$Kgc=e.$Jgc=e.$Igc=e.$Hgc=e.$Ggc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(t,n,a,c){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=a,this.activateResolvedTime=c}}e.$Ggc=g;class b{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Hgc=b;class A{constructor(t,n,a,c,h,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=a,this.module=c,this.exports=h,this.subscriptions=i}}e.$Igc=A;class D extends A{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Jgc=D;class u extends A{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Kgc=u;class p extends A{constructor(t){super(!0,t,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(t,n,a,c){this.g=c,this.a=t,this.b=n,this.c=a,this.d=new C.$nm,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,a]of this.d)t.push(a.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const a=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(a.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const a=this.a.getExtensionDescription(t);if(!a)throw new Error(`Extension '${t}' is not known`);return this.h([{id:a.identifier,reason:n}])}async h(t){const n=t.filter(a=>!this.isActivated(a.id)).map(a=>this.j(a));await Promise.all(n.map(a=>a.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new p(h));return this.c.onExtensionActivationError(t.id,h,new M.$zF(t.id.value)),i}const a=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){a.push(i);continue}if(this.l(h)){a.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const l=this.a.getExtensionDescription(h);if(l){if(!l.main&&!l.browser)continue;a.push(this.j({id:l.identifier,reason:t.reason}));continue}const r=n.displayName||n.identifier.value,d=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${h}'`),m=this.k(t,n.displayName,[],new p(d));return this.c.onExtensionActivationError(n.identifier,d,new M.$zF(h)),m}return this.k(t,n.displayName,a,null)}k(t,n,a,c){const h=new s(t.id,n,t.reason,a,c,this.c,this.g);return this.d.set(t.id,h),h}l(t){return T.$g8b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$Lgc=w,e.$Lgc=w=Je([Ke(3,R.$nj)],w);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,a,c,h,i,l){this.c=t,this.d=n,this.f=a,this.g=c,this.h=h,this.j=i,this.k=l,this.a=new $.$5g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);a.detail=n.value.activationFailedError,this.h=new p(a),this.j.onExtensionActivationError(this.c,a,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new p(n),this.b&&E.$4(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};s=Je([Ke(6,R.$nj)],s)}),define(Pe[8],Re([1,0,18,24,127,218,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,215,23,7]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c,h,i,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$9M=e.$8M=e.MarkdownString=e.$7M=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Se){function Fe(J){const{selectionStartLineNumber:Me,selectionStartColumn:Ue,positionLineNumber:Xe,positionColumn:We}=J,_e=new r.$9K(Me-1,Ue-1),mt=new r.$9K(Xe-1,We-1);return new r.$$K(_e,mt)}Se.to=Fe;function fe(J){const{anchor:Me,active:Ue}=J;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Se.from=fe})(d||(e.Selection=d={}));var m;(function(Se){function Fe(J){if(!J)return;const{start:Me,end:Ue}=J;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Se.from=Fe;function fe(J){if(!J)return;const{startLineNumber:Me,startColumn:Ue,endLineNumber:Xe,endColumn:We}=J;return new r.$0K(Me-1,Ue-1,Xe-1,We-1)}Se.to=fe})(m||(e.Range=m={}));var f;(function(Se){function Fe(fe){switch(fe){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Se.to=Fe})(f||(e.TokenType=f={}));var S;(function(Se){function Fe(J){return new r.$9K(J.lineNumber-1,J.column-1)}Se.to=Fe;function fe(J){return{lineNumber:J.line+1,column:J.character+1}}Se.from=fe})(S||(e.Position=S={}));var L;(function(Se){function Fe(Me,Ue,Xe){return(0,E.$Hb)((0,E.$3b)(Me).map(We=>fe(We,Ue,Xe)))}Se.from=Fe;function fe(Me,Ue,Xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:J(Me.scheme,Ue),pattern:Z.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Xe?.isBuiltin}}function J(Me,Ue){return Ue&&typeof Me=="string"?Ue.transformOutgoingScheme(Me):Me}})(L||(e.DocumentSelector=L={}));var v;(function(Se){function Fe(J){switch(J){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Se.from=Fe;function fe(J){switch(J){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Se.to=fe})(v||(e.DiagnosticTag=v={}));var y;(function(Se){function Fe(J){let Me;return J.code&&((0,u.$If)(J.code)||(0,u.$Mf)(J.code)?Me=String(J.code):Me={value:String(J.code.value),target:J.code.target}),{...m.from(J.range),message:J.message,source:J.source,code:Me,severity:N.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(k.from),tags:Array.isArray(J.tags)?(0,E.$Hb)(J.tags.map(v.from)):void 0}}Se.from=Fe;function fe(J){const Me=new r.$jL(m.to(J),J.message,N.to(J.severity));return Me.source=J.source,Me.code=(0,u.$If)(J.code)?J.code:J.code?.value,Me.relatedInformation=J.relatedInformation&&J.relatedInformation.map(k.to),Me.tags=J.tags&&(0,E.$Hb)(J.tags.map(v.to)),Me}Se.to=fe})(y||(e.Diagnostic=y={}));var k;(function(Se){function Fe(J){return{...m.from(J.location.range),message:J.message,resource:J.location.uri}}Se.from=Fe;function fe(J){return new r.$iL(new r.$hL(J.resource,m.to(J)),J.message)}Se.to=fe})(k||(e.DiagnosticRelatedInformation=k={}));var N;(function(Se){function Fe(J){switch(J){case r.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Se.from=Fe;function fe(J){switch(J){case o.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Se.to=fe})(N||(e.DiagnosticSeverity=N={}));var O;(function(Se){function Fe(J){return typeof J=="number"&&J>=r.ViewColumn.One?J-1:J===r.ViewColumn.Beside?i.$cD:i.$bD}Se.from=Fe;function fe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=fe})(O||(e.ViewColumn=O={}));function G(Se){return typeof Se.range<"u"}function W(Se){return Se.length===0?!0:!!G(Se[0])}e.$7M=W;var z;(function(Se){function Fe(We){return We.map(Se.from)}Se.fromMany=Fe;function fe(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function J(We){let _e;if(fe(We)){const{language:St,value:bt}=We;_e={value:"```"+St+`
`+bt+"\n```\n"}}else r.$wL.isMarkdownString(We)?_e={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?_e={value:We}:_e={value:""};const mt=Object.create(null);_e.uris=mt;const Ut=St=>{try{let bt=p.URI.parse(St,!0);bt=bt.with({query:Me(bt.query,mt)}),mt[St]=bt}catch{}return""},Et=new g.marked.Renderer;return Et.link=Ut,Et.image=St=>typeof St=="string"?Ut(R.$pk(St).href):"",(0,g.marked)(_e.value,{renderer:Et}),_e}Se.from=J;function Me(We,_e){if(!We)return We;let mt;try{mt=(0,b.$Bh)(We)}catch{}if(!mt)return We;let Ut=!1;return mt=(0,D.$xn)(mt,Et=>{if(p.URI.isUri(Et)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[St]=Et,Ut=!0,St}else return}),Ut?JSON.stringify(mt):We}function Ue(We){const _e=new r.$wL(We.value,We.supportThemeIcons);return _e.isTrusted=We.isTrusted,_e.supportHtml=We.supportHtml,_e.baseUri=We.baseUri?p.URI.from(We.baseUri):void 0,_e}Se.to=Ue;function Xe(We){if(We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=Xe})(z||(e.MarkdownString=z={}));function P(Se){return W(Se)?Se.map(Fe=>({range:m.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?z.fromMany(Fe.hoverMessage):Fe.hoverMessage?z.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Se.map(Fe=>({range:m.from(Fe)}))}e.$8M=P;function I(Se){return typeof Se>"u"?Se:typeof Se=="string"?p.URI.file(Se):Se}e.$9M=I;var H;(function(Se){function Fe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?I(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Se.from=Fe})(H||(e.ThemableDecorationAttachmentRenderOptions=H={}));var ae;(function(Se){function Fe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?I(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?H.from(fe.before):void 0,after:fe.after?H.from(fe.after):void 0}}Se.from=Fe})(ae||(e.ThemableDecorationRenderOptions=ae={}));var de;(function(Se){function Fe(fe){if(typeof fe>"u")return fe;switch(fe){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Fe})(de||(e.DecorationRangeBehavior=de={}));var we;(function(Se){function Fe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?de.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?ae.from(fe.light):void 0,dark:fe.dark?ae.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?I(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?H.from(fe.before):void 0,after:fe.after?H.from(fe.after):void 0}}Se.from=Fe})(we||(e.DecorationRenderOptions=we={}));var ke;(function(Se){function Fe(J){return{text:J.newText,eol:J.newEol&&tt.from(J.newEol),range:m.from(J.range)}}Se.from=Fe;function fe(J){const Me=new r.$cL(m.to(J.range),J.text);return Me.newEol=typeof J.eol>"u"?void 0:tt.to(J.eol),Me}Se.to=fe})(ke||(e.TextEdit=ke={}));var le;(function(Se){function Fe(J,Me){const Ue={edits:[]};if(J instanceof r.$fL){const Xe=new $.$Bc;for(const We of J._allEntries())We._type===1&&p.URI.isUri(We.to)&&We.from===void 0&&Xe.add(We.to);for(const We of J._allEntries())if(We._type===1){let _e;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?_e={type:"base64",value:(0,T.$De)(T.$je.wrap(We.options.contents))}:_e={type:"dataTransferItem",id:We.options.contents._itemId}),Ue.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:_e},metadata:We.metadata})}else We._type===2?Ue.edits.push({resource:We.uri,textEdit:ke.from(We.edit),versionId:Xe.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Ue.edits.push({resource:We.uri,textEdit:{range:m.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Xe.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Ue.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Ue.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Pt.from)}})}return Ue}Se.from=Fe;function fe(J){const Me=new r.$fL,Ue=new $.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const We=Xe,_e=p.URI.revive(We.resource),mt=m.to(We.textEdit.range),Ut=We.textEdit.text,Et=We.textEdit.insertAsSnippet;let St;Et?St=r.$eL.replace(mt,new r.$gL(Ut)):St=r.$cL.replace(mt,Ut);const bt=Ue.get(_e);bt?bt.push(St):Ue.set(_e,[St])}else Me.renameFile(p.URI.revive(Xe.oldResource),p.URI.revive(Xe.newResource),Xe.options);for(const[Xe,We]of Ue)Me.set(Xe,We);return Me}Se.to=fe})(le||(e.WorkspaceEdit=le={}));var ve;(function(Se){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function fe(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Se.from=fe;function J(Me){for(const Ue in Fe)if(Fe[Ue]===Me)return Number(Ue);return r.SymbolKind.Property}Se.to=J})(ve||(e.SymbolKind=ve={}));var se;(function(Se){function Fe(J){switch(J){case r.SymbolTag.Deprecated:return 1}}Se.from=Fe;function fe(J){switch(J){case 1:return r.SymbolTag.Deprecated}}Se.to=fe})(se||(e.SymbolTag=se={}));var be;(function(Se){function Fe(J){return{name:J.name,kind:ve.from(J.kind),tags:J.tags&&J.tags.map(se.from),containerName:J.containerName,location:Ie.from(J.location)}}Se.from=Fe;function fe(J){const Me=new r.$nL(J.name,ve.to(J.kind),J.containerName,Ie.to(J.location));return Me.tags=J.tags&&J.tags.map(se.to),Me}Se.to=fe})(be||(e.WorkspaceSymbol=be={}));var ne;(function(Se){function Fe(J){const Me={name:J.name||"!!MISSING: name!!",detail:J.detail,range:m.from(J.range),selectionRange:m.from(J.selectionRange),kind:ve.from(J.kind),tags:J.tags?.map(se.from)??[]};return J.children&&(Me.children=J.children.map(Fe)),Me}Se.from=Fe;function fe(J){const Me=new r.$oL(J.name,J.detail,ve.to(J.kind),m.to(J.range),m.to(J.selectionRange));return(0,E.$Lb)(J.tags)&&(Me.tags=J.tags.map(se.to)),J.children&&(Me.children=J.children.map(fe)),Me}Se.to=fe})(ne||(e.DocumentSymbol=ne={}));var Y;(function(Se){function Fe(J){const Me=new r.$sL(ve.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),m.to(J.range),m.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}Se.to=Fe;function fe(J,Me,Ue){if(Me=Me??J._sessionId,Ue=Ue??J._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,name:J.name,detail:J.detail,kind:ve.from(J.kind),uri:J.uri,range:m.from(J.range),selectionRange:m.from(J.selectionRange),tags:J.tags?.map(se.from)}}Se.from=fe})(Y||(e.CallHierarchyItem=Y={}));var V;(function(Se){function Fe(fe){return new r.$tL(Y.to(fe.from),fe.fromRanges.map(J=>m.to(J)))}Se.to=Fe})(V||(e.CallHierarchyIncomingCall=V={}));var ie;(function(Se){function Fe(fe){return new r.$uL(Y.to(fe.to),fe.fromRanges.map(J=>m.to(J)))}Se.to=Fe})(ie||(e.CallHierarchyOutgoingCall=ie={}));var Ie;(function(Se){function Fe(J){return{range:J.range&&m.from(J.range),uri:J.uri}}Se.from=Fe;function fe(J){return new r.$hL(p.URI.revive(J.uri),m.to(J.range))}Se.to=fe})(Ie||(e.location=Ie={}));var Le;(function(Se){function Fe(J){const Me=J,Ue=J;return{originSelectionRange:Me.originSelectionRange?m.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ue.uri,range:m.from(Me.targetRange?Me.targetRange:Ue.range),targetSelectionRange:Me.targetSelectionRange?m.from(Me.targetSelectionRange):void 0}}Se.from=Fe;function fe(J){return{targetUri:p.URI.revive(J.uri),targetRange:m.to(J.range),targetSelectionRange:J.targetSelectionRange?m.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?m.to(J.originSelectionRange):void 0}}Se.to=fe})(Le||(e.DefinitionLink=Le={}));var Ce;(function(Se){function Fe(J){return{range:m.from(J.range),contents:z.fromMany(J.contents)}}Se.from=Fe;function fe(J){return new r.$kL(J.contents.map(z.to),m.to(J.range))}Se.to=fe})(Ce||(e.Hover=Ce={}));var ce;(function(Se){function Fe(J){return{range:m.from(J.range),expression:J.expression}}Se.from=Fe;function fe(J){return new r.$eM(m.to(J.range),J.expression)}Se.to=fe})(ce||(e.EvaluatableExpression=ce={}));var te;(function(Se){function Fe(J){if(J instanceof r.$fM)return{type:"text",range:m.from(J.range),text:J.text};if(J instanceof r.$gM)return{type:"variable",range:m.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof r.$hM)return{type:"expression",range:m.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Fe;function fe(J){switch(J.type){case"text":return{range:m.to(J.range),text:J.text};case"variable":return{range:m.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:m.to(J.range),expression:J.expression}}}Se.to=fe})(te||(e.InlineValue=te={}));var Q;(function(Se){function Fe(J){return{frameId:J.frameId,stoppedLocation:m.from(J.stoppedLocation)}}Se.from=Fe;function fe(J){return new r.$iM(J.frameId,m.to(J.stoppedLocation))}Se.to=fe})(Q||(e.InlineValueContext=Q={}));var ee;(function(Se){function Fe(J){return{range:m.from(J.range),kind:J.kind}}Se.from=Fe;function fe(J){return new r.$lL(m.to(J.range),J.kind)}Se.to=fe})(ee||(e.DocumentHighlight=ee={}));var me;(function(Se){function Fe(J){return{uri:J.uri,highlights:J.highlights.map(ee.from)}}Se.from=Fe;function fe(J){return new r.$mL(p.URI.revive(J.uri),J.highlights.map(ee.to))}Se.to=fe})(me||(e.MultiDocumentHighlight=me={}));var pe;(function(Se){function Fe(fe){switch(fe){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Se.to=Fe})(pe||(e.CompletionTriggerKind=pe={}));var Ae;(function(Se){function Fe(fe){return{triggerKind:pe.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Se.to=Fe})(Ae||(e.CompletionContext=Ae={}));var he;(function(Se){function Fe(J){switch(J){case r.CompletionItemTag.Deprecated:return 1}}Se.from=Fe;function fe(J){switch(J){case 1:return r.CompletionItemTag.Deprecated}}Se.to=fe})(he||(e.CompletionItemTag=he={}));var ye;(function(Se){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function fe(Ue){return Fe.get(Ue)??9}Se.from=fe;const J=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(Ue){return J.get(Ue)??r.CompletionItemKind.Property}Se.to=Me})(ye||(e.CompletionItemKind=ye={}));var F;(function(Se){function Fe(fe,J){const Me=new r.$CL(fe.label);return Me.insertText=fe.insertText,Me.kind=ye.to(fe.kind),Me.tags=fe.tags?.map(he.to),Me.detail=fe.detail,Me.documentation=R.$jk(fe.documentation)?z.to(fe.documentation):fe.documentation,Me.sortText=fe.sortText,Me.filterText=fe.filterText,Me.preselect=fe.preselect,Me.commitCharacters=fe.commitCharacters,w.$Us.isIRange(fe.range)?Me.range=m.to(fe.range):typeof fe.range=="object"&&(Me.range={inserting:m.to(fe.range.insert),replacing:m.to(fe.range.replace)}),Me.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Me.insertText=new r.$gL(fe.insertText):(Me.insertText=fe.insertText,Me.textEdit=Me.range instanceof r.$0K?new r.$cL(Me.range,Me.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Me.additionalTextEdits=fe.additionalTextEdits.map(Ue=>ke.to(Ue))),Me.command=J&&fe.command?J.fromInternal(fe.command):void 0,Me}Se.to=Fe})(F||(e.CompletionItem=F={}));var q;(function(Se){function Fe(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:z.fromStrict(J.documentation)}}Se.from=Fe;function fe(J){return{label:J.label,documentation:R.$jk(J.documentation)?z.to(J.documentation):J.documentation}}Se.to=fe})(q||(e.ParameterInformation=q={}));var K;(function(Se){function Fe(J){return{label:J.label,documentation:z.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(q.from):[],activeParameter:J.activeParameter}}Se.from=Fe;function fe(J){return{label:J.label,documentation:R.$jk(J.documentation)?z.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(q.to):[],activeParameter:J.activeParameter}}Se.to=fe})(K||(e.SignatureInformation=K={}));var U;(function(Se){function Fe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.from):[]}}Se.from=Fe;function fe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.to):[]}}Se.to=fe})(U||(e.SignatureHelp=U={}));var X;(function(Se){function Fe(fe,J){const Me=new r.$BL(S.to(J.position),typeof J.label=="string"?J.label:J.label.map(x.to.bind(void 0,fe)),J.kind&&Ee.to(J.kind));return Me.textEdits=J.textEdits&&J.textEdits.map(ke.to),Me.tooltip=R.$jk(J.tooltip)?z.to(J.tooltip):J.tooltip,Me.paddingLeft=J.paddingLeft,Me.paddingRight=J.paddingRight,Me}Se.to=Fe})(X||(e.InlayHint=X={}));var x;(function(Se){function Fe(fe,J){const Me=new r.$AL(J.label);return Me.tooltip=R.$jk(J.tooltip)?z.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(Me.command=fe.fromInternal(J.command)),J.location&&(Me.location=Ie.to(J.location)),Me}Se.to=Fe})(x||(e.InlayHintLabelPart=x={}));var Ee;(function(Se){function Fe(J){return J}Se.from=Fe;function fe(J){return J}Se.to=fe})(Ee||(e.InlayHintKind=Ee={}));var Te;(function(Se){function Fe(J){return{range:m.from(J.range),url:J.target,tooltip:J.tooltip}}Se.from=Fe;function fe(J){let Me;if(J.url)try{Me=typeof J.url=="string"?p.URI.parse(J.url,!0):p.URI.revive(J.url)}catch{}return new r.$HL(m.to(J.range),Me)}Se.to=fe})(Te||(e.DocumentLink=Te={}));var Ve;(function(Se){function Fe(J){const Me=new r.$KL(J.label);return J.textEdit&&(Me.textEdit=ke.to(J.textEdit)),J.additionalTextEdits&&(Me.additionalTextEdits=J.additionalTextEdits.map(Ue=>ke.to(Ue))),Me}Se.to=Fe;function fe(J){return{label:J.label,textEdit:J.textEdit?ke.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Me=>ke.from(Me)):void 0}}Se.from=fe})(Ve||(e.ColorPresentation=Ve={}));var He;(function(Se){function Fe(J){return new r.$IL(J[0],J[1],J[2],J[3])}Se.to=Fe;function fe(J){return[J.red,J.green,J.blue,J.alpha]}Se.from=fe})(He||(e.Color=He={}));var Ye;(function(Se){function Fe(J){return{range:m.from(J.range)}}Se.from=Fe;function fe(J){return new r.$rL(m.to(J.range))}Se.to=fe})(Ye||(e.SelectionRange=Ye={}));var st;(function(Se){function Fe(fe){switch(fe){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Se.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var nt;(function(Se){function Fe(J){switch(J){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Fe;function fe(J){switch(J){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Se.to=fe})(nt||(e.TextEditorLineNumbersStyle=nt={}));var tt;(function(Se){function Fe(J){if(J===r.EndOfLine.CRLF)return 1;if(J===r.EndOfLine.LF)return 0}Se.from=Fe;function fe(J){if(J===1)return r.EndOfLine.CRLF;if(J===0)return r.EndOfLine.LF}Se.to=fe})(tt||(e.EndOfLine=tt={}));var at;(function(Se){function Fe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Fe})(at||(e.ProgressLocation=at={}));var ct;(function(Se){function Fe(J){const Me={start:J.start+1,end:J.end+1};return J.kind&&(Me.kind=je.from(J.kind)),Me}Se.from=Fe;function fe(J){const Me={start:J.start-1,end:J.end-1};return J.kind&&(Me.kind=je.to(J.kind)),Me}Se.to=fe})(ct||(e.FoldingRange=ct={}));var je;(function(Se){function Fe(J){if(J)switch(J){case r.FoldingRangeKind.Comment:return s.$Kt.Comment;case r.FoldingRangeKind.Imports:return s.$Kt.Imports;case r.FoldingRangeKind.Region:return s.$Kt.Region}}Se.from=Fe;function fe(J){if(J)switch(J.value){case s.$Kt.Comment.value:return r.FoldingRangeKind.Comment;case s.$Kt.Imports.value:return r.FoldingRangeKind.Imports;case s.$Kt.Region.value:return r.FoldingRangeKind.Region}}Se.to=fe})(je||(e.FoldingRangeKind=je={}));var vt;(function(Se){function Fe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?m.from(fe.selection):void 0,override:typeof fe.override=="boolean"?n.$EE.id:void 0}}Se.from=Fe})(vt||(e.TextEditorOpenOptions=vt={}));var Z;(function(Se){function Fe(Ue){return Ue instanceof r.$5L?Ue.toJSON():typeof Ue=="string"?Ue:fe(Ue)||J(Ue)?new r.$5L(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Se.from=Fe;function fe(Ue){const Xe=Ue;return Xe?p.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(Ue){const Xe=Ue;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Me(Ue){return typeof Ue=="string"?Ue:new r.$5L(p.URI.revive(Ue.baseUri),Ue.pattern)}Se.to=Me})(Z||(e.GlobPattern=Z={}));var _;(function(Se){function Fe(fe){if(fe){if(Array.isArray(fe))return fe.map(Fe);if(typeof fe=="string")return fe;{const J=fe;return{language:J.language,scheme:J.scheme,pattern:Z.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Se.from=Fe})(_||(e.LanguageSelector=_={}));var $e;(function(Se){function Fe(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Me=>Array.isArray(Me)&&Me.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&p.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Xe=>Xe instanceof r.$0K)))}Se.is=Fe;function fe(J){return{documents:J.documents.map(Me=>Me.map(Ue=>({uri:p.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Xe=>m.from(Xe))})))}}Se.from=fe})($e||(e.MappedEditsContext=$e={}));var Be;(function(Se){function Fe(J){return{start:J.start,end:J.end}}Se.from=Fe;function fe(J){return new r.$tM(J.start,J.end)}Se.to=fe})(Be||(e.NotebookRange=Be={}));var Qe;(function(Se){function Fe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Se.to=Fe;function fe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Se.from=fe})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var it;(function(Se){function Fe(fe){if(fe===a.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(fe===a.NotebookCellExecutionState.Pending)return;if(fe===a.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Se.to=Fe})(it||(e.NotebookCellExecutionState=it={}));var rt;(function(Se){function Fe(J){switch(J){case r.NotebookCellKind.Markup:return a.CellKind.Markup;case r.NotebookCellKind.Code:default:return a.CellKind.Code}}Se.from=Fe;function fe(J){switch(J){case a.CellKind.Markup:return r.NotebookCellKind.Markup;case a.CellKind.Code:default:return r.NotebookCellKind.Code}}Se.to=fe})(rt||(e.NotebookCellKind=rt={}));var Ne;(function(Se){function Fe(J){const Me={metadata:J.metadata??Object.create(null),cells:[]};for(const Ue of J.cells)r.$uM.validate(Ue),Me.cells.push(Pt.from(Ue));return Me}Se.from=Fe;function fe(J){const Me=new r.$vM(J.cells.map(Pt.to));return(0,u.$Vf)(J.metadata)||(Me.metadata=J.metadata),Me}Se.to=fe})(Ne||(e.NotebookData=Ne={}));var Pt;(function(Se){function Fe(J){return{cellKind:rt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Qe.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Ht.from):[]}}Se.from=Fe;function fe(J){return new r.$uM(rt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Ht.to):void 0,J.metadata,J.internalMetadata?Qe.to(J.internalMetadata):void 0)}Se.to=fe})(Pt||(e.NotebookCellData=Pt={}));var Tt;(function(Se){function Fe(J){return{mime:J.mime,valueBytes:T.$je.wrap(J.data)}}Se.from=Fe;function fe(J){return new r.$wM(J.valueBytes.buffer,J.mime)}Se.to=fe})(Tt||(e.NotebookCellOutputItem=Tt={}));var Ht;(function(Se){function Fe(J){return{outputId:J.id,items:J.items.map(Tt.from),metadata:J.metadata}}Se.from=Fe;function fe(J){const Me=J.items.map(Tt.to);return new r.$xM(Me,J.outputId,J.metadata)}Se.to=fe})(Ht||(e.NotebookCellOutput=Ht={}));var Bt;(function(Se){function Fe(Me){return J(Me)?{include:Z.from(Me.include)??void 0,exclude:Z.from(Me.exclude)??void 0}:Z.from(Me)??void 0}Se.from=Fe;function fe(Me){return J(Me)?{include:Z.to(Me.include),exclude:Z.to(Me.exclude)}:Z.to(Me)}Se.to=fe;function J(Me){const Ue=Me;return Ue?!(0,u.$Rf)(Ue.include)&&!(0,u.$Rf)(Ue.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var yt;(function(Se){function Fe(fe,J,Me){const Ue=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ue,Me),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Se.from=Fe})(yt||(e.NotebookStatusBarItem=yt={}));var Kt;(function(Se){function Fe(fe,J,Me){const Ue=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:J.toInternal(Ue,Me),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Se.from=Fe})(Kt||(e.NotebookKernelSourceAction=Kt={}));var Nt;(function(Se){function Fe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Se.from=Fe})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Xt;(function(Se){function Fe(J){return{uri:J.uri,provides:J.provides}}Se.from=Fe;function fe(J){return new r.$zM(p.URI.revive(J.uri),J.provides)}Se.to=fe})(Xt||(e.NotebookRendererScript=Xt={}));var zt;(function(Se){function Fe(J){return{message:z.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:m.from(J.location.range),uri:J.location.uri}}}Se.from=Fe;function fe(J){const Me=new r.$FM(typeof J.message=="string"?J.message:z.to(J.message));return Me.actualOutput=J.actual,Me.expectedOutput=J.expected,Me.contextValue=J.contextValue,Me.location=J.location?Ie.to(J.location):void 0,Me}Se.to=fe})(zt||(e.TestMessage=zt={}));var Rt;(function(Se){Se.namespace=h.$2J,Se.denamespace=h.$3J})(Rt||(e.TestTag=Rt={}));var Ze;(function(Se){function Fe(J){const Me=(0,t.$6M)(J).controllerId;return{extId:c.$XJ.fromExtHostTestItem(J,Me).toString(),label:J.label,uri:p.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ue=>Rt.namespace(Me,Ue.id)),range:w.$Us.lift(m.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&z.fromStrict(J.error)||null}}Se.from=Fe;function fe(J){return{parent:void 0,error:void 0,id:c.$XJ.fromString(J.extId).localId,label:J.label,uri:p.URI.revive(J.uri),tags:(J.tags||[]).map(Me=>{const{tagId:Ue}=Rt.denamespace(Me);return new r.$GM(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:m.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Se.toPlain=fe})(Ze||(e.TestItem=Ze={})),function(Se){function Fe(J){return{id:J.id}}Se.from=Fe;function fe(J){return new r.$GM(J.id)}Se.to=fe}(Rt||(e.TestTag=Rt={}));var Gt;(function(Se){const Fe=(J,Me)=>{const Ue=[];for(const[We,_e]of Me)c.$XJ.compare(_e.item.extId,We)===2&&(Me.delete(We),Ue.push(_e));const Xe={...Ze.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(_e=>_e.type===0).map(zt.to)})),children:Ue.map(We=>Fe(We,Me))};for(const We of Xe.children)We.parent=Xe;return Xe};function fe(J){const Me=[],Ue=new Map;for(const Xe of J.items){Ue.set(Xe.item.extId,Xe);const We=c.$XJ.root(Xe.item.extId);J.request.targets.some(_e=>_e.controllerId===We&&_e.testIds.includes(Xe.item.extId))&&Me.push(Xe)}return{completedAt:J.completedAt,results:Me.map(Xe=>Fe(Xe,Ue))}}Se.to=fe})(Gt||(e.TestResults=Gt={}));var Jt;(function(Se){function Fe(Ue){return{covered:Ue.covered,total:Ue.total}}function fe(Ue){return"line"in Ue?S.from(Ue):m.from(Ue)}function J(Ue){return"branches"in Ue?{count:Ue.executionCount,location:fe(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&fe(Xe.location),label:Xe.label})):void 0}:{type:0,name:Ue.name,count:Ue.executionCount,location:fe(Ue.location)}}Se.fromDetailed=J;function Me(Ue){return{uri:Ue.uri,statement:Fe(Ue.statementCoverage),branch:Ue.branchCoverage&&Fe(Ue.branchCoverage),function:Ue.functionCoverage&&Fe(Ue.functionCoverage),details:Ue.detailedCoverage?.map(J)}}Se.fromFile=Me})(Jt||(e.TestCoverage=Jt={}));var lt;(function(Se){function Fe(fe){switch(fe){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Se.to=Fe})(lt||(e.CodeActionTriggerKind=lt={}));var $t;(function(Se){function Fe(J){const Me=new r.$MM(ve.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),m.to(J.range),m.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}Se.to=Fe;function fe(J,Me,Ue){if(Me=Me??J._sessionId,Ue=Ue??J._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,kind:ve.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:m.from(J.range),selectionRange:m.from(J.selectionRange),tags:J.tags?.map(se.from)}}Se.from=fe})($t||(e.TypeHierarchyItem=$t={}));var jt;(function(Se){function Fe(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Se.from=Fe})(jt||(e.ViewBadge=jt={}));var Vt;(function(Se){function Fe(Ue,Xe,We){const _e=Xe.fileData;return _e?new r.$XL(new r.$YL(_e.name,p.URI.revive(_e.uri),_e.id,(0,M.$db)(()=>We(_e.id)))):Ue===A.$fs.uriList&&Xe.uriListData?new r.$WL(Me(Xe.uriListData)):new r.$WL(Xe.asString)}Se.to=Fe;async function fe(Ue,Xe){const We=await Xe.asString();if(Ue===A.$fs.uriList)return{asString:We,fileData:void 0,uriListData:J(We)};const _e=Xe.asFile();return{asString:We,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Se.from=fe;function J(Ue){return C.$rt.split(Ue).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return p.URI.parse(Xe)}catch{}return Xe})}function Me(Ue){return C.$rt.create(Ue.map(Xe=>typeof Xe=="string"?Xe:p.URI.revive(Xe)))}})(Vt||(e.DataTransferItem=Vt={}));var kt;(function(Se){function Fe(J,Me){const Ue=J.items.map(([Xe,We])=>[Xe,Vt.to(Xe,We,Me)]);return new r.$ZL(Ue)}Se.toDataTransfer=Fe;async function fe(J){const Me={items:[]},Ue=[];for(const[Xe,We]of J)Ue.push((async()=>{Me.items.push([Xe,await Vt.from(Xe,We)])})());return await Promise.all(Ue),Me}Se.from=fe})(kt||(e.DataTransfer=kt={}));var dt;(function(Se){function Fe(fe){return{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}Se.from=Fe})(dt||(e.ChatReplyFollowup=dt={}));var Ct;(function(Se){function Fe(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:dt.from(fe)}Se.from=Fe})(Ct||(e.ChatFollowup=Ct={}));var xt;(function(Se){function Fe(J){const Me=new r.$YM(Dt.to(J.role),J.content);return Me.name=J.name,Me}Se.to=Fe;function fe(J){return{role:Dt.from(J.role),content:J.content,name:J.name}}Se.from=fe})(xt||(e.ChatMessage=xt={}));var Dt;(function(Se){function Fe(J){switch(J){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Se.to=Fe;function fe(J){switch(J){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Se.from=fe})(Dt||(e.ChatMessageRole=Dt={}));var qe;(function(Se){function Fe(Me){const Ue={};for(const Xe of Object.keys(Me))Ue[Xe]=Me[Xe].map(Se.to);return Ue}Se.objectTo=Fe;function fe(Me){return{level:Mt.to(Me.level),kind:Me.kind,value:(0,p.$vc)(Me.value)?p.URI.revive(Me.value):Me.value,description:Me.description}}Se.to=fe;function J(Me){return{level:Mt.from(Me.level),kind:Me.kind,value:Me.value,description:Me.description}}Se.from=J})(qe||(e.ChatVariable=qe={}));var Mt;(function(Se){function Fe(J){switch(J){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Se.to=Fe;function fe(J){switch(J){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Se.from=fe})(Mt||(e.ChatVariableLevel=Mt={}));var Wt;(function(Se){function Fe(fe){switch(fe){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Se.to=Fe})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var Qt;(function(Se){function Fe(fe,J){return"placeholder"in J&&"resolvedContent"in J?{content:J.placeholder,kind:"asyncContent"}:"markdownContent"in J?((0,l.$CF)(fe,"chatAgents2Additions"),{content:z.from(J.markdownContent),kind:"markdownContent"}):"content"in J?"vulnerabilities"in J&&J.vulnerabilities?((0,l.$CF)(fe,"chatAgents2Additions"),{content:J.content,vulnerabilities:J.vulnerabilities,kind:"vulnerability"}):typeof J.content=="string"?{content:J.content,kind:"content"}:((0,l.$CF)(fe,"chatAgents2Additions"),{content:z.from(J.content),kind:"markdownContent"}):"documents"in J?{documents:J.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(Ue=>m.from(Ue))})),kind:"usedContext"}:"reference"in J?{reference:"uri"in J.reference?{uri:J.reference.uri,range:m.from(J.reference.range)}:J.reference,kind:"reference"}:"inlineReference"in J?{inlineReference:"uri"in J.inlineReference?{uri:J.inlineReference.uri,range:m.from(J.inlineReference.range)}:J.inlineReference,name:J.title,kind:"inlineReference"}:"agentName"in J?((0,l.$CF)(fe,"chatAgents2Additions"),{agentName:J.agentName,command:J.command,kind:"agentDetection"}):"treeData"in J?{treeData:J.treeData,kind:"treeData"}:"message"in J?{content:J.message,kind:"progressMessage"}:void 0}Se.from=Fe})(Qt||(e.ChatResponseProgress=Qt={}));var ft;(function(Se){function Fe(fe){return{label:fe.label,values:fe.values.map(qe.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation}}Se.from=Fe})(ft||(e.ChatAgentCompletionItem=ft={}));var Ft;(function(Se){function Fe(fe,J,Me){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:J.toInternal(fe,Me)}Se.from=Fe})(Ft||(e.TerminalQuickFix=Ft={}))}),define(Pe[219],Re([1,0,2,15,7,8,185]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class ${constructor(b,A,D,u={timeout:1500,errors:3}){this.c=b,this.d=A,this.f=D,this.g=u,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(b){return(A,D,u)=>{const w={dispose:this.a.push([A,D,b])};return Array.isArray(u)&&u.push(w),w}}async $participateInSave(b,A){const D=E.URI.revive(b);let u=!1;const p=setTimeout(()=>u=!0,this.g.timeout),w=[];try{for(const s of[...this.a]){if(u)break;const o=this.d.getDocument(D),t=await this.h(s,{document:o,reason:M.TextDocumentSaveReason.to(A)});w.push(t)}}finally{clearTimeout(p)}return w}h([b,A,D],u){const p=this.b.get(b);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(D,b,A,u).then(()=>!0,w=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const s=this.b.get(b);this.b.set(b,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(b,A,D,u){const p=[],w=Date.now(),{document:s,reason:o}=u,{version:t}=s,n=Object.freeze({document:s,reason:o,waitUntil(a){if(Object.isFrozen(p))throw(0,T.$8)("waitUntil can not be called async");p.push(Promise.resolve(a))}});try{A.apply(D,[n])}catch(a){return Promise.reject(a)}return Object.freeze(p),new Promise((a,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(p).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(h),a(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(a=>{const c={edits:[]};for(const h of a)if(Array.isArray(h)&&h.every(i=>i instanceof C.$cL))for(const{newText:i,newEol:l,range:r}of h)c.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:r&&M.Range.from(r),text:i,eol:l&&M.EndOfLine.from(l)}});if(c.edits.length!==0)return t===s.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$fhc=$}),define(Pe[220],Re([1,0,12,2,8,7,76]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=e.$khc=void 0;class ${constructor(D,u,p,w){this.start=D,this.deletedCount=u,this.deletedItems=p,this.items=w}asApiEvent(){return{range:new M.$tM(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(D,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,u,p){this.notebook=D,this.h=u,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return D.g},set mime(w){D.g=w},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(p)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,u,p){const w=p.map(C.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===D);if(s&&(u||(s.items.length=0),s.items.push(...w),s.items.length>1&&s.items.every(o=>R.$0I(o.mime)))){const o=new Map,t=[];s.items.forEach(n=>{let a;o.has(n.mime)?a=o.get(n.mime):(a=[],o.set(n.mime,a),t.push(n.mime)),a.push(n.data)}),s.items.length=0,t.forEach(n=>{const a=R.$$I(o.get(n));s.items.push({mime:n,data:a.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$khc=g;class b{static{this.a=0}constructor(D,u,p,w,s){this.k=D,this.l=u,this.m=p,this.uri=w,this.handle=b.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,u={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===E.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(p){return p=D.n(p),D.b[p].apiCell},getCells(p){return(p?D.p(p):D.b).map(s=>s.apiCell)},save(){return D.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,u,p){this.g=D.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:p});const w={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},s=[];for(const t of D.rawEvents)t.kind===R.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,w.contentChanges):t.kind===R.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,w.contentChanges):t.kind===R.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),s.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),s.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),s.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===R.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),s.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),s.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const o=new Map;for(let t=0;t<s.length;t++){const n=s[t],a=o.get(n.cell);if(a===void 0){const c=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,c-1)}else w.cellChanges[a]={...w.cellChanges[a],...n}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let u=D.start|0,p=D.end|0;return u<0&&(u=0),p>this.b.length&&(p=this.b.length),D.with({start:u,end:p})}p(D){D=this.o(D);const u=[];for(let p=D.start;p<D.end;p++)u.push(this.b[p]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,u,p){if(this.j)return;const w=[],s=[],o=[];if(D.reverse().forEach(t=>{const a=t[2].map(i=>{const l=new g(this,this.l,i);return u||s.push(g.asModelAddData(this.apiNotebook,i)),l}),c=new $(t[0],t[1],[],a),h=this.b.splice(t[0],t[1],...a);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);w.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),p)for(const t of w)p.push(t.asApiEvent())}s(D,u,p,w){const s=this.b.splice(D,u);this.b.splice(p,0,...s);const o=[new $(D,u,s.map(t=>t.apiCell),[]),new $(p,0,[],s)];for(const t of o)w.push(t.asApiEvent())}t(D,u){this.b[D].setOutputs(u)}u(D,u,p,w){this.b[D].setOutputItems(u,p,w)}v(D,u){const p=this.b[D];p.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(p.uri,u)}w(D,u){const p=this.b[D];p.apiCell.mime=u}x(D,u){this.b[D].setMetadata(u)}y(D,u){this.b[D].setInternalMetadata(u)}getCellFromApiCell(D){return this.b.find(u=>u.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(u=>u.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$lhc=b}),define(Pe[221],Re([1,0,5,2,8,7]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class R{constructor(g,b,A,D={timeout:1500,errors:3}){this.b=g,this.c=b,this.d=A,this.f=D,this.a=new E.$Xd}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(b,A,D)=>{const u=function(w){b.call(A,w)};return u.extension=g,this.a.event(u,void 0,D)}}async $participateInSave(g,b,A){const D=T.URI.revive(g),u=this.c.getNotebookDocument(D);if(!u)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:C.TextDocumentSaveReason.to(b)},A,async(s,o)=>{const t=Date.now(),n=await await Promise.resolve(s);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof M.$fL?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const w={edits:[]};for(const s of p){const{edits:o}=C.WorkspaceEdit.from(s);w.edits=w.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(w)}}e.$Bhc=R}),define(Pe[107],Re([1,0,15,8,7]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,g,b,A,D,u){this.id=$,this.f=g,this.notebookData=b,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=A,this.c=u}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(g){this.selections=[g]},get selections(){return $.a},set selections(g){if(!Array.isArray(g)||!g.every(C.$tM.isNotebookRange))throw(0,E.$7)("selections");$.a=g,$.g(g)},get visibleRanges(){return $.b},revealRange(g,b){$.f.$tryRevealRange($.id,T.NotebookRange.from(g),b??C.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$mhc=M}),define(Pe[222],Re([1,0,5,14,8]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;let M=class{constructor($,g){this.c=$,this.d=g,this.a=new E.$Vd,this.b=new E.$Vd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,g);const b=this.d.getEditorById($);g.visibleRanges&&b._acceptVisibleRanges(g.visibleRanges.ranges.map(C.NotebookRange.to)),g.selections&&b._acceptSelections(g.selections.selections.map(C.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns($){for(const g in $)this.d.getEditorById(g)._acceptViewColumn(C.ViewColumn.to($[g]))}};e.$Dhc=M,e.$Dhc=M=Je([Ke(0,T.$nj)],M)}),define(Pe[223],Re([1,0,8,72,20,66,15]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;class ${constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,u,p){const w=this.b++,{title:s,location:o,cancellable:t}=u,n={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(w,{location:E.ProgressLocation.from(o),title:s,source:n,cancellable:t},D.isUnderDevelopment?void 0:D.identifier.value).catch(R.$2),this.d(w,p,!!t)}d(D,u,p){let w;p&&(w=new C.$6d,this.c.set(D,w));const s=t=>{this.a.$progressEnd(t),this.c.delete(t),w?.dispose()};let o;try{o=u(new b(this.a,D),p&&w?w.token:C.CancellationToken.None)}catch(t){throw s(D),t}return o.then(t=>s(D),t=>s(D)),o}$acceptProgressCanceled(D){const u=this.c.get(D);u&&(u.cancel(),this.c.delete(D))}}e.$Khc=$;function g(A,D){return A.message=D.message,typeof D.increment=="number"&&(typeof A.increment=="number"?A.increment+=D.increment:A.increment=D.increment),A}class b extends T.$vv{constructor(D,u){super(p=>this.throttledReport(p)),this.c=D,this.d=u}throttledReport(D){this.c.$progressReport(this.d,D)}}Je([(0,M.$zh)(100,(A,D)=>g(A,D),()=>Object.create(null))],b.prototype,"throttledReport",null)}),define(Pe[108],Re([1,0,29,104,48,77,58,8,2]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=e.$kN=e.$jN=void 0;const b=(a,c,h,i)=>{let l=c;return{enumerable:!0,configurable:!1,get(){return l},set(r){if(!h(l,r)){const d=l;l=r,a.listener?.(i(r,d))}}}},A=(a,c)=>a===c,D={range:(a,c)=>a===c?!0:!a||!c?!1:a.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(a,c)=>!(a.length!==c.length||a.some(h=>!c.find(i=>h.id===i.id)))},u=a=>c=>({op:4,update:a(c)}),p=(a,c)=>({range:(()=>{let h;const i=u(l=>({range:E.$Us.lift($.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return h},set(l){a.listener?.({op:6}),D.range(h,l)||(h=l,a.listener?.(i(l)))}}})(),label:b(a,c,D.label,u(h=>({label:h}))),description:b(a,void 0,D.description,u(h=>({description:h}))),sortText:b(a,void 0,D.sortText,u(h=>({sortText:h}))),canResolveChildren:b(a,!1,D.canResolveChildren,h=>({op:2,state:h})),busy:b(a,!1,D.busy,u(h=>({busy:h}))),error:b(a,void 0,D.error,u(h=>({error:$.MarkdownString.fromStrict(h)||null}))),tags:b(a,[],D.tags,(h,i)=>({op:1,new:h.map($.TestTag.from),old:i.map($.TestTag.from)}))}),w=a=>{const c=C.$XJ.fromString(a.extId),h=new o(c.controllerId,c.localId,a.label,g.URI.revive(a.uri)||void 0);return h.range=$.Range.to(a.range||void 0),h.description=a.description||void 0,h.sortText=a.sortText||void 0,h.tags=a.tags.map(i=>$.TestTag.to({id:(0,R.$3J)(i).tagId})),h},s=a=>{let c;for(const h of a.tests){const i=w(h.item);(0,T.$6M)(i).parent=c,c=i}return c};e.$jN=s;class o{constructor(c,h,i,l){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const r=(0,T.$5M)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof t?void 0:r.parent}},children:{value:(0,M.$4M)(r,T.$6M,o),enumerable:!0,writable:!1},...p(r,i)})}}e.$kN=o;class t extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$lN=t;class n extends M.$ZM{constructor(c,h,i){super({controllerId:c,getDocumentVersion:l=>l&&i.getDocument(l)?.version,getApiFor:T.$6M,getChildren:l=>l.children,root:new t(c,h),toITestItem:$.TestItem.from})}}e.$mN=n}),define(Pe[109],Re([1,0,53,15,89,8,7]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=e.$eN=void 0;class ${static{this.c=new C.$cN("TextEditorDecorationType")}constructor(u,p,w){const s=$.c.nextId();u.$registerTextEditorDecorationType(p.identifier,s,M.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:s,dispose(){u.$removeTextEditorDecorationType(s)}})}}e.$eN=$;class g{constructor(u,p){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,p){this.k();let w=null;if(u instanceof R.$9K)w=new R.$0K(u,u);else if(u instanceof R.$0K)w=u;else throw new Error("Unrecognized location");this.l(w,p,!1)}insert(u,p){this.k(),this.l(new R.$0K(u,u),p,!0)}delete(u){this.k();let p=null;if(u instanceof R.$0K)p=u;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(u,p,w){const s=this.c.validateRange(u);this.g.push({range:s,text:p,forceMoveMarkers:w})}setEndOfLine(u){if(this.k(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=u}}class b{constructor(u,p,w,s){this.c=u,this.d=p,this._accept(w),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(t){o.n(t)},get indentSize(){return o.g},set indentSize(t){o.p(t)},get insertSpaces(){return o.j},set insertSpaces(t){o.s(t)},get cursorStyle(){return o.k},set cursorStyle(t){o.t(t)},get lineNumbers(){return o.l},set lineNumbers(t){o.u(t)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=M.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}n(u){const p=this.m(u);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}p(u){const p=this.o(u);if(p!==null){if(typeof p=="number"){if(this.h===p)return;this.g=p,this.h=p}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const p=this.q(u);if(typeof p=="boolean"){if(this.j===p)return;this.j=p}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(u)})))}assign(u){const p={};let w=!1;if(typeof u.tabSize<"u"){const s=this.m(u.tabSize);s==="auto"?(w=!0,p.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,w=!0,p.tabSize=s)}if(typeof u.indentSize<"u"){const s=this.o(u.indentSize);s==="tabSize"?(w=!0,p.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,w=!0,p.indentSize=s)}if(typeof u.insertSpaces<"u"){const s=this.q(u.insertSpaces);s==="auto"?(w=!0,p.insertSpaces=s):this.j!==s&&(this.j=s,w=!0,p.insertSpaces=s)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,w=!0,p.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,w=!0,p.lineNumbers=M.TextEditorLineNumbersStyle.from(u.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,p))}v(u,p){p.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(w)})}}e.$fN=b;class A{constructor(u,p,w,s,o,t,n,a){this.id=u,this.j=p,this.k=w,this.g=!1,this.h=new Set,this.c=o,this.d=new b(this.j,this.id,t,w),this.e=n,this.f=a;const c=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof R.$$K))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof R.$$K)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new g(s.value,i);return h(l),c.m(l)},insertSnippet(h,i,l={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=c.c.map(d=>M.Range.from(d));else if(i instanceof R.$9K){const{lineNumber:d,column:m}=M.Position.from(i);r=[{startLineNumber:d,startColumn:m,endLineNumber:d,endColumn:m}]}else if(i instanceof R.$0K)r=[M.Range.from(i)];else{r=[];for(const d of i)if(d instanceof R.$0K)r.push(M.Range.from(d));else{const{lineNumber:m,column:f}=M.Position.from(d);r.push({startLineNumber:m,startColumn:f,endLineNumber:m,endColumn:f})}}return p.$tryInsertSnippet(u,s.value.version,h.value,r,l)},setDecorations(h,i){const l=i.length===0;l&&!c.h.has(h.key)||(l?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(M.$7M(i))return p.$trySetDecorations(u,h.key,M.$8M(i));{const r=new Array(4*i.length);for(let d=0,m=i.length;d<m;d++){const f=i[d];r[4*d]=f.start.line+1,r[4*d+1]=f.start.character+1,r[4*d+2]=f.end.line+1,r[4*d+3]=f.end.character+1}return p.$trySetDecorationsFast(u,h.key,r)}}))},revealRange(h,i){c.n(()=>p.$tryRevealRange(u,M.Range.from(h),i||R.TextEditorRevealType.Default))},show(h){p.$tryShowEditor(u,M.ViewColumn.from(h))},hide(){p.$tryHideEditor(u)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,E.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,E.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,E.ok)(!this.g),this.f=u}_acceptSelections(u){(0,E.ok)(!this.g),this.c=u}async l(){const u=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const p=u.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const w=p.edits.map(o=>o.range);w.sort((o,t)=>o.end.line===t.end.line?o.end.character===t.end.character?o.start.line===t.start.line?o.start.character-t.start.character:o.start.line-t.start.line:o.end.character-t.end.character:o.end.line-t.end.line);for(let o=0,t=w.length-1;o<t;o++){const n=w[o].end;if(w[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=p.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,s,{setEndOfLine:typeof p.setEndOfLine=="number"?M.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$gN=A}),define(Pe[224],Re([1,0,166,25,2,5,6,204,13,7,16,18,8,52,20,132,23]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;function t(c,h){if((0,A.$If)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends R.$Tc{constructor(h,i,l){super(),this.f=h,this.g=i,this.h=l,this.a=new Map,this.b=new s.$j8;function r(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:d=>r(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(m=>r(m)?this.r(m):m):d})}registerTreeDataProvider(h,i,l){const r=this.createTreeView(h,{treeDataProvider:i},l);return{dispose:()=>r.dispose()}}createTreeView(h,i,l){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=i.dragAndDropController?.dropMimeTypes??[],d=i.dragAndDropController?.dragMimeTypes??[],m=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,S=this.m(h,i,l),L={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:r,dragMimeTypes:d,hasHandleDrag:m,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(h,L),y={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,o.$CF)(l,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,o.$CF)(l,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(k){(0,p.$jk)(k)&&(0,o.$CF)(l,"treeViewMarkdownMessage"),S.message=k},get title(){return S.title},set title(k){S.title=k},get description(){return S.description},set description(k){S.description=k},get badge(){return S.badge},set badge(k){k!==void 0&&b.ViewBadge.isViewBadge(k)?S.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(S.badge=void 0)},reveal:(k,N)=>S.reveal(k,N),dispose:async()=>{await v,this.a.delete(h),S.dispose()}};return this.B(y),y}$getChildren(h,i){const l=this.a.get(h);return l?l.getChildren(i):Promise.reject(new $.$aF(h))}async $handleDrop(h,i,l,r,d,m,f,S){const L=this.a.get(h);if(!L)return Promise.reject(new $.$aF(h));const v=u.DataTransfer.toDataTransfer(l,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return f===h&&S&&await this.j(v,L,S,d,m),L.onDrop(v,r,d)}async j(h,i,l,r,d){const m=this.b.removeDragOperationTransfer(d);if(m)(await m)?.forEach((f,S)=>{f&&h.set(S,f)});else if(d&&i.handleDrag){const f=i.handleDrag(l,h,r);this.b.addDragOperationTransfer(d,f),await f}return h}async $handleDrag(h,i,l,r){const d=this.a.get(h);if(!d)return Promise.reject(new $.$aF(h));const m=await this.j(new b.$ZL,d,i,r,l);if(!(!m||r.isCancellationRequested))return u.DataTransfer.from(m)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new $.$aF(h);return i.hasResolve}$resolve(h,i,l){const r=this.a.get(h);if(!r)throw new $.$aF(h);return r.resolveTreeItem(i,l)}$setExpanded(h,i,l){const r=this.a.get(h);if(!r)throw new $.$aF(h);r.setExpanded(i,l)}$setSelectionAndFocus(h,i,l){const r=this.a.get(h);if(!r)throw new $.$aF(h);r.setSelectionAndFocus(i,l)}$setVisible(h,i){const l=this.a.get(h);if(!l){if(!i)return;throw new $.$aF(h)}l.setVisible(i)}$changeCheckboxState(h,i){const l=this.a.get(h);if(!l)throw new $.$aF(h);l.setCheckboxState(i)}m(h,i,l){const r=this.B(new a(h,i,this.f,this.g.converter,this.h,l));return this.a.set(h,r),r}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$4hc=n;class a extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$Rf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,l,r,d,m){if(super(),this.I=h,this.J=l,this.L=r,this.M=d,this.N=m,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Vd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Vd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Vd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Vd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Vd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Vd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Vd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$6d,m.contributes&&m.contributes.views)for(const v in m.contributes.views)for(const y of m.contributes.views[v])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let f,S;const L=M.Event.debounce(this.F.event,(v,y)=>(v||(v={message:!1,elements:[]}),y.element!==!1&&(f||(f=new Promise(k=>S=k),this.G=this.G.then(()=>f)),Array.isArray(y.element)?v.elements.push(...y.element):v.elements.push(y.element)),y.message&&(v.message=!0),v),200,!0);this.B(L(({message:v,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const k=S;return f=null,this.$(y).then(()=>k())})),v&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let l=this.X(h);return l||(l=await this.Y(i)),l?l.map(r=>r.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const l=(0,A.$Rf)(i.select)?!0:i.select,r=(0,A.$Rf)(i.focus)?!1:i.focus,d=(0,A.$Rf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(m=>this.W(h,m[m.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:m.map(S=>S.item)},{select:l,focus:r,expand:d})),m=>this.M.error(m)):this.J.$reveal(this.I,void 0,{select:l,focus:r,expand:d})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=u.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const l=this.getExtensionElement(h);l&&(i?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(h,i){const l=!(0,D.$ub)(this.s,h);this.s=h;const r=this.t!==i;this.t=i,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async l=>{const r=this.getExtensionElement(l.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:l.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);i.forEach(l=>{l.treeItem.checkboxState=l.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(l=>[l.extensionItem,l.newState])})}async handleDrag(h,i,l){const r=[];for(const d of h){const m=this.getExtensionElement(d);m&&r.push(m)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,i,l),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,l){const r=i?this.getExtensionElement(i):void 0;if(!(!r&&i||!this.g?.handleDrop))return(0,g.$Yg)(()=>this.g?.handleDrop?this.g.handleDrop(r,h,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const l=this.j.get(h);if(l){const r=this.m.get(l);if(r){const d=await this.f.resolveTreeItem(r.extensionItem,l,i)??r.extensionItem;return this.hb(d),r.item.tooltip=this.eb(d.tooltip),r.item.command=this.fb(r.disposableStore,d.command),r.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(l=>this.W(i,l[l.length-1]).then(r=>(l.push(r),l))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$Yg)(()=>this.f.getParent(h))}W(h,i){const l=this.m.get(h);return l?Promise.resolve(l):(0,g.$Yg)(()=>this.f.getTreeItem(h)).then(r=>this.kb(h,r,i,!0)).then(r=>this.getChildren(i?i.item.handle:void 0).then(()=>{const d=this.getExtensionElement(r);if(d){const m=this.m.get(d);if(m)return Promise.resolve(m)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const l=this.getExtensionElement(h);i=l?this.m.get(l):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new w.$6d(this.Z.token);try{const l=h?this.m.get(h):void 0,r=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const d=(0,D.$Hb)(r||[]),m=await Promise.all((0,D.$Hb)(d).map(S=>this.f.getTreeItem(S)));if(i.token.isCancellationRequested)return;const f=m.map((S,L)=>S?this.db(d[L],S,l):null);return(0,D.$Hb)(f)}finally{i.dispose()}}$(h){if(h.some(l=>!l))return this.Z.dispose(!0),this.Z=new w.$6d,this.tb(),this.J.$refresh(this.I);{const l=this.ab(h);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(h){const i=new Set,l=h.map(d=>this.m.get(d));for(const d of l)if(d&&!i.has(d.item.handle)){let m=d;for(;m&&m.parent&&l.findIndex(f=>m&&m.parent&&f&&f.item.handle===m.parent.item.handle)===-1;){const f=this.j.get(m.parent.item.handle);m=f?this.m.get(f):void 0}m&&!m.parent&&i.add(d.item.handle)}const r=[];return i.forEach(d=>{const m=this.j.get(d);if(m){const f=this.m.get(m);f&&(!f.parent||!i.has(f.parent.item.handle))&&r.push(d)}}),r}bb(h){const i={};return Promise.all(h.map(l=>this.cb(l).then(r=>{r&&(i[l]=r.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const l=this.m.get(i);if(l)return this.rb(i),(0,g.$Yg)(()=>this.f.getTreeItem(i)).then(r=>{if(r){const d=this.ib(i,r,l.parent);return this.pb(i,d,l,l.parent),l.dispose(),d}return null})}return Promise.resolve(null)}db(h,i,l){const r=this.ib(h,i,l);if(i.id&&this.j.has(r.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(h,r),this.qb(r,l),r}eb(h){return b.$wL.isMarkdownString(h)?u.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,l,r;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,l=h.checkboxState.tooltip,r=h.checkboxState.accessibilityInformation),{isChecked:i===b.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:r}}hb(h){if(!b.$UL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,l){this.hb(i);const r=this.B(new R.$Sc),d=this.kb(h,i,l),m=this.lb(i);return{item:{handle:d,parentHandle:l?l.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(r,i.command),contextValue:i.contextValue,icon:m,iconDark:this.mb(i)||m,themeIcon:this.jb(i),collapsibleState:(0,A.$Rf)(i.collapsibleState)?b.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:l,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(h){return h.iconPath instanceof b.$3L?h.iconPath:void 0}kb(h,{id:i,label:l,resourceUri:r},d,m){if(i)return`${a.b}/${i}`;const f=t(l,this.N),S=d?d.item.handle:a.a;let L=f?f.label:r?(0,T.$Eg)(r):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const v=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(d)||[];let k,N=0;do{if(k=`${S}/${N}:${L}`,m||!this.j.has(k)||v===k)break;N++}while(N<=y.length);return k}lb(h){if(h.iconPath&&!(h.iconPath instanceof b.$3L))return typeof h.iconPath=="string"||C.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof b.$3L)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return C.URI.isUri(h)?h:C.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,l,r){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(h,i);const d=this.X(r)||[],m=d.filter(f=>f.item.handle===l.item.handle)[0];m&&d.splice(d.indexOf(m),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const l of i.children){const r=this.j.get(l.item.handle);r&&this.sb(r)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const l of i.children){const r=this.j.get(l.item.handle);r&&this.sb(r)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[225],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[226],Re([1,0,178,15,31,97,73,30,22,225,188,101]),function(ge,e,E,T,C,M,R,$,g,b,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=void 0;const u=$.$Hn.as(R.$In.JSONContribution);class p{constructor(h,i,l){this.a=h,this.b=i,this.c=l}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(C.default.Error,h)}warn(h){this.d(C.default.Warning,h)}info(h){this.d(C.default.Info,h)}}e.$qF=p;class w{static a(h){const i=new g.$mm;for(let l=0,r=h.length;l<r;l++)i.add(h[l].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new w(i,[]);if(!i||!i.length)return new w([],h);const l=this.a(h),r=this.a(i),d=i.filter(f=>!l.has(f.description.identifier)),m=h.filter(f=>!r.has(f.description.identifier));return new w(d,m)}constructor(h,i){this.added=h,this.removed=i}}e.$rF=w;class s{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=w.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$sF=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$tF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$km},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$mo}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$mo}},extensionKind:{description:E.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&D.$hF.register(h.extensionPoint,h.activationEventsGenerator),e.$tF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,u.registerSchema(t,e.$tF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$uF=n;const a={ExtensionsRegistry:"ExtensionsRegistry"};$.$Hn.add(a.ExtensionsRegistry,new n),e.$vF=$.$Hn.as(a.ExtensionsRegistry),u.registerSchema(t,e.$tF),u.registerSchema(A.$Gj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(Pe[227],Re([1,0,174,16,26,226,35,5]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var b;(function(u){function p(w,s,o){if(!w)return;const t=T.$If(w.type)?w.type:void 0;if(!t||t.length===0){o.error(E.localize(3,null));return}const n=[];if(Array.isArray(w.required))for(const a of w.required)T.$If(a)&&n.push(a);return{extensionId:s.value,taskType:t,required:n,properties:w.properties?C.$vn(w.properties):{},when:w.when?R.$4i.deserialize(w.when):void 0}}u.from=p})(b||(b={}));const A=M.$vF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,p)=>{for(const w of u)w.type&&p.push(`onTaskType:${w.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:g}});class D{constructor(){this.d=new $.$Vd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,w)=>{A.setHandler((s,o)=>{this.c=void 0;try{for(const t of o.removed){const n=t.value;for(const a of n)this.a&&a.type&&this.a[a.type]&&delete this.a[a.type]}for(const t of o.added){const n=t.value;for(const a of n){const c=b.from(a,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const w of this.all()){const s={type:"object",additionalProperties:!1};w.required.length>0&&(s.required=w.required.slice(0)),w.properties!==void 0?s.properties=C.$vn(w.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[w.taskType]},p.push(s)}this.c={oneOf:p}}return this.c}}e.$xG=new D}),define(Pe[228],Re([1,0,175,16,25,26,35,227]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HG=e.JsonSchemaVersion=e.ExecutionEngine=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BG=e.ShellQuoting=e.$AG=e.$zG=e.$yG=void 0,e.$yG="settings",e.$zG=new R.$kj("taskRunning",!1,E.localize(0,null)),e.$AG={value:E.localize(1,null),original:"Tasks"};var g;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$BG="$customized",function(P){function I(H){if(!H)return P.Strong;switch(H.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=I}(g||(e.ShellQuoting=g={}));var b;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var A;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(A||(e.RevealKind=A={})),function(P){function I(H){switch(H.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=I}(A||(e.RevealKind=A={}));var D;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(P){function I(H){switch(H.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=I}(D||(e.RevealProblemKind=D={}));var u;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(u||(e.PanelKind=u={})),function(P){function I(H){switch(H.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=I}(u||(e.PanelKind=u={}));var p;(function(P){P.defaults={echo:!0,reveal:A.Always,revealProblems:D.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var w;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(w||(e.RuntimeType=w={})),function(P){function I(ae){switch(ae.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=I;function H(ae){switch(ae){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=H}(w||(e.RuntimeType=w={}));var s;(function(P){function I(H){return T.$If(H)?H:H.value}P.value=I})(s||(e.CommandString=s={}));var o;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function I(ae){return ae===P.Clean._id||ae===P.Build._id||ae===P.Rebuild._id||ae===P.Test._id}P.is=I;function H(ae){if(ae!==void 0)return T.$If(ae)?I(ae)?{_id:ae,isDefault:!1}:void 0:ae}P.from=H})(o||(e.TaskGroup=o={}));var t;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function I(H){switch(H){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=I})(n||(e.TaskSourceKind=n={}));var a;(function(P){P.parallel="parallel",P.sequence="sequence"})(a||(e.DependsOrder=a={}));var c;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(I,H,ae,de,we,ke){this._label="",this._id=I,H&&(this._label=H),ae&&(this.type=ae),this.runOptions=de,this.configurationProperties=we,this._source=ke}getDefinition(I){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const I={folder:this.d(),id:this._id};return JSON.stringify(I)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(I,H=!1){if(I===void 0)return!1;if(T.$If(I))return I===this._label||I===this.configurationProperties.identifier||H&&I===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===I._key}getQualifiedLabel(){const I=this.getWorkspaceFolder();return I?`${this._label} (${I.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(I){this.c===void 0&&(this.c=[]),I&&(this.c=this.c.concat(I))}get taskLoadMessages(){return this.c}}e.$CG=i;class l extends i{constructor(I,H,ae,de,we,ke,le,ve){super(I,ae,void 0,le,ve,H),this.command={},this._source=H,this.hasDefinedMatchers=ke,we&&(this.command=we)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(I=!1){if(I&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case w.Shell:H="shell";break;case w.Process:H="process";break;case w.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(I){return I instanceof l}getMapKey(){const I=this._source.config.workspaceFolder;return I?`${I.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const I=this.d();if(!I)return;let H=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(H+=this._source.kind);const ae={type:e.$BG,folder:I,id:H};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(I){return new l(I._id,I._source,I._label,I.type,I.command,I.hasDefinedMatchers,I.runOptions,I.configurationProperties)}}e.$DG=l;class r extends i{constructor(I,H,ae,de,we,ke,le){super(I,ae,de,ke,le,H),this._source=H,this.configures=we}static is(I){return I instanceof r}f(I){return I}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const I=this.d();if(!I)return;let H=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(H+=this._source.kind);const ae={type:e.$BG,folder:I,id:H};return JSON.stringify(ae)}}e.$EG=r;class d extends i{constructor(I,H,ae,de,we,ke,le,ve,se){super(I,ae,de,ve,se,H),this.defines=we,this.hasDefinedMatchers=le,this.command=ke,this.icon=se.icon,this.hide=se.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(I){return I instanceof d}getMapKey(){const I=this._source.workspaceFolder;return I?`${this._source.scope.toString()}|${I.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const I={type:"contributed",scope:this._source.scope,id:this._id};return I.folder=this.d(),JSON.stringify(I)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(I){return new d(I._id,I._source,I._label,I.type,I.defines,I.command,I.hasDefinedMatchers,I.runOptions,I.configurationProperties)}}e.$FG=d;class m extends i{constructor(I,H,ae,de,we,ke){super(I,ae,de,we,ke,H),this._source=H}clone(){return new m(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(I){return I instanceof m}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(I){return new m(I._id,I._source,I._label,I.type,I.runOptions,I.configurationProperties)}}e.$GG=m;var f;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(P){P._default=P.Terminal}(f||(e.ExecutionEngine=f={}));var S;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class L{constructor(I){this.c=new Map;for(let H=0;H<I.length;H++)this.c.set(I[H].uri.toString(),H)}compare(I,H){const ae=I.getWorkspaceFolder(),de=H.getWorkspaceFolder();if(ae&&de){let we=this.c.get(ae.uri.toString());we=we===void 0?0:we+1;let ke=this.c.get(de.uri.toString());return ke=ke===void 0?0:ke+1,we===ke?I._label.localeCompare(H._label):we-ke}else return!ae&&de?-1:ae&&!de?1:0}}e.$HG=L;var v;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(v||(e.TaskEventKind=v={}));var y;(function(P){P.SingleRun="singleRun",P.Background="background"})(y||(e.TaskRunType=y={}));var k;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var N;(function(P){function I(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function H(ve,se,be){return{...I(ve),kind:"start",terminalId:se,resolvedVariables:be}}P.start=H;function ae(ve,se,be){return{...I(ve),kind:"processStarted",terminalId:se,processId:be}}P.processStarted=ae;function de(ve,se,be){return{...I(ve),kind:"processEnded",terminalId:se,exitCode:be}}P.processEnded=de;function we(ve,se,be){return{...I(ve),kind:"terminated",exitReason:be,terminalId:se}}P.terminated=we;function ke(ve,se,be){return{...I(se),kind:ve,terminalId:be}}P.general=ke;function le(){return{kind:"changed"}}P.changed=le})(N||(e.TaskEvent=N={}));var O;(function(P){function I(ae){const de=Object.keys(ae).sort();let we="";for(const ke of de){let le=ae[ke];le instanceof Object?le=I(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),we+=ke+","+le+","}return we}function H(ae){const we={_key:I(ae),type:ae.taskType};return Object.assign(we,ae),we}P.create=H})(O||(e.KeyedTaskIdentifier=O={}));var G;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection",P.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var W;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var z;(function(P){function I(H,ae){const de=$.$xG.get(H.type);if(de===void 0){const ve=M.$vn(H);return delete ve._key,O.create(ve)}const we=Object.create(null);we.type=de.taskType;const ke=new Set;de.required.forEach(ve=>ke.add(ve));const le=de.properties;for(const ve of Object.keys(le)){const se=H[ve];if(se!=null)we[ve]=se;else if(ke.has(ve)){const be=le[ve];if(be.default!==void 0)we[ve]=M.$vn(be.default);else switch(be.type){case"boolean":we[ve]=!1;break;case"number":case"integer":we[ve]=0;break;case"string":we[ve]="";break;default:ae.error(E.localize(2,null,JSON.stringify(H,void 0,0),ve));return}}}return O.create(we)}P.createTaskIdentifier=I})(z||(e.TaskDefinition=z={}))}),define(Pe[229],Re([1,0,15]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=e.$k8b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$1)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$k8b=T;class C extends T{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$l8b=C}),define(Pe[49],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=void 0;class E{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++E.count}}e.$Qv=E;const T=[];function C($){const g=new E($);return T[g.nid]=g,g}e.$Rv=C;function M($){return T[$].sid}e.$Sv=M;class R{constructor(g){this.value=g}}e.$Tv=R}),define(Pe[3],Re([1,0,49]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.$6K=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$5K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var C;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(C||(e.TabInputKind=C={}));var M;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var g;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var b;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var A;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class D{static{this.a=0}static mixin(o){return o._id=D.a++,o}}e.$5K=D;var u;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var p;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var w;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$6K={MainThreadAuthentication:(0,E.$Rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Rv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Rv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Rv)("MainThreadClipboard"),MainThreadCommands:(0,E.$Rv)("MainThreadCommands"),MainThreadComments:(0,E.$Rv)("MainThreadComments"),MainThreadConfiguration:(0,E.$Rv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Rv)("MainThreadConsole"),MainThreadDebugService:(0,E.$Rv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Rv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Rv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Rv)("MainThreadLanguages"),MainThreadLogger:(0,E.$Rv)("MainThreadLogger"),MainThreadMessageService:(0,E.$Rv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Rv)("MainThreadOutputService"),MainThreadProgress:(0,E.$Rv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Rv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Rv)("MainThreadSecretState"),MainThreadStorage:(0,E.$Rv)("MainThreadStorage"),MainThreadSpeech:(0,E.$Rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Rv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Rv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Rv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Rv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Rv)("MainThreadSCM"),MainThreadSearch:(0,E.$Rv)("MainThreadSearch"),MainThreadShare:(0,E.$Rv)("MainThreadShare"),MainThreadTask:(0,E.$Rv)("MainThreadTask"),MainThreadWindow:(0,E.$Rv)("MainThreadWindow"),MainThreadLabelService:(0,E.$Rv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Rv)("MainThreadInteractive"),MainThreadChat:(0,E.$Rv)("MainThreadChat"),MainThreadInlineChat:(0,E.$Rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Rv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Rv)("MainThreadTimeline"),MainThreadTesting:(0,E.$Rv)("MainThreadTesting"),MainThreadLocalization:(0,E.$Rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Rv)("MainThreadIssueReporter")},e.$7K={ExtHostCommands:(0,E.$Rv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Rv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Rv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Rv)("ExtHostStatusBar"),ExtHostShare:(0,E.$Rv)("ExtHostShare"),ExtHostExtensionService:(0,E.$Rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Rv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Rv)("ExtHostSCM"),ExtHostSearch:(0,E.$Rv)("ExtHostSearch"),ExtHostTask:(0,E.$Rv)("ExtHostTask"),ExtHostWorkspace:(0,E.$Rv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Rv)("ExtHostWindow"),ExtHostWebviews:(0,E.$Rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Rv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Rv)("ExtHostProgress"),ExtHostComments:(0,E.$Rv)("ExtHostComments"),ExtHostSecretState:(0,E.$Rv)("ExtHostSecretState"),ExtHostStorage:(0,E.$Rv)("ExtHostStorage"),ExtHostUrls:(0,E.$Rv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Rv)("ExtHostOutputService"),ExtHostLabelService:(0,E.$Rv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Rv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Rv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Rv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Rv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Rv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Rv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Rv)("ExtHostTimeline"),ExtHostTesting:(0,E.$Rv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Rv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Rv)("ExtHostIssueReporter")}}),define(Pe[230],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class C{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$6K.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,g){if(this.a.size===0)throw new Error("No related information providers registered");const b=this.a.get(R);if(!b)throw new Error("related information provider not found");return await b.provideRelatedInformation($,g)??[]}getRelatedInformation(R,$,g){return this.c.$getAiRelatedInformation($,g)}registerRelatedInformationProvider(R,$,g){const b=this.b;return this.b++,this.a.set(b,g),this.c.$registerAiRelatedInformationProvider(b,$),new T.$8K(()=>{this.c.$unregisterAiRelatedInformationProvider(b),this.a.delete(b)})}}e.$4fc=C}),define(Pe[81],Re([1,0,4,14,3,17]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=e.$$fc=e.$0fc=void 0,e.$0fc=(0,E.$6h)("IExtHostApiDeprecationService");let R=class{constructor(g,b){this.c=b,this.a=new Set,this.b=g.getProxy(C.$6K.MainThreadTelemetry)}report(g,b,A){const D=this.d(g,b);this.a.has(D)||(this.a.add(D),b.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:g}))}d(g,b){return`${g}-${b.identifier.value}`}};e.$$fc=R,e.$$fc=R=Je([Ke(0,M.$0M),Ke(1,T.$nj)],R),e.$_fc=Object.freeze(new class{report($,g,b){}})}),define(Pe[231],Re([1,0,5,3,7,22]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class R{constructor(b){this.b=new Map,this.c=new E.$Vd,this.onDidChangeSessions=this.c.event,this.d=new $,this.f=new $,this.a=b.getProxy(T.$6K.MainThreadAuthentication)}async getSession(b,A,D,u={}){const p=M.$lm.toKey(b.identifier),w=[...D].sort().join(" ");return await this.d.getOrCreate(`${p} ${A} ${w}`,async()=>{await this.a.$ensureProvider(A);const s=b.displayName||b.name;return this.a.$getSession(A,D,p,s,u)})}async getSessions(b,A,D){const u=M.$lm.toKey(b.identifier),p=[...D].sort().join(" ");return await this.f.getOrCreate(`${u} ${p}`,async()=>{await this.a.$ensureProvider(A);const w=b.displayName||b.name;return this.a.$getSessions(A,D,u,w)})}async removeSession(b,A){const D=this.b.get(b);return D?D.provider.removeSession(A):this.a.$removeSession(b,A)}registerAuthenticationProvider(b,A,D,u){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:A,provider:D,options:u??{supportsMultipleAccounts:!1}});const p=D.onDidChangeSessions(w=>this.a.$sendDidChangeSessions(b,w));return this.a.$registerAuthenticationProvider(b,A,u?.supportsMultipleAccounts??!1),new C.$8K(()=>{p.dispose(),this.b.delete(b),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,A,D){const u=this.b.get(b);if(u)return Promise.resolve(u.provider.createSession(A,D));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,A){const D=this.b.get(b);if(D)return Promise.resolve(D.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,A){const D=this.b.get(b);if(D)return Promise.resolve(D.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,A){return this.c.fire({provider:{id:b,label:A}}),Promise.resolve()}}e.$cgc=R;class ${constructor(){this.a=new Map}getOrCreate(b,A){const D=this.a.get(b);if(D)return D;const u=A().finally(()=>this.a.delete(b));return this.a.set(b,u),u}}}),define(Pe[232],Re([1,0,3,17,8]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;let M=class{constructor($,g){this.a=$.getProxy(E.$6K.MainThreadBulkEdits),this.b={getTextDocumentVersion:b=>g.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,g,b){const A=C.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,b?.isRefactoring??!1)}};e.$dgc=M,e.$dgc=M=Je([Ke(0,T.$0M)],M)}),define(Pe[233],Re([1,0,67,6,3,8]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;class R{static{this.a=0}constructor(b,A){this.extension=b,this.provider=A,this.handle=R.a++}}class ${static{this.a=0}constructor(b){this.b=new Map,this.c=new Map,this.d=b.getProxy(C.$6K.MainThreadChat)}registerChatProvider(b,A,D){const u=new R(b,D);return this.b.set(u.handle,u),this.d.$registerChatProvider(u.handle,A),(0,T.$Rc)(()=>{this.d.$unregisterChatProvider(u.handle),this.b.delete(u.handle)})}transferChatSession(b,A){const D=E.Iterable.find(this.c.keys(),u=>this.c.get(u)===b)??0;typeof D=="number"&&this.d.$transferChatSession(D,A)}sendInteractiveRequestToProvider(b,A){this.d.$sendRequestToProvider(b,A)}async $prepareChat(b,A){const D=this.b.get(b);if(!D)return;const u=await D.provider.prepareSession(A);if(!u)return;const p=$.a++;return this.c.set(p,u),{id:p,requesterUsername:u.requester?.name,requesterAvatarIconUri:u.requester?.icon,responderUsername:u.responder?.name,responderAvatarIconUri:u.responder?.icon,inputPlaceholder:u.inputPlaceholder}}async $provideWelcomeMessage(b,A){const D=this.b.get(b);if(!D||!D.provider.provideWelcomeMessage)return;const u=await D.provider.provideWelcomeMessage(A);if(u)return u.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(w=>M.ChatReplyFollowup.from(w)):M.MarkdownString.from(p))}async $provideSampleQuestions(b,A){const D=this.b.get(b);if(!D||!D.provider.provideSampleQuestions)return;const u=await D.provider.provideSampleQuestions(A);if(u)return u?.map(p=>M.ChatReplyFollowup.from(p))}$releaseSession(b){this.c.delete(b)}}e.$egc=$}),define(Pe[234],Re([1,0,13,20,40,5,60,16,2,157,72,3,8,7,205,23]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class o{static{this.a=0}constructor(a,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=a.getProxy(D.$6K.MainThreadChatAgents2)}createChatAgent(a,c,h){const i=o.a++,l=new t(a,c,this.d,i,h);return this.b.set(i,l),this.d.$registerAgent(i,c,{}),l.apiAgent}async $invokeAgent(a,c,h,i,l,r){this.g.delete(c);const d=this.b.get(a);if(!d)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let m=!1;function f(){if(m)throw new Error("Only valid while executing the command")}const S=new E.$qh;r.onCancellationRequested(()=>S.complete()),this.i.allowListExtensionWhile(d.extension.identifier,S.p);const L=i.command?await d.validateSlashCommand(i.command):void 0,v=R.$Rd.create(!1);let y;try{const k=d.invoke({prompt:i.message,variables:u.ChatVariable.objectTo(i.variables),slashCommand:L},{history:l.history.map(u.ChatMessage.to)},new A.$vv(N=>{f(),typeof y>"u"&&"content"in N&&(y=v.elapsed());const O=u.ChatResponseProgress.from(d.extension,N);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(N));return}if("placeholder"in N&&"resolvedContent"in N){const G=Promise.all([this.d.$handleProgressChunk(h,O),N.resolvedContent]);(0,E.$Ug)(G,r).then(W=>{if(!W)return;const[z,P]=W,I=u.ChatResponseProgress.from(d.extension,P);if(!I){this.j.error("Unknown progress type: "+JSON.stringify(P));return}this.d.$handleProgressChunk(h,I,z??void 0)})}else this.d.$handleProgressChunk(h,O)}),r);return await(0,E.$Ug)(Promise.resolve(k).then(N=>{if(N){this.g.set(c,N);let O=this.h.get(c);O||(O=new Map,this.h.set(c,O)),O.set(h,N);const G={firstProgress:y,totalElapsed:v.elapsed()};return{errorDetails:N.errorDetails,timings:G}}else this.g.delete(c)}),r)}catch(k){return this.j.error(k,d.extension),{errorDetails:{message:(0,b.localize)(0,null,(0,C.$Qi)(k)),responseIsIncomplete:!0}}}finally{m=!0,S.complete()}}$releaseSession(a){this.g.delete(a),this.h.delete(a)}async $provideSlashCommands(a,c){const h=this.b.get(a);return h?h.provideSlashCommand(c):[]}$provideFollowups(a,c,h){const i=this.b.get(a);if(!i)return Promise.resolve([]);const l=this.g.get(c);return l?i.provideFollowups(l,h):Promise.resolve([])}$acceptFeedback(a,c,h,i,l){const r=this.b.get(a);if(!r)return;const d=this.h.get(c)?.get(h);if(!d)return;let m;switch(i){case w.InteractiveSessionVoteDirection.Down:m=p.ChatAgentResultFeedbackKind.Unhelpful;break;case w.InteractiveSessionVoteDirection.Up:m=p.ChatAgentResultFeedbackKind.Helpful;break}r.acceptFeedback(Object.freeze(l?{result:d,kind:m,reportIssue:l}:{result:d,kind:m}))}$acceptAction(a,c,h,i){const l=this.b.get(a);if(!l)return;const r=this.h.get(c)?.get(h);r&&i.action.kind!=="vote"&&l.acceptAction(Object.freeze({action:i.action,result:r}))}async $invokeCompletionProvider(a,c,h){const i=this.b.get(a);return i?(await i.invokeCompletionProvider(c,h)).map(u.ChatAgentCompletionItem.from):[]}}e.$ggc=o;class t{constructor(a,c,h,i,l){this.extension=a,this.t=c,this.u=h,this.w=i,this.x=l,this.o=new M.$Vd,this.q=new M.$Vd}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.q.fire(a)}async invokeCompletionProvider(a,c){return this.s?await this.s.provider.provideCompletionItems(a,c)??[]:[]}async validateSlashCommand(a){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$Sf)(this.b));const c=this.b.find(h=>h.name===a);if(!c)throw new Error(`Unknown slashCommand: ${a}`);return c}async provideSlashCommand(a){if(!this.a)return[];const c=await this.a.provideSlashCommands(a);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(a,c){if(!this.d)return[];const h=await this.d.provideFollowups(a,c);return h?h.map(i=>u.ChatFollowup.from(i)):[]}get apiAgent(){let a=!1,c=!1;const h=()=>{a||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$3L?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:u.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:u.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.t},get description(){return i.g??""},set description(l){i.g=l,h()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(l){i.h=l,h()},get iconPath(){return i.i},set iconPath(l){i.i=l,h()},get slashCommandProvider(){return i.a},set slashCommandProvider(l){i.a=l,h()},get followupProvider(){return i.d},set followupProvider(l){i.d=l,h()},get isDefault(){return(0,s.$CF)(i.extension,"defaultChatAgent"),i.j},set isDefault(l){(0,s.$CF)(i.extension,"defaultChatAgent"),i.j=l,h()},get helpTextPrefix(){return(0,s.$CF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(l){if((0,s.$CF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=l,h()},get helpTextPostfix(){return(0,s.$CF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(l){if((0,s.$CF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=l,h()},get isSecondary(){return(0,s.$CF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(l){(0,s.$CF)(i.extension,"defaultChatAgent"),i.n=l,h()},get sampleRequest(){return i.m},set sampleRequest(l){i.m=l,h()},get supportIssueReporting(){return(0,s.$CF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(l){(0,s.$CF)(i.extension,"chatAgents2Additions"),i.r=l,h()},get onDidReceiveFeedback(){return i.o.event},set agentVariableProvider(l){if(i.s=l,l){if(!l.triggerCharacters.length)throw new Error("triggerCharacters are required");i.u.$registerAgentCompletionsProvider(i.w,l.triggerCharacters)}else i.u.$unregisterAgentCompletionsProvider(i.w)},get agentVariableProvider(){return i.s},onDidPerformAction:(0,s.$BF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){a=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.u.$unregisterAgent(i.w)}}}invoke(a,c,h,i){return this.x(a,c,h,i)}}}),define(Pe[235],Re([1,0,20,6,3,8,72,22,13,5]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;class A{constructor(w,s){this.stream=new g.$wh,this.stream=s??new g.$wh;const o=this;this.apiObj={option:w,response:o.stream.asyncIterable}}}class D{constructor(w,s){this.a=new b.$Vd,this.b=new Map,this.c=new g.$wh,this.d=!1;const o=this;this.apiObject={result:w,response:o.c.asyncIterable,onDidStartResponseStream:o.a.event,cancel(){s.cancel()}},w.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(w){if(this.d)return;let s=this.b.get(w.index);s||(this.b.size===0?s=new A(w.index,this.c):s=new A(w.index),this.b.set(w.index,s),this.a.fire(s.apiObj)),s.stream.emitOne(w.part)}}class u{static{this.a=1}constructor(w,s){this.d=s,this.c=new Map,this.e=new Map,this.f=new $.$nm,this.b=w.getProxy(C.$6K.MainThreadChatProvider)}registerProvider(w,s,o,t){const n=u.a++;return this.c.set(n,{extension:w,provider:o}),this.b.$registerProvider(n,s,{extension:w,model:t.name??""}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(w,s,o,t,n){const a=this.c.get(w);if(!a)return;const c=new R.$vv(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${a.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(s,{index:h.index,part:h.part})});return a.provider.provideChatResponse(o.map(M.ChatMessage.to),t,c,n)}allowListExtensionWhile(w,s){this.f.set(w,s),s.finally(()=>this.f.delete(w))}async requestChatResponseProvider(w,s){if(!this.f.has(w))throw new Error("Extension is NOT allowed to make chat requests");const o=await this.b.$prepareChatAccess(s);if(!o)throw new Error(`ChatAccess '${s}' NOT found`);const t=this;return{get model(){return o.model},get isRevoked(){return!t.f.has(w)},makeRequest(n,a,c){if(!t.f.has(w))throw new Error("Access to chat has been revoked");const h=new E.$6d(c),i=Math.random()*1e6|0,l=t.b.$fetchResponse(w,s,i,n.map(M.ChatMessage.from),a??{},h.token),r=new D(l,h);return t.e.set(i,{res:r}),l.finally(()=>{t.e.delete(i)}),r.apiObject}}}async $handleResponseFragment(w,s){const o=this.e.get(w);o&&o.res.handleFragment(s)}}e.$fgc=u}),define(Pe[236],Re([1,0,6,3,15,8]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class R{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(T.$6K.MainThreadChatVariables)}async $resolveVariable(g,b,A){const D=this.b.get(g);if(D)try{const u=await D.resolver.resolve(D.data.name,{prompt:b},A);if(u)return u.map(M.ChatVariable.from)}catch(u){(0,C.$2)(u)}}registerVariableResolver(g,b,A,D){const u=R.a++;return this.b.set(u,{extension:g.identifier,data:{name:b,description:A},resolver:D}),this.c.$registerVariable(u,{name:b,description:A}),(0,E.$Rc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$hgc=R}),define(Pe[237],Re([1,0,3]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class T{constructor(M){const R=M.getProxy(E.$6K.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$igc=T}),define(Pe[32],Re([1,0,16,7,8,26,3,18,14,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c,h,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=void 0;let r=class{#e;#t;#i;constructor(v,y,k){this.b=new Map,this.c=new Map,this.#e=v.getProxy(R.$6K.MainThreadCommands),this.d=y,this.#i=k,this.#t=v.getProxy(R.$6K.MainThreadTelemetry),this.converter=new d(this,N=>{const O=this.c.get(N);return O?.result===f.Void?O:void 0},y),this.f=[{processArgument(N){return(0,b.$Ch)(N)}},{processArgument(N){return(0,M.$xn)(N,function(O){if(A.$Us.isIRange(O))return C.Range.to(O);if(D.$Ts.isIPosition(O))return C.Position.to(O);if(A.$Us.isIRange(O.range)&&u.URI.isUri(O.uri))return C.location.to(O);if(O instanceof t.$je)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const y=this.registerCommand(!1,v.id,async(...k)=>{const N=v.args.map((G,W)=>{if(!G.validate(k[W]))throw new Error(`Invalid argument '${G.name}' when running '${v.id}', received: ${typeof k[W]=="object"?JSON.stringify(k[W],null,"	"):k[W]} `);return G.convert(k[W])}),O=await this.executeCommand(v.internalId,...N);return v.result.convert(O,k,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new T.$8K(()=>{y.dispose(),this.c.delete(v.id)})}registerCommand(v,y,k,N,O,G){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:k,thisArg:N,metadata:O,extension:G}),v&&this.#e.$registerCommand(y),new T.$8K(()=>{this.b.delete(y)&&v&&this.#e.$unregisterCommand(y)})}executeCommand(v,...y){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,y,!0)}async g(v,y,k){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,y,!1);{let N=!1;const O=(0,M.$xn)(y,function(G){if(G instanceof T.$9K)return C.Position.from(G);if(G instanceof T.$0K)return C.Range.from(G);if(G instanceof T.$hL)return C.location.from(G);if(T.$tM.isNotebookRange(G))return C.NotebookRange.from(G);if(G instanceof ArrayBuffer)return N=!0,t.$je.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return N=!0,t.$je.wrap(G);if(G instanceof t.$je)return N=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(v,N?new n.$Tv(O):O,k);return(0,b.$Ch)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(v,y,!1);throw G}}}async h(v,y,k){const N=this.b.get(v);if(!N)throw new Error("Unknown command");const{callback:O,thisArg:G,metadata:W}=N;if(W?.args)for(let P=0;P<W.args.length;P++)try{(0,E.$Zf)(y[P],W.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${W.args[P].name}' - ${W.args[P].description}`)}const z=c.$Rd.create();try{return await O.apply(G,y)}catch(P){if(v===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...y);I&&(v=I.command)}if(this.d.error(P,v,N.extension?.identifier),!k)throw P;if(N.extension?.identifier){const I=this.#i.onExtensionError(N.extension.identifier,P);this.d.trace("forwarded error to extension?",I,N.extension?.identifier)}throw new class extends Error{constructor(){super((0,a.$Qi)(P)),this.id=v,this.source=N.extension?.displayName??N.extension?.name}}}finally{this.j(N,v,z.elapsed())}}j(v,y,k){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new h.$Ko(y),duration:k})}$executeContributedCommand(v,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const k=this.b.get(v);return k?(y=y.map(N=>this.f.reduce((O,G)=>G.processArgument(O,k.extension?.identifier),N)),this.h(v,y,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(y=>(v&&(y=y.filter(k=>k[0]!=="_")),y))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[y,k]of this.b){const{metadata:N}=k;N&&(v[y]=N)}return Promise.resolve(v)}};e.$sN=r,e.$sN=r=Je([Ke(0,s.$0M),Ke(1,g.$nj),Ke(2,i.$rN)],r),e.$tN=(0,w.$6h)("IExtHostCommands");class d{constructor(v,y,k){this.d=v,this.f=y,this.g=k,this.delegatingCommandId=`__vsc${(0,l.$qg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,y){if(!v)return;const k={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return k;const N=this.f(v.command);if(N)k.id=N.internalId,k.arguments=N.args.map((O,G)=>O.convert(v.arguments&&v.arguments[G]));else if((0,$.$Lb)(v.arguments)){const O=`${v.command} /${++this.c}`;this.b.set(O,v),y.add((0,p.$Rc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),k.$ident=O,k.id=this.delegatingCommandId,k.arguments=[O],this.g.trace("CommandsConverter#CREATE",v.command,O)}return k}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const y=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$uN=d;class m{static{this.Uri=new m("uri","Uri of a text document",v=>u.URI.isUri(v),v=>v)}static{this.Position=new m("position","A position in a text document",v=>T.$9K.isPosition(v),C.Position.from)}static{this.Range=new m("range","A range in a text document",v=>T.$0K.isRange(v),C.Range.from)}static{this.Selection=new m("selection","A selection in a text document",v=>T.$$K.isSelection(v),C.Selection.from)}static{this.Number=new m("number","",v=>typeof v=="number",v=>v)}static{this.String=new m("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=m.Arr(m.String)}static Arr(v){return new m(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,y=>Array.isArray(y)&&y.every(k=>v.validate(k)),y=>y.map(k=>v.convert(k)))}static{this.CallHierarchyItem=new m("item","A call hierarchy item",v=>v instanceof T.$sL,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new m("item","A type hierarchy item",v=>v instanceof T.$MM,C.TypeHierarchyItem.from)}static{this.TestItem=new m("testItem","A VS Code TestItem",v=>v instanceof o.$kN,C.TestItem.from)}constructor(v,y,k,N){this.name=v,this.description=y,this.validate=k,this.convert=N}optional(){return new m(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,y){return new m(v??this.name,y??this.description,this.validate,this.convert)}}e.$vN=m;class f{static{this.Void=new f("no result",v=>v)}constructor(v,y){this.description=v,this.convert=y}}e.$wN=f;class S{constructor(v,y,k,N,O){this.id=v,this.internalId=y,this.description=k,this.args=N,this.result=O}}e.$xN=S}),define(Pe[238],Re([1,0,18,12,2,80,96,35,32,8,7]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;const D=[new g.$xN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$vN.Uri,g.$vN.Position],new g.$wN("A promise that resolves to an array of DocumentHighlight-instances.",p(b.DocumentHighlight.to))),new g.$xN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$vN.Uri],new g.$wN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,E.$Kb)(s))return;class t extends A.$nL{static to(a){const c=new t(a.name,b.SymbolKind.to(a.kind),a.containerName||"",new A.$hL(o[0],b.Range.to(a.range)));return c.detail=a.detail,c.range=c.location.range,c.selectionRange=b.Range.to(a.selectionRange),c.children=a.children?a.children.map(t.to):[],c}}return s.map(t.to)})),new g.$xN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$vN.Uri,new g.$vN("options","Formatting options",s=>!0,s=>s)],new g.$wN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new g.$xN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$vN.Uri,g.$vN.Range,new g.$vN("options","Formatting options",s=>!0,s=>s)],new g.$wN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new g.$xN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$vN.Uri,g.$vN.Position,new g.$vN("ch","Trigger character",s=>typeof s=="string",s=>s),new g.$vN("options","Formatting options",s=>!0,s=>s)],new g.$wN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new g.$xN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$vN.Uri,g.$vN.Position],new g.$wN("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$xN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$vN.Uri,g.$vN.Position],new g.$wN("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$xN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$vN.Uri,g.$vN.Position],new g.$wN("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$xN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$vN.Uri,g.$vN.Position],new g.$wN("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$xN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$vN.Uri,g.$vN.Position],new g.$wN("A promise that resolves to an array of Location-instances.",p(b.location.to))),new g.$xN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$vN.Uri,g.$vN.Position],new g.$wN("A promise that resolves to an array of Hover-instances.",p(b.Hover.to))),new g.$xN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$vN.Uri,new g.$vN("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>A.$9K.isPosition(o)),s=>s.map(b.Position.from))],new g.$wN("A promise that resolves to an array of ranges.",s=>s.map(o=>{let t;for(const n of o.reverse())t=new A.$rL(b.Range.to(n),t);return t}))),new g.$xN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$vN.String.with("query","Search string")],new g.$wN("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(b.WorkspaceSymbol.to))),new g.$xN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$vN.Uri,g.$vN.Position],new g.$wN("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(b.CallHierarchyItem.to))),new g.$xN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$vN.CallHierarchyItem],new g.$wN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(b.CallHierarchyIncomingCall.to))),new g.$xN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$vN.CallHierarchyItem],new g.$wN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(b.CallHierarchyOutgoingCall.to))),new g.$xN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$vN.Uri,g.$vN.Position],new g.$wN("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:b.Range.to(s.range),placeholder:s.text}})),new g.$xN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$vN.Uri,g.$vN.Position,g.$vN.String.with("newName","The new symbol name")],new g.$wN("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return b.WorkspaceEdit.to(s)}})),new g.$xN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$vN.Uri,g.$vN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$wN("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(b.DocumentLink.to))),new g.$xN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$vN.Uri],new g.$wN("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new A.$lM(s.tokenTypes,s.tokenModifiers)})),new g.$xN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$vN.Uri],new g.$wN("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,R.$t$)(s);if(o.type==="full")return new A.$nM(o.data,void 0)})),new g.$xN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$vN.Uri,g.$vN.Range.optional()],new g.$wN("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new A.$lM(s.tokenTypes,s.tokenModifiers)})),new g.$xN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$vN.Uri,g.$vN.Range],new g.$wN("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,R.$t$)(s);if(o.type==="full")return new A.$nM(o.data,void 0)})),new g.$xN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$vN.Uri,g.$vN.Position,g.$vN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$vN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$wN("A promise that resolves to a CompletionList-instance.",(s,o,t)=>{if(!s)return new A.$DL([]);const n=s.suggestions.map(a=>b.CompletionItem.to(a,t));return new A.$DL(n,s.incomplete)})),new g.$xN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$vN.Uri,g.$vN.Position,g.$vN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$wN("A promise that resolves to SignatureHelp.",s=>{if(s)return b.SignatureHelp.to(s)})),new g.$xN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$vN.Uri,g.$vN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$wN("A promise that resolves to an array of CodeLens-instances.",(s,o,t)=>p(n=>new A.$vL(b.Range.to(n.range),n.command&&t.fromInternal(n.command)))(s))),new g.$xN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$vN.Uri,new g.$vN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>A.$0K.isRange(s),s=>A.$$K.isSelection(s)?b.Selection.from(s):b.Range.from(s)),g.$vN.String.with("kind","Code action kind to return code actions for").optional(),g.$vN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$wN("A promise that resolves to an array of Command-instances.",(s,o,t)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const a=new A.$pL(n.title,n.kind?new A.$qL(n.kind):void 0);return n.edit&&(a.edit=b.WorkspaceEdit.to(n.edit)),n.command&&(a.command=t.fromInternal(n.command)),a.isPreferred=n.isPreferred,a}})(s))),new g.$xN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$vN.Uri],new g.$wN("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new A.$JL(b.Range.to(o.range),b.Color.to(o.color))):[])),new g.$xN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$vN("color","The color to show and insert",s=>s instanceof A.$IL,b.Color.from),new g.$vN("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:b.Range.from(s.range)}))],new g.$wN("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(b.ColorPresentation.to):[])),new g.$xN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$vN.Uri,g.$vN.Range],new g.$wN("A promise that resolves to an array of Inlay objects",(s,o,t)=>s.map(b.InlayHint.to.bind(void 0,t)))),new g.$xN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$vN.Uri],new g.$wN("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(b.FoldingRange.to)})),new g.$xN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$wN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>b.NotebookExclusiveDocumentPattern.to(o))})))),new g.$xN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$vN.Uri,g.$vN.Range,new g.$vN("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof A.$0K,s=>b.InlineValueContext.from(s))],new g.$wN("A promise that resolves to an array of InlineValue objects",s=>s.map(b.InlineValue.to))),new g.$xN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$vN("uriOrString","Uri-instance or string (only http/https)",s=>C.URI.isUri(s)||typeof s=="string"&&(0,T.$fg)(s,T.Schemas.http,T.Schemas.https),s=>s),new g.$vN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[b.ViewColumn.from(s),void 0]:[b.ViewColumn.from(s.viewColumn),b.TextEditorOpenOptions.from(s)])).optional(),g.$vN.String.with("label","").optional()],g.$wN.Void),new g.$xN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$vN.Uri.with("resource","Resource to open"),g.$vN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$vN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[b.ViewColumn.from(s),void 0]:[b.ViewColumn.from(s.viewColumn),b.TextEditorOpenOptions.from(s)])).optional()],g.$wN.Void),new g.$xN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$vN.Uri.with("left","Left-hand side resource of the diff editor"),g.$vN.Uri.with("right","Right-hand side resource of the diff editor"),g.$vN.String.with("title","Human readable title for the diff editor").optional(),new g.$vN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[b.ViewColumn.from(s.viewColumn),b.TextEditorOpenOptions.from(s)]).optional()],g.$wN.Void),new g.$xN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$vN.String.with("title","Human readable title for the changes editor"),new g.$vN("resourceList","List of resources to compare",s=>{for(const o of s){if(o.length!==3)return!1;const[t,n,a]=o;if(!C.URI.isUri(t)||!C.URI.isUri(n)&&n!==void 0&&n!==null||!C.URI.isUri(a)&&a!==void 0&&a!==null)return!1}return!0},s=>s)],g.$wN.Void),new g.$xN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$vN.Uri,g.$vN.Position],new g.$wN("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(b.TypeHierarchyItem.to))),new g.$xN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$vN.TypeHierarchyItem],new g.$wN("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(b.TypeHierarchyItem.to))),new g.$xN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$vN.TypeHierarchyItem],new g.$wN("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(b.TypeHierarchyItem.to))),new g.$xN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$vN.TestItem],g.$wN.Void),new g.$xN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$vN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$wN.Void),new g.$xN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$vN.String.with("name","The context key name"),new g.$vN("value","The context key value",()=>!0,s=>s)],g.$wN.Void),new g.$xN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$vN.Uri,g.$vN.StringArray,new g.$vN("MappedEditsContext","Mapped Edits Context",s=>b.MappedEditsContext.is(s),s=>b.MappedEditsContext.from(s))],new g.$wN("A promise that resolves to a workspace edit or null",s=>s?b.WorkspaceEdit.to(s):null))];class u{static register(o){D.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",$.$5i)}}e.$bgc=u;function p(s){return o=>{if(Array.isArray(o))return o.map(s)}}function w(s){if(!Array.isArray(s))return;const o=[];for(const t of s)M.$Gt(t)?o.push(b.DefinitionLink.to(t)):o.push(b.location.to(t));return o}}),define(Pe[239],Re([1,0,13,66,5,6,2,80,22,8,7,3,23]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;function p(w,s,o){const t=w.getProxy(D.$6K.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$nm,s.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const S=this.b.get(f.handle);return S?S.value:f}else if(f&&f.$mid===7){const S=this.b.get(f.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.commentThreadHandle);return L?L.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);return L?f.$mid===8?L.value:{thread:L.value,text:f.text}:f}else if(f&&f.$mid===10){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const v=f.commentUniqueId,y=L.getCommentByUniqueId(v);return y||f}else if(f&&f.$mid===11){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const L=S.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const v=f.text,y=f.commentUniqueId,k=L.getCommentByUniqueId(y);return k?(typeof k.body=="string"?k.body=v:k.body=new A.$wL(v),k):f}return f}})}createCommentController(f,S,L){const v=n.a++,y=new c(f,v,S,L);this.b.set(y.handle,y);const k=this.c.get(f.identifier)||[];return k.push(y),this.c.set(f.identifier,k),y.value}async $createCommentThreadTemplate(f,S,L){const v=this.b.get(f);v&&v.$createCommentThreadTemplate(S,L)}async $updateCommentThreadTemplate(f,S,L){const v=this.b.get(f);v&&v.$updateCommentThreadTemplate(S,L)}$deleteCommentThread(f,S){this.b.get(f)?.$deleteCommentThread(S)}$provideCommentingRanges(f,S,L){const v=this.b.get(f);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const y=o.getDocument(R.URI.revive(S));return(0,E.$Yg)(async()=>{const k=await v.commentingRangeProvider.provideCommentingRanges(y,L);let N;return Array.isArray(k)?N={ranges:k,fileComments:!1}:k?N={ranges:k.ranges||[],fileComments:k.fileComments||!1}:N=k??void 0,N}).then(k=>{let N;return k&&(N={ranges:k.ranges.map(O=>b.Range.from(O)),fileComments:k.fileComments}),N})}$toggleReaction(f,S,L,v,y){const k=this.b.get(f);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,E.$Yg)(()=>{const N=k.getCommentThread(S);if(N){const O=N.getCommentByUniqueId(v.uniqueIdInThread);if(k!==void 0&&O&&k.reactionHandler)return k.reactionHandler(O,l(y))}return Promise.resolve(void 0)})}}class a{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,S,L,v,y,k,N,O){this.m=S,this.n=L,this.o=v,this.p=y,this.q=k,this.extensionDescription=N,this.r=O,this.handle=a.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Vd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Uc,this.l.value=new M.$Sc,this.n===void 0&&(this.n=`${f}.${this.handle}`),t.$createCommentThread(S,this.handle,this.n,this.o,b.Range.from(this.p),N.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{t.$deleteCommentThread(S,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(W){G.range=W},get comments(){return G.comments},set comments(W){G.comments=W},get collapsibleState(){return G.collapsibleState},set collapsibleState(W){G.collapsibleState=W},get canReply(){return G.canReply},set canReply(W){G.canReply=W},get contextValue(){return G.contextValue},set contextValue(W){G.contextValue=W},get label(){return G.label},set label(W){G.label=W},get state(){return G.state},set state(W){G.state=W},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Sc);const f=L=>Object.prototype.hasOwnProperty.call(this.b,L),S={};f("range")&&(S.range=b.Range.from(this.p)),f("label")&&(S.label=this.label),f("contextValue")&&(S.contextValue=this.contextValue??null),f("comments")&&(S.comments=this.q.map(L=>h(this,L,this.k,this.extensionDescription))),f("collapsibleState")&&(S.collapseState=r(this.g)),f("canReply")&&(S.canReply=this.canReply),f("state")&&(S.state=d(this.h)),f("isTemplate")&&(S.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(f){for(const S of this.k){const L=S[0],v=S[1];if(f===v)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Je([(0,T.$yh)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,S,L,v){this.f=f,this.g=S,this.h=L,this.i=v,this.a=new Map,t.$registerCommentController(this.handle,L,v,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(k){y.options=k},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(k){y.commentingRangeProvider=k},get reactionHandler(){return y.reactionHandler},set reactionHandler(k){y.reactionHandler=k},createCommentThread(k,N,O){return y.createCommentThread(k,N,O).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,S,L){S===void 0&&(0,u.$CF)(this.f,"fileComments");const v=new a(this.id,this.handle,void 0,f,S,L,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(f,S){const L=new a(this.id,this.handle,void 0,R.URI.revive(f),b.Range.to(S),[],this.f,!0);return L.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(f,S){const L=this.a.get(f);L&&(L.range=b.Range.to(S))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function h(m,f,S,L){let v=S.get(f);return v||(v=++m.commentHandle,S.set(f,v)),f.state!==void 0&&(0,u.$CF)(L,"commentsDraftState"),f.reactions?.some(y=>y.reactors!==void 0)&&(0,u.$CF)(L,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:v,body:typeof f.body=="string"?f.body:b.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>i(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(m){return{label:m.label,iconPath:m.iconPath?b.$9M(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted,reactors:m.reactors&&m.reactors.length>0&&typeof m.reactors[0]!="string"?m.reactors.map(f=>f.name):m.reactors}}function l(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?R.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1,reactors:m.reactors?.map(f=>({name:f}))}}function r(m){if(m!==void 0)switch(m){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function d(m){if(m!==void 0)switch(m){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$lgc=p}),define(Pe[240],Re([1,0,26,3,27,17]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;let R=class{constructor(A,D){this.a=A.getProxy(T.$6K.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,D){const u=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){u.e(A,D,p,arguments)}})}e(A,D,u,p){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:g(p,this.b)}),this.c&&this.f(A,u,p)}};e.$_hc=R,e.$_hc=R=Je([Ke(0,M.$0M),Ke(1,C.$nN)],R);const $=1e5;function g(b,A){const D=[];if(b.length)for(let u=0;u<b.length;u++){let p=b[u];if(typeof p>"u")p="undefined";else if(p instanceof Error){const w=p;w.stack?p=w.stack:p=w.toString()}D.push(p)}if(A){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,E.$An)(D);return u.length>$?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[110],Re([1,0,2,3,7,4,17,14,18,11,19,23]),function(ge,e,E,T,C,M,R,$,g,b,A,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=e.$bhc=void 0;let p=class{static{u=this}static{this.c=0}static{this.d=250}constructor(s,o){this.h=o,this.f=new Map,this.g=s.getProxy(T.$6K.MainThreadDecorations)}registerFileDecorationProvider(s,o){const t=u.c++;this.f.set(t,{provider:s,extensionDescription:o}),this.g.$registerDecorationProvider(t,o.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(t,null);return}const c=(0,g.$3b)(a);if(c.length<=u.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(r=>({uri:r,rank:(0,b.$Pe)(r.path,"/")})),i=(0,g.$zb)(h,(r,d)=>r.rank-d.rank||(0,b.$5e)(r.uri.path,d.uri.path)),l=[];e:for(const r of i){let d;for(const m of r){const f=(0,A.$mc)(m.uri.path);if(d!==f&&(d=f,l.push(m.uri)>=u.d))break e}}this.g.$onDidChange(t,l)});return new C.$8K(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(s,o,t){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:a,extensionDescription:c}=this.f.get(s);return await Promise.all(o.map(async h=>{try{const{uri:i,id:l}=h,r=await Promise.resolve(a.provideFileDecoration(E.URI.revive(i),t));if(!r)return;try{C.$rM.validate(r),r.badge&&typeof r.badge!="string"&&(0,D.$CF)(c,"codiconDecoration"),n[l]=[r.propagate,r.tooltip,r.badge,r.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(i){this.h.error(i)}})),n}};e.$bhc=p,e.$bhc=p=u=Je([Ke(0,R.$0M),Ke(1,$.$nj)],p),e.$chc=(0,M.$6h)("IExtHostDecorations")}),define(Pe[241],Re([1,0,158,99,2,3,7,8,5,14,28,43]),function(ge,e,E,T,C,M,R,$,g,b,A,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;class p{#e;#t;#i;constructor(o,t,n,a,c,h,i,l){this.d=o,this.e=t,this.f=n,this.g=a,this.h=c,this.c=!1,this.f=Math.max(a,n),this.#i=new A.$Ac(r=>h.getComparisonKey(r)),this.#e=i,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,t){if(!o){this.clear();return}this.j();let n=[];if(C.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(p.k);for(const i of o){const[l,r]=i;if((!h||l.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=l,n.push(l),this.#i.set(l,[])),r)this.#i.get(l)?.push(...r);else{const d=this.#i.get(l);d&&(d.length=0)}}}if(this.#t.fire(n),!this.#e)return;const a=[];let c=0;for(const h of n){let i=[];const l=this.#i.get(h);if(l)if(l.length>this.g){i=[];const r=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const m of l)if(m.severity===r[d]&&i.push({...$.Diagnostic.from(m),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,l.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=l.map(r=>({...$.Diagnostic.from(r),modelVersionId:this.h(h)}));if(a.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,a)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,t){this.j();for(const[n,a]of this)o.call(t,n,a,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.$8fc=p;let w=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const t=new A.$Ac;for(const n of o)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,n,a){this.j=t,this.k=n,this.l=a,this.g=new Map,this.h=new g.$Zd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,u._mapper),this.f=o.getProxy(M.$6K.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{g:n,f:a,h:c,j:h,k:i,l}=this,r=new class{$changeMany(f,S){a.$changeMany(f,S),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,f,S.length===0?"CLEARING":S)}$clear(f){a.$clear(f),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,f)}dispose(){a.dispose()}};let d;if(!t)t="_generated_diagnostic_collection_name_#"+u.c++,d=t;else if(!n.has(t))d=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do d=t+u.c++;while(n.has(d))}return new class extends p{constructor(){super(t,d,u.e,u.d,f=>l.getDocument(f)?.version,i.extUri,r,c),n.set(d,this)}dispose(){super.dispose(),n.delete(d)}}}getDiagnostics(o){if(o)return this.m(o);{const t=new Map,n=[];for(const a of this.g.values())a.forEach((c,h)=>{let i=t.get(c.toString());typeof i>"u"&&(i=n.length,t.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(o){let t=[];for(const n of this.g.values())n.has(o)&&(t=t.concat(n.get(o)));return t}$acceptMarkersChange(o){if(!this.n){const t="_generated_mirror",n=new p(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of o)this.n.set(C.URI.revive(t),n.map($.Diagnostic.to))}};e.$9fc=w,e.$9fc=w=u=Je([Ke(1,b.$nj),Ke(2,D.$7fc)],w)}),define(Pe[242],Re([1,0,2,3,23]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class M{constructor($){this.a=$.getProxy(T.$6K.MainThreadDialogs)}showOpenDialog($,g){return g?.allowUIResources&&(0,C.$CF)($,"showLocal"),this.a.$showOpenDialog(g).then(b=>b?b.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(g=>g?E.URI.revive(g):void 0)}}e.$dhc=M}),define(Pe[243],Re([1,0,15,2,7,3,12,20,11]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class b{static{this.a=0}constructor(D,u,p){this.d=u,this.e=p,this.b=new Map,this.c=D.getProxy(M.$6K.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(R.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const p=b.a++;this.b.set(p,u),this.c.$registerTextContentProvider(p,D);let w;if(typeof u.onDidChange=="function"){let s;w=u.onDidChange(async o=>{if(o.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;s&&await s;const t=this.$provideTextDocumentContent(p,o).then(async n=>{if(!n&&typeof n!="string")return;const a=this.d.getDocument(o);if(!a)return;const c=(0,g.$Ze)(n);if(!a.equalLines(c))return this.c.$onVirtualDocumentChange(o,n)}).catch(E.$1).finally(()=>{s===t&&(s=void 0)});s=t})}return new C.$8K(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(D,u){const p=this.b.get(D);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(u),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$ehc=b}),define(Pe[244],Re([1,0,5,6,2,3,103,8,16,26,7]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class D{constructor(p,w){this.a=new E.$Vd,this.b=new E.$Vd,this.c=new E.$Vd,this.d=new E.$Vd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Sc,this.h=new Map,this.f=p.getProxy(M.$6K.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const w=this.g.getDocument(p);if(w)return w}getDocument(p){const w=this.getDocumentData(p);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return w.document}ensureDocumentData(p){const w=this.g.getDocument(p);if(w)return Promise.resolve(w);let s=this.h.get(p.toString());return s||(s=this.f.$tryOpenDocument(p).then(o=>{this.h.delete(p.toString());const t=C.URI.revive(o);return(0,g.$Tf)(this.g.getDocument(t))},o=>(this.h.delete(p.toString()),Promise.reject(o))),this.h.set(p.toString(),s)),s}createDocumentData(p){return this.f.$tryCreateDocument(p).then(w=>C.URI.revive(w))}$acceptModelLanguageChanged(p,w){const s=C.URI.revive(p),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(w),this.a.fire(o.document)}$acceptModelSaved(p){const w=C.URI.revive(p),s=this.g.getDocument(w);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(p,w){const s=C.URI.revive(p),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(w),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,w,s){const o=C.URI.revive(p),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");t._acceptIsDirty(s),t.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,b.$wn)({document:t.document,contentChanges:w.changes.map(a=>({range:$.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:n}))}setWordDefinitionFor(p,w){(0,R.$_M)(p,w)}}e.$5fc=D}),define(Pe[61],Re([1,0,53,5,6,2,4,3,103,17,109,8,14,28,12,67,39]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=e.$hN=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new T.$Vd,this.e=new T.$Vd,this.f=new T.$Vd,this.g=new T.$Vd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],l=[];if(c.removedDocuments)for(const r of c.removedDocuments){const d=M.URI.revive(r),m=this.c.get(d);m?.unref()&&(this.c.delete(d),h.push(m.value))}if(c.addedDocuments)for(const r of c.addedDocuments){const d=M.URI.revive(r.uri);let m=this.c.get(d);if(m&&d.scheme!==w.Schemas.vscodeNotebookCell&&d.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);m||(m=new t(new g.$aN(this.h.getProxy($.$6K.MainThreadDocuments),d,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(d,m),i.push(m.value)),m.ref()}if(c.removedEditors)for(const r of c.removedEditors){const d=this.b.get(r);this.b.delete(r),d&&l.push(d)}if(c.addedEditors)for(const r of c.addedEditors){const d=M.URI.revive(r.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const m=this.c.get(d).value,f=new A.$gN(r.id,this.h.getProxy($.$6K.MainThreadTextEditors),this.i,new o.$V(()=>m.document),r.selections.map(D.Selection.to),r.options,r.visibleRanges.map(S=>D.Range.to(S)),typeof r.editorPosition=="number"?D.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,C.$Oc)(h),(0,C.$Oc)(l),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$hN=n,e.$hN=n=Je([Ke(0,b.$0M),Ke(1,u.$nj)],n),e.$iN=(0,R.$6h)("IExtHostDocumentsAndEditors")}),define(Pe[62],Re([1,0,245,5,16,2,4,3,17,8,7]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=e.$Egc=void 0,e.$Egc=(0,R.$6h)("IExtHostEditorTabs");class D{constructor(o,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$NM(M.URI.revive(this.b.input.uri));case 2:return new A.$OM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$PM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$QM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$RM(this.b.input.viewType);case 4:return new A.$SM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$TM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$UM;case 9:return new A.$VM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$WM(this.b.input.providerId);default:return}}}class u{constructor(o,t){this.c=[],this.d="",this.b=o,this.e=t;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new D(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return b.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new D(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const t=this.c.find(n=>n.tabId===o.tabDto.id);if(!t)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(o.tabDto),t}activeTabId(){return this.d}}let p=class{constructor(o){this.b=new T.$Vd,this.c=new T.$Vd,this.e=[],this.a=o.getProxy($.$6K.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,t={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,C.$Tf)(o.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,a)=>{const c=Array.isArray(n)?n:[n];return c.length?w(c[0])?this.j(c,a):this.i(c,a):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(o){const t=new Set(this.e.map(r=>r.groupId)),n=new Set(o.map(r=>r.groupId)),a=(0,E.$L)(t,n),c=this.e.filter(r=>a.removed.includes(r.groupId)).map(r=>r.apiObject),h=[],i=[];this.e=o.map(r=>{const d=new u(r,()=>this.d);return a.added.includes(d.groupId)?h.push(d.apiObject):i.push(d.apiObject),d});const l=(0,C.$Tf)(o.find(r=>r.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const t=this.e.find(n=>n.groupId===o.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const t=this.e.find(a=>a.groupId===o.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(t=>t.apiObject===o)}async i(o,t){const n=[];for(const a of o){const c=this.g(a);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,t)}async j(o,t){const n=[];for(const a of o){const c=this.h(a);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,t)}};e.$Fgc=p,e.$Fgc=p=Je([Ke(0,g.$0M)],p);function w(s){return s.tabs!==void 0}}),define(Pe[246],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class C{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$6K.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const b=this.a.get(R);if(!b)throw new Error("Embedding vector provider not found");const A=await b.provideEmbeddingVector($,g);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,g){const b=this.b;return this.b++,this.a.set(b,g),this.c.$registerAiEmbeddingVectorProvider($,b),new T.$8K(()=>{this.c.$unregisterAiEmbeddingVectorProvider(b),this.a.delete(b)})}}e.$ghc=C}),define(Pe[247],Re([1,0,2,3,6,7,8,295,11,24,23,52]),function(ge,e,E,T,C,M,R,$,g,b,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class u{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const o=this.a.indexOf(s);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),o=[];let t,n,a=14,c=14;for(const h of s){let i=t?(0,g.$bf)(t,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(a=c,c=9):c+=1,o.push([n,h.toUpperCase().charCodeAt(i),c]),o.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;t=h,c=a}o.push([9,58,10]),o.push([10,47,12]),this.b=new $.$uZ(o)}}provideDocumentLinks(s){this.c();const o=[],t=$.$vZ.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of t){const a=R.DocumentLink.to(n);a.target&&o.push(a)}return o}}class p{constructor(s,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(T.$6K.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,o,t,n={}){if(p.j(t),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const a=this.h++;this.b.add(o),this.d.add(o),this.c.set(a,t);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,A.$CF)(s,"fsChunks"),c+=4);let h;n.isReadonly&&(0,D.$jk)(n.isReadonly)&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(a,o,c,h).catch(l=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${o}`),console.error(l)});const i=t.onDidChangeFile(l=>{const r=[];for(const d of l){const{uri:m,type:f}=d;if(m.scheme!==o)continue;let S;switch(f){case M.FileChangeType.Changed:S=0;break;case M.FileChangeType.Created:S=1;break;case M.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:m,type:S})}this.a.$onFileSystemChange(a,r)});return(0,C.$Rc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(a),this.a.$unregisterProvider(a)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:o,ctime:t,mtime:n,size:a,permissions:c}=s;return{type:o,ctime:t,mtime:n,size:a,permissions:c}}$stat(s,o){return Promise.resolve(this.l(s).stat(E.URI.revive(o))).then(t=>p.k(t))}$readdir(s,o){return Promise.resolve(this.l(s).readDirectory(E.URI.revive(o)))}$readFile(s,o){return Promise.resolve(this.l(s).readFile(E.URI.revive(o))).then(t=>b.$je.wrap(t))}$writeFile(s,o,t,n){return Promise.resolve(this.l(s).writeFile(E.URI.revive(o),t.buffer,n))}$delete(s,o,t){return Promise.resolve(this.l(s).delete(E.URI.revive(o),t))}$rename(s,o,t,n){return Promise.resolve(this.l(s).rename(E.URI.revive(o),E.URI.revive(t),n))}$copy(s,o,t,n){const a=this.l(s);if(!a.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(a.copy(E.URI.revive(o),E.URI.revive(t),n))}$mkdir(s,o){return Promise.resolve(this.l(s).createDirectory(E.URI.revive(o)))}$watch(s,o,t,n){const a=this.l(s).watch(E.URI.revive(t),n);this.f.set(o,a)}$unwatch(s,o){const t=this.f.get(o);t&&(t.dispose(),this.f.delete(o))}$open(s,o,t){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(o),t))}$close(s,o){const t=this.l(s);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(o))}$read(s,o,t,n){const a=this.l(s);if(!a.read)throw new Error('FileSystemProvider does not implement "read"');const c=b.$je.alloc(n);return Promise.resolve(a.read(o,t,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(s,o,t,n){const a=this.l(s);if(!a.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(a.write(o,t,n.buffer,0,n.byteLength))}l(s){const o=this.c.get(s);if(!o){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return o}}e.$hhc=p}),define(Pe[63],Re([1,0,3,42,7,24,4,17,43,6,13,25,12]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=e.$tgc=void 0;let w=p=class{constructor(o,t){this.b=new Map,this.c=new A.$ch,this.a=o.getProxy(E.$6K.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(a){try{let c;const h=n.b.get(a.scheme);return h?(await n.a.$ensureActivation(a.scheme),c=await h.impl.stat(a)):c=await n.a.$stat(a),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){p.e(c)}},async readDirectory(a){try{const c=n.b.get(a.scheme);return c?(await n.a.$ensureActivation(a.scheme),(await c.impl.readDirectory(a)).slice()):await n.a.$readdir(a)}catch(c){return p.e(c)}},async createDirectory(a){try{const c=n.b.get(a.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(a.scheme),await n.d(c.impl,c.extUri,a)):await n.a.$mkdir(a)}catch(c){return p.e(c)}},async readFile(a){try{const c=n.b.get(a.scheme);return c?(await n.a.$ensureActivation(a.scheme),(await c.impl.readFile(a)).slice()):(await n.a.$readFile(a)).buffer}catch(c){return p.e(c)}},async writeFile(a,c){try{const h=n.b.get(a.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(a.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(a)),await n.c.queueFor(a,()=>Promise.resolve(h.impl.writeFile(a,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(a,M.$je.wrap(c))}catch(h){return p.e(h)}},async delete(a,c){try{const h=n.b.get(a.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(a.scheme),await h.impl.delete(a,{recursive:!1,...c})):await n.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return p.e(h)}},async rename(a,c,h){try{return await n.a.$rename(a,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},async copy(a,c,h){try{return await n.a.$copy(a,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},isWritableFileSystem(a){const c=t.getCapabilities(a);if(typeof c=="number")return!(c&2048)}})}async d(o,t,n){const a=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&T.FileType.Directory))throw C.$jM.FileExists(`Unable to create folder '${n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$Gk(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;a.push(t.basename(n)),n=t.dirname(n)}for(let c=a.length-1;c>=0;c--){n=t.joinPath(n,a[c]);try{await o.createDirectory(n)}catch(h){if(T.$Gk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof C.$jM)throw o;if(o instanceof T.$Ck)switch(o.code){case T.FileSystemProviderErrorCode.FileExists:throw C.$jM.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$jM.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$jM.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$jM.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$jM.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$jM.Unavailable(o.message);default:throw new C.$jM(o.message,o.name)}if(!(o instanceof Error))throw new C.$jM(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw C.$jM.Unavailable(o.message);switch(o.name){case T.FileSystemProviderErrorCode.FileExists:throw C.$jM.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$jM.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$jM.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$jM.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$jM.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$jM.Unavailable(o.message);default:throw new C.$jM(o.message,o.name)}}addFileSystemProvider(o,t,n){return this.b.set(o,{impl:t,extUri:n?.isCaseSensitive?D.$xg:D.$zg,isReadonly:!!n?.isReadonly}),(0,b.$Rc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??D.$xg}};e.$tgc=w,e.$tgc=w=p=Je([Ke(0,$.$0M),Ke(1,g.$7fc)],w),e.$ugc=(0,R.$6h)("IExtHostConsumerFileSystem")}),define(Pe[248],Re([1,0,5,34,2,3,8,7,39]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;class b{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,w,s,o,t,n){this.a=Math.random(),this.b=new E.$Vd,this.c=new E.$Vd,this.d=new E.$Vd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const a=(0,T.$Mj)(t),c=typeof t=="string",h=n?.correlate,i=o(l=>{if(!(typeof l.session=="number"&&l.session!==this.a)&&!(h&&typeof l.session>"u")){if(!n?.ignoreCreateEvents)for(const r of l.created){const d=C.URI.revive(r);a(d.fsPath)&&(!c||w.getWorkspaceFolder(d))&&this.b.fire(d)}if(!n?.ignoreChangeEvents)for(const r of l.changed){const d=C.URI.revive(r);a(d.fsPath)&&(!c||w.getWorkspaceFolder(d))&&this.c.fire(d)}if(!n?.ignoreDeleteEvents)for(const r of l.deleted){const d=C.URI.revive(r);a(d.fsPath)&&(!c||w.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=$.$8K.from(this.i(p,s,t,n,n?.correlate),this.b,this.c,this.d,i)}i(p,w,s,o,t){const n=$.$8K.from();if(typeof s=="string")return n;const a=p.getProxy(M.$6K.MainThreadFileSystemEventService);let c=!1;return(s.pattern.includes(T.$Ij)||s.pattern.includes(T.$Jj))&&(c=!0),a.$watch(w.identifier.value,this.a,s.baseUri,{recursive:c,excludes:o?.excludes??[]},!!t),$.$8K.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(p){this.a=p,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(C.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(p,w,s){this.j=p,this.k=w,this.l=s,this.a=new E.$Vd,this.b=new E.$Vd,this.c=new E.$Vd,this.d=new E.$Vd,this.g=new E.$Xd,this.h=new E.$Xd,this.i=new E.$Xd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,w,s,o){return new b(this.j,p,w,this.a.event,R.GlobPattern.from(s),o)}$onFileEvent(p){this.a.fire(new A(p))}$onDidRunFileOperation(p,w){switch(p){case 2:this.b.fire(Object.freeze({files:w.map(s=>({oldUri:C.URI.revive(s.source),newUri:C.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(s=>C.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(s=>C.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,w){return(s,o,t)=>{const n=function(c){s.call(o,c)};return n.extension=p,w.event(n,void 0,t)}}async $onWillRunFileOperation(p,w,s,o){switch(p){case 2:return await this.n(this.g,{files:w.map(t=>({oldUri:C.URI.revive(t.source),newUri:C.URI.revive(t.target)}))},s,o);case 1:return await this.n(this.i,{files:w.map(t=>C.URI.revive(t.target))},s,o);case 0:case 3:return await this.n(this.h,{files:w.map(t=>C.URI.revive(t.target))},s,o)}}async n(p,w,s,o){const t=new Set,n=[];if(await p.fireAsync(w,o,async(c,h)=>{const i=Date.now(),l=await Promise.resolve(c);l instanceof $.$fL&&(n.push([h.extension,l]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const a={edits:[]};for(const[,c]of n){const{edits:h}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(h)}return{edit:a,extensionNames:Array.from(t)}}}e.$ihc=D}),define(Pe[249],Re([1,0,6,2,3,8,7,32,13]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;class b{static{this.a=0}constructor(p,w){this.extension=p,this.provider=w,this.handle=b.a++}}class A{constructor(p){this.session=p,this.responses=[]}}class D{static{this.a=0}constructor(p,w,s,o){this.f=s,this.g=o,this.b=new Map,this.d=new Map,this.e=p.getProxy(C.$6K.MainThreadInlineChat),w.registerApiCommand(new $.$xN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$vN("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?M.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?M.Position.from(t.position):void 0}})],$.$wN.Void))}registerProvider(p,w,s){const o=new b(p,w);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,s?.label??p.displayName??p.name,p.identifier.value,typeof w.handleInteractiveEditorResponseFeedback=="function",typeof w.provideFollowups=="function",s?.supportReportIssue??!1),(0,E.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(p,w,s,o){const t=this.b.get(p);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(T.URI.revive(w)),a=M.Selection.to(s),c=await t.provider.prepareInteractiveEditorSession({document:n,selection:a},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=D.a++;return this.d.set(h,new A(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:M.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,w,s,o){const t=this.b.get(p);if(!t)return;const n=this.d.get(w.id);if(!n)return;const a={prompt:s.prompt,selection:M.Selection.to(s.selection),wholeRange:M.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,withIntentDetection:s.withIntentDetection};let c=!1;const h={report:async L=>{if(!s.live&&L.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:L.message,edits:L.edits?.map(M.TextEdit.from),editsShouldBeInstant:L.editsShouldBeInstant,slashCommand:L.slashCommand?.command,markdownFragment:R.$wL.isMarkdownString(L.content)?L.content.value:L.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,a,h,o));let l;try{l=await(0,g.$Ug)(i,o)}finally{c=!0}if(!l)return;const r=n.responses.push(l)-1,d={wholeRange:M.Range.from(l.wholeRange),placeholder:l.placeholder};if(!D.h(l))return{...d,id:r,type:"editorEdit",message:M.MarkdownString.from(l.contents),edits:[]};const{edits:m,contents:f}=l,S=f!==void 0?M.MarkdownString.from(f):void 0;return m instanceof R.$fL?{...d,id:r,type:"bulkEdit",edits:M.WorkspaceEdit.from(m),message:S}:{...d,id:r,type:"editorEdit",edits:m.map(M.TextEdit.from),message:S}}async $provideFollowups(p,w,s,o){const t=this.b.get(p),n=this.d.get(w),a=n?.responses[s];if(t&&a&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(n.session,a,o));return(await(0,g.$Ug)(c,o))?.map(M.ChatReplyFollowup.from)}}$handleFeedback(p,w,s,o){const t=this.b.get(p),n=this.d.get(w),a=n?.responses[s];if(t&&a){const c=M.InteractiveEditorResponseFeedbackKind.to(o);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,a,c)}}$releaseSession(p,w){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$jhc=D}),define(Pe[250],Re([1,0,2,32]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class C{constructor(R,$,g,b,A){this.a=$,this.b=g,this.c=b;const D=new T.$xN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$vN("showOptions","Show Options",u=>!0,u=>u),new T.$vN("resource","Interactive resource Uri",u=>!0,u=>u),new T.$vN("controllerId","Notebook controller Id",u=>!0,u=>u),new T.$vN("title","Interactive editor title",u=>!0,u=>u)],new T.$wN("Notebook and input URI",u=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const p=this.a.getEditorById(u.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:E.URI.revive(u.notebookUri),inputUri:E.URI.revive(u.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:E.URI.revive(u.notebookUri),inputUri:E.URI.revive(u.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(R,$,g,b){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:g,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$whc=C}),define(Pe[251],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class C{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$6K.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(R);if(!g)throw new Error("Issue request handler not found");const b=await g.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const b=await g.provideIssueData($);if(!b)throw new Error("Issue data provider returned no result");return b}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const b=await g.provideIssueTemplate($);if(!b)throw new Error("Issue template provider returned no result");return b}registerIssueUriRequestHandler(R,$){const g=R.identifier.value;return this.a.set(g,$),this.c.$registerIssueUriRequestHandler(g),new T.$8K(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(R,$){const g=R.identifier.value;return this.b.set(g,$),this.c.$registerIssueDataProvider(g),new T.$8K(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$xhc=C}),define(Pe[252],Re([1,0,6,3]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class C{constructor(R){this.b=0,this.a=R.getProxy(T.$6K.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$yhc=C}),define(Pe[253],Re([1,0,2,26,8,7,80,3,11,29,18,16,296,20,22,6,96,89,75,60,15,13,23,160]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c,h,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class r{constructor(F,q){this.d=F,this.e=q}async provideDocumentSymbols(F,q){const K=this.d.getDocument(F),U=await this.e.provideDocumentSymbols(K,q);if(!(0,A.$Kb)(U))return U[0]instanceof M.$oL?U.map(C.DocumentSymbol.from):r.f(U)}static f(F){F=F.slice(0).sort((U,X)=>{let x=U.location.range.start.compareTo(X.location.range.start);return x===0&&(x=X.location.range.end.compareTo(U.location.range.end)),x});const q=[],K=[];for(const U of F){const X={name:U.name||"!!MISSING: name!!",kind:C.SymbolKind.from(U.kind),tags:U.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:U.containerName,range:C.Range.from(U.location.range),selectionRange:C.Range.from(U.location.range),children:[]};for(;;){if(K.length===0){K.push(X),q.push(X);break}const x=K[K.length-1];if(b.$Us.containsRange(x.range,X.range)&&!b.$Us.equalsRange(x.range,X.range)){x.children?.push(X),K.push(X);break}K.pop()}}return q}}class d{constructor(F,q,K,U,X,x){this.f=F,this.g=q,this.h=K,this.j=U,this.k=X,this.l=x,this.d=new n.$3fc("CodeLens"),this.e=new Map}async provideCodeLenses(F,q){const K=this.f.getDocument(F),U=await this.h.provideCodeLenses(K,q);if(!U||q.isCancellationRequested)return;const X=this.d.add(U),x=new s.$Sc;this.e.set(X,x);const Ee={cacheId:X,lenses:[]};for(let Te=0;Te<U.length;Te++)Ee.lenses.push({cacheId:[X,Te],range:C.Range.from(U[Te].range),command:this.g.toInternal(U[Te].command,x)});return Ee}async resolveCodeLens(F,q){const K=F.cacheId&&this.d.get(...F.cacheId);if(!K)return;let U;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?U=K:U=await this.h.resolveCodeLens(K,q),U||(U=K),q.isCancellationRequested)return;const X=F.cacheId&&this.e.get(F.cacheId[0]);if(X){if(!U.command){const x=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,x),this.l.error(x);return}return F.command=this.g.toInternal(U.command,X),F}}releaseCodeLenses(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}}function m(ye){return Array.isArray(ye)?ye.map(C.DefinitionLink.from):ye?[C.DefinitionLink.from(ye)]:[]}class f{constructor(F,q){this.d=F,this.e=q}async provideDefinition(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideDefinition(U,X,K);return m(x)}}class S{constructor(F,q){this.d=F,this.e=q}async provideDeclaration(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideDeclaration(U,X,K);return m(x)}}class L{constructor(F,q){this.d=F,this.e=q}async provideImplementation(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideImplementation(U,X,K);return m(x)}}class v{constructor(F,q){this.d=F,this.e=q}async provideTypeDefinition(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideTypeDefinition(U,X,K);return m(x)}}class y{constructor(F,q){this.d=F,this.e=q}async provideHover(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideHover(U,X,K);if(!(!x||(0,A.$Kb)(x.contents)))return x.range||(x.range=U.getWordRangeAtPosition(X)),x.range||(x.range=new M.$0K(X,X)),C.Hover.from(x)}}class k{constructor(F,q){this.d=F,this.e=q}async provideEvaluatableExpression(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideEvaluatableExpression(U,X,K);if(x)return C.EvaluatableExpression.from(x)}}class N{constructor(F,q){this.d=F,this.e=q}async provideInlineValues(F,q,K,U){const X=this.d.getDocument(F),x=await this.e.provideInlineValues(X,C.Range.to(q),C.InlineValueContext.to(K),U);if(Array.isArray(x))return x.map(Ee=>C.InlineValue.from(Ee))}}class O{constructor(F,q){this.d=F,this.e=q}async provideDocumentHighlights(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideDocumentHighlights(U,X,K);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class G{constructor(F,q){this.d=F,this.e=q}async provideMultiDocumentHighlights(F,q,K,U){const X=this.d.getDocument(F),x=K.map(Ve=>this.d.getDocument(Ve)),Ee=C.Position.to(q),Te=await this.e.provideMultiDocumentHighlights(X,Ee,x,U);if(Array.isArray(Te))return Te.map(C.MultiDocumentHighlight.from)}}class W{constructor(F,q){this.d=F,this.e=q}async provideLinkedEditingRanges(F,q,K){const U=this.d.getDocument(F),X=C.Position.to(q),x=await this.e.provideLinkedEditingRanges(U,X,K);if(x&&Array.isArray(x.ranges))return{ranges:(0,A.$Hb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class z{constructor(F,q){this.d=F,this.e=q}async provideReferences(F,q,K,U){const X=this.d.getDocument(F),x=C.Position.to(q),Ee=await this.e.provideReferences(X,x,K,U);if(Array.isArray(Ee))return Ee.map(C.location.from)}}class P{static{this.d=1e3}constructor(F,q,K,U,X,x,Ee){this.g=F,this.h=q,this.j=K,this.k=U,this.l=X,this.m=x,this.n=Ee,this.e=new n.$3fc("CodeAction"),this.f=new Map}async provideCodeActions(F,q,K,U){const X=this.g.getDocument(F),x=u.$Ws.isISelection(q)?C.Selection.to(q):C.Range.to(q),Ee=[];for(const nt of this.j.getDiagnostics(F))if(x.intersection(nt.range)&&Ee.push(nt)>P.d)break;const Te={diagnostics:Ee,only:K.only?new M.$qL(K.only):void 0,triggerKind:C.CodeActionTriggerKind.to(K.trigger)},Ve=await this.k.provideCodeActions(X,x,Te,U);if(!(0,A.$Lb)(Ve)||U.isCancellationRequested)return;const He=this.e.add(Ve),Ye=new s.$Sc;this.f.set(He,Ye);const st=[];for(let nt=0;nt<Ve.length;nt++){const tt=Ve[nt];tt&&(P.o(tt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,Ye)})):(Te.only&&(tt.kind?Te.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[He,nt],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,Ye),diagnostics:tt.diagnostics&&tt.diagnostics.map(C.Diagnostic.from),edit:tt.edit&&C.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,i.$BF)(this.m,"codeActionAI")?tt.isAI:!1,disabled:tt.disabled?.reason})))}return{cacheId:He,actions:st}}async resolveCodeAction(F,q){const[K,U]=F,X=this.e.get(K,U);if(!X||P.o(X))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(X,q)??X;let Ee;x.edit&&(Ee=C.WorkspaceEdit.from(x.edit,void 0));let Te;if(x.command){const Ve=this.f.get(K);Ve&&(Te=this.h.toInternal(x.command,Ve))}return{edit:Ee,command:Te}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class I{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,K,U,X){this.d=F,this.e=q,this.f=K,this.g=U,this.h=X}async prepareDocumentPaste(F,q,K,U){if(!this.f.prepareDocumentPaste)return;const X=this.e.getDocument(F),x=q.map(Ve=>C.Range.to(Ve)),Ee=C.DataTransfer.toDataTransfer(K,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(X,x,Ee,U),U.isCancellationRequested)return;const Te=Array.from(Ee).filter(([,Ve])=>!(Ve instanceof M.$WL));return C.DataTransfer.from(Te)}async providePasteEdits(F,q,K,U,X){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(q),Ee=K.map(He=>C.Range.to(He)),Te=C.DataTransfer.toDataTransfer(U,async He=>(await this.d.$resolvePasteFileData(this.g,F,He)).buffer),Ve=await this.f.provideDocumentPasteEdits(x,Ee,Te,X);if(Ve)return{label:Ve.label??(0,l.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ve.yieldTo?.map(He=>"mimeType"in He?He:{providerId:I.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?C.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class H{constructor(F,q){this.d=F,this.e=q}async provideDocumentFormattingEdits(F,q,K){const U=this.d.getDocument(F),X=await this.e.provideDocumentFormattingEdits(U,q,K);if(Array.isArray(X))return X.map(C.TextEdit.from)}}class ae{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeFormattingEdits(F,q,K,U){const X=this.d.getDocument(F),x=C.Range.to(q),Ee=await this.e.provideDocumentRangeFormattingEdits(X,x,K,U);if(Array.isArray(Ee))return Ee.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,q,K,U){(0,D.$Sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const X=this.d.getDocument(F),x=q.map(C.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(X,x,K,U);if(Array.isArray(Ee))return Ee.map(C.TextEdit.from)}}class de{constructor(F,q){this.d=F,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,q,K,U,X){const x=this.d.getDocument(F),Ee=C.Position.to(q),Te=await this.e.provideOnTypeFormattingEdits(x,Ee,K,U,X);if(Array.isArray(Te))return Te.map(C.TextEdit.from)}}class we{constructor(F,q){this.e=F,this.f=q,this.d=new n.$3fc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,q){const K=await this.e.provideWorkspaceSymbols(F,q);if(!(0,A.$Lb)(K))return{symbols:[]};const U=this.d.add(K),X={cacheId:U,symbols:[]};for(let x=0;x<K.length;x++){const Ee=K[x];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}X.symbols.push({...C.WorkspaceSymbol.from(Ee),cacheId:[U,x]})}return X}async resolveWorkspaceSymbol(F,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const K=this.d.get(...F.cacheId);if(K){const U=await this.e.resolveWorkspaceSymbol(K,q);return U&&(0,T.$yn)(F,C.WorkspaceSymbol.from(U),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class ke{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,q,K){this.d=F,this.e=q,this.f=K}async provideRenameEdits(F,q,K,U){const X=this.d.getDocument(F),x=C.Position.to(q);try{const Ee=await this.e.provideRenameEdits(X,x,K,U);return Ee?C.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Te=ke.g(Ee);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(F,q,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const U=this.d.getDocument(F),X=C.Position.to(q);try{const x=await this.e.prepareRename(U,X,K);let Ee,Te;if(M.$0K.isRange(x)?(Ee=x,Te=U.getText(x)):(0,D.$Kf)(x)&&(Ee=x.range,Te=x.placeholder),!Ee||!Te)return;if(Ee.start.line>X.line||Ee.end.line<X.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(Ee),text:Te}}catch(x){const Ee=ke.g(x);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(x)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class le{constructor(F,q){this.resultId=F,this.tokens=q}}class ve{constructor(F,q){this.f=F,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,q,K){const U=this.f.getDocument(F),X=q!==0?this.d.get(q):null;let x=typeof X?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(U,X.resultId,K):await this.g.provideDocumentSemanticTokens(U,K);return X&&this.d.delete(q),x?(x=ve.h(x),this.o(ve.n(X,x),x)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return ve.j(F)?ve.k(F)?F:new M.$nM(new Uint32Array(F.data),F.resultId):ve.l(F)?ve.m(F)?F:new M.$pM(F.edits.map(q=>new M.$oM(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const q of F.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(F,q){if(!ve.j(q)||!F||!F.tokens)return q;const K=F.tokens,U=K.length,X=q.data,x=X.length;let Ee=0;const Te=Math.min(U,x);for(;Ee<Te&&K[Ee]===X[Ee];)Ee++;if(Ee===U&&Ee===x)return new M.$pM([],q.resultId);let Ve=0;const He=Te-Ee;for(;Ve<He&&K[U-Ve-1]===X[x-Ve-1];)Ve++;return new M.$pM([{start:Ee,deleteCount:U-Ee-Ve,data:X.subarray(Ee,x-Ve)}],q.resultId)}o(F,q){if(ve.j(F)){const K=this.e++;return this.d.set(K,new le(F.resultId,F.data)),(0,o.$s$)({id:K,type:"full",data:F.data})}if(ve.l(F)){const K=this.e++;return ve.j(q)?this.d.set(K,new le(q.resultId,q.data)):this.d.set(K,new le(F.resultId)),(0,o.$s$)({id:K,type:"delta",deltas:(F.edits||[]).map(U=>({start:U.start,deleteCount:U.deleteCount,data:U.data}))})}return null}}class se{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeSemanticTokens(F,q,K){const U=this.d.getDocument(F),X=await this.e.provideDocumentRangeSemanticTokens(U,C.Range.to(q),K);return X?this.f(X):null}f(F){return(0,o.$s$)({id:0,type:"full",data:F.data})}}class be{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,q,K,U,X){this.f=F,this.g=q,this.h=K,this.j=U,this.k=X,this.d=new n.$3fc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,q,K,U){const X=this.f.getDocument(F),x=C.Position.to(q),Ee=X.getWordRangeAtPosition(x)||new M.$0K(x,x),Te=Ee.with({end:x}),Ve=new a.$Rd,He=await this.h.provideCompletionItems(X,x,U,C.CompletionContext.to(K));if(!He||U.isCancellationRequested)return;const Ye=Array.isArray(He)?new M.$DL(He):He,st=be.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),nt=new s.$Sc;this.e.set(st,nt);const tt=[],at={x:st,b:tt,a:{replace:C.Range.from(Ee),insert:C.Range.from(Te)},c:Ye.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Ye.items.length;ct++){const je=Ye.items[ct],vt=this.l(je,[st,ct],Te,Ee);tt.push(vt)}return at}async resolveCompletionItem(F,q){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...F);if(!K)return;const U=this.l(K,F),X=await this.h.resolveCompletionItem(K,q);if(!X)return;const x=this.l(X,F);return(U.h!==x.h||U.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(U.n!==x.n||U.o!==x.o||!(0,T.$zn)(U.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...U,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q,K,U){const X=this.e.get(q[0]);if(!X)throw Error("DisposableStore is missing...");const x=this.g.toInternal(F.command,X),Ee={x:q,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=F.textEdit.newText):typeof F.insertText=="string"?Ee.h=F.insertText:F.insertText instanceof M.$gL&&(Ee.h=F.insertText.value,Ee.i|=4);let Te;return F.textEdit?Te=F.textEdit.range:F.range&&(Te=F.range),M.$0K.isRange(Te)?Ee.j=C.Range.from(Te):Te&&(!K?.isEqual(Te.inserting)||!U?.isEqual(Te.replacing))&&(Ee.j={insert:C.Range.from(Te.inserting),replace:C.Range.from(Te.replacing)}),Ee}}class ne{async provideInlineCompletions(F,q,K,U){}disposeCompletions(F){}handleDidShowCompletionItem(F,q,K){}handlePartialAccept(F,q,K){}}class Y extends ne{constructor(F,q,K,U){super(),this.f=F,this.g=q,this.h=K,this.j=U,this.d=new V,this.e=(0,i.$BF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$BF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,q,K,U){const X=this.g.getDocument(F),x=C.Position.to(q),Ee=await this.h.provideInlineCompletionItems(X,x,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:C.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},U);if(!Ee||U.isCancellationRequested)return;const Te=Array.isArray(Ee)?Ee:Ee.items,Ve=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],He=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:Te}),items:Te.map((nt,tt)=>{let at;nt.command&&(Ye||(Ye=new s.$Sc),at=this.j.toInternal(nt.command,Ye));const ct=nt.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:nt.filterText,range:nt.range?C.Range.from(nt.range):void 0,command:at,idx:tt,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ve.map(nt=>(Ye||(Ye=new s.$Sc),this.j.toInternal(nt,Ye))),suppressSuggestions:!1,enableForwardStability:He}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,q,K){const U=this.d.get(F)?.items[q];U&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(U,K)}handlePartialAccept(F,q,K){const U=this.d.get(F)?.items[q];U&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(U,K)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const q=this.e++;return this.d.set(q,F),q}disposeReferenceId(F){const q=this.d.get(F);return this.d.delete(F),q}get(F){return this.d.get(F)}}class ie{constructor(F,q){this.e=F,this.f=q,this.d=new n.$3fc("SignatureHelp")}async provideSignatureHelp(F,q,K,U){const X=this.e.getDocument(F),x=C.Position.to(q),Ee=this.g(K),Te=await this.f.provideSignatureHelp(X,x,U,Ee);if(Te){const Ve=this.d.add([Te]);return{...C.SignatureHelp.from(Te),id:Ve}}}g(F){let q;if(F.activeSignatureHelp){const K=C.SignatureHelp.to(F.activeSignatureHelp),U=this.d.get(F.activeSignatureHelp.id,0);U?(q=U,q.activeSignature=K.activeSignature,q.activeParameter=K.activeParameter):q=K}return{...F,activeSignatureHelp:q}}releaseSignatureHelp(F){this.d.delete(F)}}class Ie{constructor(F,q,K,U,X){this.f=F,this.g=q,this.h=K,this.j=U,this.k=X,this.d=new n.$3fc("InlayHints"),this.e=new Map}async provideInlayHints(F,q,K){const U=this.f.getDocument(F),X=C.Range.to(q),x=await this.h.provideInlayHints(U,X,K);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(K.isCancellationRequested)return;const Ee=this.d.add(x);this.e.set(Ee,new s.$Sc);const Te={hints:[],cacheId:Ee};for(let Ve=0;Ve<x.length;Ve++)this.l(x[Ve],X)&&Te.hints.push(this.m(x[Ve],[Ee,Ve]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Te}async resolveInlayHint(F,q){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...F);if(!K)return;const U=await this.h.resolveInlayHint(K,q);if(U&&this.l(U))return this.m(U,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q){return F.label.length===0||Array.isArray(F.label)&&F.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(q&&!q.contains(F.position))}m(F,q){const K=this.e.get(q[0]);if(!K)throw Error("DisposableStore is missing...");const U={label:"",cacheId:q,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};if(typeof F.label=="string")U.label=F.label;else{const X=[];U.label=X;for(const x of F.label){if(!x.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:x.value,tooltip:C.MarkdownString.fromStrict(x.tooltip)};M.$hL.isLocation(x.location)&&(Ee.location=C.location.from(x.location)),x.command&&(Ee.command=this.g.toInternal(x.command,K)),X.push(Ee)}}return U}}class Le{constructor(F,q){this.e=F,this.f=q,this.d=new n.$3fc("DocumentLink")}async provideLinks(F,q){const K=this.e.getDocument(F),U=await this.f.provideDocumentLinks(K,q);if(!(!Array.isArray(U)||U.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:U.filter(Le.g).map(C.DocumentLink.from)};{const X=this.d.add(U),x={links:[],cacheId:X};for(let Ee=0;Ee<U.length;Ee++){if(!Le.g(U[Ee]))continue;const Te=C.DocumentLink.from(U[Ee]);Te.cacheId=[X,Ee],x.links.push(Te)}return x}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,q){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...F);if(!K)return;const U=await this.f.resolveDocumentLink(K,q);if(!(!U||!Le.g(U)))return C.DocumentLink.from(U)}releaseLinks(F){this.d.delete(F)}}class Ce{constructor(F,q){this.d=F,this.e=q}async provideColors(F,q){const K=this.d.getDocument(F),U=await this.e.provideDocumentColors(K,q);return Array.isArray(U)?U.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(F,q,K){const U=this.d.getDocument(F),X=C.Range.to(q.range),x=C.Color.to(q.color),Ee=await this.e.provideColorPresentations(x,{document:U,range:X},K);if(Array.isArray(Ee))return Ee.map(C.ColorPresentation.from)}}class ce{constructor(F,q){this.d=F,this.e=q}async provideFoldingRanges(F,q,K){const U=this.d.getDocument(F),X=await this.e.provideFoldingRanges(U,q,K);if(Array.isArray(X))return X.map(C.FoldingRange.from)}}class te{constructor(F,q,K){this.d=F,this.e=q,this.f=K}async provideSelectionRanges(F,q,K){const U=this.d.getDocument(F),X=q.map(C.Position.to),x=await this.e.provideSelectionRanges(U,X,K);if(!(0,A.$Lb)(x))return[];if(x.length!==X.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Te=0;Te<X.length;Te++){const Ve=[];Ee.push(Ve);let He=X[Te],Ye=x[Te];for(;;){if(!Ye.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(C.SelectionRange.from(Ye)),!Ye.parent)break;He=Ye.range,Ye=Ye.parent}}return Ee}}class Q{constructor(F,q){this.f=F,this.g=q,this.d=new t.$cN(""),this.e=new Map}async prepareSession(F,q,K){const U=this.f.getDocument(F),X=C.Position.to(q),x=await this.g.prepareCallHierarchy(U,X,K);if(!x)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(x)?x.map(Te=>this.h(Ee,Te)):[this.h(Ee,x)]}async provideCallsTo(F,q,K){const U=this.j(F,q);if(!U)throw new Error("missing call hierarchy item");const X=await this.g.provideCallHierarchyIncomingCalls(U,K);if(X)return X.map(x=>({from:this.h(F,x.from),fromRanges:x.fromRanges.map(Ee=>C.Range.from(Ee))}))}async provideCallsFrom(F,q,K){const U=this.j(F,q);if(!U)throw new Error("missing call hierarchy item");const X=await this.g.provideCallHierarchyOutgoingCalls(U,K);if(X)return X.map(x=>({to:this.h(F,x.to),fromRanges:x.fromRanges.map(Ee=>C.Range.from(Ee))}))}releaseSession(F){this.e.delete(F)}h(F,q){const K=this.e.get(F),U=C.CallHierarchyItem.from(q,F,K.size.toString(36));return K.set(U._itemId,q),U}j(F,q){return this.e.get(F)?.get(q)}}class ee{constructor(F,q){this.f=F,this.g=q,this.d=new t.$cN(""),this.e=new Map}async prepareSession(F,q,K){const U=this.f.getDocument(F),X=C.Position.to(q),x=await this.g.prepareTypeHierarchy(U,X,K);if(!x)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(x)?x.map(Te=>this.h(Ee,Te)):[this.h(Ee,x)]}async provideSupertypes(F,q,K){const U=this.j(F,q);if(!U)throw new Error("missing type hierarchy item");const X=await this.g.provideTypeHierarchySupertypes(U,K);if(X)return X.map(x=>this.h(F,x))}async provideSubtypes(F,q,K){const U=this.j(F,q);if(!U)throw new Error("missing type hierarchy item");const X=await this.g.provideTypeHierarchySubtypes(U,K);if(X)return X.map(x=>this.h(F,x))}releaseSession(F){this.e.delete(F)}h(F,q){const K=this.e.get(F),U=C.TypeHierarchyItem.from(q,F,K.size.toString(36));return K.set(U._itemId,q),U}j(F,q){return this.e.get(F)?.get(q)}}class me{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,K,U,X){this.d=F,this.e=q,this.f=K,this.g=U,this.h=X}async provideDocumentOnDropEdits(F,q,K,U,X){const x=this.e.getDocument(q),Ee=C.Position.to(K),Te=C.DataTransfer.toDataTransfer(U,async He=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,He)).buffer),Ve=await this.f.provideDocumentDropEdits(x,Ee,Te,X);if(Ve)return{label:Ve.label??(0,l.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ve.yieldTo?.map(He=>"mimeType"in He?He:{providerId:me.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?C.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class pe{constructor(F,q){this.d=F,this.e=q}async provideMappedEdits(F,q,K,U){const X=E.URI.revive(F),x=this.d.getDocument(X),Ee=K.documents.map(He=>He.map(Ye=>({uri:E.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(st=>C.Range.to(st))}))),Te={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Ve=await this.e.provideMappedEdits(x,q,Te,U);return Ve?C.WorkspaceEdit.from(Ve):null}}class Ae{constructor(F,q){this.adapter=F,this.extension=q}}class he{static{this.d=0}constructor(F,q,K,U,X,x,Ee,Te){this.g=q,this.h=K,this.j=U,this.k=X,this.l=x,this.m=Ee,this.n=Te,this.f=new Map,this.e=F.getProxy($.$6K.MainThreadLanguageFeatures)}o(F,q){return C.DocumentSelector.from(F,this.g,q)}p(F){return new M.$8K(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return he.d++}async s(F,q,K,U,X,x=!1){const Ee=this.f.get(F);if(!Ee||!(Ee.adapter instanceof q))return U;const Te=Date.now();x||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ve=K(Ee.adapter,Ee.extension);return Promise.resolve(Ve).catch(He=>{(0,c.$4)(He)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(He),this.n.onExtensionError(Ee.extension.identifier,He))}).finally(()=>{x||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),p.CancellationToken.isCancellationToken(X)?(0,h.$Vg)(Ve,X):Ve}t(F,q){const K=this.q();return this.f.set(K,new Ae(F,q)),K}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,q,K,U){const X=this.t(new r(this.h,K),F),x=U&&U.label||he.u(F);return this.e.$registerDocumentSymbolProvider(X,this.o(q,F),x),this.p(X)}$provideDocumentSymbols(F,q,K){return this.s(F,r,U=>U.provideDocumentSymbols(E.URI.revive(q),K),void 0,K)}registerCodeLensProvider(F,q,K){const U=this.q(),X=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(U,new Ae(new d(this.h,this.j.converter,K,F,this.n,this.l),F)),this.e.$registerCodeLensSupport(U,this.o(q,F),X);let x=this.p(U);if(X!==void 0){const Ee=K.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(X));x=M.$8K.from(x,Ee)}return x}$provideCodeLenses(F,q,K){return this.s(F,d,U=>U.provideCodeLenses(E.URI.revive(q),K),void 0,K)}$resolveCodeLens(F,q,K){return this.s(F,d,U=>U.resolveCodeLens(q,K),void 0,void 0)}$releaseCodeLenses(F,q){this.s(F,d,K=>Promise.resolve(K.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(F,q,K){const U=this.t(new f(this.h,K),F);return this.e.$registerDefinitionSupport(U,this.o(q,F)),this.p(U)}$provideDefinition(F,q,K,U){return this.s(F,f,X=>X.provideDefinition(E.URI.revive(q),K,U),[],U)}registerDeclarationProvider(F,q,K){const U=this.t(new S(this.h,K),F);return this.e.$registerDeclarationSupport(U,this.o(q,F)),this.p(U)}$provideDeclaration(F,q,K,U){return this.s(F,S,X=>X.provideDeclaration(E.URI.revive(q),K,U),[],U)}registerImplementationProvider(F,q,K){const U=this.t(new L(this.h,K),F);return this.e.$registerImplementationSupport(U,this.o(q,F)),this.p(U)}$provideImplementation(F,q,K,U){return this.s(F,L,X=>X.provideImplementation(E.URI.revive(q),K,U),[],U)}registerTypeDefinitionProvider(F,q,K){const U=this.t(new v(this.h,K),F);return this.e.$registerTypeDefinitionSupport(U,this.o(q,F)),this.p(U)}$provideTypeDefinition(F,q,K,U){return this.s(F,v,X=>X.provideTypeDefinition(E.URI.revive(q),K,U),[],U)}registerHoverProvider(F,q,K,U){const X=this.t(new y(this.h,K),F);return this.e.$registerHoverProvider(X,this.o(q,F)),this.p(X)}$provideHover(F,q,K,U){return this.s(F,y,X=>X.provideHover(E.URI.revive(q),K,U),void 0,U)}registerEvaluatableExpressionProvider(F,q,K,U){const X=this.t(new k(this.h,K),F);return this.e.$registerEvaluatableExpressionProvider(X,this.o(q,F)),this.p(X)}$provideEvaluatableExpression(F,q,K,U){return this.s(F,k,X=>X.provideEvaluatableExpression(E.URI.revive(q),K,U),void 0,U)}registerInlineValuesProvider(F,q,K,U){const X=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new N(this.h,K),F);this.e.$registerInlineValuesProvider(x,this.o(q,F),X);let Ee=this.p(x);if(X!==void 0){const Te=K.onDidChangeInlineValues(Ve=>this.e.$emitInlineValuesEvent(X));Ee=M.$8K.from(Ee,Te)}return Ee}$provideInlineValues(F,q,K,U,X){return this.s(F,N,x=>x.provideInlineValues(E.URI.revive(q),K,U,X),void 0,X)}registerDocumentHighlightProvider(F,q,K){const U=this.t(new O(this.h,K),F);return this.e.$registerDocumentHighlightProvider(U,this.o(q,F)),this.p(U)}registerMultiDocumentHighlightProvider(F,q,K){const U=this.t(new G(this.h,K),F);return this.e.$registerMultiDocumentHighlightProvider(U,this.o(q,F)),this.p(U)}$provideDocumentHighlights(F,q,K,U){return this.s(F,O,X=>X.provideDocumentHighlights(E.URI.revive(q),K,U),void 0,U)}$provideMultiDocumentHighlights(F,q,K,U,X){return this.s(F,G,x=>x.provideMultiDocumentHighlights(E.URI.revive(q),K,U.map(Ee=>E.URI.revive(Ee)),X),void 0,X)}registerLinkedEditingRangeProvider(F,q,K){const U=this.t(new W(this.h,K),F);return this.e.$registerLinkedEditingRangeProvider(U,this.o(q,F)),this.p(U)}$provideLinkedEditingRanges(F,q,K,U){return this.s(F,W,async X=>{const x=await X.provideLinkedEditingRanges(E.URI.revive(q),K,U);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?he.w(x.wordPattern):void 0}},void 0,U)}registerReferenceProvider(F,q,K){const U=this.t(new z(this.h,K),F);return this.e.$registerReferenceSupport(U,this.o(q,F)),this.p(U)}$provideReferences(F,q,K,U,X){return this.s(F,z,x=>x.provideReferences(E.URI.revive(q),K,U,X),void 0,X)}registerCodeActionProvider(F,q,K,U){const X=new s.$Sc,x=this.t(new P(this.h,this.j.converter,this.k,K,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(x,this.o(q,F),{providedKinds:U?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:U?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,X)}))},he.u(F),!!K.resolveCodeAction),X.add(this.p(x)),X}$provideCodeActions(F,q,K,U,X){return this.s(F,P,x=>x.provideCodeActions(E.URI.revive(q),K,U,X),void 0,X)}$resolveCodeAction(F,q,K){return this.s(F,P,U=>U.resolveCodeAction(q,K),{},void 0)}$releaseCodeActions(F,q){this.s(F,P,K=>Promise.resolve(K.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(F,q,K){const U=this.t(new H(this.h,K),F);return this.e.$registerDocumentFormattingSupport(U,this.o(q,F),F.identifier,F.displayName||F.name),this.p(U)}$provideDocumentFormattingEdits(F,q,K,U){return this.s(F,H,X=>X.provideDocumentFormattingEdits(E.URI.revive(q),K,U),void 0,U)}registerDocumentRangeFormattingEditProvider(F,q,K){const U=typeof K.provideDocumentRangesFormattingEdits=="function",X=this.t(new ae(this.h,K),F);return this.e.$registerRangeFormattingSupport(X,this.o(q,F),F.identifier,F.displayName||F.name,U),this.p(X)}$provideDocumentRangeFormattingEdits(F,q,K,U,X){return this.s(F,ae,x=>x.provideDocumentRangeFormattingEdits(E.URI.revive(q),K,U,X),void 0,X)}$provideDocumentRangesFormattingEdits(F,q,K,U,X){return this.s(F,ae,x=>x.provideDocumentRangesFormattingEdits(E.URI.revive(q),K,U,X),void 0,X)}registerOnTypeFormattingEditProvider(F,q,K,U){const X=this.t(new de(this.h,K),F);return this.e.$registerOnTypeFormattingSupport(X,this.o(q,F),U,F.identifier),this.p(X)}$provideOnTypeFormattingEdits(F,q,K,U,X,x){return this.s(F,de,Ee=>Ee.provideOnTypeFormattingEdits(E.URI.revive(q),K,U,X,x),void 0,x)}registerWorkspaceSymbolProvider(F,q){const K=this.t(new we(q,this.l),F);return this.e.$registerNavigateTypeSupport(K,typeof q.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(F,q,K){return this.s(F,we,U=>U.provideWorkspaceSymbols(q,K),{symbols:[]},K)}$resolveWorkspaceSymbol(F,q,K){return this.s(F,we,U=>U.resolveWorkspaceSymbol(q,K),void 0,void 0)}$releaseWorkspaceSymbols(F,q){this.s(F,we,K=>K.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(F,q,K){const U=this.t(new ke(this.h,K,this.l),F);return this.e.$registerRenameSupport(U,this.o(q,F),ke.supportsResolving(K)),this.p(U)}$provideRenameEdits(F,q,K,U,X){return this.s(F,ke,x=>x.provideRenameEdits(E.URI.revive(q),K,U,X),void 0,X)}$resolveRenameLocation(F,q,K,U){return this.s(F,ke,X=>X.resolveRenameLocation(E.URI.revive(q),K,U),void 0,U)}registerDocumentSemanticTokensProvider(F,q,K,U){const X=this.t(new ve(this.h,K),F),x=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(X,this.o(q,F),U,x);let Ee=this.p(X);if(x){const Te=K.onDidChangeSemanticTokens(Ve=>this.e.$emitDocumentSemanticTokensEvent(x));Ee=M.$8K.from(Ee,Te)}return Ee}$provideDocumentSemanticTokens(F,q,K,U){return this.s(F,ve,X=>X.provideDocumentSemanticTokens(E.URI.revive(q),K,U),null,U)}$releaseDocumentSemanticTokens(F,q){this.s(F,ve,K=>K.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,q,K,U){const X=this.t(new se(this.h,K),F);return this.e.$registerDocumentRangeSemanticTokensProvider(X,this.o(q,F),U),this.p(X)}$provideDocumentRangeSemanticTokens(F,q,K,U){return this.s(F,se,X=>X.provideDocumentRangeSemanticTokens(E.URI.revive(q),K,U),null,U)}registerCompletionItemProvider(F,q,K,U){const X=this.t(new be(this.h,this.j.converter,K,this.m,F),F);return this.e.$registerCompletionsProvider(X,this.o(q,F),U,be.supportsResolving(K),F.identifier),this.p(X)}$provideCompletionItems(F,q,K,U,X){return this.s(F,be,x=>x.provideCompletionItems(E.URI.revive(q),K,U,X),void 0,X)}$resolveCompletionItem(F,q,K){return this.s(F,be,U=>U.resolveCompletionItem(q,K),void 0,K)}$releaseCompletionItems(F,q){this.s(F,be,K=>K.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(F,q,K,U){const X=new Y(F,this.h,K,this.j.converter),x=this.t(X,F);return this.e.$registerInlineCompletionsSupport(x,this.o(q,F),X.supportsHandleEvents,w.$lm.toKey(F.identifier.value),U?.yieldTo?.map(Ee=>w.$lm.toKey(Ee))||[]),this.p(x)}$provideInlineCompletions(F,q,K,U,X){return this.s(F,ne,x=>x.provideInlineCompletions(E.URI.revive(q),K,U,X),void 0,X)}$handleInlineCompletionDidShow(F,q,K,U){this.s(F,ne,async X=>{X.handleDidShowCompletionItem(q,K,U)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,q,K,U){this.s(F,ne,async X=>{X.handlePartialAccept(q,K,U)},void 0,void 0)}$freeInlineCompletionsList(F,q){this.s(F,ne,async K=>{K.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(F,q,K,U){const X=Array.isArray(U)?{triggerCharacters:U,retriggerCharacters:[]}:U,x=this.t(new ie(this.h,K),F);return this.e.$registerSignatureHelpProvider(x,this.o(q,F),X),this.p(x)}$provideSignatureHelp(F,q,K,U,X){return this.s(F,ie,x=>x.provideSignatureHelp(E.URI.revive(q),K,U,X),void 0,X)}$releaseSignatureHelp(F,q){this.s(F,ie,K=>K.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(F,q,K){const U=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,X=this.t(new Ie(this.h,this.j.converter,K,this.l,F),F);this.e.$registerInlayHintsProvider(X,this.o(q,F),typeof K.resolveInlayHint=="function",U,he.u(F));let x=this.p(X);if(U!==void 0){const Ee=K.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(U));x=M.$8K.from(x,Ee)}return x}$provideInlayHints(F,q,K,U){return this.s(F,Ie,X=>X.provideInlayHints(E.URI.revive(q),K,U),void 0,U)}$resolveInlayHint(F,q,K){return this.s(F,Ie,U=>U.resolveInlayHint(q,K),void 0,K)}$releaseInlayHints(F,q){this.s(F,Ie,K=>K.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(F,q,K){const U=this.t(new Le(this.h,K),F);return this.e.$registerDocumentLinkProvider(U,this.o(q,F),typeof K.resolveDocumentLink=="function"),this.p(U)}$provideDocumentLinks(F,q,K){return this.s(F,Le,U=>U.provideLinks(E.URI.revive(q),K),void 0,K,q.scheme==="output")}$resolveDocumentLink(F,q,K){return this.s(F,Le,U=>U.resolveLink(q,K),void 0,void 0,!0)}$releaseDocumentLinks(F,q){this.s(F,Le,K=>K.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(F,q,K){const U=this.t(new Ce(this.h,K),F);return this.e.$registerDocumentColorProvider(U,this.o(q,F)),this.p(U)}$provideDocumentColors(F,q,K){return this.s(F,Ce,U=>U.provideColors(E.URI.revive(q),K),[],K)}$provideColorPresentations(F,q,K,U){return this.s(F,Ce,X=>X.provideColorPresentations(E.URI.revive(q),K,U),void 0,U)}registerFoldingRangeProvider(F,q,K){const U=this.q(),X=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(U,new Ae(new ce(this.h,K),F)),this.e.$registerFoldingRangeProvider(U,this.o(q,F),F.identifier,X);let x=this.p(U);if(X!==void 0){const Ee=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(X));x=M.$8K.from(x,Ee)}return x}$provideFoldingRanges(F,q,K,U){return this.s(F,ce,X=>X.provideFoldingRanges(E.URI.revive(q),K,U),void 0,U)}registerSelectionRangeProvider(F,q,K){const U=this.t(new te(this.h,K,this.l),F);return this.e.$registerSelectionRangeProvider(U,this.o(q,F)),this.p(U)}$provideSelectionRanges(F,q,K,U){return this.s(F,te,X=>X.provideSelectionRanges(E.URI.revive(q),K,U),[],U)}registerCallHierarchyProvider(F,q,K){const U=this.t(new Q(this.h,K),F);return this.e.$registerCallHierarchyProvider(U,this.o(q,F)),this.p(U)}$prepareCallHierarchy(F,q,K,U){return this.s(F,Q,X=>Promise.resolve(X.prepareSession(E.URI.revive(q),K,U)),void 0,U)}$provideCallHierarchyIncomingCalls(F,q,K,U){return this.s(F,Q,X=>X.provideCallsTo(q,K,U),void 0,U)}$provideCallHierarchyOutgoingCalls(F,q,K,U){return this.s(F,Q,X=>X.provideCallsFrom(q,K,U),void 0,U)}$releaseCallHierarchy(F,q){this.s(F,Q,K=>Promise.resolve(K.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(F,q,K){const U=this.t(new ee(this.h,K),F);return this.e.$registerTypeHierarchyProvider(U,this.o(q,F)),this.p(U)}$prepareTypeHierarchy(F,q,K,U){return this.s(F,ee,X=>Promise.resolve(X.prepareSession(E.URI.revive(q),K,U)),void 0,U)}$provideTypeHierarchySupertypes(F,q,K,U){return this.s(F,ee,X=>X.provideSupertypes(q,K,U),void 0,U)}$provideTypeHierarchySubtypes(F,q,K,U){return this.s(F,ee,X=>X.provideSubtypes(q,K,U),void 0,U)}$releaseTypeHierarchy(F,q){this.s(F,ee,K=>Promise.resolve(K.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(F,q,K,U){const X=this.q();this.f.set(X,new Ae(new me(this.e,this.h,K,X,F),F));const x=(0,i.$BF)(F,"dropMetadata")&&U?me.toInternalProviderId(F.identifier.value,U.id):void 0;return this.e.$registerDocumentOnDropEditProvider(X,this.o(q,F),x,(0,i.$BF)(F,"dropMetadata")?U:void 0),this.p(X)}$provideDocumentOnDropEdits(F,q,K,U,X,x){return this.s(F,me,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(q,E.URI.revive(K),U,X,x)),void 0,void 0)}registerMappedEditsProvider(F,q,K){const U=this.t(new pe(this.h,K),F);return this.e.$registerMappedEditsProvider(U,this.o(q,F)),this.p(U)}$provideMappedEdits(F,q,K,U,X){return this.s(F,pe,x=>Promise.resolve(x.provideMappedEdits(q,K,U,X)),null,X)}registerDocumentPasteEditProvider(F,q,K,U){const X=this.q();this.f.set(X,new Ae(new I(this.e,this.h,K,X,F),F));const x=I.toInternalProviderId(F.identifier.value,U.id);return this.e.$registerPasteEditProvider(X,this.o(q,F),x,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:U.copyMimeTypes,pasteMimeTypes:U.pasteMimeTypes}),this.p(X)}$prepareDocumentPaste(F,q,K,U,X){return this.s(F,I,x=>x.prepareDocumentPaste(E.URI.revive(q),K,U,X),void 0,X)}$providePasteEdits(F,q,K,U,X,x){return this.s(F,I,Ee=>Ee.providePasteEdits(q,E.URI.revive(K),U,X,x),void 0,x)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:he.w(F.decreaseIndentPattern),increaseIndentPattern:he.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?he.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?he.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:he.w(F.beforeText),afterText:F.afterText?he.w(F.afterText):void 0,previousLineText:F.previousLineText?he.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(he.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(q=>M.SyntaxTokenType.toString(q)):void 0}}static D(F){return F.map(he.C)}setLanguageConfiguration(F,q,K){const{wordPattern:U}=K;if(U&&(0,g.$Ye)(U))throw new Error(`Invalid language configuration: wordPattern '${U}' is not allowed to match the empty string.`);U?this.h.setWordDefinitionFor(q,U):this.h.setWordDefinitionFor(q,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const X=this.q(),x={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?he.w(K.wordPattern):void 0,indentationRules:K.indentationRules?he.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?he.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?he.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(X,q,x),this.p(X)}$setWordDefinitions(F){for(const q of F)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$agc=he}),define(Pe[254],Re([1,0,3,8,7,31,13,6,23]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class b{constructor(D,u,p,w){this.c=u,this.d=p,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(E.$6K.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,u){await this.a.$changeLanguage(D,u);const p=this.c.getDocumentData(D);if(!p)throw new Error(`document '${D.toString()}' NOT found`);return p.document}async tokenAtPosition(D,u){const p=D.version,w=T.Position.from(u),s=await this.a.$tokensAtPosition(D.uri,w),o={type:C.StandardTokenType.Other,range:D.getWordRangeAtPosition(u)??new C.$0K(u.line,u.character,u.line,u.character)};if(!s)return o;const t={range:T.Range.to(s.range),type:T.TokenType.to(s.type)};return!t.range.contains(u)||p!==D.version?o:t}createLanguageStatusItem(D,u,p){const w=this.f++,s=this.a,o=this.g,t=`${D.identifier.value}/${u}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(t);const n={selector:p,id:u,name:D.displayName??D.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const c=new $.$Sc,h=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${u}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,R.$8g)(()=>{c.clear(),this.a.$setLanguageStatus(w,{id:t,name:n.name??D.displayName??D.name,source:D.displayName??D.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?M.default.Error:n.severity===C.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),a?.dispose(),s.$removeLanguageStatus(w),o.delete(t)},get id(){return n.id},get name(){return n.name},set name(l){n.name=l,h()},get selector(){return n.selector},set selector(l){n.selector=l,h()},get text(){return n.text},set text(l){n.text=l,h()},set text2(l){(0,g.$CF)(D,"languageStatusText"),n.text=l,h()},get text2(){return(0,g.$CF)(D,"languageStatusText"),n.text},get detail(){return n.detail},set detail(l){n.detail=l,h()},get severity(){return n.severity},set severity(l){n.severity=l,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(l){n.accessibilityInformation=l,h()},get command(){return n.command},set command(l){n.command=l,h()},get busy(){return n.busy},set busy(l){n.busy=l,h()}};return h(),i}}e.$zhc=b}),define(Pe[82],Re([1,0,21,11,2,4,14,3,27,17]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0;let A=class{constructor(u,p,w){this.f=w,this.d=new Map,this.a=p.getProxy($.$6K.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===E.$g}getMessage(u,p){const{message:w,args:s,comment:o}=p;if(this.c)return(0,T.$Le)(w,s??{});let t=w;o&&o.length>0&&(t+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(u)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$Le)(n??w,s??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let p;const w=await this.g(u);if(!w){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(w),o=JSON.parse(s);p=u.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${u.identifier.value} from ${w}: ${s.message}`);return}p&&this.d.set(u.identifier.value,{contents:p,uri:w})}async g(u){if(u.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(p)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Xgc=A,e.$Xgc=A=Je([Ke(0,g.$nN),Ke(1,b.$0M),Ke(2,R.$nj)],A),e.$Ygc=(0,M.$6h)("IExtHostLocalizationService")}),define(Pe[255],Re([1,0,14,3,27,17,2,51]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;let g=class extends E.$yj{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(p=>(0,$.$Ch)(p))),this.r=D.getProxy(T.$6K.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(R.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this.r.$setVisibility(D,u)}s(D,u,p){return new b(this.r,D,u,p)}};e.$$hc=g,e.$$hc=g=Je([Ke(0,M.$0M),Ke(1,C.$nN)],g);class b extends E.$tj{constructor(D,u,p,w){super(w?.logLevel==="always"),this.r=D,this.s=u,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(u,w).then(()=>{this.u(this.n),this.m=!0})}g(D,u){const p=[[D,u]];this.m?this.u(p):this.n.push(...p)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Re([1,0,3,4,6,17,24]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0,e.$Zgc=(0,T.$6h)("IExtHostManagedSockets");let $=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(E.$6K.MainThreadManagedSockets)}setFactory(D,u){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(D,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this.b,p=await this.c.makeConnection(),w=new C.$Sc;return this.d.set(u,new b(u,p,w)),w.add((0,C.$Rc)(()=>this.d.delete(u))),w.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),w.dispose()})),w.add(p.onDidClose(s=>{this.a.$onDidManagedSocketClose(u,s?.stack??s?.message),w.dispose()})),w.add(p.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(u,R.$je.wrap(s)))),u}$remoteSocketWrite(D,u){this.d.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this.d.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$1gc=$,e.$1gc=$=Je([Ke(0,M.$0M)],$);class g{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class b extends C.$Tc{constructor(D,u,p){super(),this.socketId=D,this.actual=u,this.B(p)}}}),define(Pe[256],Re([1,0,3,14,23]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;function M($){return $&&$.title}let R=class{constructor(g,b){this.b=b,this.a=g.getProxy(E.$6K.MainThreadMessageService)}showMessage(g,b,A,D,u){const p={source:{identifier:g.identifier,label:g.displayName||g.name}};let w;typeof D=="string"||M(D)?w=[D,...u]:(p.modal=D?.modal,p.useCustom=D?.useCustom,p.detail=D?.detail,w=u),p.useCustom&&(0,C.$CF)(g,"resolvers");const s=[];let o=!1;for(let t=0;t<w.length;t++){const n=w[t];if(typeof n=="string")s.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:a,isCloseAffordance:c}=n;s.push({title:a,isCloseAffordance:!!c,handle:t}),c&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,n)}return this.a.$showMessage(b,A,p,s).then(t=>{if(typeof t=="number")return w[t]})}};e.$Ahc=R,e.$Ahc=R=Je([Ke(1,T.$nj)],R)}),define(Pe[257],Re([1,0,18,13,20,5,6,28,2,22,14,3,32,8,7,78,210,23,49]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0;let a=class{constructor(f,S,L,v,y){this.m=S,this.n=L,this.o=v,this.q=y,this.b=new $.$Ac,this.c=new $.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$Vd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(D.$6K.MainThreadNotebookKernels);const k=new u.$xN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$vN("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],u.$wN.Void);this.o.registerApiCommand(k)}createNotebookController(f,S,L,v,y,k){for(const se of this.j.values())if(se.controller.id===S&&b.$lm.equals(f.identifier,se.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const N=this.k++,O=this;this.q.trace(`NotebookController[${N}], CREATED by ${f.identifier.value}, ${S}`);const G=()=>console.warn(`NO execute handler from notebook controller '${I.id}' of extension: '${f.identifier}'`);let W=!1;const z=new M.$Vd,P=new M.$Vd,I={id:d(f.identifier,S),notebookType:L,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:v||f.identifier.value,preloads:k?k.map(p.NotebookRendererScript.from):[]};let H=y??G,ae,de;this.a.$addKernel(N,I).catch(se=>{console.log(se),W=!0});let we=0;const ke=()=>{if(W)return;const se=++we;Promise.resolve().then(()=>{se===we&&this.a.$updateKernel(N,I)})},le=new $.$Ac,ve={get id(){return S},get notebookType(){return I.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return I.label},set label(se){I.label=se??f.displayName??f.name,ke()},get detail(){return I.detail??""},set detail(se){I.detail=se,ke()},get description(){return I.description??""},set description(se){I.description=se,ke()},get supportedLanguages(){return I.supportedLanguages},set supportedLanguages(se){I.supportedLanguages=se,ke()},get supportsExecutionOrder(){return I.supportsExecutionOrder??!1},set supportsExecutionOrder(se){I.supportsExecutionOrder=se,ke()},get rendererScripts(){return I.preloads?I.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(se){H=se??G},get interruptHandler(){return ae},set interruptHandler(se){ae=se,I.supportsInterrupt=!!se,ke()},set variableProvider(se){(0,t.$CF)(f,"notebookVariableProvider"),de=se,I.hasVariableProvider=!!se,se?.onDidChangeVariables(be=>O.a.$variablesUpdated(be.uri)),ke()},get variableProvider(){return de},createNotebookCellExecution(se){if(W)throw new Error("notebook controller is DISPOSED");if(!le.has(se.notebook.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return O._createNotebookCellExecution(se,d(f.identifier,this.id))},createNotebookExecution(se){if((0,t.$CF)(f,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!le.has(se.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return O._createNotebookExecution(se,d(f.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${N}], DISPOSED`),W=!0,this.j.delete(N),z.dispose(),P.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(se,be){be===w.NotebookControllerAffinity2.Hidden&&(0,t.$CF)(f,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(N,se.uri,be)},onDidReceiveMessage:P.event,postMessage(se,be){return(0,t.$CF)(f,"notebookMessaging"),O.a.$postMessage(N,be&&O.n.getIdByEditor(be),se)},asWebviewUri(se){return(0,t.$CF)(f,"notebookMessaging"),(0,s.$wvb)(se,O.m.remote)}};return this.j.set(N,{extensionId:f.identifier,controller:ve,onDidReceiveMessage:P,onDidChangeSelection:z,associatedNotebooks:le}),ve}getIdByController(f){for(const[S,L]of this.j)if(L.controller===f)return d(L.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,S){const L=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(L,S);const y={dispose:()=>{this.f.delete(L),v.a.$removeKernelDetectionTask(L)}};return this.f.set(L,y),y}registerKernelSourceActionProvider(f,S,L){const v=this.i++,y=typeof L.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,k=this;this.h.set(v,L),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,S);let N;return y!==void 0&&(N=L.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(v),k.a.$removeKernelSourceActionProvider(v,v),N?.dispose()}}}async $provideKernelSourceActions(f,S){const L=this.h.get(f);if(L){const v=new R.$Sc;return(await L.provideNotebookKernelSourceActions(S)??[]).map(k=>p.NotebookKernelSourceAction.from(k,this.o.converter,v))}return[]}$acceptNotebookAssociation(f,S,L){const v=this.j.get(f);if(v){const y=this.n.getNotebookDocument(g.URI.revive(S));L?v.associatedNotebooks.set(y.uri,!0):v.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),L),v.onDidChangeSelection.fire({selected:L,notebook:y.apiNotebook})}}async $executeCells(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument(g.URI.revive(S)),k=[];for(const N of L){const O=y.getCell(N);O&&k.push(O.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),k.length),await v.controller.executeHandler.call(v.controller,k,y.apiNotebook,v.controller)}catch(N){this.q.error(`NotebookController[${f}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument(g.URI.revive(S));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,y.apiNotebook);else for(const k of L){const N=y.getCell(k);N&&this.b.get(N.uri)?.cancel()}if(v.controller.interruptHandler){const k=this.c.get(y.uri);L.length&&Array.isArray(k)&&k.length&&k.forEach(N=>N.dispose())}}async $provideVariables(f,S,L,v,y,k,N){const O=this.j.get(f);if(!O)return;const G=this.n.getNotebookDocument(g.URI.revive(L)),W=O.controller.variableProvider;if(!W)return;let z;if(v){if(z=this.s[v],!z)return}else this.s={};const P=y==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,I=W.provideVariables(G.apiNotebook,z,P,k,N);for await(const H of I){if(N.isCancellationRequested)return;const ae={id:this.r++,name:H.variable.name,value:H.variable.value,hasNamedChildren:H.hasNamedChildren,indexedChildrenCount:H.indexedChildrenCount};this.s[ae.id]=H.variable,this.a.$receiveVariable(S,ae)}}$acceptKernelMessageFromRenderer(f,S,L){const v=this.j.get(f);if(!v)return;const y=this.n.getEditorById(S);v.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:L}))}$cellExecutionChanged(f,S,L){const y=this.n.getNotebookDocument(g.URI.revive(f)).getCell(S);if(y){const k=L?p.NotebookCellExecutionState.to(L):w.NotebookCellExecutionState.Idle;k!==void 0&&this.l.fire({cell:y.apiCell,state:k})}}_createNotebookCellExecution(f,S){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const y=new h(S,v,this.a);this.b.set(v.uri,y);const k=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),k.dispose(),this.b.delete(v.uri))});return y.asApiObject()}_createNotebookExecution(f,S){const L=this.n.getNotebookDocument(f.uri),v=f.getCells().find(N=>{const O=L.getCellFromApiCell(N);return O&&this.b.has(O.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const y=new l(S,L,this.a),k=y.onDidChangeState(()=>{y.state===i.Resolved&&(y.dispose(),k.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[y,k]),y.asApiObject()}};e.$Ehc=a,e.$Ehc=a=Je([Ke(4,A.$nj)],a);var c;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(c||(c={}));class h extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(f,S,L){super(),this.m=S,this.n=L,this.b=h.a++,this.c=new M.$Vd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new C.$6d),this.h=new r(10,v=>this.s(v)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const S=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$Tv(S))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let S=this.m;if(f&&(S=this.m.notebook.getCellFromApiCell(f)),!S)throw new Error("INVALID cell");return S.handle}y(f){return f.map(S=>{const L=w.$xM.ensureUniqueMimeTypes(S.items,!0);return L===S.items?p.NotebookCellOutput.from(S):p.NotebookCellOutput.from({items:L,id:S.id,metadata:S.metadata})})}async z(f,S,L){const v=this.w(S),y=this.y((0,E.$3b)(f));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:v,append:L,outputs:y})}async C(f,S,L){return f=w.$xM.ensureUniqueMimeTypes((0,E.$3b)(f),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:f.map(p.NotebookCellOutputItem.from),outputId:S.id,append:L})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(L){f.j=L,f.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(L){if(f.f===c.Resolved||f.f===c.Started)throw new Error("Cannot call start again");f.f=c.Started,f.c.fire(),f.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,v){if(f.f===c.Resolved)throw new Error("Cannot call resolve twice");f.f=c.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new n.$Tv({runEndTime:v,lastRunSuccess:L}))},clearOutput(L){return f.t(),f.z([],L,!1)},appendOutput(L,v){return f.t(),f.z(L,v,!0)},replaceOutput(L,v){return f.t(),f.z(L,v,!1)},appendOutputItems(L,v){return f.t(),f.C(L,v,!0)},replaceOutputItems(L,v){return f.t(),f.C(L,v,!1)}})}}var i;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(i||(i={}));class l extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(f,S,L){super(),this.h=S,this.j=L,this.b=l.a++,this.c=new M.$Vd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new C.$6d),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class r{constructor(f,S){this.f=f,this.g=S,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new T.$qh,this.b=Date.now(),(0,T.$7g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>f.complete())}}function d(m,f){return`${m.value}/${f}`}e.$Fhc=d}),define(Pe[258],Re([1,0,5,3,107]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class M{constructor($,g){this.c=g,this.a=new Map,this.b=$.getProxy(T.$6K.MainThreadNotebookRenderers)}$postRendererMessage($,g,b){const A=this.c.getEditorById($);this.a.get(g)?.fire({editor:A.apiEditor,message:b})}createRendererMessaging($,g){if(!$.contributes?.notebookRenderer?.some(A=>A.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(A,D,u)=>this.d(g).event(A,D,u),postMessage:(A,D)=>{C.$mhc.apiEditorsToExtHost.has(A)&&([A,D]=[D,A]);const u=D&&C.$mhc.apiEditorsToExtHost.get(D);return this.b.$postMessage(u?.id,g,A)}}}d($){let g=this.a.get($);return g||(g=new E.$Vd({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete($)}}),this.a.set($,g),g)}}e.$Ghc=M}),define(Pe[259],Re([1,0,6,16,2,23,3]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;class ${constructor(b){this.b=new Map,this.a=b.getProxy(R.$6K.MainThreadProfileContentHandlers)}registerProfileContentHandler(b,A,D){if((0,M.$CF)(b,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,D),this.a.$registerProfileContentHandler(A,D.name,D.description,b.identifier.value),(0,E.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(b,A,D,u){const p=this.b.get(b);if(!p)throw new Error(`Unknown handler with id: ${b}`);return p.saveProfile(A,D,u)}async $readProfile(b,A,D){const u=this.b.get(b);if(!u)throw new Error(`Unknown handler with id: ${b}`);return u.readProfile((0,T.$If)(A)?A:C.URI.revive(A),D)}}e.$Jhc=$}),define(Pe[260],Re([1,0,2,3,13,8]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class R{static{this.a=0}constructor(g,b){this.d=b,this.c=new Map,this.b=g.getProxy(T.$6K.MainThreadQuickDiff)}$provideOriginalResource(g,b,A){const D=E.URI.revive(b),u=this.c.get(g);return u?(0,C.$Yg)(()=>u.provideOriginalResource(D,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(g,b,A,D){const u=R.a++;return this.c.set(u,b),this.b.$registerQuickDiffProvider(u,M.DocumentSelector.from(g,this.d),A,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Lhc=R}),define(Pe[261],Re([1,0,20,5,6,3,2,7,15,18,31,45,23,8]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;function w(s,o,t){const n=s.getProxy(M.$6K.MainThreadQuickOpen);class a{constructor(S,L){this.e=new Map,this.f=0,this.a=S,this.b=L}showQuickPick(S,L,v,y=E.CancellationToken.None){this.c=void 0;const k=Promise.resolve(L),N=++this.f,O=n.$show(N,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},y),G={},W=O.then(()=>G);return Promise.race([W,k]).then(z=>{if(z===G)return;const P=(0,u.$BF)(S,"quickPickItemTooltip");return k.then(I=>{const H=[];for(let ae=0;ae<I.length;ae++){const de=I[ae];if(typeof de=="string")H.push({label:de,handle:ae});else if(de.kind===$.QuickPickItemKind.Separator)H.push({type:"separator",label:de.label});else{de.tooltip&&!P&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const we=de.iconPath?r(de.iconPath):void 0;H.push({label:de.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:P?p.MarkdownString.fromStrict(de.tooltip):void 0,handle:ae})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=ae=>{v.onDidSelectItem(I[ae])}),n.$setItems(N,H),O.then(ae=>{if(typeof ae=="number")return I[ae];if(Array.isArray(ae))return ae.map(de=>I[de])})})}).then(void 0,z=>{if(!(0,g.$4)(z))return n.$setError(N,z),Promise.reject(z)})}$onItemSelected(S){this.c?.(S)}showInput(S,L=E.CancellationToken.None){return this.d=S?.validateInput,n.$input(S,typeof this.d=="function",L).then(void 0,v=>{if(!(0,g.$4)(v))return Promise.reject(v)})}async $validateInput(S){if(!this.d)return;const L=await this.d(S);if(!L||typeof L=="string")return L;let v;switch(L.severity){case $.InputBoxValidationSeverity.Info:v=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:v=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:v=A.default.Error;break;default:v=L.message?A.default.Error:A.default.Ignore;break}return{content:L.message,severity:v}}async showWorkspaceFolderPick(S,L=E.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!v)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(k=>k.uri.toString()===v.uri.toString())}createQuickPick(S){const L=new d(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(S){const L=new m(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(S,L){this.e.get(S)?._fireDidChangeValue(L)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,L){const v=this.e.get(S);v instanceof d&&v._fireDidChangeActive(L)}$onDidChangeSelection(S,L){const v=this.e.get(S);v instanceof d&&v._fireDidChangeSelection(L)}$onDidTriggerButton(S,L){this.e.get(S)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(S,L,v){const y=this.e.get(S);y instanceof d&&y._fireDidTriggerItemButton(L,v)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class c{static{this.a=1}constructor(S,L){this.x=S,this.y=L,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Vd,this.q=new T.$Vd,this.r=new T.$Vd,this.s=new T.$Vd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((L,v)=>{const y=L===$.$qM.Back?-1:v;this.o.set(y,L)}),this.z({buttons:S.map((L,v)=>({...r(L.iconPath),tooltip:L.tooltip,handle:L===$.$qM.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const L=this.o.get(S);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(S){if(!this.v){for(const L of Object.keys(S)){const v=S[L];this.u[L]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(f){if(f instanceof $.$3L)return{id:f.id};const S=l(f),L=i(f);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof L=="string"?R.URI.file(L):L}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function l(f){return typeof f=="object"&&"dark"in f?f.dark:f}function r(f){const S=h(f);let L,v;return"id"in S?v=D.ThemeIcon.asClassName(S):L=S,{iconPath:L,iconClass:v}}class d extends c{constructor(S,L){super(S.identifier,L),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Vd,this.L=[],this.M=new T.$Vd,this.N=new T.$Vd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((y,k)=>{this.C.set(k,y),this.D.set(y,k)});const L=(0,u.$BF)(this.O,"quickPickItemTooltip"),v=[];for(let y=0;y<S.length;y++){const k=S[y];if(k.kind===$.QuickPickItemKind.Separator)v.push({type:"separator",label:k.label});else{k.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const N=k.iconPath?r(k.iconPath):void 0;v.push({handle:y,label:k.label,iconPath:N?.iconPath,iconClass:N?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:L?p.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((O,G)=>({...r(O.iconPath),tooltip:O.tooltip,handle:G}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(S){const L=(0,b.$Hb)(S.map(v=>this.C.get(v)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(S){const L=(0,b.$Hb)(S.map(v=>this.C.get(v)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(S,L){const v=this.C.get(S);if(!v||!v.buttons||!v.buttons.length)return;const y=v.buttons[L];y&&this.N.fire({button:y,item:v})}}class m extends c{constructor(S,L){super(S.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:A.default.Error}):this.z({validationMessage:S.message,severity:S.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new a(o,t)}e.$Mhc=w}),define(Pe[262],Re([1,0,2,5,66,6,13,3,18,138,14,22,45,8,23,12,21]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=void 0;function n(N){return N instanceof E.URI}function a(N,O){return N.scheme===s.Schemas.file&&O.scheme===s.Schemas.file&&o.$k?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function c(N){if(N)return typeof N.iconPath=="string"?E.URI.file(N.iconPath):E.URI.isUri(N.iconPath)||u.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function h(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if(u.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const O=N.icon;return{light:O.light,dark:O.dark}}}else return}function i(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const G=typeof N.iconPath=="string"?N.iconPath:E.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,W=typeof O.iconPath=="string"?O.iconPath:E.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,b.$Sq)(G,W)}function l(N,O){let G=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(G=i(N,O),G!==0)return G;if(N.light&&O.light)G=i(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(G!==0)return G;if(N.dark&&O.dark)G=i(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return G}function r(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let G=0;G<N.arguments.length;G++){const W=N.arguments[G],z=O.arguments[G];if(W!==z&&!(n(W)&&n(z)&&a(W,z)))return W<z?-1:1}return 0}function d(N,O){let G=(0,b.$Sq)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(G!==0)return G;if(N.command&&O.command)G=r(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(G!==0)return G;if(N.decorations&&O.decorations)G=l(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)G=(0,b.$Sq)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)G=(0,b.$Sq)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return G}function m(N,O){for(let G=0;G<N.length;G++)if(N[G]!==O[G])return!1;return!0}function f(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?m(N.arguments,O.arguments):N.arguments===O.arguments)}function S(N,O){return(0,g.$ub)(N,O,f)}class L{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,w.$CF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,w.$CF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,w.$CF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,G,W,z,P){this.k=O,this.l=z,this.m=P,this.d="",this.e=new T.$Vd,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=W}showValidationMessage(O,G){(0,w.$CF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,G)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Nhc=L;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,G,W,z,P,I,H){this.q=O,this.s=G,this.t=W,this.u=z,this.v=P,this.multiDiffEditorEnableViewChanges=I,this.w=H,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Vd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Vd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,G){const W=this.h.get(O);return W?(0,R.$Yg)(()=>this.s.executeCommand(W.command,...W.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(d),W=(0,g.$Db)(this.o,O,d).map(I=>{const H=I.toInsert.map(ae=>{const de=this.e++;this.g.set(de,ae);const we=ae.resourceUri;let ke;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const te=new M.$Sc;ke=this.s.converter.toInternal(ae.command,te),this.j.set(de,te)}else this.h.set(de,ae.command);const le=(0,w.$BF)(this.w,"scmMultiDiffEditor"),ve=le?ae.multiDiffEditorOriginalUri:void 0,se=le?ae.multiFileDiffEditorModifiedUri:void 0,be=c(ae.decorations),ne=ae.decorations&&c(ae.decorations.light)||be,Y=ae.decorations&&c(ae.decorations.dark)||be,V=[ne,Y],ie=ae.decorations&&ae.decorations.tooltip||"",Ie=ae.decorations&&!!ae.decorations.strikeThrough,Le=ae.decorations&&!!ae.decorations.faded,Ce=ae.contextValue||"";return{rawResource:[de,we,V,ie,Ie,Le,Ce,ke,ve,se],handle:de}});return{start:I.start,deleteCount:I.deleteCount,toInsert:H}}),z=W.map(({start:I,deleteCount:H,toInsert:ae})=>[I,H,ae.map(de=>de.rawResource)]),P=W.reverse();for(const{start:I,deleteCount:H,toInsert:ae}of P){const de=ae.map(ke=>ke.handle),we=this.n.splice(I,H,...de);for(const ke of we)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=O,z}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let G;(0,w.$BF)(this.x,"quickDiffProvider")&&(G=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:G})}get historyProvider(){return(0,w.$CF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,w.$CF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new M.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new M.$Sc,this.o=O;const G=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,w.$CF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,w.$CF)(this.x,"scmActionButton"),this.p.value=new M.$Sc,this.q=O;const G=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(W=>W.map(z=>this.y.converter.toInternal(z,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&S(this.t,O))return;this.s.value=new M.$Sc,this.t=O;const G=(O||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(O,G,W,z,P,I,H){this.x=O,this.y=z,this.z=P,this.A=I,this.B=H,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Uc,this.m=void 0,this.n=new M.$Uc,this.o=void 0,this.p=new M.$Uc,this.s=new M.$Uc,this.t=void 0,this.u=!1,this.v=new T.$Vd,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=W;const ae=E.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${P}/scm${this.w}/input`,query:H?`rootUri=${encodeURIComponent(H.toString())}`:void 0});this.f=new L(O,G,this.#e,this.w,ae),this.#e.$registerSourceControl(this.w,P,I,H,ae)}createResourceGroup(O,G,W){const z=(0,w.$BF)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,P=new v(this.#e,this.y,this.w,O,G,z,this.x),I=T.Event.once(P.onDidDispose)(()=>this.C.delete(P));return this.C.set(P,I),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const O=[],G=[];for(const[W,z]of this.C){z.dispose();const P=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});T.Event.once(W.onDidDispose)(()=>{this.D.delete(W),P.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),O.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const I=W._takeResourceStateSnapshot();I.length>0&&G.push([W.handle,I]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,O,G),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(G=>{const W=G._takeResourceStateSnapshot();W.length!==0&&O.push([G.handle,W])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,C.$yh)(100)],y.prototype,"eventuallyAddResourceGroups",null),Je([(0,C.$yh)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,G,W,z){this.l=G,this.m=W,this.n=z,this.g=new Map,this.h=new D.$nm,this.j=new T.$Vd,this.e=O.getProxy($.$6K.MainThreadSCM),this.f=O.getProxy($.$6K.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const I=this.g.get(P.sourceControlHandle);if(!I)return P;const H=I.getResourceGroup(P.groupHandle);return H?H.getResourceState(P.handle):P}else if(P&&P.$mid===4){const I=this.g.get(P.sourceControlHandle);return I?I.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const I=this.g.get(P.handle);return I||P}return P}})}createSourceControl(O,G,W,z){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,G,W,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const P=t.d++,I=new y(O,this.m,this.e,this.l,G,W,z);this.g.set(P,I);const H=this.h.get(O.identifier)||[];return H.push(I),this.h.set(O.identifier,H),I}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const G=this.h.get(O.identifier),W=G&&G[G.length-1];return W&&W.inputBox}$provideOriginalResource(O,G,W){const z=E.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",O,z.toString());const P=this.g.get(O);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Yg)(()=>P.quickDiffProvider.provideOriginalResource(z,W)).then(I=>I||null)}$onInputBoxValueChange(O,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const W=this.g.get(O);return W&&W.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(O,G,W,z){this.n.trace("ExtHostSCM#$executeResourceCommand",O,G,W);const P=this.g.get(O);if(!P)return Promise.resolve(void 0);const I=P.getResourceGroup(G);return I?I.$executeResourceCommand(W,z):Promise.resolve(void 0)}$validateInput(O,G,W){this.n.trace("ExtHostSCM#$validateInput",O);const z=this.g.get(O);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Yg)(()=>z.inputBox.validateInput(G,W)).then(P=>{if(!P)return Promise.resolve(void 0);const I=p.MarkdownString.fromStrict(P.message);return I?Promise.resolve([I,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(O,G,W){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupBase(G,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(O,G,W,z){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,W,z)??void 0}async $provideHistoryItems(O,G,W,z){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(G,W,z))?.map(H=>({...H,icon:h(H)}))??void 0}async $provideHistoryItemSummary(O,G,W,z){const P=this.g.get(O)?.historyProvider;if(typeof P?.provideHistoryItemSummary!="function")return;const I=await P.provideHistoryItemSummary(G,W,z);return I?{...I,icon:h(I)}:void 0}async $provideHistoryItemChanges(O,G,W,z){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(G,W,z)??void 0}};e.$Ohc=k,e.$Ohc=k=t=Je([Ke(3,A.$nj)],k)}),define(Pe[84],Re([1,0,3,5,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=void 0;class M{constructor($){this.b=new T.$Vd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$6K.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,g){return this.a.$getPassword($,g)}store($,g,b){return this.a.$setPassword($,g,b)}delete($,g){return this.a.$deletePassword($,g)}}e.$Ugc=M,e.$Vgc=(0,C.$6h)("IExtHostSecretState")}),define(Pe[263],Re([1,0,3,8,2]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class M{static{this.a=0}constructor($,g){this.d=g,this.c=new Map,this.b=$.getProxy(E.$6K.MainThreadShare)}async $provideShare($,g,b){return await this.c.get($)?.provideShare({selection:T.Range.to(g.selection),resourceUri:C.URI.revive(g.resourceUri)},b)??void 0}registerShareProvider($,g){const b=M.a++;return this.c.set(b,g),this.b.$registerShareProvider(b,T.DocumentSelector.from($,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(b),this.c.delete(b)}}}}e.$Phc=M}),define(Pe[264],Re([1,0,20,6,3]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(C.$6K.MainThreadSpeech)}async $createSpeechToTextSession($,g){const b=this.c.get($);if(!b)return;const A=new T.$Sc,D=new E.$6d;this.d.set(g,D);const u=A.add(b.provideSpeechToTextSession(D.token));A.add(u.onDidChange(p=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,p)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,g,b){const A=M.a++;return this.c.set(A,b),this.b.$registerProvider(A,g,{extension:$,displayName:$.value}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Qhc=M}),define(Pe[265],Re([1,0,7,3,163,6,8,16]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$4L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$4L("statusBarItem.warningForeground")]])}#e;#t;constructor(u,p,w,s,o,t=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Sc,this.#e=u,this.#t=p,o&&s){this.c=(0,E.$GL)(s.identifier,o);const a=w.get(this.c);a&&(t=a.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(g.a++);this.e=s,this.f=o,this.g=t,this.h=this.u(n)}u(u){if((0,$.$Mf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!g.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new M.$Sc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=g.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,p,this.k,s,this.r?.internal,w,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Rhc=g;class b{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const p={message:u};return this.b.unshift(p),this.c(),new E.$8K(()=>{const w=this.b.indexOf(p);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(u,p){this.e=new Map,this.a=u.getProxy(T.$6K.MainThreadStatusBar),this.b=p,this.c=new b(this)}$acceptStaticEntries(u){for(const p of u)this.e.set(p.entryId,p)}createStatusBarEntry(u,p,w,s){return new g(this.a,this.b,this.e,u,p,w,s)}setStatusBarMessage(u,p){const w=this.c.setMessage(u);let s;return typeof p=="number"?s=setTimeout(()=>w.dispose(),p):typeof p<"u"&&p.then(()=>w.dispose(),()=>w.dispose()),new E.$8K(()=>{w.dispose(),clearTimeout(s)})}}e.$Shc=A}),define(Pe[85],Re([1,0,3,5,4]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=void 0;class M{constructor($,g){this.c=g,this.b=new T.$Vd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$6K.MainThreadStorage)}registerExtensionStorageKeysToSync($,g){this.a.$registerExtensionStorageKeysToSync($,g)}async initializeExtensionStorage($,g,b){const A=await this.a.$initializeExtensionStorage($,g);let D;return A&&(D=this.d($,g,A)),D||b}setValue($,g,b){return this.a.$setValue($,g,b)}$acceptValue($,g,b){const A=this.d($,g,b);A&&this.b.fire({shared:$,key:g,value:A})}d($,g,b){try{return JSON.parse(b)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${$}): ${A}`)}}}e.$Mgc=M,e.$Ngc=(0,C.$6h)("IExtHostStorage")}),define(Pe[86],Re([1,0,4,27,14,63,2]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=e.$vgc=void 0,e.$vgc=(0,E.$6h)("IExtensionStoragePaths");let $=class{constructor(b,A,D){this.d=A,this.f=D,this.a=b.workspace??void 0,this.b=b.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(b){return R.URI.joinPath(this.b.workspaceStorageHome,b)}async h(){if(!this.a)return Promise.resolve(void 0);const b=this.a.id,A=await this.g(b);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(b){if(this.c)return R.URI.joinPath(this.c,b.identifier.value)}globalValue(b){return R.URI.joinPath(this.b.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$wgc=$,e.$wgc=$=Je([Ke(0,T.$nN),Ke(1,C.$nj),Ke(2,M.$ugc)],$)}),define(Pe[64],Re([1,0,5,3,4,2,17,6,7,165,15,193,20,33,194,45,13,8,32]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=void 0,e.$Qgc=(0,C.$6h)("IExtHostTerminalService");class a{constructor(v,y,k,N){this.l=v,this._id=y,this.m=k,this.n=N,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(G,W=!0){O.q(),O.l.$sendText(O._id,G,W)},show(G){O.q(),O.l.$show(O._id,G)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(v,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??y?.cwd??void 0,env:v.env??void 0,icon:m(v.iconPath)??void 0,color:s.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(v.location,y?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,y,k,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:N,color:s.ThemeColor.isThemeColor(O)?O.id:void 0,location:y?.location||this.o(v,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,y){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in v?{viewColumn:t.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,y){this.h=Object.freeze({code:v,reason:y})}setDimensions(v,y){return v===this.d&&y===this.g||v===0||y===0?!1:(this.d=v,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(y=>{y!==v&&(this.b=Promise.resolve(v))})}}e.$Rgc=a;class c{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new E.$Vd,this.onProcessData=this.a.event,this.b=new E.$Vd,this.d=new E.$Vd,this.onDidChangeProperty=this.d.event,this.f=new E.$Vd,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,y){this.g.setDimensions?.({columns:v,rows:y})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends $.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,y,k){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Vd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Vd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Vd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Vd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Vd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Vd,this.onDidChangeShell=this.N.event,this.O=new E.$Vd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Vd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(T.$6K.MainThreadTerminalService),this.y=new w.$Krb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:N=>{const O=G=>{const W=G;return this.W(W.instanceId)?.value};switch(N?.$mid){case 15:return O(N);default:{if(Array.isArray(N))for(let G=0;G<N.length&&N[G].$mid===15;G++)N[G]=O(N[G]);return N}}}}),this.B({dispose:()=>{for(const[N,O]of this.g)O.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,y){const k=new a(this.a,(0,p.$qg)(),v,v.name),N=new c(v.pty);return k.createExtensionTerminal(v.location,y,this.R(v,y).resolvedExtHostIdentifier,m(v.iconPath),f(v.color)).then(O=>{const G=this.S(O,N);this.h[O]=G}),this.f.push(k),k.value}R(v,y){if(y=y||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const k=v.location.parentTerminal;if(k){const N=this.f.find(O=>O.value===k);N&&(y.resolvedExtHostIdentifier=N._id)}}else v.location&&typeof v.location!="object"?y.location=v.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(v,y){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const N=new c(y),O=this.S(v,N);this.h[v]=O}async $acceptActiveTerminalChanged(v){const y=this.b;if(v===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const k=this.W(v);k&&(this.b=k,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,y){const k=this.W(v);k&&this.O.fire({terminal:k.value,data:y})}async $acceptTerminalDimensions(v,y,k){const N=this.W(v);N&&N.setDimensions(y,k)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(v,y){const k=this.W(v);k&&this.P.fire({terminal:k.value,...y})}async $acceptTerminalMaximumDimensions(v,y,k){this.g.get(v)?.resize(y,k)}async $acceptTerminalTitleChange(v,y){const k=this.W(v);k&&(k.name=y)}async $acceptTerminalClosed(v,y,k){const N=this.Y(this.f,v);if(N!==null){const O=this.f.splice(N,1)[0];O.setExitStatus(y,k),this.H.fire(O.value)}}$acceptTerminalOpened(v,y,k,N){if(y){const W=this.Y(this.f,y);if(W!==null){this.f[W]._id=v,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:M.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},G=new a(this.a,v,O,k);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(v,y){this.W(v)?._setProcessId(y)}async $startExtensionTerminal(v,y){const k=this.W(v);if(!k)return{message:(0,b.localize)(0,null,v)};k.isOpen||await new Promise(O=>{const G=this.onDidOpenTerminal(async W=>{W===k.value&&(G.dispose(),O())})});const N=this.g.get(v);N?N.startSendingEvents(y):this.j[v]={initialDimensions:y}}S(v,y){const k=new $.$Sc;k.add(y.onProcessReady(O=>this.a.$sendProcessReady(v,O.pid,O.cwd,O.windowsPty))),k.add(y.onDidChangeProperty(O=>this.a.$sendProcessProperty(v,O))),this.y.startBuffering(v,y.onProcessData),k.add(y.onProcessExit(O=>this.U(v,O))),this.g.set(v,y);const N=this.j[v];return N&&y instanceof c&&(y.startSendingEvents(N.initialDimensions),delete this.j[v]),k}$acceptProcessAckDataEvent(v,y){this.g.get(v)?.acknowledgeDataEvent(y)}$acceptProcessInput(v,y){this.g.get(v)?.input(y)}$acceptTerminalInteraction(v){const y=this.W(v);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(v,y){this.W(v)?.setSelection(y)}$acceptProcessResize(v,y,k){try{this.g.get(v)?.resize(y,k)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(v,y){this.g.get(v)?.shutdown(y)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(y=>this.a.$sendProcessProperty(v,{type:"cwd",value:y}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new g.$8K(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,y,k){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,k),this.a.$registerProfileProvider(y,v.identifier.value),new g.$8K(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(v,y,k){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,k),this.a.$registerQuickFixProvider(v,y),new g.$8K(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,y){const k=new u.$6d().token;if(k.isCancellationRequested)return;const N=this.D.get(v);if(!N)return;const O=await N.provideTerminalQuickFixes(y,k);if(O===null||Array.isArray(O)&&O.length===0)return;const G=new $.$Sc;if(this.w.value=G,!Array.isArray(O))return O?t.TerminalQuickFix.from(O,this.Q.converter,G):void 0;const W=[];for(const z of O){const P=t.TerminalQuickFix.from(z,this.Q.converter,G);P&&W.push(P)}return W}async $createContributedProfileTerminal(v,y){const k=new u.$6d().token;let N=await this.C.get(v)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,y);return}this.createTerminalFromOptions(N.options,y)}}async $provideLinks(v,y){const k=this.W(v);if(!k)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const O=new u.$6d;this.G.set(v,O);const G=[],W={terminal:k.value,line:y},z=[];for(const H of this.z)z.push(o.Promises.withAsyncBody(async ae=>{O.token.onCancellationRequested(()=>ae({provider:H,links:[]}));const de=await H.provideTerminalLinks(W,O.token)||[];O.token.isCancellationRequested||ae({provider:H,links:de})}));const P=await Promise.all(z);if(O.token.isCancellationRequested)return[];const I=new Map;for(const H of P)H&&H.links.length>0&&G.push(...H.links.map(ae=>{const de={id:h++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return I.set(de.id,{provider:H.provider,link:ae}),de}));return this.F.set(v,I),G}$activateLink(v,y){const k=this.F.get(v)?.get(y);k&&k.provider.handleTerminalLink(k.link)}U(v,y){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const k=this.h[v];k&&(k.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,y)}W(v){return this.X(this.f,v)}X(v,y){const k=this.Y(v,y);return k!==null?v[k]:null}Y(v,y){const k=v.findIndex(N=>N._id===y);return k===-1?null:k}getEnvironmentVariableCollection(v){let y=this.n.get(v.identifier.value);return y||(y=new l,this.$(v.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(v,y){const k=(0,D.$Mr)(y.map),N=(0,D.$Nr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(v,y.persistent,k.length===0?void 0:k,N)}$initEnvironmentVariableCollections(v){v.forEach(y=>{const k=y[0],N=new l(y[1]);this.$(k,N)})}$acceptDefaultProfile(v,y){const k=this.s;this.s=v,this.u=y,k?.path!==v.path&&this.N.fire(v.path)}$(v,y){this.n.set(v,y),y.onDidChangeCollection(()=>{this.Z(v,y)})}};e.$Sgc=i,e.$Sgc=i=Je([Ke(1,n.$tN),Ke(2,R.$0M)],i);class l{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Vd,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const y=this.h(v);let k=this.a.get(y);return k||(k=new r(this,v),this.a.set(y,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(v,y,k,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:N})}append(v,y,k,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:N})}prepend(v,y,k,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:N})}f(v,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(v,y.scope),N=this.map.get(k),O=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==y.value||N.type!==y.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const G=this.g(v,y.scope),W={variable:v,...y,options:O};this.map.set(G,W),this.d.fire()}}get(v,y){const k=this.g(v,y),N=this.map.get(k);return N?S(N):void 0}g(v,y){const k=this.h(y);return k.length?`${v}:::${k}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const y=new Map;for(const[k,N]of this.map)this.h(N.scope)===this.h(v)&&y.set(N.variable,S(N));return y}delete(v,y){const k=this.g(v,y);this.map.delete(k),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[y,k]of this.map)k.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(y);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,y){const k=this.h(y),N=this.descriptionMap.get(k);if(!N||N.description!==v){let O;typeof v=="string"?O=v:O=v?.value.split(`

`)[0];const G={description:O,scope:y};this.descriptionMap.set(k,G),this.d.fire()}}getDescription(v){const y=this.h(v);return this.descriptionMap.get(y)?.description}k(v){const y=this.h(v);this.descriptionMap.delete(y)}}class r{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,y){this.b=v,this.d=y,this.a=new E.$Vd}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,y,k){this.b.replace(v,y,k,this.d)}append(v,y,k){this.b.append(v,y,k,this.d)}prepend(v,y,k){this.b.prepend(v,y,k,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,y){this.b.getVariableMap(this.d).forEach((k,N)=>v.call(y,N,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends i{constructor(v,y){super(!1,v,y)}createTerminal(v,y,k){throw new A.$_}createTerminalFromOptions(v,y){throw new A.$_}};e.$Tgc=d,e.$Tgc=d=Je([Ke(0,n.$tN),Ke(1,R.$0M)],d);function m(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function f(L){return s.ThemeColor.isThemeColor(L)?L:void 0}function S(L){const v={...L};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Pe[266],Re([1,0,13,24,20,5,218,98,6,26,16,33,14,3,17,108,8,7,48,77,58,23]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=e.$Yhc=e.$Xhc=e.$Whc=void 0;let i=class extends g.$Tc{constructor(z,P,I,H){super(),this.w=H,this.f=this.B(new M.$Vd),this.g=new Map,this.s=this.B(new M.$Vd),this.onResultsChanged=this.f.event,this.results=[],this.h=z.getProxy(p.$6K.MainThreadTesting),this.m=new k(this.h),this.j=new m(this.h,P),I.registerArgumentProcessor({processArgument:ae=>{switch(ae?.$mid){case 16:{const de=ae,we=de.tests[de.tests.length-1].item.extId;return this.g.get(n.$XJ.root(we))?.collection.tree.get(we)?.actual??(0,s.$jN)(ae)}case 18:{const{extId:de,message:we}=ae;return{test:this.g.get(n.$XJ.root(de))?.collection.tree.get(de)?.actual,message:o.TestMessage.to(we)}}default:return ae}}}),I.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ae=await I.executeCommand("_testing.getExplorerSelection"),de=we=>{const ke=this.g.get(n.$XJ.root(we));if(ke)return n.$XJ.isRoot(we)?ke.controller:ke.collection.tree.get(we)?.actual};return{include:ae?.include.map(de).filter(A.$Qf)||[],exclude:ae?.exclude.map(de).filter(A.$Qf)||[]}})}createTestController(z,P,I,H){if(this.g.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const ae=new g.$Sc,de=ae.add(new s.$mN(P,I,this.w));de.root.label=I;const we=new Map,ke=new Set,le=this.h,ve={items:de.root.children,get label(){return I},set label(be){I=be,de.root.label=be,le.$updateController(P,{label:I})},get refreshHandler(){return H},set refreshHandler(be){H=be,le.$updateController(P,{canRefresh:!!be})},get id(){return P},createRunProfile:(be,ne,Y,V,ie,Ie)=>{let Le=(0,$.$Ti)(be);for(;we.has(Le);)Le++;return new O(this.h,we,z,ke,this.s.event,P,Le,be,ne,Y,V,ie,Ie)},createTestItem(be,ne,Y){return new s.$kN(P,be,ne,Y)},createTestRun:(be,ne,Y=!0)=>this.j.createTestRun(z,P,de,be,ne,Y),invalidateTestResults:be=>{if(be===void 0)this.h.$markTestRetired(void 0);else{const ne=be instanceof Array?be:[be];this.h.$markTestRetired(ne.map(Y=>n.$XJ.fromExtHostTestItem(Y,P).toString()))}},set resolveHandler(be){de.resolveHandler=be},get resolveHandler(){return de.resolveHandler},dispose:()=>{ae.dispose()}};le.$registerTestController(P,I,!!H),ae.add((0,g.$Rc)(()=>le.$unregisterTestController(P)));const se={controller:ve,collection:de,profiles:we,extension:z,activeProfiles:ke};return this.g.set(P,se),ae.add((0,g.$Rc)(()=>this.g.delete(P))),ae.add(de.onDidGenerateDiff(be=>le.$publishDiff(P,be.map(c.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(z,P=C.CancellationToken.None){const I=f(z);if(!I)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.g.get(I.controllerId);if(!H)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:z.include?.map(ae=>n.$XJ.fromExtHostTestItem(ae,H.collection.root.id).toString())??[H.collection.root.id],profileGroup:G[I.kind],profileId:I.profileId,controllerId:I.controllerId}],exclude:z.exclude?.map(ae=>ae.id)},P)}$syncTests(){for(const{collection:z}of this.g.values())z.flushDiff();return Promise.resolve()}async $provideFileCoverage(z,P,I){return await this.j.getCoverageReport(z,P)?.provideFileCoverage(I)??[]}async $resolveFileCoverage(z,P,I,H){return await this.j.getCoverageReport(z,P)?.resolveFileCoverage(I,H)??[]}$configureRunProfile(z,P){this.g.get(z)?.profiles.get(P)?.configureHandler?.()}$setDefaultRunProfiles(z){const P=new Map;for(const[I,H]of Object.entries(z)){const ae=this.g.get(I);if(!ae)continue;const de=new Map,we=H.filter(le=>!ae.activeProfiles.has(le)),ke=[...ae.activeProfiles].filter(le=>!H.includes(le));for(const le of we)de.set(le,!0),ae.activeProfiles.add(le);for(const le of ke)de.set(le,!1),ae.activeProfiles.delete(le);de.size&&P.set(I,de)}this.s.fire(P)}async $refreshTests(z,P){await this.g.get(z)?.controller.refreshHandler?.(P)}$publishTestResults(z){this.results=Object.freeze(z.map(P=>(0,b.$wn)(o.TestResults.to(P))).concat(this.results).sort((P,I)=>I.completedAt-P.completedAt).slice(0,32)),this.f.fire()}async $expandTest(z,P){const I=this.g.get(n.$XJ.fromString(z).controllerId)?.collection;I&&(await I.expand(z,P<0?1/0:P),I.flushDiff())}$acceptDiff(z){this.m.applyDiff(z.map(P=>c.TestsDiffOp.deserialize({asCanonicalUri:I=>I},P)))}async $runControllerTests(z,P){return Promise.all(z.map(I=>this.y(I,!1,P)))}async $startContinuousRun(z,P){const I=new C.$6d(P),H=await Promise.all(z.map(ae=>this.y(ae,!0,I.token)));return!P.isCancellationRequested&&!H.some(ae=>ae.error)&&await new Promise(ae=>P.onCancellationRequested(ae)),I.dispose(!0),H}async y(z,P,I){const H=this.g.get(z.controllerId);if(!H)return{};const{collection:ae,profiles:de,extension:we}=H,ke=de.get(z.profileId);if(!ke)return{};const le=z.testIds.map(ne=>ae.tree.get(ne)).filter(A.$Qf),ve=z.excludeExtIds.map(ne=>H.collection.tree.get(ne)).filter(A.$Qf).filter(ne=>le.some(Y=>Y.fullId.compare(ne.fullId)===2));if(!le.length)return{};const se=new t.$EM(le.some(ne=>ne.actual instanceof s.$lN)?void 0:le.map(ne=>ne.actual),ve.map(ne=>ne.actual),ke,P),be=(0,c.$ZJ)(z)&&this.j.prepareForMainThreadTestRun(se,S.fromInternal(z,H.collection),we,I);try{return await ke.runHandler(se,I),{}}catch(ne){return{error:String(ne)}}finally{be&&(be.hasRunningTasks&&!I.isCancellationRequested&&await M.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(z){z===void 0?this.j.cancelAllRuns():this.j.cancelRunById(z)}};e.$Whc=i,e.$Whc=i=Je([Ke(0,w.$0M),Ke(1,u.$nj)],i);const l=1e4;var r;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(r||(r={}));class d extends g.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(z,P,I,H,ae){super(),this.s=z,this.w=P,this.y=I,this.z=H,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new M.$Vd),this.m=this.B(new M.$Vd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new C.$6d(ae));const de=this.B(new E.$fh(()=>this.C(),l));this.B(this.h.token.onCancellationRequested(()=>de.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(z){const P=this.s.id,I=this.s.controllerId,H=(0,D.$qg)(),ae=this.y,de=this.m;let we;const ke=be=>(ne,...Y)=>{if(ve){this.z.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ne)&&(this.F(ne),be(ne,...Y))},le=(be,ne)=>{const Y=ne instanceof Array?ne.map(o.TestMessage.from):[o.TestMessage.from(ne)];if(be.uri&&be.range){const V={range:o.Range.from(be.range),uri:be.uri};for(const ie of Y)ie.location=ie.location||V}this.w.$appendTestMessagesInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),Y)};let ve=!1;const se={isPersisted:this.s.isPersisted,token:this.h.token,name:z,get coverageProvider(){return we?.provider},set coverageProvider(be){(0,h.$CF)(ae,"testCoverage"),we=be&&new L(be),de.fire({taskId:H,runId:P,coverage:we})},enqueued:ke(be=>{this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),1)}),skipped:ke(be=>{this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),5)}),started:ke(be=>{this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),2)}),errored:ke((be,ne,Y)=>{le(be,ne),this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),6,Y)}),failed:ke((be,ne,Y)=>{le(be,ne),this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,I).toString(),4,Y)}),passed:ke((be,ne)=>{this.w.$updateTestStateInRun(P,H,n.$XJ.fromExtHostTestItem(be,this.s.controllerId).toString(),3,ne)}),appendOutput:(be,ne,Y)=>{ve||(Y&&(this.s.isIncluded(Y)?this.F(Y):Y=void 0),this.w.$appendOutputToRun(P,H,T.$je.fromString(be),ne&&o.location.from(ne),Y&&n.$XJ.fromExtHostTestItem(Y,I).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(P,H),this.f.delete(H),this.f.size||this.D())}};return this.f.set(H,{run:se}),this.w.$startedTestRunTask(P,{id:H,name:z,running:!0}),se}C(){for(const{run:z}of this.f.values())z.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(z){if(!(z instanceof s.$kN))throw new a.$2M(z.id);if(this.g.has(n.$XJ.fromExtHostTestItem(z,this.s.controllerId).toString()))return;const P=[],I=this.s.colllection.root;for(;;){const H=o.TestItem.from(z);if(P.unshift(H),this.g.has(H.extId)||(this.g.add(H.extId),z===I))break;z=z.parent||I}this.w.$addTestsToRun(this.s.controllerId,this.s.id,P)}dispose(){this.D(),super.dispose()}}class m{get trackers(){return this.c.values()}constructor(z,P){this.g=z,this.h=P,this.c=new Map,this.f=[]}getCoverageReport(z,P){return this.f.find(I=>I.runId===z)?.coverage.get(P)}prepareForMainThreadTestRun(z,P,I,H){return this.j(z,P,I,H)}cancelRunById(z){for(const P of this.c.values())if(P.id===z){P.cancel();return}}cancelAllRuns(){for(const z of this.c.values())z.cancel()}createTestRun(z,P,I,H,ae,de){const we=this.c.get(H);if(we)return we.createRun(ae);const ke=S.fromPublic(P,I,H,de),le=f(H);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!H.continuous,profile:le&&{group:G[le.kind],id:le.profileId},exclude:H.exclude?.map(se=>n.$XJ.fromExtHostTestItem(se,I.root.id).toString())??[],id:ke.id,include:H.include?.map(se=>n.$XJ.fromExtHostTestItem(se,I.root.id).toString())??[I.root.id],persist:de});const ve=this.j(H,ke,z);return M.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(ke.id),ve.dispose()}),ve.createRun(ae)}j(z,P,I,H){const ae=new d(P,this.g,I,this.h,H);this.c.set(z,ae);let de;const we=ae.onDidCoverage(({runId:ke,taskId:le,coverage:ve})=>{de||(de={runId:ke,coverage:new Map},this.f.unshift(de),this.f.length>c.$5J&&this.f.pop()),de.coverage.set(le,ve),this.g.$signalCoverageAvailable(ke,le,!!ve)});return M.Event.once(ae.onEnd)(()=>{this.c.delete(z),we.dispose()}),ae}}e.$Xhc=m;const f=W=>{if(W.profile){if(!(W.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class S{static fromPublic(z,P,I,H){return new S(z,(0,D.$qg)(),I.include?.map(ae=>n.$XJ.fromExtHostTestItem(ae,z).toString())??[z],I.exclude?.map(ae=>n.$XJ.fromExtHostTestItem(ae,z).toString())??[],H,P)}static fromInternal(z,P){return new S(z.controllerId,z.runId,z.testIds,z.excludeExtIds,!0,P)}constructor(z,P,I,H,ae,de){this.controllerId=z,this.id=P,this.isPersisted=ae,this.colllection=de,this.c=I.map(we=>we+"\0"),this.f=H.map(we=>we+"\0")}isIncluded(z){const P=n.$XJ.fromExtHostTestItem(z,this.controllerId).toString()+"\0";for(const I of this.f)if(P===I||P.startsWith(I))return!1;for(const I of this.c)if(P===I||P.startsWith(I))return!0;return!1}}e.$Yhc=S;class L{constructor(z){this.provider=z}async provideFileCoverage(z){this.c||(this.c=(async()=>this.provider.provideFileCoverage(z))());try{return(await this.c)?.map(o.TestCoverage.fromFile)??[]}catch(P){throw this.c=void 0,P}}async resolveFileCoverage(z,P){const I=await this.c;let H=I?.[z];return!this.provider||!I||!H?[]:(H.detailedCoverage||(H=I[z]=await this.provider.resolveFileCoverage?.(H,P)??H),H.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(z){this.j=z,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(z){this.c.add(z)}update(z){Object.assign(z.revived,o.TestItem.toPlain(z.item)),this.c.has(z)||this.f.add(z)}remove(z){if(this.c.has(z)){this.c.delete(z);return}this.f.delete(z);const P=n.$XJ.parentId(z.item.extId);if(P&&this.h.has(P.toString())){this.h.add(z.item.extId);return}this.g.add(z)}getChangeEvent(){const{c:z,f:P,g:I}=this;return{get added(){return[...z].map(H=>H.revived)},get updated(){return[...P].map(H=>H.revived)},get removed(){return[...I].map(H=>H.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends c.$6J{constructor(){super(...arguments),this.s=new M.$Vd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(z){return this.f.get(z)}getMirroredTestDataByReference(z){return this.f.get(z.id)}w(z,P){return{...z,revived:o.TestItem.toPlain(z.item),depth:P?P.depth+1:0,children:new Set}}v(){return new v(this.s)}}class k{constructor(z){this.f=z}checkout(){this.c||(this.c=this.g());const z=this.c;return z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,get tests(){return[...z.tests.rootTests].map(P=>P.revived)},dispose:(0,R.$db)(()=>{--z.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(z){return this.c?.tests.getMirroredTestDataByReference(z)}applyDiff(z){this.c?.tests.apply(z)}g(){const z=new y({asCanonicalUri:P=>P});return this.f.$subscribeToDiffs(),{observers:0,tests:z}}}const N=(W,z,P,I)=>{P?Object.assign(P,I):z.$updateTestRunConfig(W.controllerId,W.profileId,I)};class O{#e;#t;#i;#o;#n;#r;get label(){return this.f}set label(z){z!==this.f&&(this.f=z,N(this,this.#e,this.#n,{label:z}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(z){z!==this.g&&(this.g=z,N(this,this.#e,this.#n,{supportsContinuousRun:z}))}get isDefault(){return this.#i.has(this.profileId)}set isDefault(z){z!==this.isDefault&&(z?this.#i.add(this.profileId):this.#i.delete(this.profileId),N(this,this.#e,this.#n,{isDefault:z}))}get tag(){return this._tag}set tag(z){z?.id!==this._tag?.id&&(this._tag=z,N(this,this.#e,this.#n,{tag:z?o.TestTag.namespace(this.controllerId,z.id):null}))}get configureHandler(){return this.c}set configureHandler(z){z!==this.c&&(this.c=z,N(this,this.#e,this.#n,{hasConfigurationHandler:!!z}))}get onDidChangeDefault(){return(0,h.$CF)(this.#t,"testingActiveProfile"),M.Event.chain(this.#o,z=>z.map(P=>P.get(this.controllerId)?.get(this.profileId)).filter(A.$Qf))}constructor(z,P,I,H,ae,de,we,ke,le,ve,se=!1,be=void 0,ne=!1){this.controllerId=de,this.profileId=we,this.f=ke,this.kind=le,this.runHandler=ve,this._tag=be,this.g=ne,this.#e=z,this.#r=P,this.#t=I,this.#i=H,this.#o=ae,P.set(we,this);const Y=G[le];if(typeof Y!="number")throw new Error(`Unknown TestRunProfile.group ${le}`);se&&H.add(we),this.#n={profileId:we,controllerId:de,tag:be?o.TestTag.namespace(this.controllerId,be.id):null,label:ke,group:Y,isDefault:se,hasConfigurationHandler:!1,supportsContinuousRun:ne},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Zhc=O;const G={[t.TestRunProfileKind.Coverage]:8,[t.TestRunProfileKind.Debug]:4,[t.TestRunProfileKind.Run]:2}}),define(Pe[267],Re([1,0,18,5,3,109,8,7]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class g{constructor(A,D){this.i=D,this.a=new T.$Vd,this.b=new T.$Vd,this.c=new T.$Vd,this.d=new T.$Vd,this.f=new T.$Vd,this.g=new T.$Vd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(C.$6K.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const D=this.i.allEditors();return A?D:D.map(u=>u.value)}async showTextDocument(A,D,u){let p;typeof D=="number"?p={position:R.ViewColumn.from(D),preserveFocus:u}:typeof D=="object"?p={position:R.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?R.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(A.uri,p),s=w&&this.i.getEditor(w);if(s)return s.value;throw w?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,D){return new M.$eN(this.h,A,D).value}$acceptEditorPropertiesChanged(A,D){const u=this.i.getEditor(A);if(!u)throw new Error("unknown text editor");if(D.options&&u._acceptOptions(D.options),D.selections){const p=D.selections.selections.map(R.Selection.to);u._acceptSelections(p)}if(D.visibleRanges){const p=E.$Hb(D.visibleRanges.map(R.Range.to));u._acceptVisibleRanges(p)}if(D.options&&this.b.fire({textEditor:u.value,options:{...D.options,lineNumbers:R.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const p=$.TextEditorSelectionChangeKind.fromValue(D.selections.source),w=D.selections.selections.map(R.Selection.to);this.a.fire({textEditor:u.value,selections:w,kind:p})}if(D.visibleRanges){const p=E.$Hb(D.visibleRanges.map(R.Range.to));this.c.fire({textEditor:u.value,visibleRanges:p})}}$acceptEditorPositionData(A){for(const D in A){const u=this.i.getEditor(D);if(!u)throw new Error("Unknown text editor");const p=R.ViewColumn.to(A[D]);u.value.viewColumn!==p&&(u._acceptViewColumn(p),this.d.fire({textEditor:u.value,viewColumn:p}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$jgc=g}),define(Pe[268],Re([1,0,2,4,3,6,7,8,22,16]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=void 0,e.$2hc=(0,T.$6h)("IExtHostTimeline");class A{constructor(p,w){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$6K.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&g.$lm.equals(o,this.b.get(s.source)?.extension)){const t=s.uri===void 0?void 0:E.URI.revive(s.uri);return this.c.get(s.source)?.get(D(t))?.get(s.handle)}else return;return s}})}async $getTimeline(p,w,s,o){return this.b.get(p)?.provider.provideTimeline(E.URI.revive(w),s,o)}registerTimelineProvider(p,w,s,o){const t=new M.$Sc,n=this.d(w.id,o,t).bind(this);let a;w.onDidChange&&(a=w.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:w.id}),this));const c=this.c;return this.f({...w,scheme:p,onDidChange:void 0,async provideTimeline(h,i,l){i?.resetCache&&(t.clear(),c.get(w.id)?.clear());const r=await w.provideTimeline(h,i,l);if(r==null)return;const d=n(h,i);return{...r,source:w.id,items:r.items.map(d)}},dispose(){for(const h of c.values())h.get(w.id)?.clear();a?.dispose(),t.dispose()}},s)}d(p,w,s){return(o,t)=>{let n;if(t?.cacheResults){let a=this.c.get(p);a===void 0&&(a=new Map,this.c.set(p,a));const c=D(o);n=a.get(c),n===void 0&&(n=new Map,a.set(c,n))}return a=>{const{iconPath:c,...h}=a,i=`${p}|${a.id??a.timestamp}`;n?.set(i,a);let l,r,d;a.iconPath&&(c instanceof R.$3L?d={id:c.id,color:c.color}:E.URI.isUri(c)?(l=c,r=c):{light:l,dark:r}=c);let m;return R.$wL.isMarkdownString(h.tooltip)?m=$.MarkdownString.from(h.tooltip):(0,b.$If)(h.tooltip)?m=h.tooltip:R.$wL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=$.MarkdownString.from(h.detail)):(0,b.$If)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=h.detail),{...h,id:h.id??void 0,handle:i,source:p,command:a.command?w.toInternal(a.command,s):void 0,icon:l,iconDark:r,themeIcon:d,tooltip:m,accessibilityInformation:a.accessibilityInformation}}}}f(p,w){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:w}),(0,M.$Rc)(()=>{for(const o of this.c.values())o.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$3hc=A;function D(u){return u?.toString()}}),define(Pe[87],Re([1,0,20,5,6,167,4,14,196,3,27,17,7]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pyb=e.$oyb=e.TunnelDtoConverter=void 0;class p extends g.$Jv{}var w;(function(o){function t(a){return{remoteAddress:a.remoteAddress,localAddress:a.localAddress,public:!!a.public,privacy:a.privacy??(a.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:a.protocol}}o.fromApiTunnel=t;function n(a){return{remoteAddress:{host:a.tunnelRemoteHost,port:a.tunnelRemotePort},localAddress:a.localAddress,public:a.privacy!==g.TunnelPrivacyId.ConstantPrivate&&a.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:a.privacy,protocol:a.protocol}}o.fromServiceTunnel=n})(w||(e.TunnelDtoConverter=w={})),e.$oyb=(0,R.$6h)("IExtHostTunnelService");let s=class extends C.$Tc{constructor(t,n,a){super(),this.s=a,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Vd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(b.$6K.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const a=await this.a.$openTunnel(n,t.displayName);if(a){const c=new p(a.remoteAddress,a.localAddress,()=>this.a.$closeTunnel(a.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const a=this.u();return this.r.set(a,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,a),new u.$8K(()=>{this.r.delete(a),this.a.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(t,n,a,c,h){const i=[];for(const r of t){const d=this.r.get(r);if(!d)return[];i.push(...await Promise.all(n.map(async m=>{let f;try{f=await d.provider.providePortAttributes({port:m,pid:a,commandLine:c},h)}catch{f=await d.provider.providePortAttributes(m,a,c,h)}return{providedAttributes:f,port:m}})))}const l=i.filter(r=>!!r.providedAttributes);return l.length>0?l.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await t.provideTunnel(c,h,new E.$6d().token)??void 0;const a=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(a),Promise.resolve((0,C.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const a=t.tunnelFactory??(n?this.w(n):void 0);if(a){this.b=a;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,C.$Rc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const a=this.g.get(t.host);a.has(t.port)&&(n&&a.get(t.port).disposeListener.dispose(),await a.get(t.port).tunnel.dispose(),a.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const c=await a;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:h}),w.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(a){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),a instanceof Error)return a.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),a=t.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${a.map(c=>c.port).join(", ")}`),a}};e.$pyb=s,e.$pyb=s=Je([Ke(0,D.$0M),Ke(1,A.$nN),Ke(2,$.$nj)],s)}),define(Pe[269],Re([1,0,6,12,2,3]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(M.$6K.MainThreadUriOpeners)}registerExternalUriOpener(g,b,A,D){if(this.c.has(b))throw new Error(`Opener with id '${b}' already registered`);const u=D.schemes.find(p=>!R.a.has(p));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(b,A),this.b.$registerUriOpener(b,D.schemes,g,D.label),(0,E.$Rc)(()=>{this.c.delete(b),this.b.$unregisterUriOpener(b)})}async $canOpenUri(g,b,A){const D=this.c.get(g);if(!D)throw new Error(`Unknown opener with id: ${g}`);const u=C.URI.revive(b);return D.canOpenExternalUri(u,A)}async $openUri(g,b,A){const D=this.c.get(g);if(!D)throw new Error(`Unknown opener id: '${g}'`);return D.openExternalUri(C.URI.revive(b.resolvedUri),{sourceUri:C.URI.revive(b.sourceUri)},A)}}e.$5hc=R}),define(Pe[270],Re([1,0,3,2,6,15,22]),function(ge,e,E,T,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class ${static{this.a=0}constructor(b){this.c=new R.$mm,this.d=new Map,this.b=b.getProxy(E.$6K.MainThreadUrls)}registerUriHandler(b,A){const D=b.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=$.a++;return this.c.add(D),this.d.set(u,A),this.b.$registerUriHandler(u,D,b.displayName||b.name),(0,C.$Rc)(()=>{this.c.delete(D),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(b,A){const D=this.d.get(b);if(!D)return Promise.resolve(void 0);try{D.handleUri(T.URI.revive(A))}catch(u){(0,M.$1)(u)}return Promise.resolve(void 0)}async createAppUri(b){return T.URI.revive(await this.b.$createAppUri(b))}}e.$6hc=$}),define(Pe[65],Re([1,0,5,6,12,26,2,181,203,78,3]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=e.$Agc=e.$zgc=e.$ygc=e.$xgc=void 0;class D{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;constructor(c,h,i,l,r,d,m){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Vd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Vd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=l,this.#n=r,this.#r=d,this.#l=u(d),this.#d=p(d),this.#i=m}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,b.$wvb)(c,this.#o)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===C.Schemas.https||c.scheme===C.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+b.$vvb}return b.$vvb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),M.$zn(this.#s,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#n,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$clb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,r,d,m,f,S)=>{const L=R.URI.from({scheme:m||"file",path:decodeURIComponent(f)}),v=(0,b.$wvb)(L,{isRemote:h,authority:i}).toString();return`${r}${v}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,r,d,m,f,S)=>{const L=R.URI.from({scheme:m||"file",path:decodeURIComponent(f)}),v=(0,b.$wvb)(L,{isRemote:h,authority:i}).toString();return`${r}${v}${S}`})}}e.$xgc=D;function u(a){try{const c=(0,$.$cp)((0,$.$bp)(a.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$ygc=u;function p(a){try{const c=(0,$.$cp)((0,$.$bp)(a.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class w extends T.$Tc{constructor(c,h,i,l,r){super(),this.c=h,this.f=i,this.g=l,this.h=r,this.b=new Map,this.a=c.getProxy(A.$6K.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const l=this.j(c);if(l){const{message:r}=(0,g.$dlb)(h,i.value);l._onMessageEmitter.fire(r)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const l=new D(c,this.a,t(h),this.c,this.f,i,this.h);this.b.set(c,l);const r=l._onDidDispose(()=>{r.dispose(),this.deleteWebview(c)});return l}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$zgc=w;function s(a){return{id:a.identifier,location:a.extensionLocation}}e.$Agc=s;function o(a,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(a,c)}}e.$Bgc=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(c=>R.URI.from(c))}}function n(a,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),a.extensionLocation]}}),define(Pe[271],Re([1,0,20,98,6,12,25,2,8,65,75,3,7]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class p{constructor(l,r){this.document=l,this.b=r,this.a=1,this.c=new A.$3fc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,r){await this.f(l).undo(),r||this.disposeBackup()}async redo(l,r){await this.f(l).redo(),r||this.disposeBackup()}disposeEdits(l){for(const r of l)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=h(this.document.uri)+this.a++;return(0,R.$Hg)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const r=this.c.get(l,0);if(!r)throw new Error("No edit found");return r}}class w{constructor(){this.a=new Map}get(l,r){return this.a.get(this.b(l,r))}add(l,r,d){const m=this.b(l,r.uri);if(this.a.has(m))throw new Error(`Document already exists for viewType:${l} resource:${r.uri}`);const f=new p(r,d);return this.a.set(m,f),f}delete(l,r){const d=this.b(l,r.uri);this.a.delete(d)}b(l,r){return`${l}@@@${r}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider(l,r,d){return this.b(0,l,r,d)}addCustomProvider(l,r,d){return this.b(1,l,r,d)}get(l){return this.a.get(l)}b(l,r,d,m){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:l,extension:d,provider:m}),new u.$8K(()=>this.a.delete(r))}}class t{constructor(l,r,d,m,f){this.d=r,this.f=d,this.g=m,this.h=f,this.b=new o,this.c=new w,this.a=l.getProxy(D.$6K.MainThreadCustomEditors)}registerCustomEditorProvider(l,r,d,m){const f=new C.$Sc;return a(d)?(f.add(this.b.addTextProvider(r,l,d)),this.a.$registerTextEditorProvider((0,b.$Agc)(l),r,m.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,b.$ygc)(l))):(f.add(this.b.addCustomProvider(r,l,d)),n(d)&&f.add(d.onDidChangeCustomDocument(S=>{const L=this.i(r,S.document.uri);if(c(S)){const v=L.addEdit(S);this.a.$onDidEdit(S.document.uri,r,v,S.label)}else this.a.$onContentChange(S.document.uri,r)})),this.a.$registerCustomEditorProvider((0,b.$Agc)(l),r,m.webviewOptions||{},!!m.supportsMultipleEditorsPerDocument,(0,b.$ygc)(l))),u.$8K.from(f,new u.$8K(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(l,r,d,m,f){const S=this.b.get(r);if(!S)throw new Error(`No provider found for '${r}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${r}'`);const L=$.URI.revive(l),v=await S.provider.openCustomDocument(L,{backupId:d,untitledDocumentData:m?.buffer},f);let y;return n(S.provider)&&this.f&&(y=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(r,v,y),{editable:n(S.provider)}}async $disposeCustomDocument(l,r){const d=this.b.get(r);if(!d)throw new Error(`No provider found for '${r}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${r}'`);const m=$.URI.revive(l),{document:f}=this.i(r,m);this.c.delete(r,f),f.dispose()}async $resolveCustomEditor(l,r,d,m,f,S){const L=this.b.get(d);if(!L)throw new Error(`No provider found for '${d}'`);const v=g.ViewColumn.to(f),y=this.g.createNewWebview(r,m.contentOptions,L.extension),k=this.h.createNewWebviewPanel(r,d,m.title,v,m.options,y,m.active),N=$.URI.revive(l);switch(L.type){case 1:{const{document:O}=this.i(d,N);return L.provider.resolveCustomEditor(O,k,S)}case 0:{const O=this.d.getDocument(N);return L.provider.resolveCustomTextEditor(O,k,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,r,d){this.i(r,l).disposeEdits(d)}async $onMoveCustomEditor(l,r,d){const m=this.b.get(d);if(!m)throw new Error(`No provider found for '${d}'`);if(!m.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this.h.getWebviewPanel(l);if(!f)throw new Error("No webview found");const S=$.URI.revive(r),L=this.d.getDocument(S);await m.provider.moveCustomTextEditor(L,f,E.CancellationToken.None)}async $undo(l,r,d,m){return this.i(r,l).undo(d,m)}async $redo(l,r,d,m){return this.i(r,l).redo(d,m)}async $revert(l,r,d){const m=this.i(r,l);await this.j(r).revertCustomDocument(m.document,d),m.disposeBackup()}async $onSave(l,r,d){const m=this.i(r,l);await this.j(r).saveCustomDocument(m.document,d),m.disposeBackup()}async $onSaveAs(l,r,d,m){const f=this.i(r,l);return this.j(r).saveCustomDocumentAs(f.document,$.URI.revive(d),m)}async $backup(l,r,d){const m=this.i(r,l),S=await this.j(r).backupCustomDocument(m.document,{destination:m.getNewBackupUri()},d);return m.updateBackup(S),S.id}i(l,r){const d=this.c.get(l,$.URI.revive(r));if(!d)throw new Error("No custom document found");return d}j(l){const d=this.b.get(l)?.provider;if(!d||!n(d))throw new Error("Custom document is not editable");return d}}e.$Dgc=t;function n(i){return!!i.onDidChangeCustomDocument}function a(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const l=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Ti)(l)+""}}),define(Pe[272],Re([1,0,5,6,2,33,8,65,3,7]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;class A extends T.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;#h;constructor(w,s,o,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Vd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Vd),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=s,this.#o=o,this.#i=t.viewType,this.#n=t.panelOptions,this.#s=t.viewColumn,this.#r=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,C.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#n}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(w){this.#l||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#u=w.active,this.#c=w.visible,this.#s=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:R.ViewColumn.from(w),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends T.$Tc{static c(){return(0,M.$qg)()}constructor(w,s,o){super(),this.j=s,this.m=o,this.g=new Map,this.h=new Map,this.f=w.getProxy(g.$6K.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,s,o,t,n={}){const a=typeof t=="object"?t.viewColumn:t,c={viewColumn:R.ViewColumn.from(a),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,$.$ygc)(w),i=D.c();this.f.$createWebviewPanel((0,$.$Agc)(w),i,s,{title:o,panelOptions:u(n),webviewOptions:(0,$.$Bgc)(w,this.m,n),serializeBuffersForPostMessage:h},c);const l=this.j.createNewWebview(i,n,w);return this.createNewWebviewPanel(i,s,o,a,n,l,!0)}$onDidChangeWebviewPanelViewStates(w){const s=Object.keys(w);s.sort((o,t)=>{const n=w[o],a=w[t];return n.active?1:a.active?-1:+n.visible-+a.visible});for(const o of s){const t=this.getWebviewPanel(o);if(!t)continue;const n=w[o];t._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,s,o){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:o,extension:w}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,$.$ygc)(w)}),new b.$8K(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(w,s,o,t){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:a,extension:c}=n,h=this.j.createNewWebview(w,o.webviewOptions,c),i=this.createNewWebviewPanel(w,s,o.title,t,o.panelOptions,h,o.active);await a.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(w,s,o,t,n,a,c){const h=new A(w,this.f,a,{viewType:s,title:o,viewColumn:t,panelOptions:n,active:c});return this.g.set(w,h),h}getWebviewPanel(w){return this.g.get(w)}}e.$Cgc=D;function u(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Pe[273],Re([1,0,5,6,65,8,3,7]),function(ge,e,E,T,C,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;class g extends T.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;constructor(D,u,p,w,s,o){super(),this.#n=!1,this.#u=this.B(new E.$Vd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Vd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=w,this.#e=D,this.#t=u,this.#o=s,this.#r=o}dispose(){this.#n||(this.#n=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#s}set description(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#n||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#n)throw new Error("Webview is disposed")}}class b{constructor(D,u){this.d=u,this.b=new Map,this.c=new Map,this.a=D.getProxy(R.$6K.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,p,w){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:p,extension:D}),this.a.$registerWebviewViewProvider((0,C.$Agc)(D),u,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$ygc)(D)}),new $.$8K(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,p,w,s){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:t,extension:n}=o,a=this.d.createNewWebview(D,{},n),c=new g(D,this.a,u,p,a,!0);this.c.set(D,c),await t.resolveWebviewView(c,{state:w},s)}async $onDidChangeWebviewViewVisibility(D,u){this.e(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.e(D);this.c.delete(D),u.dispose(),this.d.deleteWebview(D)}e(D){const u=this.c.get(D);if(!u)throw new Error("No webview found");return u}}e.$7hc=b}),define(Pe[111],Re([1,0,5,3,2,12,11,4,17,23]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=e.$8hc=void 0;let D=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(p){const w=this.d;return{get focused(){return w.focused},get active(){return(0,b.$CF)(p,"windowActivity"),w.active}}}constructor(p){this.c=new E.$Vd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=p.getProxy(T.$6K.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:s})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,w){w!==this.d[p]&&(this.d={...this.d,[p]:w},this.c.fire(this.d))}openUri(p,w){let s;if(typeof p=="string"){s=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,R.$Je)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,s,w)}async asExternalUri(p,w){if((0,R.$Je)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(p,w);return C.URI.from(s)}};e.$8hc=D,e.$8hc=D=A=Je([Ke(0,g.$0M)],D),e.$9hc=(0,$.$6h)("IExtHostWindow")}),define(Pe[274],Re([1,0,240,27,17]),function(ge,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=void 0;let M=class extends E.$_hc{constructor($,g){super($,g)}f($,g,b){g.apply(console,b)}};e.$ikc=M,e.$ikc=M=Je([Ke(0,C.$0M),Ke(1,T.$nN)],M)}),define(Pe[275],Re([1,0,13,24,20,15,5,6,139,229,49]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$o8b=e.ResponsiveState=e.RequestInitiator=e.$n8b=e.$m8b=void 0;function u(k,N){try{return JSON.stringify(k,N)}catch{return"null"}}const p="$$ref$$",w={[p]:-1};class s{constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function o(k,N=null,O=!1){const G=[];return{jsonString:(O?u:JSON.stringify)(k,(z,P)=>{if(typeof P>"u")return w;if(typeof P=="object"){if(P instanceof T.$je){const I=G.push(P)-1;return{[p]:I}}if(N)return N(z,P)}return P}),referencedBuffers:G}}e.$m8b=o;function t(k,N,O){return JSON.parse(k,(G,W)=>{if(W){const z=W[p];if(typeof z=="number")return N[z];if(O&&W.$mid===1)return O.transformIncoming(W)}return W})}e.$n8b=t;function n(k,N){return JSON.stringify(k,N)}function a(k){return k?(N,O)=>O&&O.$mid===1?k.transformOutgoing(O):O:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},l=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class d extends $.$Tc{static{D=l}static{this.a=3*1e3}constructor(N,O=null,G=null){super(),this[D]=!0,this.b=this.B(new R.$Vd),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=O,this.g=G,this.h=a(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,z=A.$Qv.count;W<z;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$fh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const O=this.w[N];delete this.w[N],O.resolveErr(M.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,g.$7m)(N,this.g):N}getProxy(N){const{nid:O,sid:G}=N;return this.s[O]||(this.s[O]=this.J(O,G)),this.s[O]}J(N,O){const G={get:(W,z)=>(typeof z=="string"&&!W[z]&&z.charCodeAt(0)===36&&(W[z]=(...P)=>this.U(N,z,P)),z===r?O:W[z])};return new Proxy(Object.create(null),G)}set(N,O){return this.m[N.nid]=O,O}assertRegistered(N){for(let O=0,G=N.length;O<G;O++){const W=N[O];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(N){if(this.j)return;const O=N.byteLength,G=f.read(N,0),W=G.readUInt8(),z=G.readUInt32();switch(W){case 1:case 2:{let{rpcId:P,method:I,args:H}=L.deserializeRequestJSONArgs(G);this.g&&(H=(0,g.$7m)(H,this.g)),this.M(O,z,P,I,H,W===2);break}case 3:case 4:{let{rpcId:P,method:I,args:H}=L.deserializeRequestMixedArgs(G);this.g&&(H=(0,g.$7m)(H,this.g)),this.M(O,z,P,I,H,W===4);break}case 5:{this.f?.logIncoming(O,z,0,"ack"),this.G(z);break}case 6:{this.N(O,z);break}case 7:{this.O(O,z,void 0);break}case 9:{let P=L.deserializeReplyOKJSON(G);this.g&&(P=(0,g.$7m)(P,this.g)),this.O(O,z,P);break}case 10:{const P=L.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(O,z,P);break}case 8:{const P=L.deserializeReplyOKVSBuffer(G);this.O(O,z,P);break}case 11:{let P=L.deserializeReplyErrError(G);this.g&&(P=(0,g.$7m)(P,this.g)),this.P(O,z,P);break}case 12:{this.P(O,z,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,O,G,W,z,P){this.f?.logIncoming(N,O,1,`receiveRequest ${(0,A.$Sv)(G)}.${W}(`,z);const I=String(O);let H,ae;if(P){const we=new C.$6d;z.push(we.token),H=this.Q(G,W,z),ae=()=>we.cancel()}else H=this.Q(G,W,z),ae=i;this.u[I]=ae;const de=L.serializeAcknowledged(O);this.f?.logOutgoing(de.byteLength,O,1,"ack"),this.c.send(de),H.then(we=>{delete this.u[I];const ke=L.serializeReplyOK(O,we,this.h);this.f?.logOutgoing(ke.byteLength,O,1,"reply:",we),this.c.send(ke)},we=>{delete this.u[I];const ke=L.serializeReplyErr(O,we);this.f?.logOutgoing(ke.byteLength,O,1,"replyErr:",we),this.c.send(ke)})}N(N,O){this.f?.logIncoming(N,O,1,"receiveCancel");const G=String(O);this.u[G]?.()}O(N,O,G){this.f?.logIncoming(N,O,0,"receiveReply:",G);const W=String(O);if(!this.w.hasOwnProperty(W))return;const z=this.w[W];delete this.w[W],z.resolveOk(G)}P(N,O,G){this.f?.logIncoming(N,O,0,"receiveReplyErr:",G);const W=String(O);if(!this.w.hasOwnProperty(W))return;const z=this.w[W];delete this.w[W];let P;G&&(G.$isError?(P=new Error,P.name=G.name,P.message=G.message,P.stack=G.stack):P=G),z.resolveErr(P)}Q(N,O,G){try{return Promise.resolve(this.S(N,O,G))}catch(W){return Promise.reject(W)}}S(N,O,G){const W=this.m[N];if(!W)throw new Error("Unknown actor "+(0,A.$Sv)(N));const z=W[O];if(typeof z!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$Sv)(N));return z.apply(W,G)}U(N,O,G){if(this.j)return new b.$l8b;let W=null;if(G.length>0&&C.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(M.$6());const z=L.serializeRequestArguments(G,this.h),P=++this.t,I=String(P),H=new b.$k8b,ae=new $.$Sc;W&&ae.add(W.onCancellationRequested(()=>{const we=L.serializeCancel(P);this.f?.logOutgoing(we.byteLength,P,0,"cancel"),this.c.send(L.serializeCancel(P))})),this.w[I]=new m(H,ae),this.F(P);const de=L.serializeRequest(P,N,O,z,!!W);return this.f?.logOutgoing(de.byteLength,P,0,`request: ${(0,A.$Sv)(N)}.${O}(`,G),this.c.send(de),H}}e.$o8b=d;class m{constructor(N,O){this.a=N,this.b=O}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class f{static alloc(N,O,G){const W=new f(T.$je.alloc(G+1+4),0);return W.writeUInt8(N),W.writeUInt32(O),W}static read(N,O){return new f(N,O)}get buffer(){return this.a}constructor(N,O){this.a=N,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+N);return this.b+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let G=0,W=N.length;G<W;G++){const z=N[G];switch(O+=1,z.type){case 1:O+=this.sizeLongString(z.value);break;case 2:O+=this.sizeVSBuffer(z.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(z.value);for(let P=0;P<z.buffers.length;++P)O+=this.sizeVSBuffer(z.buffers[P]);break;case 4:break}}return O}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let O=0,G=N.length;O<G;O++){const W=N[O];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let z=0;z<W.buffers.length;++z)this.writeBuffer(W.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const O=new Array(N);for(let G=0;G<N;G++)switch(this.readUInt8()){case 1:O[G]=this.readLongString();break;case 2:O[G]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),P=this.readLongString(),I=[];for(let H=0;H<z;++H)I.push(this.readVSBuffer());O[G]=new A.$Tv(t(P,I,null));break}case 4:O[G]=void 0;break}return O}}var S;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(S||(S={}));class L{static a(N){for(let O=0,G=N.length;O<G;O++)if(N[O]instanceof T.$je||N[O]instanceof A.$Tv||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this.a(N)){const G=[];for(let W=0,z=N.length;W<z;W++){const P=N[W];if(P instanceof T.$je)G[W]={type:2,value:P};else if(typeof P>"u")G[W]={type:4};else if(P instanceof A.$Tv){const{jsonString:I,referencedBuffers:H}=o(P.value,O);G[W]={type:3,value:T.$je.fromString(I),buffers:H}}else G[W]={type:1,value:T.$je.fromString(n(P,O))}}return{type:1,args:G}}return{type:0,args:n(N,O)}}static serializeRequest(N,O,G,W,z){switch(W.type){case 0:return this.b(N,O,G,W.args,z);case 1:return this.c(N,O,G,W.args,z)}}static b(N,O,G,W,z){const P=T.$je.fromString(G),I=T.$je.fromString(W);let H=0;H+=f.sizeUInt8(),H+=f.sizeShortString(P),H+=f.sizeLongString(I);const ae=f.alloc(z?2:1,N,H);return ae.writeUInt8(O),ae.writeShortString(P),ae.writeLongString(I),ae.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),G=N.readShortString(),W=N.readLongString();return{rpcId:O,method:G,args:JSON.parse(W)}}static c(N,O,G,W,z){const P=T.$je.fromString(G);let I=0;I+=f.sizeUInt8(),I+=f.sizeShortString(P),I+=f.sizeMixedArray(W);const H=f.alloc(z?4:3,N,I);return H.writeUInt8(O),H.writeShortString(P),H.writeMixedArray(W),H.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),G=N.readShortString(),W=N.readMixedArray(),z=new Array(W.length);for(let P=0,I=W.length;P<I;P++){const H=W[P];typeof H=="string"?z[P]=JSON.parse(H):z[P]=H}return{rpcId:O,method:G,args:z}}static serializeAcknowledged(N){return f.alloc(5,N,0).buffer}static serializeCancel(N){return f.alloc(6,N,0).buffer}static serializeReplyOK(N,O,G){if(typeof O>"u")return this.d(N);if(O instanceof T.$je)return this.e(N,O);if(O instanceof A.$Tv){const{jsonString:W,referencedBuffers:z}=o(O.value,G,!0);return this.g(N,W,z)}else return this.f(N,u(O,G))}static d(N){return f.alloc(7,N,0).buffer}static e(N,O){let G=0;G+=f.sizeVSBuffer(O);const W=f.alloc(8,N,G);return W.writeVSBuffer(O),W.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,O){const G=T.$je.fromString(O);let W=0;W+=f.sizeLongString(G);const z=f.alloc(9,N,W);return z.writeLongString(G),z.buffer}static g(N,O,G){const W=T.$je.fromString(O);let z=0;z+=f.sizeUInt32,z+=f.sizeLongString(W);for(const I of G)z+=f.sizeVSBuffer(I);const P=f.alloc(10,N,z);P.writeUInt32(G.length),P.writeLongString(W);for(const I of G)P.writeBuffer(I);return P.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const G=N.readUInt32(),W=N.readLongString(),z=[];for(let P=0;P<G;++P)z.push(N.readVSBuffer());return new A.$Tv(t(W,z,O))}static serializeReplyErr(N,O){const G=O?u(M.$3(O),null):void 0;if(typeof G!="string")return this.h(N);const W=T.$je.fromString(G);let z=0;z+=f.sizeLongString(W);const P=f.alloc(11,N,z);return P.writeLongString(W),P.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static h(N){return f.alloc(12,N,0).buffer}}var v;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var y;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(y||(y={}))}),define(Pe[276],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=void 0;const E=function(M){const R=$=>{globalThis.removeEventListener("message",R);const g=$.data;Object.defineProperties(globalThis,{postMessage:{value(b,A){g.postMessage(b,A)}},onmessage:{get(){return g.onmessage},set(b){g.onmessage=b}}}),g.addEventListener("message",b=>{globalThis.dispatchEvent(new MessageEvent("message",{data:b.data,ports:b.ports?[...b.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class T extends EventTarget{constructor(M,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${E})('${R}'))`,b=new Blob([g],{type:"application/javascript"}),A=URL.createObjectURL(b),D=new MessageChannel,u=A,p={type:"_newWorker",id:u,port:D.port2,url:A,options:$};M(p,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{M({type:"_terminateWorker",id:u}),URL.revokeObjectURL(A),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(w){D.port1.onmessage=w}},onmessageerror:{get(){return D.port1.onmessageerror},set(w){D.port1.onmessageerror=w}}}),D.port1.addEventListener("messageerror",w=>{const s=new MessageEvent("messageerror",{data:w.data});this.dispatchEvent(s)}),D.port1.addEventListener("message",w=>{const s=new MessageEvent("message",{data:w.data});this.dispatchEvent(s)}),D.port1.start()}}e.$kkc=T}),define(Pe[277],Re([1,0,5,30,35,4]),function(ge,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=e.$oK=e.OutputChannelUpdateMode=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=void 0,e.$eK="text/x-code-output",e.$fK="output",e.$gK="Log",e.$hK="text/x-code-log-output",e.$iK="log",e.$jK="workbench.panel.output",e.$kK=new C.$kj("inOutput",!1),e.$lK=new C.$kj("activeLogOutput",!1),e.$mK=new C.$kj("outputView.scrollLock",!1),e.$nK=(0,M.$6h)("outputService");var R;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$oK={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Vd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Vd,this.onDidRemoveChannel=this.c.event}registerChannel(b){this.a.has(b.id)||(this.a.set(b.id,b),this.b.fire(b.id))}getChannels(){const b=[];return this.a.forEach(A=>b.push(A)),b}getChannel(b){return this.a.get(b)}removeChannel(b){this.a.delete(b),this.c.fire(b)}}T.$Hn.add(e.$oK.OutputChannels,new $),e.$pK=new C.$kj("activeOutputChannel","")}),define(Pe[112],Re([1,0,3,4,17,22,14,277,63,27,43,136,24,16,42,5,6]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=e.$Hhc=void 0;class t extends R.$tj{get disposed(){return this.n}constructor(h,i,l,r,d){super(),this.id=h,this.name=i,this.r=l,this.s=r,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(m=>this.setLevel(m)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=u.$je.fromString(i).byteLength,(0,R.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(h){this.append(h)}}let a=class{constructor(h,i,l,r,d,m){this.i=i,this.j=l,this.k=r,this.l=d,this.m=m,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(E.$6K.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,D.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,l]of this.g)l.visible=i===this.h}createOutputChannel(h,i,l){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const r=typeof i=="object"&&i.log,d=(0,p.$If)(i)?i:void 0;if((0,p.$If)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let m;const f=this.i.environment.extensionLogLevel?.find(([L])=>M.$lm.equals(l.identifier,L))?.[1];f&&(m=(0,R.$Dj)(f));const S=r?this.o(h,m,l):this.n(h,d,l);return S.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),r?this.r(h,m??this.m.getLevel(),S):this.q(h,S)}async n(h,i,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,d=this.k.extUri.joinPath(r,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,d,i,l.identifier.value);return new t(f,h,m,this.a,l)}async o(h,i,l){const r=await this.p(l),d=h.replace(/[\\/:\*\?"<>\|]/g,""),m=this.k.extUri.joinPath(r,`${d}.log`),f=`${l.identifier.value}.${d}`,S=this.l.createLogger(m,{id:f,name:h,logLevel:i,extensionId:l.identifier.value});return new n(f,h,S,this.a,l)}p(h){let i=this.d.get(h.identifier.value);if(!i){const l=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(l)}catch(r){if((0,w.$Gk)(r)!==w.FileSystemProviderErrorCode.FileExists)throw r}return l})())}return i}q(h,i){let l=!1;const r=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return h},append(d){r(),i.then(m=>m.append(d))},appendLine(d){r(),i.then(m=>m.appendLine(d))},clear(){r(),i.then(d=>d.clear())},replace(d){r(),i.then(m=>m.replace(d))},show(d,m){r(),i.then(f=>f.show(d,m))},hide(){r(),i.then(d=>d.hide())},dispose(){l=!0,i.then(d=>d.dispose())}}}r(h,i,l){const r=new o.$Sc,d=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},m=r.add(new s.$Vd);function f(S){i=S,m.fire(S)}return l.then(S=>{r.add(S),S.logLevel!==i&&f(S.logLevel),r.add(S.onDidChangeLogLevel(L=>f(L)))}),{...this.q(h,l),get logLevel(){return i},onDidChangeLogLevel:m.event,trace(S,...L){d(),l.then(v=>v.trace(S,...L))},debug(S,...L){d(),l.then(v=>v.debug(S,...L))},info(S,...L){d(),l.then(v=>v.info(S,...L))},warn(S,...L){d(),l.then(v=>v.warn(S,...L))},error(S,...L){d(),l.then(v=>v.error(S,...L))},dispose(){r.dispose()}}}};e.$Hhc=a,e.$Hhc=a=Je([Ke(0,C.$0M),Ke(1,b.$nN),Ke(2,g.$ugc),Ke(3,A.$7fc),Ke(4,R.$oj),Ke(5,R.$nj)],a),e.$Ihc=(0,T.$6h)("IExtHostOutputService")}),define(Pe[113],Re([1,0,4,13]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=void 0,e.$Lm=(0,E.$6h)("remoteAgentService"),e.$Mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const g=await C.getRoundTripTime();if(g===void 0)return;M=Math.min(M,g/2),await(0,T.$7g)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce(($,g)=>$+g,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce(($,g)=>$+g,0)/this.average.length,high:(()=>typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[278],Re([1,0,169,54,30,47,41,6,5,113,21,26]),function(ge,e,E,T,C,M,R,$,g,b,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=void 0,e.$RH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$SH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$TH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$UH=Object.freeze({id:"problems",title:(0,E.localize)(3,null),type:"object",order:101}),e.$VH={ConfigurationMigration:"base.contributions.configuration.migration"};class u{constructor(){this.migrations=[],this.a=new g.$Vd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const p=new u;C.$Hn.add(e.$VH.ConfigurationMigration,p);let w=class extends $.$Tc{constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const c of a.added)await this.f(c,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(a=>this.g(a,t?.uri))])}async g(t,n){const a=this.a.inspect(t.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,i]of c){const l=[];for(const d of a.overrideIdentifiers??[]){const m=await this.h(t,{resource:n,overrideIdentifier:d},h);for(const f of m??[]){let S=l.find(([[L,v]])=>L===f[0]&&(0,D.$zn)(v.value,f[1].value));S||l.push(S=[f,[]]),S[1].push(d)}}const r=await this.h(t,{resource:n},h,a);for(const d of r??[])l.push([d,[]]);l.length&&await Promise.allSettled(l.map(async([[d,m],f])=>this.a.updateValue(d,m.value,{resource:n,overrideIdentifiers:f},i)))}}async h(t,n,a,c){const h=d=>i(this.a.inspect(d,n)),i=d=>{const m=d[a];return n.overrideIdentifier?m?.override:m?.value},l=c?i(c):h(t.key);if(l===void 0)return;const r=await t.migrateFn(l,h);return Array.isArray(r)?r:[[t.key,r]]}};e.$WH=w,e.$WH=w=Je([Ke(0,R.$zi),Ke(1,M.$ci)],w);let s=class extends $.$Tc{constructor(t){super(),(async()=>{if(!A.$i&&(await t.getEnvironment())?.os!==1)return;C.$Hn.as(T.$Mn.Configuration).registerConfiguration({...e.$TH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(4,null)},default:[],markdownDescription:(0,E.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(6,null),scope:2}}})})()}};e.$XH=s,e.$XH=s=Je([Ke(0,b.$Lm)],s)}),define(Pe[279],Re([1,0,34,12,19,25,177,278,54,4,30]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdb=e.$edb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$ddb=e.$cdb=void 0,e.$cdb=(0,b.$6h)("editorResolverService"),e.$ddb="workbench.editorAssociations";const D=A.$Hn.as(g.$Mn.Configuration),u={...$.$SH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(u);var p;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(p||(e.RegisteredEditorPriority=p={}));var w;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function s(t){switch(t){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$edb=s;function o(t,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof t=="string"&&t.indexOf(C.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$Eg)(n);return E.$Lj(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$fdb=o}),define(Pe[280],Re([1,0,46,12,19,21,25,2,4,198,47,216,113]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$IK=e.$HK=void 0,e.$HK=(0,g.$6h)("pathService");let w=p=class{constructor(o,t,n,a){this.d=o,this.e=t,this.f=n,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(a=>this.h(o,a,t)):this.h(o,t,n)}h(o,t,n){return o.scheme===T.Schemas.file||o.scheme===T.Schemas.vscodeRemote?(0,E.$6f)(n??(0,R.$Eg)(o),t===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,b.$EK)(t.getWorkspace());if(n)return n;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?C.$fc:C.$gc)}async fileURI(o){let t="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.$IK=w,e.$IK=w=p=Je([Ke(1,u.$Lm),Ke(2,D.$qK),Ke(3,A.$ci)],w)}),define(Pe[114],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$kJ=e.$jJ=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$jJ=E;class T{constructor(R,$,g,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(g,b)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$kJ=T;var C;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Pe[44],Re([1,0,18,34,26,46,11,4,19,15,114,13]),function(ge,e,E,T,C,M,R,$,g,b,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.SearchErrorCode=e.$zJ=e.$yJ=e.SearchSortOrder=e.ViewMode=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.SearchCompletionExitCode=e.$tJ=e.$sJ=e.$rJ=e.QueryType=e.SearchProviderType=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$lJ="workbench.view.search",e.$mJ="workbench.panel.search",e.$nJ="workbench.view.search",e.$oJ="search-result",e.$pJ="search.exclude";const u="\u27EA ",p=" characters skipped \u27EB",w=(u.length+p.length+5)*2;e.$qJ=(0,$.$6h)("searchService");var s;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(s||(e.SearchProviderType=s={}));var o;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(o||(e.QueryType=o={}));function t(le){return!!le.preview}e.$rJ=t;function n(le){return!!le.resource}e.$sJ=n;function a(le){return!!le.message}e.$tJ=a;var c;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(ve){this.resource=ve,this.results=[]}}e.$uJ=h;class i{constructor(ve,se,be,ne){this.ranges=se,this.webviewIndex=ne;const Y=Array.isArray(se)?se:[se];if(be&&be.matchLines===1&&l(Y)){ve=(0,R.$Bf)(ve,be.matchLines);let V="",ie=0,Ie=0;const Le=Math.floor(be.charsPerLine/5),Ce=[];for(const ce of Y){const te=Math.max(ce.startColumn-Le,0),Q=ce.startColumn+be.charsPerLine;if(te>Ie+Le+w){const ee=u+(te-Ie)+p;V+=ee+ve.slice(te,Q),ie+=te-(Ie+ee.length)}else V+=ve.slice(Ie,Q);Ce.push(new d(0,ce.startColumn-ie,ce.endColumn-ie)),Ie=Q}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ve,matches:(0,E.$2b)(se,ie=>new r(ie.startLineNumber-V,ie.startColumn,ie.endLineNumber-V,ie.endColumn))}}}}e.$vJ=i;function l(le){const ve=le[0].startLineNumber;for(const se of le)if(se.startLineNumber!==ve||se.endLineNumber!==ve)return!1;return!0}class r{constructor(ve,se,be,ne){this.startLineNumber=ve,this.startColumn=se,this.endLineNumber=be,this.endColumn=ne}}e.$wJ=r;class d extends r{constructor(ve,se,be){super(ve,se,ve,be)}}e.$xJ=d;var m;(function(le){le.List="list",le.Tree="tree"})(m||(e.ViewMode=m={}));var f;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function S(le,ve=!0){const se=le&&le.files&&le.files.exclude,be=ve&&le&&le.search&&le.search.exclude;if(!se&&!be)return;if(!se||!be)return se||be;let ne=Object.create(null);return ne=C.$yn(ne,C.$vn(se)),ne=C.$yn(ne,C.$vn(be),!0),ne}e.$yJ=S;function L(le,ve){return le.excludePattern&&T.$Lj(le.excludePattern,ve)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&T.$Lj(le.includePattern,ve)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(se=>{const be=se.folder.fsPath;if(M.$8f(ve,be)){const ne=g.$lc(be,ve);return!se.includePattern||!!T.$Lj(se.includePattern,ne)}else return!1}):!1:!0}e.$zJ=L;var v;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class y extends Error{constructor(ve,se){super(ve),this.code=se}}e.$AJ=y;function k(le){const ve=le.message;if((0,b.$4)(le))return new y(ve,v.canceled);try{const se=JSON.parse(ve);return new y(se.message,se.code)}catch{return new y(ve,v.other)}}e.$BJ=k;function N(le){const ve={message:le.message,code:le.code};return new Error(JSON.stringify(ve))}e.$CJ=N;function O(le){return le.type==="error"?!0:le.type==="success"}e.$DJ=O;function G(le){return le.type==="success"}e.$EJ=G;function W(le){return!!le.path}e.$FJ=W;function z(le,ve){const se=le.searchPath?le.searchPath:le.relativePath;return(0,R.$yf)(se,ve)}e.$GJ=z;class P{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$HJ=P;function I(le,ve){const se={...le||{},...ve||{}};return Object.keys(se).filter(be=>{const ne=se[be];return typeof ne=="boolean"&&ne})}e.$IJ=I;class H{constructor(ve,se){this.c=null,this.a={...ve.excludePattern||{},...se.excludePattern||{}},this.b=T.$Mj(this.a);let be=ve.includePattern;se.includePattern&&(be?be={...be,...se.includePattern}:be=se.includePattern),be&&(this.c=T.$Mj(be))}matchesExcludesSync(ve,se,be){return!!(this.b&&this.b(ve,se,be))}includedInQuerySync(ve,se,be){return!(this.b&&this.b(ve,se,be)||this.c&&!this.c(ve,se,be))}includedInQuery(ve,se,be){const ne=this.b(ve,se,be),Y=()=>this.c?!!this.c(ve,se,be):!0;return(0,D.$Sg)(ne)?ne.then(V=>V?!1:Y()):Y()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$JJ=H;function ae(le){for(const ve in le)if(typeof le[ve]!="boolean")return!0;return!1}function de(le){if(!le)return;let ve;return se=>(ve||(ve=(le()||Promise.resolve([])).then(be=>be?ke(be):{})),ve.then(be=>!!be[se]))}e.$KJ=de;function we(le){if(!le)return;let ve;return se=>{if(!ve){const be=le();ve=be?ke(be):{}}return!!ve[se]}}e.$LJ=we;function ke(le){const ve={};for(const se of le)ve[se]=!0;return ve}}),define(Pe[36],Re([1,0,18,13,20,5,6,50,12,122,25,11,2,168,4,14,187,47,43,27,17,8,7,57,44,3,51]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c,h,i,l,r,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0;function f(G,W,z){return new A.$wg(P=>y(P,z)).isEqual(G,W)}function S(G,W,z){return f(G.uri,W.uri,z)?0:(0,D.$5e)(G.uri.toString(),W.uri.toString())}function L(G,W,z){return G.index!==W.index?G.index<W.index?-1:1:f(G.uri,W.uri,z)?(0,D.$5e)(G.name,W.name):(0,D.$5e)(G.uri.toString(),W.uri.toString())}function v(G,W,z,P){const I=G.slice(0).sort((ae,de)=>z(ae,de,P)),H=W.slice(0).sort((ae,de)=>z(ae,de,P));return(0,E.$Eb)(I,H,(ae,de)=>z(ae,de,P))}function y(G,W){const z=W.getCapabilities(G.scheme);return!(z&&z&1024)}class k extends t.$mi{static toExtHostWorkspace(W,z,P,I){if(!W)return{workspace:null,added:[],removed:[]};const{id:H,name:ae,folders:de,configuration:we,transient:ke,isUntitled:le}=W,ve=[],se=z;z?de.forEach((V,ie)=>{const Ie=u.URI.revive(V.uri),Le=k.o(P||z,Ie,I);Le?(Le.name=V.name,Le.index=V.index,ve.push(Le)):ve.push({uri:Ie,name:V.name,index:ie})}):ve.push(...de.map(({uri:V,name:ie,index:Ie})=>({uri:u.URI.revive(V),name:ie,index:Ie}))),ve.sort((V,ie)=>V.index<ie.index?-1:1);const be=new k(H,ae,ve,!!ke,we?u.URI.revive(we):null,!!le,V=>y(V,I)),{added:ne,removed:Y}=v(se?se.workspaceFolders:[],be.workspaceFolders,S,I);return{workspace:be,added:ne,removed:Y}}static o(W,z,P){for(let I=0;I<W.folders.length;I++){const H=W.workspaceFolders[I];if(f(H.uri,z,P))return H}}constructor(W,z,P,I,H,ae,de){super(W,P.map(we=>new t.$ni(we)),I,H,de),this.t=z,this.u=ae,this.q=[],this.s=$.$_h.forUris(de),P.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,z){return z&&this.s.get(W)&&(W=(0,A.$Gg)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let N=class{constructor(W,z,P,I,H){this.c=new M.$Vd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Vd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Xd,this.B=new Map,this.h=I,this.s=P,this.t=H,this.j=new b.$9l,this.k=new T.$5g,this.o=W.getProxy(d.$6K.MainThreadWorkspace),this.q=W.getProxy(d.$6K.MainThreadMessageService);const ae=z.workspace;this.l=ae?new k(ae.id,ae.name,[],!!ae.transient,ae.configuration?u.URI.revive(ae.configuration):null,!!ae.isUntitled,de=>y(de,P)):void 0}$initializeWorkspace(W,z){this.v=z,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:g.Schemas.untitled,path:(0,A.$Eg)((0,A.$Gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,z,P,...I){const H=[];if(Array.isArray(I)&&I.forEach(le=>{u.URI.isUri(le.uri)&&!H.some(ve=>f(ve.uri,le.uri,this.s))&&H.push({uri:le.uri,name:le.name||(0,A.$Dg)(le.uri)})}),this.n||[z,P].some(le=>typeof le!="number"||le<0)||P===0&&H.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(z+P>ae.length)return!1;const de=ae.slice(0);de.splice(z,P,...H.map(le=>({uri:le.uri,name:le.name||(0,A.$Dg)(le.uri),index:void 0})));for(let le=0;le<de.length;le++){const ve=de[le];if(de.some((se,be)=>be!==le&&f(ve.uri,se.uri,this.s)))return!1}de.forEach((le,ve)=>le.index=ve);const{added:we,removed:ke}=v(ae,de,L,this.s);if(we.length===0&&ke.length===0)return!1;if(this.o){const le=W.displayName||W.name;this.o.$updateWorkspaceFolders(le,z,P,H).then(void 0,ve=>{this.n=void 0;const se={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(o.Severity.Error,(0,p.localize)(0,null,le,ve.toString()),se,[])})}return this.y(de),!0}getWorkspaceFolder(W,z){if(this.x)return this.x.getWorkspaceFolder(W,z)}async getWorkspaceFolder2(W,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,z)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,z){let P,I="";if(typeof W=="string"?(P=u.URI.file(W),I=W):typeof W<"u"&&(P=W,I=W.fsPath),!P)return I;const H=this.getWorkspaceFolder(P,!0);if(!H)return I;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ae=(0,A.$Jg)(H.uri,P);return z&&H.name&&(ae=`${H.name}/${ae}`),ae}y(W){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:z,added:P,removed:I}=k.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:I}))}findFiles(W,z,P,I,H=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${I.value}, entryPoint: findFiles`);let ae;if(z===null?ae=!1:z&&(typeof z=="string"?ae=z:ae=z.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:we}=O(h.GlobPattern.from(W));return this.o.$startFileSearch(de??null,we??null,ae??null,P??null,H).then(ke=>Array.isArray(ke)?ke.map(le=>u.URI.revive(le)):[])}async findTextInFiles(W,z,P,I,H=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${I.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),de=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:we,folder:ke}=O(h.GlobPattern.from(z.include)),le=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ve={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:de,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:we,excludePattern:le},se=!1;if(this.u[ae]=be=>{if(se)return;const ne=u.URI.revive(be.resource);be.results.forEach(Y=>{const V=(0,m.$Ch)(Y);(0,r.$rJ)(V)?P({uri:ne,preview:{text:V.preview.text,matches:(0,E.$2b)(V.preview.matches,ie=>new i.$0K(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,E.$2b)(V.ranges,ie=>new i.$0K(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):P({uri:ne,text:V.text,lineNumber:V.lineNumber})})},H.isCancellationRequested)return{};try{const be=await this.o.$startTextSearch(W,ke??null,ve,ae,H);return delete this.u[ae],be||{}}catch(be){throw delete this.u[ae],be}}$handleTextSearchResult(W,z){this.u[z]?.(W)}async save(W){const z=await this.o.$save(W,{saveAs:!1});return u.URI.revive(z)}async saveAs(W){const z=await this.o.$save(W,{saveAs:!0});return u.URI.revive(z)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,z){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,z);const P=this.t.transformOutgoingScheme(W),I=this.z++;return this.o.$registerEditSessionIdentityProvider(I,P),(0,R.$Rc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(I)})}async $getEditSessionIdentifier(W,z){this.h.info("Getting edit session identifier for workspaceFolder",W);const P=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const I=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!I),!I)return;const H=await I.provideEditSessionIdentity(P,z);if(this.h.info("Provider returned edit session identifier: ",H),!!H)return H}async $provideEditSessionIdentityMatch(W,z,P,I){this.h.info("Getting edit session identifier for workspaceFolder",W);const H=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!H){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",H);const ae=this.w.get(H.uri.scheme);if(this.h.info(`Provider for scheme ${H.uri.scheme} is defined: `,!!ae),!ae)return;const de=await ae.provideEditSessionIdentityMatch?.(z,P,I);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(W){return(z,P,I)=>{const H=function(de){z.call(P,de)};return H.extension=W,this.A.event(H,void 0,I)}}async $onWillCreateEditSessionIdentity(W,z,P){const I=await this.resolveWorkspaceFolder(u.URI.revive(W));if(I===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:I},z,async(H,ae)=>{const de=Date.now();await Promise.resolve(H),Date.now()-de>P&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(W,z){if(this.B.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.B.set(W,z);const P=this.t.transformOutgoingScheme(W),I=this.z++;return this.o.$registerCanonicalUriProvider(I,P),(0,R.$Rc)(()=>{this.B.delete(W),this.o.$unregisterCanonicalUriProvider(I)})}async provideCanonicalUri(W,z,P){const I=this.B.get(W.scheme);if(!I)return;const H=await I.provideCanonicalUri?.(u.URI.revive(W),z,P);if(H)return H}async $provideCanonicalUri(W,z,P){return this.provideCanonicalUri(u.URI.revive(W),{targetScheme:z},P)}};e.$ogc=N,e.$ogc=N=Je([Ke(0,c.$0M),Ke(1,a.$nN),Ke(2,n.$7fc),Ke(3,s.$nj),Ke(4,l.$mgc)],N),e.$pgc=(0,w.$6h)("IExtHostWorkspace");function O(G){let W,z;return G&&(typeof G=="string"?W=G:(W=G.pattern,z=u.URI.revive(G.baseUri))),{includePattern:W,folder:z}}}),define(Pe[37],Re([1,0,26,5,36,3,7,189,54,16,13,4,17,14,2]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=e.$rgc=e.$qgc=void 0;function s(l,r){if(r){const d=r.split(".");let m=l;for(let f=0;m&&f<d.length;f++)m=m[d[f]];return m}}function o(l){return l instanceof w.URI}function t(l){return l&&l.uri instanceof w.URI&&l.languageId&&typeof l.languageId=="string"}function n(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function a(l){return l&&l.uri instanceof w.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function c(l){if(o(l))return{resource:l};if(t(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(n(l))return{overrideIdentifier:l.languageId};if(a(l))return{resource:l.uri};if(l===null)return{resource:null}}let h=class{constructor(r,d,m){this.a=r.getProxy(M.$6K.MainThreadConfiguration),this.c=d,this.b=m,this.d=new A.$5g,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new i(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,d){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(r,d))}};e.$qgc=h,e.$qgc=h=Je([Ke(0,u.$0M),Ke(1,C.$pgc),Ke(2,p.$nj)],h);class i{constructor(r,d,m,f){this.a=new T.$Vd,this.b=r,this.f=f,this.c=d,this.e=$.$6n.parse(m),this.d=this.k(m.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,d){const m={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$6n.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(d,m))}getConfiguration(r,d,m){const f=c(d)||{},S=this.g(r?s(this.e.getValue(void 0,f,this.c.workspace),r):this.e.getValue(void 0,f,this.c.workspace));r&&this.h(r,f,m?.identifier);function L(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(y){return typeof s(S,y)<"u"},get:(y,k)=>{this.h(r?`${r}.${y}`:y,f,m?.identifier);let N=s(S,y);if(typeof N>"u")N=k;else{let O;const G=(W,z)=>{if((0,b.$Kf)(W)){let P;const I=()=>{O=O||(0,E.$vn)(S),P=P||s(O,z)};return new Proxy(W,{get:(H,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return I(),()=>P;if(O)return P=P||s(O,z),P[ae];const de=H[ae];return typeof ae=="string"?G(de,`${z}.${ae}`):de},set:(H,ae,de)=>(I(),P&&(P[ae]=de),!0),deleteProperty:(H,ae)=>(I(),P&&delete P[ae],!0),defineProperty:(H,ae,de)=>(I(),P&&Object.defineProperty(P,ae,de),!0)})}return Array.isArray(W)?(0,E.$vn)(W):W};N=G(N,y)}return N},update:(y,k,N,O)=>{y=r?`${r}.${y}`:y;const G=L(N);return k!==void 0?this.b.$updateConfigurationOption(G,y,k,f,O):this.b.$removeConfigurationOption(G,y,f,O)},inspect:y=>{y=r?`${r}.${y}`:y;const k=this.e.inspect(y,f,this.c.workspace);if(k)return{key:y,defaultValue:(0,E.$vn)(k.policy?.value??k.default?.value),globalValue:(0,E.$vn)(k.user?.value??k.application?.value),workspaceValue:(0,E.$vn)(k.workspace?.value),workspaceFolderValue:(0,E.$vn)(k.workspaceFolder?.value),defaultLanguageValue:(0,E.$vn)(k.default?.override),globalLanguageValue:(0,E.$vn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,E.$vn)(k.workspace?.override),workspaceFolderLanguageValue:(0,E.$vn)(k.workspaceFolder?.override),languageIds:(0,E.$vn)(k.overrideIdentifiers)}}};return typeof S=="object"&&(0,E.$yn)(v,S,!1),Object.freeze(v)}g(r){const d=m=>(0,b.$Kf)(m)?new Proxy(m,{get:(f,S)=>d(f[S]),set:(f,S,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(f,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(f,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return d(r)}h(r,d,m){const f=g.$Wn.test(r)?4:this.d.get(r),S=m?`[${m.value}] `:"";if(f===4){typeof d?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,d){const m=new $.$8n(r,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,S)=>m.affectsConfiguration(f,c(S))})}k(r){return r.reduce((d,m)=>(d.set(m[0],m[1]),d),new Map)}}e.$rgc=i,e.$sgc=(0,D.$6h)("IExtHostConfiguration")}),define(Pe[115],Re([1,0,2,13,5,3,7,36,61,37,20,64,17,27,4,12,21,14,81,228,15]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=e.$Uhc=e.$Thc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(G){function W(P){if(P!=null)return P}G.from=W;function z(P){if(P!=null)return P}G.to=z})(h||(h={}));var i;(function(G){function W(P){if(P!=null)return P}G.from=W;function z(P){if(P!=null)return P}G.to=z})(i||(i={}));var l;(function(G){function W(P){if(P!=null)return P}G.from=W;function z(P){if(P!=null)return P}G.to=z})(l||(l={}));var r;(function(G){function W(I){if(I){const H=I;return H&&!!H.process}else return!1}G.is=W;function z(I){if(I==null)return;const H={process:I.process,args:I.args};return I.options&&(H.options=l.from(I.options)),H}G.from=z;function P(I){if(I!=null)return new R.$QL(I.process,I.args,I.options)}G.to=P})(r||(r={}));var d;(function(G){function W(P){if(P!=null)return P}G.from=W;function z(P){if(P!=null)return P}G.to=z})(d||(d={}));var m;(function(G){function W(I){if(I){const H=I;return H&&(!!H.commandLine||!!H.command)}else return!1}G.is=W;function z(I){if(I==null)return;const H={};return I.commandLine!==void 0?H.commandLine=I.commandLine:(H.command=I.command,H.args=I.args),I.options&&(H.options=d.from(I.options)),H}G.from=z;function P(I){if(!(I==null||I.command===void 0&&I.commandLine===void 0))return I.commandLine?new R.$RL(I.commandLine,I.options):new R.$RL(I.command,I.args?I.args:[],I.options)}G.to=P})(m||(m={}));var f;(function(G){function W(I){if(I){const H=I;return H&&H.customExecution==="customExecution"}else return!1}G.is=W;function z(I){return{customExecution:"customExecution"}}G.from=z;function P(I,H){return H.get(I)}G.to=P})(f||(e.CustomExecutionDTO=f={}));var S;(function(G){function W(z,P){let I;return z.scope!==void 0&&typeof z.scope!="number"?I=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&P&&P.workspaceFile?I=P.workspaceFile:I=a.$yG),{id:z._id,workspaceFolder:I}}G.from=W})(S||(e.TaskHandleDTO=S={}));var L;(function(G){function W(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}G.from=W})(L||(L={}));var v;(function(G){function W(I,H){if(I==null)return[];const ae=[];for(const de of I){const we=z(de,H);we&&ae.push(we)}return ae}G.fromMany=W;function z(I,H){if(I==null)return;let ae;I.execution instanceof R.$QL?ae=r.from(I.execution):I.execution instanceof R.$RL?ae=m.from(I.execution):I.execution&&I.execution instanceof R.$SL&&(ae=f.from(I.execution));const de=h.from(I.definition);let we;return I.scope?typeof I.scope=="number"?we=I.scope:we=I.scope.uri:we=R.TaskScope.Workspace,!de||!we?void 0:{_id:I._id,definition:de,name:I.name,source:{extensionId:H.identifier.value,label:I.source,scope:we},execution:ae,isBackground:I.isBackground,group:L.from(I.group),presentationOptions:i.from(I.presentationOptions),problemMatchers:I.problemMatchers,hasDefinedMatchers:I.hasDefinedMatchers,runOptions:I.runOptions?I.runOptions:{reevaluateOnRerun:!0},detail:I.detail}}G.from=z;async function P(I,H,ae){if(I==null)return;let de;r.is(I.execution)?de=r.to(I.execution):m.is(I.execution)?de=m.to(I.execution):f.is(I.execution)&&(de=f.to(I._id,ae));const we=h.to(I.definition);let ke;if(I.source&&(I.source.scope!==void 0?typeof I.source.scope=="number"?ke=I.source.scope:ke=await H.resolveWorkspaceFolder(E.URI.revive(I.source.scope)):ke=R.TaskScope.Workspace),!we||!ke)return;const le=new R.$TL(we,ke,I.name,I.source.label,de,I.problemMatchers);return I.isBackground!==void 0&&(le.isBackground=I.isBackground),I.group!==void 0&&(le.group=R.$PL.from(I.group._id),le.group&&I.group.isDefault&&(le.group=new R.$PL(le.group.id,le.group.label),I.group.isDefault===!0&&(le.group.isDefault=I.group.isDefault))),I.presentationOptions&&(le.presentationOptions=i.to(I.presentationOptions)),I._id&&(le._id=I._id),I.detail&&(le.detail=I.detail),le}G.to=P})(v||(e.TaskDTO=v={}));var y;(function(G){function W(P){return P}G.from=W;function z(P){if(P)return Object.assign(Object.create(null),P)}G.to=z})(y||(y={}));class k{#e;constructor(W,z,P){this._id=z,this.a=P,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let N=class{constructor(W,z,P,I,H,ae,de,we){this.q=new C.$Vd,this.r=new C.$Vd,this.s=new C.$Vd,this.u=new C.$Vd,this.a=W.getProxy(M.$6K.MainThreadTask),this.b=P,this.c=I,this.d=H,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,z,P){if(!P)return new R.$8K(()=>{});const I=this.x();return this.j.set(I,{type:z,provider:P,extension:W}),this.a.$registerTaskProvider(I,z),new R.$8K(()=>{this.j.delete(I),this.a.$unregisterTaskProvider(I)})}registerTaskSystem(W,z){this.a.$registerTaskSystem(W,z)}fetchTasks(W){return this.a.$fetchTasks(y.from(W)).then(async z=>{const P=[];for(const I of z){const H=await v.to(I,this.b,this.m);H&&P.push(H)}return P})}get taskExecutions(){const W=[];return this.k.forEach(z=>W.push(z)),W}terminateTask(W){if(!(W instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,z,P){const I=this.m.get(W.id);I&&(this.o.set(W.id,I),this.e.attachPtyToTerminal(z,await I.callback(P))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const z=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const z=await this.z(W.id);this.s.fire({execution:z,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const z=await this.z(W.id);this.u.fire({execution:z,exitCode:W.exitCode})}$provideTasks(W,z){const P=this.j.get(W);if(!P)return Promise.reject(new Error("no handler found"));const I=[],H=(0,T.$Yg)(()=>P.provider.provideTasks(A.CancellationToken.None)).then(ae=>this.v(z,I,P,ae));return new Promise(ae=>{H.then(de=>{Promise.all(I).then(()=>{ae(de)})})})}async $resolveTask(W,z){const P=this.j.get(W);if(!P)return Promise.reject(new Error("no handler found"));if(z.definition.type!==P.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${P.type}].`);const I=await v.to(z,this.b,this.m);if(!I)throw new Error("Unexpected: Task cannot be resolved.");const H=await P.provider.resolveTask(I,A.CancellationToken.None);if(!H)return;this.A(H,P);const ae=v.from(H,P.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==I.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ae.execution)&&await this.y(ae,H,!0),await this.w(ae)}x(){return this.h++}async y(W,z,P){const I=await this.a.$createTaskId(W);!P&&!this.m.has(I)&&(this.n.add(I),this.o.set(I,z.execution)),this.m.set(I,z.execution)}async z(W,z){if(typeof W=="string"){const H=this.l.get(W);if(!H)throw new c.$bb("Unexpected: The specified task is missing an execution");return H}const P=this.l.get(W.id);if(P)return P;let I;return z?I=Promise.resolve(new k(this,W.id,z)):I=v.to(W.task,this.b,this.m).then(H=>{if(!H)throw new c.$bb("Unexpected: Task does not exist.");return new k(this,W.id,H)}),this.l.set(W.id,I),I.then(H=>(this.k.set(W.id,H),H))}A(W,z){W._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const P=this.n.values();let I=P.next();for(;!I.done;)!this.o.has(I.value)&&this.p!==I.value&&(this.m.delete(I.value),this.n.delete(I.value)),I=P.next()}};e.$Thc=N,e.$Thc=N=Je([Ke(0,u.$0M),Ke(1,p.$nN),Ke(2,$.$pgc),Ke(3,g.$iN),Ke(4,b.$sgc),Ke(5,D.$Qgc),Ke(6,t.$nj),Ke(7,n.$0fc)],N);let O=class extends N{constructor(W,z,P,I,H,ae,de,we){super(W,z,P,I,H,ae,de,we),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(W,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const P=v.from(z,W);if(P===void 0)throw new Error("Task is not valid");if(f.is(P.execution))await this.y(P,z,!1);else throw new c.$_;const I=await this.z(await this.a.$getTaskExecution(P),z);return this.a.$executeTask(P).catch(H=>{throw new Error(H)}),I}v(W,z,P,I){const H=[];if(I)for(const ae of I){if(this.A(ae,P),!ae.definition||!W[ae.definition.type]){const we=ae.source?ae.source:"No task source";this.f.warn(`The task [${we}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const de=v.from(ae,P.extension);de&&f.is(de.execution)?(H.push(de),z.push(this.y(de,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:H,extension:P.extension}}async w(W){if(f.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,z,P){}};e.$Uhc=O,e.$Uhc=O=Je([Ke(0,u.$0M),Ke(1,p.$nN),Ke(2,$.$pgc),Ke(3,g.$iN),Ke(4,b.$sgc),Ke(5,D.$Qgc),Ke(6,t.$nj),Ke(7,n.$0fc)],O),e.$Vhc=(0,w.$6h)("IExtHostTask")}),define(Pe[281],Re([1,0,44,29]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.$RJ=void 0;function C(R){return"cellResults"in R}e.$RJ=C,e.$SJ="rawCell#";function M(R,$){let g=-1;const b=[];let A=[];return R.forEach(u=>{u.range.startLineNumber!==g&&A.length>0&&(b.push([...A]),A=[]),A.push(u),g=u.range.endLineNumber}),A.length>0&&b.push([...A]),b.map(u=>{const p=[],w=u[0].range.startLineNumber,s=u[u.length-1].range.endLineNumber;for(let o=w;o<=s;o++)p.push($.getLineContent(o));return new E.$vJ(p.join(`
`)+`
`,u.map(o=>new T.$Us(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}e.$TJ=M}),define(Pe[282],Re([1,0,162,24,5,6,28,11,16,2,42,75,3,32,8,7,49,220,107,26,12,211,281,279]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c,h,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,f,S,L,v,y){this.q=S,this.r=L,this.s=v,this.t=y,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new C.$Vd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Vd,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Vd,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Vd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$3fc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(u.$6K.MainThreadNotebook),this.c=m.getProxy(u.$6K.MainThreadNotebookDocuments),this.d=m.getProxy(u.$6K.MainThreadNotebookEditors),this.i=f.converter,f.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const N=k.notebookEditor?.notebookUri,O=k.cell.handle,W=this.g.get(N)?.getCell(O);if(W)return W.apiCell}if(k&&k.$mid===14){const N=k.uri,O=this.g.get(N);if(O)return O.apiNotebook}return k}}),r.B(f)}getEditorById(m){const f=this.h.get(m);if(!f)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return f}getIdByEditor(m){for(const[f,S]of this.h)if(S.apiEditor===m)return f}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,f){const S=this.g.get(m);if(!S&&!f)throw new Error(`NO notebook document for '${m}'`);return S}static u(m,f){if(!f)return;const S=f.filenamePattern.map(L=>w.NotebookExclusiveDocumentPattern.from(L)).filter(L=>L!==void 0);if(f.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:f.displayName,filenamePattern:S,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,f,S){const L=r.a++,v=typeof S.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(L,S),this.b.$registerNotebookCellStatusBarItemProvider(L,v,f);let y;return v!==void 0&&(y=S.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(v))),new s.$8K(()=>{this.f.delete(L),this.b.$unregisterNotebookCellStatusBarItemProvider(L,v),y?.dispose()})}async createNotebookDocument(m){const f=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&w.NotebookData.from(m.content)});return b.URI.revive(f)}async openNotebookDocument(m){const f=this.g.get(m);if(f)return f.apiNotebook;const S=await this.c.$tryOpenNotebook(m),L=this.g.get(b.URI.revive(S));return(0,g.$Tf)(L?.apiNotebook)}async showNotebookDocument(m,f){b.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let S;typeof f=="object"?S={position:w.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(w.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:S={preserveFocus:!1};const L=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,S),v=L&&this.h.get(L)?.apiEditor;if(v)return v;throw L?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,f,S,L){const v=this.f.get(m),y=b.URI.revive(f),k=this.g.get(y);if(!k||!v)return;const N=k.getCellFromIndex(S);if(!N)return;const O=await v.provideCellStatusBarItems(N.apiCell,L);if(!O)return;const G=new M.$Sc,W=this.p.add([G]),P=(Array.isArray(O)?O:[O]).map(I=>w.NotebookStatusBarItem.from(I,this.i,G));return{cacheId:W,items:P}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,f,S,L,v){if((0,$.$Je)(f))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:f,serializer:S,options:L}),this.b.$registerNotebookSerializer(y,{id:m.identifier,location:m.extensionLocation},f,w.NotebookDocumentContentOptions.from(L),r.u(m,v)),(0,M.$Rc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(m,f,S){const L=this.x.get(m);if(!L)throw new Error("NO serializer found");const v=await L.serializer.deserializeNotebook(f.buffer,S);return new o.$Tv(w.NotebookData.from(v))}async $notebookToData(m,f,S){const L=this.x.get(m);if(!L)throw new Error("NO serializer found");const v=await L.serializer.serializeNotebook(w.NotebookData.to(f.value),S);return T.$je.wrap(v)}async $saveNotebook(m,f,S,L,v){const y=b.URI.revive(f),k=this.x.get(m);if(!k)throw new Error("NO serializer found");const N=this.g.get(y);if(!N)throw new Error("Document NOT found");if(N.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$Lk((0,E.localize)(0,null,this.z(y)),6);await this.y(y,L);const O={metadata:(0,a.$Dn)(N.apiNotebook.metadata,I=>!(k.options?.transientDocumentMetadata??{})[I]),cells:[]};for(const I of N.apiNotebook.getCells()){const H=new s.$uM(I.kind,I.document.getText(),I.document.languageId,I.mime,k.options?.transientOutputs?[]:[...I.outputs],I.metadata,I.executionSummary);H.metadata=(0,a.$Dn)(I.metadata,ae=>!(k.options?.transientCellMetadata??{})[ae]),O.cells.push(H)}const G=await k.serializer.serializeNotebook(O,v);await this.s.value.writeFile(y,G);const W=this.s.getFileSystemProviderExtUri(y.scheme),z=await this.s.value.stat(y);return{name:W.basename(y),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$Wk({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(m,f,S,L,v){const y=this.x.get(m)?.serializer;if(!y)return{limitHit:!1,results:[]};const k=new R.$Bc;await(async(z,P,I)=>{await Promise.all(z.map(async H=>await Promise.all(H.filenamePatterns.map(ae=>{const de={_reason:I._reason,folderQueries:I.folderQueries,includePattern:I.includePattern,excludePattern:I.excludePattern,maxResults:I.maxResults,type:1,filePattern:ae};return this.t.doInternalFileSearchWithCustomCallback(de,P,we=>{we.forEach(ke=>{k.has(ke)||L.some(ve=>H.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(se=>(0,l.$fdb)(se,ke)))||k.add(ke)})})}))))})(S,v,f);const O=new R.$Ac;let G=!1;const W=Array.from(k).map(async z=>{const P=[];try{if(v.isCancellationRequested)return;if(f.maxResults&&[...O.values()].reduce((de,we)=>de+we.cellResults.length,0)>f.maxResults){G=!0;return}const I=[],H=this.g.get(z);if(H)H.apiNotebook.getCells().forEach(we=>I.push({input:we.document.getText(),outputs:we.outputs.flatMap(ke=>ke.items.map(le=>le.data.toString()))}));else{const de=await this.s.value.readFile(z),we=T.$je.fromString(de.toString()),ke=await y.deserializeNotebook(we.buffer,v);if(v.isCancellationRequested)return;w.NotebookData.from(ke).cells.forEach(ve=>I.push({input:ve.source,outputs:ve.outputs.flatMap(se=>se.items.map(be=>be.valueBytes.toString()))}))}if(v.isCancellationRequested)return;I.forEach((de,we)=>{const ke=f.contentPattern.pattern,le=new h.$KQb(de.input,void 0,de.outputs),ve=le.findInInputs(ke),se=le.findInOutputs(ke),be=se.flatMap(ne=>(0,i.$TJ)(ne.matches,ne.textBuffer)).map((ne,Y)=>(ne.webviewIndex=Y,ne));if(ve.length>0||se.length>0){const ne={index:we,contentResults:(0,i.$TJ)(ve,le.inputTextBuffer),webviewResults:be};P.push(ne)}});const ae={resource:z,cellResults:P};O.set(z,ae);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...O.values()]}}async y(m,f){const S=await this.s.value.stat(m);if(typeof f?.mtime=="number"&&typeof f.etag=="string"&&f.etag!==A.$Vk&&typeof S.mtime=="number"&&typeof S.size=="number"&&f.mtime<S.mtime&&f.etag!==A.$Wk({mtime:f.mtime,size:S.size}))throw new A.$Lk((0,E.localize)(1,null),3,f)}z(m){return m.scheme===c.Schemas.file?m.fsPath:m.toString()}A(m,f,S){if(this.h.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const L=new n.$mhc(f,this.d,m,S.visibleRanges.map(w.NotebookRange.to),S.selections.map(w.NotebookRange.to),typeof S.viewColumn=="number"?w.ViewColumn.to(S.viewColumn):void 0);this.h.set(f,L)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const S of m.value.removedDocuments){const L=b.URI.revive(S),v=this.g.get(L);v&&(v.dispose(),this.g.delete(L),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(v.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===L.toString()&&this.h.delete(y.id)}if(m.value.addedDocuments){const S=[];for(const L of m.value.addedDocuments){const v=b.URI.revive(L.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const y=new t.$lhc(this.c,this.q,this.r,v,L);S.push(...L.cells.map(k=>t.$khc.asModelAddData(y.apiNotebook,k))),this.g.get(v)?.dispose(),this.g.set(v,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(y.apiNotebook)}}if(m.value.addedEditors)for(const S of m.value.addedEditors){if(this.h.has(S.id))return;const L=b.URI.revive(S.documentUri),v=this.g.get(L);v&&this.A(v,S.id,S)}const f=[];if(m.value.removedEditors)for(const S of m.value.removedEditors){const L=this.h.get(S);L&&(this.h.delete(S),this.k?.id===L.id&&(this.k=void 0),f.push(L))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(L=>this.h.get(L)).filter(L=>!!L);const S=new Set;this.l.forEach(L=>S.add(L.id));for(const L of this.h.values()){const v=S.has(L.id);L._acceptVisibility(v)}this.l=[...this.h.values()].map(L=>L).filter(L=>L.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const f=p.$vN.String.with("notebookType","A notebook type"),S=new p.$xN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[f,new p.$vN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>T.$je.wrap(v))],new p.$wN("Notebook Data",v=>w.NotebookData.to(v.value))),L=new p.$xN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[f,new p.$vN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new o.$Tv(w.NotebookData.from(v)))],new p.$wN("Bytes",v=>v.buffer));m.registerApiCommand(S),m.registerApiCommand(L)}}e.$vhc=r}),define(Pe[283],Re([1,0,19,20,40,34,25,60,44]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class b{constructor(u,p,w){this.k=u,this.l=p,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&M.$Mj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&M.$Mj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const p=this.k.folderQueries||[];return new Promise((w,s)=>{const o=t=>{this.f++,u(t)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),a=E.$nc(n);this.j&&this.j(n,a)||this.v(o,{base:t,basename:a})}),Promise.all(p.map(t=>this.p(t,o))).then(t=>{w({limitHit:this.e,stats:t[0]||void 0})},t=>{s(new Error((0,C.$Qi)(t)))})})}async p(u,p){const w=new T.$6d,s=this.q(u),o=this.r(),t=new g.$JJ(this.k,u),n=!t.hasSiblingExcludeClauses();let a;try{this.h.add(w),a=$.$Rd.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,w.token),h=a.elapsed(),i=$.$Rd.create();return this.g&&!this.e||(c&&c.forEach(l=>{const r=E.$gc.relative(u.folder.path,l.path);if(n){const d=E.$nc(l.path);this.v(p,{base:u.folder,relativePath:r,basename:d});return}this.s(o,u.folder,r,p)}),this.g&&!this.e)?null:(this.u(o,t,p),{providerTime:h,postProcessTime:i.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(u){const p=(0,g.$IJ)(this.k.includePattern,u.includePattern),w=(0,g.$IJ)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:w,includes:p,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},p,w,s){if(w===this.a){const t=E.$nc(this.a);this.v(s,{base:p,relativePath:this.a,basename:t})}function o(t){const n=E.$nc(t),a=E.$mc(t);let c=u[a];c||(c=u[a]=[],o(a)),c.push({base:p,relativePath:t,basename:n})}o(w)}u({rootEntries:u,pathToEntries:p},w,s){const o=this,t=this.a;function n(a){const c=(0,g.$LJ)(()=>a.map(h=>h.basename));for(let h=0,i=a.length;h<i;h++){const l=a[h],{relativePath:r,basename:d}=l;if(w.matchesExcludesSync(r,d,t!==d?c:void 0))continue;const m=p[r];if(m)n(m);else{if(r===t)continue;o.v(s,l)}if(o.e)break}}n(u)}v(u,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(p))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,p,w,s){const o=this.c(u.cacheKey),t=new b(u,p,o&&o.token);let n=0;const a=c=>{n+=c.length,w(c.map(h=>this.d(h)))};return this.e(t,A.a,a,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new T.$6d),this.b.get(u)}d(u){return u.relativePath?{resource:R.$Hg(u.base,u.relativePath)}:{resource:u.base}}e(u,p,w,s){const o=s.onCancellationRequested(()=>{u.cancel()}),t=a=>{a&&(n.push(a),p>0&&n.length>=p&&(w(n),n=[]))};let n=[];return u.search(t).then(a=>(n.length&&w(n),o.dispose(),a),a=>(n.length&&w(n),o.dispose(),Promise.reject(a)))}}e.$nhc=A}),define(Pe[284],Re([1,0,18,245,34,95,28,12,19,25,11,16,2,94,179,41,14,47,105,280,44]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=void 0;let h=class{constructor(y,k,N,O,G){this.a=y,this.b=k,this.c=N,this.d=O,this.e=G}text(y,k,N={}){y=this.f(y,N);const O=this.a.getValue(),G=k&&k.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(k?.map(t.$oi),N),type:2,contentPattern:y,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:O.search.usePCRE2||G||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(y,k){const N=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const O={...y,wordSeparators:N.editor.wordSeparators};return this.j(y,k)&&(O.isCaseSensitive=!0),this.k(y)&&(O.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),O}file(y,k={}){return{...this.h(y,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(y,k){return y?(y=Array.isArray(y)?y.map(m):m(y),k?this.parseSearchPaths(y):{pattern:l(...Array.isArray(y)?y:[y])}):{}}h(y=[],k={}){const N=this.g(k.includePattern,k.expandPatterns),O=this.g(k.excludePattern,k.expandPatterns),G=y.length>1,W=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(I=>this.q(I,k,O)):y.map(I=>this.r(I,k,O,G))).filter(I=>!!I),z={_reason:k._reason,folderQueries:W,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:O.pattern,includePattern:N.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const I=E.$Hb(E.$Rb(this.c.groups.map(de=>de.editors.map(we=>we.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(I));const H=I.filter(de=>(0,c.$zJ)(z,de.fsPath)),ae=this.i(H);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...z,...ae}}const P=k.extraFileResources&&k.extraFileResources.filter(I=>(0,c.$zJ)(z,I.fsPath));return z.extraFileResources=P&&P.length?P:void 0,z}i(y){const k=[],N=new R.$Ac,O={};let G=!1;return y.forEach(W=>{if(W.scheme===$.Schemas.walkThrough)return;if((0,b.$Lg)(W)){const P=this.b.getWorkspaceFolder(W)?.uri??W.with({path:g.$mc(W.fsPath)});let I=N.get(P);I||(G=!0,I={folder:P,includePattern:{}},k.push(I),N.set(P,I));const H=g.$lc(P.fsPath,W.fsPath);(0,D.$Tf)(I.includePattern)[H.replace(/\\/g,"/")]=!0}else W.fsPath&&(G=!0,O[W.fsPath]=!0)}),{folderQueries:k,includePattern:O,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(y,k){if(k.isSmartCase){if(y.isRegExp){if(A.$zf(y.pattern,!0))return!0}else if(A.$zf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,p.$4B)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const k=ae=>g.$ic(ae)||/^\.\.?([\/\\]|$)/.test(ae),O=(Array.isArray(y)?y:r(y)).map(ae=>{const de=this.e.resolvedUserHome;return de?(0,M.$Yv)(ae,de.scheme===$.Schemas.file?de.fsPath:de.path):ae}),G=T.$K(O,ae=>k(ae)?"searchPaths":"exprSegments"),W=(G.exprSegments||[]).map(ae=>A.$Ue(ae,"/")).map(ae=>A.$Ue(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),d(ae))),z={},P=this.m(G.searchPaths||[]);P&&P.length&&(z.searchPaths=P);const I=E.$Rb(W),H=l(...I);return H&&(z.pattern=H),z}l(y,k){return k.disregardExcludeSettings?void 0:(0,c.$yJ)(y,!k.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const k=y.flatMap(O=>{let{pathPortion:G,globPortion:W}=i(O);return W&&(W=f(W)),this.n(G).flatMap(P=>this.o(P,W))}),N=new Map;return k.forEach(O=>{const G=O.searchPath.toString(),W=N.get(G);W?O.pattern&&(W.pattern=W.pattern||{},W.pattern[O.pattern]=!0):N.set(G,{searchPath:O.searchPath,pattern:O.pattern?l(O.pattern):void 0})}),Array.from(N.values())}n(y){if(g.$ic(y)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==$.Schemas.file?[{searchPath:k[0].uri.with({path:y})}]:[{searchPath:u.URI.file(g.$hc(y))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(y=m(y),y.startsWith("../")||y===".."){const O=g.$gc.resolve(k.path,y);return[{searchPath:k.with({path:O})}]}const N=f(y);return[{searchPath:k,pattern:N}]}else{if(y==="./"||y===".\\")return[];{const k=y.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(G=>{const W=k.match(new RegExp(`^${A.$Oe(G.name)}(?:/(.*)|$)`));return W?{match:W,folder:G}:null}).filter(D.$Qf);if(O.length)return O.map(G=>{const W=G.match[1];return{searchPath:G.folder.uri,pattern:W&&f(W)}});{const G=y.match(/\.[\/\\](.+)[\/\\]?/),W=G?G[1]:y,z=w.localize(0,null,W);throw new Error(z)}}}}o(y,k){const N=y.pattern&&k?`${y.pattern}/${k}`:y.pattern||k,O=[{searchPath:y.searchPath,pattern:N}];return N&&!N.endsWith("**")&&O.push({searchPath:y.searchPath,pattern:N+"/**"}),O}q(y,k,N){const O=this.r((0,t.$oi)(y.searchPath),k,N,!1);return O?{...O,includePattern:y.pattern}:null}r(y,k,N,O){let G;const W=u.URI.isUri(y)?y:y.uri;if(N.searchPaths){const ae=N.searchPaths.filter(de=>(0,b.$Ag)(de.searchPath,W))[0];if(ae&&!ae.pattern)return null;ae&&(G=ae.pattern)}const z=this.a.getValue({resource:W}),I={...this.l(z,k)||{},...G||{}},H=u.URI.isUri(y)?(0,b.$Eg)(y):y.name;return{folder:W,folderName:O?H:void 0,excludePattern:Object.keys(I).length>0?I:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!z.search.followSymlinks}}};e.$JK=h,e.$JK=h=Je([Ke(0,s.$zi),Ke(1,t.$ci),Ke(2,n.$9C),Ke(3,o.$nj),Ke(4,a.$HK)],h);function i(v){const y=v.match(/[\*\{\}\(\)\[\]\?]/);if(y){const k=y.index,N=v.substr(0,k).match(/[/|\\][^/\\]*$/);if(N){let O=v.substr(0,N.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:v.substr((N.index||0)+1)}}}return{pathPortion:v}}function l(...v){return v.length?v.reduce((y,k)=>(y[k]=!0,y),Object.create(null)):void 0}function r(v){return C.$Kj(v,",").map(y=>y.trim()).filter(y=>!!y.length)}function d(v){return[`**/${v}/**`,`**/${v}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function m(v){return v.replace(/\\/g,"/")}function f(v){return m(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(v){return v.replace(/([?*[\]])/g,"[$1]")}function L(v,y){v=E.$Mb(v,O=>O.toString());const k=[],N=y.getWorkspace();return v&&v.forEach(O=>{let G;if(y.getWorkbenchState()===2)G=(0,b.$Jg)(N.folders[0].uri,O),G&&G!=="."&&(G="./"+G);else{const W=y.getWorkspaceFolder(O);if(W){const z=W.name;if(N.folders.filter(I=>I.name===z).length===1){const I=(0,b.$Jg)(W.uri,O);I===""?G=`./${W.name}`:G=`./${W.name}/${I}`}else G=O.fsPath}}G&&k.push(S(G))}),k}e.$KK=L}),define(Pe[285],Re([1,0,25,2,20,15,4,284,44,47]),function(ge,e,E,T,C,M,R,$,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsb=e.$qsb=void 0;const A=7e3;function D(s,o){const t=o.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],a=[];for(const d of t)if(/^workspaceContains:/.test(d)){const m=d.substr(18);m.indexOf("*")>=0||m.indexOf("?")>=0||s.forceUsingSearch?a.push(m):n.push(m)}if(n.length===0&&a.length===0)return Promise.resolve(void 0);let c;const h=new Promise((d,m)=>{c=d}),i=d=>c({activationEvent:d}),l=Promise.all(n.map(d=>u(s,d,i))).then(()=>{}),r=p(s,o.identifier,a,i);return Promise.all([l,r]).then(()=>{c(void 0)}),h}e.$qsb=D;async function u(s,o,t){for(const n of s.folders)if(await s.exists(E.$Hg(T.URI.revive(n),o))){t(`workspaceContains:${o}`);return}}async function p(s,o,t,n){if(t.length===0)return Promise.resolve(void 0);const a=new C.$6d,c=s.checkExists(s.folders,t,a.token),h=setTimeout(async()=>{a.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},A);let i=!1;try{i=await c}catch(l){M.$4(l)||M.$1(l)}a.dispose(),clearTimeout(h),i&&n(`workspaceContains:${t.join(",")}`)}function w(s,o,t,n){const a=s.get(R.$5h),c=s.get(g.$qJ),i=a.createInstance($.$JK).file(o.map(l=>(0,b.$oi)(T.URI.revive(l))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,n).then(l=>!!l.limitHit,l=>M.$4(l)?!1:Promise.reject(l))}e.$rsb=w}),define(Pe[38],Re([1,0,159,19,88,25,13,6,50,2,14,3,37,217,85,36,23,106,15,22,24,200,7,100,4,27,86,17,71,87,64,5,285,84,202,12,82,60,21,83]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c,h,i,l,r,d,m,f,S,L,v,y,k,N,O,G,W,z,P,I){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=e.$5gc=e.$4gc=e.$3gc=e.$2gc=void 0,e.$2gc=(0,r.$6h)("IHostUtils");let ae=H=class extends $.$Tc{constructor(Y,V,ie,Ie,Le,Ce,ce,te,Q,ee,me,pe){super(),this.X=pe,this.a=this.B(new y.$Vd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ie,this.f=ce,this.j=Ie,this.m=Le,this.s=Ce,this.t=Q,this.u=ee,this.w=me,this.y=this.g.getProxy(D.$6K.MainThreadWorkspace),this.z=this.g.getProxy(D.$6K.MainThreadTelemetry),this.C=this.g.getProxy(D.$6K.MainThreadExtensionService),this.D=new R.$5g,this.F=new R.$5g,this.G=new R.$5g,this.H=new R.$5g,this.I=new be(this.f.extensions.activationEvents),this.L=new t.$g8b(this.I,this.f.extensions.allExtensions);const Ae=new a.$mm(this.f.extensions.myExtensions);this.J=new t.$g8b(this.I,ve(this.L,Ae)),P.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new w.$Mgc(this.g,this.s),this.N=new N.$Ugc(this.g),this.O=te,this.h=Y.createChild(new S.$4h([w.$Ngc,this.M],[N.$Vgc,this.N])),this.P=this.B(new p.$Lgc(this.J,this.L,{onExtensionActivationError:(he,ye,F)=>{this.C.$onExtensionActivationError(he,n.$3(ye),F)},actualActivateExtension:async(he,ye)=>{if(t.$g8b.isHostExtension(he,this.J,this.L))return await this.C.$activateExtension(he,ye),new p.$Kgc;const F=this.J.getExtensionDescription(he);return this.db(F,ye)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Y){n.$1(Y)}}async Y(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(Le=>Le.identifier).filter(Le=>this.isActivated(Le)).map(Le=>this.cb(Le))}catch{}await Promise.all(Y)}terminate(Y,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ie=this.Y();Promise.race([(0,R.$7g)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const V=await this.C.$getExtension(Y);return V&&{...V,identifier:new a.$lm(V.identifier.value),extensionLocation:b.URI.revive(V.extensionLocation)}}Z(Y,V){return this.P.activateByEvent(Y,V)}$(Y,V){return this.P.activateById(Y,V)}activateByIdWithErrors(Y,V){return this.$(Y,V).then(()=>{const ie=this.P.getActivatedExtension(Y);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async ab(Y){if(Y.scheme===G.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(Y.fsPath);return b.URI.file(V)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Y=>new se(Y))),this.Q}async bb(Y){const V=g.$_h.forUris(ie=>M.$yg.ignorePathCasing(ie));return await Promise.all(Y.map(async ie=>{if(this.ub(ie)){const Ie=await this.ab(ie.extensionLocation);V.set(Ie,ie)}})),V}cb(Y){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return V;const ie=this.P.getActivatedExtension(Y);if(!ie)return V;try{typeof ie.module.deactivate=="function"&&(V=Promise.resolve(ie.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(Ie)}try{(0,$.$Oc)(ie.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(Ie)}return V}async db(Y,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.fb(Y,V).then(ie=>{const Ie=ie.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(Y,V,"success",Ie),ie},ie=>{throw this.eb(Y,V,"failure"),ie})}eb(Y,V,ie,Ie){const Le=we(Y,V);this.z.$publicLog2("extensionActivationTimes",{...Le,...Ie||{},outcome:ie})}fb(Y,V){const ie=we(Y,V);this.z.$publicLog2("activatePlugin",ie);const Ie=this.ub(Y);if(!Ie)return Promise.resolve(new p.$Jgc(p.$Ggc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${Y.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Le=new p.$Hgc(V.startup);return Promise.all([this.vb(Y,(0,M.$Hg)(Y.extensionLocation,Ie),Le),this.gb(Y)]).then(Ce=>(C.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),H.hb(this.s,Y.identifier,Ce[0],Ce[1],Le))).then(Ce=>(C.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Ce))}gb(Y){const V=new h.$Pgc(Y,this.M),ie=new h.$Ogc(Y.identifier.value,!1,this.M),Ie=new O.$Wgc(Y,this.N),Le=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([V.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const ce=this;let te,Q;const ee=(0,o.$BF)(Y,"ipc")?this.f.messagePorts?.get(a.$lm.toKey(Y.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ie,secrets:Ie,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(me){return T.$jc(Y.extensionLocation.fsPath,me)},get storagePath(){return ce.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Y).fsPath},get logPath(){return T.$jc(ce.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return b.URI.joinPath(ce.f.logsLocation,Y.identifier.value)},get storageUri(){return ce.O.workspaceValue(Y)},get globalStorageUri(){return ce.O.globalValue(Y)},get extensionMode(){return Le},get extension(){return te===void 0&&(te=new le(ce,Y.identifier,Y,Ce,!1)),te},get extensionRuntime(){return(0,o.$CF)(Y,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!Q){if(!ee)return;const me=y.Event.buffer(y.Event.fromDOMEventEmitter(ee,"message",pe=>pe.data));ee.start(),Q={onDidReceiveMessage:me,postMessage:ee.postMessage.bind(ee)}}return Q}})})}static hb(Y,V,ie,Ie,Le){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(Y,V,ie,Ie,Le).then(Ce=>new p.$Igc(!1,null,Le.build(),ie,Ce,Ie.subscriptions))}static ib(Y,V,ie,Ie,Le){if(typeof ie.activate=="function")try{Le.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Ce=typeof global=="object"?global:self,ce=ie.activate.apply(Ce,[Ie]);return Le.activateCallStop(),Le.activateResolveStart(),Promise.resolve(ce).then(te=>(Le.activateResolveStop(),te))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(ie)}jb(Y,V){this.$(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:V}).then(void 0,ie=>{this.s.error(ie)})}kb(Y,V=0){const Ie=Date.now();(0,P.$B)(()=>{for(let Le=V;Le<Y.length;Le+=1){const Ce=Y[Le];for(const ce of Ce.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ie>50){this.kb(Y,Le);break}else this.jb(Ce,ce)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Y=>{const V=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(V)this.kb(ie);else for(const Ie of ie)if(Ie.activationEvents)for(const Le of Ie.activationEvents)Le==="onStartupFinished"&&this.jb(Ie,Le)})}mb(){const Y=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const V=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(V),Ie=this.pb(),Le=Promise.all([Ie,Y,ie]).then(()=>{});return Promise.race([Le,(0,R.$7g)(1e4)]).then(()=>{this.lb()}),Le}nb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(Y,V))).then(()=>{})}async ob(Y,V){if(this.isActivated(V.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:Y.map(Ce=>Ce.uri),forceUsingSearch:ie||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,ce,te)=>this.y.$checkExists(Ce,ce,te)},Le=await(0,k.$qsb)(Ie,V);if(Le)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Le.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Y){throw console.error(Y),Y}}async qb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:V}=this.f.environment;if(!Y||!V)throw new Error(E.localize(0,null));const ie=await this.vb(null,V,new p.$Hgc(!1));if(!ie||typeof ie.run!="function")throw new Error(E.localize(1,null,V.toString()));return new Promise((Ie,Le)=>{const Ce=(Q,ee)=>{Q?(P.$t&&this.s.error("Test runner called back with error",Q),Le(Q)):(P.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof ee=="number"&&ee>0?1:0))},ce=(0,M.$vg)(V),te=ie.run(ce,Ce);te&&te.then&&te.then(()=>{P.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(Q=>{P.$t&&this.s.error("Test runner finished with error",Q),Le(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$7g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,V){return this.R[Y]=V,(0,$.$Rc)(()=>{delete this.R[Y]})}async getRemoteExecServer(Y){const{resolver:V}=await this.sb(Y);return V?.resolveExecServer?.(Y,{resolveAttempt:0})}async sb(Y){const V=Y.indexOf("+");if(V===-1)throw new i.$bL("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=Y.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(Y,V){const ie=z.$Rd.create(!1),Ie=()=>`[resolveAuthority(${(0,l.$_k)(Y)},${V})][${ie.elapsed()}ms] `,Le=K=>this.s.info(`${Ie()}${K}`),Ce=K=>this.s.warn(`${Ie()}${K}`),ce=(K,U=void 0)=>this.s.error(`${Ie()}${K}`,U),te=K=>{if(K instanceof i.$bL)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K},Q=async K=>{Le(`activating resolver for ${K}...`);const{resolver:U,authorityPrefix:X}=await this.sb(K);if(!U)throw ce(`no resolver for ${X}`),new i.$bL(`No remote extension installed to resolve ${X}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:U,authorityPrefix:X,remoteAuthority:K}},ee=Y.split(/@|%40/g).reverse();Le(`activating remote resolvers ${ee.join(" -> ")}`);let me;try{me=await Promise.all(ee.map(Q)).catch(async K=>{if(!(K instanceof i.$bL)||K._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw K;return Ce(`resolving nested authorities failed: ${K.message}`),[await Q(Y)]})}catch(K){return te(K)}const pe=new R.$eh;pe.cancelAndSet(()=>Le("waiting..."),1e3);let Ae,he;for(const[K,{authorityPrefix:U,resolver:X,remoteAuthority:x}]of me.entries())try{if(K===me.length-1)Le("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${U}`),Ae=await X.resolve(x,{resolveAttempt:V,execServer:he}),C.mark(`code/extHost/didResolveAuthorityOK/${U}`),Le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(X,i.$aL.isManagedResolvedAuthority(Ae)?Ae:void 0));else{if(Le(`invoking resolveExecServer() for ${x}`),C.mark(`code/extHost/willResolveExecServer/${U}`),he=await X.resolveExecServer?.(x,{resolveAttempt:V,execServer:he}),!he)throw new i.$bL(`Exec server was not available for ${x}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${U}`)}}catch(Ee){return C.mark(`code/extHost/didResolveAuthorityError/${U}`),ce("returned an error",Ee),pe.dispose(),te(Ee)}pe.dispose();const ye={environmentTunnels:Ae.environmentTunnels,features:Ae.tunnelFeatures?{elevation:Ae.tunnelFeatures.elevation,privacyOptions:Ae.tunnelFeatures.privacyOptions,protocol:Ae.tunnelFeatures.protocol===void 0?!0:Ae.tunnelFeatures.protocol}:void 0},F={extensionHostEnv:Ae.extensionHostEnv,isTrusted:Ae.isTrusted,authenticationSession:Ae.authenticationSessionForInitializingExtensions?{id:Ae.authenticationSessionForInitializingExtensions.id,providerId:Ae.authenticationSessionForInitializingExtensions.providerId}:void 0};Le(`returned ${i.$aL.isManagedResolvedAuthority(Ae)?"managed authority":`${Ae.host}:${Ae.port}`}`);let q;if(i.$aL.isManagedResolvedAuthority(Ae)){const K=V;this.X.setFactory(K,Ae.makeConnection),q={authority:Y,connectTo:new l.$9k(K),connectionToken:Ae.connectionToken}}else q={authority:Y,connectTo:new l.$0k(Ae.host,Ae.port),connectionToken:Ae.connectionToken};return{type:"ok",value:{authority:q,options:F,tunnelInformation:ye}}}async $getCanonicalURI(Y,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$_k)(Y)})`);const{resolver:ie}=await this.sb(Y);if(!ie)return null;const Ie=b.URI.revive(V);if(typeof ie.getCanonicalURI>"u")return Ie;const Le=await(0,R.$Yg)(()=>ie.getCanonicalURI(Ie));return Le||Ie}$startExtensionHost(Y){Y.toAdd.forEach(Ie=>Ie.extensionLocation=b.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ie}=de(this.I,this.L,this.J,Y);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),P.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(Y,V){return V===1?this.D.wait().then(ie=>this.Z(Y,!1)):this.G.wait().then(ie=>this.Z(Y,!1))}async $activate(Y,V){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.$(Y,V),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Ce=>Ce.extensionLocation=b.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ie}=de(this.I,this.L,this.J,Y),Ie=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),P.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const V=c.$je.alloc(Y),ie=Math.random()%256;for(let Ie=0;Ie<Y;Ie++)V.writeUInt8(ie,Ie);return V}async $updateRemoteConnectionData(Y){this.W=Y,this.a.fire()}};e.$3gc=ae,e.$3gc=ae=H=Je([Ke(0,r.$5h),Ke(1,e.$2gc),Ke(2,f.$0M),Ke(3,s.$pgc),Ke(4,u.$sgc),Ke(5,A.$nj),Ke(6,d.$nN),Ke(7,m.$vgc),Ke(8,L.$oyb),Ke(9,v.$Qgc),Ke(10,W.$Ygc),Ke(11,I.$Zgc)],ae);function de(ne,Y,V,ie){ne.addActivationEvents(ie.addActivationEvents);const Ie=new t.$g8b(ne,Y.getAllExtensionDescriptions());Ie.deltaExtensions(ie.toAdd,ie.toRemove);const Le=new a.$mm(V.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ie.myToRemove)Le.delete(ce);for(const ce of ie.myToAdd)Le.add(ce);const Ce=ve(Ie,Le);return{globalRegistry:Ie,myExtensions:Ce}}function we(ne,Y){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function ke(ne){return ne.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$4gc=(0,r.$6h)("IExtHostExtensionService");class le{#e;#t;#i;constructor(Y,V,ie,Ie,Le){this.#e=Y,this.#t=V,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=T.$hc((0,M.$vg)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$5gc=le;function ve(ne,Y){return ne.getAllExtensionDescriptions().filter(V=>Y.has(V.identifier))}class se{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$6gc=se;class be{constructor(Y){this.a=new a.$nm,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const V of Object.keys(Y))this.a.set(V,Y[V])}}}),define(Pe[286],Re([1,0,88,2,3,37,23,22,17,27,4,38,14,11]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;let s=class{constructor(c,h,i,l,r,d,m){this.c=c,this.d=h,this.e=i,this.f=l,this.g=r,this.h=d,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$bic=s,e.$bic=s=Je([Ke(2,A.$5h),Ke(3,M.$sgc),Ke(4,D.$4gc),Ke(5,b.$nN),Ke(6,u.$nj)],s);let o=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&w.a.size){const h=(0,p.$Oe)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",l=`@${i}+\\/${i}+|${i}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${r}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,l,r]=h,d=w.a.get(l);if(d!==void 0)return console.warn(`${l} as been renamed to ${d}, please update your imports`),i+d+r}c(c){return c.replace(/\\/g,"/")}};o=w=Je([Ke(0,b.$nN)],o);class t{constructor(c,h,i,l,r){this.c=c,this.d=h,this.e=i,this.f=l,this.g=r,this.nodeModuleName="vscode",this.a=new $.$nm}load(c,h){const i=this.d.findSubstr(h);if(i){let l=this.a.get(i.identifier);return l||(l=this.c(i,this.e,this.f),this.a.set(i.identifier,l)),l}if(!this.b){let l="";this.d.forEach((r,d)=>l+=`	${d} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${l}`),this.b=this.c(R.$wF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(C.$6K.MainThreadTelemetry);const l=i.getProxy(C.$6K.MainThreadWindow);this.c=(r,d)=>{const m=T.URI.parse(r);return d?this.g(r,d):m.scheme==="http"||m.scheme==="https"?l.$openUri(m,r,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?l.$openUri(m,r,{}):this.g(r,d)}}load(c,h,i){const l=this.e.findSubstr(h);return l&&(this.a=l.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([Ke(2,g.$0M)],n)}),define(Pe[116],Re([1,0,39,6,19,74,4,61,62,38,7,36,214,37]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=void 0,e.$7gc=(0,R.$6h)("IExtHostVariableResolverProvider");class w extends u.$$N{constructor(t,n,a,c,h,i,l){function r(){if(a){const d=a.activeEditor();if(d)return d.document.uri;const m=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(m!==void 0){if(m.input instanceof A.$OM||m.input instanceof A.$TM)return m.input.modified;if(m.input instanceof A.$NM||m.input instanceof A.$SM||m.input instanceof A.$QM)return m.input.uri}}}super({getFolderUri:d=>{const m=i.folders.filter(f=>f.name===d);if(m&&m.length>0)return m[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(d,m)=>h.getConfiguration(void 0,d).get(m),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=r();if(d)return C.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const d=r();if(d){const m=n.getWorkspaceFolder(d);if(m)return C.$hc(m.uri.fsPath)}}},getSelectedText:()=>{if(a){const d=a.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(a){const d=a.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>t.getExtension(d)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(M.env))}}let s=class extends T.$Tc{constructor(t,n,a,c,h){super(),this.b=t,this.c=n,this.g=a,this.h=c,this.j=h,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,i,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$8gc=s,e.$8gc=s=Je([Ke(0,b.$4gc),Ke(1,D.$pgc),Ke(2,$.$iN),Ke(3,p.$sgc),Ke(4,g.$Egc)],s)}),define(Pe[117],Re([1,0,13,5,2,4,3,62,38,17,7,36,206,208,37,116]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=e.$_gc=e.$$gc=e.$0gc=e.$9gc=void 0,e.$9gc=(0,M.$6h)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(l,r,d,m,f,S){this.E=r,this.F=d,this.G=m,this.H=f,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Vd,this.n=new T.$Vd,this.o=new T.$Vd,this.u=new T.$Vd,this.k=l.getProxy(R.$6K.MainThreadDebugService),this.y=new T.$Vd,this.A=new T.$Vd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(v=>{this.J(L)}),this.J(L)})}asDebugSourceUri(l,r){const d=l;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let m=`debug:${encodeURIComponent(d.path||"")}`,f="?";return r&&(m+=`${f}session=${encodeURIComponent(r.id)}`,f="&"),m+=`${f}ref=${d.sourceReference}`,C.URI.parse(m)}else{if(d.path)return C.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(l){const r=[];for(const d of l.getAllExtensionDescriptions())if(d.contributes){const m=d.contributes.debuggers;if(m&&m.length>0)for(const f of m)(0,p.$bG)(f)&&r.push(f.type)}this.k.$registerDebugTypes(r)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const l=[];return this.w.forEach(r=>l.push(r)),l}addBreakpoints(l){const r=l.filter(f=>{const S=f.id;return this.w.has(S)?!1:(this.w.set(S,f),!0)});this.U(r,[],[]);const d=[],m=new Map;for(const f of r)if(f instanceof A.$8L){let S=m.get(f.location.uri.toString());S||(S={type:"sourceMulti",uri:f.location.uri,lines:[]},m.set(f.location.uri.toString(),S),d.push(S)),S.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.$9L&&d.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(l){const r=l.filter(S=>this.w.delete(S.id));this.U([],r,[]);const d=r.filter(S=>S instanceof A.$8L).map(S=>S.id),m=r.filter(S=>S instanceof A.$9L).map(S=>S.id),f=r.filter(S=>S instanceof A.$0L).map(S=>S.id);return this.k.$unregisterBreakpoints(d,m,f)}startDebugging(l,r,d){return this.k.$startDebugging(l?l.uri:void 0,r,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(l){return this.k.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,r,d){if(!r)return new A.$8K(()=>{});const m=this.d++;return this.f.push({type:l,handle:m,provider:r}),this.k.$registerDebugConfigurationProvider(l,d,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,m),new A.$8K(()=>{this.f=this.f.filter(f=>f.provider!==r),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(l,r,d){if(!d)return new A.$8K(()=>{});if(!this.Q(l,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.N(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:r,handle:m,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(r,m),new A.$8K(()=>{this.h=this.h.filter(f=>f.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(l,r){if(!r)return new A.$8K(()=>{});const d=this.i++;return this.j.push({type:l,handle:d,factory:r}),new A.$8K(()=>{this.j=this.j.filter(m=>m.factory!==r)})}async $runInTerminal(l,r){return Promise.resolve(void 0)}async $substituteVariables(l,r){let d;const m=await this.W(l);return m&&(d={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,r)}K(l,r){if(l.type==="implementation")return new c(l.implementation)}L(){}async $startDASession(l,r){const d=this,m=await this.V(r);return this.S(this.N(m.type),m).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const S=this.M(f),L=this.K(S,m);if(!L)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const v=L;return this.B.set(l,v),this.R(m).then(y=>(y&&this.C.set(l,y),v.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const N=k,O={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const G=await this.D.sign(N.arguments.value);O.body={signature:G},v.sendResponse(O)}else throw new Error("no signer")}catch(G){O.success=!1,O.message=G.message,v.sendResponse(O)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(k),k=(0,p.$gG)(k,!0),d.k.$acceptDAMessage(l,k)}),v.onError(k=>{y&&y.onError&&y.onError(k),this.k.$acceptDAError(l,k.name,k.message,k.stack)}),v.onExit(k=>{y&&y.onExit&&y.onExit(k??void 0,void 0),this.k.$acceptDAExit(l,k??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),v.startSession()))})}$sendDAMessage(l,r){r=(0,p.$fG)(r,!1);const d=this.C.get(l);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(r),this.B.get(l)?.sendMessage(r)}$stopDASession(l){const r=this.C.get(l);this.C.delete(l),r&&r.onWillStopSession&&r.onWillStopSession();const d=this.B.get(l);return this.B.delete(l),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const r=[],d=[],m=[];if(l.added)for(const f of l.added){const S=f.id;if(S&&!this.w.has(S)){let L;if(f.type==="function")L=new A.$9L(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")L=new A.$0L(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const v=C.URI.revive(f.uri);L=new A.$8L(new A.$hL(v,new A.$9K(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,A.$6L)(L,S),this.w.set(S,L),r.push(L)}}if(l.removed)for(const f of l.removed){const S=this.w.get(f);S&&(this.w.delete(f),d.push(S))}if(l.changed){for(const f of l.changed)if(f.id){const S=this.w.get(f.id);if(S){if(S instanceof A.$9L&&f.type==="function"){const L=S;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.functionName=f.functionName}else if(S instanceof A.$8L&&f.type==="source"){const L=S;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.location=new A.$hL(C.URI.revive(f.uri),new A.$9K(f.line,f.character))}m.push(S)}}}this.U(r,d,m)}async $acceptStackFrameFocus(l){let r;const d=l.sessionId?await this.V(l.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");l.kind==="thread"?r=new A.$dM(d,l.threadId):r=new A.$cM(d,l.threadId,l.frameId),this.z=r,this.A.fire(this.z)}$provideDebugConfigurations(l,r,d){return(0,E.$Yg)(async()=>{const m=this.P(l);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(r);return m.provideDebugConfigurations(f,d)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(l,r,d,m){return(0,E.$Yg)(async()=>{const f=this.P(l);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(r);return f.resolveDebugConfiguration(S,d,m)})}$resolveDebugConfigurationWithSubstitutedVariables(l,r,d,m){return(0,E.$Yg)(async()=>{const f=this.P(l);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(r);return f.resolveDebugConfigurationWithSubstitutedVariables(S,d,m)})}async $provideDebugAdapter(l,r){const d=this.O(l);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(r);return this.S(d,m).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(l){const r=await this.V(l);this.m.fire(r)}async $acceptDebugSessionTerminated(l){const r=await this.V(l);r&&(this.n.fire(r),this.l.delete(r.id))}async $acceptDebugSessionActiveChanged(l){this.q=l?await this.V(l):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(l,r){(await this.V(l))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(l,r){const m={session:await this.V(l),event:r.event,body:r.body};this.u.fire(m)}M(l){if(l instanceof A.$$L)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof A.$_L)return{type:"server",port:l.port,host:l.host};if(l instanceof A.$aM)return{type:"pipeServer",path:l.path};if(l instanceof A.$bM)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}N(l){const r=this.h.filter(d=>d.type===l);if(r.length>0)return r[0].factory}O(l){const r=this.h.filter(d=>d.handle===l);if(r.length>0)return r[0].factory}P(l){const r=this.f.filter(d=>d.handle===l);if(r.length>0)return r[0].provider}Q(l,r){if(l.contributes){const d=l.contributes.debuggers;if(d&&d.length>0){for(const m of d)if(m.label&&m.type&&m.type===r)return!0}}return!1}R(l){const d=l.configuration.type,m=this.j.filter(f=>f.type===d||f.type==="*").map(f=>(0,E.$Yg)(()=>f.factory.createDebugAdapterTracker(l)).then(S=>S,S=>null));return Promise.race([Promise.all(m).then(f=>{const S=f.filter(L=>!!L);if(S.length>0)return new a(S)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(l,r){const d=r.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new A.$_L(d));if(l){const f=await this.F.getExtensionRegistry();return(0,E.$Yg)(()=>l.createDebugAdapterDescriptor(r,this.T(r,f))).then(S=>{if(S)return S})}const m=await this.F.getExtensionRegistry();return Promise.resolve(this.T(r,m))}T(l,r){}U(l,r,d){(l.length>0||r.length>0||d.length>0)&&this.y.fire(Object.freeze({added:l,removed:r,changed:d}))}async V(l){if(l)if(typeof l=="string"){const r=this.l.get(l);if(r)return r}else{let r=this.l.get(l.id);if(!r){const d=await this.W(l.folderUri),m=l.parent?this.l.get(l.parent):void 0;r=new t(this.k,l.id,l.type,l.name,d,l.configuration,m),this.l.set(r.id,r),this.k.$sessionCached(r.id)}return r}throw new Error("cannot find session")}W(l){if(l){const r=C.URI.revive(l);return this.E.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};e.$0gc=o,e.$0gc=o=Je([Ke(0,b.$0M),Ke(1,D.$pgc),Ke(2,g.$4gc),Ke(3,w.$sgc),Ke(4,$.$Egc),Ke(5,s.$7gc)],o);class t{constructor(l,r,d,m,f,S,L){this.d=l,this.f=r,this.g=d,this.h=m,this.i=f,this.j=S,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(l){this.h=l,this.d.$setDebugSessionName(this.f,l)}get parentSession(){return this.k}_acceptNameChanged(l){this.h=l}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(l,r){return this.d.$customDebugAdapterRequest(this.f,l,r)}getDebugProtocolBreakpoint(l){return this.d.$getDebugProtocolBreakpoint(this.f,l.id)}}e.$$gc=t;class n{constructor(l){this.value=Object.freeze({append(r){l.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.$_gc=n;class a{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(r=>r.onError?r.onError(l):void 0)}onExit(l,r){this.d.forEach(d=>d.onExit?d.onExit(l,r):void 0)}}class c extends u.$Ilb{constructor(l){super(),this.h=l,l.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends o{constructor(l,r,d,m,f,S){super(l,r,d,m,f,S)}};e.$ahc=h,e.$ahc=h=Je([Ke(0,b.$0M),Ke(1,D.$pgc),Ke(2,g.$4gc),Ke(3,w.$sgc),Ke(4,$.$Egc),Ke(5,s.$7gc)],h)}),define(Pe[287],Re([1,0,15,88,2,3,275,14,70,71,27,184,17,57,38,59]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=void 0;class o{static async installEarlyHandler(a){Error.stackTraceLimit=100;const c=a.get($.$nj),i=a.get(u.$0M).getProxy(M.$6K.MainThreadErrors);E.setUnexpectedErrorHandler(l=>{c.error(l);const r=E.$3(l);i.$onUnexpectedError(r)})}static async installFullHandler(a){const c=a.get($.$nj),h=a.get(u.$0M),i=a.get(w.$4gc),l=a.get(s.$rN),r=h.getProxy(M.$6K.MainThreadExtensionService),d=h.getProxy(M.$6K.MainThreadErrors),m=await i.getExtensionPathIndex(),f=new WeakMap;function S(y,k){if(f.has(y))return f.get(y).stack;let N="",O,G;for(const z of k)N+=`
	at ${z.toString()}`,G=z.getFileName(),!O&&G&&(O=m.findSubstr(C.URI.file(G)));const W=`${y.name||"Error"}: ${y.message||""}${N}`;return f.set(y,{extensionIdentifier:O?.identifier,stack:W}),W}const L=Symbol("prepareStackTrace wrapped");let v=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(y){if(y===S||!y||y[L]){v=y||S;return}v=function(k,N){return S(k,N),y.call(Error,k,N)},Object.assign(v,{[L]:!0})}}),E.setUnexpectedErrorHandler(y=>{c.error(y);const k=E.$3(y),N=f.get(y);if(!N?.extensionIdentifier){d.$onUnexpectedError(k);return}r.$onExtensionRuntimeError(N.extensionIdentifier,k);const O=l.onExtensionError(N.extensionIdentifier,y);c.trace("forwarded error to extension?",O,N)})}}e.$cic=o;class t{constructor(a,c,h,i,l){this.a=h,this.b=new R.$o8b(a,null,i),c=t.e(c,this.b);const r=new b.$4h(...(0,g.$Zr)());r.set(A.$nN,{_serviceBrand:void 0,...c,messagePorts:l}),r.set(u.$0M,new u.$$M(this.b)),r.set(p.$mgc,new p.$ngc(i)),r.set(w.$2gc,h);const d=new D.$Eq(r,!0);d.invokeFunction(o.installEarlyHandler),this.d=d.invokeFunction(m=>m.get($.$nj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(m=>m.get(w.$4gc)),this.c.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(a){const c=this.b.getProxy(M.$6K.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(a))}terminate(a){this.c.terminate(a)}static e(a,c){a.extensions.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),a.environment.appRoot=C.URI.revive(c.transformIncomingURIs(a.environment.appRoot));const h=a.environment.extensionDevelopmentLocationURI;return h&&(a.environment.extensionDevelopmentLocationURI=h.map(i=>C.URI.revive(c.transformIncomingURIs(i)))),a.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(a.environment.workspaceStorageHome)),a.environment.extensionTelemetryLogResource=C.URI.revive(c.transformIncomingURIs(a.environment.extensionTelemetryLogResource)),a.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(a.nlsBaseUrl)),a.logsLocation=C.URI.revive(c.transformIncomingURIs(a.logsLocation)),a.workspace=c.transformIncomingURIs(a.workspace),a}}e.$dic=t}),define(Pe[288],Re([1,0,18,13,20,40,12,19,25,2,44]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=e.$qhc=e.$phc=e.$ohc=void 0;class D{constructor(n,a,c,h){this.d=n,this.e=a,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,a){const c=this.d.folderQueries||[],h=new C.$6d(a);return new Promise((i,l)=>{this.a=new p(n);let r=!1;const d=(m,f)=>{if(!r&&!this.b){const S=this.h(m);s(m)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,r=!0,h.cancel(),m=this.j(m,this.d.maxResults-this.c));const L=this.h(m);this.c+=L,(L>0||!s(m))&&this.a.add(m,f)}};Promise.all(c.map((m,f)=>this.k(m,S=>d(S,f),h.token))).then(m=>{h.dispose(),this.a.flush();const f=m.some(S=>!!S&&!!S.limitHit);i({limitHit:this.b||f,messages:(0,E.$Rb)(m.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},m=>{h.dispose();const f=(0,M.$Qi)(m);l(new Error(f))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,a){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,a),preview:{matches:h.slice(0,a),text:n.preview.text},uri:n.uri}}async k(n,a,c){const h=new A.$JJ(this.d,n),i=[],l={report:m=>{if(!this.l(m))return;const f=n.folder.scheme===R.Schemas.file?(0,A.$KJ)(()=>this.f.readdir(g.$Gg(m.uri))):void 0,S=g.$Jg(n.folder,m.uri);if(S){const L=h.includedInQuery(S,$.$nc(S),f);(0,T.$Sg)(L)?i.push(L.then(v=>{v&&a(m)})):L&&a(m)}}},r=this.n(n),d=await this.e.provideTextSearchResults(u(this.d.contentPattern),r,l,c);return i.length&&await Promise.all(i),d}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const a=(0,A.$IJ)(this.d.includePattern,n.includePattern),c=(0,A.$IJ)(this.d.excludePattern,n.excludePattern),h={folder:b.URI.from(n.folder),excludes:c,includes:a,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$ohc=D;function u(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class p{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,a=>this.g(a))}add(n,a){this.d&&(this.b!==a||!g.$Ag(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=a,this.d={resource:n.uri,results:[]}),this.d.results.push(w(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$phc=p;function w(t){return s(t)?{preview:{matches:(0,E.$2b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,E.$2b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function s(t){return!!t.preview}e.$qhc=s;class o{static{this.a=4e3}static{this.b=50}constructor(n,a){this.g=n,this.h=a,this.c=0,this.d=[],this.e=0}addItem(n,a){n&&this.j(n,a)}addItems(n,a){n&&this.k(n,a)}j(n,a){this.d.push(n),this.e+=a,this.l()}k(n,a){this.d=this.d.concat(n),this.e+=a,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$rhc=o}),define(Pe[118],Re([1,0,6,3,4,283,17,57,14,2,288]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=e.$thc=e.$shc=void 0,e.$shc=(0,C.$6h)("IExtHostSearch");let D=class{constructor(s,o,t){this.k=s,this.l=o,this.n=t,this.c=this.k.getProxy(T.$6K.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$nhc}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const t=this.d++;return this.e.set(t,o),this.c.$registerTextSearchProvider(t,this.o(s)),(0,E.$Rc)(()=>{this.g.delete(s),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(s,o){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const t=this.d++;return this.h.set(t,o),this.c.$registerFileSearchProvider(t,this.o(s)),(0,E.$Rc)(()=>{this.i.delete(s),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(s,o,t,n){const a=u(t),c=this.h.get(s);if(c)return this.j.fileSearch(a,c,h=>{this.c.$handleFileMatch(s,o,h.map(i=>i.resource))},n);throw new Error("unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,o,t){return{messages:[]}}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,t,n){const a=this.e.get(s);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const c=u(t);return this.q(c,a).search(i=>this.c.$handleTextMatch(s,o,i),n)}$enableExtensionHostSearch(){}q(s,o){return new A.$ohc(s,o,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$thc=D,e.$thc=D=Je([Ke(0,R.$0M),Ke(1,$.$mgc),Ke(2,g.$nj)],D);function u(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(p),extraFileResources:w.extraFileResources&&w.extraFileResources.map(s=>b.URI.revive(s))}}e.$uhc=u;function p(w){return{...w,folder:b.URI.revive(w.folder)}}}),define(Pe[289],Re([1,0,20,15,5,6,12,31,2,146,142,130,93,22,42,14,55,56,197,3,230,238,81,231,232,233,234,235,236,237,212,32,239,37,271,117,110,241,242,243,219,244,61,62,246,38,247,63,248,43,27,249,250,251,252,253,254,82,83,256,282,221,201,222,257,258,112,259,223,260,261,17,262,118,84,263,264,265,85,86,115,59,64,266,267,209,268,224,87,8,7,269,57,270,65,272,273,111,36,207,79,23,114]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c,h,i,l,r,d,m,f,S,L,v,y,k,N,O,G,W,z,P,I,H,ae,de,we,ke,le,ve,se,be,ne,Y,V,ie,Ie,Le,Ce,ce,te,Q,ee,me,pe,Ae,he,ye,F,q,K,U,X,x,Ee,Te,Ve,He,Ye,st,nt,tt,at,ct,je,vt,Z,_,$e,Be,Qe,it,rt,Ne,Pt,Tt,Ht,Bt,yt,Kt,Nt,Xt,zt,Rt,Ze,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;function Jt(lt){const $t=lt.get(Y.$nN),jt=lt.get(ne.$7fc),Vt=lt.get(se.$ugc),kt=lt.get(le.$4gc),dt=lt.get(Xt.$pgc),Ct=lt.get(je.$rN),xt=lt.get(N.$sgc),Dt=lt.get(Tt.$mgc),qe=lt.get(Ee.$0M),Mt=lt.get(tt.$Ngc),Wt=lt.get(at.$vgc),Qt=lt.get(s.$oj),ft=lt.get(s.$nj),Ft=lt.get(it.$oyb),Se=lt.get(i.$0fc),Fe=lt.get(Nt.$9hc),fe=lt.get(He.$Vgc),J=lt.get(we.$Egc),Me=lt.get(Q.$Zgc);qe.set(a.$7K.ExtHostFileSystemInfo,jt),qe.set(a.$7K.ExtHostLogLevelServiceShape,Qt),qe.set(a.$7K.ExtHostWorkspace,dt),qe.set(a.$7K.ExtHostConfiguration,xt),qe.set(a.$7K.ExtHostExtensionService,kt),qe.set(a.$7K.ExtHostStorage,Mt),qe.set(a.$7K.ExtHostTunnelService,Ft),qe.set(a.$7K.ExtHostWindow,Fe),qe.set(a.$7K.ExtHostSecretState,fe),qe.set(a.$7K.ExtHostTelemetry,Ct),qe.set(a.$7K.ExtHostEditorTabs,J),qe.set(a.$7K.ExtHostManagedSockets,Me);const Ue=qe.set(a.$7K.ExtHostDecorations,lt.get(W.$chc)),Xe=qe.set(a.$7K.ExtHostDocumentsAndEditors,lt.get(de.$iN)),We=qe.set(a.$7K.ExtHostCommands,lt.get(y.$tN)),_e=qe.set(a.$7K.ExtHostTerminalService,lt.get(vt.$Qgc)),mt=qe.set(a.$7K.ExtHostDebugService,lt.get(G.$9gc)),Ut=qe.set(a.$7K.ExtHostSearch,lt.get(Ve.$shc)),Et=qe.set(a.$7K.ExtHostTask,lt.get(ct.$Vhc)),St=qe.set(a.$7K.ExtHostOutputService,lt.get(q.$Ihc)),bt=qe.set(a.$7K.ExtHostLocalization,lt.get(te.$Ygc)),gi=qe.set(a.$7K.ExtHostUrls,new Ht.$6hc(qe)),At=qe.set(a.$7K.ExtHostDocuments,new ae.$5fc(qe,Xe)),Si=qe.set(a.$7K.ExtHostDocumentContentProviders,new I.$ehc(qe,Xe,ft)),Gi=qe.set(a.$7K.ExtHostDocumentSaveParticipant,new H.$fhc(ft,At,qe.getProxy(a.$6K.MainThreadBulkEdits))),It=qe.set(a.$7K.ExtHostNotebook,new me.$vhc(qe,We,Xe,At,Vt,Ut)),ri=qe.set(a.$7K.ExtHostNotebookDocuments,new Ae.$Chc(It)),mi=qe.set(a.$7K.ExtHostNotebookEditors,new he.$Dhc(ft,It)),ci=qe.set(a.$7K.ExtHostNotebookKernels,new ye.$Ehc(qe,$t,It,We,ft)),Ii=qe.set(a.$7K.ExtHostNotebookRenderers,new F.$Ghc(qe,It)),Ci=qe.set(a.$7K.ExtHostNotebookDocumentSaveParticipant,new pe.$Bhc(ft,It,qe.getProxy(a.$6K.MainThreadBulkEdits))),Ot=qe.set(a.$7K.ExtHostEditors,new _.$jgc(qe,Xe)),$i=qe.set(a.$7K.ExtHostTreeViews,new Qe.$4hc(qe.getProxy(a.$6K.MainThreadTreeViews),We,ft)),Pi=qe.set(a.$7K.ExtHostEditorInsets,new v.$kgc(qe.getProxy(a.$6K.MainThreadEditorInsets),Ot,$t.remote)),ui=qe.set(a.$7K.ExtHostDiagnostics,new z.$9fc(qe,ft,jt,Xe)),li=qe.set(a.$7K.ExtHostLanguages,new ce.$zhc(qe,At,We.converter,Dt)),ht=qe.set(a.$7K.ExtHostLanguageFeatures,new Ce.$agc(qe,Dt,At,We,ui,ft,Se,Ct)),Ji=qe.set(a.$7K.ExtHostFileSystem,new ve.$hhc(qe,ht)),_t=qe.set(a.$7K.ExtHostFileSystemEventService,new be.$ihc(qe,ft,Xe)),si=qe.set(a.$7K.ExtHostQuickOpen,(0,x.$Mhc)(qe,dt,We)),pi=qe.set(a.$7K.ExtHostSCM,new Te.$Ohc(qe,We,At,ft)),Ri=qe.set(a.$7K.ExtHostQuickDiff,new X.$Lhc(qe,Dt)),Qi=qe.set(a.$7K.ExtHostShare,new Ye.$Phc(qe,Dt)),Ai=qe.set(a.$7K.ExtHostComments,(0,k.$lgc)(qe,We,At)),vi=qe.set(a.$7K.ExtHostProgress,new U.$Khc(qe.getProxy(a.$6K.MainThreadProgress))),Xi=qe.set(a.$7K.ExtHostLabelService,new Le.$yhc(qe)),Li=qe.set(a.$7K.ExtHostTheming,new $e.$1hc(qe)),hi=qe.set(a.$7K.ExtHostAuthentication,new l.$cgc(qe)),Yi=qe.set(a.$7K.ExtHostTimeline,new Be.$3hc(qe,We)),wi=qe.set(a.$7K.ExtHostWebviews,new Bt.$zgc(qe,$t.remote,dt,ft,Se)),Mi=qe.set(a.$7K.ExtHostWebviewPanels,new yt.$Cgc(qe,wi,dt)),un=qe.set(a.$7K.ExtHostCustomEditors,new O.$Dgc(qe,At,Wt,wi,Mi)),Fi=qe.set(a.$7K.ExtHostWebviewViews,new Kt.$7hc(qe,wi)),oi=qe.set(a.$7K.ExtHostTesting,new Z.$Whc(qe,ft,We,Xe)),ln=qe.set(a.$7K.ExtHostUriOpeners,new Pt.$5hc(qe)),hn=qe.set(a.$7K.ExtHostProfileContentHandlers,new K.$Jhc(qe));qe.set(a.$7K.ExtHostInteractive,new ie.$whc(qe,It,Xe,We,ft));const Zi=qe.set(a.$7K.ExtHostInlineChat,new V.$jhc(qe,We,At,ft)),di=qe.set(a.$7K.ExtHostChatProvider,new f.$fgc(qe,ft)),xi=qe.set(a.$7K.ExtHostChatAgents2,new m.$ggc(qe,di,ft)),_i=qe.set(a.$7K.ExtHostChatVariables,new S.$hgc(qe)),bi=qe.set(a.$7K.ExtHostChat,new d.$egc(qe)),en=qe.set(a.$7K.ExtHostAiRelatedInformation,new c.$4fc(qe)),Ti=qe.set(a.$7K.ExtHostAiEmbeddingVector,new ke.$ghc(qe)),Ni=qe.set(a.$7K.ExtHostIssueReporter,new Ie.$xhc(qe)),ei=qe.set(a.$7K.ExtHostStatusBar,new nt.$Shc(qe,We.converter)),yi=qe.set(a.$7K.ExtHostSpeech,new st.$Qhc(qe)),dn=Object.values(a.$7K);qe.assertRegistered(dn);const Yt=new r.$dgc(qe,Xe),Ei=new L.$igc(qe),ki=new ee.$Ahc(qe,ft),Oi=new P.$dhc(qe);return h.$bgc.register(We),function(ze,ti,tn){function et(re){return(ue,Oe,ot)=>{const wt=re(Lt=>{try{ue.call(Oe,Lt)}catch(cn){T.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event`,{cause:cn})),Ct.onExtensionError(ze.identifier,cn)}});return ot?.push(wt),wt}}const pt=function(){let re=!ze.isUnderDevelopment;function ue(){re||(ft.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(ot){if(Array.isArray(ot))ot.forEach(Oe);else if(typeof ot=="string")ue();else{const wt=ot;typeof wt.scheme>"u"&&ue(),typeof wt.exclusive=="boolean"&&(0,Ze.$CF)(ze,"documentFiltersExclusive")}return ot}}(),fn={getSession(re,ue,Oe){return hi.getSession(ze,re,ue,Oe)},getSessions(re,ue){return(0,Ze.$CF)(ze,"authGetSessions"),hi.getSessions(ze,re,ue)},async hasSession(re,ue){return(0,Ze.$CF)(ze,"authSession"),!!await hi.getSession(ze,re,ue,{silent:!0})},get onDidChangeSessions(){return et(hi.onDidChangeSessions)},registerAuthenticationProvider(re,ue,Oe,ot){return hi.registerAuthenticationProvider(re,ue,Oe,ot)}},gn={registerCommand(re,ue,Oe){return We.registerCommand(!0,re,ue,Oe,void 0,ze)},registerTextEditorCommand(re,ue,Oe){return We.registerCommand(!0,re,(...ot)=>{const wt=Ot.getActiveTextEditor();if(!wt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Lt=>{ue.apply(Oe,[wt,Lt,...ot])}).then(Lt=>{Lt||ft.warn("Edits from command "+re+" were not applied.")},Lt=>{ft.warn("An error occurred while running command "+re,Lt)})},void 0,void 0,ze)},registerDiffInformationCommand:(re,ue,Oe)=>((0,Ze.$CF)(ze,"diffCommand"),We.registerCommand(!0,re,async(...ot)=>{const wt=Xe.activeEditor(!0);if(!wt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(wt.id);ue.apply(Oe,[Lt,...ot])},void 0,void 0,ze)),executeCommand(re,...ue){return We.executeCommand(re,...ue)},getCommands(re=!1){return We.getCommands(re)}},zi={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return _e.getDefaultShell(!1)},get onDidChangeShell(){return et(_e.onDidChangeShell)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return et(Ct.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$CF)(ze,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$CF)(ze,"telemetry"),et(Ct.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,je.$qN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,ue){return je.$pN.validateSender(re),Ct.instantiateLogger(ze,re,ue)},openExternal(re,ue){return Fe.openUri(re,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===$t.environment.appUriScheme)return gi.createAppUri(re);try{return await Fe.asExternalUri(re,{allowTunneling:!!$t.remote.authority})}catch(ue){if((0,R.$eg)(re,R.Schemas.http)||(0,R.$eg)(re,R.Schemas.https))return re;throw ue}},get remoteName(){return(0,o.$bl)($t.remote.authority)},get remoteAuthority(){return(0,Ze.$CF)(ze,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return et(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(re){return(0,Ze.$CF)(ze,"handleIssueUri"),Ni.registerIssueUriRequestHandler(ze,re)},registerIssueDataProvider(re){return(0,Ze.$CF)(ze,"handleIssueUri"),Ni.registerIssueDataProvider(ze,re)},get appQuality(){return(0,Ze.$CF)(ze,"resolvers"),$t.quality},get appCommit(){return(0,Ze.$CF)(ze,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(zi);const ji={createTestController(re,ue,Oe){return oi.createTestController(ze,re,ue,Oe)},createTestObserver(){return(0,Ze.$CF)(ze,"testObserver"),oi.createTestObserver()},runTests(re){return(0,Ze.$CF)(ze,"testObserver"),oi.runTests(re)},get onDidChangeTestResults(){return(0,Ze.$CF)(ze,"testObserver"),et(oi.onResultsChanged)},get testResults(){return(0,Ze.$CF)(ze,"testObserver"),oi.results}},fi=$t.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,nn={getExtension(re,ue){(0,Ze.$BF)(ze,"extensionsAny")||(ue=!1);const Oe=ti.mine.getExtensionDescription(re);if(Oe)return new le.$5gc(kt,ze.identifier,Oe,fi,!1);if(ue){const ot=ti.all.getExtensionDescription(re);if(ot)return new le.$5gc(kt,ze.identifier,ot,fi,!0)}},get all(){const re=[];for(const ue of ti.mine.getAllExtensionDescriptions())re.push(new le.$5gc(kt,ze.identifier,ue,fi,!1));return re},get allAcrossExtensionHosts(){(0,Ze.$CF)(ze,"extensionsAny");const re=new p.$mm(ti.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ti.all.getAllExtensionDescriptions()){const ot=!re.has(Oe.identifier);ue.push(new le.$5gc(kt,ze.identifier,Oe,fi,ot))}return ue},get onDidChange(){return(0,Ze.$BF)(ze,"extensionsAny")?et(C.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):et(ti.mine.onDidChange)}},rn={createDiagnosticCollection(re){return ui.createDiagnosticCollection(ze.identifier,re)},get onDidChangeDiagnostics(){return et(ui.onDidChangeDiagnostics)},getDiagnostics:re=>ui.getDiagnostics(re),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(re,ue){return li.changeLanguage(re.uri,ue)},match(re,ue){const Oe=At.getDocumentData(ue.uri)?.notebook;return(0,A.$Bt)(rt.LanguageSelector.from(re),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,ue,Oe){return ht.registerCodeActionProvider(ze,pt(re),ue,Oe)},registerDocumentPasteEditProvider(re,ue,Oe){return(0,Ze.$CF)(ze,"documentPaste"),ht.registerDocumentPasteEditProvider(ze,pt(re),ue,Oe)},registerCodeLensProvider(re,ue){return ht.registerCodeLensProvider(ze,pt(re),ue)},registerDefinitionProvider(re,ue){return ht.registerDefinitionProvider(ze,pt(re),ue)},registerDeclarationProvider(re,ue){return ht.registerDeclarationProvider(ze,pt(re),ue)},registerImplementationProvider(re,ue){return ht.registerImplementationProvider(ze,pt(re),ue)},registerTypeDefinitionProvider(re,ue){return ht.registerTypeDefinitionProvider(ze,pt(re),ue)},registerHoverProvider(re,ue){return ht.registerHoverProvider(ze,pt(re),ue,ze.identifier)},registerEvaluatableExpressionProvider(re,ue){return ht.registerEvaluatableExpressionProvider(ze,pt(re),ue,ze.identifier)},registerInlineValuesProvider(re,ue){return ht.registerInlineValuesProvider(ze,pt(re),ue,ze.identifier)},registerDocumentHighlightProvider(re,ue){return ht.registerDocumentHighlightProvider(ze,pt(re),ue)},registerMultiDocumentHighlightProvider(re,ue){return ht.registerMultiDocumentHighlightProvider(ze,pt(re),ue)},registerLinkedEditingRangeProvider(re,ue){return ht.registerLinkedEditingRangeProvider(ze,pt(re),ue)},registerReferenceProvider(re,ue){return ht.registerReferenceProvider(ze,pt(re),ue)},registerRenameProvider(re,ue){return ht.registerRenameProvider(ze,pt(re),ue)},registerDocumentSymbolProvider(re,ue,Oe){return ht.registerDocumentSymbolProvider(ze,pt(re),ue,Oe)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(ze,re)},registerDocumentFormattingEditProvider(re,ue){return ht.registerDocumentFormattingEditProvider(ze,pt(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return ht.registerDocumentRangeFormattingEditProvider(ze,pt(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Oe,...ot){return ht.registerOnTypeFormattingEditProvider(ze,pt(re),ue,[Oe].concat(ot))},registerDocumentSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentSemanticTokensProvider(ze,pt(re),ue,Oe)},registerDocumentRangeSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentRangeSemanticTokensProvider(ze,pt(re),ue,Oe)},registerSignatureHelpProvider(re,ue,Oe,...ot){return typeof Oe=="object"?ht.registerSignatureHelpProvider(ze,pt(re),ue,Oe):ht.registerSignatureHelpProvider(ze,pt(re),ue,typeof Oe>"u"?[]:[Oe,...ot])},registerCompletionItemProvider(re,ue,...Oe){return ht.registerCompletionItemProvider(ze,pt(re),ue,Oe)},registerInlineCompletionItemProvider(re,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Ze.$CF)(ze,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$CF)(ze,"inlineCompletionsAdditions"),Oe&&(0,Ze.$CF)(ze,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(ze,pt(re),ue,Oe)},registerDocumentLinkProvider(re,ue){return ht.registerDocumentLinkProvider(ze,pt(re),ue)},registerColorProvider(re,ue){return ht.registerColorProvider(ze,pt(re),ue)},registerFoldingRangeProvider(re,ue){return ht.registerFoldingRangeProvider(ze,pt(re),ue)},registerSelectionRangeProvider(re,ue){return ht.registerSelectionRangeProvider(ze,re,ue)},registerCallHierarchyProvider(re,ue){return ht.registerCallHierarchyProvider(ze,re,ue)},registerTypeHierarchyProvider(re,ue){return ht.registerTypeHierarchyProvider(ze,re,ue)},setLanguageConfiguration:(re,ue)=>ht.setLanguageConfiguration(ze,re,ue),getTokenInformationAtPosition(re,ue){return(0,Ze.$CF)(ze,"tokenInformation"),li.tokenAtPosition(re,ue)},registerInlayHintsProvider(re,ue){return ht.registerInlayHintsProvider(ze,re,ue)},createLanguageStatusItem(re,ue){return li.createLanguageStatusItem(ze,re,ue)},registerDocumentDropEditProvider(re,ue,Oe){return ht.registerDocumentOnDropEditProvider(ze,re,ue,(0,Ze.$BF)(ze,"dropMetadata")?Oe:void 0)}},mn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return _e.activeTerminal},get terminals(){return _e.terminals},async showTextDocument(re,ue,Oe){const ot=await(g.URI.isUri(re)?Promise.resolve(sn.openTextDocument(re)):Promise.resolve(re));return Ot.showTextDocument(ot,ue,Oe)},createTextEditorDecorationType(re){return Ot.createTextEditorDecorationType(ze,re)},onDidChangeActiveTextEditor(re,ue,Oe){return et(Ot.onDidChangeActiveTextEditor)(re,ue,Oe)},onDidChangeVisibleTextEditors(re,ue,Oe){return et(Ot.onDidChangeVisibleTextEditors)(re,ue,Oe)},onDidChangeTextEditorSelection(re,ue,Oe){return et(Ot.onDidChangeTextEditorSelection)(re,ue,Oe)},onDidChangeTextEditorOptions(re,ue,Oe){return et(Ot.onDidChangeTextEditorOptions)(re,ue,Oe)},onDidChangeTextEditorVisibleRanges(re,ue,Oe){return et(Ot.onDidChangeTextEditorVisibleRanges)(re,ue,Oe)},onDidChangeTextEditorViewColumn(re,ue,Oe){return et(Ot.onDidChangeTextEditorViewColumn)(re,ue,Oe)},onDidCloseTerminal(re,ue,Oe){return et(_e.onDidCloseTerminal)(re,ue,Oe)},onDidOpenTerminal(re,ue,Oe){return et(_e.onDidOpenTerminal)(re,ue,Oe)},onDidChangeActiveTerminal(re,ue,Oe){return et(_e.onDidChangeActiveTerminal)(re,ue,Oe)},onDidChangeTerminalDimensions(re,ue,Oe){return(0,Ze.$CF)(ze,"terminalDimensions"),et(_e.onDidChangeTerminalDimensions)(re,ue,Oe)},onDidChangeTerminalState(re,ue,Oe){return et(_e.onDidChangeTerminalState)(re,ue,Oe)},onDidWriteTerminalData(re,ue,Oe){return(0,Ze.$CF)(ze,"terminalDataWriteEvent"),et(_e.onDidWriteTerminalData)(re,ue,Oe)},onDidExecuteTerminalCommand(re,ue,Oe){return(0,Ze.$CF)(ze,"terminalExecuteCommandEvent"),et(_e.onDidExecuteTerminalCommand)(re,ue,Oe)},get state(){return Fe.getState(ze)},onDidChangeWindowState(re,ue,Oe){return et(Fe.onDidChangeWindowState)(re,ue,Oe)},showInformationMessage(re,...ue){return ki.showMessage(ze,$.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return ki.showMessage(ze,$.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return ki.showMessage(ze,$.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Oe){return si.showQuickPick(ze,re,ue,Oe)},showWorkspaceFolderPick(re){return si.showWorkspaceFolderPick(re)},showInputBox(re,ue){return si.showInput(re,ue)},showOpenDialog(re){return Oi.showOpenDialog(ze,re)},showSaveDialog(re){return Oi.showSaveDialog(re)},createStatusBarItem(re,ue,Oe){let ot,wt,Lt;return typeof re=="string"?(ot=re,wt=ue,Lt=Oe):(wt=re,Lt=ue),ei.createStatusBarEntry(ze,ot,wt,Lt)},setStatusBarMessage(re,ue){return ei.setStatusBarMessage(re,ue)},withScmProgress(re){return Se.report("window.withScmProgress",ze,"Use 'withProgress' instead."),vi.withProgress(ze,{location:Ne.ProgressLocation.SourceControl},(ue,Oe)=>re({report(ot){}}))},withProgress(re,ue){return vi.withProgress(ze,re,ue)},createOutputChannel(re,ue){return St.createOutputChannel(re,ue,ze)},createWebviewPanel(re,ue,Oe,ot){return Mi.createWebviewPanel(ze,re,ue,Oe,ot)},createWebviewTextEditorInset(re,ue,Oe,ot){return(0,Ze.$CF)(ze,"editorInsets"),Pi.createWebviewEditorInset(re,ue,Oe,ot,ze)},createTerminal(re,ue,Oe){return typeof re=="object"?"pty"in re?_e.createExtensionTerminal(re):_e.createTerminalFromOptions(re):_e.createTerminal(re,ue,Oe)},registerTerminalLinkProvider(re){return _e.registerLinkProvider(re)},registerTerminalProfileProvider(re,ue){return _e.registerProfileProvider(ze,re,ue)},registerTerminalQuickFixProvider(re,ue){return(0,Ze.$CF)(ze,"terminalQuickFixProvider"),_e.registerTerminalQuickFixProvider(re,ze.identifier.value,ue)},registerTreeDataProvider(re,ue){return $i.registerTreeDataProvider(re,ue,ze)},createTreeView(re,ue){return $i.createTreeView(re,ue,ze)},registerWebviewPanelSerializer:(re,ue)=>Mi.registerWebviewPanelSerializer(ze,re,ue),registerCustomEditorProvider:(re,ue,Oe={})=>un.registerCustomEditorProvider(ze,re,ue,Oe),registerFileDecorationProvider(re){return Ue.registerFileDecorationProvider(re,ze)},registerUriHandler(re){return gi.registerUriHandler(ze,re)},createQuickPick(){return si.createQuickPick(ze)},createInputBox(){return si.createInputBox(ze)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Oe){return et(Li.onDidChangeActiveColorTheme)(re,ue,Oe)},registerWebviewViewProvider(re,ue,Oe){return Fi.registerWebviewViewProvider(ze,re,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Oe){return et(It.onDidChangeActiveNotebookEditor)(re,ue,Oe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return et(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(re,ue,Oe){return et(mi.onDidChangeNotebookEditorSelection)(re,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Oe){return et(mi.onDidChangeNotebookEditorVisibleRanges)(re,ue,Oe)},showNotebookDocument(re,ue){return It.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Oe){return(0,Ze.$CF)(ze,"externalUriOpener"),ln.registerExternalUriOpener(ze.identifier,re,ue,Oe)},registerProfileContentHandler(re,ue){return(0,Ze.$CF)(ze,"profileContentHandlers"),hn.registerProfileContentHandler(ze,re,ue)},registerQuickDiffProvider(re,ue,Oe,ot){return(0,Ze.$CF)(ze,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(re),ue,Oe,ot)},get tabGroups(){return J.tabGroups},registerShareProvider(re,ue){return(0,Ze.$CF)(ze,"shareProvider"),Qi.registerShareProvider(pt(re),ue)}},sn={get rootPath(){return Se.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(re){throw new T.$9("rootPath")},getWorkspaceFolder(re){return dt.getWorkspaceFolder(re)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(re){throw new T.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(re){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(re,ue,...Oe)=>dt.updateWorkspaceFolders(ze,re,ue||0,...Oe),onDidChangeWorkspaceFolders:function(re,ue,Oe){return et(dt.onDidChangeWorkspace)(re,ue,Oe)},asRelativePath:(re,ue)=>dt.getRelativePath(re,ue),findFiles:(re,ue,Oe,ot)=>dt.findFiles(re,ue,Oe,ze.identifier,ot),findTextInFiles:(re,ue,Oe,ot)=>{(0,Ze.$CF)(ze,"findTextInFiles");let wt,Lt;return typeof ue=="object"?(wt=ue,Lt=Oe):(wt={},Lt=ue,ot=Oe),dt.findTextInFiles(re,wt||{},Lt,ze.identifier,ot)},save:re=>dt.save(re),saveAs:re=>dt.saveAs(re),saveAll:re=>dt.saveAll(re),applyEdit(re,ue){return Yt.applyWorkspaceEdit(re,ze,ue)},createFileSystemWatcher:(re,ue,Oe,ot)=>{let wt;return typeof ue=="boolean"?wt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ot,correlate:!1}:ue&&((0,Ze.$CF)(ze,"createFileSystemWatcher"),wt={...ue,correlate:!0}),_t.createFileSystemWatcher(dt,ze,re,wt)},get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new T.$9("textDocuments")},openTextDocument(re){let ue;const Oe=re;if(typeof re=="string")ue=Promise.resolve(g.URI.file(re));else if(g.URI.isUri(re))ue=Promise.resolve(re);else if(!Oe||typeof Oe=="object")ue=At.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ot=>At.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(re,ue,Oe)=>et(At.onDidAddDocument)(re,ue,Oe),onDidCloseTextDocument:(re,ue,Oe)=>et(At.onDidRemoveDocument)(re,ue,Oe),onDidChangeTextDocument:(re,ue,Oe)=>et(At.onDidChangeDocument)(re,ue,Oe),onDidSaveTextDocument:(re,ue,Oe)=>et(At.onDidSaveDocument)(re,ue,Oe),onWillSaveTextDocument:(re,ue,Oe)=>et(Gi.getOnWillSaveTextDocumentEvent(ze))(re,ue,Oe),get notebookDocuments(){return It.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ue){let Oe;if(g.URI.isUri(re))Oe=re,await It.openNotebookDocument(re);else if(typeof re=="string")Oe=g.URI.revive(await It.createNotebookDocument({viewType:re,content:ue}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,ue,Oe){return et(ri.onDidSaveNotebookDocument)(re,ue,Oe)},onDidChangeNotebookDocument(re,ue,Oe){return et(ri.onDidChangeNotebookDocument)(re,ue,Oe)},onWillSaveNotebookDocument(re,ue,Oe){return et(Ci.getOnWillSaveNotebookDocumentEvent(ze))(re,ue,Oe)},get onDidOpenNotebookDocument(){return et(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return et(It.onDidCloseNotebookDocument)},registerNotebookSerializer(re,ue,Oe,ot){return It.registerNotebookSerializer(ze,re,ue,Oe,(0,Ze.$BF)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(re,ue,Oe)=>et(tn.onDidChangeConfiguration)(re,ue,Oe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,tn.getConfiguration(re,ue,ze)},registerTextDocumentContentProvider(re,ue){return Si.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Se.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(ze,re,ue)),registerFileSystemProvider(re,ue,Oe){return(0,M.$Qc)(Ji.registerFileSystemProvider(ze,re,ue,Oe),Vt.addFileSystemProvider(re,ue,Oe))},get fs(){return Vt.value},registerFileSearchProvider:(re,ue)=>((0,Ze.$CF)(ze,"fileSearchProvider"),Ut.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,Ze.$CF)(ze,"textSearchProvider"),Ut.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,Ze.$CF)(ze,"resolvers"),kt.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,Ze.$CF)(ze,"resolvers"),Xi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Ze.$CF)(ze,"resolvers"),kt.getRemoteExecServer(re)),onDidCreateFiles:(re,ue,Oe)=>et(_t.onDidCreateFile)(re,ue,Oe),onDidDeleteFiles:(re,ue,Oe)=>et(_t.onDidDeleteFile)(re,ue,Oe),onDidRenameFiles:(re,ue,Oe)=>et(_t.onDidRenameFile)(re,ue,Oe),onWillCreateFiles:(re,ue,Oe)=>et(_t.getOnWillCreateFileEvent(ze))(re,ue,Oe),onWillDeleteFiles:(re,ue,Oe)=>et(_t.getOnWillDeleteFileEvent(ze))(re,ue,Oe),onWillRenameFiles:(re,ue,Oe)=>et(_t.getOnWillRenameFileEvent(ze))(re,ue,Oe),openTunnel:re=>((0,Ze.$CF)(ze,"tunnels"),Ft.openTunnel(ze,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ze.$CF)(ze,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(re,ue,Oe)=>((0,Ze.$CF)(ze,"tunnels"),et(Ft.onDidChangeTunnels)(re,ue,Oe)),registerPortAttributesProvider:(re,ue)=>((0,Ze.$CF)(ze,"portsAttributes"),Ft.registerPortsAttributesProvider(re,ue)),registerTunnelProvider:(re,ue)=>((0,Ze.$CF)(ze,"tunnelFactory"),Ft.registerTunnelProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,Ze.$CF)(ze,"timeline"),Yi.registerTimelineProvider(re,ue,ze.identifier,We.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:re=>((0,Ze.$CF)(ze,"workspaceTrust"),dt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ue,Oe)=>et(dt.onDidGrantWorkspaceTrust)(re,ue,Oe),registerEditSessionIdentityProvider:(re,ue)=>((0,Ze.$CF)(ze,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(re,ue)),onWillCreateEditSessionIdentity:(re,ue,Oe)=>((0,Ze.$CF)(ze,"editSessionIdentityProvider"),et(dt.getOnWillCreateEditSessionIdentityEvent(ze))(re,ue,Oe)),registerCanonicalUriProvider:(re,ue)=>((0,Ze.$CF)(ze,"canonicalUriProvider"),dt.registerCanonicalUriProvider(re,ue)),getCanonicalUri:(re,ue,Oe)=>((0,Ze.$CF)(ze,"canonicalUriProvider"),dt.provideCanonicalUri(re,ue,Oe))},on={get inputBox(){return Se.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(ze)},createSourceControl(re,ue,Oe){return pi.createSourceControl(ze,re,ue,Oe)}},an={createCommentController(re,ue){return Ai.createCommentController(ze,re,ue)}},Ui={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(re,ue,Oe){return et(mt.onDidStartDebugSession)(re,ue,Oe)},onDidTerminateDebugSession(re,ue,Oe){return et(mt.onDidTerminateDebugSession)(re,ue,Oe)},onDidChangeActiveDebugSession(re,ue,Oe){return et(mt.onDidChangeActiveDebugSession)(re,ue,Oe)},onDidReceiveDebugSessionCustomEvent(re,ue,Oe){return et(mt.onDidReceiveDebugSessionCustomEvent)(re,ue,Oe)},onDidChangeBreakpoints(re,ue,Oe){return et(mt.onDidChangeBreakpoints)(re,ue,Oe)},onDidChangeStackFrameFocus(re,ue,Oe){return(0,Ze.$CF)(ze,"debugFocus"),et(mt.onDidChangeStackFrameFocus)(re,ue,Oe)},registerDebugConfigurationProvider(re,ue,Oe){return mt.registerDebugConfigurationProvider(re,ue,Oe||zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return mt.registerDebugAdapterDescriptorFactory(ze,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return mt.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?mt.startDebugging(re,ue,{parentSession:Oe}):mt.startDebugging(re,ue,Oe||{})},stopDebugging(re){return mt.stopDebugging(re)},addBreakpoints(re){return mt.addBreakpoints(re)},removeBreakpoints(re){return mt.removeBreakpoints(re)},asDebugSourceUri(re,ue){return mt.asDebugSourceUri(re,ue)}},Bi={registerTaskProvider:(re,ue)=>Et.registerTaskProvider(ze,re,ue),fetchTasks:re=>Et.fetchTasks(re),executeTask:re=>Et.executeTask(ze,re),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(re,ue,Oe)=>et(Et.onDidStartTask)(re,ue,Oe),onDidEndTask:(re,ue,Oe)=>et(Et.onDidEndTask)(re,ue,Oe),onDidStartTaskProcess:(re,ue,Oe)=>et(Et.onDidStartTaskProcess)(re,ue,Oe),onDidEndTaskProcess:(re,ue,Oe)=>et(Et.onDidEndTaskProcess)(re,ue,Oe)},Vi={createNotebookController(re,ue,Oe,ot,wt){return ci.createNotebookController(ze,re,ue,Oe,ot,(0,Ze.$BF)(ze,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,ue)=>It.registerNotebookCellStatusBarItemProvider(ze,re,ue),createRendererMessaging(re){return Ii.createRendererMessaging(ze,re)},createNotebookControllerDetectionTask(re){return(0,Ze.$CF)(ze,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(ze,re)},registerKernelSourceActionProvider(re,ue){return(0,Ze.$CF)(ze,"notebookKernelSource"),ci.registerKernelSourceActionProvider(ze,re,ue)},onDidChangeNotebookCellExecutionState(re,ue,Oe){return(0,Ze.$CF)(ze,"notebookCellExecutionState"),et(ci.onDidChangeNotebookCellExecutionState)(re,ue,Oe)}},Di={t(...re){if(typeof re[0]=="string"){const ue=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return bt.getMessage(ze.identifier.value,{message:ue,args:Oe})}return bt.getMessage(ze.identifier.value,re[0])},get bundle(){return bt.getBundle(ze.identifier.value)},get uri(){return bt.getBundleUri(ze.identifier.value)}},Wi={_version:1,registerInteractiveEditorSessionProvider(re,ue){return(0,Ze.$CF)(ze,"interactive"),Zi.registerProvider(ze,re,ue)},registerInteractiveSessionProvider(re,ue){return(0,Ze.$CF)(ze,"interactive"),bi.registerChatProvider(ze,re,ue)},sendInteractiveRequestToProvider(re,ue){return(0,Ze.$CF)(ze,"interactive"),bi.sendInteractiveRequestToProvider(re,ue)},transferChatSession(re,ue){return(0,Ze.$CF)(ze,"interactive"),bi.transferChatSession(re,ue)}},qi={getRelatedInformation(re,ue){return(0,Ze.$CF)(ze,"aiRelatedInformation"),en.getRelatedInformation(ze,re,ue)},registerRelatedInformationProvider(re,ue){return(0,Ze.$CF)(ze,"aiRelatedInformation"),en.registerRelatedInformationProvider(ze,re,ue)},registerEmbeddingVectorProvider(re,ue){return(0,Ze.$CF)(ze,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(ze,re,ue)}},$n={registerChatResponseProvider(re,ue,Oe){return(0,Ze.$CF)(ze,"chatProvider"),di.registerProvider(ze.identifier,re,ue,Oe)},requestChatAccess(re){return(0,Ze.$CF)(ze,"chatRequestAccess"),di.requestChatResponseProvider(ze.identifier,re)},registerVariable(re,ue,Oe){return(0,Ze.$CF)(ze,"chatAgents2"),_i.registerVariableResolver(ze,re,ue,Oe)},registerMappedEditsProvider(re,ue){return(0,Ze.$CF)(ze,"mappedEditsProvider"),ht.registerMappedEditsProvider(ze,re,ue)},createChatAgent(re,ue){return(0,Ze.$CF)(ze,"chatAgents2"),xi.createChatAgent(ze,re,ue)}},pn={registerSpeechProvider(re,ue){return(0,Ze.$CF)(ze,"speech"),yi.registerProvider(ze.identifier,re,ue)}};return{version:$t.version,ai:qi,authentication:fn,commands:gn,comments:an,chat:$n,debug:Ui,env:zi,extensions:nn,interactive:Wi,l10n:Di,languages:rn,notebooks:Vi,scm:on,speech:pn,tasks:Bi,tests:ji,window:mn,workspace:sn,Breakpoint:Ne.$7L,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$YM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$XM,CallHierarchyIncomingCall:Ne.$tL,CallHierarchyItem:Ne.$sL,CallHierarchyOutgoingCall:Ne.$uL,CancellationError:T.$5,CancellationTokenSource:E.$6d,CandidatePortSource:a.CandidatePortSource,CodeAction:Ne.$pL,CodeActionKind:Ne.$qL,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$vL,Color:Ne.$IL,ColorInformation:Ne.$JL,ColorPresentation:Ne.$KL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$CL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$DL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$SL,DebugAdapterExecutable:Ne.$$L,DebugAdapterInlineImplementation:Ne.$bM,DebugAdapterNamedPipeServer:Ne.$aM,DebugAdapterServer:Ne.$_L,DebugConfigurationProviderTriggerKind:zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$jL,DiagnosticRelatedInformation:Ne.$iL,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$8K,DocumentHighlight:Ne.$lL,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$mL,DocumentLink:Ne.$HL,DocumentSymbol:Ne.$oL,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$eM,InlineValueText:Ne.$fM,InlineValueVariableLookup:Ne.$gM,InlineValueEvaluatableExpression:Ne.$hM,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:C.$Vd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$rM,FileDecoration2:Ne.$rM,FileSystemError:Ne.$jM,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Ne.$kM,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$9L,InlineCompletionItem:Ne.$EL,InlineCompletionList:Ne.$FL,Hover:Ne.$kL,IndentAction:D.IndentAction,Location:Ne.$hL,MarkdownString:Ne.$wL,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Ne.$xL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$9K,ProcessExecution:Ne.$QL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$qM,Range:Ne.$0K,RelativePattern:Ne.$5L,Selection:Ne.$$K,SelectionRange:Ne.$rL,SemanticTokens:Ne.$nM,SemanticTokensBuilder:Ne.$mM,SemanticTokensEdit:Ne.$oM,SemanticTokensEdits:Ne.$pM,SemanticTokensLegend:Ne.$lM,ShellExecution:Ne.$RL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$zL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$yL,SnippetString:Ne.$gL,SourceBreakpoint:Ne.$8L,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$nL,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$TL,TaskGroup:Ne.$PL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$LL,TerminalQuickFixTerminalCommand:Ne.$NL,TerminalQuickFixOpener:Ne.$ML,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$OL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$cL,SnippetTextEdit:Ne.$eL,TextEditorCursorStyle:b.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$4L,ThemeIcon:Ne.$3L,TreeItem:Ne.$UL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$MM,UIKind:Rt.UIKind,Uri:g.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$fL,DocumentDropEdit:Ne.$1L,DocumentPasteEdit:Ne.$2L,InlayHint:Ne.$BL,InlayHintLabelPart:Ne.$AL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$bL,ResolvedAuthority:Ne.$_K,ManagedResolvedAuthority:Ne.$aL,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$BM,NotebookRange:Ne.$tM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$uM,NotebookData:Ne.$vM,NotebookRendererScript:Ne.$zM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$xM,NotebookCellOutputItem:Ne.$wM,NotebookCellStatusBarItem:Ne.$yM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$dL,NotebookKernelSourceAction:Ne.$AM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$DM,LinkedEditingRanges:Ne.$CM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$EM,TestMessage:Ne.$FM,TestMessage2:Ne.$FM,TestTag:Ne.$GM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Ne.$ZL,DataTransferItem:Ne.$VL,CoveredCount:Ne.$HM,FileCoverage:Ne.$IM,StatementCoverage:Ne.$JM,BranchCoverage:Ne.$KM,FunctionCoverage:Ne.$LM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$NM,TabInputTextDiff:Ne.$OM,TabInputTextMerge:Ne.$PM,TabInputCustom:Ne.$QM,TabInputNotebook:Ne.$SM,TabInputNotebookDiff:Ne.$TM,TabInputWebview:Ne.$RM,TabInputTerminal:Ne.$UM,TabInputInteractiveWindow:Ne.$VM,TabInputChat:Ne.$WM,TelemetryTrustedValue:t.$Ko,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$cM,ThreadFocus:Ne.$dM,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$0hc=Jt}),define(Pe[290],Re([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,255,14,116,82,83]),function(ge,e,E,T,C,M,R,$,g,b,A,D,u,p,w,s,o,t,n,a,c,h,i,l,r,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Yr)(d.$Ygc,d.$Xgc,1),(0,E.$Yr)(l.$oj,i.$$hc,1),(0,E.$Yr)(s.$0fc,s.$$fc,1),(0,E.$Yr)($.$tN,$.$sN,0),(0,E.$Yr)(R.$sgc,R.$qgc,0),(0,E.$Yr)(t.$ugc,t.$tgc,0),(0,E.$Yr)(D.$9gc,D.$ahc,0),(0,E.$Yr)(M.$chc,M.$bhc,0),(0,E.$Yr)(g.$iN,g.$hN,0),(0,E.$Yr)(m.$Zgc,m.$1gc,0),(0,E.$Yr)(n.$7fc,n.$6fc,0),(0,E.$Yr)(T.$Ihc,T.$Hhc,1),(0,E.$Yr)(u.$shc,u.$thc,0),(0,E.$Yr)(p.$Ngc,p.$Mgc,0),(0,E.$Yr)(A.$Vhc,A.$Uhc,0),(0,E.$Yr)(b.$Qgc,b.$Tgc,0),(0,E.$Yr)(w.$oyb,w.$pyb,0),(0,E.$Yr)(o.$9hc,o.$8hc,0),(0,E.$Yr)(C.$pgc,C.$ogc,0),(0,E.$Yr)(a.$Vgc,a.$Ugc,0),(0,E.$Yr)(c.$rN,c.$oN,0),(0,E.$Yr)(h.$Egc,h.$Fgc,0),(0,E.$Yr)(r.$7gc,r.$8gc,0)}),define(Pe[291],Re([1,0,289,38,2,286,7,13,274]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;class b extends M.$bic{j(){}getModule(p,w){for(const s of this.b){const o=s(p);if(o){p=o;break}}if(this.a.has(p))return this.a.get(p).load(p,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends T.$3gc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$ikc);const p=this.h.invokeFunction(E.$0hc);this.r=this.h.createInstance(b,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,w,s){w=w.with({path:D(w.path,".js")});const o=p?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const t=C.URI.revive(await this.C.$asBrowserUri(w)),n=await fetch(t.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const a=await n.text(),c=`${w.toString(!0)}#vscode-extension`,h=`${a}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(m){throw console.error(o?`Loading code for extension ${o} failed: ${m.message}`:`Loading code failed: ${m.message}`),console.error(`${w.toString(!0)}${typeof m.line=="number"?` line ${m.line}`:""}${typeof m.column=="number"?` column ${m.column}`:""}`),console.error(m),m}p&&await this.w.initializeLocalizedMessages(p);const l={},r={exports:l},d=m=>{const f=this.r.getModule(m,w);if(f===void 0)throw new Error(`Cannot load module '${m}'`);return f};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(r,l,d),r.exports!==l?r.exports:l}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+p;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,$.$7g)(10)}}e.$jkc=A;function D(u,p){return u.endsWith(p)?u:u+p}}),define(Pe[292],Re([1,0,69,70,14,38,199,86,291]),function(ge,e,E,T,C,M,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Yr)(C.$nj,new E.$3h(R.$aic,[!0],!0)),(0,T.$Yr)(M.$4gc,g.$jkc,0),(0,T.$Yr)($.$vgc,$.$wgc,0)}),define(Pe[297],Re([1,0,24,5,79,287,276,19,88,12,2,290,292]),function(ge,e,E,T,C,M,R,$,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(i){return/^(file|vscode-remote):/i.test(i)}const w=fetch.bind(self);function s(i){self.fetch=async function(l,r){return l instanceof Request||p(String(l))&&(l=(await i(A.URI.parse(String(l)))).toString(!0)),w(l,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,r,d,m,f){(async()=>(p(r.toString())&&(r=(await i(A.URI.parse(r.toString()))).toString(!0)),super.open(l,r,d??!0,m,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(l,r){if(/^file:/i.test(l.toString()))l=b.$og.uriToBrowserUri(A.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const m=`(${function(v){function y(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const k=fetch.bind(self);self.fetch=function(O,G){return O instanceof Request?k(O,G):k(y(O),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,G,W,z,P){return super.open(O,y(G),W??!0,z,P)}};const N=importScripts.bind(self);self.importScripts=(...O)=>{N(...O.map(y))},N(v)}.toString()}('${l}'))`;r=r||{},r.name=r.name||$.$nc(l.toString());const f=new Blob([m],{type:"application/javascript"}),S=URL.createObjectURL(f);return new i(S,r)}}else self.Worker=class extends R.$kkc{constructor(i,l){super(u,i,{name:$.$nc(i.toString()),...l})}};const o=new class{constructor(){this.pid=void 0}exit(i){D()}};class t{constructor(){const l=new MessageChannel,r=new T.$Vd;let d=!1;u(l.port2,[l.port2]),l.port1.onmessage=m=>{const{data:f}=m;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const S=E.$je.wrap(new Uint8Array(f,0,f.byteLength));if((0,C.$um)(S,2)){d=!0,a("received terminate message from renderer");return}r.fire(S)},this.protocol={onMessage:r.event,send:m=>{if(!d){const f=m.buffer.buffer.slice(m.buffer.byteOffset,m.buffer.byteOffset+m.buffer.byteLength);l.port1.postMessage(f,[f])}}}}}function n(i){return new Promise(l=>{const r=i.onMessage(d=>{r.dispose();const m=JSON.parse(d.toString());i.send((0,C.$tm)(0)),l({protocol:i,initData:m})});i.send((0,C.$tm)(1))})}let a=i=>D();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(l){c(l)&&n(i.protocol).then(r=>{g.mark("code/extHost/didWaitForInitData");const d=new M.$dic(r.protocol,r.initData,o,null,l.data);s(m=>d.asBrowserUri(m)),a=m=>d.terminate(m)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/81725794264e4c0fddbc1b3b728013744ae90840/core/vs/workbench/api/worker/extensionHostWorker.js.map
